/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/editor/common/core/range","vs/base/common/charCode","vs/base/common/errors","vs/editor/common/core/position","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/platform","vs/base/common/arrays","vs/base/common/lifecycle","vs/base/common/arraysFind","vs/base/common/event","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/uri","vs/base/common/assert","vs/base/common/uint","vs/editor/common/core/lineRange","vs/base/common/path","vs/base/common/map","vs/base/common/cancellation","vs/base/common/types","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/network","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/codiconsUtil","vs/base/common/objects","vs/base/common/diff/diff","vs/editor/common/core/characterClassifier","vs/editor/common/core/textLength","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/nls.messages","vs/nls","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/marshallingIds","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/base/common/hash","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/positionToOffset","vs/editor/common/core/textEdit","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/encodedTokenAttributes","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/editorWorkerHost","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/base/common/process","vs/base/common/extpath","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/editor/common/services/textModelSync/textModelSync.impl","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ue=function(W){for(var t=[],n=0,i=W.length;n<i;n++)t[n]=re[W[n]];return t};const Qe=this,Je=typeof global=="object"?global:{};var _e;(function(W){W.global=Qe;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof W.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}W.Environment=t})(_e||(_e={}));var _e;(function(W){class t{constructor(m,A,d){this.type=m,this.detail=A,this.timestamp=d}}W.LoaderEvent=t;class n{constructor(m){this._events=[new t(1,"",m)]}record(m,A){this._events.push(new t(m,A,W.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}W.LoaderEventRecorder=n;class i{record(m,A){}getEvents(){return[]}}i.INSTANCE=new i,W.NullLoaderEventRecorder=i})(_e||(_e={}));var _e;(function(W){class t{static fileUriToFilePath(i,p){if(p=decodeURI(p).replace(/%23/g,"#"),i){if(/^file:\/\/\//.test(p))return p.substr(8);if(/^file:\/\//.test(p))return p.substr(5)}else if(/^file:\/\//.test(p))return p.substr(7);return p}static startsWith(i,p){return i.length>=p.length&&i.substr(0,p.length)===p}static endsWith(i,p){return i.length>=p.length&&i.substr(i.length-p.length)===p}static containsQueryString(i){return/^[^\#]*\?/gi.test(i)}static isAbsolutePath(i){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(i)}static forEachProperty(i,p){if(i){let m;for(m in i)i.hasOwnProperty(m)&&p(m,i[m])}}static isEmpty(i){let p=!0;return t.forEachProperty(i,()=>{p=!1}),p}static recursiveClone(i){if(!i||typeof i!="object"||i instanceof RegExp||!Array.isArray(i)&&Object.getPrototypeOf(i)!==Object.prototype)return i;let p=Array.isArray(i)?[]:{};return t.forEachProperty(i,(m,A)=>{A&&typeof A=="object"?p[m]=t.recursiveClone(A):p[m]=A}),p}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(i){return t.startsWith(i,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=W.global.performance&&typeof W.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?W.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,W.Utilities=t})(_e||(_e={}));var _e;(function(W){function t(p){if(p instanceof Error)return p;const m=new Error(p.message||String(p)||"Unknown Error");return p.stack&&(m.stack=p.stack),m}W.ensureError=t;class n{static validateConfigurationOptions(m){function A(d){if(d.phase==="loading"){console.error('Loading "'+d.moduleId+'" failed'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}if(d.phase==="factory"){console.error('The factory function of "'+d.moduleId+'" has thrown an exception'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}}if(m=m||{},typeof m.baseUrl!="string"&&(m.baseUrl=""),typeof m.isBuild!="boolean"&&(m.isBuild=!1),typeof m.paths!="object"&&(m.paths={}),typeof m.config!="object"&&(m.config={}),typeof m.catchError>"u"&&(m.catchError=!1),typeof m.recordStats>"u"&&(m.recordStats=!1),typeof m.urlArgs!="string"&&(m.urlArgs=""),typeof m.onError!="function"&&(m.onError=A),Array.isArray(m.ignoreDuplicateModules)||(m.ignoreDuplicateModules=[]),m.baseUrl.length>0&&(W.Utilities.endsWith(m.baseUrl,"/")||(m.baseUrl+="/")),typeof m.cspNonce!="string"&&(m.cspNonce=""),typeof m.preferScriptTags>"u"&&(m.preferScriptTags=!1),m.nodeCachedData&&typeof m.nodeCachedData=="object"&&(typeof m.nodeCachedData.seed!="string"&&(m.nodeCachedData.seed="seed"),(typeof m.nodeCachedData.writeDelay!="number"||m.nodeCachedData.writeDelay<0)&&(m.nodeCachedData.writeDelay=1e3*7),!m.nodeCachedData.path||typeof m.nodeCachedData.path!="string")){const d=t(new Error("INVALID cached data configuration, 'path' MUST be set"));d.phase="configuration",m.onError(d),m.nodeCachedData=void 0}return m}static mergeConfigurationOptions(m=null,A=null){let d=W.Utilities.recursiveClone(A||{});return W.Utilities.forEachProperty(m,(o,u)=>{o==="ignoreDuplicateModules"&&typeof d.ignoreDuplicateModules<"u"?d.ignoreDuplicateModules=d.ignoreDuplicateModules.concat(u):o==="paths"&&typeof d.paths<"u"?W.Utilities.forEachProperty(u,(h,$)=>d.paths[h]=$):o==="config"&&typeof d.config<"u"?W.Utilities.forEachProperty(u,(h,$)=>d.config[h]=$):d[o]=W.Utilities.recursiveClone(u)}),n.validateConfigurationOptions(d)}}W.ConfigurationOptionsUtil=n;class i{constructor(m,A){if(this._env=m,this.options=n.mergeConfigurationOptions(A),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let d=this.options.nodeRequire.main.filename,o=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,o+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let m=0;m<this.options.ignoreDuplicateModules.length;m++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[m]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],W.Utilities.forEachProperty(this.options.paths,(m,A)=>{Array.isArray(A)?this.sortedPathsRules.push({from:m,to:A}):this.sortedPathsRules.push({from:m,to:[A]})}),this.sortedPathsRules.sort((m,A)=>A.from.length-m.from.length)}cloneAndMerge(m){return new i(this._env,n.mergeConfigurationOptions(m,this.options))}getOptionsLiteral(){return this.options}_applyPaths(m){let A;for(let d=0,o=this.sortedPathsRules.length;d<o;d++)if(A=this.sortedPathsRules[d],W.Utilities.startsWith(m,A.from)){let u=[];for(let h=0,$=A.to.length;h<$;h++)u.push(A.to[h]+m.substr(A.from.length));return u}return[m]}_addUrlArgsToUrl(m){return W.Utilities.containsQueryString(m)?m+"&"+this.options.urlArgs:m+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(m){return this.options.urlArgs?this._addUrlArgsToUrl(m):m}_addUrlArgsIfNecessaryToUrls(m){if(this.options.urlArgs)for(let A=0,d=m.length;A<d;A++)m[A]=this._addUrlArgsToUrl(m[A]);return m}moduleIdToPaths(m){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(m))return this.isBuild()?["empty:"]:["node|"+m];let A=m,d;if(!W.Utilities.endsWith(A,".js")&&!W.Utilities.isAbsolutePath(A)){d=this._applyPaths(A);for(let o=0,u=d.length;o<u;o++)this.isBuild()&&d[o]==="empty:"||(W.Utilities.isAbsolutePath(d[o])||(d[o]=this.options.baseUrl+d[o]),!W.Utilities.endsWith(d[o],".js")&&!W.Utilities.containsQueryString(d[o])&&(d[o]=d[o]+".js"))}else!W.Utilities.endsWith(A,".js")&&!W.Utilities.containsQueryString(A)&&(A=A+".js"),d=[A];return this._addUrlArgsIfNecessaryToUrls(d)}requireToUrl(m){let A=m;return W.Utilities.isAbsolutePath(A)||(A=this._applyPaths(A)[0],W.Utilities.isAbsolutePath(A)||(A=this.options.baseUrl+A)),this._addUrlArgsIfNecessaryToUrl(A)}isBuild(){return this.options.isBuild}shouldInvokeFactory(m){return!!(!this.options.isBuild||W.Utilities.isAnonymousModule(m)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[m])}isDuplicateMessageIgnoredFor(m){return this.ignoreDuplicateModulesMap.hasOwnProperty(m)}getConfigForModule(m){if(this.options.config)return this.options.config[m]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(m){this.options.onError(m)}}W.Configuration=i})(_e||(_e={}));var _e;(function(W){class t{constructor(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}load(u,h,$,b){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new p;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=u.getConfig().getOptionsLiteral();e?this._scriptLoader=new n:this._scriptLoader=new m(this._env)}else this._env.isNode?this._scriptLoader=new m(this._env):this._scriptLoader=new n;let c={callback:$,errorback:b};if(this._callbackMap.hasOwnProperty(h)){this._callbackMap[h].push(c);return}this._callbackMap[h]=[c],this._scriptLoader.load(u,h,()=>this.triggerCallback(h),e=>this.triggerErrorback(h,e))}triggerCallback(u){let h=this._callbackMap[u];delete this._callbackMap[u];for(let $=0;$<h.length;$++)h[$].callback()}triggerErrorback(u,h){let $=this._callbackMap[u];delete this._callbackMap[u];for(let b=0;b<$.length;b++)$[b].errorback(h)}}class n{attachListeners(u,h,$){let b=()=>{u.removeEventListener("load",c),u.removeEventListener("error",e)},c=l=>{b(),h()},e=l=>{b(),$(l)};u.addEventListener("load",c),u.addEventListener("error",e)}load(u,h,$,b){if(/^node\|/.test(h)){let c=u.getConfig().getOptionsLiteral(),e=A(u.getRecorder(),c.nodeRequire||W.global.nodeRequire),l=h.split("|"),g=null;try{g=e(l[1])}catch(L){b(L);return}u.enqueueDefineAnonymousModule([],()=>g),$()}else{let c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript"),this.attachListeners(c,$,b);const{trustedTypesPolicy:e}=u.getConfig().getOptionsLiteral();e&&(h=e.createScriptURL(h)),c.setAttribute("src",h);const{cspNonce:l}=u.getConfig().getOptionsLiteral();l&&c.setAttribute("nonce",l),document.getElementsByTagName("head")[0].appendChild(c)}}}function i(o){const{trustedTypesPolicy:u}=o.getConfig().getOptionsLiteral();try{return(u?self.eval(u.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class p{constructor(){this._cachedCanUseEval=null}_canUseEval(u){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=i(u)),this._cachedCanUseEval}load(u,h,$,b){if(/^node\|/.test(h)){const c=u.getConfig().getOptionsLiteral(),e=A(u.getRecorder(),c.nodeRequire||W.global.nodeRequire),l=h.split("|");let g=null;try{g=e(l[1])}catch(L){b(L);return}u.enqueueDefineAnonymousModule([],function(){return g}),$()}else{const{trustedTypesPolicy:c}=u.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(u)){fetch(h).then(l=>{if(l.status!==200)throw new Error(l.statusText);return l.text()}).then(l=>{l=`${l}
//# sourceURL=${h}`,(c?self.eval(c.createScript("",l)):new Function(l)).call(self),$()}).then(void 0,b);return}try{c&&(h=c.createScriptURL(h)),importScripts(h),$()}catch(l){b(l)}}}}class m{constructor(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))}_initNodeRequire(u,h){const{nodeCachedData:$}=h.getConfig().getOptionsLiteral();if(!$||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const b=this,c=u("module");function e(l){const g=l.constructor;let L=function(E){try{return l.require(E)}finally{}};return L.resolve=function(E,_){return g._resolveFilename(E,l,!1,_)},L.resolve.paths=function(E){return g._resolveLookupPaths(E,l)},L.main=process.mainModule,L.extensions=g._extensions,L.cache=g._cache,L}c.prototype._compile=function(l,g){const L=c.wrap(l.replace(/^#!.*/,"")),N=h.getRecorder(),E=b._getCachedDataPath($,g),_={filename:g};let w;try{const T=b._fs.readFileSync(E);w=T.slice(0,16),_.cachedData=T.slice(16),N.record(60,E)}catch{N.record(61,E)}const a=new b._vm.Script(L,_),s=a.runInThisContext(_),f=b._path.dirname(g),v=e(this),k=[this.exports,v,this,g,f,process,Je,Buffer],R=s.apply(this.exports,k);return b._handleCachedData(a,L,E,!_.cachedData,h),b._verifyCachedData(a,L,E,w,h),R}}load(u,h,$,b){const c=u.getConfig().getOptionsLiteral(),e=A(u.getRecorder(),c.nodeRequire||W.global.nodeRequire),l=c.nodeInstrumenter||function(L){return L};this._init(e),this._initNodeRequire(e,u);let g=u.getRecorder();if(/^node\|/.test(h)){let L=h.split("|"),N=null;try{N=e(L[1])}catch(E){b(E);return}u.enqueueDefineAnonymousModule([],()=>N),$()}else{h=W.Utilities.fileUriToFilePath(this._env.isWindows,h);const L=this._path.normalize(h),N=this._getElectronRendererScriptPathOrUri(L),E=!!c.nodeCachedData,_=E?this._getCachedDataPath(c.nodeCachedData,h):void 0;this._readSourceAndCachedData(L,_,g,(w,a,s,f)=>{if(w){b(w);return}let v;a.charCodeAt(0)===m._BOM?v=m._PREFIX+a.substring(1)+m._SUFFIX:v=m._PREFIX+a+m._SUFFIX,v=l(v,L);const k={filename:N,cachedData:s},R=this._createAndEvalScript(u,v,k,$,b);this._handleCachedData(R,v,_,E&&!s,u),this._verifyCachedData(R,v,_,f,u)})}}_createAndEvalScript(u,h,$,b,c){const e=u.getRecorder();e.record(31,$.filename);const l=new this._vm.Script(h,$),g=l.runInThisContext($),L=u.getGlobalAMDDefineFunc();let N=!1;const E=function(){return N=!0,L.apply(null,arguments)};return E.amd=L.amd,g.call(W.global,u.getGlobalAMDRequireFunc(),E,$.filename,this._path.dirname($.filename)),e.record(32,$.filename),N?b():c(new Error(`Didn't receive define call in ${$.filename}!`)),l}_getElectronRendererScriptPathOrUri(u){if(!this._env.isElectronRenderer)return u;let h=u.match(/^([a-z])\:(.*)/i);return h?`file:///${(h[1].toUpperCase()+":"+h[2]).replace(/\\/g,"/")}`:`file://${u}`}_getCachedDataPath(u,h){const $=this._crypto.createHash("md5").update(h,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),b=this._path.basename(h).replace(/\.js$/,"");return this._path.join(u.path,`${b}-${$}.code`)}_handleCachedData(u,h,$,b,c){u.cachedDataRejected?this._fs.unlink($,e=>{c.getRecorder().record(62,$),this._createAndWriteCachedData(u,h,$,c),e&&c.getConfig().onError(e)}):b&&this._createAndWriteCachedData(u,h,$,c)}_createAndWriteCachedData(u,h,$,b){let c=Math.ceil(b.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,l=0,g;const L=()=>{setTimeout(()=>{g||(g=this._crypto.createHash("md5").update(h,"utf8").digest());const N=u.createCachedData();if(!(N.length===0||N.length===e||l>=5)){if(N.length<e){L();return}e=N.length,this._fs.writeFile($,Buffer.concat([g,N]),E=>{E&&b.getConfig().onError(E),b.getRecorder().record(63,$),L()})}},c*Math.pow(4,l++))};L()}_readSourceAndCachedData(u,h,$,b){if(!h)this._fs.readFile(u,{encoding:"utf8"},b);else{let c,e,l,g=2;const L=N=>{N?b(N):--g===0&&b(void 0,c,e,l)};this._fs.readFile(u,{encoding:"utf8"},(N,E)=>{c=E,L(N)}),this._fs.readFile(h,(N,E)=>{!N&&E&&E.length>0?(l=E.slice(0,16),e=E.slice(16),$.record(60,h)):$.record(61,h),L()})}}_verifyCachedData(u,h,$,b,c){b&&(u.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(h,"utf8").digest();b.equals(e)||(c.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${$}' now, but a RESTART IS REQUIRED`)),this._fs.unlink($,l=>{l&&c.getConfig().onError(l)}))},Math.ceil(5e3*(1+Math.random()))))}}m._BOM=65279,m._PREFIX="(function (require, define, __filename, __dirname) { ",m._SUFFIX=`
});`;function A(o,u){if(u.__$__isRecorded)return u;const h=function(b){o.record(33,b);try{return u(b)}finally{o.record(34,b)}};return h.__$__isRecorded=!0,h}W.ensureRecordedNodeRequire=A;function d(o){return new t(o)}W.createScriptLoader=d})(_e||(_e={}));var _e;(function(W){class t{constructor(o){let u=o.lastIndexOf("/");u!==-1?this.fromModulePath=o.substr(0,u+1):this.fromModulePath=""}static _normalizeModuleId(o){let u=o,h;for(h=/\/\.\//;h.test(u);)u=u.replace(h,"/");for(u=u.replace(/^\.\//g,""),h=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;h.test(u);)u=u.replace(h,"/");return u=u.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),u}resolveModule(o){let u=o;return W.Utilities.isAbsolutePath(u)||(W.Utilities.startsWith(u,"./")||W.Utilities.startsWith(u,"../"))&&(u=t._normalizeModuleId(this.fromModulePath+u)),u}}t.ROOT=new t(""),W.ModuleIdResolver=t;class n{constructor(o,u,h,$,b,c){this.id=o,this.strId=u,this.dependencies=h,this._callback=$,this._errorback=b,this.moduleIdResolver=c,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(o,u){try{return{returnedValue:o.apply(W.global,u),producedError:null}}catch(h){return{returnedValue:null,producedError:h}}}static _invokeFactory(o,u,h,$){return o.shouldInvokeFactory(u)?o.shouldCatchError()?this._safeInvokeFunction(h,$):{returnedValue:h.apply(W.global,$),producedError:null}:{returnedValue:null,producedError:null}}complete(o,u,h,$){this._isComplete=!0;let b=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);let c=n._invokeFactory(u,this.strId,this._callback,h);b=c.producedError,o.record(22,this.strId),!b&&typeof c.returnedValue<"u"&&(!this.exportsPassedIn||W.Utilities.isEmpty(this.exports))&&(this.exports=c.returnedValue)}else this.exports=this._callback;if(b){let c=W.ensureError(b);c.phase="factory",c.moduleId=this.strId,c.neededBy=$(this.id),this.error=c,u.onError(c)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1}isComplete(){return this._isComplete}}W.Module=n;class i{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(o){let u=this._strModuleIdToIntModuleId.get(o);return typeof u>"u"&&(u=this._nextId++,this._strModuleIdToIntModuleId.set(o,u),this._intModuleIdToStrModuleId[u]=o),u}getStrModuleId(o){return this._intModuleIdToStrModuleId[o]}}class p{constructor(o){this.id=o}}p.EXPORTS=new p(0),p.MODULE=new p(1),p.REQUIRE=new p(2),W.RegularDependency=p;class m{constructor(o,u,h){this.id=o,this.pluginId=u,this.pluginParam=h}}W.PluginDependency=m;class A{constructor(o,u,h,$,b=0){this._env=o,this._scriptLoader=u,this._loaderAvailableTimestamp=b,this._defineFunc=h,this._requireFunc=$,this._moduleIdProvider=new i,this._config=new W.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new A(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(o,u){let h=c=>c.replace(/\\/g,"/"),$=h(o),b=u.split(/\n/);for(let c=0;c<b.length;c++){let e=b[c].match(/(.*):(\d+):(\d+)\)?$/);if(e){let l=e[1],g=e[2],L=e[3],N=Math.max(l.lastIndexOf(" ")+1,l.lastIndexOf("(")+1);if(l=l.substr(N),l=h(l),l===$){let E={line:parseInt(g,10),col:parseInt(L,10)};return E.line===1&&(E.col-=53),E}}}throw new Error("Could not correlate define call site for needle "+o)}getBuildInfo(){if(!this._config.isBuild())return null;let o=[],u=0;for(let h=0,$=this._modules2.length;h<$;h++){let b=this._modules2[h];if(!b)continue;let c=this._buildInfoPath[b.id]||null,e=this._buildInfoDefineStack[b.id]||null,l=this._buildInfoDependencies[b.id];o[u++]={id:b.strId,path:c,defineLocation:c&&e?A._findRelevantLocationInStack(c,e):null,dependencies:l,shim:null,exports:b.exports}}return o}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new W.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=W.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(o,u){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let h=null;this._config.isBuild()&&(h=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:h,dependencies:o,callback:u}}defineModule(o,u,h,$,b,c=new t(o)){let e=this._moduleIdProvider.getModuleId(o);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}let l=new n(e,o,this._normalizeDependencies(u,c),h,$,c);this._modules2[e]=l,this._config.isBuild()&&(this._buildInfoDefineStack[e]=b,this._buildInfoDependencies[e]=(l.dependencies||[]).map(g=>this._moduleIdProvider.getStrModuleId(g.id))),this._resolve(l)}_normalizeDependency(o,u){if(o==="exports")return p.EXPORTS;if(o==="module")return p.MODULE;if(o==="require")return p.REQUIRE;let h=o.indexOf("!");if(h>=0){let $=u.resolveModule(o.substr(0,h)),b=u.resolveModule(o.substr(h+1)),c=this._moduleIdProvider.getModuleId($+"!"+b),e=this._moduleIdProvider.getModuleId($);return new m(c,e,b)}return new p(this._moduleIdProvider.getModuleId(u.resolveModule(o)))}_normalizeDependencies(o,u){let h=[],$=0;for(let b=0,c=o.length;b<c;b++)h[$++]=this._normalizeDependency(o[b],u);return h}_relativeRequire(o,u,h,$){if(typeof u=="string")return this.synchronousRequire(u,o);this.defineModule(W.Utilities.generateAnonymousModule(),u,h,$,null,o)}synchronousRequire(o,u=new t(o)){let h=this._normalizeDependency(o,u),$=this._modules2[h.id];if(!$)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!$.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if($.error)throw $.error;return $.exports}configure(o,u){let h=this._config.shouldRecordStats();u?this._config=new W.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!h&&(this._recorder=null)}getConfig(){return this._config}_onLoad(o){if(this._currentAnonymousDefineCall!==null){let u=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),u.dependencies,u.callback,null,u.stack)}}_createLoadError(o,u){let h=this._moduleIdProvider.getStrModuleId(o),$=(this._inverseDependencies2[o]||[]).map(c=>this._moduleIdProvider.getStrModuleId(c));const b=W.ensureError(u);return b.phase="loading",b.moduleId=h,b.neededBy=$,b}_onLoadError(o,u){const h=this._createLoadError(o,u);this._modules2[o]||(this._modules2[o]=new n(o,this._moduleIdProvider.getStrModuleId(o),[],()=>{},null,null));let $=[];for(let e=0,l=this._moduleIdProvider.getMaxModuleId();e<l;e++)$[e]=!1;let b=!1,c=[];for(c.push(o),$[o]=!0;c.length>0;){let e=c.shift(),l=this._modules2[e];l&&(b=l.onDependencyError(h)||b);let g=this._inverseDependencies2[e];if(g)for(let L=0,N=g.length;L<N;L++){let E=g[L];$[E]||(c.push(E),$[E]=!0)}}b||this._config.onError(h)}_hasDependencyPath(o,u){let h=this._modules2[o];if(!h)return!1;let $=[];for(let c=0,e=this._moduleIdProvider.getMaxModuleId();c<e;c++)$[c]=!1;let b=[];for(b.push(h),$[o]=!0;b.length>0;){let e=b.shift().dependencies;if(e)for(let l=0,g=e.length;l<g;l++){let L=e[l];if(L.id===u)return!0;let N=this._modules2[L.id];N&&!$[L.id]&&($[L.id]=!0,b.push(N))}}return!1}_findCyclePath(o,u,h){if(o===u||h===50)return[o];let $=this._modules2[o];if(!$)return null;let b=$.dependencies;if(b)for(let c=0,e=b.length;c<e;c++){let l=this._findCyclePath(b[c].id,u,h+1);if(l!==null)return l.push(o),l}return null}_createRequire(o){let u=(h,$,b)=>this._relativeRequire(o,h,$,b);return u.toUrl=h=>this._config.requireToUrl(o.resolveModule(h)),u.getStats=()=>this.getLoaderEvents(),u.hasDependencyCycle=()=>this._hasDependencyCycle,u.config=(h,$=!1)=>{this.configure(h,$)},u.__$__nodeRequire=W.global.nodeRequire,u}_loadModule(o){if(this._modules2[o]||this._knownModules2[o])return;this._knownModules2[o]=!0;let u=this._moduleIdProvider.getStrModuleId(o),h=this._config.moduleIdToPaths(u),$=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(u.indexOf("/")===-1||$.test(u))&&h.push("node|"+u);let b=-1,c=e=>{if(b++,b>=h.length)this._onLoadError(o,e);else{let l=h[b],g=this.getRecorder();if(this._config.isBuild()&&l==="empty:"){this._buildInfoPath[o]=l,this.defineModule(this._moduleIdProvider.getStrModuleId(o),[],null,null,null),this._onLoad(o);return}g.record(10,l),this._scriptLoader.load(this,l,()=>{this._config.isBuild()&&(this._buildInfoPath[o]=l),g.record(11,l),this._onLoad(o)},L=>{g.record(12,l),c(L)})}};c(null)}_loadPluginDependency(o,u){if(this._modules2[u.id]||this._knownModules2[u.id])return;this._knownModules2[u.id]=!0;let h=$=>{this.defineModule(this._moduleIdProvider.getStrModuleId(u.id),[],$,null,null)};h.error=$=>{this._config.onError(this._createLoadError(u.id,$))},o.load(u.pluginParam,this._createRequire(t.ROOT),h,this._config.getOptionsLiteral())}_resolve(o){let u=o.dependencies;if(u)for(let h=0,$=u.length;h<$;h++){let b=u[h];if(b===p.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(b===p.MODULE){o.unresolvedDependenciesCount--;continue}if(b===p.REQUIRE){o.unresolvedDependenciesCount--;continue}let c=this._modules2[b.id];if(c&&c.isComplete()){if(c.error){o.onDependencyError(c.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");let e=this._findCyclePath(b.id,o.id,0)||[];e.reverse(),e.push(b.id),console.warn(e.map(l=>this._moduleIdProvider.getStrModuleId(l)).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(o.id),b instanceof m){let e=this._modules2[b.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,b);continue}let l=this._inversePluginDependencies2.get(b.pluginId);l||(l=[],this._inversePluginDependencies2.set(b.pluginId,l)),l.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)}_onModuleComplete(o){let u=this.getRecorder();if(o.isComplete())return;let h=o.dependencies,$=[];if(h)for(let l=0,g=h.length;l<g;l++){let L=h[l];if(L===p.EXPORTS){$[l]=o.exports;continue}if(L===p.MODULE){$[l]={id:o.strId,config:()=>this._config.getConfigForModule(o.strId)};continue}if(L===p.REQUIRE){$[l]=this._createRequire(o.moduleIdResolver);continue}let N=this._modules2[L.id];if(N){$[l]=N.exports;continue}$[l]=null}const b=l=>(this._inverseDependencies2[l]||[]).map(g=>this._moduleIdProvider.getStrModuleId(g));o.complete(u,this._config,$,b);let c=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,c)for(let l=0,g=c.length;l<g;l++){let L=c[l],N=this._modules2[L];N.unresolvedDependenciesCount--,N.unresolvedDependenciesCount===0&&this._onModuleComplete(N)}let e=this._inversePluginDependencies2.get(o.id);if(e){this._inversePluginDependencies2.delete(o.id);for(let l=0,g=e.length;l<g;l++)this._loadPluginDependency(o.exports,e[l])}}}W.ModuleManager=A})(_e||(_e={}));var ie,_e;(function(W){const t=new W.Environment;let n=null;const i=function(d,o,u){typeof d!="string"&&(u=o,o=d,d=null),(typeof o!="object"||!Array.isArray(o))&&(u=o,o=null),o||(o=["require","exports","module"]),d?n.defineModule(d,o,u,null,null):n.enqueueDefineAnonymousModule(o,u)};i.amd={jQuery:!0};const p=function(d,o=!1){n.configure(d,o)},m=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){p(arguments[0]);return}if(typeof arguments[0]=="string")return n.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){n.defineModule(W.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};m.config=p,m.getConfig=function(){return n.getConfig().getOptionsLiteral()},m.reset=function(){n=n.reset()},m.getBuildInfo=function(){return n.getBuildInfo()},m.getStats=function(){return n.getLoaderEvents()},m.define=i;function A(){if(typeof W.global.require<"u"||typeof require<"u"){const d=W.global.require||require;if(typeof d=="function"&&typeof d.resolve=="function"){const o=W.ensureRecordedNodeRequire(n.getRecorder(),d);W.global.nodeRequire=o,m.nodeRequire=o,m.__$__nodeRequire=o}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=m:(t.isElectronRenderer||(W.global.define=i),W.global.require=m)}W.init=A,(typeof W.global.define!="function"||!W.global.define.amd)&&(n=new W.ModuleManager(t,W.createScriptLoader(t),i,m,W.Utilities.getHighPerformanceTimestamp()),typeof W.global.require<"u"&&typeof W.global.require!="function"&&m.config(W.global.require),ie=function(){return i.apply(null,arguments)},ie.amd=i.amd,typeof doNotInitLoader>"u"&&A())})(_e||(_e={})),ie(re[83],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=n;function n(d,o,u,h){if(h=h||{},(h["vs/css"]||{}).disabled){u({});return}const b=o.toUrl(d+".css");i(d,b,()=>{u({})},c=>{typeof u.error=="function"&&u.error("Could not find "+b+".")})}function i(d,o,u,h){if(p(d,o)){u();return}m(d,o,u,h)}function p(d,o){const u=window.document.getElementsByTagName("link");for(let h=0,$=u.length;h<$;h++){const b=u[h].getAttribute("data-name"),c=u[h].getAttribute("href");if(b===d||c===o)return!0}return!1}function m(d,o,u,h){const $=document.createElement("link");$.setAttribute("rel","stylesheet"),$.setAttribute("type","text/css"),$.setAttribute("data-name",d),A(d,$,u,h),$.setAttribute("href",o),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild($)}function A(d,o,u,h){const $=()=>{o.removeEventListener("load",b),o.removeEventListener("error",c)},b=e=>{$(),u()},c=e=>{$(),h(e)};o.addEventListener("load",b),o.addEventListener("error",c)}}),function(){const W=globalThis.MonacoEnvironment,t=W&&W.baseUrl?W.baseUrl:"../../../";function n($,b){if(W?.createTrustedTypesPolicy)try{return W.createTrustedTypesPolicy($,b)}catch(c){console.warn(c);return}try{return self.trustedTypes?.createPolicy($,b)}catch(c){console.warn(c);return}}const i=n("amdLoader",{createScriptURL:$=>$,createScript:($,...b)=>{const c=b.slice(0,-1).join(","),e=b.pop().toString();return`(function anonymous(${c}) { ${e}
})`}});function p(){try{return(i?globalThis.eval(i.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function m(){return new Promise(($,b)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return $();const c=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,globalThis.origin.length)!==globalThis.origin)&&p()){fetch(c).then(l=>{if(l.status!==200)throw new Error(l.statusText);return l.text()}).then(l=>{l=`${l}
//# sourceURL=${c}`,(i?globalThis.eval(i.createScript("",l)):new Function(l)).call(globalThis),$()}).then(void 0,b);return}i?importScripts(i.createScriptURL(c)):importScripts(c),$()})}function A(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:i,amdModulesPattern:/^vs\//})}function d($){return m().then(()=>(A(),new Promise((b,c)=>{require([$],b,c)})))}function o($){setTimeout(function(){const b=$.create((c,e)=>{globalThis.postMessage(c,e)});for(self.onmessage=c=>b.onmessage(c.data,c.ports);h.length>0;)self.onmessage(h.shift())},0)}typeof globalThis.define=="function"&&globalThis.define.amd&&A();let u=!0;const h=[];globalThis.onmessage=$=>{if(!u){h.push($);return}u=!1,d($.data).then(b=>{o(b)},b=>{console.error(b)})}}(),ie(re[11],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qb=void 0,t.$jb=n,t.$kb=i,t.$lb=p,t.$mb=m,t.$nb=A,t.$ob=d,t.$pb=o,t.$rb=h,t.$sb=$,t.$tb=b,t.$ub=c,t.$vb=e;function n(l,g){const L=i(l,g);if(L!==-1)return l[L]}function i(l,g,L=l.length-1){for(let N=L;N>=0;N--){const E=l[N];if(g(E))return N}return-1}function p(l,g){const L=m(l,g);return L===-1?void 0:l[L]}function m(l,g,L=0,N=l.length){let E=L,_=N;for(;E<_;){const w=Math.floor((E+_)/2);g(l[w])?E=w+1:_=w}return E-1}function A(l,g){const L=d(l,g);return L===l.length?void 0:l[L]}function d(l,g,L=0,N=l.length){let E=L,_=N;for(;E<_;){const w=Math.floor((E+_)/2);g(l[w])?_=w:E=w+1}return E}function o(l,g,L=0,N=l.length){const E=d(l,g,L,N);return E===l.length?-1:E}class u{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(u.assertInvariants){if(this.d){for(const N of this.e)if(this.d(N)&&!g(N))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const L=m(this.e,g,this.c);return this.c=L+1,L===-1?void 0:this.e[L]}}t.$qb=u;function h(l,g){if(l.length===0)return;let L=l[0];for(let N=1;N<l.length;N++){const E=l[N];g(E,L)>0&&(L=E)}return L}function $(l,g){if(l.length===0)return;let L=l[0];for(let N=1;N<l.length;N++){const E=l[N];g(E,L)>=0&&(L=E)}return L}function b(l,g){return h(l,(L,N)=>-g(L,N))}function c(l,g){if(l.length===0)return-1;let L=0;for(let N=1;N<l.length;N++){const E=l[N];g(E,l[L])>0&&(L=N)}return L}function e(l,g){for(const L of l){const N=g(L);if(N!==void 0)return N}}}),ie(re[3],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharCode=void 0;var n;(function(i){i[i.Null=0]="Null",i[i.Backspace=8]="Backspace",i[i.Tab=9]="Tab",i[i.LineFeed=10]="LineFeed",i[i.CarriageReturn=13]="CarriageReturn",i[i.Space=32]="Space",i[i.ExclamationMark=33]="ExclamationMark",i[i.DoubleQuote=34]="DoubleQuote",i[i.Hash=35]="Hash",i[i.DollarSign=36]="DollarSign",i[i.PercentSign=37]="PercentSign",i[i.Ampersand=38]="Ampersand",i[i.SingleQuote=39]="SingleQuote",i[i.OpenParen=40]="OpenParen",i[i.CloseParen=41]="CloseParen",i[i.Asterisk=42]="Asterisk",i[i.Plus=43]="Plus",i[i.Comma=44]="Comma",i[i.Dash=45]="Dash",i[i.Period=46]="Period",i[i.Slash=47]="Slash",i[i.Digit0=48]="Digit0",i[i.Digit1=49]="Digit1",i[i.Digit2=50]="Digit2",i[i.Digit3=51]="Digit3",i[i.Digit4=52]="Digit4",i[i.Digit5=53]="Digit5",i[i.Digit6=54]="Digit6",i[i.Digit7=55]="Digit7",i[i.Digit8=56]="Digit8",i[i.Digit9=57]="Digit9",i[i.Colon=58]="Colon",i[i.Semicolon=59]="Semicolon",i[i.LessThan=60]="LessThan",i[i.Equals=61]="Equals",i[i.GreaterThan=62]="GreaterThan",i[i.QuestionMark=63]="QuestionMark",i[i.AtSign=64]="AtSign",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.OpenSquareBracket=91]="OpenSquareBracket",i[i.Backslash=92]="Backslash",i[i.CloseSquareBracket=93]="CloseSquareBracket",i[i.Caret=94]="Caret",i[i.Underline=95]="Underline",i[i.BackTick=96]="BackTick",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.OpenCurlyBrace=123]="OpenCurlyBrace",i[i.Pipe=124]="Pipe",i[i.CloseCurlyBrace=125]="CloseCurlyBrace",i[i.Tilde=126]="Tilde",i[i.NoBreakSpace=160]="NoBreakSpace",i[i.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",i[i.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",i[i.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",i[i.U_Combining_Tilde=771]="U_Combining_Tilde",i[i.U_Combining_Macron=772]="U_Combining_Macron",i[i.U_Combining_Overline=773]="U_Combining_Overline",i[i.U_Combining_Breve=774]="U_Combining_Breve",i[i.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",i[i.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",i[i.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",i[i.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",i[i.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",i[i.U_Combining_Caron=780]="U_Combining_Caron",i[i.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",i[i.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",i[i.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",i[i.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",i[i.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",i[i.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",i[i.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",i[i.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",i[i.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",i[i.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",i[i.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",i[i.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",i[i.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",i[i.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",i[i.U_Combining_Horn=795]="U_Combining_Horn",i[i.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",i[i.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",i[i.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",i[i.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",i[i.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",i[i.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",i[i.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",i[i.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",i[i.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",i[i.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",i[i.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",i[i.U_Combining_Cedilla=807]="U_Combining_Cedilla",i[i.U_Combining_Ogonek=808]="U_Combining_Ogonek",i[i.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",i[i.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",i[i.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",i[i.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",i[i.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",i[i.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",i[i.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",i[i.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",i[i.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",i[i.U_Combining_Low_Line=818]="U_Combining_Low_Line",i[i.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",i[i.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",i[i.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",i[i.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",i[i.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",i[i.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",i[i.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",i[i.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",i[i.U_Combining_Square_Below=827]="U_Combining_Square_Below",i[i.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",i[i.U_Combining_X_Above=829]="U_Combining_X_Above",i[i.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",i[i.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",i[i.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",i[i.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",i[i.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",i[i.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",i[i.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",i[i.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",i[i.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",i[i.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",i[i.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",i[i.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",i[i.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",i[i.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",i[i.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",i[i.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",i[i.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",i[i.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",i[i.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",i[i.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",i[i.U_Combining_Fermata=850]="U_Combining_Fermata",i[i.U_Combining_X_Below=851]="U_Combining_X_Below",i[i.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",i[i.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",i[i.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",i[i.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",i[i.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",i[i.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",i[i.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",i[i.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",i[i.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",i[i.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",i[i.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",i[i.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",i[i.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",i[i.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",i[i.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",i[i.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",i[i.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",i[i.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",i[i.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",i[i.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",i[i.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",i[i.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",i[i.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",i[i.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",i[i.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",i[i.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",i[i.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",i[i.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",i[i.LINE_SEPARATOR=8232]="LINE_SEPARATOR",i[i.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",i[i.NEXT_LINE=133]="NEXT_LINE",i[i.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",i[i.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",i[i.U_DIAERESIS=168]="U_DIAERESIS",i[i.U_MACRON=175]="U_MACRON",i[i.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",i[i.U_CEDILLA=184]="U_CEDILLA",i[i.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",i[i.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",i[i.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",i[i.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",i[i.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",i[i.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",i[i.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",i[i.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",i[i.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",i[i.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",i[i.U_BREVE=728]="U_BREVE",i[i.U_DOT_ABOVE=729]="U_DOT_ABOVE",i[i.U_RING_ABOVE=730]="U_RING_ABOVE",i[i.U_OGONEK=731]="U_OGONEK",i[i.U_SMALL_TILDE=732]="U_SMALL_TILDE",i[i.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",i[i.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",i[i.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",i[i.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",i[i.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",i[i.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",i[i.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",i[i.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",i[i.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",i[i.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",i[i.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",i[i.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",i[i.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",i[i.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",i[i.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",i[i.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",i[i.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",i[i.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",i[i.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",i[i.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",i[i.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",i[i.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",i[i.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",i[i.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",i[i.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",i[i.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",i[i.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",i[i.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",i[i.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",i[i.U_GREEK_TONOS=900]="U_GREEK_TONOS",i[i.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",i[i.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",i[i.U_GREEK_PSILI=8127]="U_GREEK_PSILI",i[i.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",i[i.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",i[i.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",i[i.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",i[i.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",i[i.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",i[i.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",i[i.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",i[i.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",i[i.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",i[i.U_GREEK_VARIA=8175]="U_GREEK_VARIA",i[i.U_GREEK_OXIA=8189]="U_GREEK_OXIA",i[i.U_GREEK_DASIA=8190]="U_GREEK_DASIA",i[i.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",i[i.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",i[i.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",i[i.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",i[i.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",i[i.U_OVERLINE=8254]="U_OVERLINE",i[i.UTF8_BOM=65279]="UTF8_BOM",i[i.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",i[i.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(n||(t.CharCode=n={}))}),ie(re[42],ue([0,1]),function(W,t){"use strict";var n;Object.defineProperty(t,"__esModule",{value:!0}),t.$i=void 0,t.$e=i,t.$f=p,t.$g=m,t.$h=A;function i(o,u){const h=Object.create(null);for(const $ of o){const b=u($);let c=h[b];c||(c=h[b]=[]),c.push($)}return h}function p(o,u){const h=[],$=[];for(const b of o)u.has(b)||h.push(b);for(const b of u)o.has(b)||$.push(b);return{removed:h,added:$}}function m(o,u){const h=[],$=[];for(const[b,c]of o)u.has(b)||h.push(c);for(const[b,c]of u)o.has(b)||$.push(c);return{removed:h,added:$}}function A(o,u){const h=new Set;for(const $ of u)o.has($)&&h.add($);return h}class d{static{n=Symbol.toStringTag}constructor(u,h){this.b=h,this.a=new Map,this[n]="SetWithKey";for(const $ of u)this.add($)}get size(){return this.a.size}add(u){const h=this.b(u);return this.a.set(h,u),this}delete(u){return this.a.delete(this.b(u))}has(u){return this.a.has(this.b(u))}*entries(){for(const u of this.a.values())yield[u,u]}keys(){return this.values()}*values(){for(const u of this.a.values())yield u}clear(){this.a.clear()}forEach(u,h){this.a.forEach($=>u.call(h,$,$,this))}[Symbol.iterator](){return this.values()}}t.$i=d}),ie(re[43],ue([0,1,3]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wu=t.$vu=t.$uu=t.$tu=void 0;function i(o,u){const h=Math.pow(10,u);return Math.round(o*h)/h}class p{constructor(u,h,$,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,h))|0,this.b=Math.min(255,Math.max(0,$))|0,this.a=i(Math.max(Math.min(1,b),0),3)}static equals(u,h){return u.r===h.r&&u.g===h.g&&u.b===h.b&&u.a===h.a}}t.$tu=p;class m{constructor(u,h,$,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=i(Math.max(Math.min(1,h),0),3),this.l=i(Math.max(Math.min(1,$),0),3),this.a=i(Math.max(Math.min(1,b),0),3)}static equals(u,h){return u.h===h.h&&u.s===h.s&&u.l===h.l&&u.a===h.a}static fromRGBA(u){const h=u.r/255,$=u.g/255,b=u.b/255,c=u.a,e=Math.max(h,$,b),l=Math.min(h,$,b);let g=0,L=0;const N=(l+e)/2,E=e-l;if(E>0){switch(L=Math.min(N<=.5?E/(2*N):E/(2-2*N),1),e){case h:g=($-b)/E+($<b?6:0);break;case $:g=(b-h)/E+2;break;case b:g=(h-$)/E+4;break}g*=60,g=Math.round(g)}return new m(g,L,N,c)}static i(u,h,$){return $<0&&($+=1),$>1&&($-=1),$<1/6?u+(h-u)*6*$:$<1/2?h:$<2/3?u+(h-u)*(2/3-$)*6:u}static toRGBA(u){const h=u.h/360,{s:$,l:b,a:c}=u;let e,l,g;if($===0)e=l=g=b;else{const L=b<.5?b*(1+$):b+$-b*$,N=2*b-L;e=m.i(N,L,h+1/3),l=m.i(N,L,h),g=m.i(N,L,h-1/3)}return new p(Math.round(e*255),Math.round(l*255),Math.round(g*255),c)}}t.$uu=m;class A{constructor(u,h,$,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=i(Math.max(Math.min(1,h),0),3),this.v=i(Math.max(Math.min(1,$),0),3),this.a=i(Math.max(Math.min(1,b),0),3)}static equals(u,h){return u.h===h.h&&u.s===h.s&&u.v===h.v&&u.a===h.a}static fromRGBA(u){const h=u.r/255,$=u.g/255,b=u.b/255,c=Math.max(h,$,b),e=Math.min(h,$,b),l=c-e,g=c===0?0:l/c;let L;return l===0?L=0:c===h?L=(($-b)/l%6+6)%6:c===$?L=(b-h)/l+2:L=(h-$)/l+4,new A(Math.round(L*60),g,c,u.a)}static toRGBA(u){const{h,s:$,v:b,a:c}=u,e=b*$,l=e*(1-Math.abs(h/60%2-1)),g=b-e;let[L,N,E]=[0,0,0];return h<60?(L=e,N=l):h<120?(L=l,N=e):h<180?(N=e,E=l):h<240?(N=l,E=e):h<300?(L=l,E=e):h<=360&&(L=e,E=l),L=Math.round((L+g)*255),N=Math.round((N+g)*255),E=Math.round((E+g)*255),new p(L,N,E,c)}}t.$vu=A;class d{static fromHex(u){return d.Format.CSS.parseHex(u)||d.red}static equals(u,h){return!u&&!h?!0:!u||!h?!1:u.equals(h)}get hsla(){return this.i?this.i:m.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:A.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof p)this.rgba=u;else if(u instanceof m)this.i=u,this.rgba=m.toRGBA(u);else if(u instanceof A)this.j=u,this.rgba=A.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&p.equals(this.rgba,u.rgba)&&m.equals(this.hsla,u.hsla)&&A.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=d.k(this.rgba.r),h=d.k(this.rgba.g),$=d.k(this.rgba.b),b=.2126*u+.7152*h+.0722*$;return i(b,4)}static k(u){const h=u/255;return h<=.03928?h/12.92:Math.pow((h+.055)/1.055,2.4)}getContrastRatio(u){const h=this.getRelativeLuminance(),$=u.getRelativeLuminance();return h>$?(h+.05)/($+.05):($+.05)/(h+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const h=this.getRelativeLuminance(),$=u.getRelativeLuminance();return h>$}isDarkerThan(u){const h=this.getRelativeLuminance(),$=u.getRelativeLuminance();return h<$}lighten(u){return new d(new m(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new d(new m(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:h,g:$,b,a:c}=this.rgba;return new d(new p(h,$,b,c*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new d(new p(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const h=u.rgba,$=this.rgba.a,b=h.a,c=$+b*(1-$);if(c<1e-6)return d.transparent;const e=this.rgba.r*$/c+h.r*b*(1-$)/c,l=this.rgba.g*$/c+h.g*b*(1-$)/c,g=this.rgba.b*$/c+h.b*b*(1-$)/c;return new d(new p(e,l,g,c))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:h,g:$,b,a:c}=this.rgba;return new d(new p(u.rgba.r-c*(u.rgba.r-h),u.rgba.g-c*(u.rgba.g-$),u.rgba.b-c*(u.rgba.b-b),1))}flatten(...u){const h=u.reduceRight(($,b)=>d.o(b,$));return d.o(this,h)}static o(u,h){const $=1-u.rgba.a;return new d(new p($*h.rgba.r+u.rgba.a*u.rgba.r,$*h.rgba.g+u.rgba.a*u.rgba.g,$*h.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this.u||(this.u=d.Format.CSS.format(this)),this.u}static getLighterColor(u,h,$){if(u.isLighterThan(h))return u;$=$||.5;const b=u.getRelativeLuminance(),c=h.getRelativeLuminance();return $=$*(c-b)/c,u.lighten($)}static getDarkerColor(u,h,$){if(u.isDarkerThan(h))return u;$=$||.5;const b=u.getRelativeLuminance(),c=h.getRelativeLuminance();return $=$*(b-c)/b,u.darken($)}static{this.white=new d(new p(255,255,255,1))}static{this.black=new d(new p(0,0,0,1))}static{this.red=new d(new p(255,0,0,1))}static{this.blue=new d(new p(0,0,255,1))}static{this.green=new d(new p(0,255,0,1))}static{this.cyan=new d(new p(0,255,255,1))}static{this.lightgrey=new d(new p(211,211,211,1))}static{this.transparent=new d(new p(0,0,0,0))}}t.$wu=d,function(o){let u;(function(h){let $;(function(b){function c(s){return s.rgba.a===1?`rgb(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b})`:o.Format.CSS.formatRGBA(s)}b.formatRGB=c;function e(s){return`rgba(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b}, ${+s.rgba.a.toFixed(2)})`}b.formatRGBA=e;function l(s){return s.hsla.a===1?`hsl(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%)`:o.Format.CSS.formatHSLA(s)}b.formatHSL=l;function g(s){return`hsla(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%, ${s.hsla.a.toFixed(2)})`}b.formatHSLA=g;function L(s){const f=s.toString(16);return f.length!==2?"0"+f:f}function N(s){return`#${L(s.rgba.r)}${L(s.rgba.g)}${L(s.rgba.b)}`}b.formatHex=N;function E(s,f=!1){return f&&s.rgba.a===1?o.Format.CSS.formatHex(s):`#${L(s.rgba.r)}${L(s.rgba.g)}${L(s.rgba.b)}${L(Math.round(s.rgba.a*255))}`}b.formatHexA=E;function _(s){return s.isOpaque()?o.Format.CSS.formatHex(s):o.Format.CSS.formatRGBA(s)}b.format=_;function w(s){const f=s.length;if(f===0||s.charCodeAt(0)!==n.CharCode.Hash)return null;if(f===7){const v=16*a(s.charCodeAt(1))+a(s.charCodeAt(2)),k=16*a(s.charCodeAt(3))+a(s.charCodeAt(4)),R=16*a(s.charCodeAt(5))+a(s.charCodeAt(6));return new o(new p(v,k,R,1))}if(f===9){const v=16*a(s.charCodeAt(1))+a(s.charCodeAt(2)),k=16*a(s.charCodeAt(3))+a(s.charCodeAt(4)),R=16*a(s.charCodeAt(5))+a(s.charCodeAt(6)),T=16*a(s.charCodeAt(7))+a(s.charCodeAt(8));return new o(new p(v,k,R,T/255))}if(f===4){const v=a(s.charCodeAt(1)),k=a(s.charCodeAt(2)),R=a(s.charCodeAt(3));return new o(new p(16*v+v,16*k+k,16*R+R))}if(f===5){const v=a(s.charCodeAt(1)),k=a(s.charCodeAt(2)),R=a(s.charCodeAt(3)),T=a(s.charCodeAt(4));return new o(new p(16*v+v,16*k+k,16*R+R,(16*T+T)/255))}return null}b.parseHex=w;function a(s){switch(s){case n.CharCode.Digit0:return 0;case n.CharCode.Digit1:return 1;case n.CharCode.Digit2:return 2;case n.CharCode.Digit3:return 3;case n.CharCode.Digit4:return 4;case n.CharCode.Digit5:return 5;case n.CharCode.Digit6:return 6;case n.CharCode.Digit7:return 7;case n.CharCode.Digit8:return 8;case n.CharCode.Digit9:return 9;case n.CharCode.a:return 10;case n.CharCode.A:return 10;case n.CharCode.b:return 11;case n.CharCode.B:return 11;case n.CharCode.c:return 12;case n.CharCode.C:return 12;case n.CharCode.d:return 13;case n.CharCode.D:return 13;case n.CharCode.e:return 14;case n.CharCode.E:return 14;case n.CharCode.f:return 15;case n.CharCode.F:return 15}return 0}})($=h.CSS||(h.CSS={}))})(u=o.Format||(o.Format={}))}(d||(t.$wu=d={}))}),ie(re[44],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zt=void 0;class n{constructor(p,m,A,d){this.originalStart=p,this.originalLength=m,this.modifiedStart=A,this.modifiedLength=d}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Zt=n}),ie(re[4],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gb=t.$fb=t.$eb=t.$db=t.$cb=t.$ab=t.$9=t.$1=t.$Z=void 0,t.setUnexpectedErrorHandler=i,t.$3=p,t.$4=m,t.$5=A,t.$6=d,t.$7=o,t.$8=h,t.$0=b,t.$$=c,t.$_=e,t.$bb=g;class n{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?_.isErrorNoTelemetry(s)?new _(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(f=>{f(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}t.$Z=n,t.$1=new n;function i(a){t.$1.setUnexpectedErrorHandler(a)}function p(a){if(!a||typeof a!="object")return!1;const s=a;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}function m(a){h(a)||t.$1.onUnexpectedError(a)}function A(a){h(a)||t.$1.onUnexpectedExternalError(a)}function d(a){if(a instanceof Error){const{name:s,message:f}=a,v=a.stacktrace||a.stack;return{$isError:!0,name:s,message:f,stack:v,noTelemetry:_.isErrorNoTelemetry(a)}}return a}function o(a){let s;return a.noTelemetry?s=new _:(s=new Error,s.name=a.name),s.message=a.message,s.stack=a.stack,s}const u="Canceled";function h(a){return a instanceof $?!0:a instanceof Error&&a.name===u&&a.message===u}class $ extends Error{constructor(){super(u),this.name=this.message}}t.$9=$;function b(){const a=new Error(u);return a.name=a.message,a}function c(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function e(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class l extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$ab=l;function g(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class L extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}t.$cb=L;class N extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}t.$db=N;class E extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$eb=E;class _ extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof _)return s;const f=new _;return f.message=s.message,f.stack=s.stack,f}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}t.$fb=_;class w extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,w.prototype)}}t.$gb=w}),ie(re[9],ue([0,1,4,11]),function(W,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.$cc=t.$ac=t.$_b=t.CompareResult=void 0,t.$wb=p,t.$xb=m,t.$yb=A,t.$zb=d,t.$Ab=o,t.$Bb=u,t.$Cb=h,t.$Db=$,t.$Eb=b,t.$Fb=c,t.$Gb=e,t.$Hb=l,t.$Ib=g,t.top=L,t.$Kb=N,t.$Lb=_,t.$Mb=w,t.$Nb=a,t.$Ob=s,t.$Pb=f,t.$Qb=v,t.$Rb=k,t.$Sb=R,t.$Tb=T,t.$Ub=j,t.$Vb=M,t.$Wb=D,t.$Xb=F,t.$Yb=y,t.$Zb=B,t.$1b=z,t.$2b=H,t.$3b=U,t.$4b=C,t.$5b=ee,t.$6b=J,t.$7b=K,t.$8b=ne,t.$9b=P,t.$0b=ge,t.$$b=Le,t.$bc=Fe,t.$fc=qe;function p(x,G=0){return x[x.length-(1+G)]}function m(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}function A(x,G,O=(I,q)=>I===q){if(x===G)return!0;if(!x||!G||x.length!==G.length)return!1;for(let I=0,q=x.length;I<q;I++)if(!O(x[I],G[I]))return!1;return!0}function d(x,G){const O=x.length-1;G<O&&(x[G]=x[O]),x.pop()}function o(x,G,O){return u(x.length,I=>O(x[I],G))}function u(x,G){let O=0,I=x-1;for(;O<=I;){const q=(O+I)/2|0,Z=G(q);if(Z<0)O=q+1;else if(Z>0)I=q-1;else return q}return-(O+1)}function h(x,G,O){if(x=x|0,x>=G.length)throw new TypeError("invalid index");const I=G[Math.floor(G.length*Math.random())],q=[],Z=[],Q=[];for(const ae of G){const we=O(ae,I);we<0?q.push(ae):we>0?Z.push(ae):Q.push(ae)}return x<q.length?h(x,q,O):x<q.length+Q.length?Q[0]:h(x-(q.length+Q.length),Z,O)}function $(x,G){const O=[];let I;for(const q of x.slice(0).sort(G))!I||G(I[0],q)!==0?(I=[q],O.push(I)):I.push(q);return O}function*b(x,G){let O,I;for(const q of x)I!==void 0&&G(I,q)?O.push(q):(O&&(yield O),O=[q]),I=q;O&&(yield O)}function c(x,G){for(let O=0;O<=x.length;O++)G(O===0?void 0:x[O-1],O===x.length?void 0:x[O])}function e(x,G){for(let O=0;O<x.length;O++)G(O===0?void 0:x[O-1],x[O],O+1===x.length?void 0:x[O+1])}function l(x,G,O){const I=[];function q(ae,we,Ee){if(we===0&&Ee.length===0)return;const Re=I[I.length-1];Re&&Re.start+Re.deleteCount===ae?(Re.deleteCount+=we,Re.toInsert.push(...Ee)):I.push({start:ae,deleteCount:we,toInsert:Ee})}let Z=0,Q=0;for(;;){if(Z===x.length){q(Z,0,G.slice(Q));break}if(Q===G.length){q(Z,x.length-Z,[]);break}const ae=x[Z],we=G[Q],Ee=O(ae,we);Ee===0?(Z+=1,Q+=1):Ee<0?(q(Z,1,[]),Z+=1):Ee>0&&(q(Z,0,[we]),Q+=1)}return I}function g(x,G,O){const I=l(x,G,O),q=[],Z=[];for(const Q of I)q.push(...x.slice(Q.start,Q.start+Q.deleteCount)),Z.push(...Q.toInsert);return{removed:q,added:Z}}function L(x,G,O){if(O===0)return[];const I=x.slice(0,O).sort(G);return E(x,G,I,O,x.length),I}function N(x,G,O,I,q){return O===0?Promise.resolve([]):new Promise((Z,Q)=>{(async()=>{const ae=x.length,we=x.slice(0,O).sort(G);for(let Ee=O,Re=Math.min(O+I,ae);Ee<ae;Ee=Re,Re=Math.min(Re+I,ae)){if(Ee>O&&await new Promise(oe=>setTimeout(oe)),q&&q.isCancellationRequested)throw new n.$9;E(x,G,we,Ee,Re)}return we})().then(Z,Q)})}function E(x,G,O,I,q){for(const Z=O.length;I<q;I++){const Q=x[I];if(G(Q,O[Z-1])<0){O.pop();const ae=(0,i.$ob)(O,we=>G(Q,we)<0);O.splice(ae,0,Q)}}}function _(x){return x.filter(G=>!!G)}function w(x){let G=0;for(let O=0;O<x.length;O++)x[O]&&(x[G]=x[O],G+=1);x.length=G}function a(x,G,O){x.splice(O,0,x.splice(G,1)[0])}function s(x){return!Array.isArray(x)||x.length===0}function f(x){return Array.isArray(x)&&x.length>0}function v(x,G=O=>O){const O=new Set;return x.filter(I=>{const q=G(I);return O.has(q)?!1:(O.add(q),!0)})}function k(x){const G=new Set;return O=>{const I=x(O);return G.has(I)?!1:(G.add(I),!0)}}function R(x,G){return x.length>0?x[0]:G}function T(x,G){return x.length>0?x[x.length-1]:G}function j(x,G,O=(I,q)=>I===q){let I=0;for(let q=0,Z=Math.min(x.length,G.length);q<Z&&O(x[q],G[q]);q++)I++;return I}function M(x,G){let O=typeof G=="number"?x:0;typeof G=="number"?O=x:(O=0,G=x);const I=[];if(O<=G)for(let q=O;q<G;q++)I.push(q);else for(let q=O;q>G;q--)I.push(q);return I}function D(x,G,O){return x.reduce((I,q)=>(I[G(q)]=O?O(q):q,I),Object.create(null))}function F(x,G){return x.push(G),()=>y(x,G)}function y(x,G){const O=x.indexOf(G);if(O>-1)return x.splice(O,1),G}function B(x,G,O){const I=x.slice(0,G),q=x.slice(G);return I.concat(O,q)}function z(x,G){let O;if(typeof G=="number"){let I=G;O=()=>{const q=Math.sin(I++)*179426549;return q-Math.floor(q)}}else O=Math.random;for(let I=x.length-1;I>0;I-=1){const q=Math.floor(O()*(I+1)),Z=x[I];x[I]=x[q],x[q]=Z}}function H(x,G){const O=x.indexOf(G);O>-1&&(x.splice(O,1),x.unshift(G))}function U(x,G){const O=x.indexOf(G);O>-1&&(x.splice(O,1),x.push(G))}function C(x,G){for(const O of G)x.push(O)}function ee(x,G){return Array.isArray(x)?x.map(G):G(x)}function J(x){return Array.isArray(x)?x:[x]}function K(x){return x[Math.floor(Math.random()*x.length)]}function ne(x,G,O){const I=X(x,G),q=x.length,Z=O.length;x.length=q+Z;for(let Q=q-1;Q>=I;Q--)x[Q+Z]=x[Q];for(let Q=0;Q<Z;Q++)x[Q+I]=O[Q]}function P(x,G,O,I){const q=X(x,G);let Z=x.splice(q,O);return Z===void 0&&(Z=[]),ne(x,q,I),Z}function X(x,G){return G<0?Math.max(G+x.length,0):Math.min(G,x.length)}var he;(function(x){function G(Z){return Z<0}x.isLessThan=G;function O(Z){return Z<=0}x.isLessThanOrEqual=O;function I(Z){return Z>0}x.isGreaterThan=I;function q(Z){return Z===0}x.isNeitherLessOrGreaterThan=q,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(he||(t.CompareResult=he={}));function ge(x,G){return(O,I)=>G(x(O),x(I))}function Le(...x){return(G,O)=>{for(const I of x){const q=I(G,O);if(!he.isNeitherLessOrGreaterThan(q))return q}return he.neitherLessOrGreaterThan}}const r=(x,G)=>x-G;t.$_b=r;const Me=(x,G)=>(0,t.$_b)(x?1:0,G?1:0);t.$ac=Me;function Fe(x){return(G,O)=>-x(G,O)}class Ue{constructor(G){this.g=G,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(G){let O=this.c;for(;O<this.g.length&&G(this.g[O]);)O++;const I=O===this.c?null:this.g.slice(this.c,O);return this.c=O,I}takeFromEndWhile(G){let O=this.d;for(;O>=0&&G(this.g[O]);)O--;const I=O===this.d?null:this.g.slice(O+1,this.d+1);return this.d=O,I}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const G=this.g[this.c];return this.c++,G}removeLast(){const G=this.g[this.d];return this.d--,G}takeCount(G){const O=this.g.slice(this.c,this.c+G);return this.c+=G,O}}t.$cc=Ue;class Ae{static{this.empty=new Ae(G=>{})}constructor(G){this.iterate=G}forEach(G){this.iterate(O=>(G(O),!0))}toArray(){const G=[];return this.iterate(O=>(G.push(O),!0)),G}filter(G){return new Ae(O=>this.iterate(I=>G(I)?O(I):!0))}map(G){return new Ae(O=>this.iterate(I=>O(G(I))))}some(G){let O=!1;return this.iterate(I=>(O=G(I),!O)),O}findFirst(G){let O;return this.iterate(I=>G(I)?(O=I,!1):!0),O}findLast(G){let O;return this.iterate(I=>(G(I)&&(O=I),!0)),O}findLastMaxBy(G){let O,I=!0;return this.iterate(q=>((I||he.isGreaterThan(G(q,O)))&&(I=!1,O=q),!0)),O}}t.$dc=Ae;class Ne{constructor(G){this.c=G}static createSortPermutation(G,O){const I=Array.from(G.keys()).sort((q,Z)=>O(G[q],G[Z]));return new Ne(I)}apply(G){return G.map((O,I)=>G[this.c[I]])}inverse(){const G=this.c.slice();for(let O=0;O<this.c.length;O++)G[this.c[O]]=O;return new Ne(G)}}t.$ec=Ne;async function qe(x,G){return(await Promise.all(x.map(async(I,q)=>({element:I,ok:await G(I,q)})))).find(I=>I.ok)?.element}}),ie(re[15],ue([0,1,4]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=i,t.$jd=p,t.$kd=m,t.$ld=A,t.$md=d,t.$nd=o;function i(u,h){if(!u)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}function p(u,h="Unreachable"){throw new Error(h)}function m(u,h="unexpected state"){if(!u)throw new n.$gb(`Assertion Failed: ${h}`)}function A(u){u||(0,n.$4)(new n.$gb("Soft Assertion Failed"))}function d(u){if(!u()){debugger;u(),(0,n.$4)(new n.$gb("Assertion Failed"))}}function o(u,h){let $=0;for(;$<u.length-1;){const b=u[$],c=u[$+1];if(!h(b,c))return!1;$++}return!0}}),ie(re[25],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hb=n;function n(i,p){const m=this;let A=!1,d;return function(){if(A)return d;if(A=!0,p)try{d=i.apply(m,arguments)}finally{p()}else d=i.apply(m,arguments);return d}}}),ie(re[26],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var n;(function(i){function p(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}i.is=p;const m=Object.freeze([]);function A(){return m}i.empty=A;function*d(s){yield s}i.single=d;function o(s){return p(s)?s:d(s)}i.wrap=o;function u(s){return s||m}i.from=u;function*h(s){for(let f=s.length-1;f>=0;f--)yield s[f]}i.reverse=h;function $(s){return!s||s[Symbol.iterator]().next().done===!0}i.isEmpty=$;function b(s){return s[Symbol.iterator]().next().value}i.first=b;function c(s,f){let v=0;for(const k of s)if(f(k,v++))return!0;return!1}i.some=c;function e(s,f){for(const v of s)if(f(v))return v}i.find=e;function*l(s,f){for(const v of s)f(v)&&(yield v)}i.filter=l;function*g(s,f){let v=0;for(const k of s)yield f(k,v++)}i.map=g;function*L(s,f){let v=0;for(const k of s)yield*f(k,v++)}i.flatMap=L;function*N(...s){for(const f of s)yield*f}i.concat=N;function E(s,f,v){let k=v;for(const R of s)k=f(k,R);return k}i.reduce=E;function*_(s,f,v=s.length){for(f<0&&(f+=s.length),v<0?v+=s.length:v>s.length&&(v=s.length);f<v;f++)yield s[f]}i.slice=_;function w(s,f=Number.POSITIVE_INFINITY){const v=[];if(f===0)return[v,s];const k=s[Symbol.iterator]();for(let R=0;R<f;R++){const T=k.next();if(T.done)return[v,i.empty()];v.push(T.value)}return[v,{[Symbol.iterator](){return k}}]}i.consume=w;async function a(s){const f=[];for await(const v of s)f.push(v);return Promise.resolve(f)}i.asyncToArray=a})(n||(t.Iterable=n={}))}),ie(re[45],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$6r=t.$5r=t.$4r=t.$3r=t.$2r=t.ScanCode=t.KeyCode=void 0,t.$7r=c;var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(n||(t.KeyCode=n={}));var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(i||(t.ScanCode=i={}));class p{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(l,g){this._keyCodeToStr[l]=g,this._strToKeyCode[g.toLowerCase()]=l}keyCodeToStr(l){return this._keyCodeToStr[l]}strToKeyCode(l){return this._strToKeyCode[l.toLowerCase()]||n.Unknown}}const m=new p,A=new p,d=new p;t.$2r=new Array(230),t.$3r={};const o=[],u=Object.create(null),h=Object.create(null);t.$4r={lowerCaseToEnum:e=>h[e]||i.None,toEnum:e=>u[e]||i.None,toString:e=>o[e]||"None"},t.$5r=[],t.$6r=[];for(let e=0;e<=i.MAX_VALUE;e++)t.$5r[e]=n.DependsOnKbLayout;for(let e=0;e<=n.MAX_VALUE;e++)t.$6r[e]=i.DependsOnKbLayout;(function(){const e="",l=[[1,i.None,"None",n.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,i.Hyper,"Hyper",n.Unknown,e,0,e,e,e],[1,i.Super,"Super",n.Unknown,e,0,e,e,e],[1,i.Fn,"Fn",n.Unknown,e,0,e,e,e],[1,i.FnLock,"FnLock",n.Unknown,e,0,e,e,e],[1,i.Suspend,"Suspend",n.Unknown,e,0,e,e,e],[1,i.Resume,"Resume",n.Unknown,e,0,e,e,e],[1,i.Turbo,"Turbo",n.Unknown,e,0,e,e,e],[1,i.Sleep,"Sleep",n.Unknown,e,0,"VK_SLEEP",e,e],[1,i.WakeUp,"WakeUp",n.Unknown,e,0,e,e,e],[0,i.KeyA,"KeyA",n.KeyA,"A",65,"VK_A",e,e],[0,i.KeyB,"KeyB",n.KeyB,"B",66,"VK_B",e,e],[0,i.KeyC,"KeyC",n.KeyC,"C",67,"VK_C",e,e],[0,i.KeyD,"KeyD",n.KeyD,"D",68,"VK_D",e,e],[0,i.KeyE,"KeyE",n.KeyE,"E",69,"VK_E",e,e],[0,i.KeyF,"KeyF",n.KeyF,"F",70,"VK_F",e,e],[0,i.KeyG,"KeyG",n.KeyG,"G",71,"VK_G",e,e],[0,i.KeyH,"KeyH",n.KeyH,"H",72,"VK_H",e,e],[0,i.KeyI,"KeyI",n.KeyI,"I",73,"VK_I",e,e],[0,i.KeyJ,"KeyJ",n.KeyJ,"J",74,"VK_J",e,e],[0,i.KeyK,"KeyK",n.KeyK,"K",75,"VK_K",e,e],[0,i.KeyL,"KeyL",n.KeyL,"L",76,"VK_L",e,e],[0,i.KeyM,"KeyM",n.KeyM,"M",77,"VK_M",e,e],[0,i.KeyN,"KeyN",n.KeyN,"N",78,"VK_N",e,e],[0,i.KeyO,"KeyO",n.KeyO,"O",79,"VK_O",e,e],[0,i.KeyP,"KeyP",n.KeyP,"P",80,"VK_P",e,e],[0,i.KeyQ,"KeyQ",n.KeyQ,"Q",81,"VK_Q",e,e],[0,i.KeyR,"KeyR",n.KeyR,"R",82,"VK_R",e,e],[0,i.KeyS,"KeyS",n.KeyS,"S",83,"VK_S",e,e],[0,i.KeyT,"KeyT",n.KeyT,"T",84,"VK_T",e,e],[0,i.KeyU,"KeyU",n.KeyU,"U",85,"VK_U",e,e],[0,i.KeyV,"KeyV",n.KeyV,"V",86,"VK_V",e,e],[0,i.KeyW,"KeyW",n.KeyW,"W",87,"VK_W",e,e],[0,i.KeyX,"KeyX",n.KeyX,"X",88,"VK_X",e,e],[0,i.KeyY,"KeyY",n.KeyY,"Y",89,"VK_Y",e,e],[0,i.KeyZ,"KeyZ",n.KeyZ,"Z",90,"VK_Z",e,e],[0,i.Digit1,"Digit1",n.Digit1,"1",49,"VK_1",e,e],[0,i.Digit2,"Digit2",n.Digit2,"2",50,"VK_2",e,e],[0,i.Digit3,"Digit3",n.Digit3,"3",51,"VK_3",e,e],[0,i.Digit4,"Digit4",n.Digit4,"4",52,"VK_4",e,e],[0,i.Digit5,"Digit5",n.Digit5,"5",53,"VK_5",e,e],[0,i.Digit6,"Digit6",n.Digit6,"6",54,"VK_6",e,e],[0,i.Digit7,"Digit7",n.Digit7,"7",55,"VK_7",e,e],[0,i.Digit8,"Digit8",n.Digit8,"8",56,"VK_8",e,e],[0,i.Digit9,"Digit9",n.Digit9,"9",57,"VK_9",e,e],[0,i.Digit0,"Digit0",n.Digit0,"0",48,"VK_0",e,e],[1,i.Enter,"Enter",n.Enter,"Enter",13,"VK_RETURN",e,e],[1,i.Escape,"Escape",n.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,i.Backspace,"Backspace",n.Backspace,"Backspace",8,"VK_BACK",e,e],[1,i.Tab,"Tab",n.Tab,"Tab",9,"VK_TAB",e,e],[1,i.Space,"Space",n.Space,"Space",32,"VK_SPACE",e,e],[0,i.Minus,"Minus",n.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,i.Equal,"Equal",n.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,i.BracketLeft,"BracketLeft",n.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,i.BracketRight,"BracketRight",n.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,i.Backslash,"Backslash",n.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,i.IntlHash,"IntlHash",n.Unknown,e,0,e,e,e],[0,i.Semicolon,"Semicolon",n.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,i.Quote,"Quote",n.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,i.Backquote,"Backquote",n.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,i.Comma,"Comma",n.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,i.Period,"Period",n.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,i.Slash,"Slash",n.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,i.CapsLock,"CapsLock",n.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,i.F1,"F1",n.F1,"F1",112,"VK_F1",e,e],[1,i.F2,"F2",n.F2,"F2",113,"VK_F2",e,e],[1,i.F3,"F3",n.F3,"F3",114,"VK_F3",e,e],[1,i.F4,"F4",n.F4,"F4",115,"VK_F4",e,e],[1,i.F5,"F5",n.F5,"F5",116,"VK_F5",e,e],[1,i.F6,"F6",n.F6,"F6",117,"VK_F6",e,e],[1,i.F7,"F7",n.F7,"F7",118,"VK_F7",e,e],[1,i.F8,"F8",n.F8,"F8",119,"VK_F8",e,e],[1,i.F9,"F9",n.F9,"F9",120,"VK_F9",e,e],[1,i.F10,"F10",n.F10,"F10",121,"VK_F10",e,e],[1,i.F11,"F11",n.F11,"F11",122,"VK_F11",e,e],[1,i.F12,"F12",n.F12,"F12",123,"VK_F12",e,e],[1,i.PrintScreen,"PrintScreen",n.Unknown,e,0,e,e,e],[1,i.ScrollLock,"ScrollLock",n.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,i.Pause,"Pause",n.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,i.Insert,"Insert",n.Insert,"Insert",45,"VK_INSERT",e,e],[1,i.Home,"Home",n.Home,"Home",36,"VK_HOME",e,e],[1,i.PageUp,"PageUp",n.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,i.Delete,"Delete",n.Delete,"Delete",46,"VK_DELETE",e,e],[1,i.End,"End",n.End,"End",35,"VK_END",e,e],[1,i.PageDown,"PageDown",n.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,i.ArrowRight,"ArrowRight",n.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,i.ArrowLeft,"ArrowLeft",n.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,i.ArrowDown,"ArrowDown",n.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,i.ArrowUp,"ArrowUp",n.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,i.NumLock,"NumLock",n.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,i.NumpadDivide,"NumpadDivide",n.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,i.NumpadMultiply,"NumpadMultiply",n.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,i.NumpadSubtract,"NumpadSubtract",n.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,i.NumpadAdd,"NumpadAdd",n.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,i.NumpadEnter,"NumpadEnter",n.Enter,e,0,e,e,e],[1,i.Numpad1,"Numpad1",n.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,i.Numpad2,"Numpad2",n.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,i.Numpad3,"Numpad3",n.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,i.Numpad4,"Numpad4",n.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,i.Numpad5,"Numpad5",n.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,i.Numpad6,"Numpad6",n.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,i.Numpad7,"Numpad7",n.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,i.Numpad8,"Numpad8",n.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,i.Numpad9,"Numpad9",n.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,i.Numpad0,"Numpad0",n.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,i.NumpadDecimal,"NumpadDecimal",n.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,i.IntlBackslash,"IntlBackslash",n.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,i.ContextMenu,"ContextMenu",n.ContextMenu,"ContextMenu",93,e,e,e],[1,i.Power,"Power",n.Unknown,e,0,e,e,e],[1,i.NumpadEqual,"NumpadEqual",n.Unknown,e,0,e,e,e],[1,i.F13,"F13",n.F13,"F13",124,"VK_F13",e,e],[1,i.F14,"F14",n.F14,"F14",125,"VK_F14",e,e],[1,i.F15,"F15",n.F15,"F15",126,"VK_F15",e,e],[1,i.F16,"F16",n.F16,"F16",127,"VK_F16",e,e],[1,i.F17,"F17",n.F17,"F17",128,"VK_F17",e,e],[1,i.F18,"F18",n.F18,"F18",129,"VK_F18",e,e],[1,i.F19,"F19",n.F19,"F19",130,"VK_F19",e,e],[1,i.F20,"F20",n.F20,"F20",131,"VK_F20",e,e],[1,i.F21,"F21",n.F21,"F21",132,"VK_F21",e,e],[1,i.F22,"F22",n.F22,"F22",133,"VK_F22",e,e],[1,i.F23,"F23",n.F23,"F23",134,"VK_F23",e,e],[1,i.F24,"F24",n.F24,"F24",135,"VK_F24",e,e],[1,i.Open,"Open",n.Unknown,e,0,e,e,e],[1,i.Help,"Help",n.Unknown,e,0,e,e,e],[1,i.Select,"Select",n.Unknown,e,0,e,e,e],[1,i.Again,"Again",n.Unknown,e,0,e,e,e],[1,i.Undo,"Undo",n.Unknown,e,0,e,e,e],[1,i.Cut,"Cut",n.Unknown,e,0,e,e,e],[1,i.Copy,"Copy",n.Unknown,e,0,e,e,e],[1,i.Paste,"Paste",n.Unknown,e,0,e,e,e],[1,i.Find,"Find",n.Unknown,e,0,e,e,e],[1,i.AudioVolumeMute,"AudioVolumeMute",n.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,i.AudioVolumeUp,"AudioVolumeUp",n.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,i.AudioVolumeDown,"AudioVolumeDown",n.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,i.NumpadComma,"NumpadComma",n.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,i.IntlRo,"IntlRo",n.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,i.KanaMode,"KanaMode",n.Unknown,e,0,e,e,e],[0,i.IntlYen,"IntlYen",n.Unknown,e,0,e,e,e],[1,i.Convert,"Convert",n.Unknown,e,0,e,e,e],[1,i.NonConvert,"NonConvert",n.Unknown,e,0,e,e,e],[1,i.Lang1,"Lang1",n.Unknown,e,0,e,e,e],[1,i.Lang2,"Lang2",n.Unknown,e,0,e,e,e],[1,i.Lang3,"Lang3",n.Unknown,e,0,e,e,e],[1,i.Lang4,"Lang4",n.Unknown,e,0,e,e,e],[1,i.Lang5,"Lang5",n.Unknown,e,0,e,e,e],[1,i.Abort,"Abort",n.Unknown,e,0,e,e,e],[1,i.Props,"Props",n.Unknown,e,0,e,e,e],[1,i.NumpadParenLeft,"NumpadParenLeft",n.Unknown,e,0,e,e,e],[1,i.NumpadParenRight,"NumpadParenRight",n.Unknown,e,0,e,e,e],[1,i.NumpadBackspace,"NumpadBackspace",n.Unknown,e,0,e,e,e],[1,i.NumpadMemoryStore,"NumpadMemoryStore",n.Unknown,e,0,e,e,e],[1,i.NumpadMemoryRecall,"NumpadMemoryRecall",n.Unknown,e,0,e,e,e],[1,i.NumpadMemoryClear,"NumpadMemoryClear",n.Unknown,e,0,e,e,e],[1,i.NumpadMemoryAdd,"NumpadMemoryAdd",n.Unknown,e,0,e,e,e],[1,i.NumpadMemorySubtract,"NumpadMemorySubtract",n.Unknown,e,0,e,e,e],[1,i.NumpadClear,"NumpadClear",n.Clear,"Clear",12,"VK_CLEAR",e,e],[1,i.NumpadClearEntry,"NumpadClearEntry",n.Unknown,e,0,e,e,e],[1,i.None,e,n.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,i.None,e,n.Shift,"Shift",16,"VK_SHIFT",e,e],[1,i.None,e,n.Alt,"Alt",18,"VK_MENU",e,e],[1,i.None,e,n.Meta,"Meta",91,"VK_COMMAND",e,e],[1,i.ControlLeft,"ControlLeft",n.Ctrl,e,0,"VK_LCONTROL",e,e],[1,i.ShiftLeft,"ShiftLeft",n.Shift,e,0,"VK_LSHIFT",e,e],[1,i.AltLeft,"AltLeft",n.Alt,e,0,"VK_LMENU",e,e],[1,i.MetaLeft,"MetaLeft",n.Meta,e,0,"VK_LWIN",e,e],[1,i.ControlRight,"ControlRight",n.Ctrl,e,0,"VK_RCONTROL",e,e],[1,i.ShiftRight,"ShiftRight",n.Shift,e,0,"VK_RSHIFT",e,e],[1,i.AltRight,"AltRight",n.Alt,e,0,"VK_RMENU",e,e],[1,i.MetaRight,"MetaRight",n.Meta,e,0,"VK_RWIN",e,e],[1,i.BrightnessUp,"BrightnessUp",n.Unknown,e,0,e,e,e],[1,i.BrightnessDown,"BrightnessDown",n.Unknown,e,0,e,e,e],[1,i.MediaPlay,"MediaPlay",n.Unknown,e,0,e,e,e],[1,i.MediaRecord,"MediaRecord",n.Unknown,e,0,e,e,e],[1,i.MediaFastForward,"MediaFastForward",n.Unknown,e,0,e,e,e],[1,i.MediaRewind,"MediaRewind",n.Unknown,e,0,e,e,e],[1,i.MediaTrackNext,"MediaTrackNext",n.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,i.MediaTrackPrevious,"MediaTrackPrevious",n.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,i.MediaStop,"MediaStop",n.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,i.Eject,"Eject",n.Unknown,e,0,e,e,e],[1,i.MediaPlayPause,"MediaPlayPause",n.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,i.MediaSelect,"MediaSelect",n.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,i.LaunchMail,"LaunchMail",n.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,i.LaunchApp2,"LaunchApp2",n.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,i.LaunchApp1,"LaunchApp1",n.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,i.SelectTask,"SelectTask",n.Unknown,e,0,e,e,e],[1,i.LaunchScreenSaver,"LaunchScreenSaver",n.Unknown,e,0,e,e,e],[1,i.BrowserSearch,"BrowserSearch",n.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,i.BrowserHome,"BrowserHome",n.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,i.BrowserBack,"BrowserBack",n.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,i.BrowserForward,"BrowserForward",n.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,i.BrowserStop,"BrowserStop",n.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,i.BrowserRefresh,"BrowserRefresh",n.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,i.BrowserFavorites,"BrowserFavorites",n.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,i.ZoomToggle,"ZoomToggle",n.Unknown,e,0,e,e,e],[1,i.MailReply,"MailReply",n.Unknown,e,0,e,e,e],[1,i.MailForward,"MailForward",n.Unknown,e,0,e,e,e],[1,i.MailSend,"MailSend",n.Unknown,e,0,e,e,e],[1,i.None,e,n.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,i.None,e,n.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,i.None,e,n.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,i.None,e,n.Unknown,e,0,"VK_KANA",e,e],[1,i.None,e,n.Unknown,e,0,"VK_HANGUL",e,e],[1,i.None,e,n.Unknown,e,0,"VK_JUNJA",e,e],[1,i.None,e,n.Unknown,e,0,"VK_FINAL",e,e],[1,i.None,e,n.Unknown,e,0,"VK_HANJA",e,e],[1,i.None,e,n.Unknown,e,0,"VK_KANJI",e,e],[1,i.None,e,n.Unknown,e,0,"VK_CONVERT",e,e],[1,i.None,e,n.Unknown,e,0,"VK_NONCONVERT",e,e],[1,i.None,e,n.Unknown,e,0,"VK_ACCEPT",e,e],[1,i.None,e,n.Unknown,e,0,"VK_MODECHANGE",e,e],[1,i.None,e,n.Unknown,e,0,"VK_SELECT",e,e],[1,i.None,e,n.Unknown,e,0,"VK_PRINT",e,e],[1,i.None,e,n.Unknown,e,0,"VK_EXECUTE",e,e],[1,i.None,e,n.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,i.None,e,n.Unknown,e,0,"VK_HELP",e,e],[1,i.None,e,n.Unknown,e,0,"VK_APPS",e,e],[1,i.None,e,n.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,i.None,e,n.Unknown,e,0,"VK_PACKET",e,e],[1,i.None,e,n.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,i.None,e,n.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,i.None,e,n.Unknown,e,0,"VK_ATTN",e,e],[1,i.None,e,n.Unknown,e,0,"VK_CRSEL",e,e],[1,i.None,e,n.Unknown,e,0,"VK_EXSEL",e,e],[1,i.None,e,n.Unknown,e,0,"VK_EREOF",e,e],[1,i.None,e,n.Unknown,e,0,"VK_PLAY",e,e],[1,i.None,e,n.Unknown,e,0,"VK_ZOOM",e,e],[1,i.None,e,n.Unknown,e,0,"VK_NONAME",e,e],[1,i.None,e,n.Unknown,e,0,"VK_PA1",e,e],[1,i.None,e,n.Unknown,e,0,"VK_OEM_CLEAR",e,e]],g=[],L=[];for(const N of l){const[E,_,w,a,s,f,v,k,R]=N;if(L[_]||(L[_]=!0,o[_]=w,u[w]=_,h[w.toLowerCase()]=_,E&&(t.$5r[_]=a,a!==n.Unknown&&a!==n.Enter&&a!==n.Ctrl&&a!==n.Shift&&a!==n.Alt&&a!==n.Meta&&(t.$6r[a]=_))),!g[a]){if(g[a]=!0,!s)throw new Error(`String representation missing for key code ${a} around scan code ${w}`);m.define(a,s),A.define(a,k||s),d.define(a,R||k||s)}f&&(t.$2r[f]=a),v&&(t.$3r[v]=a)}t.$6r[n.Enter]=i.Enter})();var $;(function(e){function l(w){return m.keyCodeToStr(w)}e.toString=l;function g(w){return m.strToKeyCode(w)}e.fromString=g;function L(w){return A.keyCodeToStr(w)}e.toUserSettingsUS=L;function N(w){return d.keyCodeToStr(w)}e.toUserSettingsGeneral=N;function E(w){return A.strToKeyCode(w)||d.strToKeyCode(w)}e.fromUserSettings=E;function _(w){if(w>=n.Numpad0&&w<=n.NumpadDivide)return null;switch(w){case n.UpArrow:return"Up";case n.DownArrow:return"Down";case n.LeftArrow:return"Left";case n.RightArrow:return"Right"}return m.keyCodeToStr(w)}e.toElectronAccelerator=_})($||(t.KeyCodeUtils=$={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b||(t.KeyMod=b={}));function c(e,l){const g=(l&65535)<<16>>>0;return(e|g)>>>0}}),ie(re[27],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Y=void 0;class n{constructor(p){this.d=p,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(p){this.c=p}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$Y=n}),ie(re[28],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(m){this.element=m,this.next=n.Undefined,this.prev=n.Undefined}}class i{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let m=this.a;for(;m!==n.Undefined;){const A=m.next;m.prev=n.Undefined,m.next=n.Undefined,m=A}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(m){return this.d(m,!1)}push(m){return this.d(m,!0)}d(m,A){const d=new n(m);if(this.a===n.Undefined)this.a=d,this.b=d;else if(A){const u=this.b;this.b=d,d.prev=u,u.next=d}else{const u=this.a;this.a=d,d.next=u,u.prev=d}this.c+=1;let o=!1;return()=>{o||(o=!0,this.e(d))}}shift(){if(this.a!==n.Undefined){const m=this.a.element;return this.e(this.a),m}}pop(){if(this.b!==n.Undefined){const m=this.b.element;return this.e(this.b),m}}e(m){if(m.prev!==n.Undefined&&m.next!==n.Undefined){const A=m.prev;A.next=m.next,m.next.prev=A}else m.prev===n.Undefined&&m.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):m.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):m.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let m=this.a;for(;m!==n.Undefined;)yield m.element,m=m.next}}t.$0c=i}),ie(re[19],ue([0,1]),function(W,t){"use strict";var n,i,p;Object.defineProperty(t,"__esModule",{value:!0}),t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=t.Touch=t.$Gc=t.$Fc=void 0,t.$Cc=m,t.$Dc=A,t.$Ec=d,t.$Nc=_;function m(w,a,s){let f=w.get(a);return f===void 0&&(f=s,w.set(a,f)),f}function A(w){const a=[];return w.forEach((s,f)=>{a.push(`${f} => ${s}`)}),`Map(${w.size}) {${a.join(", ")}}`}function d(w){const a=[];return w.forEach(s=>{a.push(s)}),`Set(${w.size}) {${a.join(", ")}}`}class o{constructor(a,s){this.uri=a,this.value=s}}function u(w){return Array.isArray(w)}class h{static{this.c=a=>a.toString()}constructor(a,s){if(this[n]="ResourceMap",a instanceof h)this.d=new Map(a.d),this.e=s??h.c;else if(u(a)){this.d=new Map,this.e=s??h.c;for(const[f,v]of a)this.set(f,v)}else this.d=new Map,this.e=a??h.c}set(a,s){return this.d.set(this.e(a),new o(a,s)),this}get(a){return this.d.get(this.e(a))?.value}has(a){return this.d.has(this.e(a))}get size(){return this.d.size}clear(){this.d.clear()}delete(a){return this.d.delete(this.e(a))}forEach(a,s){typeof s<"u"&&(a=a.bind(s));for(const[f,v]of this.d)a(v.value,v.uri,this)}*values(){for(const a of this.d.values())yield a.value}*keys(){for(const a of this.d.values())yield a.uri}*entries(){for(const a of this.d.values())yield[a.uri,a.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.d)yield[a.uri,a.value]}}t.$Fc=h;class ${constructor(a,s){this[i]="ResourceSet",!a||typeof a=="function"?this.c=new h(a):(this.c=new h(s),a.forEach(this.add,this))}get size(){return this.c.size}add(a){return this.c.set(a,a),this}clear(){this.c.clear()}delete(a){return this.c.delete(a)}forEach(a,s){this.c.forEach((f,v)=>a.call(s,v,v,this))}has(a){return this.c.has(a)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Gc=$;var b;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(b||(t.Touch=b={}));class c{constructor(){this[p]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(a){return this.c.has(a)}get(a,s=b.None){const f=this.c.get(a);if(f)return s!==b.None&&this.m(f,s),f.value}set(a,s,f=b.None){let v=this.c.get(a);if(v)v.value=s,f!==b.None&&this.m(v,f);else{switch(v={key:a,value:s,next:void 0,previous:void 0},f){case b.None:this.k(v);break;case b.AsOld:this.j(v);break;case b.AsNew:this.k(v);break;default:this.k(v);break}this.c.set(a,v),this.f++}return this}delete(a){return!!this.remove(a)}remove(a){const s=this.c.get(a);if(s)return this.c.delete(a),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const a=this.d;return this.c.delete(a.key),this.l(a),this.f--,a.value}forEach(a,s){const f=this.g;let v=this.d;for(;v;){if(s?a.bind(s)(v.value,v.key,this):a(v.value,v.key,this),this.g!==f)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const a=this,s=this.g;let f=this.d;const v={[Symbol.iterator](){return v},next(){if(a.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const k={value:f.key,done:!1};return f=f.next,k}else return{value:void 0,done:!0}}};return v}values(){const a=this,s=this.g;let f=this.d;const v={[Symbol.iterator](){return v},next(){if(a.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const k={value:f.value,done:!1};return f=f.next,k}else return{value:void 0,done:!0}}};return v}entries(){const a=this,s=this.g;let f=this.d;const v={[Symbol.iterator](){return v},next(){if(a.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const k={value:[f.key,f.value],done:!1};return f=f.next,k}else return{value:void 0,done:!0}}};return v}[(p=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(a){if(a>=this.size)return;if(a===0){this.clear();return}let s=this.d,f=this.size;for(;s&&f>a;)this.c.delete(s.key),s=s.next,f--;this.d=s,this.f=f,s&&(s.previous=void 0),this.g++}i(a){if(a>=this.size)return;if(a===0){this.clear();return}let s=this.e,f=this.size;for(;s&&f>a;)this.c.delete(s.key),s=s.previous,f--;this.e=s,this.f=f,s&&(s.next=void 0),this.g++}j(a){if(!this.d&&!this.e)this.e=a;else if(this.d)a.next=this.d,this.d.previous=a;else throw new Error("Invalid list");this.d=a,this.g++}k(a){if(!this.d&&!this.e)this.d=a;else if(this.e)a.previous=this.e,this.e.next=a;else throw new Error("Invalid list");this.e=a,this.g++}l(a){if(a===this.d&&a===this.e)this.d=void 0,this.e=void 0;else if(a===this.d){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.d=a.next}else if(a===this.e){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.e=a.previous}else{const s=a.next,f=a.previous;if(!s||!f)throw new Error("Invalid list");s.previous=f,f.next=s}a.next=void 0,a.previous=void 0,this.g++}m(a,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==b.AsOld&&s!==b.AsNew)){if(s===b.AsOld){if(a===this.d)return;const f=a.next,v=a.previous;a===this.e?(v.next=void 0,this.e=v):(f.previous=v,v.next=f),a.previous=void 0,a.next=this.d,this.d.previous=a,this.d=a,this.g++}else if(s===b.AsNew){if(a===this.e)return;const f=a.next,v=a.previous;a===this.d?(f.previous=void 0,this.d=f):(f.previous=v,v.next=f),a.next=void 0,a.previous=this.e,this.e.next=a,this.e=a,this.g++}}}toJSON(){const a=[];return this.forEach((s,f)=>{a.push([f,s])}),a}fromJSON(a){this.clear();for(const[s,f]of a)this.set(s,f)}}t.$Hc=c;class e extends c{constructor(a,s=1){super(),this.n=a,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(a){this.n=a,this.p()}get ratio(){return this.o}set ratio(a){this.o=Math.min(Math.max(0,a),1),this.p()}get(a,s=b.AsNew){return super.get(a,s)}peek(a){return super.get(a,b.None)}set(a,s){return super.set(a,s,b.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class l extends e{constructor(a,s=1){super(a,s)}q(a){this.h(a)}set(a,s){return super.set(a,s),this.p(),this}}t.$Ic=l;class g extends e{constructor(a,s=1){super(a,s)}q(a){this.i(a)}set(a,s){return this.n<=this.size&&!this.has(a)&&this.q(Math.round(this.n*this.o)-1),super.set(a,s),this}}t.$Jc=g;class L{constructor(){this.c=new Map}add(a){return this.c.set(a,(this.c.get(a)||0)+1),this}delete(a){let s=this.c.get(a)||0;return s===0?!1:(s--,s===0?this.c.delete(a):this.c.set(a,s),!0)}has(a){return this.c.has(a)}}t.$Kc=L;class N{constructor(a){if(this.c=new Map,this.d=new Map,a)for(const[s,f]of a)this.set(s,f)}clear(){this.c.clear(),this.d.clear()}set(a,s){this.c.set(a,s),this.d.set(s,a)}get(a){return this.c.get(a)}getKey(a){return this.d.get(a)}delete(a){const s=this.c.get(a);return s===void 0?!1:(this.c.delete(a),this.d.delete(s),!0)}forEach(a,s){this.c.forEach((f,v)=>{a.call(s,f,v,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Lc=N;class E{constructor(){this.c=new Map}add(a,s){let f=this.c.get(a);f||(f=new Set,this.c.set(a,f)),f.add(s)}delete(a,s){const f=this.c.get(a);f&&(f.delete(s),f.size===0&&this.c.delete(a))}forEach(a,s){const f=this.c.get(a);f&&f.forEach(s)}get(a){const s=this.c.get(a);return s||new Set}}t.$Mc=E;function _(w,a){if(w===a)return!0;if(w.size!==a.size)return!1;for(const[s,f]of w)if(!a.has(s)||a.get(s)!==f)return!1;for(const[s]of a)if(!w.has(s))return!1;return!0}}),ie(re[10],ue([0,1,9,42,19,25,26]),function(W,t,n,i,p,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9c=t.$7c=t.$6c=t.$5c=t.$4c=t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Oc=void 0,t.$Pc=h,t.$Qc=$,t.$Rc=b,t.$Sc=l,t.$Tc=g,t.$Uc=L,t.$Vc=N,t.$Wc=E,t.$Xc=_,t.$8c=M;const d=!1;let o=null;class u{constructor(){this.b=new Map}static{this.a=0}c(y){let B=this.b.get(y);return B||(B={parent:null,source:null,isSingleton:!1,value:y,idx:u.a++},this.b.set(y,B)),B}trackDisposable(y){const B=this.c(y);B.source||(B.source=new Error().stack)}setParent(y,B){const z=this.c(y);z.parent=B}markAsDisposed(y){this.b.delete(y)}markAsSingleton(y){this.c(y).isSingleton=!0}f(y,B){const z=B.get(y);if(z)return z;const H=y.parent?this.f(this.c(y.parent),B):y;return B.set(y,H),H}getTrackedDisposables(){const y=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,y).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(y=10,B){let z;if(B)z=B;else{const J=new Map,K=[...this.b.values()].filter(P=>P.source!==null&&!this.f(P,J).isSingleton);if(K.length===0)return;const ne=new Set(K.map(P=>P.value));if(z=K.filter(P=>!(P.parent&&ne.has(P.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function H(J){function K(P,X){for(;P.length>0&&X.some(he=>typeof he=="string"?he===P[0]:P[0].match(he));)P.shift()}const ne=J.source.split(`
`).map(P=>P.trim().replace("at ","")).filter(P=>P!=="");return K(ne,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ne.reverse()}const U=new p.$Mc;for(const J of z){const K=H(J);for(let ne=0;ne<=K.length;ne++)U.add(K.slice(0,ne).join(`
`),J)}z.sort((0,n.$0b)(J=>J.idx,n.$_b));let C="",ee=0;for(const J of z.slice(0,y)){ee++;const K=H(J),ne=[];for(let P=0;P<K.length;P++){let X=K[P];X=`(shared with ${U.get(K.slice(0,P+1).join(`
`)).size}/${z.length} leaks) at ${X}`;const ge=U.get(K.slice(0,P).join(`
`)),Le=(0,i.$e)([...ge].map(r=>H(r)[P]),r=>r);delete Le[K[P]];for(const[r,Me]of Object.entries(Le))ne.unshift(`    - stacktraces of ${Me.length} other leaks continue with ${r}`);ne.unshift(X)}C+=`


==================== Leaking disposable ${ee}/${z.length}: ${J.value.constructor.name} ====================
${ne.join(`
`)}
============================================================

`}return z.length>y&&(C+=`


... and ${z.length-y} more leaking disposables

`),{leaks:z,details:C}}}t.$Oc=u;function h(F){o=F}if(d){const F="__is_disposable_tracked__";h(new class{trackDisposable(y){const B=new Error("Potentially leaked disposable").stack;setTimeout(()=>{y[F]||console.log(B)},3e3)}setParent(y,B){if(y&&y!==a.None)try{y[F]=!0}catch{}}markAsDisposed(y){if(y&&y!==a.None)try{y[F]=!0}catch{}}markAsSingleton(y){}})}function $(F){return o?.trackDisposable(F),F}function b(F){o?.markAsDisposed(F)}function c(F,y){o?.setParent(F,y)}function e(F,y){if(o)for(const B of F)o.setParent(B,y)}function l(F){return o?.markAsSingleton(F),F}function g(F){return typeof F=="object"&&F!==null&&typeof F.dispose=="function"&&F.dispose.length===0}function L(F){if(A.Iterable.is(F)){const y=[];for(const B of F)if(B)try{B.dispose()}catch(z){y.push(z)}if(y.length===1)throw y[0];if(y.length>1)throw new AggregateError(y,"Encountered errors while disposing of store");return Array.isArray(F)?[]:F}else if(F)return F.dispose(),F}function N(F){for(const y of F)g(y)&&y.dispose();return[]}function E(...F){const y=_(()=>L(F));return e(F,y),y}function _(F){const y=$({dispose:(0,m.$hb)(()=>{b(y),F()})});return y}class w{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,$(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{L(this.f)}finally{this.f.clear()}}add(y){if(!y)return y;if(y===this)throw new Error("Cannot register a disposable on itself!");return c(y,this),this.g?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(y),y}delete(y){if(y){if(y===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(y),y.dispose()}}deleteAndLeak(y){y&&this.f.has(y)&&(this.f.delete(y),c(y,null))}}t.$Yc=w;class a{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new w,$(this),c(this.q,this)}dispose(){b(this),this.q.dispose()}B(y){if(y===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(y)}}t.$Zc=a;class s{constructor(){this.b=!1,$(this)}get value(){return this.b?void 0:this.a}set value(y){this.b||y===this.a||(this.a?.dispose(),y&&c(y,this),this.a=y)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const y=this.a;return this.a=void 0,y&&c(y,null),y}}t.$1c=s;class f{constructor(y){this.a=new s,this.b=!1,this.a.value=y}get value(){return this.a.value}set value(y){this.b||y===this.a.value||(this.a.value=y)}dispose(){this.b=!0,this.a.dispose()}}t.$2c=f;class v{constructor(y){this.b=y,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$3c=v;class k{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,$(this)}set(y){let B=y;return this.unset=()=>B=void 0,this.isset=()=>B!==void 0,this.dispose=()=>{B&&(B(),B=void 0,b(this))},this}}t.$4c=k;class R{constructor(){this.a=new Map}acquire(y,...B){let z=this.a.get(y);z||(z={counter:0,object:this.b(y,...B)},this.a.set(y,z));const{object:H}=z,U=(0,m.$hb)(()=>{--z.counter===0&&(this.c(y,z.object),this.a.delete(y))});return z.counter++,{object:H,dispose:U}}}t.$5c=R;class T{constructor(y){this.a=y}async acquire(y,...B){const z=this.a.acquire(y,...B);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(H){throw z.dispose(),H}}}t.$6c=T;class j{constructor(y){this.object=y}dispose(){}}t.$7c=j;function M(F){const y=new w;try{F(y)}finally{y.dispose()}}class D{constructor(){this.a=new Map,this.b=!1,$(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{L(this.a.values())}finally{this.a.clear()}}has(y){return this.a.has(y)}get size(){return this.a.size}get(y){return this.a.get(y)}set(y,B,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(y)?.dispose(),this.a.set(y,B)}deleteAndDispose(y){this.a.get(y)?.dispose(),this.a.delete(y)}deleteAndLeak(y){const B=this.a.get(y);return this.a.delete(y),B}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$9c=D}),ie(re[46],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarshalledId=void 0;var n;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadInstance=8]="CommentThreadInstance",i[i.CommentThreadReply=9]="CommentThreadReply",i[i.CommentNode=10]="CommentNode",i[i.CommentThreadNode=11]="CommentThreadNode",i[i.TimelineActionContext=12]="TimelineActionContext",i[i.NotebookCellActionContext=13]="NotebookCellActionContext",i[i.NotebookActionContext=14]="NotebookActionContext",i[i.TerminalContext=15]="TerminalContext",i[i.TestItemContext=16]="TestItemContext",i[i.Date=17]="Date",i[i.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(n||(t.MarshalledId=n={}))}),ie(re[29],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ke=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class i{static create(m){return new i(m)}constructor(m){this.c=n&&m===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$ke=i}),ie(re[12],ue([0,1,4,25,10,28,29]),function(W,t,n,i,p,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ae=t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$me=t.Event=void 0,t.$ne=c;const d=!1,o=!1,u=!1;var h;(function(H){H.None=()=>p.$Zc.None;function U(oe){if(u){const{onDidAddListener:se}=oe,ce=l.create();let le=0;oe.onDidAddListener=()=>{++le===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ce.print()),se?.()}}}function C(oe,se){return Me(oe,()=>{},0,void 0,!0,void 0,se)}H.defer=C;function ee(oe){return(se,ce=null,le)=>{let me=!1,de;return de=oe(ve=>{if(!me)return de?de.dispose():me=!0,se.call(ce,ve)},null,le),me&&de.dispose(),de}}H.once=ee;function J(oe,se){return H.once(H.filter(oe,se))}H.onceIf=J;function K(oe,se,ce){return Le((le,me=null,de)=>oe(ve=>le.call(me,se(ve)),null,de),ce)}H.map=K;function ne(oe,se,ce){return Le((le,me=null,de)=>oe(ve=>{se(ve),le.call(me,ve)},null,de),ce)}H.forEach=ne;function P(oe,se,ce){return Le((le,me=null,de)=>oe(ve=>se(ve)&&le.call(me,ve),null,de),ce)}H.filter=P;function X(oe){return oe}H.signal=X;function he(...oe){return(se,ce=null,le)=>{const me=(0,p.$Wc)(...oe.map(de=>de(ve=>se.call(ce,ve))));return r(me,le)}}H.any=he;function ge(oe,se,ce,le){let me=ce;return K(oe,de=>(me=se(me,de),me),le)}H.reduce=ge;function Le(oe,se){let ce;const le={onWillAddFirstListener(){ce=oe(me.fire,me)},onDidRemoveLastListener(){ce?.dispose()}};se||U(le);const me=new s(le);return se?.add(me),me.event}function r(oe,se){return se instanceof Array?se.push(oe):se&&se.add(oe),oe}function Me(oe,se,ce=100,le=!1,me=!1,de,ve){let pe,Te,be,ye=0,We;const ze={leakWarningThreshold:de,onWillAddFirstListener(){pe=oe(Ze=>{ye++,Te=se(Te,Ze),le&&!be&&(He.fire(Te),Te=void 0),We=()=>{const Ve=Te;Te=void 0,be=void 0,(!le||ye>1)&&He.fire(Ve),ye=0},typeof ce=="number"?(clearTimeout(be),be=setTimeout(We,ce)):be===void 0&&(be=0,queueMicrotask(We))})},onWillRemoveListener(){me&&ye>0&&We?.()},onDidRemoveLastListener(){We=void 0,pe.dispose()}};ve||U(ze);const He=new s(ze);return ve?.add(He),He.event}H.debounce=Me;function Fe(oe,se=0,ce){return H.debounce(oe,(le,me)=>le?(le.push(me),le):[me],se,void 0,!0,void 0,ce)}H.accumulate=Fe;function Ue(oe,se=(le,me)=>le===me,ce){let le=!0,me;return P(oe,de=>{const ve=le||!se(de,me);return le=!1,me=de,ve},ce)}H.latch=Ue;function Ae(oe,se,ce){return[H.filter(oe,se,ce),H.filter(oe,le=>!se(le),ce)]}H.split=Ae;function Ne(oe,se=!1,ce=[],le){let me=ce.slice(),de=oe(Te=>{me?me.push(Te):pe.fire(Te)});le&&le.add(de);const ve=()=>{me?.forEach(Te=>pe.fire(Te)),me=null},pe=new s({onWillAddFirstListener(){de||(de=oe(Te=>pe.fire(Te)),le&&le.add(de))},onDidAddFirstListener(){me&&(se?setTimeout(ve):ve())},onDidRemoveLastListener(){de&&de.dispose(),de=null}});return le&&le.add(pe),pe.event}H.buffer=Ne;function qe(oe,se){return(le,me,de)=>{const ve=se(new G);return oe(function(pe){const Te=ve.evaluate(pe);Te!==x&&le.call(me,Te)},void 0,de)}}H.chain=qe;const x=Symbol("HaltChainable");class G{constructor(){this.f=[]}map(se){return this.f.push(se),this}forEach(se){return this.f.push(ce=>(se(ce),ce)),this}filter(se){return this.f.push(ce=>se(ce)?ce:x),this}reduce(se,ce){let le=ce;return this.f.push(me=>(le=se(le,me),le)),this}latch(se=(ce,le)=>ce===le){let ce=!0,le;return this.f.push(me=>{const de=ce||!se(me,le);return ce=!1,le=me,de?me:x}),this}evaluate(se){for(const ce of this.f)if(se=ce(se),se===x)break;return se}}function O(oe,se,ce=le=>le){const le=(...pe)=>ve.fire(ce(...pe)),me=()=>oe.on(se,le),de=()=>oe.removeListener(se,le),ve=new s({onWillAddFirstListener:me,onDidRemoveLastListener:de});return ve.event}H.fromNodeEventEmitter=O;function I(oe,se,ce=le=>le){const le=(...pe)=>ve.fire(ce(...pe)),me=()=>oe.addEventListener(se,le),de=()=>oe.removeEventListener(se,le),ve=new s({onWillAddFirstListener:me,onDidRemoveLastListener:de});return ve.event}H.fromDOMEventEmitter=I;function q(oe){return new Promise(se=>ee(oe)(se))}H.toPromise=q;function Z(oe){const se=new s;return oe.then(ce=>{se.fire(ce)},()=>{se.fire(void 0)}).finally(()=>{se.dispose()}),se.event}H.fromPromise=Z;function Q(oe,se){return oe(ce=>se.fire(ce))}H.forward=Q;function ae(oe,se,ce){return se(ce),oe(le=>se(le))}H.runAndSubscribe=ae;class we{constructor(se,ce){this._observable=se,this.f=0,this.g=!1;const le={onWillAddFirstListener:()=>{se.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{se.removeObserver(this)}};ce||U(le),this.emitter=new s(le),ce&&ce.add(this.emitter)}beginUpdate(se){this.f++}handlePossibleChange(se){}handleChange(se,ce){this.g=!0}endUpdate(se){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ee(oe,se){return new we(oe,se).emitter.event}H.fromObservable=Ee;function Re(oe){return(se,ce,le)=>{let me=0,de=!1;const ve={beginUpdate(){me++},endUpdate(){me--,me===0&&(oe.reportChanges(),de&&(de=!1,se.call(ce)))},handlePossibleChange(){},handleChange(){de=!0}};oe.addObserver(ve),oe.reportChanges();const pe={dispose(){oe.removeObserver(ve)}};return le instanceof p.$Yc?le.add(pe):Array.isArray(le)&&le.push(pe),pe}}H.fromObservableLight=Re})(h||(t.Event=h={}));class ${static{this.all=new Set}static{this.f=0}constructor(U){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${U}_${$.f++}`,$.all.add(this)}start(U){this.g=new A.$ke,this.listenerCount=U}stop(){if(this.g){const U=this.g.elapsed();this.durations.push(U),this.elapsedOverall+=U,this.invocationCount+=1,this.g=void 0}}}t.$me=$;let b=-1;function c(H){const U=b;return b=H,{dispose(){b=U}}}class e{static{this.f=1}constructor(U,C,ee=(e.f++).toString(16).padStart(3,"0")){this.j=U,this.threshold=C,this.name=ee,this.h=0}dispose(){this.g?.clear()}check(U,C){const ee=this.threshold;if(ee<=0||C<ee)return;this.g||(this.g=new Map);const J=this.g.get(U.value)||0;if(this.g.set(U.value,J+1),this.h-=1,this.h<=0){this.h=ee*.5;const[K,ne]=this.getMostFrequentStack(),P=`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${ne}):`;console.warn(P),console.warn(K);const X=new g(P,K);this.j(X)}return()=>{const K=this.g.get(U.value)||0;this.g.set(U.value,K-1)}}getMostFrequentStack(){if(!this.g)return;let U,C=0;for(const[ee,J]of this.g)(!U||C<J)&&(U=[ee,J],C=J);return U}}class l{static create(){const U=new Error;return new l(U.stack??"")}constructor(U){this.value=U}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g extends Error{constructor(U,C){super(U),this.name="ListenerLeakError",this.stack=C}}t.$oe=g;class L extends Error{constructor(U,C){super(U),this.name="ListenerRefusalError",this.stack=C}}t.$pe=L;let N=0;class E{constructor(U){this.value=U,this.id=N++}}const _=2,w=(H,U)=>{if(H instanceof E)U(H);else for(let C=0;C<H.length;C++){const ee=H[C];ee&&U(ee)}};let a;if(d){const H=[];setInterval(()=>{H.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(H.join(`
`)),H.length=0)},3e3),a=new FinalizationRegistry(U=>{typeof U=="string"&&H.push(U)})}class s{constructor(U){this.z=0,this.f=U,this.g=b>0||this.f?.leakWarningThreshold?new e(U?.onListenerError??n.$4,this.f?.leakWarningThreshold??b):void 0,this.j=this.f?._profName?new $(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(o){const U=this.u;queueMicrotask(()=>{w(U,C=>C.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(U,C,ee)=>{if(this.g&&this.z>this.g.threshold**2){const X=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(X);const he=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ge=new L(`${X}. HINT: Stack shows most frequent listener (${he[1]}-times)`,he[0]);return(this.f?.onListenerError||n.$4)(ge),p.$Zc.None}if(this.m)return p.$Zc.None;C&&(U=U.bind(C));const J=new E(U);let K,ne;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(J.stack=l.create(),K=this.g.check(J.stack,this.z+1)),o&&(J.stack=ne??l.create()),this.u?this.u instanceof E?(this.w??=new v,this.u=[this.u,J]):this.u.push(J):(this.f?.onWillAddFirstListener?.(this),this.u=J,this.f?.onDidAddFirstListener?.(this)),this.z++;const P=(0,p.$Xc)(()=>{a?.unregister(P),K?.(),this.A(J)});if(ee instanceof p.$Yc?ee.add(P):Array.isArray(ee)&&ee.push(P),a){const X=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),he=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(X);a.register(P,he?.[2]??X,P)}return P},this.q}A(U){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const C=this.u,ee=C.indexOf(U);if(ee===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,C[ee]=void 0;const J=this.w.current===this;if(this.z*_<=C.length){let K=0;for(let ne=0;ne<C.length;ne++)C[ne]?C[K++]=C[ne]:J&&(this.w.end--,K<this.w.i&&this.w.i--);C.length=K}}B(U,C){if(!U)return;const ee=this.f?.onListenerError||n.$4;if(!ee){U.value(C);return}try{U.value(C)}catch(J){ee(J)}}C(U){const C=U.current.u;for(;U.i<U.end;)this.B(C[U.i++],U.value);U.reset()}fire(U){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof E)this.B(this.u,U);else{const C=this.w;C.enqueue(this,U,this.u.length),this.C(C)}this.j?.stop()}hasListeners(){return this.z>0}}t.$qe=s;const f=()=>new v;t.$re=f;class v{constructor(){this.i=-1,this.end=0}enqueue(U,C,ee){this.i=0,this.end=ee,this.current=U,this.value=C}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class k extends s{async fireAsync(U,C,ee){if(this.u)for(this.h||(this.h=new m.$0c),w(this.u,J=>this.h.push([J.value,U]));this.h.size>0&&!C.isCancellationRequested;){const[J,K]=this.h.shift(),ne=[],P={...K,token:C,waitUntil:X=>{if(Object.isFrozen(ne))throw new Error("waitUntil can NOT be called asynchronous");ee&&(X=ee(X,J)),ne.push(X)}};try{J(P)}catch(X){(0,n.$4)(X);continue}Object.freeze(ne),await Promise.allSettled(ne).then(X=>{for(const he of X)he.status==="rejected"&&(0,n.$4)(he.reason)})}}}t.$se=k;class R extends s{get isPaused(){return this.h!==0}constructor(U){super(U),this.h=0,this.s=new m.$0c,this.t=U?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const U=Array.from(this.s);this.s.clear(),super.fire(this.t(U))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(U){this.z&&(this.h!==0?this.s.push(U):super.fire(U))}}t.$te=R;class T extends R{constructor(U){super(U),this.k=U.delay??100}fire(U){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(U)}}t.$ue=T;class j extends s{constructor(U){super(U),this.h=[],this.k=U?.merge}fire(U){this.hasListeners()&&(this.h.push(U),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(C=>super.fire(C)),this.h=[]}))}}t.$ve=j;class M{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(U){const C={event:U,listener:null};this.h.push(C),this.g&&this.m(C);const ee=()=>{this.g&&this.o(C);const J=this.h.indexOf(C);this.h.splice(J,1)};return(0,p.$Xc)((0,i.$hb)(ee))}j(){this.g=!0,this.h.forEach(U=>this.m(U))}k(){this.g=!1,this.h.forEach(U=>this.o(U))}m(U){U.listener=U.event(C=>this.f.fire(C))}o(U){U.listener?.dispose(),U.listener=null}dispose(){this.f.dispose();for(const U of this.h)U.listener?.dispose();this.h=[]}}t.$we=M;class D{constructor(U,C,ee,J){this.f=new p.$Yc;const K=this.f.add(new M),ne=this.f.add(new p.$9c);function P(X){ne.set(X,K.add(J(X)))}for(const X of U)P(X);this.f.add(C(X=>{P(X)})),this.f.add(ee(X=>{ne.deleteAndDispose(X)})),this.event=K.event}dispose(){this.f.dispose()}}t.$xe=D;class F{constructor(){this.f=[]}wrapEvent(U,C,ee){return(J,K,ne)=>U(P=>{const X=this.f[this.f.length-1];if(!C){X?X.buffers.push(()=>J.call(K,P)):J.call(K,P);return}const he=X;if(!he){J.call(K,C(ee,P));return}he.items??=[],he.items.push(P),he.buffers.length===0&&X.buffers.push(()=>{he.reducedResult??=ee?he.items.reduce(C,ee):he.items.reduce(C),J.call(K,he.reducedResult)})},void 0,ne)}bufferEvents(U){const C={buffers:new Array};this.f.push(C);const ee=U();return this.f.pop(),C.buffers.forEach(J=>J()),ee}}t.$ye=F;class y{constructor(){this.f=!1,this.g=h.None,this.h=p.$Zc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(U){this.g=U,this.f&&(this.h.dispose(),this.h=U(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$ze=y;class B{static const(U){return new z(U)}constructor(U){this.g=U,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(U){U!==this.g&&(this.g=U,this.f.fire(void 0))}}t.$Ae=B;class z{constructor(U){this.value=U,this.onDidChange=h.None}}}),ie(re[20],ue([0,1,12]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Be=t.CancellationToken=void 0,t.$Ce=d;const i=Object.freeze(function(o,u){const h=setTimeout(o.bind(u),0);return{dispose(){clearTimeout(h)}}});var p;(function(o){function u(h){return h===o.None||h===o.Cancelled||h instanceof m?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}o.isCancellationToken=u,o.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),o.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(p||(t.CancellationToken=p={}));class m{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?i:(this.b||(this.b=new n.$qe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(u){this.f=void 0,this.g=void 0,this.g=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new m),this.f}cancel(){this.f?this.f instanceof m&&this.f.cancel():this.f=p.Cancelled}dispose(u=!1){u&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof m&&this.f.dispose():this.f=p.None}}t.$Be=A;function d(o){const u=new A;return o.add({dispose(){u.cancel()}}),u.token}}),ie(re[47],ue([0,1,20]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ef=t.$df=t.$bf=void 0,t.$cf=p;class i{constructor(o){this.b=o,this.a=null}get(){if(this.a)return this.a;const o=new n.$Be,u=this.b(o.token);return this.a={promise:u,dispose:()=>{this.a=null,o.cancel(),o.dispose()}},this.a}}t.$bf=i;function p(d){return d}class m{constructor(o,u){this.a=void 0,this.b=void 0,typeof o=="function"?(this.c=o,this.d=p):(this.c=u,this.d=o.getCacheKey)}get(o){const u=this.d(o);return this.b!==u&&(this.b=u,this.a=this.c(o)),this.a}}t.$df=m;class A{get cachedValues(){return this.a}constructor(o,u){this.a=new Map,this.b=new Map,typeof o=="function"?(this.c=o,this.d=p):(this.c=u,this.d=o.getCacheKey)}get(o){const u=this.d(o);if(this.b.has(u))return this.b.get(u);const h=this.c(o);return this.a.set(o,h),this.b.set(u,h),h}}t.$ef=A}),ie(re[48],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$le=void 0,t.$le=Symbol("MicrotaskDelay")}),ie(re[21],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jg=n,t.$kg=i,t.$lg=p,t.$mg=m,t.$ng=A,t.$og=d,t.$pg=o,t.$qg=u,t.$rg=h,t.$sg=$,t.$tg=b,t.$ug=c,t.$vg=e,t.$wg=g,t.$xg=L,t.$yg=N,t.$zg=E,t.$Ag=_,t.$Bg=w;function n(a){return typeof a=="string"}function i(a){return Array.isArray(a)&&a.every(s=>n(s))}function p(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function m(a){const s=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof s}function A(a){return typeof a=="number"&&!isNaN(a)}function d(a){return!!a&&typeof a[Symbol.iterator]=="function"}function o(a){return a===!0||a===!1}function u(a){return typeof a>"u"}function h(a){return!$(a)}function $(a){return u(a)||a===null}function b(a,s){if(!a)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}function c(a){if($(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function e(...a){const s=[];for(let f=0;f<a.length;f++){const v=a[f];if($(v))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);s.push(v)}return s}const l=Object.prototype.hasOwnProperty;function g(a){if(!p(a))return!1;for(const s in a)if(l.call(a,s))return!1;return!0}function L(a){return typeof a=="function"}function N(...a){return a.length>0&&a.every(L)}function E(a,s){const f=Math.min(a.length,s.length);for(let v=0;v<f;v++)_(a[v],s[v])}function _(a,s){if(n(s)){if(typeof a!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(L(s)){try{if(a instanceof s)return}catch{}if(!$(a)&&a.constructor===s||s.length===1&&s.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function w(a){return a}}),ie(re[30],ue([0,1,21]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5j=p,t.$6j=m;const i=Object.create(null);function p(A,d){if((0,n.$jg)(d)){const o=i[d];if(o===void 0)throw new Error(`${A} references an unknown codicon: ${d}`);d=o}return i[A]=d,{id:A}}function m(){return i}}),ie(re[49],ue([0,1,30]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7j=void 0,t.$7j={add:(0,n.$5j)("add",6e4),plus:(0,n.$5j)("plus",6e4),gistNew:(0,n.$5j)("gist-new",6e4),repoCreate:(0,n.$5j)("repo-create",6e4),lightbulb:(0,n.$5j)("lightbulb",60001),lightBulb:(0,n.$5j)("light-bulb",60001),repo:(0,n.$5j)("repo",60002),repoDelete:(0,n.$5j)("repo-delete",60002),gistFork:(0,n.$5j)("gist-fork",60003),repoForked:(0,n.$5j)("repo-forked",60003),gitPullRequest:(0,n.$5j)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$5j)("git-pull-request-abandoned",60004),recordKeys:(0,n.$5j)("record-keys",60005),keyboard:(0,n.$5j)("keyboard",60005),tag:(0,n.$5j)("tag",60006),gitPullRequestLabel:(0,n.$5j)("git-pull-request-label",60006),tagAdd:(0,n.$5j)("tag-add",60006),tagRemove:(0,n.$5j)("tag-remove",60006),person:(0,n.$5j)("person",60007),personFollow:(0,n.$5j)("person-follow",60007),personOutline:(0,n.$5j)("person-outline",60007),personFilled:(0,n.$5j)("person-filled",60007),gitBranch:(0,n.$5j)("git-branch",60008),gitBranchCreate:(0,n.$5j)("git-branch-create",60008),gitBranchDelete:(0,n.$5j)("git-branch-delete",60008),sourceControl:(0,n.$5j)("source-control",60008),mirror:(0,n.$5j)("mirror",60009),mirrorPublic:(0,n.$5j)("mirror-public",60009),star:(0,n.$5j)("star",60010),starAdd:(0,n.$5j)("star-add",60010),starDelete:(0,n.$5j)("star-delete",60010),starEmpty:(0,n.$5j)("star-empty",60010),comment:(0,n.$5j)("comment",60011),commentAdd:(0,n.$5j)("comment-add",60011),alert:(0,n.$5j)("alert",60012),warning:(0,n.$5j)("warning",60012),search:(0,n.$5j)("search",60013),searchSave:(0,n.$5j)("search-save",60013),logOut:(0,n.$5j)("log-out",60014),signOut:(0,n.$5j)("sign-out",60014),logIn:(0,n.$5j)("log-in",60015),signIn:(0,n.$5j)("sign-in",60015),eye:(0,n.$5j)("eye",60016),eyeUnwatch:(0,n.$5j)("eye-unwatch",60016),eyeWatch:(0,n.$5j)("eye-watch",60016),circleFilled:(0,n.$5j)("circle-filled",60017),primitiveDot:(0,n.$5j)("primitive-dot",60017),closeDirty:(0,n.$5j)("close-dirty",60017),debugBreakpoint:(0,n.$5j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$5j)("debug-breakpoint-disabled",60017),debugHint:(0,n.$5j)("debug-hint",60017),terminalDecorationSuccess:(0,n.$5j)("terminal-decoration-success",60017),primitiveSquare:(0,n.$5j)("primitive-square",60018),edit:(0,n.$5j)("edit",60019),pencil:(0,n.$5j)("pencil",60019),info:(0,n.$5j)("info",60020),issueOpened:(0,n.$5j)("issue-opened",60020),gistPrivate:(0,n.$5j)("gist-private",60021),gitForkPrivate:(0,n.$5j)("git-fork-private",60021),lock:(0,n.$5j)("lock",60021),mirrorPrivate:(0,n.$5j)("mirror-private",60021),close:(0,n.$5j)("close",60022),removeClose:(0,n.$5j)("remove-close",60022),x:(0,n.$5j)("x",60022),repoSync:(0,n.$5j)("repo-sync",60023),sync:(0,n.$5j)("sync",60023),clone:(0,n.$5j)("clone",60024),desktopDownload:(0,n.$5j)("desktop-download",60024),beaker:(0,n.$5j)("beaker",60025),microscope:(0,n.$5j)("microscope",60025),vm:(0,n.$5j)("vm",60026),deviceDesktop:(0,n.$5j)("device-desktop",60026),file:(0,n.$5j)("file",60027),fileText:(0,n.$5j)("file-text",60027),more:(0,n.$5j)("more",60028),ellipsis:(0,n.$5j)("ellipsis",60028),kebabHorizontal:(0,n.$5j)("kebab-horizontal",60028),mailReply:(0,n.$5j)("mail-reply",60029),reply:(0,n.$5j)("reply",60029),organization:(0,n.$5j)("organization",60030),organizationFilled:(0,n.$5j)("organization-filled",60030),organizationOutline:(0,n.$5j)("organization-outline",60030),newFile:(0,n.$5j)("new-file",60031),fileAdd:(0,n.$5j)("file-add",60031),newFolder:(0,n.$5j)("new-folder",60032),fileDirectoryCreate:(0,n.$5j)("file-directory-create",60032),trash:(0,n.$5j)("trash",60033),trashcan:(0,n.$5j)("trashcan",60033),history:(0,n.$5j)("history",60034),clock:(0,n.$5j)("clock",60034),folder:(0,n.$5j)("folder",60035),fileDirectory:(0,n.$5j)("file-directory",60035),symbolFolder:(0,n.$5j)("symbol-folder",60035),logoGithub:(0,n.$5j)("logo-github",60036),markGithub:(0,n.$5j)("mark-github",60036),github:(0,n.$5j)("github",60036),terminal:(0,n.$5j)("terminal",60037),console:(0,n.$5j)("console",60037),repl:(0,n.$5j)("repl",60037),zap:(0,n.$5j)("zap",60038),symbolEvent:(0,n.$5j)("symbol-event",60038),error:(0,n.$5j)("error",60039),stop:(0,n.$5j)("stop",60039),variable:(0,n.$5j)("variable",60040),symbolVariable:(0,n.$5j)("symbol-variable",60040),array:(0,n.$5j)("array",60042),symbolArray:(0,n.$5j)("symbol-array",60042),symbolModule:(0,n.$5j)("symbol-module",60043),symbolPackage:(0,n.$5j)("symbol-package",60043),symbolNamespace:(0,n.$5j)("symbol-namespace",60043),symbolObject:(0,n.$5j)("symbol-object",60043),symbolMethod:(0,n.$5j)("symbol-method",60044),symbolFunction:(0,n.$5j)("symbol-function",60044),symbolConstructor:(0,n.$5j)("symbol-constructor",60044),symbolBoolean:(0,n.$5j)("symbol-boolean",60047),symbolNull:(0,n.$5j)("symbol-null",60047),symbolNumeric:(0,n.$5j)("symbol-numeric",60048),symbolNumber:(0,n.$5j)("symbol-number",60048),symbolStructure:(0,n.$5j)("symbol-structure",60049),symbolStruct:(0,n.$5j)("symbol-struct",60049),symbolParameter:(0,n.$5j)("symbol-parameter",60050),symbolTypeParameter:(0,n.$5j)("symbol-type-parameter",60050),symbolKey:(0,n.$5j)("symbol-key",60051),symbolText:(0,n.$5j)("symbol-text",60051),symbolReference:(0,n.$5j)("symbol-reference",60052),goToFile:(0,n.$5j)("go-to-file",60052),symbolEnum:(0,n.$5j)("symbol-enum",60053),symbolValue:(0,n.$5j)("symbol-value",60053),symbolRuler:(0,n.$5j)("symbol-ruler",60054),symbolUnit:(0,n.$5j)("symbol-unit",60054),activateBreakpoints:(0,n.$5j)("activate-breakpoints",60055),archive:(0,n.$5j)("archive",60056),arrowBoth:(0,n.$5j)("arrow-both",60057),arrowDown:(0,n.$5j)("arrow-down",60058),arrowLeft:(0,n.$5j)("arrow-left",60059),arrowRight:(0,n.$5j)("arrow-right",60060),arrowSmallDown:(0,n.$5j)("arrow-small-down",60061),arrowSmallLeft:(0,n.$5j)("arrow-small-left",60062),arrowSmallRight:(0,n.$5j)("arrow-small-right",60063),arrowSmallUp:(0,n.$5j)("arrow-small-up",60064),arrowUp:(0,n.$5j)("arrow-up",60065),bell:(0,n.$5j)("bell",60066),bold:(0,n.$5j)("bold",60067),book:(0,n.$5j)("book",60068),bookmark:(0,n.$5j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$5j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$5j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$5j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$5j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$5j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$5j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$5j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$5j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$5j)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$5j)("briefcase",60076),broadcast:(0,n.$5j)("broadcast",60077),browser:(0,n.$5j)("browser",60078),bug:(0,n.$5j)("bug",60079),calendar:(0,n.$5j)("calendar",60080),caseSensitive:(0,n.$5j)("case-sensitive",60081),check:(0,n.$5j)("check",60082),checklist:(0,n.$5j)("checklist",60083),chevronDown:(0,n.$5j)("chevron-down",60084),chevronLeft:(0,n.$5j)("chevron-left",60085),chevronRight:(0,n.$5j)("chevron-right",60086),chevronUp:(0,n.$5j)("chevron-up",60087),chromeClose:(0,n.$5j)("chrome-close",60088),chromeMaximize:(0,n.$5j)("chrome-maximize",60089),chromeMinimize:(0,n.$5j)("chrome-minimize",60090),chromeRestore:(0,n.$5j)("chrome-restore",60091),circleOutline:(0,n.$5j)("circle-outline",60092),circle:(0,n.$5j)("circle",60092),debugBreakpointUnverified:(0,n.$5j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$5j)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$5j)("circle-slash",60093),circuitBoard:(0,n.$5j)("circuit-board",60094),clearAll:(0,n.$5j)("clear-all",60095),clippy:(0,n.$5j)("clippy",60096),closeAll:(0,n.$5j)("close-all",60097),cloudDownload:(0,n.$5j)("cloud-download",60098),cloudUpload:(0,n.$5j)("cloud-upload",60099),code:(0,n.$5j)("code",60100),collapseAll:(0,n.$5j)("collapse-all",60101),colorMode:(0,n.$5j)("color-mode",60102),commentDiscussion:(0,n.$5j)("comment-discussion",60103),creditCard:(0,n.$5j)("credit-card",60105),dash:(0,n.$5j)("dash",60108),dashboard:(0,n.$5j)("dashboard",60109),database:(0,n.$5j)("database",60110),debugContinue:(0,n.$5j)("debug-continue",60111),debugDisconnect:(0,n.$5j)("debug-disconnect",60112),debugPause:(0,n.$5j)("debug-pause",60113),debugRestart:(0,n.$5j)("debug-restart",60114),debugStart:(0,n.$5j)("debug-start",60115),debugStepInto:(0,n.$5j)("debug-step-into",60116),debugStepOut:(0,n.$5j)("debug-step-out",60117),debugStepOver:(0,n.$5j)("debug-step-over",60118),debugStop:(0,n.$5j)("debug-stop",60119),debug:(0,n.$5j)("debug",60120),deviceCameraVideo:(0,n.$5j)("device-camera-video",60121),deviceCamera:(0,n.$5j)("device-camera",60122),deviceMobile:(0,n.$5j)("device-mobile",60123),diffAdded:(0,n.$5j)("diff-added",60124),diffIgnored:(0,n.$5j)("diff-ignored",60125),diffModified:(0,n.$5j)("diff-modified",60126),diffRemoved:(0,n.$5j)("diff-removed",60127),diffRenamed:(0,n.$5j)("diff-renamed",60128),diff:(0,n.$5j)("diff",60129),diffSidebyside:(0,n.$5j)("diff-sidebyside",60129),discard:(0,n.$5j)("discard",60130),editorLayout:(0,n.$5j)("editor-layout",60131),emptyWindow:(0,n.$5j)("empty-window",60132),exclude:(0,n.$5j)("exclude",60133),extensions:(0,n.$5j)("extensions",60134),eyeClosed:(0,n.$5j)("eye-closed",60135),fileBinary:(0,n.$5j)("file-binary",60136),fileCode:(0,n.$5j)("file-code",60137),fileMedia:(0,n.$5j)("file-media",60138),filePdf:(0,n.$5j)("file-pdf",60139),fileSubmodule:(0,n.$5j)("file-submodule",60140),fileSymlinkDirectory:(0,n.$5j)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$5j)("file-symlink-file",60142),fileZip:(0,n.$5j)("file-zip",60143),files:(0,n.$5j)("files",60144),filter:(0,n.$5j)("filter",60145),flame:(0,n.$5j)("flame",60146),foldDown:(0,n.$5j)("fold-down",60147),foldUp:(0,n.$5j)("fold-up",60148),fold:(0,n.$5j)("fold",60149),folderActive:(0,n.$5j)("folder-active",60150),folderOpened:(0,n.$5j)("folder-opened",60151),gear:(0,n.$5j)("gear",60152),gift:(0,n.$5j)("gift",60153),gistSecret:(0,n.$5j)("gist-secret",60154),gist:(0,n.$5j)("gist",60155),gitCommit:(0,n.$5j)("git-commit",60156),gitCompare:(0,n.$5j)("git-compare",60157),compareChanges:(0,n.$5j)("compare-changes",60157),gitMerge:(0,n.$5j)("git-merge",60158),githubAction:(0,n.$5j)("github-action",60159),githubAlt:(0,n.$5j)("github-alt",60160),globe:(0,n.$5j)("globe",60161),grabber:(0,n.$5j)("grabber",60162),graph:(0,n.$5j)("graph",60163),gripper:(0,n.$5j)("gripper",60164),heart:(0,n.$5j)("heart",60165),home:(0,n.$5j)("home",60166),horizontalRule:(0,n.$5j)("horizontal-rule",60167),hubot:(0,n.$5j)("hubot",60168),inbox:(0,n.$5j)("inbox",60169),issueReopened:(0,n.$5j)("issue-reopened",60171),issues:(0,n.$5j)("issues",60172),italic:(0,n.$5j)("italic",60173),jersey:(0,n.$5j)("jersey",60174),json:(0,n.$5j)("json",60175),kebabVertical:(0,n.$5j)("kebab-vertical",60176),key:(0,n.$5j)("key",60177),law:(0,n.$5j)("law",60178),lightbulbAutofix:(0,n.$5j)("lightbulb-autofix",60179),linkExternal:(0,n.$5j)("link-external",60180),link:(0,n.$5j)("link",60181),listOrdered:(0,n.$5j)("list-ordered",60182),listUnordered:(0,n.$5j)("list-unordered",60183),liveShare:(0,n.$5j)("live-share",60184),loading:(0,n.$5j)("loading",60185),location:(0,n.$5j)("location",60186),mailRead:(0,n.$5j)("mail-read",60187),mail:(0,n.$5j)("mail",60188),markdown:(0,n.$5j)("markdown",60189),megaphone:(0,n.$5j)("megaphone",60190),mention:(0,n.$5j)("mention",60191),milestone:(0,n.$5j)("milestone",60192),gitPullRequestMilestone:(0,n.$5j)("git-pull-request-milestone",60192),mortarBoard:(0,n.$5j)("mortar-board",60193),move:(0,n.$5j)("move",60194),multipleWindows:(0,n.$5j)("multiple-windows",60195),mute:(0,n.$5j)("mute",60196),noNewline:(0,n.$5j)("no-newline",60197),note:(0,n.$5j)("note",60198),octoface:(0,n.$5j)("octoface",60199),openPreview:(0,n.$5j)("open-preview",60200),package:(0,n.$5j)("package",60201),paintcan:(0,n.$5j)("paintcan",60202),pin:(0,n.$5j)("pin",60203),play:(0,n.$5j)("play",60204),run:(0,n.$5j)("run",60204),plug:(0,n.$5j)("plug",60205),preserveCase:(0,n.$5j)("preserve-case",60206),preview:(0,n.$5j)("preview",60207),project:(0,n.$5j)("project",60208),pulse:(0,n.$5j)("pulse",60209),question:(0,n.$5j)("question",60210),quote:(0,n.$5j)("quote",60211),radioTower:(0,n.$5j)("radio-tower",60212),reactions:(0,n.$5j)("reactions",60213),references:(0,n.$5j)("references",60214),refresh:(0,n.$5j)("refresh",60215),regex:(0,n.$5j)("regex",60216),remoteExplorer:(0,n.$5j)("remote-explorer",60217),remote:(0,n.$5j)("remote",60218),remove:(0,n.$5j)("remove",60219),replaceAll:(0,n.$5j)("replace-all",60220),replace:(0,n.$5j)("replace",60221),repoClone:(0,n.$5j)("repo-clone",60222),repoForcePush:(0,n.$5j)("repo-force-push",60223),repoPull:(0,n.$5j)("repo-pull",60224),repoPush:(0,n.$5j)("repo-push",60225),report:(0,n.$5j)("report",60226),requestChanges:(0,n.$5j)("request-changes",60227),rocket:(0,n.$5j)("rocket",60228),rootFolderOpened:(0,n.$5j)("root-folder-opened",60229),rootFolder:(0,n.$5j)("root-folder",60230),rss:(0,n.$5j)("rss",60231),ruby:(0,n.$5j)("ruby",60232),saveAll:(0,n.$5j)("save-all",60233),saveAs:(0,n.$5j)("save-as",60234),save:(0,n.$5j)("save",60235),screenFull:(0,n.$5j)("screen-full",60236),screenNormal:(0,n.$5j)("screen-normal",60237),searchStop:(0,n.$5j)("search-stop",60238),server:(0,n.$5j)("server",60240),settingsGear:(0,n.$5j)("settings-gear",60241),settings:(0,n.$5j)("settings",60242),shield:(0,n.$5j)("shield",60243),smiley:(0,n.$5j)("smiley",60244),sortPrecedence:(0,n.$5j)("sort-precedence",60245),splitHorizontal:(0,n.$5j)("split-horizontal",60246),splitVertical:(0,n.$5j)("split-vertical",60247),squirrel:(0,n.$5j)("squirrel",60248),starFull:(0,n.$5j)("star-full",60249),starHalf:(0,n.$5j)("star-half",60250),symbolClass:(0,n.$5j)("symbol-class",60251),symbolColor:(0,n.$5j)("symbol-color",60252),symbolConstant:(0,n.$5j)("symbol-constant",60253),symbolEnumMember:(0,n.$5j)("symbol-enum-member",60254),symbolField:(0,n.$5j)("symbol-field",60255),symbolFile:(0,n.$5j)("symbol-file",60256),symbolInterface:(0,n.$5j)("symbol-interface",60257),symbolKeyword:(0,n.$5j)("symbol-keyword",60258),symbolMisc:(0,n.$5j)("symbol-misc",60259),symbolOperator:(0,n.$5j)("symbol-operator",60260),symbolProperty:(0,n.$5j)("symbol-property",60261),wrench:(0,n.$5j)("wrench",60261),wrenchSubaction:(0,n.$5j)("wrench-subaction",60261),symbolSnippet:(0,n.$5j)("symbol-snippet",60262),tasklist:(0,n.$5j)("tasklist",60263),telescope:(0,n.$5j)("telescope",60264),textSize:(0,n.$5j)("text-size",60265),threeBars:(0,n.$5j)("three-bars",60266),thumbsdown:(0,n.$5j)("thumbsdown",60267),thumbsup:(0,n.$5j)("thumbsup",60268),tools:(0,n.$5j)("tools",60269),triangleDown:(0,n.$5j)("triangle-down",60270),triangleLeft:(0,n.$5j)("triangle-left",60271),triangleRight:(0,n.$5j)("triangle-right",60272),triangleUp:(0,n.$5j)("triangle-up",60273),twitter:(0,n.$5j)("twitter",60274),unfold:(0,n.$5j)("unfold",60275),unlock:(0,n.$5j)("unlock",60276),unmute:(0,n.$5j)("unmute",60277),unverified:(0,n.$5j)("unverified",60278),verified:(0,n.$5j)("verified",60279),versions:(0,n.$5j)("versions",60280),vmActive:(0,n.$5j)("vm-active",60281),vmOutline:(0,n.$5j)("vm-outline",60282),vmRunning:(0,n.$5j)("vm-running",60283),watch:(0,n.$5j)("watch",60284),whitespace:(0,n.$5j)("whitespace",60285),wholeWord:(0,n.$5j)("whole-word",60286),window:(0,n.$5j)("window",60287),wordWrap:(0,n.$5j)("word-wrap",60288),zoomIn:(0,n.$5j)("zoom-in",60289),zoomOut:(0,n.$5j)("zoom-out",60290),listFilter:(0,n.$5j)("list-filter",60291),listFlat:(0,n.$5j)("list-flat",60292),listSelection:(0,n.$5j)("list-selection",60293),selection:(0,n.$5j)("selection",60293),listTree:(0,n.$5j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$5j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$5j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$5j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$5j)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$5j)("circle-small-filled",60298),debugStackframeDot:(0,n.$5j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$5j)("terminal-decoration-mark",60298),debugStackframe:(0,n.$5j)("debug-stackframe",60299),debugStackframeFocused:(0,n.$5j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$5j)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$5j)("symbol-string",60301),debugReverseContinue:(0,n.$5j)("debug-reverse-continue",60302),debugStepBack:(0,n.$5j)("debug-step-back",60303),debugRestartFrame:(0,n.$5j)("debug-restart-frame",60304),debugAlt:(0,n.$5j)("debug-alt",60305),callIncoming:(0,n.$5j)("call-incoming",60306),callOutgoing:(0,n.$5j)("call-outgoing",60307),menu:(0,n.$5j)("menu",60308),expandAll:(0,n.$5j)("expand-all",60309),feedback:(0,n.$5j)("feedback",60310),gitPullRequestReviewer:(0,n.$5j)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$5j)("group-by-ref-type",60311),ungroupByRefType:(0,n.$5j)("ungroup-by-ref-type",60312),account:(0,n.$5j)("account",60313),gitPullRequestAssignee:(0,n.$5j)("git-pull-request-assignee",60313),bellDot:(0,n.$5j)("bell-dot",60314),debugConsole:(0,n.$5j)("debug-console",60315),library:(0,n.$5j)("library",60316),output:(0,n.$5j)("output",60317),runAll:(0,n.$5j)("run-all",60318),syncIgnored:(0,n.$5j)("sync-ignored",60319),pinned:(0,n.$5j)("pinned",60320),githubInverted:(0,n.$5j)("github-inverted",60321),serverProcess:(0,n.$5j)("server-process",60322),serverEnvironment:(0,n.$5j)("server-environment",60323),pass:(0,n.$5j)("pass",60324),issueClosed:(0,n.$5j)("issue-closed",60324),stopCircle:(0,n.$5j)("stop-circle",60325),playCircle:(0,n.$5j)("play-circle",60326),record:(0,n.$5j)("record",60327),debugAltSmall:(0,n.$5j)("debug-alt-small",60328),vmConnect:(0,n.$5j)("vm-connect",60329),cloud:(0,n.$5j)("cloud",60330),merge:(0,n.$5j)("merge",60331),export:(0,n.$5j)("export",60332),graphLeft:(0,n.$5j)("graph-left",60333),magnet:(0,n.$5j)("magnet",60334),notebook:(0,n.$5j)("notebook",60335),redo:(0,n.$5j)("redo",60336),checkAll:(0,n.$5j)("check-all",60337),pinnedDirty:(0,n.$5j)("pinned-dirty",60338),passFilled:(0,n.$5j)("pass-filled",60339),circleLargeFilled:(0,n.$5j)("circle-large-filled",60340),circleLarge:(0,n.$5j)("circle-large",60341),circleLargeOutline:(0,n.$5j)("circle-large-outline",60341),combine:(0,n.$5j)("combine",60342),gather:(0,n.$5j)("gather",60342),table:(0,n.$5j)("table",60343),variableGroup:(0,n.$5j)("variable-group",60344),typeHierarchy:(0,n.$5j)("type-hierarchy",60345),typeHierarchySub:(0,n.$5j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$5j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$5j)("git-pull-request-create",60348),runAbove:(0,n.$5j)("run-above",60349),runBelow:(0,n.$5j)("run-below",60350),notebookTemplate:(0,n.$5j)("notebook-template",60351),debugRerun:(0,n.$5j)("debug-rerun",60352),workspaceTrusted:(0,n.$5j)("workspace-trusted",60353),workspaceUntrusted:(0,n.$5j)("workspace-untrusted",60354),workspaceUnknown:(0,n.$5j)("workspace-unknown",60355),terminalCmd:(0,n.$5j)("terminal-cmd",60356),terminalDebian:(0,n.$5j)("terminal-debian",60357),terminalLinux:(0,n.$5j)("terminal-linux",60358),terminalPowershell:(0,n.$5j)("terminal-powershell",60359),terminalTmux:(0,n.$5j)("terminal-tmux",60360),terminalUbuntu:(0,n.$5j)("terminal-ubuntu",60361),terminalBash:(0,n.$5j)("terminal-bash",60362),arrowSwap:(0,n.$5j)("arrow-swap",60363),copy:(0,n.$5j)("copy",60364),personAdd:(0,n.$5j)("person-add",60365),filterFilled:(0,n.$5j)("filter-filled",60366),wand:(0,n.$5j)("wand",60367),debugLineByLine:(0,n.$5j)("debug-line-by-line",60368),inspect:(0,n.$5j)("inspect",60369),layers:(0,n.$5j)("layers",60370),layersDot:(0,n.$5j)("layers-dot",60371),layersActive:(0,n.$5j)("layers-active",60372),compass:(0,n.$5j)("compass",60373),compassDot:(0,n.$5j)("compass-dot",60374),compassActive:(0,n.$5j)("compass-active",60375),azure:(0,n.$5j)("azure",60376),issueDraft:(0,n.$5j)("issue-draft",60377),gitPullRequestClosed:(0,n.$5j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$5j)("git-pull-request-draft",60379),debugAll:(0,n.$5j)("debug-all",60380),debugCoverage:(0,n.$5j)("debug-coverage",60381),runErrors:(0,n.$5j)("run-errors",60382),folderLibrary:(0,n.$5j)("folder-library",60383),debugContinueSmall:(0,n.$5j)("debug-continue-small",60384),beakerStop:(0,n.$5j)("beaker-stop",60385),graphLine:(0,n.$5j)("graph-line",60386),graphScatter:(0,n.$5j)("graph-scatter",60387),pieChart:(0,n.$5j)("pie-chart",60388),bracket:(0,n.$5j)("bracket",60175),bracketDot:(0,n.$5j)("bracket-dot",60389),bracketError:(0,n.$5j)("bracket-error",60390),lockSmall:(0,n.$5j)("lock-small",60391),azureDevops:(0,n.$5j)("azure-devops",60392),verifiedFilled:(0,n.$5j)("verified-filled",60393),newline:(0,n.$5j)("newline",60394),layout:(0,n.$5j)("layout",60395),layoutActivitybarLeft:(0,n.$5j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$5j)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$5j)("layout-panel-left",60398),layoutPanelCenter:(0,n.$5j)("layout-panel-center",60399),layoutPanelJustify:(0,n.$5j)("layout-panel-justify",60400),layoutPanelRight:(0,n.$5j)("layout-panel-right",60401),layoutPanel:(0,n.$5j)("layout-panel",60402),layoutSidebarLeft:(0,n.$5j)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$5j)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$5j)("layout-statusbar",60405),layoutMenubar:(0,n.$5j)("layout-menubar",60406),layoutCentered:(0,n.$5j)("layout-centered",60407),target:(0,n.$5j)("target",60408),indent:(0,n.$5j)("indent",60409),recordSmall:(0,n.$5j)("record-small",60410),errorSmall:(0,n.$5j)("error-small",60411),terminalDecorationError:(0,n.$5j)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$5j)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$5j)("arrow-circle-left",60413),arrowCircleRight:(0,n.$5j)("arrow-circle-right",60414),arrowCircleUp:(0,n.$5j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$5j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$5j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$5j)("layout-sidebar-left-off",60418),blank:(0,n.$5j)("blank",60419),heartFilled:(0,n.$5j)("heart-filled",60420),map:(0,n.$5j)("map",60421),mapHorizontal:(0,n.$5j)("map-horizontal",60421),foldHorizontal:(0,n.$5j)("fold-horizontal",60421),mapFilled:(0,n.$5j)("map-filled",60422),mapHorizontalFilled:(0,n.$5j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$5j)("fold-horizontal-filled",60422),circleSmall:(0,n.$5j)("circle-small",60423),bellSlash:(0,n.$5j)("bell-slash",60424),bellSlashDot:(0,n.$5j)("bell-slash-dot",60425),commentUnresolved:(0,n.$5j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$5j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$5j)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$5j)("search-fuzzy",60429),commentDraft:(0,n.$5j)("comment-draft",60430),send:(0,n.$5j)("send",60431),sparkle:(0,n.$5j)("sparkle",60432),insert:(0,n.$5j)("insert",60433),mic:(0,n.$5j)("mic",60434),thumbsdownFilled:(0,n.$5j)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$5j)("thumbsup-filled",60436),coffee:(0,n.$5j)("coffee",60437),snake:(0,n.$5j)("snake",60438),game:(0,n.$5j)("game",60439),vr:(0,n.$5j)("vr",60440),chip:(0,n.$5j)("chip",60441),piano:(0,n.$5j)("piano",60442),music:(0,n.$5j)("music",60443),micFilled:(0,n.$5j)("mic-filled",60444),repoFetch:(0,n.$5j)("repo-fetch",60445),copilot:(0,n.$5j)("copilot",60446),lightbulbSparkle:(0,n.$5j)("lightbulb-sparkle",60447),robot:(0,n.$5j)("robot",60448),sparkleFilled:(0,n.$5j)("sparkle-filled",60449),diffSingle:(0,n.$5j)("diff-single",60450),diffMultiple:(0,n.$5j)("diff-multiple",60451),surroundWith:(0,n.$5j)("surround-with",60452),share:(0,n.$5j)("share",60453),gitStash:(0,n.$5j)("git-stash",60454),gitStashApply:(0,n.$5j)("git-stash-apply",60455),gitStashPop:(0,n.$5j)("git-stash-pop",60456),vscode:(0,n.$5j)("vscode",60457),vscodeInsiders:(0,n.$5j)("vscode-insiders",60458),codeOss:(0,n.$5j)("code-oss",60459),runCoverage:(0,n.$5j)("run-coverage",60460),runAllCoverage:(0,n.$5j)("run-all-coverage",60461),coverage:(0,n.$5j)("coverage",60462),githubProject:(0,n.$5j)("github-project",60463),mapVertical:(0,n.$5j)("map-vertical",60464),foldVertical:(0,n.$5j)("fold-vertical",60464),mapVerticalFilled:(0,n.$5j)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$5j)("fold-vertical-filled",60465),goToSearch:(0,n.$5j)("go-to-search",60466),percentage:(0,n.$5j)("percentage",60467),sortPercentage:(0,n.$5j)("sort-percentage",60467),attach:(0,n.$5j)("attach",60468)}}),ie(re[50],ue([0,1,30,49]),function(W,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0j=t.$9j=void 0,t.$8j=p;function p(){return Object.values(t.$0j)}t.$9j={dialogError:(0,n.$5j)("dialog-error","error"),dialogWarning:(0,n.$5j)("dialog-warning","warning"),dialogInfo:(0,n.$5j)("dialog-info","info"),dialogClose:(0,n.$5j)("dialog-close","close"),treeItemExpanded:(0,n.$5j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$5j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$5j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$5j)("tree-filter-clear","close"),treeItemLoading:(0,n.$5j)("tree-item-loading","loading"),menuSelection:(0,n.$5j)("menu-selection","check"),menuSubmenu:(0,n.$5j)("menu-submenu","chevron-right"),menuBarMore:(0,n.$5j)("menubar-more","more"),scrollbarButtonLeft:(0,n.$5j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$5j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$5j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$5j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$5j)("toolbar-more","more"),quickInputBack:(0,n.$5j)("quick-input-back","arrow-left"),dropDownButton:(0,n.$5j)("drop-down-button",60084),symbolCustomColor:(0,n.$5j)("symbol-customcolor",60252),exportIcon:(0,n.$5j)("export",60332),workspaceUnspecified:(0,n.$5j)("workspace-unspecified",60355),newLine:(0,n.$5j)("newline",60394),thumbsDownFilled:(0,n.$5j)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$5j)("thumbsup-filled",60436),gitFetch:(0,n.$5j)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$5j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$5j)("debug-breakpoint-pending",60377)},t.$0j={...i.$7j,...t.$9j}}),ie(re[31],ue([0,1,21]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ko=i,t.$lo=p,t.$mo=A,t.$no=o,t.$oo=u,t.$po=h,t.$qo=$,t.$ro=b,t.$so=c,t.$to=e,t.$uo=l,t.$vo=g,t.$wo=L;function i(N){if(!N||typeof N!="object"||N instanceof RegExp)return N;const E=Array.isArray(N)?[]:{};return Object.entries(N).forEach(([_,w])=>{E[_]=w&&typeof w=="object"?i(w):w}),E}function p(N){if(!N||typeof N!="object")return N;const E=[N];for(;E.length>0;){const _=E.shift();Object.freeze(_);for(const w in _)if(m.call(_,w)){const a=_[w];typeof a=="object"&&!Object.isFrozen(a)&&!(0,n.$mg)(a)&&E.push(a)}}return N}const m=Object.prototype.hasOwnProperty;function A(N,E){return d(N,E,new Set)}function d(N,E,_){if((0,n.$sg)(N))return N;const w=E(N);if(typeof w<"u")return w;if(Array.isArray(N)){const a=[];for(const s of N)a.push(d(s,E,_));return a}if((0,n.$lg)(N)){if(_.has(N))throw new Error("Cannot clone recursive data-structure");_.add(N);const a={};for(const s in N)m.call(N,s)&&(a[s]=d(N[s],E,_));return _.delete(N),a}return N}function o(N,E,_=!0){return(0,n.$lg)(N)?((0,n.$lg)(E)&&Object.keys(E).forEach(w=>{w in N?_&&((0,n.$lg)(N[w])&&(0,n.$lg)(E[w])?o(N[w],E[w],_):N[w]=E[w]):N[w]=E[w]}),N):E}function u(N,E){if(N===E)return!0;if(N==null||E===null||E===void 0||typeof N!=typeof E||typeof N!="object"||Array.isArray(N)!==Array.isArray(E))return!1;let _,w;if(Array.isArray(N)){if(N.length!==E.length)return!1;for(_=0;_<N.length;_++)if(!u(N[_],E[_]))return!1}else{const a=[];for(w in N)a.push(w);a.sort();const s=[];for(w in E)s.push(w);if(s.sort(),!u(a,s))return!1;for(_=0;_<a.length;_++)if(!u(N[a[_]],E[a[_]]))return!1}return!0}function h(N){const E=new Set;return JSON.stringify(N,(_,w)=>{if((0,n.$lg)(w)||Array.isArray(w)){if(E.has(w))return"[Circular]";E.add(w)}return typeof w=="bigint"?`[BigInt ${w.toString()}]`:w})}function $(N,E){const _=Object.create(null);return!N||!E||Object.keys(E).forEach(a=>{const s=N[a],f=E[a];u(s,f)||(_[a]=f)}),_}function b(N,E){const _=E.toLowerCase(),w=Object.keys(N).find(a=>a.toLowerCase()===_);return w?N[w]:N[E]}function c(N,E){const _=Object.create(null);for(const[w,a]of Object.entries(N))E(w,a)&&(_[w]=a);return _}function e(N){let E=[];for(;Object.prototype!==N;)E=E.concat(Object.getOwnPropertyNames(N)),N=Object.getPrototypeOf(N);return E}function l(N){const E=[];for(const _ of e(N))typeof N[_]=="function"&&E.push(_);return E}function g(N,E){const _=a=>function(){const s=Array.prototype.slice.call(arguments,0);return E(a,s)},w={};for(const a of N)w[a]=_(a);return w}function L(N,E){const _={};for(const[w,a]of Object.entries(N))_[w]=E(a,w);return _}}),ie(re[16],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.$ff=i,t.$gf=p;var n;(function(m){m[m.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",m[m.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",m[m.MAX_UINT_8=255]="MAX_UINT_8",m[m.MAX_UINT_16=65535]="MAX_UINT_16",m[m.MAX_UINT_32=4294967295]="MAX_UINT_32",m[m.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(t.Constants=n={}));function i(m){return m<0?0:m>n.MAX_UINT_8?n.MAX_UINT_8:m|0}function p(m){return m<0?0:m>n.MAX_UINT_32?n.MAX_UINT_32:m|0}}),ie(re[6],ue([0,1,47,3,27,16]),function(W,t,n,i,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ig=t.$hg=t.$gg=t.GraphemeBreakType=t.$9f=t.$1f=t.$Tf=t.$Sf=void 0,t.$hf=A,t.$if=o,t.$jf=h,t.$kf=$,t.$lf=b,t.$mf=c,t.$nf=e,t.$of=l,t.$pf=g,t.$qf=L,t.$rf=N,t.$sf=E,t.$tf=_,t.$uf=w,t.$vf=a,t.$wf=s,t.$xf=f,t.$yf=v,t.$zf=k,t.$Af=R,t.$Bf=T,t.$Cf=j,t.$Df=M,t.$Ef=D,t.$Ff=F,t.$Gf=y,t.$Hf=B,t.$If=z,t.$Jf=H,t.$Kf=U,t.$Lf=C,t.$Mf=ee,t.$Nf=J,t.$Of=K,t.$Pf=ne,t.$Qf=P,t.$Rf=X,t.$Uf=r,t.$Vf=Me,t.$Wf=Fe,t.$Xf=Ue,t.$Yf=qe,t.$Zf=G,t.$2f=O,t.$3f=I,t.$4f=q,t.$5f=Z,t.$6f=ae,t.$7f=we,t.$8f=Re,t.$0f=oe,t.$$f=se,t.$_f=ce,t.$ag=le,t.$bg=me,t.$cg=de,t.$dg=ve,t.$eg=pe,t.$fg=ze;function A(S){return!S||typeof S!="string"?!0:S.trim().length===0}const d=/{(\d+)}/g;function o(S,...V){return V.length===0?S:S.replace(d,function(Y,te){const fe=parseInt(te,10);return isNaN(fe)||fe<0||fe>=V.length?Y:V[fe]})}const u=/{([^}]+)}/g;function h(S,V){return Object.keys(V).length===0?S:S.replace(u,(Y,te)=>V[te]??Y)}function $(S){return S.replace(/[<>"'&]/g,V=>{switch(V){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return V})}function b(S){return S.replace(/[<>&]/g,function(V){switch(V){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return V}})}function c(S){return S.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(S,V){let Y=0,te=S.indexOf(V);for(;te!==-1;)Y++,te=S.indexOf(V,te+V.length);return Y}function l(S,V,Y="\u2026"){return S.length<=V?S:`${S.substr(0,V)}${Y}`}function g(S,V,Y="\u2026"){if(S.length<=V)return S;const te=Math.ceil(V/2)-Y.length/2,fe=Math.floor(V/2)-Y.length/2;return`${S.substr(0,te)}${Y}${S.substr(S.length-fe)}`}function L(S,V=" "){const Y=N(S,V);return E(Y,V)}function N(S,V){if(!S||!V)return S;const Y=V.length;if(Y===0||S.length===0)return S;let te=0;for(;S.indexOf(V,te)===te;)te=te+Y;return S.substring(te)}function E(S,V){if(!S||!V)return S;const Y=V.length,te=S.length;if(Y===0||te===0)return S;let fe=te,$e=-1;for(;$e=S.lastIndexOf(V,fe-1),!($e===-1||$e+Y!==fe);){if($e===0)return"";fe=$e}return S.substring(0,fe)}function _(S){return S.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function w(S){return S.replace(/\*/g,"")}function a(S,V,Y={}){if(!S)throw new Error("Cannot create regex from empty string");V||(S=c(S)),Y.wholeWord&&(/\B/.test(S.charAt(0))||(S="\\b"+S),/\B/.test(S.charAt(S.length-1))||(S=S+"\\b"));let te="";return Y.global&&(te+="g"),Y.matchCase||(te+="i"),Y.multiline&&(te+="m"),Y.unicode&&(te+="u"),new RegExp(S,te)}function s(S){return S.source==="^"||S.source==="^$"||S.source==="$"||S.source==="^\\s*$"?!1:!!(S.exec("")&&S.lastIndex===0)}function f(S){return S.split(/\r\n|\r|\n/)}function v(S){const V=[],Y=S.split(/(\r\n|\r|\n)/);for(let te=0;te<Math.ceil(Y.length/2);te++)V.push(Y[2*te]+(Y[2*te+1]??""));return V}function k(S){for(let V=0,Y=S.length;V<Y;V++){const te=S.charCodeAt(V);if(te!==i.CharCode.Space&&te!==i.CharCode.Tab)return V}return-1}function R(S,V=0,Y=S.length){for(let te=V;te<Y;te++){const fe=S.charCodeAt(te);if(fe!==i.CharCode.Space&&fe!==i.CharCode.Tab)return S.substring(V,te)}return S.substring(V,Y)}function T(S,V=S.length-1){for(let Y=V;Y>=0;Y--){const te=S.charCodeAt(Y);if(te!==i.CharCode.Space&&te!==i.CharCode.Tab)return Y}return-1}function j(S,V,Y){const te=[];let fe=0;for(const $e of S.matchAll(V)){if(te.push(S.slice(fe,$e.index)),$e.index===void 0)throw new Error("match.index should be defined");fe=$e.index+$e[0].length,te.push(Y($e[0],...$e.slice(1),$e.index,S,$e.groups))}return te.push(S.slice(fe)),Promise.all(te).then($e=>$e.join(""))}function M(S,V){return S<V?-1:S>V?1:0}function D(S,V,Y=0,te=S.length,fe=0,$e=V.length){for(;Y<te&&fe<$e;Y++,fe++){const Pe=S.charCodeAt(Y),Ie=V.charCodeAt(fe);if(Pe<Ie)return-1;if(Pe>Ie)return 1}const je=te-Y,Oe=$e-fe;return je<Oe?-1:je>Oe?1:0}function F(S,V){return y(S,V,0,S.length,0,V.length)}function y(S,V,Y=0,te=S.length,fe=0,$e=V.length){for(;Y<te&&fe<$e;Y++,fe++){let Pe=S.charCodeAt(Y),Ie=V.charCodeAt(fe);if(Pe===Ie)continue;if(Pe>=128||Ie>=128)return D(S.toLowerCase(),V.toLowerCase(),Y,te,fe,$e);z(Pe)&&(Pe-=32),z(Ie)&&(Ie-=32);const ke=Pe-Ie;if(ke!==0)return ke}const je=te-Y,Oe=$e-fe;return je<Oe?-1:je>Oe?1:0}function B(S){return S>=i.CharCode.Digit0&&S<=i.CharCode.Digit9}function z(S){return S>=i.CharCode.a&&S<=i.CharCode.z}function H(S){return S>=i.CharCode.A&&S<=i.CharCode.Z}function U(S,V){return S.length===V.length&&y(S,V)===0}function C(S,V){const Y=V.length;return V.length>S.length?!1:y(S,V,0,Y)===0}function ee(S,V){const Y=Math.min(S.length,V.length);let te;for(te=0;te<Y;te++)if(S.charCodeAt(te)!==V.charCodeAt(te))return te;return Y}function J(S,V){const Y=Math.min(S.length,V.length);let te;const fe=S.length-1,$e=V.length-1;for(te=0;te<Y;te++)if(S.charCodeAt(fe-te)!==V.charCodeAt($e-te))return te;return Y}function K(S){return 55296<=S&&S<=56319}function ne(S){return 56320<=S&&S<=57343}function P(S,V){return(S-55296<<10)+(V-56320)+65536}function X(S,V,Y){const te=S.charCodeAt(Y);if(K(te)&&Y+1<V){const fe=S.charCodeAt(Y+1);if(ne(fe))return P(te,fe)}return te}function he(S,V){const Y=S.charCodeAt(V-1);if(ne(Y)&&V>1){const te=S.charCodeAt(V-2);if(K(te))return P(te,Y)}return Y}class ge{get offset(){return this.e}constructor(V,Y=0){this.c=V,this.d=V.length,this.e=Y}setOffset(V){this.e=V}prevCodePoint(){const V=he(this.c,this.e);return this.e-=V>=m.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,V}nextCodePoint(){const V=X(this.c,this.d,this.e);return this.e+=V>=m.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,V}eol(){return this.e>=this.d}}t.$Sf=ge;class Le{get offset(){return this.c.offset}constructor(V,Y=0){this.c=new ge(V,Y)}nextGraphemeLength(){const V=ye.getInstance(),Y=this.c,te=Y.offset;let fe=V.getGraphemeBreakType(Y.nextCodePoint());for(;!Y.eol();){const $e=Y.offset,je=V.getGraphemeBreakType(Y.nextCodePoint());if(Te(fe,je)){Y.setOffset($e);break}fe=je}return Y.offset-te}prevGraphemeLength(){const V=ye.getInstance(),Y=this.c,te=Y.offset;let fe=V.getGraphemeBreakType(Y.prevCodePoint());for(;Y.offset>0;){const $e=Y.offset,je=V.getGraphemeBreakType(Y.prevCodePoint());if(Te(je,fe)){Y.setOffset($e);break}fe=je}return te-Y.offset}eol(){return this.c.eol()}}t.$Tf=Le;function r(S,V){return new Le(S,V).nextGraphemeLength()}function Me(S,V){return new Le(S,V).prevGraphemeLength()}function Fe(S,V){V>0&&ne(S.charCodeAt(V))&&V--;const Y=V+r(S,V);return[Y-Me(S,Y),Y]}function Ue(S){const V=new Le(S);let Y=0;for(;!V.eol();)Y++,V.nextGraphemeLength();return Y}let Ae;function Ne(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function qe(S){return Ae||(Ae=Ne()),Ae.test(S)}const x=/^[\t\n\r\x20-\x7E]*$/;function G(S){return x.test(S)}t.$1f=/[\u2028\u2029]/;function O(S){return t.$1f.test(S)}function I(S){return S>=11904&&S<=55215||S>=63744&&S<=64255||S>=65281&&S<=65374}function q(S){return S>=127462&&S<=127487||S===8986||S===8987||S===9200||S===9203||S>=9728&&S<=10175||S===11088||S===11093||S>=127744&&S<=128591||S>=128640&&S<=128764||S>=128992&&S<=129008||S>=129280&&S<=129535||S>=129648&&S<=129782}function Z(S,V,Y=""){const te=S.trimStart();if(te.length<V)return te;const fe=/\b/g;let $e=0;for(;fe.test(te)&&!(te.length-fe.lastIndex<V);)$e=fe.lastIndex,fe.lastIndex+=1;return $e===0?te:Y+te.substring($e).trimStart()}const Q=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ae(S){let V=0;for(const Y of S.matchAll(Q))V!==Y.index&&(yield{isCode:!1,str:S.substring(V,Y.index)}),yield{isCode:!0,str:Y[0]},V=Y.index+Y[0].length;V!==S.length&&(yield{isCode:!1,str:S.substring(V)})}function we(S){return S&&(S=S.replace(Q,"")),S}const Ee=/\\\[.*?\\\]/g;function Re(S){return we(S).replace(Ee,"")}t.$9f=String.fromCharCode(i.CharCode.UTF8_BOM);function oe(S){return!!(S&&S.length>0&&S.charCodeAt(0)===i.CharCode.UTF8_BOM)}function se(S){return oe(S)?S.substr(1):S}function ce(S,V){if(!S||!V||S.length<V.length)return!1;const Y=V.length,te=S.toLowerCase();let fe=0,$e=-1;for(;fe<Y;){const je=te.indexOf(V[fe],$e+1);if(je<0)return!1;$e=je,fe++}return!0}function le(S,V=!1){return S?(V&&(S=S.replace(/\\./g,"")),S.toLowerCase()!==S):!1}function me(S){return S.charAt(0).toUpperCase()+S.slice(1)}function de(S,V=1){if(V===0)return"";let Y=-1;do Y=S.indexOf(`
`,Y+1),V--;while(V>0&&Y>=0);return Y===-1?S:(S[Y-1]==="\r"&&Y--,S.substr(0,Y))}function ve(S){const V=i.CharCode.Z-i.CharCode.A+1;return S=S%(2*V),S<V?String.fromCharCode(i.CharCode.a+S):String.fromCharCode(i.CharCode.A+S-V)}function pe(S){return ye.getInstance().getGraphemeBreakType(S)}function Te(S,V){return S===be.Other?V!==be.Extend&&V!==be.SpacingMark:S===be.CR&&V===be.LF?!1:S===be.Control||S===be.CR||S===be.LF||V===be.Control||V===be.CR||V===be.LF?!0:!(S===be.L&&(V===be.L||V===be.V||V===be.LV||V===be.LVT)||(S===be.LV||S===be.V)&&(V===be.V||V===be.T)||(S===be.LVT||S===be.T)&&V===be.T||V===be.Extend||V===be.ZWJ||V===be.SpacingMark||S===be.Prepend||S===be.ZWJ&&V===be.Extended_Pictographic||S===be.Regional_Indicator&&V===be.Regional_Indicator)}var be;(function(S){S[S.Other=0]="Other",S[S.Prepend=1]="Prepend",S[S.CR=2]="CR",S[S.LF=3]="LF",S[S.Control=4]="Control",S[S.Extend=5]="Extend",S[S.Regional_Indicator=6]="Regional_Indicator",S[S.SpacingMark=7]="SpacingMark",S[S.L=8]="L",S[S.V=9]="V",S[S.T=10]="T",S[S.LV=11]="LV",S[S.LVT=12]="LVT",S[S.ZWJ=13]="ZWJ",S[S.Extended_Pictographic=14]="Extended_Pictographic"})(be||(t.GraphemeBreakType=be={}));class ye{static{this.c=null}static getInstance(){return ye.c||(ye.c=new ye),ye.c}constructor(){this.d=We()}getGraphemeBreakType(V){if(V<32)return V===i.CharCode.LineFeed?be.LF:V===i.CharCode.CarriageReturn?be.CR:be.Control;if(V<127)return be.Other;const Y=this.d,te=Y.length/3;let fe=1;for(;fe<=te;)if(V<Y[3*fe])fe=2*fe;else if(V>Y[3*fe+1])fe=2*fe+1;else return Y[3*fe+2];return be.Other}}function We(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(S,V){if(S===0)return 0;const Y=He(S,V);if(Y!==void 0)return Y;const te=new ge(V,S);return te.prevCodePoint(),te.offset}function He(S,V){const Y=new ge(V,S);let te=Y.prevCodePoint();for(;Ze(te)||te===Ve.emojiVariantSelector||te===Ve.enclosingKeyCap;){if(Y.offset===0)return;te=Y.prevCodePoint()}if(!q(te))return;let fe=Y.offset;return fe>0&&Y.prevCodePoint()===Ve.zwj&&(fe=Y.offset),fe}function Ze(S){return 127995<=S&&S<=127999}var Ve;(function(S){S[S.zwj=8205]="zwj",S[S.emojiVariantSelector=65039]="emojiVariantSelector",S[S.enclosingKeyCap=8419]="enclosingKeyCap"})(Ve||(Ve={})),t.$gg="\xA0";class xe{static{this.c=new p.$Y(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$df({getCacheKey:JSON.stringify},V=>{function Y(ke){const Be=new Map;for(let Se=0;Se<ke.length;Se+=2)Be.set(ke[Se],ke[Se+1]);return Be}function te(ke,Be){const Se=new Map(ke);for(const[Xe,Ye]of Be)Se.set(Xe,Ye);return Se}function fe(ke,Be){if(!ke)return Be;const Se=new Map;for(const[Xe,Ye]of ke)Be.has(Xe)&&Se.set(Xe,Ye);return Se}const $e=this.c.value;let je=V.filter(ke=>!ke.startsWith("_")&&ke in $e);je.length===0&&(je=["_default"]);let Oe;for(const ke of je){const Be=Y($e[ke]);Oe=fe(Oe,Be)}const Pe=Y($e._common),Ie=te(Pe,Oe);return new xe(Ie)})}static getInstance(V){return xe.d.get(Array.from(V))}static{this.e=new p.$Y(()=>Object.keys(xe.c.value).filter(V=>!V.startsWith("_")))}static getLocales(){return xe.e.value}constructor(V){this.f=V}isAmbiguous(V){return this.f.has(V)}containsAmbiguousCharacter(V){for(let Y=0;Y<V.length;Y++){const te=V.codePointAt(Y);if(typeof te=="number"&&this.isAmbiguous(te))return!0}return!1}getPrimaryConfusable(V){return this.f.get(V)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$hg=xe;class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(V){return Ge.e().has(V)}static containsInvisibleCharacter(V){for(let Y=0;Y<V.length;Y++){const te=V.codePointAt(Y);if(typeof te=="number"&&Ge.isInvisibleCharacter(te))return!0}return!1}static get codePoints(){return Ge.e()}}t.$ig=Ge});var Ce=this&&this.__createBinding||(Object.create?function(W,t,n,i){i===void 0&&(i=n);var p=Object.getOwnPropertyDescriptor(t,n);(!p||("get"in p?!t.__esModule:p.writable||p.configurable))&&(p={enumerable:!0,get:function(){return t[n]}}),Object.defineProperty(W,i,p)}:function(W,t,n,i){i===void 0&&(i=n),W[i]=t[n]}),Ke=this&&this.__setModuleDefault||(Object.create?function(W,t){Object.defineProperty(W,"default",{enumerable:!0,value:t})}:function(W,t){W.default=t}),De=this&&this.__importStar||function(W){if(W&&W.__esModule)return W;var t={};if(W!=null)for(var n in W)n!=="default"&&Object.prototype.hasOwnProperty.call(W,n)&&Ce(t,W,n);return Ke(t,W),t};ie(re[51],ue([0,1,6]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ej=t.$Cj=void 0,t.$yj=i,t.$zj=p,t.$Aj=m,t.$Bj=d,t.$Dj=l,n=De(n);function i(L){return p(L,0)}function p(L,N){switch(typeof L){case"object":return L===null?m(349,N):Array.isArray(L)?o(L,N):u(L,N);case"string":return d(L,N);case"boolean":return A(L,N);case"number":return m(L,N);case"undefined":return m(937,N);default:return m(617,N)}}function m(L,N){return(N<<5)-N+L|0}function A(L,N){return m(L?433:863,N)}function d(L,N){N=m(149417,N);for(let E=0,_=L.length;E<_;E++)N=m(L.charCodeAt(E),N);return N}function o(L,N){return N=m(104579,N),L.reduce((E,_)=>p(_,E),N)}function u(L,N){return N=m(181387,N),Object.keys(L).sort().reduce((E,_)=>(E=d(_,E),p(L[_],E)),N)}class h{constructor(){this.g=0}get value(){return this.g}hash(N){return this.g=p(N,this.g),this.g}}t.$Cj=h;var $;(function(L){L[L.BLOCK_SIZE=64]="BLOCK_SIZE",L[L.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})($||($={}));function b(L,N,E=32){const _=E-N,w=~((1<<_)-1);return(L<<N|(w&L)>>>_)>>>0}function c(L,N=0,E=L.byteLength,_=0){for(let w=0;w<E;w++)L[N+w]=_}function e(L,N,E="0"){for(;L.length<N;)L=E+L;return L}function l(L,N=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(E=>E.toString(16).padStart(2,"0")).join(""):e((L>>>0).toString(16),N/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array($.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(N){const E=N.length;if(E===0)return;const _=this.p;let w=this.r,a=this.u,s,f;for(a!==0?(s=a,f=-1,a=0):(s=N.charCodeAt(0),f=0);;){let v=s;if(n.$Of(s))if(f+1<E){const k=N.charCodeAt(f+1);n.$Pf(k)?(f++,v=n.$Qf(s,k)):v=$.UNICODE_REPLACEMENT}else{a=s;break}else n.$Pf(s)&&(v=$.UNICODE_REPLACEMENT);if(w=this.w(_,w,v),f++,f<E)s=N.charCodeAt(f);else break}this.r=w,this.u=a}w(N,E,_){return _<128?N[E++]=_:_<2048?(N[E++]=192|(_&1984)>>>6,N[E++]=128|(_&63)>>>0):_<65536?(N[E++]=224|(_&61440)>>>12,N[E++]=128|(_&4032)>>>6,N[E++]=128|(_&63)>>>0):(N[E++]=240|(_&1835008)>>>18,N[E++]=128|(_&258048)>>>12,N[E++]=128|(_&4032)>>>6,N[E++]=128|(_&63)>>>0),E>=$.BLOCK_SIZE&&(this.y(),E-=$.BLOCK_SIZE,this.t+=$.BLOCK_SIZE,N[0]=N[$.BLOCK_SIZE+0],N[1]=N[$.BLOCK_SIZE+1],N[2]=N[$.BLOCK_SIZE+2]),E}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,$.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),l(this.h)+l(this.l)+l(this.m)+l(this.n)+l(this.o)}x(){this.p[this.r++]=128,c(this.p,this.r),this.r>56&&(this.y(),c(this.p));const N=8*this.t;this.q.setUint32(56,Math.floor(N/4294967296),!1),this.q.setUint32(60,N%4294967296,!1),this.y()}y(){const N=g.g,E=this.q;for(let T=0;T<64;T+=4)N.setUint32(T,E.getUint32(T,!1),!1);for(let T=64;T<320;T+=4)N.setUint32(T,b(N.getUint32(T-12,!1)^N.getUint32(T-32,!1)^N.getUint32(T-56,!1)^N.getUint32(T-64,!1),1),!1);let _=this.h,w=this.l,a=this.m,s=this.n,f=this.o,v,k,R;for(let T=0;T<80;T++)T<20?(v=w&a|~w&s,k=1518500249):T<40?(v=w^a^s,k=1859775393):T<60?(v=w&a|w&s|a&s,k=2400959708):(v=w^a^s,k=3395469782),R=b(_,5)+v+f+k+N.getUint32(T*4,!1)&4294967295,f=s,s=a,a=b(w,30),w=_,_=R;this.h=this.h+_&4294967295,this.l=this.l+w&4294967295,this.m=this.m+a&4294967295,this.n=this.n+s&4294967295,this.o=this.o+f&4294967295}}t.$Ej=g}),ie(re[32],ue([0,1,44,51,16]),function(W,t,n,i,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3t=t.$1t=void 0,t.$2t=A;class m{constructor(c){this.a=c}getElements(){const c=this.a,e=new Int32Array(c.length);for(let l=0,g=c.length;l<g;l++)e[l]=c.charCodeAt(l);return e}}t.$1t=m;function A(b,c,e){return new $(new m(b),new m(c)).ComputeDiff(e).changes}class d{static Assert(c,e){if(!c)throw new Error(e)}}class o{static Copy(c,e,l,g,L){for(let N=0;N<L;N++)l[g+N]=c[e+N]}static Copy2(c,e,l,g,L){for(let N=0;N<L;N++)l[g+N]=c[e+N]}}var u;(function(b){b[b.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class h{constructor(){this.a=[],this.b=p.Constants.MAX_SAFE_SMALL_INTEGER,this.c=p.Constants.MAX_SAFE_SMALL_INTEGER,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new n.$Zt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=p.Constants.MAX_SAFE_SMALL_INTEGER,this.c=p.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(c,e){this.b=Math.min(this.b,c),this.c=Math.min(this.c,e),this.d++}AddModifiedElement(c,e){this.b=Math.min(this.b,c),this.c=Math.min(this.c,e),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class ${constructor(c,e,l=null){this.a=l,this.b=c,this.c=e;const[g,L,N]=$.o(c),[E,_,w]=$.o(e);this.d=N&&w,this.e=g,this.f=L,this.g=E,this.h=_,this.k=[],this.m=[]}static n(c){return c.length>0&&typeof c[0]=="string"}static o(c){const e=c.getElements();if($.n(e)){const l=new Int32Array(e.length);for(let g=0,L=e.length;g<L;g++)l[g]=(0,i.$Bj)(e[g],0);return[e,l,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}p(c,e){return this.f[c]!==this.h[e]?!1:this.d?this.e[c]===this.g[e]:!0}q(c,e){if(!this.p(c,e))return!1;const l=$.r(this.b,c),g=$.r(this.c,e);return l===g}static r(c,e){return typeof c.getStrictElement=="function"?c.getStrictElement(e):null}s(c,e){return this.f[c]!==this.f[e]?!1:this.d?this.e[c]===this.e[e]:!0}u(c,e){return this.h[c]!==this.h[e]?!1:this.d?this.g[c]===this.g[e]:!0}ComputeDiff(c){return this.v(0,this.f.length-1,0,this.h.length-1,c)}v(c,e,l,g,L){const N=[!1];let E=this.w(c,e,l,g,N);return L&&(E=this.z(E)),{quitEarly:N[0],changes:E}}w(c,e,l,g,L){for(L[0]=!1;c<=e&&l<=g&&this.p(c,l);)c++,l++;for(;e>=c&&g>=l&&this.p(e,g);)e--,g--;if(c>e||l>g){let s;return l<=g?(d.Assert(c===e+1,"originalStart should only be one more than originalEnd"),s=[new n.$Zt(c,0,l,g-l+1)]):c<=e?(d.Assert(l===g+1,"modifiedStart should only be one more than modifiedEnd"),s=[new n.$Zt(c,e-c+1,l,0)]):(d.Assert(c===e+1,"originalStart should only be one more than originalEnd"),d.Assert(l===g+1,"modifiedStart should only be one more than modifiedEnd"),s=[]),s}const N=[0],E=[0],_=this.y(c,e,l,g,N,E,L),w=N[0],a=E[0];if(_!==null)return _;if(!L[0]){const s=this.w(c,w,l,a,L);let f=[];return L[0]?f=[new n.$Zt(w+1,e-(w+1)+1,a+1,g-(a+1)+1)]:f=this.w(w+1,e,a+1,g,L),this.H(s,f)}return[new n.$Zt(c,e-c+1,l,g-l+1)]}x(c,e,l,g,L,N,E,_,w,a,s,f,v,k,R,T,j,M){let D=null,F=null,y=new h,B=e,z=l,H=v[0]-T[0]-g,U=p.Constants.MIN_SAFE_SMALL_INTEGER,C=this.k.length-1;do{const ee=H+c;ee===B||ee<z&&w[ee-1]<w[ee+1]?(s=w[ee+1],k=s-H-g,s<U&&y.MarkNextChange(),U=s,y.AddModifiedElement(s+1,k),H=ee+1-c):(s=w[ee-1]+1,k=s-H-g,s<U&&y.MarkNextChange(),U=s-1,y.AddOriginalElement(s,k+1),H=ee-1-c),C>=0&&(w=this.k[C],c=w[0],B=1,z=w.length-1)}while(--C>=-1);if(D=y.getReverseChanges(),M[0]){let ee=v[0]+1,J=T[0]+1;if(D!==null&&D.length>0){const K=D[D.length-1];ee=Math.max(ee,K.getOriginalEnd()),J=Math.max(J,K.getModifiedEnd())}F=[new n.$Zt(ee,f-ee+1,J,R-J+1)]}else{y=new h,B=N,z=E,H=v[0]-T[0]-_,U=p.Constants.MAX_SAFE_SMALL_INTEGER,C=j?this.m.length-1:this.m.length-2;do{const ee=H+L;ee===B||ee<z&&a[ee-1]>=a[ee+1]?(s=a[ee+1]-1,k=s-H-_,s>U&&y.MarkNextChange(),U=s+1,y.AddOriginalElement(s+1,k+1),H=ee+1-L):(s=a[ee-1],k=s-H-_,s>U&&y.MarkNextChange(),U=s,y.AddModifiedElement(s+1,k+1),H=ee-1-L),C>=0&&(a=this.m[C],L=a[0],B=1,z=a.length-1)}while(--C>=-1);F=y.getChanges()}return this.H(D,F)}y(c,e,l,g,L,N,E){let _=0,w=0,a=0,s=0,f=0,v=0;c--,l--,L[0]=0,N[0]=0,this.k=[],this.m=[];const k=e-c+(g-l),R=k+1,T=new Int32Array(R),j=new Int32Array(R),M=g-l,D=e-c,F=c-l,y=e-g,z=(D-M)%2===0;T[M]=c,j[D]=e,E[0]=!1;for(let H=1;H<=k/2+1;H++){let U=0,C=0;a=this.J(M-H,H,M,R),s=this.J(M+H,H,M,R);for(let J=a;J<=s;J+=2){J===a||J<s&&T[J-1]<T[J+1]?_=T[J+1]:_=T[J-1]+1,w=_-(J-M)-F;const K=_;for(;_<e&&w<g&&this.p(_+1,w+1);)_++,w++;if(T[J]=_,_+w>U+C&&(U=_,C=w),!z&&Math.abs(J-D)<=H-1&&_>=j[J])return L[0]=_,N[0]=w,K<=j[J]&&u.MaxDifferencesHistory>0&&H<=u.MaxDifferencesHistory+1?this.x(M,a,s,F,D,f,v,y,T,j,_,e,L,w,g,N,z,E):null}const ee=(U-c+(C-l)-H)/2;if(this.a!==null&&!this.a(U,ee))return E[0]=!0,L[0]=U,N[0]=C,ee>0&&u.MaxDifferencesHistory>0&&H<=u.MaxDifferencesHistory+1?this.x(M,a,s,F,D,f,v,y,T,j,_,e,L,w,g,N,z,E):(c++,l++,[new n.$Zt(c,e-c+1,l,g-l+1)]);f=this.J(D-H,H,D,R),v=this.J(D+H,H,D,R);for(let J=f;J<=v;J+=2){J===f||J<v&&j[J-1]>=j[J+1]?_=j[J+1]-1:_=j[J-1],w=_-(J-D)-y;const K=_;for(;_>c&&w>l&&this.p(_,w);)_--,w--;if(j[J]=_,z&&Math.abs(J-M)<=H&&_<=T[J])return L[0]=_,N[0]=w,K>=T[J]&&u.MaxDifferencesHistory>0&&H<=u.MaxDifferencesHistory+1?this.x(M,a,s,F,D,f,v,y,T,j,_,e,L,w,g,N,z,E):null}if(H<=u.MaxDifferencesHistory){let J=new Int32Array(s-a+2);J[0]=M-a+1,o.Copy2(T,a,J,1,s-a+1),this.k.push(J),J=new Int32Array(v-f+2),J[0]=D-f+1,o.Copy2(j,f,J,1,v-f+1),this.m.push(J)}}return this.x(M,a,s,F,D,f,v,y,T,j,_,e,L,w,g,N,z,E)}z(c){for(let e=0;e<c.length;e++){const l=c[e],g=e<c.length-1?c[e+1].originalStart:this.f.length,L=e<c.length-1?c[e+1].modifiedStart:this.h.length,N=l.originalLength>0,E=l.modifiedLength>0;for(;l.originalStart+l.originalLength<g&&l.modifiedStart+l.modifiedLength<L&&(!N||this.s(l.originalStart,l.originalStart+l.originalLength))&&(!E||this.u(l.modifiedStart,l.modifiedStart+l.modifiedLength));){const w=this.q(l.originalStart,l.modifiedStart);if(this.q(l.originalStart+l.originalLength,l.modifiedStart+l.modifiedLength)&&!w)break;l.originalStart++,l.modifiedStart++}const _=[null];if(e<c.length-1&&this.I(c[e],c[e+1],_)){c[e]=_[0],c.splice(e+1,1),e--;continue}}for(let e=c.length-1;e>=0;e--){const l=c[e];let g=0,L=0;if(e>0){const s=c[e-1];g=s.originalStart+s.originalLength,L=s.modifiedStart+s.modifiedLength}const N=l.originalLength>0,E=l.modifiedLength>0;let _=0,w=this.G(l.originalStart,l.originalLength,l.modifiedStart,l.modifiedLength);for(let s=1;;s++){const f=l.originalStart-s,v=l.modifiedStart-s;if(f<g||v<L||N&&!this.s(f,f+l.originalLength)||E&&!this.u(v,v+l.modifiedLength))break;const R=(f===g&&v===L?5:0)+this.G(f,l.originalLength,v,l.modifiedLength);R>w&&(w=R,_=s)}l.originalStart-=_,l.modifiedStart-=_;const a=[null];if(e>0&&this.I(c[e-1],c[e],a)){c[e-1]=a[0],c.splice(e,1),e++;continue}}if(this.d)for(let e=1,l=c.length;e<l;e++){const g=c[e-1],L=c[e],N=L.originalStart-g.originalStart-g.originalLength,E=g.originalStart,_=L.originalStart+L.originalLength,w=_-E,a=g.modifiedStart,s=L.modifiedStart+L.modifiedLength,f=s-a;if(N<5&&w<20&&f<20){const v=this.A(E,w,a,f,N);if(v){const[k,R]=v;(k!==g.originalStart+g.originalLength||R!==g.modifiedStart+g.modifiedLength)&&(g.originalLength=k-g.originalStart,g.modifiedLength=R-g.modifiedStart,L.originalStart=k+N,L.modifiedStart=R+N,L.originalLength=_-L.originalStart,L.modifiedLength=s-L.modifiedStart)}}}return c}A(c,e,l,g,L){if(e<L||g<L)return null;const N=c+e-L+1,E=l+g-L+1;let _=0,w=0,a=0;for(let s=c;s<N;s++)for(let f=l;f<E;f++){const v=this.B(s,f,L);v>0&&v>_&&(_=v,w=s,a=f)}return _>0?[w,a]:null}B(c,e,l){let g=0;for(let L=0;L<l;L++){if(!this.p(c+L,e+L))return 0;g+=this.e[c+L].length}return g}C(c){return c<=0||c>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[c])}D(c,e){if(this.C(c)||this.C(c-1))return!0;if(e>0){const l=c+e;if(this.C(l-1)||this.C(l))return!0}return!1}E(c){return c<=0||c>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[c])}F(c,e){if(this.E(c)||this.E(c-1))return!0;if(e>0){const l=c+e;if(this.E(l-1)||this.E(l))return!0}return!1}G(c,e,l,g){const L=this.D(c,e)?1:0,N=this.F(l,g)?1:0;return L+N}H(c,e){const l=[];if(c.length===0||e.length===0)return e.length>0?e:c;if(this.I(c[c.length-1],e[0],l)){const g=new Array(c.length+e.length-1);return o.Copy(c,0,g,0,c.length-1),g[c.length-1]=l[0],o.Copy(e,1,g,c.length,e.length-1),g}else{const g=new Array(c.length+e.length);return o.Copy(c,0,g,0,c.length),o.Copy(e,0,g,c.length,e.length),g}}I(c,e,l){if(d.Assert(c.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),d.Assert(c.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),c.originalStart+c.originalLength>=e.originalStart||c.modifiedStart+c.modifiedLength>=e.modifiedStart){const g=c.originalStart;let L=c.originalLength;const N=c.modifiedStart;let E=c.modifiedLength;return c.originalStart+c.originalLength>=e.originalStart&&(L=e.originalStart+e.originalLength-c.originalStart),c.modifiedStart+c.modifiedLength>=e.modifiedStart&&(E=e.modifiedStart+e.modifiedLength-c.modifiedStart),l[0]=new n.$Zt(g,L,N,E),!0}else return l[0]=null,!1}J(c,e,l,g){if(c>=0&&c<g)return c;const L=l,N=g-l-1,E=e%2===0;if(c<0){const _=L%2===0;return E===_?0:1}else{const _=N%2===0;return E===_?g-1:g-2}}}t.$3t=$}),ie(re[33],ue([0,1,16]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qu=t.$pu=void 0;class i{constructor(d){const o=(0,n.$ff)(d);this.c=o,this.a=i.d(o),this.b=new Map}static d(d){const o=new Uint8Array(256);return o.fill(d),o}set(d,o){const u=(0,n.$ff)(o);d>=0&&d<256?this.a[d]=u:this.b.set(d,u)}get(d){return d>=0&&d<256?this.a[d]:this.b.get(d)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$pu=i;var p;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(p||(p={}));class m{constructor(){this.a=new i(p.False)}add(d){this.a.set(d,p.True)}has(d){return this.a.get(d)===p.True}clear(){return this.a.clear()}}t.$qu=m}),ie(re[7],ue([0,1,4]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5t=t.$4t=void 0;class i{static addRange(A,d){let o=0;for(;o<d.length&&d[o].endExclusive<A.start;)o++;let u=o;for(;u<d.length&&d[u].start<=A.endExclusive;)u++;if(o===u)d.splice(o,0,A);else{const h=Math.min(A.start,d[o].start),$=Math.max(A.endExclusive,d[u-1].endExclusive);d.splice(o,u-o,new i(h,$))}}static tryCreate(A,d){if(!(A>d))return new i(A,d)}static ofLength(A){return new i(0,A)}static ofStartAndLength(A,d){return new i(A,A+d)}constructor(A,d){if(this.start=A,this.endExclusive=d,A>d)throw new n.$gb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(A){return new i(this.start+A,this.endExclusive+A)}deltaStart(A){return new i(this.start+A,this.endExclusive)}deltaEnd(A){return new i(this.start,this.endExclusive+A)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(A){return this.start===A.start&&this.endExclusive===A.endExclusive}containsRange(A){return this.start<=A.start&&A.endExclusive<=this.endExclusive}contains(A){return this.start<=A&&A<this.endExclusive}join(A){return new i(Math.min(this.start,A.start),Math.max(this.endExclusive,A.endExclusive))}intersect(A){const d=Math.max(this.start,A.start),o=Math.min(this.endExclusive,A.endExclusive);if(d<=o)return new i(d,o)}intersects(A){const d=Math.max(this.start,A.start),o=Math.min(this.endExclusive,A.endExclusive);return d<o}intersectsOrTouches(A){const d=Math.max(this.start,A.start),o=Math.min(this.endExclusive,A.endExclusive);return d<=o}isBefore(A){return this.endExclusive<=A.start}isAfter(A){return this.start>=A.endExclusive}slice(A){return A.slice(this.start,this.endExclusive)}substring(A){return A.substring(this.start,this.endExclusive)}clip(A){if(this.isEmpty)throw new n.$gb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,A))}clipCyclic(A){if(this.isEmpty)throw new n.$gb(`Invalid clipping range: ${this.toString()}`);return A<this.start?this.endExclusive-(this.start-A)%this.length:A>=this.endExclusive?this.start+(A-this.start)%this.length:A}map(A){const d=[];for(let o=this.start;o<this.endExclusive;o++)d.push(A(o));return d}forEach(A){for(let d=this.start;d<this.endExclusive;d++)A(d)}}t.$4t=i;class p{constructor(){this.a=[]}addRange(A){let d=0;for(;d<this.a.length&&this.a[d].endExclusive<A.start;)d++;let o=d;for(;o<this.a.length&&this.a[o].start<=A.endExclusive;)o++;if(d===o)this.a.splice(d,0,A);else{const u=Math.min(A.start,this.a[d].start),h=Math.max(A.endExclusive,this.a[o-1].endExclusive);this.a.splice(d,o-d,new i(u,h))}}toString(){return this.a.map(A=>A.toString()).join(", ")}intersectsStrict(A){let d=0;for(;d<this.a.length&&this.a[d].endExclusive<=A.start;)d++;return d<this.a.length&&this.a[d].start<A.endExclusive}intersectWithRange(A){const d=new p;for(const o of this.a){const u=o.intersect(A);u&&d.addRange(u)}return d}intersectWithRangeLength(A){return this.intersectWithRange(A).length}get length(){return this.a.reduce((A,d)=>A+d.length,0)}}t.$5t=p}),ie(re[5],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vt=void 0;class n{constructor(p,m){this.lineNumber=p,this.column=m}with(p=this.lineNumber,m=this.column){return p===this.lineNumber&&m===this.column?this:new n(p,m)}delta(p=0,m=0){return this.with(this.lineNumber+p,this.column+m)}equals(p){return n.equals(this,p)}static equals(p,m){return!p&&!m?!0:!!p&&!!m&&p.lineNumber===m.lineNumber&&p.column===m.column}isBefore(p){return n.isBefore(this,p)}static isBefore(p,m){return p.lineNumber<m.lineNumber?!0:m.lineNumber<p.lineNumber?!1:p.column<m.column}isBeforeOrEqual(p){return n.isBeforeOrEqual(this,p)}static isBeforeOrEqual(p,m){return p.lineNumber<m.lineNumber?!0:m.lineNumber<p.lineNumber?!1:p.column<=m.column}static compare(p,m){const A=p.lineNumber|0,d=m.lineNumber|0;if(A===d){const o=p.column|0,u=m.column|0;return o-u}return A-d}clone(){return new n(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(p){return new n(p.lineNumber,p.column)}static isIPosition(p){return p&&typeof p.lineNumber=="number"&&typeof p.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$Vt=n}),ie(re[2],ue([0,1,5]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wt=void 0;class i{constructor(m,A,d,o){m>d||m===d&&A>o?(this.startLineNumber=d,this.startColumn=o,this.endLineNumber=m,this.endColumn=A):(this.startLineNumber=m,this.startColumn=A,this.endLineNumber=d,this.endColumn=o)}isEmpty(){return i.isEmpty(this)}static isEmpty(m){return m.startLineNumber===m.endLineNumber&&m.startColumn===m.endColumn}containsPosition(m){return i.containsPosition(this,m)}static containsPosition(m,A){return!(A.lineNumber<m.startLineNumber||A.lineNumber>m.endLineNumber||A.lineNumber===m.startLineNumber&&A.column<m.startColumn||A.lineNumber===m.endLineNumber&&A.column>m.endColumn)}static strictContainsPosition(m,A){return!(A.lineNumber<m.startLineNumber||A.lineNumber>m.endLineNumber||A.lineNumber===m.startLineNumber&&A.column<=m.startColumn||A.lineNumber===m.endLineNumber&&A.column>=m.endColumn)}containsRange(m){return i.containsRange(this,m)}static containsRange(m,A){return!(A.startLineNumber<m.startLineNumber||A.endLineNumber<m.startLineNumber||A.startLineNumber>m.endLineNumber||A.endLineNumber>m.endLineNumber||A.startLineNumber===m.startLineNumber&&A.startColumn<m.startColumn||A.endLineNumber===m.endLineNumber&&A.endColumn>m.endColumn)}strictContainsRange(m){return i.strictContainsRange(this,m)}static strictContainsRange(m,A){return!(A.startLineNumber<m.startLineNumber||A.endLineNumber<m.startLineNumber||A.startLineNumber>m.endLineNumber||A.endLineNumber>m.endLineNumber||A.startLineNumber===m.startLineNumber&&A.startColumn<=m.startColumn||A.endLineNumber===m.endLineNumber&&A.endColumn>=m.endColumn)}plusRange(m){return i.plusRange(this,m)}static plusRange(m,A){let d,o,u,h;return A.startLineNumber<m.startLineNumber?(d=A.startLineNumber,o=A.startColumn):A.startLineNumber===m.startLineNumber?(d=A.startLineNumber,o=Math.min(A.startColumn,m.startColumn)):(d=m.startLineNumber,o=m.startColumn),A.endLineNumber>m.endLineNumber?(u=A.endLineNumber,h=A.endColumn):A.endLineNumber===m.endLineNumber?(u=A.endLineNumber,h=Math.max(A.endColumn,m.endColumn)):(u=m.endLineNumber,h=m.endColumn),new i(d,o,u,h)}intersectRanges(m){return i.intersectRanges(this,m)}static intersectRanges(m,A){let d=m.startLineNumber,o=m.startColumn,u=m.endLineNumber,h=m.endColumn;const $=A.startLineNumber,b=A.startColumn,c=A.endLineNumber,e=A.endColumn;return d<$?(d=$,o=b):d===$&&(o=Math.max(o,b)),u>c?(u=c,h=e):u===c&&(h=Math.min(h,e)),d>u||d===u&&o>h?null:new i(d,o,u,h)}equalsRange(m){return i.equalsRange(this,m)}static equalsRange(m,A){return!m&&!A?!0:!!m&&!!A&&m.startLineNumber===A.startLineNumber&&m.startColumn===A.startColumn&&m.endLineNumber===A.endLineNumber&&m.endColumn===A.endColumn}getEndPosition(){return i.getEndPosition(this)}static getEndPosition(m){return new n.$Vt(m.endLineNumber,m.endColumn)}getStartPosition(){return i.getStartPosition(this)}static getStartPosition(m){return new n.$Vt(m.startLineNumber,m.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(m,A){return new i(this.startLineNumber,this.startColumn,m,A)}setStartPosition(m,A){return new i(m,A,this.endLineNumber,this.endColumn)}collapseToStart(){return i.collapseToStart(this)}static collapseToStart(m){return new i(m.startLineNumber,m.startColumn,m.startLineNumber,m.startColumn)}collapseToEnd(){return i.collapseToEnd(this)}static collapseToEnd(m){return new i(m.endLineNumber,m.endColumn,m.endLineNumber,m.endColumn)}delta(m){return new i(this.startLineNumber+m,this.startColumn,this.endLineNumber+m,this.endColumn)}static fromPositions(m,A=m){return new i(m.lineNumber,m.column,A.lineNumber,A.column)}static lift(m){return m?new i(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):null}static isIRange(m){return m&&typeof m.startLineNumber=="number"&&typeof m.startColumn=="number"&&typeof m.endLineNumber=="number"&&typeof m.endColumn=="number"}static areIntersectingOrTouching(m,A){return!(m.endLineNumber<A.startLineNumber||m.endLineNumber===A.startLineNumber&&m.endColumn<A.startColumn||A.endLineNumber<m.startLineNumber||A.endLineNumber===m.startLineNumber&&A.endColumn<m.startColumn)}static areIntersecting(m,A){return!(m.endLineNumber<A.startLineNumber||m.endLineNumber===A.startLineNumber&&m.endColumn<=A.startColumn||A.endLineNumber<m.startLineNumber||A.endLineNumber===m.startLineNumber&&A.endColumn<=m.startColumn)}static compareRangesUsingStarts(m,A){if(m&&A){const u=m.startLineNumber|0,h=A.startLineNumber|0;if(u===h){const $=m.startColumn|0,b=A.startColumn|0;if($===b){const c=m.endLineNumber|0,e=A.endLineNumber|0;if(c===e){const l=m.endColumn|0,g=A.endColumn|0;return l-g}return c-e}return $-b}return u-h}return(m?1:0)-(A?1:0)}static compareRangesUsingEnds(m,A){return m.endLineNumber===A.endLineNumber?m.endColumn===A.endColumn?m.startLineNumber===A.startLineNumber?m.startColumn-A.startColumn:m.startLineNumber-A.startLineNumber:m.endColumn-A.endColumn:m.endLineNumber-A.endLineNumber}static spansMultipleLines(m){return m.endLineNumber>m.startLineNumber}toJSON(){return this}}t.$Wt=i}),ie(re[52],ue([0,1,2]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xt=void 0;class i{static insert(m,A){return{range:new n.$Wt(m.lineNumber,m.column,m.lineNumber,m.column),text:A,forceMoveMarkers:!0}}static delete(m){return{range:m,text:null}}static replace(m,A){return{range:m,text:A}}static replaceMove(m,A){return{range:m,text:A,forceMoveMarkers:!0}}}t.$Xt=i}),ie(re[17],ue([0,1,4,7,2,11]),function(W,t,n,i,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7t=t.$6t=void 0;class A{static fromRange(u){return new A(u.startLineNumber,u.endLineNumber)}static fromRangeInclusive(u){return new A(u.startLineNumber,u.endLineNumber+1)}static subtract(u,h){return h?u.startLineNumber<h.startLineNumber&&h.endLineNumberExclusive<u.endLineNumberExclusive?[new A(u.startLineNumber,h.startLineNumber),new A(h.endLineNumberExclusive,u.endLineNumberExclusive)]:h.startLineNumber<=u.startLineNumber&&u.endLineNumberExclusive<=h.endLineNumberExclusive?[]:h.endLineNumberExclusive<u.endLineNumberExclusive?[new A(Math.max(h.endLineNumberExclusive,u.startLineNumber),u.endLineNumberExclusive)]:[new A(u.startLineNumber,Math.min(h.startLineNumber,u.endLineNumberExclusive))]:[u]}static joinMany(u){if(u.length===0)return[];let h=new d(u[0].slice());for(let $=1;$<u.length;$++)h=h.getUnion(new d(u[$].slice()));return h.ranges}static join(u){if(u.length===0)throw new n.$gb("lineRanges cannot be empty");let h=u[0].startLineNumber,$=u[0].endLineNumberExclusive;for(let b=1;b<u.length;b++)h=Math.min(h,u[b].startLineNumber),$=Math.max($,u[b].endLineNumberExclusive);return new A(h,$)}static ofLength(u,h){return new A(u,u+h)}static deserialize(u){return new A(u[0],u[1])}constructor(u,h){if(u>h)throw new n.$gb(`startLineNumber ${u} cannot be after endLineNumberExclusive ${h}`);this.startLineNumber=u,this.endLineNumberExclusive=h}contains(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(u){return new A(this.startLineNumber+u,this.endLineNumberExclusive+u)}deltaLength(u){return new A(this.startLineNumber,this.endLineNumberExclusive+u)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(u){return new A(Math.min(this.startLineNumber,u.startLineNumber),Math.max(this.endLineNumberExclusive,u.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(u){const h=Math.max(this.startLineNumber,u.startLineNumber),$=Math.min(this.endLineNumberExclusive,u.endLineNumberExclusive);if(h<=$)return new A(h,$)}intersectsStrict(u){return this.startLineNumber<u.endLineNumberExclusive&&u.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(u){return this.startLineNumber<=u.endLineNumberExclusive&&u.startLineNumber<=this.endLineNumberExclusive}equals(u){return this.startLineNumber===u.startLineNumber&&this.endLineNumberExclusive===u.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new p.$Wt(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new p.$Wt(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(u){const h=[];for(let $=this.startLineNumber;$<this.endLineNumberExclusive;$++)h.push(u($));return h}forEach(u){for(let h=this.startLineNumber;h<this.endLineNumberExclusive;h++)u(h)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}toOffsetRange(){return new i.$4t(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$6t=A;class d{constructor(u=[]){this.c=u}get ranges(){return this.c}addRange(u){if(u.length===0)return;const h=(0,m.$ob)(this.c,b=>b.endLineNumberExclusive>=u.startLineNumber),$=(0,m.$mb)(this.c,b=>b.startLineNumber<=u.endLineNumberExclusive)+1;if(h===$)this.c.splice(h,0,u);else if(h===$-1){const b=this.c[h];this.c[h]=b.join(u)}else{const b=this.c[h].join(this.c[$-1]).join(u);this.c.splice(h,$-h,b)}}contains(u){const h=(0,m.$lb)(this.c,$=>$.startLineNumber<=u);return!!h&&h.endLineNumberExclusive>u}intersects(u){const h=(0,m.$lb)(this.c,$=>$.startLineNumber<u.endLineNumberExclusive);return!!h&&h.endLineNumberExclusive>u.startLineNumber}getUnion(u){if(this.c.length===0)return u;if(u.c.length===0)return this;const h=[];let $=0,b=0,c=null;for(;$<this.c.length||b<u.c.length;){let e=null;if($<this.c.length&&b<u.c.length){const l=this.c[$],g=u.c[b];l.startLineNumber<g.startLineNumber?(e=l,$++):(e=g,b++)}else $<this.c.length?(e=this.c[$],$++):(e=u.c[b],b++);c===null?c=e:c.endLineNumberExclusive>=e.startLineNumber?c=new A(c.startLineNumber,Math.max(c.endLineNumberExclusive,e.endLineNumberExclusive)):(h.push(c),c=e)}return c!==null&&h.push(c),new d(h)}subtractFrom(u){const h=(0,m.$ob)(this.c,e=>e.endLineNumberExclusive>=u.startLineNumber),$=(0,m.$mb)(this.c,e=>e.startLineNumber<=u.endLineNumberExclusive)+1;if(h===$)return new d([u]);const b=[];let c=u.startLineNumber;for(let e=h;e<$;e++){const l=this.c[e];l.startLineNumber>c&&b.push(new A(c,l.startLineNumber)),c=l.endLineNumberExclusive}return c<u.endLineNumberExclusive&&b.push(new A(c,u.endLineNumberExclusive)),new d(b)}toString(){return this.c.map(u=>u.toString()).join(", ")}getIntersection(u){const h=[];let $=0,b=0;for(;$<this.c.length&&b<u.c.length;){const c=this.c[$],e=u.c[b],l=c.intersect(e);l&&!l.isEmpty&&h.push(l),c.endLineNumberExclusive<e.endLineNumberExclusive?$++:b++}return new d(h)}getWithDelta(u){return new d(this.c.map(h=>h.delta(u)))}}t.$7t=d}),ie(re[53],ue([0,1,5,2]),function(W,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yt=t.SelectionDirection=void 0;var p;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(p||(t.SelectionDirection=p={}));class m extends i.$Wt{constructor(d,o,u,h){super(d,o,u,h),this.selectionStartLineNumber=d,this.selectionStartColumn=o,this.positionLineNumber=u,this.positionColumn=h}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return m.selectionsEqual(this,d)}static selectionsEqual(d,o){return d.selectionStartLineNumber===o.selectionStartLineNumber&&d.selectionStartColumn===o.selectionStartColumn&&d.positionLineNumber===o.positionLineNumber&&d.positionColumn===o.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?p.LTR:p.RTL}setEndPosition(d,o){return this.getDirection()===p.LTR?new m(this.startLineNumber,this.startColumn,d,o):new m(d,o,this.startLineNumber,this.startColumn)}getPosition(){return new n.$Vt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new n.$Vt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(d,o){return this.getDirection()===p.LTR?new m(d,o,this.endLineNumber,this.endColumn):new m(this.endLineNumber,this.endColumn,d,o)}static fromPositions(d,o=d){return new m(d.lineNumber,d.column,o.lineNumber,o.column)}static fromRange(d,o){return o===p.LTR?new m(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):new m(d.endLineNumber,d.endColumn,d.startLineNumber,d.startColumn)}static liftSelection(d){return new m(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,o){if(d&&!o||!d&&o)return!1;if(!d&&!o)return!0;if(d.length!==o.length)return!1;for(let u=0,h=d.length;u<h;u++)if(!this.selectionsEqual(d[u],o[u]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,o,u,h,$){return $===p.LTR?new m(d,o,u,h):new m(u,h,d,o)}}t.$Yt=m}),ie(re[34],ue([0,1,5,2]),function(W,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8t=void 0;class p{static{this.zero=new p(0,0)}static lengthDiffNonNegative(A,d){return d.isLessThan(A)?p.zero:A.lineCount===d.lineCount?new p(0,d.columnCount-A.columnCount):new p(d.lineCount-A.lineCount,d.columnCount)}static betweenPositions(A,d){return A.lineNumber===d.lineNumber?new p(0,d.column-A.column):new p(d.lineNumber-A.lineNumber,d.column-1)}static ofRange(A){return p.betweenPositions(A.getStartPosition(),A.getEndPosition())}static ofText(A){let d=0,o=0;for(const u of A)u===`
`?(d++,o=0):o++;return new p(d,o)}constructor(A,d){this.lineCount=A,this.columnCount=d}isZero(){return this.lineCount===0&&this.columnCount===0}isLessThan(A){return this.lineCount!==A.lineCount?this.lineCount<A.lineCount:this.columnCount<A.columnCount}isGreaterThan(A){return this.lineCount!==A.lineCount?this.lineCount>A.lineCount:this.columnCount>A.columnCount}isGreaterThanOrEqualTo(A){return this.lineCount!==A.lineCount?this.lineCount>A.lineCount:this.columnCount>=A.columnCount}equals(A){return this.lineCount===A.lineCount&&this.columnCount===A.columnCount}compare(A){return this.lineCount!==A.lineCount?this.lineCount-A.lineCount:this.columnCount-A.columnCount}add(A){return A.lineCount===0?new p(this.lineCount,this.columnCount+A.columnCount):new p(this.lineCount+A.lineCount,A.columnCount)}createRange(A){return this.lineCount===0?new i.$Wt(A.lineNumber,A.column,A.lineNumber,A.column+this.columnCount):new i.$Wt(A.lineNumber,A.column,A.lineNumber+this.lineCount,this.columnCount+1)}toRange(){return new i.$Wt(1,1,this.lineCount+1,this.columnCount+1)}addToPosition(A){return this.lineCount===0?new n.$Vt(A.lineNumber,A.column+this.columnCount):new n.$Vt(A.lineNumber+this.lineCount,this.columnCount+1)}toString(){return`${this.lineCount},${this.columnCount}`}}t.$8t=p}),ie(re[54],ue([0,1,11,7,5,2,34]),function(W,t,n,i,p,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9t=void 0;class d{constructor(u){this.text=u,this.a=[],this.a.push(0);for(let h=0;h<u.length;h++)u.charAt(h)===`
`&&this.a.push(h+1)}getOffset(u){return this.a[u.lineNumber-1]+u.column-1}getOffsetRange(u){return new i.$4t(this.getOffset(u.getStartPosition()),this.getOffset(u.getEndPosition()))}getPosition(u){const h=(0,n.$mb)(this.a,c=>c<=u),$=h+1,b=u-this.a[h]+1;return new p.$Vt($,b)}getRange(u){return m.$Wt.fromPositions(this.getPosition(u.start),this.getPosition(u.endExclusive))}getTextLength(u){return A.$8t.ofRange(this.getRange(u))}get textLength(){const u=this.a.length-1;return new A.$8t(u,this.text.length-this.a[u])}}t.$9t=d}),ie(re[55],ue([0,1,15,4,5,54,2,34]),function(W,t,n,i,p,m,A,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cu=t.$bu=t.$au=t.$_t=t.$$t=t.$0t=void 0;class o{static single(g,L){return new o([new u(g,L)])}constructor(g){this.edits=g,(0,n.$md)(()=>(0,n.$nd)(g,(L,N)=>L.range.getEndPosition().isBeforeOrEqual(N.range.getStartPosition())))}normalize(){const g=[];for(const L of this.edits)if(g.length>0&&g[g.length-1].range.getEndPosition().equals(L.range.getStartPosition())){const N=g[g.length-1];g[g.length-1]=new u(N.range.plusRange(L.range),N.text+L.text)}else L.isEmpty||g.push(L);return new o(g)}mapPosition(g){let L=0,N=0,E=0;for(const _ of this.edits){const w=_.range.getStartPosition(),a=_.range.getEndPosition();if(g.isBeforeOrEqual(w))break;const s=d.$8t.ofText(_.text);if(g.isBefore(a)){const f=new p.$Vt(w.lineNumber+L,w.column+(w.lineNumber+L===N?E:0)),v=s.addToPosition(f);return h(f,v)}L+=s.lineCount-(_.range.endLineNumber-_.range.startLineNumber),s.lineCount===0?a.lineNumber!==w.lineNumber?E+=s.columnCount-(a.column-1):E+=s.columnCount-(a.column-w.column):E=s.columnCount,N=a.lineNumber+L}return new p.$Vt(g.lineNumber+L,g.column+(g.lineNumber+L===N?E:0))}mapRange(g){function L(w){return w instanceof p.$Vt?w:w.getStartPosition()}function N(w){return w instanceof p.$Vt?w:w.getEndPosition()}const E=L(this.mapPosition(g.getStartPosition())),_=N(this.mapPosition(g.getEndPosition()));return h(E,_)}inverseMapPosition(g,L){return this.inverse(L).mapPosition(g)}inverseMapRange(g,L){return this.inverse(L).mapRange(g)}apply(g){let L="",N=new p.$Vt(1,1);for(const _ of this.edits){const w=_.range,a=w.getStartPosition(),s=w.getEndPosition(),f=h(N,a);f.isEmpty()||(L+=g.getValueOfRange(f)),L+=_.text,N=s}const E=h(N,g.endPositionExclusive);return E.isEmpty()||(L+=g.getValueOfRange(E)),L}applyToString(g){const L=new e(g);return this.apply(L)}inverse(g){const L=this.getNewRanges();return new o(this.edits.map((N,E)=>new u(L[E],g.getValueOfRange(N.range))))}getNewRanges(){const g=[];let L=0,N=0,E=0;for(const _ of this.edits){const w=d.$8t.ofText(_.text),a=p.$Vt.lift({lineNumber:_.range.startLineNumber+N,column:_.range.startColumn+(_.range.startLineNumber===L?E:0)}),s=w.createRange(a);g.push(s),N=s.endLineNumber-_.range.endLineNumber,E=s.endColumn-_.range.endColumn,L=_.range.endLineNumber}return g}}t.$0t=o;class u{constructor(g,L){this.range=g,this.text=L}get isEmpty(){return this.range.isEmpty()&&this.text.length===0}static equals(g,L){return g.range.equalsRange(L.range)&&g.text===L.text}toSingleEditOperation(){return{range:this.range,text:this.text}}}t.$$t=u;function h(l,g){if(l.lineNumber===g.lineNumber&&l.column===Number.MAX_SAFE_INTEGER)return A.$Wt.fromPositions(g,g);if(!l.isBeforeOrEqual(g))throw new i.$gb("start must be before end");return new A.$Wt(l.lineNumber,l.column,g.lineNumber,g.column)}class ${get endPositionExclusive(){return this.length.addToPosition(new p.$Vt(1,1))}getValue(){return this.getValueOfRange(this.length.toRange())}}t.$_t=$;class b extends ${constructor(g,L){(0,n.$kd)(L>=1),super(),this.c=g,this.d=L}getValueOfRange(g){if(g.startLineNumber===g.endLineNumber)return this.c(g.startLineNumber).substring(g.startColumn-1,g.endColumn-1);let L=this.c(g.startLineNumber).substring(g.startColumn-1);for(let N=g.startLineNumber+1;N<g.endLineNumber;N++)L+=`
`+this.c(N);return L+=`
`+this.c(g.endLineNumber).substring(0,g.endColumn-1),L}get length(){const g=this.c(this.d);return new d.$8t(this.d-1,g.length)}}t.$au=b;class c extends b{constructor(g){super(L=>g[L-1],g.length)}}t.$bu=c;class e extends ${constructor(g){super(),this.value=g,this.c=new m.$9t(this.value)}getValueOfRange(g){return this.c.getOffsetRange(g).substring(this.value)}get length(){return this.c.textLength}}t.$cu=e}),ie(re[56],ue([0,1,3,19,33]),function(W,t,n,i,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ru=t.WordCharacterClass=void 0,t.$su=o;var m;(function(u){u[u.Regular=0]="Regular",u[u.Whitespace=1]="Whitespace",u[u.WordSeparator=2]="WordSeparator"})(m||(t.WordCharacterClass=m={}));class A extends p.$pu{constructor(h,$){super(m.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=$,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let b=0,c=h.length;b<c;b++)this.set(h.charCodeAt(b),m.WordSeparator);this.set(n.CharCode.Space,m.Whitespace),this.set(n.CharCode.Tab,m.Whitespace)}findPrevIntlWordBeforeOrAtOffset(h,$){let b=null;for(const c of this.h(h)){if(c.index>$)break;b=c}return b}findNextIntlWordAtOrAfterOffset(h,$){for(const b of this.h(h))if(!(b.index<$))return b;return null}h(h){return this.e?this.f===h?this.g:(this.f=h,this.g=this.j(this.e.segment(h)),this.g):[]}j(h){const $=[];for(const b of h)this.k(b)&&$.push(b);return $}k(h){return!!h.isWordLike}}t.$ru=A;const d=new i.$Ic(10);function o(u,h){const $=`${u}/${h.join(",")}`;let b=d.get($);return b||(b=new A(u,h),d.set($,b)),b}}),ie(re[35],ue([0,1,26,10,28]),function(W,t,n,i,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vt=t.$ut=void 0,t.$wt=A,t.$xt=o,t.$yt=u,t.$ut="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m($=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const c of t.$ut)$.indexOf(c)>=0||(b+="\\"+c);return b+="\\s]+)",new RegExp(b,"g")}t.$vt=m();function A($){let b=t.$vt;if($&&$ instanceof RegExp)if($.global)b=$;else{let c="g";$.ignoreCase&&(c+="i"),$.multiline&&(c+="m"),$.unicode&&(c+="u"),b=new RegExp($.source,c)}return b.lastIndex=0,b}const d=new p.$0c;d.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function o($){const b=d.unshift($);return(0,i.$Xc)(b)}function u($,b,c,e,l){if(b=A(b),l||(l=n.Iterable.first(d)),c.length>l.maxLen){let _=$-l.maxLen/2;return _<0?_=0:e+=_,c=c.substring(_,$+l.maxLen/2),u($,b,c,e,l)}const g=Date.now(),L=$-1-e;let N=-1,E=null;for(let _=1;!(Date.now()-g>=l.timeBudget);_++){const w=L-l.windowSize*_;b.lastIndex=Math.max(0,w);const a=h(b,c,L,N);if(!a&&E||(E=a,w<=0))break;N=w}if(E){const _={word:E[0],startColumn:e+1+E.index,endColumn:e+1+E.index+E[0].length};return b.lastIndex=0,_}return null}function h($,b,c,e){let l;for(;l=$.exec(b);){const g=l.index||0;if(g<=c&&$.lastIndex>=c)return l;if(e>0&&g>e)return null}return null}}),ie(re[13],ue([0,1,9,4,7]),function(W,t,n,i,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$i5=t.$h5=t.$g5=t.$f5=t.$e5=void 0;class m{static trivial($,b){return new m([new A(p.$4t.ofLength($.length),p.$4t.ofLength(b.length))],!1)}static trivialTimedOut($,b){return new m([new A(p.$4t.ofLength($.length),p.$4t.ofLength(b.length))],!0)}constructor($,b){this.diffs=$,this.hitTimeout=b}}t.$e5=m;class A{static invert($,b){const c=[];return(0,n.$Fb)($,(e,l)=>{c.push(A.fromOffsetPairs(e?e.getEndExclusives():d.zero,l?l.getStarts():new d(b,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+b)))}),c}static fromOffsetPairs($,b){return new A(new p.$4t($.offset1,b.offset1),new p.$4t($.offset2,b.offset2))}static assertSorted($){let b;for(const c of $){if(b&&!(b.seq1Range.endExclusive<=c.seq1Range.start&&b.seq2Range.endExclusive<=c.seq2Range.start))throw new i.$gb("Sequence diffs must be sorted");b=c}}constructor($,b){this.seq1Range=$,this.seq2Range=b}swap(){return new A(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join($){return new A(this.seq1Range.join($.seq1Range),this.seq2Range.join($.seq2Range))}delta($){return $===0?this:new A(this.seq1Range.delta($),this.seq2Range.delta($))}deltaStart($){return $===0?this:new A(this.seq1Range.deltaStart($),this.seq2Range.deltaStart($))}deltaEnd($){return $===0?this:new A(this.seq1Range.deltaEnd($),this.seq2Range.deltaEnd($))}intersectsOrTouches($){return this.seq1Range.intersectsOrTouches($.seq1Range)||this.seq2Range.intersectsOrTouches($.seq2Range)}intersect($){const b=this.seq1Range.intersect($.seq1Range),c=this.seq2Range.intersect($.seq2Range);if(!(!b||!c))return new A(b,c)}getStarts(){return new d(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new d(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$f5=A;class d{static{this.zero=new d(0,0)}static{this.max=new d(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor($,b){this.offset1=$,this.offset2=b}toString(){return`${this.offset1} <-> ${this.offset2}`}delta($){return $===0?this:new d(this.offset1+$,this.offset2+$)}equals($){return this.offset1===$.offset1&&this.offset2===$.offset2}}t.$g5=d;class o{static{this.instance=new o}isValid(){return!0}}t.$h5=o;class u{constructor($){if(this.e=$,this.c=Date.now(),this.d=!0,$<=0)throw new i.$gb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$i5=u}),ie(re[36],ue([0,1,7,13]),function(W,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$n5=void 0;class p{compute(u,h,$=i.$h5.instance){if(u.length===0||h.length===0)return i.$e5.trivial(u,h);const b=u,c=h;function e(s,f){for(;s<b.length&&f<c.length&&b.getElement(s)===c.getElement(f);)s++,f++;return s}let l=0;const g=new A;g.set(0,e(0,0));const L=new d;L.set(0,g.get(0)===0?null:new m(null,0,0,g.get(0)));let N=0;e:for(;;){if(l++,!$.isValid())return i.$e5.trivialTimedOut(b,c);const s=-Math.min(l,c.length+l%2),f=Math.min(l,b.length+l%2);for(N=s;N<=f;N+=2){let v=0;const k=N===f?-1:g.get(N+1),R=N===s?-1:g.get(N-1)+1;v++;const T=Math.min(Math.max(k,R),b.length),j=T-N;if(v++,T>b.length||j>c.length)continue;const M=e(T,j);g.set(N,M);const D=T===k?L.get(N+1):L.get(N-1);if(L.set(N,M!==T?new m(D,T,j,M-T):D),g.get(N)===b.length&&g.get(N)-N===c.length)break e}}let E=L.get(N);const _=[];let w=b.length,a=c.length;for(;;){const s=E?E.x+E.length:0,f=E?E.y+E.length:0;if((s!==w||f!==a)&&_.push(new i.$f5(new n.$4t(s,w),new n.$4t(f,a))),!E)break;w=E.x,a=E.y,E=E.prev}return _.reverse(),new i.$e5(_,!1)}}t.$n5=p;class m{constructor(u,h,$,b){this.prev=u,this.x=h,this.y=$,this.length=b}}class A{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,h){if(u<0){if(u=-u-1,u>=this.b.length){const $=this.b;this.b=new Int32Array($.length*2),this.b.set($)}this.b[u]=h}else{if(u>=this.a.length){const $=this.a;this.a=new Int32Array($.length*2),this.a.set($)}this.a[u]=h}}}class d{constructor(){this.a=[],this.b=[]}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,h){u<0?(u=-u-1,this.b[u]=h):this.a[u]=h}}}),ie(re[57],ue([0,1,9,7,13]),function(W,t,n,i,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$r5=m,t.$s5=u,t.$t5=h,t.$u5=b,t.$v5=c;function m(e,l,g){let L=g;return L=A(e,l,L),L=A(e,l,L),L=d(e,l,L),L}function A(e,l,g){if(g.length===0)return g;const L=[];L.push(g[0]);for(let E=1;E<g.length;E++){const _=L[L.length-1];let w=g[E];if(w.seq1Range.isEmpty||w.seq2Range.isEmpty){const a=w.seq1Range.start-_.seq1Range.endExclusive;let s;for(s=1;s<=a&&!(e.getElement(w.seq1Range.start-s)!==e.getElement(w.seq1Range.endExclusive-s)||l.getElement(w.seq2Range.start-s)!==l.getElement(w.seq2Range.endExclusive-s));s++);if(s--,s===a){L[L.length-1]=new p.$f5(new i.$4t(_.seq1Range.start,w.seq1Range.endExclusive-a),new i.$4t(_.seq2Range.start,w.seq2Range.endExclusive-a));continue}w=w.delta(-s)}L.push(w)}const N=[];for(let E=0;E<L.length-1;E++){const _=L[E+1];let w=L[E];if(w.seq1Range.isEmpty||w.seq2Range.isEmpty){const a=_.seq1Range.start-w.seq1Range.endExclusive;let s;for(s=0;s<a&&!(!e.isStronglyEqual(w.seq1Range.start+s,w.seq1Range.endExclusive+s)||!l.isStronglyEqual(w.seq2Range.start+s,w.seq2Range.endExclusive+s));s++);if(s===a){L[E+1]=new p.$f5(new i.$4t(w.seq1Range.start+a,_.seq1Range.endExclusive),new i.$4t(w.seq2Range.start+a,_.seq2Range.endExclusive));continue}s>0&&(w=w.delta(s))}N.push(w)}return L.length>0&&N.push(L[L.length-1]),N}function d(e,l,g){if(!e.getBoundaryScore||!l.getBoundaryScore)return g;for(let L=0;L<g.length;L++){const N=L>0?g[L-1]:void 0,E=g[L],_=L+1<g.length?g[L+1]:void 0,w=new i.$4t(N?N.seq1Range.endExclusive+1:0,_?_.seq1Range.start-1:e.length),a=new i.$4t(N?N.seq2Range.endExclusive+1:0,_?_.seq2Range.start-1:l.length);E.seq1Range.isEmpty?g[L]=o(E,e,l,w,a):E.seq2Range.isEmpty&&(g[L]=o(E.swap(),l,e,a,w).swap())}return g}function o(e,l,g,L,N){let _=1;for(;e.seq1Range.start-_>=L.start&&e.seq2Range.start-_>=N.start&&g.isStronglyEqual(e.seq2Range.start-_,e.seq2Range.endExclusive-_)&&_<100;)_++;_--;let w=0;for(;e.seq1Range.start+w<L.endExclusive&&e.seq2Range.endExclusive+w<N.endExclusive&&g.isStronglyEqual(e.seq2Range.start+w,e.seq2Range.endExclusive+w)&&w<100;)w++;if(_===0&&w===0)return e;let a=0,s=-1;for(let f=-_;f<=w;f++){const v=e.seq2Range.start+f,k=e.seq2Range.endExclusive+f,R=e.seq1Range.start+f,T=l.getBoundaryScore(R)+g.getBoundaryScore(v)+g.getBoundaryScore(k);T>s&&(s=T,a=f)}return e.delta(a)}function u(e,l,g){const L=[];for(const N of g){const E=L[L.length-1];if(!E){L.push(N);continue}N.seq1Range.start-E.seq1Range.endExclusive<=2||N.seq2Range.start-E.seq2Range.endExclusive<=2?L[L.length-1]=new p.$f5(E.seq1Range.join(N.seq1Range),E.seq2Range.join(N.seq2Range)):L.push(N)}return L}function h(e,l,g){const L=p.$f5.invert(g,e.length),N=[];let E=new p.$g5(0,0);function _(a,s){if(a.offset1<E.offset1||a.offset2<E.offset2)return;const f=e.findWordContaining(a.offset1),v=l.findWordContaining(a.offset2);if(!f||!v)return;let k=new p.$f5(f,v);const R=k.intersect(s);let T=R.seq1Range.length,j=R.seq2Range.length;for(;L.length>0;){const M=L[0];if(!(M.seq1Range.intersects(k.seq1Range)||M.seq2Range.intersects(k.seq2Range)))break;const F=e.findWordContaining(M.seq1Range.start),y=l.findWordContaining(M.seq2Range.start),B=new p.$f5(F,y),z=B.intersect(M);if(T+=z.seq1Range.length,j+=z.seq2Range.length,k=k.join(B),k.seq1Range.endExclusive>=M.seq1Range.endExclusive)L.shift();else break}T+j<(k.seq1Range.length+k.seq2Range.length)*2/3&&N.push(k),E=k.getEndExclusives()}for(;L.length>0;){const a=L.shift();a.seq1Range.isEmpty||(_(a.getStarts(),a),_(a.getEndExclusives().delta(-1),a))}return $(g,N)}function $(e,l){const g=[];for(;e.length>0||l.length>0;){const L=e[0],N=l[0];let E;L&&(!N||L.seq1Range.start<N.seq1Range.start)?E=e.shift():E=l.shift(),g.length>0&&g[g.length-1].seq1Range.endExclusive>=E.seq1Range.start?g[g.length-1]=g[g.length-1].join(E):g.push(E)}return g}function b(e,l,g){let L=g;if(L.length===0)return L;let N=0,E;do{E=!1;const _=[L[0]];for(let w=1;w<L.length;w++){let f=function(k,R){const T=new i.$4t(s.seq1Range.endExclusive,a.seq1Range.start);return e.getText(T).replace(/\s/g,"").length<=4&&(k.seq1Range.length+k.seq2Range.length>5||R.seq1Range.length+R.seq2Range.length>5)};const a=L[w],s=_[_.length-1];f(s,a)?(E=!0,_[_.length-1]=_[_.length-1].join(a)):_.push(a)}L=_}while(N++<10&&E);return L}function c(e,l,g){let L=g;if(L.length===0)return L;let N=0,E;do{E=!1;const w=[L[0]];for(let a=1;a<L.length;a++){let v=function(R,T){const j=new i.$4t(f.seq1Range.endExclusive,s.seq1Range.start);if(e.countLinesIn(j)>5||j.length>500)return!1;const D=e.getText(j).trim();if(D.length>20||D.split(/\r\n|\r|\n/).length>1)return!1;const F=e.countLinesIn(R.seq1Range),y=R.seq1Range.length,B=l.countLinesIn(R.seq2Range),z=R.seq2Range.length,H=e.countLinesIn(T.seq1Range),U=T.seq1Range.length,C=l.countLinesIn(T.seq2Range),ee=T.seq2Range.length,J=2*40+50;function K(ne){return Math.min(ne,J)}return Math.pow(Math.pow(K(F*40+y),1.5)+Math.pow(K(B*40+z),1.5),1.5)+Math.pow(Math.pow(K(H*40+U),1.5)+Math.pow(K(C*40+ee),1.5),1.5)>(J**1.5)**1.5*1.3};const s=L[a],f=w[w.length-1];v(f,s)?(E=!0,w[w.length-1]=w[w.length-1].join(s)):w.push(s)}L=w}while(N++<10&&E);const _=[];return(0,n.$Gb)(L,(w,a,s)=>{let f=a;function v(D){return D.length>0&&D.trim().length<=3&&a.seq1Range.length+a.seq2Range.length>100}const k=e.extendToFullLines(a.seq1Range),R=e.getText(new i.$4t(k.start,a.seq1Range.start));v(R)&&(f=f.deltaStart(-R.length));const T=e.getText(new i.$4t(a.seq1Range.endExclusive,k.endExclusive));v(T)&&(f=f.deltaEnd(T.length));const j=p.$f5.fromOffsetPairs(w?w.getEndExclusives():p.$g5.zero,s?s.getStarts():p.$g5.max),M=f.intersect(j);_.length>0&&M.getStarts().equals(_[_.length-1].getEndExclusives())?_[_.length-1]=_[_.length-1].join(M):_.push(M)}),_}}),ie(re[58],ue([0,1,3]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$q5=void 0;class i{constructor(A,d){this.a=A,this.b=d}getElement(A){return this.a[A]}get length(){return this.a.length}getBoundaryScore(A){const d=A===0?0:p(this.b[A-1]),o=A===this.b.length?0:p(this.b[A]);return 1e3-(d+o)}getText(A){return this.b.slice(A.start,A.endExclusive).join(`
`)}isStronglyEqual(A,d){return this.b[A]===this.b[d]}}t.$q5=i;function p(m){let A=0;for(;A<m.length&&(m.charCodeAt(A)===n.CharCode.Space||m.charCodeAt(A)===n.CharCode.Tab);)A++;return A}}),ie(re[22],ue([0,1,3]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$l5=t.$j5=void 0,t.$k5=p;class i{constructor(d,o){this.width=d,this.height=o,this.a=[],this.a=new Array(d*o)}get(d,o){return this.a[d+o*this.width]}set(d,o,u){this.a[d+o*this.width]=u}}t.$j5=i;function p(A){return A===n.CharCode.Space||A===n.CharCode.Tab}class m{static{this.a=new Map}static b(d){let o=this.a.get(d);return o===void 0&&(o=this.a.size,this.a.set(d,o)),o}constructor(d,o,u){this.range=d,this.lines=o,this.source=u,this.d=[];let h=0;for(let $=d.startLineNumber-1;$<d.endLineNumberExclusive-1;$++){const b=o[$];for(let e=0;e<b.length;e++){h++;const l=b[e],g=m.b(l);this.d[g]=(this.d[g]||0)+1}h++;const c=m.b(`
`);this.d[c]=(this.d[c]||0)+1}this.c=h}computeSimilarity(d){let o=0;const u=Math.max(this.d.length,d.d.length);for(let h=0;h<u;h++)o+=Math.abs((this.d[h]??0)-(d.d[h]??0));return 1-o/(this.c+d.c)}}t.$l5=m}),ie(re[59],ue([0,1,7,13,22]),function(W,t,n,i,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$m5=void 0;class m{compute(d,o,u=i.$h5.instance,h){if(d.length===0||o.length===0)return i.$e5.trivial(d,o);const $=new p.$j5(d.length,o.length),b=new p.$j5(d.length,o.length),c=new p.$j5(d.length,o.length);for(let _=0;_<d.length;_++)for(let w=0;w<o.length;w++){if(!u.isValid())return i.$e5.trivialTimedOut(d,o);const a=_===0?0:$.get(_-1,w),s=w===0?0:$.get(_,w-1);let f;d.getElement(_)===o.getElement(w)?(_===0||w===0?f=0:f=$.get(_-1,w-1),_>0&&w>0&&b.get(_-1,w-1)===3&&(f+=c.get(_-1,w-1)),f+=h?h(_,w):1):f=-1;const v=Math.max(a,s,f);if(v===f){const k=_>0&&w>0?c.get(_-1,w-1):0;c.set(_,w,k+1),b.set(_,w,3)}else v===a?(c.set(_,w,0),b.set(_,w,1)):v===s&&(c.set(_,w,0),b.set(_,w,2));$.set(_,w,v)}const e=[];let l=d.length,g=o.length;function L(_,w){(_+1!==l||w+1!==g)&&e.push(new i.$f5(new n.$4t(_+1,l),new n.$4t(w+1,g))),l=_,g=w}let N=d.length-1,E=o.length-1;for(;N>=0&&E>=0;)b.get(N,E)===3?(L(N,E),N--,E--):b.get(N,E)===1?N--:E--;return L(-1,-1),e.reverse(),new i.$e5(e,!1)}}t.$m5=m}),ie(re[37],ue([0,1,11,3,7,5,2,22]),function(W,t,n,i,p,m,A,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$o5=void 0;class o{constructor(l,g,L){this.lines=l,this.g=g,this.considerWhitespaceChanges=L,this.b=[],this.c=[],this.d=[],this.f=[],this.c.push(0);for(let N=this.g.startLineNumber;N<=this.g.endLineNumber;N++){let E=l[N-1],_=0;N===this.g.startLineNumber&&this.g.startColumn>1&&(_=this.g.startColumn-1,E=E.substring(_)),this.d.push(_);let w=0;if(!L){const s=E.trimStart();w=E.length-s.length,E=s.trimEnd()}this.f.push(w);const a=N===this.g.endLineNumber?Math.min(this.g.endColumn-1-_-w,E.length):E.length;for(let s=0;s<a;s++)this.b.push(E.charCodeAt(s));N<this.g.endLineNumber&&(this.b.push(10),this.c.push(this.b.length))}}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new p.$4t(0,this.length))}getText(l){return this.b.slice(l.start,l.endExclusive).map(g=>String.fromCharCode(g)).join("")}getElement(l){return this.b[l]}get length(){return this.b.length}getBoundaryScore(l){const g=c(l>0?this.b[l-1]:-1),L=c(l<this.b.length?this.b[l]:-1);if(g===h.LineBreakCR&&L===h.LineBreakLF)return 0;if(g===h.LineBreakLF)return 150;let N=0;return g!==L&&(N+=10,g===h.WordLower&&L===h.WordUpper&&(N+=1)),N+=b(g),N+=b(L),N}translateOffset(l,g="right"){const L=(0,n.$mb)(this.c,E=>E<=l),N=l-this.c[L];return new m.$Vt(this.g.startLineNumber+L,1+this.d[L]+N+(N===0&&g==="left"?0:this.f[L]))}translateRange(l){const g=this.translateOffset(l.start,"right"),L=this.translateOffset(l.endExclusive,"left");return L.isBefore(g)?A.$Wt.fromPositions(L,L):A.$Wt.fromPositions(g,L)}findWordContaining(l){if(l<0||l>=this.b.length||!u(this.b[l]))return;let g=l;for(;g>0&&u(this.b[g-1]);)g--;let L=l;for(;L<this.b.length&&u(this.b[L]);)L++;return new p.$4t(g,L)}countLinesIn(l){return this.translateOffset(l.endExclusive).lineNumber-this.translateOffset(l.start).lineNumber}isStronglyEqual(l,g){return this.b[l]===this.b[g]}extendToFullLines(l){const g=(0,n.$lb)(this.c,N=>N<=l.start)??0,L=(0,n.$nb)(this.c,N=>l.endExclusive<=N)??this.b.length;return new p.$4t(g,L)}}t.$o5=o;function u(e){return e>=i.CharCode.a&&e<=i.CharCode.z||e>=i.CharCode.A&&e<=i.CharCode.Z||e>=i.CharCode.Digit0&&e<=i.CharCode.Digit9}var h;(function(e){e[e.WordLower=0]="WordLower",e[e.WordUpper=1]="WordUpper",e[e.WordNumber=2]="WordNumber",e[e.End=3]="End",e[e.Other=4]="Other",e[e.Separator=5]="Separator",e[e.Space=6]="Space",e[e.LineBreakCR=7]="LineBreakCR",e[e.LineBreakLF=8]="LineBreakLF"})(h||(h={}));const $={[h.WordLower]:0,[h.WordUpper]:0,[h.WordNumber]:0,[h.End]:10,[h.Other]:2,[h.Separator]:30,[h.Space]:3,[h.LineBreakCR]:10,[h.LineBreakLF]:10};function b(e){return $[e]}function c(e){return e===i.CharCode.LineFeed?h.LineBreakLF:e===i.CharCode.CarriageReturn?h.LineBreakCR:(0,d.$k5)(e)?h.Space:e>=i.CharCode.a&&e<=i.CharCode.z?h.WordLower:e>=i.CharCode.A&&e<=i.CharCode.Z?h.WordUpper:e>=i.CharCode.Digit0&&e<=i.CharCode.Digit9?h.WordNumber:e===-1?h.End:e===i.CharCode.Comma||e===i.CharCode.Semicolon?h.Separator:h.Other}}),ie(re[38],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hu=t.$gu=void 0;class n{constructor(m,A,d){this.changes=m,this.moves=A,this.hitTimeout=d}}t.$gu=n;class i{constructor(m,A){this.lineRangeMapping=m,this.changes=A}flip(){return new i(this.lineRangeMapping.flip(),this.changes.map(m=>m.flip()))}}t.$hu=i}),ie(re[23],ue([0,1,4,17,5,2,55]),function(W,t,n,i,p,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fu=t.$eu=t.$du=void 0;class d{static inverse(c,e,l){const g=[];let L=1,N=1;for(const _ of c){const w=new d(new i.$6t(L,_.original.startLineNumber),new i.$6t(N,_.modified.startLineNumber));w.modified.isEmpty||g.push(w),L=_.original.endLineNumberExclusive,N=_.modified.endLineNumberExclusive}const E=new d(new i.$6t(L,e+1),new i.$6t(N,l+1));return E.modified.isEmpty||g.push(E),g}static clip(c,e,l){const g=[];for(const L of c){const N=L.original.intersect(e),E=L.modified.intersect(l);N&&!N.isEmpty&&E&&!E.isEmpty&&g.push(new d(N,E))}return g}constructor(c,e){this.original=c,this.modified=e}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new d(this.modified,this.original)}join(c){return new d(this.original.join(c.original),this.modified.join(c.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}toRangeMapping(){const c=this.original.toInclusiveRange(),e=this.modified.toInclusiveRange();if(c&&e)return new $(c,e);if(this.original.startLineNumber===1||this.modified.startLineNumber===1){if(!(this.modified.startLineNumber===1&&this.original.startLineNumber===1))throw new n.$gb("not a valid diff");return new $(new m.$Wt(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new m.$Wt(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1))}else return new $(new m.$Wt(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),new m.$Wt(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER))}toRangeMapping2(c,e){if(u(this.original.endLineNumberExclusive,c)&&u(this.modified.endLineNumberExclusive,e))return new $(new m.$Wt(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new m.$Wt(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1));if(!this.original.isEmpty&&!this.modified.isEmpty)return new $(m.$Wt.fromPositions(new p.$Vt(this.original.startLineNumber,1),o(new p.$Vt(this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),c)),m.$Wt.fromPositions(new p.$Vt(this.modified.startLineNumber,1),o(new p.$Vt(this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),e)));if(this.original.startLineNumber>1&&this.modified.startLineNumber>1)return new $(m.$Wt.fromPositions(o(new p.$Vt(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER),c),o(new p.$Vt(this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),c)),m.$Wt.fromPositions(o(new p.$Vt(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER),e),o(new p.$Vt(this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),e)));throw new n.$gb}}t.$du=d;function o(b,c){if(b.lineNumber<1)return new p.$Vt(1,1);if(b.lineNumber>c.length)return new p.$Vt(c.length,c[c.length-1].length+1);const e=c[b.lineNumber-1];return b.column>e.length+1?new p.$Vt(b.lineNumber,e.length+1):b}function u(b,c){return b>=1&&b<=c.length}class h extends d{static fromRangeMappings(c){const e=i.$6t.join(c.map(g=>i.$6t.fromRangeInclusive(g.originalRange))),l=i.$6t.join(c.map(g=>i.$6t.fromRangeInclusive(g.modifiedRange)));return new h(e,l,c)}constructor(c,e,l){super(c,e),this.innerChanges=l}flip(){return new h(this.modified,this.original,this.innerChanges?.map(c=>c.flip()))}withInnerChangesFromLineRanges(){return new h(this.original,this.modified,[this.toRangeMapping()])}}t.$eu=h;class ${static assertSorted(c){for(let e=1;e<c.length;e++){const l=c[e-1],g=c[e];if(!(l.originalRange.getEndPosition().isBeforeOrEqual(g.originalRange.getStartPosition())&&l.modifiedRange.getEndPosition().isBeforeOrEqual(g.modifiedRange.getStartPosition())))throw new n.$gb("Range mappings must be sorted")}}constructor(c,e){this.originalRange=c,this.modifiedRange=e}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new $(this.modifiedRange,this.originalRange)}toTextEdit(c){const e=c.getValueOfRange(this.modifiedRange);return new A.$$t(this.originalRange,e)}}t.$fu=$}),ie(re[60],ue([0,1,13,23,9,11,19,17,37,22,36,2]),function(W,t,n,i,p,m,A,d,o,u,h,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$p5=b;function b(E,_,w,a,s,f){let{moves:v,excludedChanges:k}=e(E,_,w,f);if(!f.isValid())return[];const R=E.filter(j=>!k.has(j)),T=l(R,a,s,_,w,f);return(0,p.$4b)(v,T),v=L(v),v=v.filter(j=>{const M=j.original.toOffsetRange().slice(_).map(F=>F.trim());return M.join(`
`).length>=15&&c(M,F=>F.length>=2)>=2}),v=N(E,v),v}function c(E,_){let w=0;for(const a of E)_(a)&&w++;return w}function e(E,_,w,a){const s=[],f=E.filter(R=>R.modified.isEmpty&&R.original.length>=3).map(R=>new u.$l5(R.original,_,R)),v=new Set(E.filter(R=>R.original.isEmpty&&R.modified.length>=3).map(R=>new u.$l5(R.modified,w,R))),k=new Set;for(const R of f){let T=-1,j;for(const M of v){const D=R.computeSimilarity(M);D>T&&(T=D,j=M)}if(T>.9&&j&&(v.delete(j),s.push(new i.$du(R.range,j.range)),k.add(R.source),k.add(j.source)),!a.isValid())return{moves:s,excludedChanges:k}}return{moves:s,excludedChanges:k}}function l(E,_,w,a,s,f){const v=[],k=new A.$Mc;for(const D of E)for(let F=D.original.startLineNumber;F<D.original.endLineNumberExclusive-2;F++){const y=`${_[F-1]}:${_[F+1-1]}:${_[F+2-1]}`;k.add(y,{range:new d.$6t(F,F+3)})}const R=[];E.sort((0,p.$0b)(D=>D.modified.startLineNumber,p.$_b));for(const D of E){let F=[];for(let y=D.modified.startLineNumber;y<D.modified.endLineNumberExclusive-2;y++){const B=`${w[y-1]}:${w[y+1-1]}:${w[y+2-1]}`,z=new d.$6t(y,y+3),H=[];k.forEach(B,({range:U})=>{for(const ee of F)if(ee.originalLineRange.endLineNumberExclusive+1===U.endLineNumberExclusive&&ee.modifiedLineRange.endLineNumberExclusive+1===z.endLineNumberExclusive){ee.originalLineRange=new d.$6t(ee.originalLineRange.startLineNumber,U.endLineNumberExclusive),ee.modifiedLineRange=new d.$6t(ee.modifiedLineRange.startLineNumber,z.endLineNumberExclusive),H.push(ee);return}const C={modifiedLineRange:z,originalLineRange:U};R.push(C),H.push(C)}),F=H}if(!f.isValid())return[]}R.sort((0,p.$bc)((0,p.$0b)(D=>D.modifiedLineRange.length,p.$_b)));const T=new d.$7t,j=new d.$7t;for(const D of R){const F=D.modifiedLineRange.startLineNumber-D.originalLineRange.startLineNumber,y=T.subtractFrom(D.modifiedLineRange),B=j.subtractFrom(D.originalLineRange).getWithDelta(F),z=y.getIntersection(B);for(const H of z.ranges){if(H.length<3)continue;const U=H,C=H.delta(-F);v.push(new i.$du(C,U)),T.addRange(U),j.addRange(C)}}v.sort((0,p.$0b)(D=>D.original.startLineNumber,p.$_b));const M=new m.$qb(E);for(let D=0;D<v.length;D++){const F=v[D],y=M.findLastMonotonous(K=>K.original.startLineNumber<=F.original.startLineNumber),B=(0,m.$lb)(E,K=>K.modified.startLineNumber<=F.modified.startLineNumber),z=Math.max(F.original.startLineNumber-y.original.startLineNumber,F.modified.startLineNumber-B.modified.startLineNumber),H=M.findLastMonotonous(K=>K.original.startLineNumber<F.original.endLineNumberExclusive),U=(0,m.$lb)(E,K=>K.modified.startLineNumber<F.modified.endLineNumberExclusive),C=Math.max(H.original.endLineNumberExclusive-F.original.endLineNumberExclusive,U.modified.endLineNumberExclusive-F.modified.endLineNumberExclusive);let ee;for(ee=0;ee<z;ee++){const K=F.original.startLineNumber-ee-1,ne=F.modified.startLineNumber-ee-1;if(K>a.length||ne>s.length||T.contains(ne)||j.contains(K)||!g(a[K-1],s[ne-1],f))break}ee>0&&(j.addRange(new d.$6t(F.original.startLineNumber-ee,F.original.startLineNumber)),T.addRange(new d.$6t(F.modified.startLineNumber-ee,F.modified.startLineNumber)));let J;for(J=0;J<C;J++){const K=F.original.endLineNumberExclusive+J,ne=F.modified.endLineNumberExclusive+J;if(K>a.length||ne>s.length||T.contains(ne)||j.contains(K)||!g(a[K-1],s[ne-1],f))break}J>0&&(j.addRange(new d.$6t(F.original.endLineNumberExclusive,F.original.endLineNumberExclusive+J)),T.addRange(new d.$6t(F.modified.endLineNumberExclusive,F.modified.endLineNumberExclusive+J))),(ee>0||J>0)&&(v[D]=new i.$du(new d.$6t(F.original.startLineNumber-ee,F.original.endLineNumberExclusive+J),new d.$6t(F.modified.startLineNumber-ee,F.modified.endLineNumberExclusive+J)))}return v}function g(E,_,w){if(E.trim()===_.trim())return!0;if(E.length>300&&_.length>300)return!1;const s=new h.$n5().compute(new o.$o5([E],new $.$Wt(1,1,1,E.length),!1),new o.$o5([_],new $.$Wt(1,1,1,_.length),!1),w);let f=0;const v=n.$f5.invert(s.diffs,E.length);for(const j of v)j.seq1Range.forEach(M=>{(0,u.$k5)(E.charCodeAt(M))||f++});function k(j){let M=0;for(let D=0;D<E.length;D++)(0,u.$k5)(j.charCodeAt(D))||M++;return M}const R=k(E.length>_.length?E:_);return f/R>.6&&R>10}function L(E){if(E.length===0)return E;E.sort((0,p.$0b)(w=>w.original.startLineNumber,p.$_b));const _=[E[0]];for(let w=1;w<E.length;w++){const a=_[_.length-1],s=E[w],f=s.original.startLineNumber-a.original.endLineNumberExclusive,v=s.modified.startLineNumber-a.modified.endLineNumberExclusive;if(f>=0&&v>=0&&f+v<=2){_[_.length-1]=a.join(s);continue}_.push(s)}return _}function N(E,_){const w=new m.$qb(E);return _=_.filter(a=>{const s=w.findLastMonotonous(k=>k.original.startLineNumber<a.original.endLineNumberExclusive)||new i.$du(new d.$6t(1,1),new d.$6t(1,1)),f=(0,m.$lb)(E,k=>k.modified.startLineNumber<a.modified.endLineNumberExclusive);return s!==f}),_}}),ie(re[61],ue([0,1,9,15,17,7,2,13,59,36,60,57,58,37,38,23]),function(W,t,n,i,p,m,A,d,o,u,h,$,b,c,e,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$w5=void 0,t.$x5=L,t.$y5=N;class g{constructor(){this.e=new o.$m5,this.f=new u.$n5}computeDiff(w,a,s){if(w.length<=1&&(0,n.$yb)(w,a,(K,ne)=>K===ne))return new e.$gu([],[],!1);if(w.length===1&&w[0].length===0||a.length===1&&a[0].length===0)return new e.$gu([new l.$eu(new p.$6t(1,w.length+1),new p.$6t(1,a.length+1),[new l.$fu(new A.$Wt(1,1,w.length,w[w.length-1].length+1),new A.$Wt(1,1,a.length,a[a.length-1].length+1))])],[],!1);const f=s.maxComputationTimeMs===0?d.$h5.instance:new d.$i5(s.maxComputationTimeMs),v=!s.ignoreTrimWhitespace,k=new Map;function R(K){let ne=k.get(K);return ne===void 0&&(ne=k.size,k.set(K,ne)),ne}const T=w.map(K=>R(K.trim())),j=a.map(K=>R(K.trim())),M=new b.$q5(T,w),D=new b.$q5(j,a),F=M.length+D.length<1700?this.e.compute(M,D,f,(K,ne)=>w[K]===a[ne]?a[ne].length===0?.1:1+Math.log(1+a[ne].length):.99):this.f.compute(M,D,f);let y=F.diffs,B=F.hitTimeout;y=(0,$.$r5)(M,D,y),y=(0,$.$u5)(M,D,y);const z=[],H=K=>{if(v)for(let ne=0;ne<K;ne++){const P=U+ne,X=C+ne;if(w[P]!==a[X]){const he=this.j(w,a,new d.$f5(new m.$4t(P,P+1),new m.$4t(X,X+1)),f,v);for(const ge of he.mappings)z.push(ge);he.hitTimeout&&(B=!0)}}};let U=0,C=0;for(const K of y){(0,i.$md)(()=>K.seq1Range.start-U===K.seq2Range.start-C);const ne=K.seq1Range.start-U;H(ne),U=K.seq1Range.endExclusive,C=K.seq2Range.endExclusive;const P=this.j(w,a,K,f,v);P.hitTimeout&&(B=!0);for(const X of P.mappings)z.push(X)}H(w.length-U);const ee=L(z,w,a);let J=[];return s.computeMoves&&(J=this.h(ee,w,a,T,j,f,v)),(0,i.$md)(()=>{function K(P,X){if(P.lineNumber<1||P.lineNumber>X.length)return!1;const he=X[P.lineNumber-1];return!(P.column<1||P.column>he.length+1)}function ne(P,X){return!(P.startLineNumber<1||P.startLineNumber>X.length+1||P.endLineNumberExclusive<1||P.endLineNumberExclusive>X.length+1)}for(const P of ee){if(!P.innerChanges)return!1;for(const X of P.innerChanges)if(!(K(X.modifiedRange.getStartPosition(),a)&&K(X.modifiedRange.getEndPosition(),a)&&K(X.originalRange.getStartPosition(),w)&&K(X.originalRange.getEndPosition(),w)))return!1;if(!ne(P.modified,a)||!ne(P.original,w))return!1}return!0}),new e.$gu(ee,J,B)}h(w,a,s,f,v,k,R){return(0,h.$p5)(w,a,s,f,v,k).map(M=>{const D=this.j(a,s,new d.$f5(M.original.toOffsetRange(),M.modified.toOffsetRange()),k,R),F=L(D.mappings,a,s,!0);return new e.$hu(M,F)})}j(w,a,s,f,v){const R=E(s).toRangeMapping2(w,a),T=new c.$o5(w,R.originalRange,v),j=new c.$o5(a,R.modifiedRange,v),M=T.length+j.length<500?this.e.compute(T,j,f):this.f.compute(T,j,f),D=!1;let F=M.diffs;D&&d.$f5.assertSorted(F),F=(0,$.$r5)(T,j,F),D&&d.$f5.assertSorted(F),F=(0,$.$t5)(T,j,F),D&&d.$f5.assertSorted(F),F=(0,$.$s5)(T,j,F),D&&d.$f5.assertSorted(F),F=(0,$.$v5)(T,j,F),D&&d.$f5.assertSorted(F);const y=F.map(B=>new l.$fu(T.translateRange(B.seq1Range),j.translateRange(B.seq2Range)));return D&&l.$fu.assertSorted(y),{mappings:y,hitTimeout:M.hitTimeout}}}t.$w5=g;function L(_,w,a,s=!1){const f=[];for(const v of(0,n.$Eb)(_.map(k=>N(k,w,a)),(k,R)=>k.original.overlapOrTouch(R.original)||k.modified.overlapOrTouch(R.modified))){const k=v[0],R=v[v.length-1];f.push(new l.$eu(k.original.join(R.original),k.modified.join(R.modified),v.map(T=>T.innerChanges[0])))}return(0,i.$md)(()=>!s&&f.length>0&&(f[0].modified.startLineNumber!==f[0].original.startLineNumber||a.length-f[f.length-1].modified.endLineNumberExclusive!==w.length-f[f.length-1].original.endLineNumberExclusive)?!1:(0,i.$nd)(f,(v,k)=>k.original.startLineNumber-v.original.endLineNumberExclusive===k.modified.startLineNumber-v.modified.endLineNumberExclusive&&v.original.endLineNumberExclusive<k.original.startLineNumber&&v.modified.endLineNumberExclusive<k.modified.startLineNumber)),f}function N(_,w,a){let s=0,f=0;_.modifiedRange.endColumn===1&&_.originalRange.endColumn===1&&_.originalRange.startLineNumber+s<=_.originalRange.endLineNumber&&_.modifiedRange.startLineNumber+s<=_.modifiedRange.endLineNumber&&(f=-1),_.modifiedRange.startColumn-1>=a[_.modifiedRange.startLineNumber-1].length&&_.originalRange.startColumn-1>=w[_.originalRange.startLineNumber-1].length&&_.originalRange.startLineNumber<=_.originalRange.endLineNumber+f&&_.modifiedRange.startLineNumber<=_.modifiedRange.endLineNumber+f&&(s=1);const v=new p.$6t(_.originalRange.startLineNumber+s,_.originalRange.endLineNumber+1+f),k=new p.$6t(_.modifiedRange.startLineNumber+s,_.modifiedRange.endLineNumber+1+f);return new l.$eu(v,k,[_])}function E(_){return new l.$du(new p.$6t(_.seq1Range.start+1,_.seq1Range.endExclusive+1),new p.$6t(_.seq2Range.start+1,_.seq2Range.endExclusive+1))}}),ie(re[39],ue([0,1,3,32,38,23,6,2,15,17]),function(W,t,n,i,p,m,A,d,o,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ju=t.$iu=void 0,A=De(A);const h=3;class ${computeDiff(s,f,v){const R=new N(s,f,{maxComputationTime:v.maxComputationTimeMs,shouldIgnoreTrimWhitespace:v.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),T=[];let j=null;for(const M of R.changes){let D;M.originalEndLineNumber===0?D=new u.$6t(M.originalStartLineNumber+1,M.originalStartLineNumber+1):D=new u.$6t(M.originalStartLineNumber,M.originalEndLineNumber+1);let F;M.modifiedEndLineNumber===0?F=new u.$6t(M.modifiedStartLineNumber+1,M.modifiedStartLineNumber+1):F=new u.$6t(M.modifiedStartLineNumber,M.modifiedEndLineNumber+1);let y=new m.$eu(D,F,M.charChanges?.map(B=>new m.$fu(new d.$Wt(B.originalStartLineNumber,B.originalStartColumn,B.originalEndLineNumber,B.originalEndColumn),new d.$Wt(B.modifiedStartLineNumber,B.modifiedStartColumn,B.modifiedEndLineNumber,B.modifiedEndColumn))));j&&(j.modified.endLineNumberExclusive===y.modified.startLineNumber||j.original.endLineNumberExclusive===y.original.startLineNumber)&&(y=new m.$eu(j.original.join(y.original),j.modified.join(y.modified),j.innerChanges&&y.innerChanges?j.innerChanges.concat(y.innerChanges):void 0),T.pop()),T.push(y),j=y}return(0,o.$md)(()=>(0,o.$nd)(T,(M,D)=>D.original.startLineNumber-M.original.endLineNumberExclusive===D.modified.startLineNumber-M.modified.endLineNumberExclusive&&M.original.endLineNumberExclusive<D.original.startLineNumber&&M.modified.endLineNumberExclusive<D.modified.startLineNumber)),new p.$gu(T,[],R.quitEarly)}}t.$iu=$;function b(a,s,f,v){return new i.$3t(a,s,f).ComputeDiff(v)}class c{constructor(s){const f=[],v=[];for(let k=0,R=s.length;k<R;k++)f[k]=E(s[k],1),v[k]=_(s[k],1);this.lines=s,this.a=f,this.b=v}getElements(){const s=[];for(let f=0,v=this.lines.length;f<v;f++)s[f]=this.lines[f].substring(this.a[f]-1,this.b[f]-1);return s}getStrictElement(s){return this.lines[s]}getStartLineNumber(s){return s+1}getEndLineNumber(s){return s+1}createCharSequence(s,f,v){const k=[],R=[],T=[];let j=0;for(let M=f;M<=v;M++){const D=this.lines[M],F=s?this.a[M]:1,y=s?this.b[M]:D.length+1;for(let B=F;B<y;B++)k[j]=D.charCodeAt(B-1),R[j]=M+1,T[j]=B,j++;!s&&M<v&&(k[j]=n.CharCode.LineFeed,R[j]=M+1,T[j]=D.length+1,j++)}return new e(k,R,T)}}class e{constructor(s,f,v){this.a=s,this.b=f,this.d=v}toString(){return"["+this.a.map((s,f)=>(s===n.CharCode.LineFeed?"\\n":String.fromCharCode(s))+`-(${this.b[f]},${this.d[f]})`).join(", ")+"]"}e(s,f){if(s<0||s>=f.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(s){return s>0&&s===this.b.length?this.getEndLineNumber(s-1):(this.e(s,this.b),this.b[s])}getEndLineNumber(s){return s===-1?this.getStartLineNumber(s+1):(this.e(s,this.b),this.a[s]===n.CharCode.LineFeed?this.b[s]+1:this.b[s])}getStartColumn(s){return s>0&&s===this.d.length?this.getEndColumn(s-1):(this.e(s,this.d),this.d[s])}getEndColumn(s){return s===-1?this.getStartColumn(s+1):(this.e(s,this.d),this.a[s]===n.CharCode.LineFeed?1:this.d[s]+1)}}class l{constructor(s,f,v,k,R,T,j,M){this.originalStartLineNumber=s,this.originalStartColumn=f,this.originalEndLineNumber=v,this.originalEndColumn=k,this.modifiedStartLineNumber=R,this.modifiedStartColumn=T,this.modifiedEndLineNumber=j,this.modifiedEndColumn=M}static createFromDiffChange(s,f,v){const k=f.getStartLineNumber(s.originalStart),R=f.getStartColumn(s.originalStart),T=f.getEndLineNumber(s.originalStart+s.originalLength-1),j=f.getEndColumn(s.originalStart+s.originalLength-1),M=v.getStartLineNumber(s.modifiedStart),D=v.getStartColumn(s.modifiedStart),F=v.getEndLineNumber(s.modifiedStart+s.modifiedLength-1),y=v.getEndColumn(s.modifiedStart+s.modifiedLength-1);return new l(k,R,T,j,M,D,F,y)}}function g(a){if(a.length<=1)return a;const s=[a[0]];let f=s[0];for(let v=1,k=a.length;v<k;v++){const R=a[v],T=R.originalStart-(f.originalStart+f.originalLength),j=R.modifiedStart-(f.modifiedStart+f.modifiedLength);Math.min(T,j)<h?(f.originalLength=R.originalStart+R.originalLength-f.originalStart,f.modifiedLength=R.modifiedStart+R.modifiedLength-f.modifiedStart):(s.push(R),f=R)}return s}class L{constructor(s,f,v,k,R){this.originalStartLineNumber=s,this.originalEndLineNumber=f,this.modifiedStartLineNumber=v,this.modifiedEndLineNumber=k,this.charChanges=R}static createFromDiffResult(s,f,v,k,R,T,j){let M,D,F,y,B;if(f.originalLength===0?(M=v.getStartLineNumber(f.originalStart)-1,D=0):(M=v.getStartLineNumber(f.originalStart),D=v.getEndLineNumber(f.originalStart+f.originalLength-1)),f.modifiedLength===0?(F=k.getStartLineNumber(f.modifiedStart)-1,y=0):(F=k.getStartLineNumber(f.modifiedStart),y=k.getEndLineNumber(f.modifiedStart+f.modifiedLength-1)),T&&f.originalLength>0&&f.originalLength<20&&f.modifiedLength>0&&f.modifiedLength<20&&R()){const z=v.createCharSequence(s,f.originalStart,f.originalStart+f.originalLength-1),H=k.createCharSequence(s,f.modifiedStart,f.modifiedStart+f.modifiedLength-1);if(z.getElements().length>0&&H.getElements().length>0){let U=b(z,H,R,!0).changes;j&&(U=g(U)),B=[];for(let C=0,ee=U.length;C<ee;C++)B.push(l.createFromDiffChange(U[C],z,H))}}return new L(M,D,F,y,B)}}class N{constructor(s,f,v){this.a=v.shouldComputeCharChanges,this.b=v.shouldPostProcessCharChanges,this.d=v.shouldIgnoreTrimWhitespace,this.e=v.shouldMakePrettyDiff,this.f=s,this.g=f,this.h=new c(s),this.j=new c(f),this.k=w(v.maxComputationTime),this.l=w(v.maxComputationTime===0?0:Math.min(v.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const s=b(this.h,this.j,this.k,this.e),f=s.changes,v=s.quitEarly;if(this.d){const j=[];for(let M=0,D=f.length;M<D;M++)j.push(L.createFromDiffResult(this.d,f[M],this.h,this.j,this.l,this.a,this.b));return{quitEarly:v,changes:j}}const k=[];let R=0,T=0;for(let j=-1,M=f.length;j<M;j++){const D=j+1<M?f[j+1]:null,F=D?D.originalStart:this.f.length,y=D?D.modifiedStart:this.g.length;for(;R<F&&T<y;){const B=this.f[R],z=this.g[T];if(B!==z){{let H=E(B,1),U=E(z,1);for(;H>1&&U>1;){const C=B.charCodeAt(H-2),ee=z.charCodeAt(U-2);if(C!==ee)break;H--,U--}(H>1||U>1)&&this.m(k,R+1,1,H,T+1,1,U)}{let H=_(B,1),U=_(z,1);const C=B.length+1,ee=z.length+1;for(;H<C&&U<ee;){const J=B.charCodeAt(H-1),K=B.charCodeAt(U-1);if(J!==K)break;H++,U++}(H<C||U<ee)&&this.m(k,R+1,H,C,T+1,U,ee)}}R++,T++}D&&(k.push(L.createFromDiffResult(this.d,D,this.h,this.j,this.l,this.a,this.b)),R+=D.originalLength,T+=D.modifiedLength)}return{quitEarly:v,changes:k}}m(s,f,v,k,R,T,j){if(this.n(s,f,v,k,R,T,j))return;let M;this.a&&(M=[new l(f,v,f,k,R,T,R,j)]),s.push(new L(f,f,R,R,M))}n(s,f,v,k,R,T,j){const M=s.length;if(M===0)return!1;const D=s[M-1];return D.originalEndLineNumber===0||D.modifiedEndLineNumber===0?!1:D.originalEndLineNumber===f&&D.modifiedEndLineNumber===R?(this.a&&D.charChanges&&D.charChanges.push(new l(f,v,f,k,R,T,R,j)),!0):D.originalEndLineNumber+1===f&&D.modifiedEndLineNumber+1===R?(D.originalEndLineNumber=f,D.modifiedEndLineNumber=R,this.a&&D.charChanges&&D.charChanges.push(new l(f,v,f,k,R,T,R,j)),!0):!1}}t.$ju=N;function E(a,s){const f=A.$zf(a);return f===-1?s:f+1}function _(a,s){const f=A.$Bf(a);return f===-1?s:f+2}function w(a){if(a===0)return()=>!0;const s=Date.now();return()=>Date.now()-s<a}}),ie(re[62],ue([0,1,39,61]),function(W,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$z5=void 0,t.$z5={getLegacy:()=>new n.$iu,getDefault:()=>new i.$w5}}),ie(re[63],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Du=t.MetadataConsts=t.StandardTokenType=t.ColorId=t.FontStyle=t.LanguageId=void 0;var n;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(n||(t.LanguageId=n={}));var i;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline",o[o.Strikethrough=8]="Strikethrough"})(i||(t.FontStyle=i={}));var p;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(p||(t.ColorId=p={}));var m;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=3]="RegEx"})(m||(t.StandardTokenType=m={}));var A;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",o[o.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",o[o.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",o[o.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(A||(t.MetadataConsts=A={}));class d{static getLanguageId(u){return(u&A.LANGUAGEID_MASK)>>>A.LANGUAGEID_OFFSET}static getTokenType(u){return(u&A.TOKEN_TYPE_MASK)>>>A.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(u){return(u&A.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(u){return(u&A.FONT_STYLE_MASK)>>>A.FONT_STYLE_OFFSET}static getForeground(u){return(u&A.FOREGROUND_MASK)>>>A.FOREGROUND_OFFSET}static getBackground(u){return(u&A.BACKGROUND_MASK)>>>A.BACKGROUND_OFFSET}static getClassNameFromMetadata(u){let $="mtk"+this.getForeground(u);const b=this.getFontStyle(u);return b&i.Italic&&($+=" mtki"),b&i.Bold&&($+=" mtkb"),b&i.Underline&&($+=" mtku"),b&i.Strikethrough&&($+=" mtks"),$}static getInlineStyleFromMetadata(u,h){const $=this.getForeground(u),b=this.getFontStyle(u);let c=`color: ${h[$]};`;b&i.Italic&&(c+="font-style: italic;"),b&i.Bold&&(c+="font-weight: bold;");let e="";return b&i.Underline&&(e+=" underline"),b&i.Strikethrough&&(e+=" line-through"),e&&(c+=`text-decoration:${e};`),c}static getPresentationFromMetadata(u){const h=this.getForeground(u),$=this.getFontStyle(u);return{foreground:h,italic:!!($&i.Italic),bold:!!($&i.Bold),underline:!!($&i.Underline),strikethrough:!!($&i.Strikethrough)}}}t.$Du=d}),ie(re[64],ue([0,1,43]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$A5=$;function i(b){const c=[];for(const e of b){const l=Number(e);(l||l===0&&e.replace(/\s/g,"")!=="")&&c.push(l)}return c}function p(b,c,e,l){return{red:b/255,blue:e/255,green:c/255,alpha:l}}function m(b,c){const e=c.index,l=c[0].length;if(!e)return;const g=b.positionAt(e);return{startLineNumber:g.lineNumber,startColumn:g.column,endLineNumber:g.lineNumber,endColumn:g.column+l}}function A(b,c){if(!b)return;const e=n.$wu.Format.CSS.parseHex(c);if(e)return{range:b,color:p(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function d(b,c,e){if(!b||c.length!==1)return;const g=c[0].values(),L=i(g);return{range:b,color:p(L[0],L[1],L[2],e?L[3]:1)}}function o(b,c,e){if(!b||c.length!==1)return;const g=c[0].values(),L=i(g),N=new n.$wu(new n.$uu(L[0],L[1]/100,L[2]/100,e?L[3]:1));return{range:b,color:p(N.rgba.r,N.rgba.g,N.rgba.b,N.rgba.a)}}function u(b,c){return typeof b=="string"?[...b.matchAll(c)]:b.findMatches(c)}function h(b){const c=[],l=u(b,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(l.length>0)for(const g of l){const L=g.filter(w=>w!==void 0),N=L[1],E=L[2];if(!E)continue;let _;if(N==="rgb"){const w=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;_=d(m(b,g),u(E,w),!1)}else if(N==="rgba"){const w=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;_=d(m(b,g),u(E,w),!0)}else if(N==="hsl"){const w=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;_=o(m(b,g),u(E,w),!1)}else if(N==="hsla"){const w=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;_=o(m(b,g),u(E,w),!0)}else N==="#"&&(_=A(m(b,g),N+E));_&&c.push(_)}return c}function $(b){return!b||typeof b.getValue!="function"||typeof b.positionAt!="function"?[]:h(b)}}),ie(re[65],ue([0,1,3,33]),function(W,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$4=t.$04=t.State=void 0,t.$_4=c;var p;(function(e){e[e.Invalid=0]="Invalid",e[e.Start=1]="Start",e[e.H=2]="H",e[e.HT=3]="HT",e[e.HTT=4]="HTT",e[e.HTTP=5]="HTTP",e[e.F=6]="F",e[e.FI=7]="FI",e[e.FIL=8]="FIL",e[e.BeforeColon=9]="BeforeColon",e[e.AfterColon=10]="AfterColon",e[e.AlmostThere=11]="AlmostThere",e[e.End=12]="End",e[e.Accept=13]="Accept",e[e.LastKnownState=14]="LastKnownState"})(p||(t.State=p={}));class m{constructor(l,g,L){const N=new Uint8Array(l*g);for(let E=0,_=l*g;E<_;E++)N[E]=L;this.a=N,this.rows=l,this.cols=g}get(l,g){return this.a[l*this.cols+g]}set(l,g,L){this.a[l*this.cols+g]=L}}class A{constructor(l){let g=0,L=p.Invalid;for(let E=0,_=l.length;E<_;E++){const[w,a,s]=l[E];a>g&&(g=a),w>L&&(L=w),s>L&&(L=s)}g++,L++;const N=new m(L,g,p.Invalid);for(let E=0,_=l.length;E<_;E++){const[w,a,s]=l[E];N.set(w,a,s)}this.a=N,this.b=g}nextState(l,g){return g<0||g>=this.b?p.Invalid:this.a.get(l,g)}}t.$04=A;let d=null;function o(){return d===null&&(d=new A([[p.Start,n.CharCode.h,p.H],[p.Start,n.CharCode.H,p.H],[p.Start,n.CharCode.f,p.F],[p.Start,n.CharCode.F,p.F],[p.H,n.CharCode.t,p.HT],[p.H,n.CharCode.T,p.HT],[p.HT,n.CharCode.t,p.HTT],[p.HT,n.CharCode.T,p.HTT],[p.HTT,n.CharCode.p,p.HTTP],[p.HTT,n.CharCode.P,p.HTTP],[p.HTTP,n.CharCode.s,p.BeforeColon],[p.HTTP,n.CharCode.S,p.BeforeColon],[p.HTTP,n.CharCode.Colon,p.AfterColon],[p.F,n.CharCode.i,p.FI],[p.F,n.CharCode.I,p.FI],[p.FI,n.CharCode.l,p.FIL],[p.FI,n.CharCode.L,p.FIL],[p.FIL,n.CharCode.e,p.BeforeColon],[p.FIL,n.CharCode.E,p.BeforeColon],[p.BeforeColon,n.CharCode.Colon,p.AfterColon],[p.AfterColon,n.CharCode.Slash,p.AlmostThere],[p.AlmostThere,n.CharCode.Slash,p.End]])),d}var u;(function(e){e[e.None=0]="None",e[e.ForceTermination=1]="ForceTermination",e[e.CannotEndIn=2]="CannotEndIn"})(u||(u={}));let h=null;function $(){if(h===null){h=new i.$pu(u.None);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<e.length;g++)h.set(e.charCodeAt(g),u.ForceTermination);const l=".,;:";for(let g=0;g<l.length;g++)h.set(l.charCodeAt(g),u.CannotEndIn)}return h}class b{static a(l,g,L,N,E){let _=E-1;do{const w=g.charCodeAt(_);if(l.get(w)!==u.CannotEndIn)break;_--}while(_>N);if(N>0){const w=g.charCodeAt(N-1),a=g.charCodeAt(_);(w===n.CharCode.OpenParen&&a===n.CharCode.CloseParen||w===n.CharCode.OpenSquareBracket&&a===n.CharCode.CloseSquareBracket||w===n.CharCode.OpenCurlyBrace&&a===n.CharCode.CloseCurlyBrace)&&_--}return{range:{startLineNumber:L,startColumn:N+1,endLineNumber:L,endColumn:_+2},url:g.substring(N,_+1)}}static computeLinks(l,g=o()){const L=$(),N=[];for(let E=1,_=l.getLineCount();E<=_;E++){const w=l.getLineContent(E),a=w.length;let s=0,f=0,v=0,k=p.Start,R=!1,T=!1,j=!1,M=!1;for(;s<a;){let D=!1;const F=w.charCodeAt(s);if(k===p.Accept){let y;switch(F){case n.CharCode.OpenParen:R=!0,y=u.None;break;case n.CharCode.CloseParen:y=R?u.None:u.ForceTermination;break;case n.CharCode.OpenSquareBracket:j=!0,T=!0,y=u.None;break;case n.CharCode.CloseSquareBracket:j=!1,y=T?u.None:u.ForceTermination;break;case n.CharCode.OpenCurlyBrace:M=!0,y=u.None;break;case n.CharCode.CloseCurlyBrace:y=M?u.None:u.ForceTermination;break;case n.CharCode.SingleQuote:case n.CharCode.DoubleQuote:case n.CharCode.BackTick:v===F?y=u.ForceTermination:v===n.CharCode.SingleQuote||v===n.CharCode.DoubleQuote||v===n.CharCode.BackTick?y=u.None:y=u.ForceTermination;break;case n.CharCode.Asterisk:y=v===n.CharCode.Asterisk?u.ForceTermination:u.None;break;case n.CharCode.Pipe:y=v===n.CharCode.Pipe?u.ForceTermination:u.None;break;case n.CharCode.Space:y=j?u.None:u.ForceTermination;break;default:y=L.get(F)}y===u.ForceTermination&&(N.push(b.a(L,w,E,f,s)),D=!0)}else if(k===p.End){let y;F===n.CharCode.OpenSquareBracket?(T=!0,y=u.None):y=L.get(F),y===u.ForceTermination?D=!0:k=p.Accept}else k=g.nextState(k,F),k===p.Invalid&&(D=!0);D&&(k=p.Start,R=!1,T=!1,M=!1,f=s+1,v=F),s++}k===p.Accept&&N.push(b.a(L,w,E,f,a))}return N}}t.$$4=b;function c(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:b.computeLinks(e)}}),ie(re[66],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$a5=void 0;class n{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new n}navigateValueSet(p,m,A,d,o){if(p&&m){const u=this.a(m,o);if(u)return{range:p,value:u}}if(A&&d){const u=this.a(d,o);if(u)return{range:A,value:u}}return null}a(p,m){const A=this.b(p,m);return A!==null?A:this.d(p,m)}b(p,m){const A=Math.pow(10,p.length-(p.lastIndexOf(".")+1));let d=Number(p);const o=parseFloat(p);return!isNaN(d)&&!isNaN(o)&&d===o?d===0&&!m?null:(d=Math.floor(d*A),d+=m?A:-A,String(d/A)):null}d(p,m){return this.e(this.c,p,m)}e(p,m,A){let d=null;for(let o=0,u=p.length;d===null&&o<u;o++)d=this.f(p[o],m,A);return d}f(p,m,A){let d=p.indexOf(m);return d>=0?(d+=A?1:-1,d<0?d=p.length-1:d%=p.length,p[d]):null}}t.$a5=n}),ie(re[67],ue([0,1,31]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rw=t.$qw=t.$pw=t.ModelConstants=t.PositionAffinity=t.TrackedRangeStickiness=t.$nw=t.$mw=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0,t.$ow=e,t.$sw=_;var i;(function(w){w[w.Left=1]="Left",w[w.Center=2]="Center",w[w.Right=4]="Right",w[w.Full=7]="Full"})(i||(t.OverviewRulerLane=i={}));var p;(function(w){w[w.Left=1]="Left",w[w.Center=2]="Center",w[w.Right=3]="Right"})(p||(t.GlyphMarginLane=p={}));var m;(function(w){w[w.Inline=1]="Inline",w[w.Gutter=2]="Gutter"})(m||(t.MinimapPosition=m={}));var A;(function(w){w[w.Normal=1]="Normal",w[w.Underlined=2]="Underlined"})(A||(t.MinimapSectionHeaderStyle=A={}));var d;(function(w){w[w.Both=0]="Both",w[w.Right=1]="Right",w[w.Left=2]="Left",w[w.None=3]="None"})(d||(t.InjectedTextCursorStops=d={}));var o;(function(w){w[w.TextDefined=0]="TextDefined",w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(o||(t.EndOfLinePreference=o={}));var u;(function(w){w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(u||(t.DefaultEndOfLine=u={}));var h;(function(w){w[w.LF=0]="LF",w[w.CRLF=1]="CRLF"})(h||(t.EndOfLineSequence=h={}));class ${get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,n.$oo)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}t.$mw=$;class b{constructor(a,s){this._findMatchBrand=void 0,this.range=a,this.matches=s}}t.$nw=b;var c;(function(w){w[w.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",w[w.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",w[w.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",w[w.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(c||(t.TrackedRangeStickiness=c={}));function e(w){return w&&typeof w.read=="function"}var l;(function(w){w[w.Left=0]="Left",w[w.Right=1]="Right",w[w.None=2]="None",w[w.LeftOfInjectedText=3]="LeftOfInjectedText",w[w.RightOfInjectedText=4]="RightOfInjectedText"})(l||(t.PositionAffinity=l={}));var g;(function(w){w[w.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(g||(t.ModelConstants=g={}));class L{constructor(a,s,f,v,k,R){this.identifier=a,this.range=s,this.text=f,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=k,this._isTracked=R}}t.$pw=L;class N{constructor(a,s,f){this.regex=a,this.wordSeparators=s,this.simpleSearch=f}}t.$qw=N;class E{constructor(a,s,f){this.reverseEdits=a,this.changes=s,this.trimAutoWhitespaceLineNumbers=f}}t.$rw=E;function _(w){return!w.isTooLargeForSyncing()&&!w.isForSimpleWidget}}),ie(re[68],ue([0,1,9,16]),function(W,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xw=t.$ww=t.$vw=void 0;class p{constructor(o){this.a=o,this.b=new Uint32Array(o.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(o,u){o=(0,i.$gf)(o);const h=this.a,$=this.b,b=u.length;return b===0?!1:(this.a=new Uint32Array(h.length+b),this.a.set(h.subarray(0,o),0),this.a.set(h.subarray(o),o+b),this.a.set(u,o),o-1<this.c[0]&&(this.c[0]=o-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set($.subarray(0,this.c[0]+1)),!0)}setValue(o,u){return o=(0,i.$gf)(o),u=(0,i.$gf)(u),this.a[o]===u?!1:(this.a[o]=u,o-1<this.c[0]&&(this.c[0]=o-1),!0)}removeValues(o,u){o=(0,i.$gf)(o),u=(0,i.$gf)(u);const h=this.a,$=this.b;if(o>=h.length)return!1;const b=h.length-o;return u>=b&&(u=b),u===0?!1:(this.a=new Uint32Array(h.length-u),this.a.set(h.subarray(0,o),0),this.a.set(h.subarray(o+u),o),this.b=new Uint32Array(this.a.length),o-1<this.c[0]&&(this.c[0]=o-1),this.c[0]>=0&&this.b.set($.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(o){return o<0?0:(o=(0,i.$gf)(o),this.d(o))}d(o){if(o<=this.c[0])return this.b[o];let u=this.c[0]+1;u===0&&(this.b[0]=this.a[0],u++),o>=this.a.length&&(o=this.a.length-1);for(let h=u;h<=o;h++)this.b[h]=this.b[h-1]+this.a[h];return this.c[0]=Math.max(this.c[0],o),this.b[o]}getIndexOf(o){o=Math.floor(o),this.getTotalSum();let u=0,h=this.a.length-1,$=0,b=0,c=0;for(;u<=h;)if($=u+(h-u)/2|0,b=this.b[$],c=b-this.a[$],o<c)h=$-1;else if(o>=b)u=$+1;else break;return new A($,o-c)}}t.$vw=p;class m{constructor(o){this.a=o,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(o){return this.g(),o===0?0:this.d[o-1]}getIndexOf(o){this.g();const u=this.e[o],h=u>0?this.d[u-1]:0;return new A(u,o-h)}removeValues(o,u){this.a.splice(o,u),this.f(o)}insertValues(o,u){this.a=(0,n.$Zb)(this.a,o,u),this.f(o)}f(o){this.b=!1,this.c=Math.min(this.c,o-1)}g(){if(!this.b){for(let o=this.c+1,u=this.a.length;o<u;o++){const h=this.a[o],$=o>0?this.d[o-1]:0;this.d[o]=$+h;for(let b=0;b<h;b++)this.e[$+b]=o}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(o,u){this.a[o]!==u&&(this.a[o]=u,this.f(o))}}t.$ww=m;class A{constructor(o,u){this.index=o,this.remainder=u,this._prefixSumIndexOfResultBrand=void 0,this.index=o,this.remainder=u}}t.$xw=A}),ie(re[69],ue([0,1,6,5,68]),function(W,t,n,i,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yw=void 0;class m{constructor(d,o,u,h){this.a=d,this.b=o,this.c=u,this.d=h,this.f=null,this.g=null}dispose(){this.b.length=0}get version(){return this.d}getText(){return this.g===null&&(this.g=this.b.join(this.c)),this.g}onEvents(d){d.eol&&d.eol!==this.c&&(this.c=d.eol,this.f=null);const o=d.changes;for(const u of o)this.k(u.range),this.l(new i.$Vt(u.range.startLineNumber,u.range.startColumn),u.text);this.d=d.versionId,this.g=null}h(){if(!this.f){const d=this.c.length,o=this.b.length,u=new Uint32Array(o);for(let h=0;h<o;h++)u[h]=this.b[h].length+d;this.f=new p.$vw(u)}}j(d,o){this.b[d]=o,this.f&&this.f.setValue(d,this.b[d].length+this.c.length)}k(d){if(d.startLineNumber===d.endLineNumber){if(d.startColumn===d.endColumn)return;this.j(d.startLineNumber-1,this.b[d.startLineNumber-1].substring(0,d.startColumn-1)+this.b[d.startLineNumber-1].substring(d.endColumn-1));return}this.j(d.startLineNumber-1,this.b[d.startLineNumber-1].substring(0,d.startColumn-1)+this.b[d.endLineNumber-1].substring(d.endColumn-1)),this.b.splice(d.startLineNumber,d.endLineNumber-d.startLineNumber),this.f&&this.f.removeValues(d.startLineNumber,d.endLineNumber-d.startLineNumber)}l(d,o){if(o.length===0)return;const u=(0,n.$xf)(o);if(u.length===1){this.j(d.lineNumber-1,this.b[d.lineNumber-1].substring(0,d.column-1)+u[0]+this.b[d.lineNumber-1].substring(d.column-1));return}u[u.length-1]+=this.b[d.lineNumber-1].substring(d.column-1),this.j(d.lineNumber-1,this.b[d.lineNumber-1].substring(0,d.column-1)+u[0]);const h=new Uint32Array(u.length-1);for(let $=1;$<u.length;$++)this.b.splice(d.lineNumber+$-1,0,u[$]),h[$-1]=u[$].length+this.c.length;this.f&&this.f.insertValues(d.lineNumber,h)}}t.$yw=m}),ie(re[70],ue([0,1,3,6,56,5,2,67]),function(W,t,n,i,p,m,A,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CD=t.$AD=t.$xD=void 0,t.$yD=h,t.$zD=$,t.$BD=g,i=De(i);const o=999;class u{constructor(E,_,w,a){this.searchString=E,this.isRegex=_,this.matchCase=w,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let E;this.isRegex?E=h(this.searchString):E=this.searchString.indexOf(`
`)>=0;let _=null;try{_=i.$vf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:E,global:!0,unicode:!0})}catch{return null}if(!_)return null;let w=!this.isRegex&&!E;return w&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(w=this.matchCase),new d.$qw(_,this.wordSeparators?(0,p.$su)(this.wordSeparators,[]):null,w?this.searchString:null)}}t.$xD=u;function h(N){if(!N||N.length===0)return!1;for(let E=0,_=N.length;E<_;E++){const w=N.charCodeAt(E);if(w===n.CharCode.LineFeed)return!0;if(w===n.CharCode.Backslash){if(E++,E>=_)break;const a=N.charCodeAt(E);if(a===n.CharCode.n||a===n.CharCode.r||a===n.CharCode.W)return!0}}return!1}function $(N,E,_){if(!_)return new d.$nw(N,null);const w=[];for(let a=0,s=E.length;a<s;a++)w[a]=E[a];return new d.$nw(N,w)}class b{constructor(E){const _=[];let w=0;for(let a=0,s=E.length;a<s;a++)E.charCodeAt(a)===n.CharCode.LineFeed&&(_[w++]=a);this.a=_}findLineFeedCountBeforeOffset(E){const _=this.a;let w=0,a=_.length-1;if(a===-1||E<=_[0])return 0;for(;w<a;){const s=w+((a-w)/2>>0);_[s]>=E?a=s-1:_[s+1]>=E?(w=s,a=s):w=s+1}return w+1}}class c{static findMatches(E,_,w,a,s){const f=_.parseSearchRequest();return f?f.regex.multiline?this.b(E,w,new L(f.wordSeparators,f.regex),a,s):this.c(E,w,f,a,s):[]}static a(E,_,w,a,s,f){let v,k=0;a?(k=a.findLineFeedCountBeforeOffset(s),v=_+s+k):v=_+s;let R;if(a){const D=a.findLineFeedCountBeforeOffset(s+f.length)-k;R=v+f.length+D}else R=v+f.length;const T=E.getPositionAt(v),j=E.getPositionAt(R);return new A.$Wt(T.lineNumber,T.column,j.lineNumber,j.column)}static b(E,_,w,a,s){const f=E.getOffsetAt(_.getStartPosition()),v=E.getValueInRange(_,d.EndOfLinePreference.LF),k=E.getEOL()===`\r
`?new b(v):null,R=[];let T=0,j;for(w.reset(0);j=w.next(v);)if(R[T++]=$(this.a(E,f,v,k,j.index,j[0]),j,a),T>=s)return R;return R}static c(E,_,w,a,s){const f=[];let v=0;if(_.startLineNumber===_.endLineNumber){const R=E.getLineContent(_.startLineNumber).substring(_.startColumn-1,_.endColumn-1);return v=this.d(w,R,_.startLineNumber,_.startColumn-1,v,f,a,s),f}const k=E.getLineContent(_.startLineNumber).substring(_.startColumn-1);v=this.d(w,k,_.startLineNumber,_.startColumn-1,v,f,a,s);for(let R=_.startLineNumber+1;R<_.endLineNumber&&v<s;R++)v=this.d(w,E.getLineContent(R),R,0,v,f,a,s);if(v<s){const R=E.getLineContent(_.endLineNumber).substring(0,_.endColumn-1);v=this.d(w,R,_.endLineNumber,0,v,f,a,s)}return f}static d(E,_,w,a,s,f,v,k){const R=E.wordSeparators;if(!v&&E.simpleSearch){const M=E.simpleSearch,D=M.length,F=_.length;let y=-D;for(;(y=_.indexOf(M,y+D))!==-1;)if((!R||g(R,_,F,y,D))&&(f[s++]=new d.$nw(new A.$Wt(w,y+1+a,w,y+1+D+a),null),s>=k))return s;return s}const T=new L(E.wordSeparators,E.regex);let j;T.reset(0);do if(j=T.next(_),j&&(f[s++]=$(new A.$Wt(w,j.index+1+a,w,j.index+1+j[0].length+a),j,v),s>=k))return s;while(j);return s}static findNextMatch(E,_,w,a){const s=_.parseSearchRequest();if(!s)return null;const f=new L(s.wordSeparators,s.regex);return s.regex.multiline?this.e(E,w,f,a):this.f(E,w,f,a)}static e(E,_,w,a){const s=new m.$Vt(_.lineNumber,1),f=E.getOffsetAt(s),v=E.getLineCount(),k=E.getValueInRange(new A.$Wt(s.lineNumber,s.column,v,E.getLineMaxColumn(v)),d.EndOfLinePreference.LF),R=E.getEOL()===`\r
`?new b(k):null;w.reset(_.column-1);const T=w.next(k);return T?$(this.a(E,f,k,R,T.index,T[0]),T,a):_.lineNumber!==1||_.column!==1?this.e(E,new m.$Vt(1,1),w,a):null}static f(E,_,w,a){const s=E.getLineCount(),f=_.lineNumber,v=E.getLineContent(f),k=this.g(w,v,f,_.column,a);if(k)return k;for(let R=1;R<=s;R++){const T=(f+R-1)%s,j=E.getLineContent(T+1),M=this.g(w,j,T+1,1,a);if(M)return M}return null}static g(E,_,w,a,s){E.reset(a-1);const f=E.next(_);return f?$(new A.$Wt(w,f.index+1,w,f.index+1+f[0].length),f,s):null}static findPreviousMatch(E,_,w,a){const s=_.parseSearchRequest();if(!s)return null;const f=new L(s.wordSeparators,s.regex);return s.regex.multiline?this.h(E,w,f,a):this.j(E,w,f,a)}static h(E,_,w,a){const s=this.b(E,new A.$Wt(1,1,_.lineNumber,_.column),w,a,10*o);if(s.length>0)return s[s.length-1];const f=E.getLineCount();return _.lineNumber!==f||_.column!==E.getLineMaxColumn(f)?this.h(E,new m.$Vt(f,E.getLineMaxColumn(f)),w,a):null}static j(E,_,w,a){const s=E.getLineCount(),f=_.lineNumber,v=E.getLineContent(f).substring(0,_.column-1),k=this.k(w,v,f,a);if(k)return k;for(let R=1;R<=s;R++){const T=(s+f-R-1)%s,j=E.getLineContent(T+1),M=this.k(w,j,T+1,a);if(M)return M}return null}static k(E,_,w,a){let s=null,f;for(E.reset(0);f=E.next(_);)s=$(new A.$Wt(w,f.index+1,w,f.index+1+f[0].length),f,a);return s}}t.$AD=c;function e(N,E,_,w,a){if(w===0)return!0;const s=E.charCodeAt(w-1);if(N.get(s)!==p.WordCharacterClass.Regular||s===n.CharCode.CarriageReturn||s===n.CharCode.LineFeed)return!0;if(a>0){const f=E.charCodeAt(w);if(N.get(f)!==p.WordCharacterClass.Regular)return!0}return!1}function l(N,E,_,w,a){if(w+a===_)return!0;const s=E.charCodeAt(w+a);if(N.get(s)!==p.WordCharacterClass.Regular||s===n.CharCode.CarriageReturn||s===n.CharCode.LineFeed)return!0;if(a>0){const f=E.charCodeAt(w+a-1);if(N.get(f)!==p.WordCharacterClass.Regular)return!0}return!1}function g(N,E,_,w,a){return e(N,E,_,w,a)&&l(N,E,_,w,a)}class L{constructor(E,_){this._wordSeparators=E,this.a=_,this.b=-1,this.c=0}reset(E){this.a.lastIndex=E,this.b=-1,this.c=0}next(E){const _=E.length;let w;do{if(this.b+this.c===_||(w=this.a.exec(E),!w))return null;const a=w.index,s=w[0].length;if(a===this.b&&s===this.c){if(s===0){i.$Rf(E,_,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=s,!this._wordSeparators||g(this._wordSeparators,E,_,a,s))return w}while(w);return null}}t.$CD=L}),ie(re[71],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$d5=void 0;class n{static{this.CHANNEL_NAME="editorWorkerHost"}static getChannel(p){return p.getChannel(n.CHANNEL_NAME)}static setChannel(p,m){p.setChannel(n.CHANNEL_NAME,m)}}t.$d5=n}),ie(re[72],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$B5=p;const n=new RegExp("\\bMARK:\\s*(.*)$","d"),i=/^-+|-+$/g;function p(u,h){let $=[];if(h.findRegionSectionHeaders&&h.foldingRules?.markers){const b=m(u,h);$=$.concat(b)}if(h.findMarkSectionHeaders){const b=A(u);$=$.concat(b)}return $}function m(u,h){const $=[],b=u.getLineCount();for(let c=1;c<=b;c++){const e=u.getLineContent(c),l=e.match(h.foldingRules.markers.start);if(l){const g={startLineNumber:c,startColumn:l[0].length+1,endLineNumber:c,endColumn:e.length+1};if(g.endColumn>g.startColumn){const L={range:g,...o(e.substring(l[0].length)),shouldBeInComments:!1};(L.text||L.hasSeparatorLine)&&$.push(L)}}}return $}function A(u){const h=[],$=u.getLineCount();for(let b=1;b<=$;b++){const c=u.getLineContent(b);d(c,b,h)}return h}function d(u,h,$){n.lastIndex=0;const b=n.exec(u);if(b){const c=b.indices[1][0]+1,e=b.indices[1][1]+1,l={startLineNumber:h,startColumn:c,endLineNumber:h,endColumn:e};if(l.endColumn>l.startColumn){const g={range:l,...o(b[1]),shouldBeInComments:!0};(g.text||g.hasSeparatorLine)&&$.push(g)}}}function o(u){u=u.trim();const h=u.startsWith("-");return u=u.replace(i,""),{text:u,hasSeparatorLine:h}}}),ie(re[73],ue([0,1,2,70,6,15,35]),function(W,t,n,i,p,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$94=void 0,p=De(p);class d{static computeUnicodeHighlights(e,l,g){const L=g?g.startLineNumber:1,N=g?g.endLineNumber:e.getLineCount(),E=new h(l),_=E.getCandidateCodePoints();let w;_==="allNonBasicAscii"?w=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):w=new RegExp(`${o(Array.from(_))}`,"g");const a=new i.$CD(null,w),s=[];let f=!1,v,k=0,R=0,T=0;e:for(let j=L,M=N;j<=M;j++){const D=e.getLineContent(j),F=D.length;a.reset(0);do if(v=a.next(D),v){let y=v.index,B=v.index+v[0].length;if(y>0){const C=D.charCodeAt(y-1);p.$Of(C)&&y--}if(B+1<F){const C=D.charCodeAt(B-1);p.$Of(C)&&B++}const z=D.substring(y,B);let H=(0,A.$yt)(y+1,A.$vt,D,0);H&&H.endColumn<=y+1&&(H=null);const U=E.shouldHighlightNonBasicASCII(z,H?H.word:null);if(U!==b.None){if(U===b.Ambiguous?k++:U===b.Invisible?R++:U===b.NonBasicASCII?T++:(0,m.$jd)(U),s.length>=1e3){f=!0;break e}s.push(new n.$Wt(j,y+1,j,B+1))}}while(v)}return{ranges:s,hasMore:f,ambiguousCharacterCount:k,invisibleCharacterCount:R,nonBasicAsciiCharacterCount:T}}static computeUnicodeHighlightReason(e,l){const g=new h(l);switch(g.shouldHighlightNonBasicASCII(e,null)){case b.None:return null;case b.Invisible:return{kind:u.Invisible};case b.Ambiguous:{const N=e.codePointAt(0),E=g.ambiguousCharacters.getPrimaryConfusable(N),_=p.$hg.getLocales().filter(w=>!p.$hg.getInstance(new Set([...l.allowedLocales,w])).isAmbiguous(N));return{kind:u.Ambiguous,confusableWith:String.fromCodePoint(E),notAmbiguousInLocales:_}}case b.NonBasicASCII:return{kind:u.NonBasicAscii}}}}t.$94=d;function o(c,e){return`[${p.$mf(c.map(g=>String.fromCodePoint(g)).join(""))}]`}var u;(function(c){c[c.Ambiguous=0]="Ambiguous",c[c.Invisible=1]="Invisible",c[c.NonBasicAscii=2]="NonBasicAscii"})(u||(t.UnicodeHighlighterReasonKind=u={}));class h{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=p.$hg.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const l of p.$ig.codePoints)$(String.fromCodePoint(l))||e.add(l);if(this.b.ambiguousCharacters)for(const l of this.ambiguousCharacters.getConfusableCodePoints())e.add(l);for(const l of this.a)e.delete(l);return e}shouldHighlightNonBasicASCII(e,l){const g=e.codePointAt(0);if(this.a.has(g))return b.None;if(this.b.nonBasicASCII)return b.NonBasicASCII;let L=!1,N=!1;if(l)for(const E of l){const _=E.codePointAt(0),w=p.$Zf(E);L=L||w,!w&&!this.ambiguousCharacters.isAmbiguous(_)&&!p.$ig.isInvisibleCharacter(_)&&(N=!0)}return!L&&N?b.None:this.b.invisibleCharacters&&!$(e)&&p.$ig.isInvisibleCharacter(g)?b.Invisible:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(g)?b.Ambiguous:b.None}}function $(c){return c===" "||c===`
`||c==="	"}var b;(function(c){c[c.None=0]="None",c[c.NonBasicASCII=1]="NonBasicASCII",c[c.Invisible=2]="Invisible",c[c.Ambiguous=3]="Ambiguous"})(b||(b={}))}),ie(re[74],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.PartialAcceptTriggerKind=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTriggerKind=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineEditTriggerKind=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.HoverVerbosityAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var n;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(n||(t.AccessibilitySupport=n={}));var i;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(i||(t.CodeActionTriggerType=i={}));var p;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(p||(t.CompletionItemInsertTextRule=p={}));var m;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(m||(t.CompletionItemKind=m={}));var A;(function(r){r[r.Deprecated=1]="Deprecated"})(A||(t.CompletionItemTag=A={}));var d;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(t.CompletionTriggerKind=d={}));var o;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(o||(t.ContentWidgetPositionPreference=o={}));var u;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(u||(t.CursorChangeReason=u={}));var h;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(h||(t.DefaultEndOfLine=h={}));var $;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})($||(t.DocumentHighlightKind=$={}));var b;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(b||(t.EditorAutoIndentStrategy=b={}));var c;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.ariaRequired=5]="ariaRequired",r[r.autoClosingBrackets=6]="autoClosingBrackets",r[r.autoClosingComments=7]="autoClosingComments",r[r.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",r[r.autoClosingDelete=9]="autoClosingDelete",r[r.autoClosingOvertype=10]="autoClosingOvertype",r[r.autoClosingQuotes=11]="autoClosingQuotes",r[r.autoIndent=12]="autoIndent",r[r.automaticLayout=13]="automaticLayout",r[r.autoSurround=14]="autoSurround",r[r.bracketPairColorization=15]="bracketPairColorization",r[r.guides=16]="guides",r[r.codeLens=17]="codeLens",r[r.codeLensFontFamily=18]="codeLensFontFamily",r[r.codeLensFontSize=19]="codeLensFontSize",r[r.colorDecorators=20]="colorDecorators",r[r.colorDecoratorsLimit=21]="colorDecoratorsLimit",r[r.columnSelection=22]="columnSelection",r[r.comments=23]="comments",r[r.contextmenu=24]="contextmenu",r[r.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",r[r.cursorBlinking=26]="cursorBlinking",r[r.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",r[r.cursorStyle=28]="cursorStyle",r[r.cursorSurroundingLines=29]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",r[r.cursorWidth=31]="cursorWidth",r[r.disableLayerHinting=32]="disableLayerHinting",r[r.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",r[r.domReadOnly=34]="domReadOnly",r[r.dragAndDrop=35]="dragAndDrop",r[r.dropIntoEditor=36]="dropIntoEditor",r[r.emptySelectionClipboard=37]="emptySelectionClipboard",r[r.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",r[r.extraEditorClassName=39]="extraEditorClassName",r[r.fastScrollSensitivity=40]="fastScrollSensitivity",r[r.find=41]="find",r[r.fixedOverflowWidgets=42]="fixedOverflowWidgets",r[r.folding=43]="folding",r[r.foldingStrategy=44]="foldingStrategy",r[r.foldingHighlight=45]="foldingHighlight",r[r.foldingImportsByDefault=46]="foldingImportsByDefault",r[r.foldingMaximumRegions=47]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=49]="fontFamily",r[r.fontInfo=50]="fontInfo",r[r.fontLigatures=51]="fontLigatures",r[r.fontSize=52]="fontSize",r[r.fontWeight=53]="fontWeight",r[r.fontVariations=54]="fontVariations",r[r.formatOnPaste=55]="formatOnPaste",r[r.formatOnType=56]="formatOnType",r[r.glyphMargin=57]="glyphMargin",r[r.gotoLocation=58]="gotoLocation",r[r.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",r[r.hover=60]="hover",r[r.inDiffEditor=61]="inDiffEditor",r[r.inlineSuggest=62]="inlineSuggest",r[r.inlineEdit=63]="inlineEdit",r[r.letterSpacing=64]="letterSpacing",r[r.lightbulb=65]="lightbulb",r[r.lineDecorationsWidth=66]="lineDecorationsWidth",r[r.lineHeight=67]="lineHeight",r[r.lineNumbers=68]="lineNumbers",r[r.lineNumbersMinChars=69]="lineNumbersMinChars",r[r.linkedEditing=70]="linkedEditing",r[r.links=71]="links",r[r.matchBrackets=72]="matchBrackets",r[r.minimap=73]="minimap",r[r.mouseStyle=74]="mouseStyle",r[r.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=76]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",r[r.multiCursorModifier=78]="multiCursorModifier",r[r.multiCursorPaste=79]="multiCursorPaste",r[r.multiCursorLimit=80]="multiCursorLimit",r[r.occurrencesHighlight=81]="occurrencesHighlight",r[r.overviewRulerBorder=82]="overviewRulerBorder",r[r.overviewRulerLanes=83]="overviewRulerLanes",r[r.padding=84]="padding",r[r.pasteAs=85]="pasteAs",r[r.parameterHints=86]="parameterHints",r[r.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",r[r.placeholder=88]="placeholder",r[r.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",r[r.quickSuggestions=90]="quickSuggestions",r[r.quickSuggestionsDelay=91]="quickSuggestionsDelay",r[r.readOnly=92]="readOnly",r[r.readOnlyMessage=93]="readOnlyMessage",r[r.renameOnType=94]="renameOnType",r[r.renderControlCharacters=95]="renderControlCharacters",r[r.renderFinalNewline=96]="renderFinalNewline",r[r.renderLineHighlight=97]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=99]="renderValidationDecorations",r[r.renderWhitespace=100]="renderWhitespace",r[r.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",r[r.roundedSelection=102]="roundedSelection",r[r.rulers=103]="rulers",r[r.scrollbar=104]="scrollbar",r[r.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=106]="scrollBeyondLastLine",r[r.scrollPredominantAxis=107]="scrollPredominantAxis",r[r.selectionClipboard=108]="selectionClipboard",r[r.selectionHighlight=109]="selectionHighlight",r[r.selectOnLineNumbers=110]="selectOnLineNumbers",r[r.showFoldingControls=111]="showFoldingControls",r[r.showUnused=112]="showUnused",r[r.snippetSuggestions=113]="snippetSuggestions",r[r.smartSelect=114]="smartSelect",r[r.smoothScrolling=115]="smoothScrolling",r[r.stickyScroll=116]="stickyScroll",r[r.stickyTabStops=117]="stickyTabStops",r[r.stopRenderingLineAfter=118]="stopRenderingLineAfter",r[r.suggest=119]="suggest",r[r.suggestFontSize=120]="suggestFontSize",r[r.suggestLineHeight=121]="suggestLineHeight",r[r.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",r[r.suggestSelection=123]="suggestSelection",r[r.tabCompletion=124]="tabCompletion",r[r.tabIndex=125]="tabIndex",r[r.unicodeHighlighting=126]="unicodeHighlighting",r[r.unusualLineTerminators=127]="unusualLineTerminators",r[r.useShadowDOM=128]="useShadowDOM",r[r.useTabStops=129]="useTabStops",r[r.wordBreak=130]="wordBreak",r[r.wordSegmenterLocales=131]="wordSegmenterLocales",r[r.wordSeparators=132]="wordSeparators",r[r.wordWrap=133]="wordWrap",r[r.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=136]="wordWrapColumn",r[r.wordWrapOverride1=137]="wordWrapOverride1",r[r.wordWrapOverride2=138]="wordWrapOverride2",r[r.wrappingIndent=139]="wrappingIndent",r[r.wrappingStrategy=140]="wrappingStrategy",r[r.showDeprecated=141]="showDeprecated",r[r.inlayHints=142]="inlayHints",r[r.editorClassName=143]="editorClassName",r[r.pixelRatio=144]="pixelRatio",r[r.tabFocusMode=145]="tabFocusMode",r[r.layoutInfo=146]="layoutInfo",r[r.wrappingInfo=147]="wrappingInfo",r[r.defaultColorDecorators=148]="defaultColorDecorators",r[r.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",r[r.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(c||(t.EditorOption=c={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var l;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(l||(t.EndOfLineSequence=l={}));var g;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(g||(t.GlyphMarginLane=g={}));var L;(function(r){r[r.Increase=0]="Increase",r[r.Decrease=1]="Decrease"})(L||(t.HoverVerbosityAction=L={}));var N;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(N||(t.IndentAction=N={}));var E;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(E||(t.InjectedTextCursorStops=E={}));var _;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(_||(t.InlayHintKind=_={}));var w;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(w||(t.InlineCompletionTriggerKind=w={}));var a;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(a||(t.InlineEditTriggerKind=a={}));var s;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.F20=78]="F20",r[r.F21=79]="F21",r[r.F22=80]="F22",r[r.F23=81]="F23",r[r.F24=82]="F24",r[r.NumLock=83]="NumLock",r[r.ScrollLock=84]="ScrollLock",r[r.Semicolon=85]="Semicolon",r[r.Equal=86]="Equal",r[r.Comma=87]="Comma",r[r.Minus=88]="Minus",r[r.Period=89]="Period",r[r.Slash=90]="Slash",r[r.Backquote=91]="Backquote",r[r.BracketLeft=92]="BracketLeft",r[r.Backslash=93]="Backslash",r[r.BracketRight=94]="BracketRight",r[r.Quote=95]="Quote",r[r.OEM_8=96]="OEM_8",r[r.IntlBackslash=97]="IntlBackslash",r[r.Numpad0=98]="Numpad0",r[r.Numpad1=99]="Numpad1",r[r.Numpad2=100]="Numpad2",r[r.Numpad3=101]="Numpad3",r[r.Numpad4=102]="Numpad4",r[r.Numpad5=103]="Numpad5",r[r.Numpad6=104]="Numpad6",r[r.Numpad7=105]="Numpad7",r[r.Numpad8=106]="Numpad8",r[r.Numpad9=107]="Numpad9",r[r.NumpadMultiply=108]="NumpadMultiply",r[r.NumpadAdd=109]="NumpadAdd",r[r.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=111]="NumpadSubtract",r[r.NumpadDecimal=112]="NumpadDecimal",r[r.NumpadDivide=113]="NumpadDivide",r[r.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",r[r.ABNT_C1=115]="ABNT_C1",r[r.ABNT_C2=116]="ABNT_C2",r[r.AudioVolumeMute=117]="AudioVolumeMute",r[r.AudioVolumeUp=118]="AudioVolumeUp",r[r.AudioVolumeDown=119]="AudioVolumeDown",r[r.BrowserSearch=120]="BrowserSearch",r[r.BrowserHome=121]="BrowserHome",r[r.BrowserBack=122]="BrowserBack",r[r.BrowserForward=123]="BrowserForward",r[r.MediaTrackNext=124]="MediaTrackNext",r[r.MediaTrackPrevious=125]="MediaTrackPrevious",r[r.MediaStop=126]="MediaStop",r[r.MediaPlayPause=127]="MediaPlayPause",r[r.LaunchMediaPlayer=128]="LaunchMediaPlayer",r[r.LaunchMail=129]="LaunchMail",r[r.LaunchApp2=130]="LaunchApp2",r[r.Clear=131]="Clear",r[r.MAX_VALUE=132]="MAX_VALUE"})(s||(t.KeyCode=s={}));var f;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(f||(t.MarkerSeverity=f={}));var v;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(v||(t.MarkerTag=v={}));var k;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(k||(t.MinimapPosition=k={}));var R;(function(r){r[r.Normal=1]="Normal",r[r.Underlined=2]="Underlined"})(R||(t.MinimapSectionHeaderStyle=R={}));var T;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(T||(t.MouseTargetType=T={}));var j;(function(r){r[r.AIGenerated=1]="AIGenerated"})(j||(t.NewSymbolNameTag=j={}));var M;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(M||(t.NewSymbolNameTriggerKind=M={}));var D;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(D||(t.OverlayWidgetPositionPreference=D={}));var F;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(F||(t.OverviewRulerLane=F={}));var y;(function(r){r[r.Word=0]="Word",r[r.Line=1]="Line",r[r.Suggest=2]="Suggest"})(y||(t.PartialAcceptTriggerKind=y={}));var B;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(B||(t.PositionAffinity=B={}));var z;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(z||(t.RenderLineNumbersType=z={}));var H;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(H||(t.RenderMinimap=H={}));var U;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(U||(t.ScrollType=U={}));var C;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(C||(t.ScrollbarVisibility=C={}));var ee;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(ee||(t.SelectionDirection=ee={}));var J;(function(r){r.Off="off",r.OnCode="onCode",r.On="on"})(J||(t.ShowLightbulbIconMode=J={}));var K;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(K||(t.SignatureHelpTriggerKind=K={}));var ne;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(ne||(t.SymbolKind=ne={}));var P;(function(r){r[r.Deprecated=1]="Deprecated"})(P||(t.SymbolTag=P={}));var X;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(X||(t.TextEditorCursorBlinkingStyle=X={}));var he;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(he||(t.TextEditorCursorStyle=he={}));var ge;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(ge||(t.TrackedRangeStickiness=ge={}));var Le;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(Le||(t.WrappingIndent=Le={}))}),ie(re[75],ue([0,1,12,10,63]),function(W,t,n,i,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gu=void 0;class m{constructor(){this.a=new Map,this.b=new Map,this.c=new n.$qe,this.onDidChange=this.c.event,this.d=null}handleChange(o){this.c.fire({changedLanguages:o,changedColorMap:!1})}register(o,u){return this.a.set(o,u),this.handleChange([o]),(0,i.$Xc)(()=>{this.a.get(o)===u&&(this.a.delete(o),this.handleChange([o]))})}get(o){return this.a.get(o)||null}registerFactory(o,u){this.b.get(o)?.dispose();const h=new A(this,o,u);return this.b.set(o,h),(0,i.$Xc)(()=>{const $=this.b.get(o);!$||$!==h||(this.b.delete(o),$.dispose())})}async getOrCreate(o){const u=this.get(o);if(u)return u;const h=this.b.get(o);return!h||h.isResolved?null:(await h.resolve(),this.get(o))}isResolved(o){if(this.get(o))return!0;const h=this.b.get(o);return!!(!h||h.isResolved)}setColorMap(o){this.d=o,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>p.ColorId.DefaultBackground?this.d[p.ColorId.DefaultBackground]:null}}t.$Gu=m;class A extends i.$Zc{get isResolved(){return this.c}constructor(o,u,h){super(),this.f=o,this.g=u,this.h=h,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const o=await this.h.tokenizationSupport;this.c=!0,o&&!this.a&&this.B(this.f.register(this.g,o))}}}),ie(re[40],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$a=n,t.$b=i;function n(){return globalThis._VSCODE_NLS_MESSAGES}function i(){return globalThis._VSCODE_NLS_LANGUAGE}}),ie(re[41],ue([0,1,40,40]),function(W,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNLSMessages=t.getNLSLanguage=void 0,t.localize=A,t.localize2=o,Object.defineProperty(t,"getNLSLanguage",{enumerable:!0,get:function(){return i.$b}}),Object.defineProperty(t,"getNLSMessages",{enumerable:!0,get:function(){return i.$a}});const p=(0,n.$b)()==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function m(u,h){let $;return h.length===0?$=u:$=u.replace(/\{(\d+)\}/g,(b,c)=>{const e=c[0],l=h[e];let g=b;return typeof l=="string"?g=l:(typeof l=="number"||typeof l=="boolean"||l===void 0||l===null)&&(g=String(l)),g}),p&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),$}function A(u,h,...$){return m(typeof u=="number"?d(u,h):h,$)}function d(u,h){const $=(0,n.$a)()?.[u];if(typeof $!="string"){if(typeof h=="string")return h;throw new Error(`!!! NLS MISSING: ${u} !!!`)}return $}function o(u,h,...$){let b;typeof u=="number"?b=d(u,h):b=h;const c=m(b,$);return{value:c,original:h===b?c:m(h,$)}}}),ie(re[8],ue([0,1,41]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$L=t.$K=t.$J=t.$I=t.$H=t.OS=t.OperatingSystem=t.$E=t.$D=t.$C=t.$B=t.$A=t.Language=t.$z=t.$y=t.$x=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.Platform=t.$j=void 0,t.$k=s,t.$G=j,t.$M=M,n=De(n),t.$j="en";let i=!1,p=!1,m=!1,A=!1,d=!1,o=!1,u=!1,h=!1,$=!1,b=!1,c,e=t.$j,l=t.$j,g,L;const N=globalThis;let E;typeof N.vscode<"u"&&typeof N.vscode.process<"u"?E=N.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(E=process);const _=typeof E?.versions?.electron=="string",w=_&&E?.type==="renderer";if(typeof E=="object"){i=E.platform==="win32",p=E.platform==="darwin",m=E.platform==="linux",A=m&&!!E.env.SNAP&&!!E.env.SNAP_REVISION,u=_,$=!!E.env.CI||!!E.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=t.$j,e=t.$j;const D=E.env.VSCODE_NLS_CONFIG;if(D)try{const F=JSON.parse(D);c=F.userLocale,l=F.osLocale,e=F.resolvedLanguage||t.$j,g=F.languagePack?.translationsConfigFile}catch{}d=!0}else typeof navigator=="object"&&!w?(L=navigator.userAgent,i=L.indexOf("Windows")>=0,p=L.indexOf("Macintosh")>=0,h=(L.indexOf("Macintosh")>=0||L.indexOf("iPad")>=0||L.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,m=L.indexOf("Linux")>=0,b=L?.indexOf("Mobi")>=0,o=!0,e=n.getNLSLanguage()||t.$j,c=navigator.language.toLowerCase(),l=c):console.error("Unable to resolve platform.");var a;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(a||(t.Platform=a={}));function s(D){switch(D){case a.Web:return"Web";case a.Mac:return"Mac";case a.Linux:return"Linux";case a.Windows:return"Windows"}}let f=a.Web;p?f=a.Mac:i?f=a.Windows:m&&(f=a.Linux),t.$l=i,t.$m=p,t.$n=m,t.$o=A,t.$p=d,t.$q=u,t.$r=o,t.$s=o&&typeof N.importScripts=="function",t.$t=t.$s?N.origin:void 0,t.$u=h,t.$v=b,t.$w=$,t.$x=f,t.$y=L,t.$z=e;var v;(function(D){function F(){return t.$z}D.value=F;function y(){return t.$z.length===2?t.$z==="en":t.$z.length>=3?t.$z[0]==="e"&&t.$z[1]==="n"&&t.$z[2]==="-":!1}D.isDefaultVariant=y;function B(){return t.$z==="en"}D.isDefault=B})(v||(t.Language=v={})),t.$A=c,t.$B=l,t.$C=g,t.$D=typeof N.postMessage=="function"&&!N.importScripts,t.$E=(()=>{if(t.$D){const D=[];N.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let B=0,z=D.length;B<z;B++){const H=D[B];if(H.id===y.data.vscodeScheduleAsyncWork){D.splice(B,1),H.callback();return}}});let F=0;return y=>{const B=++F;D.push({id:B,callback:y}),N.postMessage({vscodeScheduleAsyncWork:B},"*")}}return D=>setTimeout(D)})();var k;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(k||(t.OperatingSystem=k={})),t.OS=p||h?k.Macintosh:i?k.Windows:k.Linux;let R=!0,T=!1;function j(){if(!T){T=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,R=new Uint16Array(D.buffer)[0]===513}return R}t.$H=!!(t.$y&&t.$y.indexOf("Chrome")>=0),t.$I=!!(t.$y&&t.$y.indexOf("Firefox")>=0),t.$J=!!(!t.$H&&t.$y&&t.$y.indexOf("Safari")>=0),t.$K=!!(t.$y&&t.$y.indexOf("Edg/")>=0),t.$L=!!(t.$y&&t.$y.indexOf("Android")>=0);function M(D){return parseFloat(D)>=20}}),ie(re[76],ue([0,1,8]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jc=t.$ic=t.env=t.cwd=void 0;let i;const p=globalThis.vscode;if(typeof p<"u"&&typeof p.process<"u"){const m=p.process;i={get platform(){return m.platform},get arch(){return m.arch},get env(){return m.env},cwd(){return m.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return n.$l?"win32":n.$m?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=i.cwd,t.env=i.env,t.$ic=i.platform,t.$jc=i.arch}),ie(re[18],ue([0,1,76]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yc=t.sep=t.$wc=t.$vc=t.$uc=t.$tc=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=void 0,n=De(n);const i=65,p=97,m=90,A=122,d=46,o=47,u=92,h=58,$=63;class b extends Error{constructor(f,v,k){let R;typeof v=="string"&&v.indexOf("not ")===0?(R="must not be",v=v.replace(/^not /,"")):R="must be";const T=f.indexOf(".")!==-1?"property":"argument";let j=`The "${f}" ${T} ${R} of type ${v}`;j+=`. Received type ${typeof k}`,super(j),this.code="ERR_INVALID_ARG_TYPE"}}function c(s,f){if(s===null||typeof s!="object")throw new b(f,"Object",s)}function e(s,f){if(typeof s!="string")throw new b(f,"string",s)}const l=n.$ic==="win32";function g(s){return s===o||s===u}function L(s){return s===o}function N(s){return s>=i&&s<=m||s>=p&&s<=A}function E(s,f,v,k){let R="",T=0,j=-1,M=0,D=0;for(let F=0;F<=s.length;++F){if(F<s.length)D=s.charCodeAt(F);else{if(k(D))break;D=o}if(k(D)){if(!(j===F-1||M===1))if(M===2){if(R.length<2||T!==2||R.charCodeAt(R.length-1)!==d||R.charCodeAt(R.length-2)!==d){if(R.length>2){const y=R.lastIndexOf(v);y===-1?(R="",T=0):(R=R.slice(0,y),T=R.length-1-R.lastIndexOf(v)),j=F,M=0;continue}else if(R.length!==0){R="",T=0,j=F,M=0;continue}}f&&(R+=R.length>0?`${v}..`:"..",T=2)}else R.length>0?R+=`${v}${s.slice(j+1,F)}`:R=s.slice(j+1,F),T=F-j-1;j=F,M=0}else D===d&&M!==-1?++M:M=-1}return R}function _(s){return s?`${s[0]==="."?"":"."}${s}`:""}function w(s,f){c(f,"pathObject");const v=f.dir||f.root,k=f.base||`${f.name||""}${_(f.ext)}`;return v?v===f.root?`${v}${k}`:`${v}${s}${k}`:k}t.$kc={resolve(...s){let f="",v="",k=!1;for(let R=s.length-1;R>=-1;R--){let T;if(R>=0){if(T=s[R],e(T,`paths[${R}]`),T.length===0)continue}else f.length===0?T=n.cwd():(T=n.env[`=${f}`]||n.cwd(),(T===void 0||T.slice(0,2).toLowerCase()!==f.toLowerCase()&&T.charCodeAt(2)===u)&&(T=`${f}\\`));const j=T.length;let M=0,D="",F=!1;const y=T.charCodeAt(0);if(j===1)g(y)&&(M=1,F=!0);else if(g(y))if(F=!0,g(T.charCodeAt(1))){let B=2,z=B;for(;B<j&&!g(T.charCodeAt(B));)B++;if(B<j&&B!==z){const H=T.slice(z,B);for(z=B;B<j&&g(T.charCodeAt(B));)B++;if(B<j&&B!==z){for(z=B;B<j&&!g(T.charCodeAt(B));)B++;(B===j||B!==z)&&(D=`\\\\${H}\\${T.slice(z,B)}`,M=B)}}}else M=1;else N(y)&&T.charCodeAt(1)===h&&(D=T.slice(0,2),M=2,j>2&&g(T.charCodeAt(2))&&(F=!0,M=3));if(D.length>0)if(f.length>0){if(D.toLowerCase()!==f.toLowerCase())continue}else f=D;if(k){if(f.length>0)break}else if(v=`${T.slice(M)}\\${v}`,k=F,F&&f.length>0)break}return v=E(v,!k,"\\",g),k?`${f}\\${v}`:`${f}${v}`||"."},normalize(s){e(s,"path");const f=s.length;if(f===0)return".";let v=0,k,R=!1;const T=s.charCodeAt(0);if(f===1)return L(T)?"\\":s;if(g(T))if(R=!0,g(s.charCodeAt(1))){let M=2,D=M;for(;M<f&&!g(s.charCodeAt(M));)M++;if(M<f&&M!==D){const F=s.slice(D,M);for(D=M;M<f&&g(s.charCodeAt(M));)M++;if(M<f&&M!==D){for(D=M;M<f&&!g(s.charCodeAt(M));)M++;if(M===f)return`\\\\${F}\\${s.slice(D)}\\`;M!==D&&(k=`\\\\${F}\\${s.slice(D,M)}`,v=M)}}}else v=1;else N(T)&&s.charCodeAt(1)===h&&(k=s.slice(0,2),v=2,f>2&&g(s.charCodeAt(2))&&(R=!0,v=3));let j=v<f?E(s.slice(v),!R,"\\",g):"";return j.length===0&&!R&&(j="."),j.length>0&&g(s.charCodeAt(f-1))&&(j+="\\"),k===void 0?R?`\\${j}`:j:R?`${k}\\${j}`:`${k}${j}`},isAbsolute(s){e(s,"path");const f=s.length;if(f===0)return!1;const v=s.charCodeAt(0);return g(v)||f>2&&N(v)&&s.charCodeAt(1)===h&&g(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let f,v;for(let T=0;T<s.length;++T){const j=s[T];e(j,"path"),j.length>0&&(f===void 0?f=v=j:f+=`\\${j}`)}if(f===void 0)return".";let k=!0,R=0;if(typeof v=="string"&&g(v.charCodeAt(0))){++R;const T=v.length;T>1&&g(v.charCodeAt(1))&&(++R,T>2&&(g(v.charCodeAt(2))?++R:k=!1))}if(k){for(;R<f.length&&g(f.charCodeAt(R));)R++;R>=2&&(f=`\\${f.slice(R)}`)}return t.$kc.normalize(f)},relative(s,f){if(e(s,"from"),e(f,"to"),s===f)return"";const v=t.$kc.resolve(s),k=t.$kc.resolve(f);if(v===k||(s=v.toLowerCase(),f=k.toLowerCase(),s===f))return"";let R=0;for(;R<s.length&&s.charCodeAt(R)===u;)R++;let T=s.length;for(;T-1>R&&s.charCodeAt(T-1)===u;)T--;const j=T-R;let M=0;for(;M<f.length&&f.charCodeAt(M)===u;)M++;let D=f.length;for(;D-1>M&&f.charCodeAt(D-1)===u;)D--;const F=D-M,y=j<F?j:F;let B=-1,z=0;for(;z<y;z++){const U=s.charCodeAt(R+z);if(U!==f.charCodeAt(M+z))break;U===u&&(B=z)}if(z!==y){if(B===-1)return k}else{if(F>y){if(f.charCodeAt(M+z)===u)return k.slice(M+z+1);if(z===2)return k.slice(M+z)}j>y&&(s.charCodeAt(R+z)===u?B=z:z===2&&(B=3)),B===-1&&(B=0)}let H="";for(z=R+B+1;z<=T;++z)(z===T||s.charCodeAt(z)===u)&&(H+=H.length===0?"..":"\\..");return M+=B,H.length>0?`${H}${k.slice(M,D)}`:(k.charCodeAt(M)===u&&++M,k.slice(M,D))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const f=t.$kc.resolve(s);if(f.length<=2)return s;if(f.charCodeAt(0)===u){if(f.charCodeAt(1)===u){const v=f.charCodeAt(2);if(v!==$&&v!==d)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(N(f.charCodeAt(0))&&f.charCodeAt(1)===h&&f.charCodeAt(2)===u)return`\\\\?\\${f}`;return s},dirname(s){e(s,"path");const f=s.length;if(f===0)return".";let v=-1,k=0;const R=s.charCodeAt(0);if(f===1)return g(R)?s:".";if(g(R)){if(v=k=1,g(s.charCodeAt(1))){let M=2,D=M;for(;M<f&&!g(s.charCodeAt(M));)M++;if(M<f&&M!==D){for(D=M;M<f&&g(s.charCodeAt(M));)M++;if(M<f&&M!==D){for(D=M;M<f&&!g(s.charCodeAt(M));)M++;if(M===f)return s;M!==D&&(v=k=M+1)}}}}else N(R)&&s.charCodeAt(1)===h&&(v=f>2&&g(s.charCodeAt(2))?3:2,k=v);let T=-1,j=!0;for(let M=f-1;M>=k;--M)if(g(s.charCodeAt(M))){if(!j){T=M;break}}else j=!1;if(T===-1){if(v===-1)return".";T=v}return s.slice(0,T)},basename(s,f){f!==void 0&&e(f,"suffix"),e(s,"path");let v=0,k=-1,R=!0,T;if(s.length>=2&&N(s.charCodeAt(0))&&s.charCodeAt(1)===h&&(v=2),f!==void 0&&f.length>0&&f.length<=s.length){if(f===s)return"";let j=f.length-1,M=-1;for(T=s.length-1;T>=v;--T){const D=s.charCodeAt(T);if(g(D)){if(!R){v=T+1;break}}else M===-1&&(R=!1,M=T+1),j>=0&&(D===f.charCodeAt(j)?--j===-1&&(k=T):(j=-1,k=M))}return v===k?k=M:k===-1&&(k=s.length),s.slice(v,k)}for(T=s.length-1;T>=v;--T)if(g(s.charCodeAt(T))){if(!R){v=T+1;break}}else k===-1&&(R=!1,k=T+1);return k===-1?"":s.slice(v,k)},extname(s){e(s,"path");let f=0,v=-1,k=0,R=-1,T=!0,j=0;s.length>=2&&s.charCodeAt(1)===h&&N(s.charCodeAt(0))&&(f=k=2);for(let M=s.length-1;M>=f;--M){const D=s.charCodeAt(M);if(g(D)){if(!T){k=M+1;break}continue}R===-1&&(T=!1,R=M+1),D===d?v===-1?v=M:j!==1&&(j=1):v!==-1&&(j=-1)}return v===-1||R===-1||j===0||j===1&&v===R-1&&v===k+1?"":s.slice(v,R)},format:w.bind(null,"\\"),parse(s){e(s,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return f;const v=s.length;let k=0,R=s.charCodeAt(0);if(v===1)return g(R)?(f.root=f.dir=s,f):(f.base=f.name=s,f);if(g(R)){if(k=1,g(s.charCodeAt(1))){let B=2,z=B;for(;B<v&&!g(s.charCodeAt(B));)B++;if(B<v&&B!==z){for(z=B;B<v&&g(s.charCodeAt(B));)B++;if(B<v&&B!==z){for(z=B;B<v&&!g(s.charCodeAt(B));)B++;B===v?k=B:B!==z&&(k=B+1)}}}}else if(N(R)&&s.charCodeAt(1)===h){if(v<=2)return f.root=f.dir=s,f;if(k=2,g(s.charCodeAt(2))){if(v===3)return f.root=f.dir=s,f;k=3}}k>0&&(f.root=s.slice(0,k));let T=-1,j=k,M=-1,D=!0,F=s.length-1,y=0;for(;F>=k;--F){if(R=s.charCodeAt(F),g(R)){if(!D){j=F+1;break}continue}M===-1&&(D=!1,M=F+1),R===d?T===-1?T=F:y!==1&&(y=1):T!==-1&&(y=-1)}return M!==-1&&(T===-1||y===0||y===1&&T===M-1&&T===j+1?f.base=f.name=s.slice(j,M):(f.name=s.slice(j,T),f.base=s.slice(j,M),f.ext=s.slice(T,M))),j>0&&j!==k?f.dir=s.slice(0,j-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(l){const s=/\\/g;return()=>{const f=n.cwd().replace(s,"/");return f.slice(f.indexOf("/"))}}return()=>n.cwd()})();t.$lc={resolve(...s){let f="",v=!1;for(let k=s.length-1;k>=-1&&!v;k--){const R=k>=0?s[k]:a();e(R,`paths[${k}]`),R.length!==0&&(f=`${R}/${f}`,v=R.charCodeAt(0)===o)}return f=E(f,!v,"/",L),v?`/${f}`:f.length>0?f:"."},normalize(s){if(e(s,"path"),s.length===0)return".";const f=s.charCodeAt(0)===o,v=s.charCodeAt(s.length-1)===o;return s=E(s,!f,"/",L),s.length===0?f?"/":v?"./":".":(v&&(s+="/"),f?`/${s}`:s)},isAbsolute(s){return e(s,"path"),s.length>0&&s.charCodeAt(0)===o},join(...s){if(s.length===0)return".";let f;for(let v=0;v<s.length;++v){const k=s[v];e(k,"path"),k.length>0&&(f===void 0?f=k:f+=`/${k}`)}return f===void 0?".":t.$lc.normalize(f)},relative(s,f){if(e(s,"from"),e(f,"to"),s===f||(s=t.$lc.resolve(s),f=t.$lc.resolve(f),s===f))return"";const v=1,k=s.length,R=k-v,T=1,j=f.length-T,M=R<j?R:j;let D=-1,F=0;for(;F<M;F++){const B=s.charCodeAt(v+F);if(B!==f.charCodeAt(T+F))break;B===o&&(D=F)}if(F===M)if(j>M){if(f.charCodeAt(T+F)===o)return f.slice(T+F+1);if(F===0)return f.slice(T+F)}else R>M&&(s.charCodeAt(v+F)===o?D=F:F===0&&(D=0));let y="";for(F=v+D+1;F<=k;++F)(F===k||s.charCodeAt(F)===o)&&(y+=y.length===0?"..":"/..");return`${y}${f.slice(T+D)}`},toNamespacedPath(s){return s},dirname(s){if(e(s,"path"),s.length===0)return".";const f=s.charCodeAt(0)===o;let v=-1,k=!0;for(let R=s.length-1;R>=1;--R)if(s.charCodeAt(R)===o){if(!k){v=R;break}}else k=!1;return v===-1?f?"/":".":f&&v===1?"//":s.slice(0,v)},basename(s,f){f!==void 0&&e(f,"ext"),e(s,"path");let v=0,k=-1,R=!0,T;if(f!==void 0&&f.length>0&&f.length<=s.length){if(f===s)return"";let j=f.length-1,M=-1;for(T=s.length-1;T>=0;--T){const D=s.charCodeAt(T);if(D===o){if(!R){v=T+1;break}}else M===-1&&(R=!1,M=T+1),j>=0&&(D===f.charCodeAt(j)?--j===-1&&(k=T):(j=-1,k=M))}return v===k?k=M:k===-1&&(k=s.length),s.slice(v,k)}for(T=s.length-1;T>=0;--T)if(s.charCodeAt(T)===o){if(!R){v=T+1;break}}else k===-1&&(R=!1,k=T+1);return k===-1?"":s.slice(v,k)},extname(s){e(s,"path");let f=-1,v=0,k=-1,R=!0,T=0;for(let j=s.length-1;j>=0;--j){const M=s.charCodeAt(j);if(M===o){if(!R){v=j+1;break}continue}k===-1&&(R=!1,k=j+1),M===d?f===-1?f=j:T!==1&&(T=1):f!==-1&&(T=-1)}return f===-1||k===-1||T===0||T===1&&f===k-1&&f===v+1?"":s.slice(f,k)},format:w.bind(null,"/"),parse(s){e(s,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return f;const v=s.charCodeAt(0)===o;let k;v?(f.root="/",k=1):k=0;let R=-1,T=0,j=-1,M=!0,D=s.length-1,F=0;for(;D>=k;--D){const y=s.charCodeAt(D);if(y===o){if(!M){T=D+1;break}continue}j===-1&&(M=!1,j=D+1),y===d?R===-1?R=D:F!==1&&(F=1):R!==-1&&(F=-1)}if(j!==-1){const y=T===0&&v?1:T;R===-1||F===0||F===1&&R===j-1&&R===T+1?f.base=f.name=s.slice(y,j):(f.name=s.slice(y,R),f.base=s.slice(y,j),f.ext=s.slice(R,j))}return T>0?f.dir=s.slice(0,T-1):v&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},t.$lc.win32=t.$kc.win32=t.$kc,t.$lc.posix=t.$kc.posix=t.$lc,t.$mc=l?t.$kc.normalize:t.$lc.normalize,t.$nc=l?t.$kc.isAbsolute:t.$lc.isAbsolute,t.$oc=l?t.$kc.join:t.$lc.join,t.$pc=l?t.$kc.resolve:t.$lc.resolve,t.$qc=l?t.$kc.relative:t.$lc.relative,t.$rc=l?t.$kc.dirname:t.$lc.dirname,t.$sc=l?t.$kc.basename:t.$lc.basename,t.$tc=l?t.$kc.extname:t.$lc.extname,t.$uc=l?t.$kc.format:t.$lc.format,t.$vc=l?t.$kc.parse:t.$lc.parse,t.$wc=l?t.$kc.toNamespacedPath:t.$lc.toNamespacedPath,t.sep=l?t.$kc.sep:t.$lc.sep,t.$yc=l?t.$kc.delimiter:t.$lc.delimiter}),ie(re[77],ue([0,1,3,18,8,6,21]),function(W,t,n,i,p,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cg=d,t.$Dg=o,t.$Eg=u,t.$Fg=h,t.$Gg=$,t.$Hg=l,t.$Ig=g,t.$Jg=L,t.$Kg=N,t.$Lg=E,t.$Mg=_,t.$Ng=w,t.$Og=a,t.$Pg=s,t.$Qg=f,t.$Rg=v,t.$Sg=T;function d(j){return j===n.CharCode.Slash||j===n.CharCode.Backslash}function o(j){return j.replace(/[\\/]/g,i.$lc.sep)}function u(j){return j.indexOf("/")===-1&&(j=o(j)),/^[a-zA-Z]:(\/|$)/.test(j)&&(j="/"+j),j}function h(j,M=i.$lc.sep){if(!j)return"";const D=j.length,F=j.charCodeAt(0);if(d(F)){if(d(j.charCodeAt(1))&&!d(j.charCodeAt(2))){let B=3;const z=B;for(;B<D&&!d(j.charCodeAt(B));B++);if(z!==B&&!d(j.charCodeAt(B+1))){for(B+=1;B<D;B++)if(d(j.charCodeAt(B)))return j.slice(0,B+1).replace(/[\\/]/g,M)}}return M}else if(N(F)&&j.charCodeAt(1)===n.CharCode.Colon)return d(j.charCodeAt(2))?j.slice(0,2)+M:j.slice(0,2);let y=j.indexOf("://");if(y!==-1){for(y+=3;y<D;y++)if(d(j.charCodeAt(y)))return j.slice(0,y+1)}return""}function $(j){if(!p.$l||!j||j.length<5)return!1;let M=j.charCodeAt(0);if(M!==n.CharCode.Backslash||(M=j.charCodeAt(1),M!==n.CharCode.Backslash))return!1;let D=2;const F=D;for(;D<j.length&&(M=j.charCodeAt(D),M!==n.CharCode.Backslash);D++);return!(F===D||(M=j.charCodeAt(D+1),isNaN(M)||M===n.CharCode.Backslash))}const b=/[\\/:\*\?"<>\|]/g,c=/[/]/g,e=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(j,M=p.$l){const D=M?b:c;return!(!j||j.length===0||/^\s+$/.test(j)||(D.lastIndex=0,D.test(j))||M&&e.test(j)||j==="."||j===".."||M&&j[j.length-1]==="."||M&&j.length!==j.trim().length||j.length>255)}function g(j,M,D){const F=j===M;return!D||F?F:!j||!M?!1:(0,m.$Kf)(j,M)}function L(j,M,D,F=i.sep){if(j===M)return!0;if(!j||!M||M.length>j.length)return!1;if(D){if(!(0,m.$Lf)(j,M))return!1;if(M.length===j.length)return!0;let B=M.length;return M.charAt(M.length-1)===F&&B--,j.charAt(B)===F}return M.charAt(M.length-1)!==F&&(M+=F),j.indexOf(M)===0}function N(j){return j>=n.CharCode.A&&j<=n.CharCode.Z||j>=n.CharCode.a&&j<=n.CharCode.z}function E(j,M){return p.$l&&j.endsWith(":")&&(j+=i.sep),(0,i.$nc)(j)||(j=(0,i.$oc)(M,j)),j=(0,i.$mc)(j),_(j)}function _(j){return p.$l?(j=(0,m.$sf)(j,i.sep),j.endsWith(":")&&(j+=i.sep)):(j=(0,m.$sf)(j,i.sep),j||(j=i.sep)),j}function w(j){const M=(0,i.$mc)(j);return p.$l?j.length>3?!1:a(M)&&(j.length===2||M.charCodeAt(2)===n.CharCode.Backslash):M===i.$lc.sep}function a(j,M=p.$l){return M?N(j.charCodeAt(0))&&j.charCodeAt(1)===n.CharCode.Colon:!1}function s(j,M=p.$l){return a(j,M)?j[0]:void 0}function f(j,M,D){return M.length>j.length?-1:j===M?0:(D&&(j=j.toLowerCase(),M=M.toLowerCase()),j.indexOf(M))}function v(j){const M=j.split(":");let D,F,y;for(const B of M){const z=Number(B);(0,A.$ng)(z)?F===void 0?F=z:y===void 0&&(y=z):D=D?[D,B].join(":"):B}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:F!==void 0?F:void 0,column:y!==void 0?y:F!==void 0?1:void 0}}const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",R="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function T(j,M,D=8){let F="";for(let B=0;B<D;B++){let z;B===0&&p.$l&&!M&&(D===3||D===4)?z=R:z=k,F+=z.charAt(Math.floor(Math.random()*z.length))}let y;return M?y=`${M}-${F}`:y=F,j?(0,i.$oc)(j,y):y}}),ie(re[14],ue([0,1,3,46,18,8]),function(W,t,n,i,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$Ac=g,t.$Bc=a,p=De(p);const A=/^\w[\w\d+.-]*$/,d=/^\//,o=/^\/\//;function u(R,T){if(!R.scheme&&T)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!A.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!d.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(o.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(R,T){return!R&&!T?"file":R}function $(R,T){switch(R){case"https":case"http":case"file":T?T[0]!==c&&(T=c+T):T=c;break}return T}const b="",c="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(T){return T instanceof l?!0:T?typeof T.authority=="string"&&typeof T.fragment=="string"&&typeof T.path=="string"&&typeof T.query=="string"&&typeof T.scheme=="string"&&typeof T.fsPath=="string"&&typeof T.with=="function"&&typeof T.toString=="function":!1}constructor(T,j,M,D,F,y=!1){typeof T=="object"?(this.scheme=T.scheme||b,this.authority=T.authority||b,this.path=T.path||b,this.query=T.query||b,this.fragment=T.fragment||b):(this.scheme=h(T,y),this.authority=j||b,this.path=$(this.scheme,M||b),this.query=D||b,this.fragment=F||b,u(this,y))}get fsPath(){return a(this,!1)}with(T){if(!T)return this;let{scheme:j,authority:M,path:D,query:F,fragment:y}=T;return j===void 0?j=this.scheme:j===null&&(j=b),M===void 0?M=this.authority:M===null&&(M=b),D===void 0?D=this.path:D===null&&(D=b),F===void 0?F=this.query:F===null&&(F=b),y===void 0?y=this.fragment:y===null&&(y=b),j===this.scheme&&M===this.authority&&D===this.path&&F===this.query&&y===this.fragment?this:new N(j,M,D,F,y)}static parse(T,j=!1){const M=e.exec(T);return M?new N(M[2]||b,k(M[4]||b),k(M[5]||b),k(M[7]||b),k(M[9]||b),j):new N(b,b,b,b,b)}static file(T){let j=b;if(m.$l&&(T=T.replace(/\\/g,c)),T[0]===c&&T[1]===c){const M=T.indexOf(c,2);M===-1?(j=T.substring(2),T=c):(j=T.substring(2,M),T=T.substring(M)||c)}return new N("file",j,T,b,b)}static from(T,j){return new N(T.scheme,T.authority,T.path,T.query,T.fragment,j)}static joinPath(T,...j){if(!T.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return m.$l&&T.scheme==="file"?M=l.file(p.$kc.join(a(T,!0),...j)).path:M=p.$lc.join(T.path,...j),T.with({path:M})}toString(T=!1){return s(this,T)}toJSON(){return this}static revive(T){if(T){if(T instanceof l)return T;{const j=new N(T);return j._formatted=T.external??null,j._fsPath=T._sep===L?T.fsPath??null:null,j}}else return T}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}t.URI=l;function g(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}const L=m.$l?1:void 0;class N extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(T=!1){return T?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const T={$mid:i.MarshalledId.Uri};return this._fsPath&&(T.fsPath=this._fsPath,T._sep=L),this._formatted&&(T.external=this._formatted),this.path&&(T.path=this.path),this.scheme&&(T.scheme=this.scheme),this.authority&&(T.authority=this.authority),this.query&&(T.query=this.query),this.fragment&&(T.fragment=this.fragment),T}}const E={[n.CharCode.Colon]:"%3A",[n.CharCode.Slash]:"%2F",[n.CharCode.QuestionMark]:"%3F",[n.CharCode.Hash]:"%23",[n.CharCode.OpenSquareBracket]:"%5B",[n.CharCode.CloseSquareBracket]:"%5D",[n.CharCode.AtSign]:"%40",[n.CharCode.ExclamationMark]:"%21",[n.CharCode.DollarSign]:"%24",[n.CharCode.Ampersand]:"%26",[n.CharCode.SingleQuote]:"%27",[n.CharCode.OpenParen]:"%28",[n.CharCode.CloseParen]:"%29",[n.CharCode.Asterisk]:"%2A",[n.CharCode.Plus]:"%2B",[n.CharCode.Comma]:"%2C",[n.CharCode.Semicolon]:"%3B",[n.CharCode.Equals]:"%3D",[n.CharCode.Space]:"%20"};function _(R,T,j){let M,D=-1;for(let F=0;F<R.length;F++){const y=R.charCodeAt(F);if(y>=n.CharCode.a&&y<=n.CharCode.z||y>=n.CharCode.A&&y<=n.CharCode.Z||y>=n.CharCode.Digit0&&y<=n.CharCode.Digit9||y===n.CharCode.Dash||y===n.CharCode.Period||y===n.CharCode.Underline||y===n.CharCode.Tilde||T&&y===n.CharCode.Slash||j&&y===n.CharCode.OpenSquareBracket||j&&y===n.CharCode.CloseSquareBracket||j&&y===n.CharCode.Colon)D!==-1&&(M+=encodeURIComponent(R.substring(D,F)),D=-1),M!==void 0&&(M+=R.charAt(F));else{M===void 0&&(M=R.substr(0,F));const B=E[y];B!==void 0?(D!==-1&&(M+=encodeURIComponent(R.substring(D,F)),D=-1),M+=B):D===-1&&(D=F)}}return D!==-1&&(M+=encodeURIComponent(R.substring(D))),M!==void 0?M:R}function w(R){let T;for(let j=0;j<R.length;j++){const M=R.charCodeAt(j);M===n.CharCode.Hash||M===n.CharCode.QuestionMark?(T===void 0&&(T=R.substr(0,j)),T+=E[M]):T!==void 0&&(T+=R[j])}return T!==void 0?T:R}function a(R,T){let j;return R.authority&&R.path.length>1&&R.scheme==="file"?j=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===n.CharCode.Slash&&(R.path.charCodeAt(1)>=n.CharCode.A&&R.path.charCodeAt(1)<=n.CharCode.Z||R.path.charCodeAt(1)>=n.CharCode.a&&R.path.charCodeAt(1)<=n.CharCode.z)&&R.path.charCodeAt(2)===n.CharCode.Colon?T?j=R.path.substr(1):j=R.path[1].toLowerCase()+R.path.substr(2):j=R.path,m.$l&&(j=j.replace(/\//g,"\\")),j}function s(R,T){const j=T?w:_;let M="",{scheme:D,authority:F,path:y,query:B,fragment:z}=R;if(D&&(M+=D,M+=":"),(F||D==="file")&&(M+=c,M+=c),F){let H=F.indexOf("@");if(H!==-1){const U=F.substr(0,H);F=F.substr(H+1),H=U.lastIndexOf(":"),H===-1?M+=j(U,!1,!1):(M+=j(U.substr(0,H),!1,!1),M+=":",M+=j(U.substr(H+1),!1,!0)),M+="@"}F=F.toLowerCase(),H=F.lastIndexOf(":"),H===-1?M+=j(F,!1,!0):(M+=j(F.substr(0,H),!1,!0),M+=F.substr(H))}if(y){if(y.length>=3&&y.charCodeAt(0)===n.CharCode.Slash&&y.charCodeAt(2)===n.CharCode.Colon){const H=y.charCodeAt(1);H>=n.CharCode.A&&H<=n.CharCode.Z&&(y=`/${String.fromCharCode(H+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===n.CharCode.Colon){const H=y.charCodeAt(0);H>=n.CharCode.A&&H<=n.CharCode.Z&&(y=`${String.fromCharCode(H+32)}:${y.substr(2)}`)}M+=j(y,!0,!1)}return B&&(M+="?",M+=j(B,!1,!1)),z&&(M+="#",M+=T?z:_(z,!1,!1)),M}function f(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+f(R.substr(3)):R}}const v=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function k(R){return R.match(v)?R.replace(v,T=>f(T)):R}}),ie(re[24],ue([0,1,4,8,6,14,18]),function(W,t,n,i,p,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Xg=t.$Wg=t.$Vg=t.Schemas=void 0,t.$Tg=o,t.$Ug=u,t.$Yg=$,n=De(n),i=De(i),A=De(A);var d;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",e.vscodeNotebookMetadata="vscode-notebook-metadata",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting",e.outputChannel="output"})(d||(t.Schemas=d={}));function o(e,l){return m.URI.isUri(e)?(0,p.$Kf)(e.scheme,l):(0,p.$Lf)(e,l+":")}function u(e,...l){return l.some(g=>o(e,g))}t.$Vg="vscode-tkn",t.$Wg="tkn";class h{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(l){this.d=l}setDelegate(l){this.e=l}setServerRootPath(l,g){this.f=$(l,g)}getServerRootPath(){return this.f}get g(){return A.$lc.join(this.f,d.vscodeRemoteResource)}set(l,g,L){this.a[l]=g,this.b[l]=L}setConnectionToken(l,g){this.c[l]=g}getPreferredWebSchema(){return this.d}rewrite(l){if(this.e)try{return this.e(l)}catch(w){return n.$4(w),l}const g=l.authority;let L=this.a[g];L&&L.indexOf(":")!==-1&&L.indexOf("[")===-1&&(L=`[${L}]`);const N=this.b[g],E=this.c[g];let _=`path=${encodeURIComponent(l.path)}`;return typeof E=="string"&&(_+=`&${t.$Wg}=${encodeURIComponent(E)}`),m.URI.from({scheme:i.$r?this.d:d.vscodeRemoteResource,authority:`${L}:${N}`,path:this.g,query:_})}}t.$Xg=new h;function $(e,l){return A.$lc.join(l??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.$Zg="vs/../../extensions",t.$1g="vs/../../node_modules",t.$2g="vs/../../node_modules.asar",t.$3g="vs/../../node_modules.asar.unpacked",t.$4g="vscode-app";class b{static{this.a=t.$4g}asBrowserUri(l){const g=this.b(l,W);return this.uriToBrowserUri(g)}uriToBrowserUri(l){return l.scheme===d.vscodeRemote?t.$Xg.rewrite(l):l.scheme===d.file&&(i.$p||i.$t===`${d.vscodeFileResource}://${b.a}`)?l.with({scheme:d.vscodeFileResource,authority:l.authority||b.a,query:null,fragment:null}):l}asFileUri(l){const g=this.b(l,W);return this.uriToFileUri(g)}uriToFileUri(l){return l.scheme===d.vscodeFileResource?l.with({scheme:d.file,authority:l.authority!==b.a?l.authority:null,query:null,fragment:null}):l}b(l,g){if(m.URI.isUri(l))return l;if(globalThis._VSCODE_FILE_ROOT){const L=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(L))return m.URI.joinPath(m.URI.parse(L,!0),l);const N=A.$oc(L,l);return m.URI.file(N)}return m.URI.parse(g.toUrl(l))}}t.$5g=new b;var c;(function(e){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(l.get("3"));const g="vscode-coi";function L(E){let _;typeof E=="string"?_=new URL(E).searchParams:E instanceof URL?_=E.searchParams:m.URI.isUri(E)&&(_=new URL(E.toString(!0)).searchParams);const w=_?.get(g);if(w)return l.get(w)}e.getHeadersFromQuery=L;function N(E,_,w){if(!globalThis.crossOriginIsolated)return;const a=_&&w?"3":w?"2":"1";E instanceof URLSearchParams?E.set(g,a):E[g]=a}e.addSearchParam=N})(c||(t.COI=c={}))}),ie(re[78],ue([0,1,3,77,24,18,8,6,14]),function(W,t,n,i,p,m,A,d,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.$th=t.$sh=t.$rh=t.$qh=t.$ph=t.$oh=t.$nh=t.$mh=t.$lh=t.$kh=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=void 0,t.$_g=u,t.$uh=$,t.$vh=c,i=De(i),m=De(m);function u(e){return(0,o.$Bc)(e,!0)}class h{constructor(l){this.a=l}compare(l,g,L=!1){return l===g?0:(0,d.$Df)(this.getComparisonKey(l,L),this.getComparisonKey(g,L))}isEqual(l,g,L=!1){return l===g?!0:!l||!g?!1:this.getComparisonKey(l,L)===this.getComparisonKey(g,L)}getComparisonKey(l,g=!1){return l.with({path:this.a(l)?l.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(l){return this.a(l)}isEqualOrParent(l,g,L=!1){if(l.scheme===g.scheme){if(l.scheme===p.Schemas.file)return i.$Jg(u(l),u(g),this.a(l))&&l.query===g.query&&(L||l.fragment===g.fragment);if((0,t.$qh)(l.authority,g.authority))return i.$Jg(l.path,g.path,this.a(l),"/")&&l.query===g.query&&(L||l.fragment===g.fragment)}return!1}joinPath(l,...g){return o.URI.joinPath(l,...g)}basenameOrAuthority(l){return(0,t.$ih)(l)||l.authority}basename(l){return m.$lc.basename(l.path)}extname(l){return m.$lc.extname(l.path)}dirname(l){if(l.path.length===0)return l;let g;return l.scheme===p.Schemas.file?g=o.URI.file(m.$rc(u(l))).path:(g=m.$lc.dirname(l.path),l.authority&&g.length&&g.charCodeAt(0)!==n.CharCode.Slash&&(console.error(`dirname("${l.toString})) resulted in a relative path`),g="/")),l.with({path:g})}normalizePath(l){if(!l.path.length)return l;let g;return l.scheme===p.Schemas.file?g=o.URI.file(m.$mc(u(l))).path:g=m.$lc.normalize(l.path),l.with({path:g})}relativePath(l,g){if(l.scheme!==g.scheme||!(0,t.$qh)(l.authority,g.authority))return;if(l.scheme===p.Schemas.file){const E=m.$qc(u(l),u(g));return A.$l?i.$Dg(E):E}let L=l.path||"/";const N=g.path||"/";if(this.a(l)){let E=0;for(const _=Math.min(L.length,N.length);E<_&&!(L.charCodeAt(E)!==N.charCodeAt(E)&&L.charAt(E).toLowerCase()!==N.charAt(E).toLowerCase());E++);L=N.substr(0,E)+L.substr(E)}return m.$lc.relative(L,N)}resolvePath(l,g){if(l.scheme===p.Schemas.file){const L=o.URI.file(m.$pc(u(l),g));return l.with({authority:L.authority,path:L.path})}return g=i.$Eg(g),l.with({path:m.$lc.resolve(l.path,g)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,g){return l===g||l!==void 0&&g!==void 0&&(0,d.$Kf)(l,g)}hasTrailingPathSeparator(l,g=m.sep){if(l.scheme===p.Schemas.file){const L=u(l);return L.length>i.$Fg(L).length&&L[L.length-1]===g}else{const L=l.path;return L.length>1&&L.charCodeAt(L.length-1)===n.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,g=m.sep){return(0,t.$rh)(l,g)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,g=m.sep){let L=!1;if(l.scheme===p.Schemas.file){const N=u(l);L=N!==void 0&&N.length===i.$Fg(N).length&&N[N.length-1]===g}else{g="/";const N=l.path;L=N.length===1&&N.charCodeAt(N.length-1)===n.CharCode.Slash}return!L&&!(0,t.$rh)(l,g)?l.with({path:l.path+"/"}):l}}t.$ah=h,t.$bh=new h(()=>!1),t.$ch=new h(e=>e.scheme===p.Schemas.file?!A.$n:!0),t.$dh=new h(e=>!0),t.$eh=t.$bh.isEqual.bind(t.$bh),t.$fh=t.$bh.isEqualOrParent.bind(t.$bh),t.$gh=t.$bh.getComparisonKey.bind(t.$bh),t.$hh=t.$bh.basenameOrAuthority.bind(t.$bh),t.$ih=t.$bh.basename.bind(t.$bh),t.$jh=t.$bh.extname.bind(t.$bh),t.$kh=t.$bh.dirname.bind(t.$bh),t.$lh=t.$bh.joinPath.bind(t.$bh),t.$mh=t.$bh.normalizePath.bind(t.$bh),t.$nh=t.$bh.relativePath.bind(t.$bh),t.$oh=t.$bh.resolvePath.bind(t.$bh),t.$ph=t.$bh.isAbsolutePath.bind(t.$bh),t.$qh=t.$bh.isEqualAuthority.bind(t.$bh),t.$rh=t.$bh.hasTrailingPathSeparator.bind(t.$bh),t.$sh=t.$bh.removeTrailingPathSeparator.bind(t.$bh),t.$th=t.$bh.addTrailingPathSeparator.bind(t.$bh);function $(e,l){const g=[];for(let L=0;L<e.length;L++){const N=l(e[L]);e.some((E,_)=>_===L?!1:(0,t.$fh)(N,l(E)))||g.push(e[L])}return g}var b;(function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime";function l(g){const L=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(_=>{const[w,a]=_.split(":");w&&a&&L.set(w,a)});const E=g.path.substring(0,g.path.indexOf(";"));return E&&L.set(e.META_DATA_MIME,E),L}e.parseMetaData=l})(b||(t.DataUri=b={}));function c(e,l,g){if(l){let L=e.path;return L&&L[0]!==m.$lc.sep&&(L=m.$lc.sep+L),e.with({scheme:g,authority:l,path:L})}return e.with({scheme:g})}}),ie(re[79],ue([0,1,20,4,12,10,78,8,48,27]),function(W,t,n,i,p,m,A,d,o,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bi=t.$_h=t.$$h=t.$0h=t.$9h=t.Promises=t.$8h=t.$7h=t.$6h=t.$4h=t.$3h=t.$2h=t.$1h=t.$Zh=t.$Yh=t.$Xh=t.$Wh=t.$Vh=t.$Uh=t.$Th=t.$Sh=t.$Rh=t.$Qh=t.$Kh=t.$Jh=t.$Ih=t.$Hh=t.$Gh=t.$Fh=t.$Eh=void 0,t.$wh=h,t.$xh=$,t.$yh=b,t.$zh=c,t.$Ah=e,t.$Bh=l,t.$Ch=g,t.$Dh=L,t.$Lh=R,t.$Mh=T,t.$Nh=j,t.$Oh=M,t.$Ph=D,t.$5h=X,t.$ai=x;function h(O){return!!O&&typeof O.then=="function"}function $(O){const I=new n.$Be,q=O(I.token),Z=new Promise((Q,ae)=>{const we=I.token.onCancellationRequested(()=>{we.dispose(),ae(new i.$9)});Promise.resolve(q).then(Ee=>{we.dispose(),I.dispose(),Q(Ee)},Ee=>{we.dispose(),I.dispose(),ae(Ee)})});return new class{cancel(){I.cancel(),I.dispose()}then(Q,ae){return Z.then(Q,ae)}catch(Q){return this.then(void 0,Q)}finally(Q){return Z.finally(Q)}}}function b(O,I,q){return new Promise((Z,Q)=>{const ae=I.onCancellationRequested(()=>{ae.dispose(),Z(q)});O.then(Z,Q).finally(()=>ae.dispose())})}function c(O,I){return new Promise((q,Z)=>{const Q=I.onCancellationRequested(()=>{Q.dispose(),Z(new i.$9)});O.then(q,Z).finally(()=>Q.dispose())})}async function e(O){let I=-1;const q=O.map((Z,Q)=>Z.then(ae=>(I=Q,ae)));try{return await Promise.race(q)}finally{O.forEach((Z,Q)=>{Q!==I&&Z.cancel()})}}function l(O,I,q){let Z;const Q=setTimeout(()=>{Z?.(void 0),q?.()},I);return Promise.race([O.finally(()=>clearTimeout(Q)),new Promise(ae=>Z=ae)])}function g(O){return new Promise((I,q)=>{const Z=O();h(Z)?Z.then(I,q):I(Z)})}function L(){let O,I;return{promise:new Promise((Z,Q)=>{O=Z,I=Q}),resolve:O,reject:I}}class N{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(I){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=I,!this.b){const q=()=>{if(this.b=null,this.f)return;const Z=this.queue(this.d);return this.d=null,Z};this.b=new Promise(Z=>{this.a.then(q,q).then(Z)})}return new Promise((q,Z)=>{this.b.then(q,Z)})}return this.a=I(),new Promise((q,Z)=>{this.a.then(Q=>{this.a=null,q(Q)},Q=>{this.a=null,Z(Q)})})}dispose(){this.f=!0}}t.$Eh=N;class E{constructor(){this.a=Promise.resolve(null)}queue(I){return this.a=this.a.then(()=>I(),()=>I())}}t.$Fh=E;class _{constructor(){this.a=new Map}queue(I,q){const Q=(this.a.get(I)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.a.get(I)===Q&&this.a.delete(I)});return this.a.set(I,Q),Q}}t.$Gh=_;const w=(O,I)=>{let q=!0;const Z=setTimeout(()=>{q=!1,I()},O);return{isTriggered:()=>q,dispose:()=>{clearTimeout(Z),q=!1}}},a=O=>{let I=!0;return queueMicrotask(()=>{I&&(I=!1,O())}),{isTriggered:()=>I,dispose:()=>{I=!1}}};class s{constructor(I){this.defaultDelay=I,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(I,q=this.defaultDelay){this.g=I,this.h(),this.b||(this.b=new Promise((Q,ae)=>{this.d=Q,this.f=ae}).then(()=>{if(this.b=null,this.d=null,this.g){const Q=this.g;return this.g=null,Q()}}));const Z=()=>{this.a=null,this.d?.(null)};return this.a=q===o.$le?a(Z):w(q,Z),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new i.$9),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Hh=s;class f{constructor(I){this.a=new s(I),this.b=new N}trigger(I,q){return this.a.trigger(()=>this.b.queue(I),q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Ih=f;class v{constructor(){this.a=!1,this.b=new Promise((I,q)=>{this.d=I})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Jh=v;class k extends v{constructor(I){super(),this.f=setTimeout(()=>this.open(),I)}open(){clearTimeout(this.f),super.open()}}t.$Kh=k;function R(O,I){return I?new Promise((q,Z)=>{const Q=setTimeout(()=>{ae.dispose(),q()},O),ae=I.onCancellationRequested(()=>{clearTimeout(Q),ae.dispose(),Z(new i.$9)})}):$(q=>R(O,q))}function T(O,I=0,q){const Z=setTimeout(()=>{O(),q&&Q.dispose()},I),Q=(0,m.$Xc)(()=>{clearTimeout(Z),q?.deleteAndLeak(Q)});return q?.add(Q),Q}function j(O){const I=[];let q=0;const Z=O.length;function Q(){return q<Z?O[q++]():null}function ae(we){we!=null&&I.push(we);const Ee=Q();return Ee?Ee.then(ae):Promise.resolve(I)}return Promise.resolve(null).then(ae)}function M(O,I=Z=>!!Z,q=null){let Z=0;const Q=O.length,ae=()=>{if(Z>=Q)return Promise.resolve(q);const we=O[Z++];return Promise.resolve(we()).then(Re=>I(Re)?Promise.resolve(Re):ae())};return ae()}function D(O,I=Z=>!!Z,q=null){if(O.length===0)return Promise.resolve(q);let Z=O.length;const Q=()=>{Z=-1;for(const ae of O)ae.cancel?.()};return new Promise((ae,we)=>{for(const Ee of O)Ee.then(Re=>{--Z>=0&&I(Re)?(Q(),ae(Re)):Z===0&&ae(q)}).catch(Re=>{--Z>=0&&(Q(),we(Re))})})}class F{constructor(I){this.a=0,this.b=!1,this.f=I,this.g=[],this.d=0,this.h=new p.$qe}whenIdle(){return this.size>0?p.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(I){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((q,Z)=>{this.g.push({factory:I,c:q,e:Z}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const I=this.g.shift();this.d++;const q=I.factory();q.then(I.c,I.e),q.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$Qh=F;class y extends F{constructor(){super(1)}}t.$Rh=y;class B{constructor(){this.a=new he,this.b=0}queue(I){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,I())):this.a.run(this.b++,I())}}t.$Sh=B;class z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const I=new r;return this.b.add(I),I.p}g(){for(const[,I]of this.a)if(I.size>0)return!1;return!0}queueSize(I,q=A.$bh){const Z=q.getComparisonKey(I);return this.a.get(Z)?.size??0}queueFor(I,q,Z=A.$bh){const Q=Z.getComparisonKey(I);let ae=this.a.get(Q);if(!ae){ae=new y;const we=this.f++,Ee=p.Event.once(ae.onDrained)(()=>{ae?.dispose(),this.a.delete(Q),this.h(),this.d?.deleteAndDispose(we),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new m.$9c),this.d.set(we,Ee),this.a.set(Q,ae)}return ae.queue(q)}h(){this.g()&&this.j()}j(){for(const I of this.b)I.complete();this.b.clear()}dispose(){for(const[,I]of this.a)I.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$Th=z;class H{constructor(I,q){this.b=!1,this.a=-1,typeof I=="function"&&typeof q=="number"&&this.setIfNotSet(I,q)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(I,q){if(this.b)throw new i.$gb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,I()},q)}setIfNotSet(I,q){if(this.b)throw new i.$gb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,I()},q))}}t.$Uh=H;class U{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(I,q,Z=globalThis){if(this.f)throw new i.$gb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const Q=Z.setInterval(()=>{I()},q);this.d=(0,m.$Xc)(()=>{Z.clearInterval(Q),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}t.$Vh=U;class C{constructor(I,q){this.b=-1,this.a=I,this.d=q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(I=this.d){this.cancel(),this.b=setTimeout(this.f,I)}get delay(){return this.d}set delay(I){this.d=I}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$Wh=C;class ee{constructor(I,q){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.a=I,this.b=q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(I=this.b){I%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${I}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(I/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$Xh=ee;class J extends C{constructor(I,q){super(I,q),this.j=[]}work(I){this.j.push(I),this.isScheduled()||this.schedule()}h(){const I=this.j;this.j=[],this.a?.(I)}dispose(){this.j=[],super.dispose()}}t.$Yh=J;class K extends m.$Zc{constructor(I,q){super(),this.g=I,this.h=q,this.a=[],this.b=this.B(new m.$1c),this.f=!1}get pending(){return this.a.length}work(I){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+I.length>this.g.maxBufferedWork)return!1}else if(this.pending+I.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const q of I)this.a.push(q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new C(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$Zh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$2h=(O,I)=>{(0,d.$E)(()=>{if(q)return;const Z=Date.now()+15;I(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Z-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:t.$2h=(O,I,q)=>{const Z=O.requestIdleCallback(I,typeof q=="number"?{timeout:q}:void 0);let Q=!1;return{dispose(){Q||(Q=!0,O.cancelIdleCallback(Z))}}},t.$1h=O=>(0,t.$2h)(globalThis,O)}();class ne{constructor(I,q){this.g=!1,this.d=()=>{try{this.j=q()}catch(Z){this.l=Z}finally{this.g=!0}},this.f=(0,t.$2h)(I,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$3h=ne;class P extends ne{constructor(I){super(globalThis,I)}}t.$4h=P;async function X(O,I,q){let Z;for(let Q=0;Q<q;Q++)try{return await O()}catch(ae){Z=ae,await R(I)}throw Z}class he{isRunning(I){return typeof I=="number"?this.a?.taskId===I:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(I,q,Z){return this.a={taskId:I,cancel:()=>Z?.(),promise:q},q.then(()=>this.d(I),()=>this.d(I)),q}d(I){this.a&&I===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const I=this.b;this.b=void 0,I.run().then(I.promiseResolve,I.promiseReject)}}queue(I){if(this.b)this.b.run=I;else{const{promise:q,resolve:Z,reject:Q}=L();this.b={run:I,promise:q,promiseResolve:Z,promiseReject:Q}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$6h=he;class ge{constructor(I,q=()=>Date.now()){this.d=I,this.f=q,this.a=0,this.b=0}increment(){const I=this.f();return I-this.a>this.d&&(this.a=I,this.b=0),this.b++,this.b}}t.$7h=ge;var Le;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(Le||(Le={}));class r{get isRejected(){return this.d?.outcome===Le.Rejected}get isResolved(){return this.d?.outcome===Le.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===Le.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((I,q)=>{this.a=I,this.b=q})}complete(I){return new Promise(q=>{this.a(I),this.d={outcome:Le.Resolved,value:I},q()})}error(I){return new Promise(q=>{this.b(I),this.d={outcome:Le.Rejected,value:I},q()})}cancel(){return this.error(new i.$9)}}t.$8h=r;var Me;(function(O){async function I(Z){let Q;const ae=await Promise.all(Z.map(we=>we.then(Ee=>Ee,Ee=>{Q||(Q=Ee)})));if(typeof Q<"u")throw Q;return ae}O.settled=I;function q(Z){return new Promise(async(Q,ae)=>{try{await Z(Q,ae)}catch(we){ae(we)}})}O.withAsyncBody=q})(Me||(t.Promises=Me={}));class Fe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(I){this.a=void 0,this.b=void 0,this.d=!1,this.promise=I.then(q=>(this.a=q,this.d=!0,q),q=>{throw this.b=q,this.d=!0,q})}requireValue(){if(!this.d)throw new i.$gb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$9h=Fe;class Ue{constructor(I){this.b=I,this.a=new u.$Y(()=>new Fe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$0h=Ue;var Ae;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(Ae||(Ae={}));class Ne{static fromArray(I){return new Ne(q=>{q.emitMany(I)})}static fromPromise(I){return new Ne(async q=>{q.emitMany(await I)})}static fromPromises(I){return new Ne(async q=>{await Promise.all(I.map(async Z=>q.emitOne(await Z)))})}static merge(I){return new Ne(async q=>{await Promise.all(I.map(async Z=>{for await(const Q of Z)q.emitOne(Q)}))})}static{this.EMPTY=Ne.fromArray([])}constructor(I,q){this.a=Ae.Initial,this.b=[],this.d=null,this.f=q,this.g=new p.$qe,queueMicrotask(async()=>{const Z={emitOne:Q=>this.h(Q),emitMany:Q=>this.j(Q),reject:Q=>this.l(Q)};try{await Promise.resolve(I(Z)),this.k()}catch(Q){this.l(Q)}finally{Z.emitOne=void 0,Z.emitMany=void 0,Z.reject=void 0}})}[Symbol.asyncIterator](){let I=0;return{next:async()=>{do{if(this.a===Ae.DoneError)throw this.d;if(I<this.b.length)return{done:!1,value:this.b[I++]};if(this.a===Ae.DoneOK)return{done:!0,value:void 0};await p.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(I,q){return new Ne(async Z=>{for await(const Q of I)Z.emitOne(q(Q))})}map(I){return Ne.map(this,I)}static filter(I,q){return new Ne(async Z=>{for await(const Q of I)q(Q)&&Z.emitOne(Q)})}filter(I){return Ne.filter(this,I)}static coalesce(I){return Ne.filter(I,q=>!!q)}coalesce(){return Ne.coalesce(this)}static async toPromise(I){const q=[];for await(const Z of I)q.push(Z);return q}toPromise(){return Ne.toPromise(this)}h(I){this.a===Ae.Initial&&(this.b.push(I),this.g.fire())}j(I){this.a===Ae.Initial&&(this.b=this.b.concat(I),this.g.fire())}k(){this.a===Ae.Initial&&(this.a=Ae.DoneOK,this.g.fire())}l(I){this.a===Ae.Initial&&(this.a=Ae.DoneError,this.d=I,this.g.fire())}}t.$$h=Ne;class qe extends Ne{constructor(I,q){super(q),this.m=I}cancel(){this.m.cancel()}}t.$_h=qe;function x(O){const I=new n.$Be,q=O(I.token);return new qe(I,async Z=>{const Q=I.token.onCancellationRequested(()=>{Q.dispose(),I.dispose(),Z.reject(new i.$9)});try{for await(const ae of q){if(I.token.isCancellationRequested)return;Z.emitOne(ae)}Q.dispose(),I.dispose()}catch(ae){Q.dispose(),I.dispose(),Z.reject(ae)}})}class G{constructor(I){this.a=new r,this.b=new Ne(Q=>{if(q){Q.reject(q);return}return Z&&Q.emitMany(Z),this.d=ae=>Q.reject(ae),this.f=ae=>Q.emitOne(ae),this.a.p},I);let q,Z;this.f=Q=>{Z||(Z=[]),Z.push(Q)},this.d=Q=>{q||(q=Q)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(I){this.d(I),this.a.complete()}emitOne(I){this.f(I)}}t.$bi=G}),ie(re[84],ue([0,1,3,4,12,10,24,8,6]),function(W,t,n,i,p,m,A,d,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SimpleWorkerServer=t.SimpleWorkerClient=void 0,t.logOnceWebWorkerWarning=c,t.create=v,o=De(o);const u=!1,h="default",$="$initialize";let b=!1;function c(k){d.$r&&(b||(b=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(k.message))}var e;(function(k){k[k.Request=0]="Request",k[k.Reply=1]="Reply",k[k.SubscribeEvent=2]="SubscribeEvent",k[k.Event=3]="Event",k[k.UnsubscribeEvent=4]="UnsubscribeEvent"})(e||(e={}));class l{constructor(R,T,j,M,D){this.vsWorker=R,this.req=T,this.channel=j,this.method=M,this.args=D,this.type=e.Request}}class g{constructor(R,T,j,M){this.vsWorker=R,this.seq=T,this.res=j,this.err=M,this.type=e.Reply}}class L{constructor(R,T,j,M,D){this.vsWorker=R,this.req=T,this.channel=j,this.eventName=M,this.arg=D,this.type=e.SubscribeEvent}}class N{constructor(R,T,j){this.vsWorker=R,this.req=T,this.event=j,this.type=e.Event}}class E{constructor(R,T){this.vsWorker=R,this.req=T,this.type=e.UnsubscribeEvent}}class _{constructor(R){this.a=-1,this.g=R,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(R){this.a=R}sendMessage(R,T,j){const M=String(++this.b);return new Promise((D,F)=>{this.c[M]={resolve:D,reject:F},this.o(new l(this.a,M,R,T,j))})}listen(R,T,j){let M=null;const D=new p.$qe({onWillAddFirstListener:()=>{M=String(++this.b),this.d.set(M,D),this.o(new L(this.a,M,R,T,j))},onDidRemoveLastListener:()=>{this.d.delete(M),this.o(new E(this.a,M)),M=null}});return D.event}handleMessage(R){!R||!R.vsWorker||this.a!==-1&&R.vsWorker!==this.a||this.h(R)}createProxyToRemoteChannel(R,T){const j={get:(M,D)=>(typeof D=="string"&&!M[D]&&(s(D)?M[D]=F=>this.listen(R,D,F):a(D)?M[D]=this.listen(R,D,void 0):D.charCodeAt(0)===n.CharCode.DollarSign&&(M[D]=async(...F)=>(await T?.(),this.sendMessage(R,D,F)))),M[D])};return new Proxy(Object.create(null),j)}h(R){switch(R.type){case e.Reply:return this.j(R);case e.Request:return this.k(R);case e.SubscribeEvent:return this.l(R);case e.Event:return this.m(R);case e.UnsubscribeEvent:return this.n(R)}}j(R){if(!this.c[R.seq]){console.warn("Got reply to unknown seq");return}const T=this.c[R.seq];if(delete this.c[R.seq],R.err){let j=R.err;R.err.$isError&&(j=new Error,j.name=R.err.name,j.message=R.err.message,j.stack=R.err.stack),T.reject(j);return}T.resolve(R.res)}k(R){const T=R.req;this.g.handleMessage(R.channel,R.method,R.args).then(M=>{this.o(new g(this.a,T,M,void 0))},M=>{M.detail instanceof Error&&(M.detail=(0,i.$6)(M.detail)),this.o(new g(this.a,T,void 0,(0,i.$6)(M)))})}l(R){const T=R.req,j=this.g.handleEvent(R.channel,R.eventName,R.arg)(M=>{this.o(new N(this.a,T,M))});this.f.set(T,j)}m(R){if(!this.d.has(R.req)){console.warn("Got event for unknown req");return}this.d.get(R.req).fire(R.event)}n(R){if(!this.f.has(R.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(R.req).dispose(),this.f.delete(R.req)}o(R){const T=[];if(R.type===e.Request)for(let j=0;j<R.args.length;j++)R.args[j]instanceof ArrayBuffer&&T.push(R.args[j]);else R.type===e.Reply&&R.res instanceof ArrayBuffer&&T.push(R.res);this.g.sendMessage(R,T)}}class w extends m.$Zc{constructor(R,T){super(),this.f=new Map,this.g=new Map,this.a=this.B(R.create({amdModuleId:"vs/base/common/worker/simpleWorker",esmModuleLocation:T.esmModuleLocation,label:T.label},D=>{this.c.handleMessage(D)},D=>{(0,i.$4)(D)})),this.c=new _({sendMessage:(D,F)=>{this.a.postMessage(D,F)},handleMessage:(D,F,y)=>this.h(D,F,y),handleEvent:(D,F,y)=>this.j(D,F,y)}),this.c.setWorkerId(this.a.getId());let j=null;const M=globalThis.require;typeof M<"u"&&typeof M.getConfig=="function"?j=M.getConfig():typeof globalThis.requirejs<"u"&&(j=globalThis.requirejs.s.contexts._.config),this.b=this.c.sendMessage(h,$,[this.a.getId(),JSON.parse(JSON.stringify(j)),T.amdModuleId]),this.proxy=this.c.createProxyToRemoteChannel(h,async()=>{await this.b}),this.b.catch(D=>{this.m("Worker failed to load "+T.amdModuleId,D)})}h(R,T,j){const M=this.f.get(R);if(!M)return Promise.reject(new Error(`Missing channel ${R} on main thread`));if(typeof M[T]!="function")return Promise.reject(new Error(`Missing method ${T} on main thread channel ${R}`));try{return Promise.resolve(M[T].apply(M,j))}catch(D){return Promise.reject(D)}}j(R,T,j){const M=this.f.get(R);if(!M)throw new Error(`Missing channel ${R} on main thread`);if(s(T)){const D=M[T].call(M,j);if(typeof D!="function")throw new Error(`Missing dynamic event ${T} on main thread channel ${R}.`);return D}if(a(T)){const D=M[T];if(typeof D!="function")throw new Error(`Missing event ${T} on main thread channel ${R}.`);return D}throw new Error(`Malformed event name ${T}`)}setChannel(R,T){this.f.set(R,T)}getChannel(R){if(!this.g.has(R)){const T=this.c.createProxyToRemoteChannel(R,async()=>{await this.b});this.g.set(R,T)}return this.g.get(R)}m(R,T){console.error(R),console.info(T)}}t.SimpleWorkerClient=w;function a(k){return k[0]==="o"&&k[1]==="n"&&o.$Jf(k.charCodeAt(2))}function s(k){return/^onDynamic/.test(k)&&o.$Jf(k.charCodeAt(9))}class f{constructor(R,T){this.d=new Map,this.f=new Map,this.a=T,this.b=null,this.c=new _({sendMessage:(j,M)=>{R(j,M)},handleMessage:(j,M,D)=>this.g(j,M,D),handleEvent:(j,M,D)=>this.h(j,M,D)})}onmessage(R){this.c.handleMessage(R)}g(R,T,j){if(R===h&&T===$)return this.j(j[0],j[1],j[2]);const M=R===h?this.b:this.d.get(R);if(!M)return Promise.reject(new Error(`Missing channel ${R} on worker thread`));if(typeof M[T]!="function")return Promise.reject(new Error(`Missing method ${T} on worker thread channel ${R}`));try{return Promise.resolve(M[T].apply(M,j))}catch(D){return Promise.reject(D)}}h(R,T,j){const M=R===h?this.b:this.d.get(R);if(!M)throw new Error(`Missing channel ${R} on worker thread`);if(s(T)){const D=M[T].call(M,j);if(typeof D!="function")throw new Error(`Missing dynamic event ${T} on request handler.`);return D}if(a(T)){const D=M[T];if(typeof D!="function")throw new Error(`Missing event ${T} on request handler.`);return D}throw new Error(`Malformed event name ${T}`)}setChannel(R,T){this.d.set(R,T)}getChannel(R){if(!this.f.has(R)){const T=this.c.createProxyToRemoteChannel(R);this.f.set(R,T)}return this.f.get(R)}async j(R,T,j){if(this.c.setWorkerId(R),this.a){this.b=this.a(this);return}if(T&&(typeof T.baseUrl<"u"&&delete T.baseUrl,typeof T.paths<"u"&&typeof T.paths.vs<"u"&&delete T.paths.vs,typeof T.trustedTypesPolicy<"u"&&delete T.trustedTypesPolicy,T.catchError=!0,globalThis.require.config(T)),u){const M=A.$5g.asBrowserUri(`${j}.js`).toString(!0);return new Promise((D,F)=>{W([`${M}`],D,F)}).then(De).then(D=>{if(this.b=D.create(this),!this.b)throw new Error("No RequestHandler!")})}return new Promise((M,D)=>{(globalThis.require||W)([j],y=>{if(this.b=y.create(this),!this.b){D(new Error("No RequestHandler!"));return}M()},D)})}}t.SimpleWorkerServer=f;function v(k){return new f(k,null)}}),ie(re[80],ue([0,1,50,14,52,2,75,41]),function(W,t,n,i,p,m,A,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineEditTriggerKind=t.ExternalUriOpenerPriority=t.$1u=t.$Zu=t.$Yu=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadApplicability=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.NewSymbolNameTriggerKind=t.NewSymbolNameTag=t.$Xu=t.$Wu=t.SymbolKinds=t.SymbolTag=t.$Uu=t.SymbolKind=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.DocumentPasteTriggerKind=t.CodeActionTriggerType=t.$Su=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.PartialAcceptTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.HoverVerbosityAction=t.$Ru=t.$Qu=t.$Pu=void 0,t.$Tu=f,t.$Vu=k;class o{constructor(X,he,ge){this.offset=X,this.type=he,this.language=ge,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$Pu=o;class u{constructor(X,he){this.tokens=X,this.endState=he,this._tokenizationResultBrand=void 0}}t.$Qu=u;class h{constructor(X,he){this.tokens=X,this.endState=he,this._encodedTokenizationResultBrand=void 0}}t.$Ru=h;var $;(function(P){P[P.Increase=0]="Increase",P[P.Decrease=1]="Decrease"})($||(t.HoverVerbosityAction=$={}));var b;(function(P){P[P.Method=0]="Method",P[P.Function=1]="Function",P[P.Constructor=2]="Constructor",P[P.Field=3]="Field",P[P.Variable=4]="Variable",P[P.Class=5]="Class",P[P.Struct=6]="Struct",P[P.Interface=7]="Interface",P[P.Module=8]="Module",P[P.Property=9]="Property",P[P.Event=10]="Event",P[P.Operator=11]="Operator",P[P.Unit=12]="Unit",P[P.Value=13]="Value",P[P.Constant=14]="Constant",P[P.Enum=15]="Enum",P[P.EnumMember=16]="EnumMember",P[P.Keyword=17]="Keyword",P[P.Text=18]="Text",P[P.Color=19]="Color",P[P.File=20]="File",P[P.Reference=21]="Reference",P[P.Customcolor=22]="Customcolor",P[P.Folder=23]="Folder",P[P.TypeParameter=24]="TypeParameter",P[P.User=25]="User",P[P.Issue=26]="Issue",P[P.Snippet=27]="Snippet"})(b||(t.CompletionItemKind=b={}));var c;(function(P){const X=new Map;X.set(b.Method,n.$0j.symbolMethod),X.set(b.Function,n.$0j.symbolFunction),X.set(b.Constructor,n.$0j.symbolConstructor),X.set(b.Field,n.$0j.symbolField),X.set(b.Variable,n.$0j.symbolVariable),X.set(b.Class,n.$0j.symbolClass),X.set(b.Struct,n.$0j.symbolStruct),X.set(b.Interface,n.$0j.symbolInterface),X.set(b.Module,n.$0j.symbolModule),X.set(b.Property,n.$0j.symbolProperty),X.set(b.Event,n.$0j.symbolEvent),X.set(b.Operator,n.$0j.symbolOperator),X.set(b.Unit,n.$0j.symbolUnit),X.set(b.Value,n.$0j.symbolValue),X.set(b.Enum,n.$0j.symbolEnum),X.set(b.Constant,n.$0j.symbolConstant),X.set(b.Enum,n.$0j.symbolEnum),X.set(b.EnumMember,n.$0j.symbolEnumMember),X.set(b.Keyword,n.$0j.symbolKeyword),X.set(b.Snippet,n.$0j.symbolSnippet),X.set(b.Text,n.$0j.symbolText),X.set(b.Color,n.$0j.symbolColor),X.set(b.File,n.$0j.symbolFile),X.set(b.Reference,n.$0j.symbolReference),X.set(b.Customcolor,n.$0j.symbolCustomColor),X.set(b.Folder,n.$0j.symbolFolder),X.set(b.TypeParameter,n.$0j.symbolTypeParameter),X.set(b.User,n.$0j.account),X.set(b.Issue,n.$0j.issues);function he(r){let Me=X.get(r);return Me||(console.info("No codicon found for CompletionItemKind "+r),Me=n.$0j.symbolProperty),Me}P.toIcon=he;const ge=new Map;ge.set("method",b.Method),ge.set("function",b.Function),ge.set("constructor",b.Constructor),ge.set("field",b.Field),ge.set("variable",b.Variable),ge.set("class",b.Class),ge.set("struct",b.Struct),ge.set("interface",b.Interface),ge.set("module",b.Module),ge.set("property",b.Property),ge.set("event",b.Event),ge.set("operator",b.Operator),ge.set("unit",b.Unit),ge.set("value",b.Value),ge.set("constant",b.Constant),ge.set("enum",b.Enum),ge.set("enum-member",b.EnumMember),ge.set("enumMember",b.EnumMember),ge.set("keyword",b.Keyword),ge.set("snippet",b.Snippet),ge.set("text",b.Text),ge.set("color",b.Color),ge.set("file",b.File),ge.set("reference",b.Reference),ge.set("customcolor",b.Customcolor),ge.set("folder",b.Folder),ge.set("type-parameter",b.TypeParameter),ge.set("typeParameter",b.TypeParameter),ge.set("account",b.User),ge.set("issue",b.Issue);function Le(r,Me){let Fe=ge.get(r);return typeof Fe>"u"&&!Me&&(Fe=b.Property),Fe}P.fromString=Le})(c||(t.CompletionItemKinds=c={}));var e;(function(P){P[P.Deprecated=1]="Deprecated"})(e||(t.CompletionItemTag=e={}));var l;(function(P){P[P.None=0]="None",P[P.KeepWhitespace=1]="KeepWhitespace",P[P.InsertAsSnippet=4]="InsertAsSnippet"})(l||(t.CompletionItemInsertTextRule=l={}));var g;(function(P){P[P.Word=0]="Word",P[P.Line=1]="Line",P[P.Suggest=2]="Suggest"})(g||(t.PartialAcceptTriggerKind=g={}));var L;(function(P){P[P.Invoke=0]="Invoke",P[P.TriggerCharacter=1]="TriggerCharacter",P[P.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(L||(t.CompletionTriggerKind=L={}));var N;(function(P){P[P.Automatic=0]="Automatic",P[P.Explicit=1]="Explicit"})(N||(t.InlineCompletionTriggerKind=N={}));class E{constructor(X,he,ge,Le){this.range=X,this.text=he,this.completionKind=ge,this.isSnippetText=Le}equals(X){return m.$Wt.lift(this.range).equalsRange(X.range)&&this.text===X.text&&this.completionKind===X.completionKind&&this.isSnippetText===X.isSnippetText}}t.$Su=E;var _;(function(P){P[P.Invoke=1]="Invoke",P[P.Auto=2]="Auto"})(_||(t.CodeActionTriggerType=_={}));var w;(function(P){P[P.Automatic=0]="Automatic",P[P.PasteAs=1]="PasteAs"})(w||(t.DocumentPasteTriggerKind=w={}));var a;(function(P){P[P.Invoke=1]="Invoke",P[P.TriggerCharacter=2]="TriggerCharacter",P[P.ContentChange=3]="ContentChange"})(a||(t.SignatureHelpTriggerKind=a={}));var s;(function(P){P[P.Text=0]="Text",P[P.Read=1]="Read",P[P.Write=2]="Write"})(s||(t.DocumentHighlightKind=s={}));function f(P){return P&&i.URI.isUri(P.uri)&&m.$Wt.isIRange(P.range)&&(m.$Wt.isIRange(P.originSelectionRange)||m.$Wt.isIRange(P.targetSelectionRange))}var v;(function(P){P[P.File=0]="File",P[P.Module=1]="Module",P[P.Namespace=2]="Namespace",P[P.Package=3]="Package",P[P.Class=4]="Class",P[P.Method=5]="Method",P[P.Property=6]="Property",P[P.Field=7]="Field",P[P.Constructor=8]="Constructor",P[P.Enum=9]="Enum",P[P.Interface=10]="Interface",P[P.Function=11]="Function",P[P.Variable=12]="Variable",P[P.Constant=13]="Constant",P[P.String=14]="String",P[P.Number=15]="Number",P[P.Boolean=16]="Boolean",P[P.Array=17]="Array",P[P.Object=18]="Object",P[P.Key=19]="Key",P[P.Null=20]="Null",P[P.EnumMember=21]="EnumMember",P[P.Struct=22]="Struct",P[P.Event=23]="Event",P[P.Operator=24]="Operator",P[P.TypeParameter=25]="TypeParameter"})(v||(t.SymbolKind=v={})),t.$Uu={[v.Array]:(0,d.localize)(788,null),[v.Boolean]:(0,d.localize)(789,null),[v.Class]:(0,d.localize)(790,null),[v.Constant]:(0,d.localize)(791,null),[v.Constructor]:(0,d.localize)(792,null),[v.Enum]:(0,d.localize)(793,null),[v.EnumMember]:(0,d.localize)(794,null),[v.Event]:(0,d.localize)(795,null),[v.Field]:(0,d.localize)(796,null),[v.File]:(0,d.localize)(797,null),[v.Function]:(0,d.localize)(798,null),[v.Interface]:(0,d.localize)(799,null),[v.Key]:(0,d.localize)(800,null),[v.Method]:(0,d.localize)(801,null),[v.Module]:(0,d.localize)(802,null),[v.Namespace]:(0,d.localize)(803,null),[v.Null]:(0,d.localize)(804,null),[v.Number]:(0,d.localize)(805,null),[v.Object]:(0,d.localize)(806,null),[v.Operator]:(0,d.localize)(807,null),[v.Package]:(0,d.localize)(808,null),[v.Property]:(0,d.localize)(809,null),[v.String]:(0,d.localize)(810,null),[v.Struct]:(0,d.localize)(811,null),[v.TypeParameter]:(0,d.localize)(812,null),[v.Variable]:(0,d.localize)(813,null)};function k(P,X){return(0,d.localize)(814,null,P,t.$Uu[X])}var R;(function(P){P[P.Deprecated=1]="Deprecated"})(R||(t.SymbolTag=R={}));var T;(function(P){const X=new Map;X.set(v.File,n.$0j.symbolFile),X.set(v.Module,n.$0j.symbolModule),X.set(v.Namespace,n.$0j.symbolNamespace),X.set(v.Package,n.$0j.symbolPackage),X.set(v.Class,n.$0j.symbolClass),X.set(v.Method,n.$0j.symbolMethod),X.set(v.Property,n.$0j.symbolProperty),X.set(v.Field,n.$0j.symbolField),X.set(v.Constructor,n.$0j.symbolConstructor),X.set(v.Enum,n.$0j.symbolEnum),X.set(v.Interface,n.$0j.symbolInterface),X.set(v.Function,n.$0j.symbolFunction),X.set(v.Variable,n.$0j.symbolVariable),X.set(v.Constant,n.$0j.symbolConstant),X.set(v.String,n.$0j.symbolString),X.set(v.Number,n.$0j.symbolNumber),X.set(v.Boolean,n.$0j.symbolBoolean),X.set(v.Array,n.$0j.symbolArray),X.set(v.Object,n.$0j.symbolObject),X.set(v.Key,n.$0j.symbolKey),X.set(v.Null,n.$0j.symbolNull),X.set(v.EnumMember,n.$0j.symbolEnumMember),X.set(v.Struct,n.$0j.symbolStruct),X.set(v.Event,n.$0j.symbolEvent),X.set(v.Operator,n.$0j.symbolOperator),X.set(v.TypeParameter,n.$0j.symbolTypeParameter);function he(ge){let Le=X.get(ge);return Le||(console.info("No codicon found for SymbolKind "+ge),Le=n.$0j.symbolProperty),Le}P.toIcon=he})(T||(t.SymbolKinds=T={}));class j{static asEditOperation(X){return p.$Xt.replace(m.$Wt.lift(X.range),X.text)}}t.$Wu=j;class M{static{this.Comment=new M("comment")}static{this.Imports=new M("imports")}static{this.Region=new M("region")}static fromValue(X){switch(X){case"comment":return M.Comment;case"imports":return M.Imports;case"region":return M.Region}return new M(X)}constructor(X){this.value=X}}t.$Xu=M;var D;(function(P){P[P.AIGenerated=1]="AIGenerated"})(D||(t.NewSymbolNameTag=D={}));var F;(function(P){P[P.Invoke=0]="Invoke",P[P.Automatic=1]="Automatic"})(F||(t.NewSymbolNameTriggerKind=F={}));var y;(function(P){function X(he){return!he||typeof he!="object"?!1:typeof he.id=="string"&&typeof he.title=="string"}P.is=X})(y||(t.Command=y={}));var B;(function(P){P[P.Collapsed=0]="Collapsed",P[P.Expanded=1]="Expanded"})(B||(t.CommentThreadCollapsibleState=B={}));var z;(function(P){P[P.Unresolved=0]="Unresolved",P[P.Resolved=1]="Resolved"})(z||(t.CommentThreadState=z={}));var H;(function(P){P[P.Current=0]="Current",P[P.Outdated=1]="Outdated"})(H||(t.CommentThreadApplicability=H={}));var U;(function(P){P[P.Editing=0]="Editing",P[P.Preview=1]="Preview"})(U||(t.CommentMode=U={}));var C;(function(P){P[P.Published=0]="Published",P[P.Draft=1]="Draft"})(C||(t.CommentState=C={}));var ee;(function(P){P[P.Type=1]="Type",P[P.Parameter=2]="Parameter"})(ee||(t.InlayHintKind=ee={}));class J{constructor(X){this.b=X,this.a=null}dispose(){this.a&&this.a.then(X=>{X&&X.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$Yu=J,t.$Zu=new A.$Gu,t.$1u=new A.$Gu;var K;(function(P){P[P.None=0]="None",P[P.Option=1]="Option",P[P.Default=2]="Default",P[P.Preferred=3]="Preferred"})(K||(t.ExternalUriOpenerPriority=K={}));var ne;(function(P){P[P.Invoke=0]="Invoke",P[P.Automatic=1]="Automatic"})(ne||(t.InlineEditTriggerKind=ne={}))}),ie(re[81],ue([0,1,20,12,45,14,5,2,53,80,74]),function(W,t,n,i,p,m,A,d,o,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$b5=void 0,t.$c5=b,h=De(h);class ${static{this.CtrlCmd=p.KeyMod.CtrlCmd}static{this.Shift=p.KeyMod.Shift}static{this.Alt=p.KeyMod.Alt}static{this.WinCtrl=p.KeyMod.WinCtrl}static chord(e,l){return(0,p.$7r)(e,l)}}t.$b5=$;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:n.$Be,Emitter:i.$qe,KeyCode:h.KeyCode,KeyMod:$,Position:A.$Vt,Range:d.$Wt,Selection:o.$Yt,SelectionDirection:h.SelectionDirection,MarkerSeverity:h.MarkerSeverity,MarkerTag:h.MarkerTag,Uri:m.URI,Token:u.$Pu}}}),ie(re[82],ue([0,1,79,10,14,5,2,35,69]),function(W,t,n,i,p,m,A,d,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$G5=t.$F5=t.$E5=t.$D5=t.$C5=void 0,t.$C5=60*1e3,t.$D5="workerTextModelSync";class u extends i.$Zc{static create(c,e){return new u(c.getChannel(t.$D5),e)}constructor(c,e,l=!1){if(super(),this.c=Object.create(null),this.f=Object.create(null),this.a=c,this.b=e,!l){const g=new n.$Vh;g.cancelAndSet(()=>this.g(),Math.round(t.$C5/2)),this.B(g)}}dispose(){for(const c in this.c)(0,i.$Uc)(this.c[c]);this.c=Object.create(null),this.f=Object.create(null),super.dispose()}ensureSyncedResources(c,e=!1){for(const l of c){const g=l.toString();this.c[g]||this.h(l,e),this.c[g]&&(this.f[g]=new Date().getTime())}}g(){const c=new Date().getTime(),e=[];for(const l in this.f)c-this.f[l]>t.$C5&&e.push(l);for(const l of e)this.j(l)}h(c,e){const l=this.b.getModel(c);if(!l||!e&&l.isTooLargeForSyncing())return;const g=c.toString();this.a.$acceptNewModel({url:l.uri.toString(),lines:l.getLinesContent(),EOL:l.getEOL(),versionId:l.getVersionId()});const L=new i.$Yc;L.add(l.onDidChangeContent(N=>{this.a.$acceptModelChanged(g.toString(),N)})),L.add(l.onWillDispose(()=>{this.j(g)})),L.add((0,i.$Xc)(()=>{this.a.$acceptRemovedModel(g)})),this.c[g]=L}j(c){const e=this.c[c];delete this.c[c],delete this.f[c],(0,i.$Uc)(e)}}t.$E5=u;class h{constructor(){this.a=Object.create(null)}bindToServer(c){c.setChannel(t.$D5,this)}getModel(c){return this.a[c]}getModels(){const c=[];return Object.keys(this.a).forEach(e=>c.push(this.a[e])),c}$acceptNewModel(c){this.a[c.url]=new $(p.URI.parse(c.url),c.lines,c.EOL,c.versionId)}$acceptModelChanged(c,e){if(!this.a[c])return;this.a[c].onEvents(e)}$acceptRemovedModel(c){this.a[c]&&delete this.a[c]}}t.$F5=h;class $ extends o.$yw{get uri(){return this.a}get eol(){return this.c}getValue(){return this.getText()}findMatches(c){const e=[];for(let l=0;l<this.b.length;l++){const g=this.b[l],L=this.offsetAt(new m.$Vt(l+1,1)),N=g.matchAll(c);for(const E of N)(E.index||E.index===0)&&(E.index=E.index+L),e.push(E)}return e}getLinesContent(){return this.b.slice(0)}getLineCount(){return this.b.length}getLineContent(c){return this.b[c-1]}getWordAtPosition(c,e){const l=(0,d.$yt)(c.column,(0,d.$wt)(e),this.b[c.lineNumber-1],0);return l?new A.$Wt(c.lineNumber,l.startColumn,c.lineNumber,l.endColumn):null}getWordUntilPosition(c,e){const l=this.getWordAtPosition(c,e);return l?{word:this.b[c.lineNumber-1].substring(l.startColumn-1,c.column-1),startColumn:l.startColumn,endColumn:c.column}:{word:"",startColumn:c.column,endColumn:c.column}}words(c){const e=this.b,l=this.m.bind(this);let g=0,L="",N=0,E=[];return{*[Symbol.iterator](){for(;;)if(N<E.length){const _=L.substring(E[N].start,E[N].end);N+=1,yield _}else if(g<e.length)L=e[g],E=l(L,c),N=0,g+=1;else break}}}getLineWords(c,e){const l=this.b[c-1],g=this.m(l,e),L=[];for(const N of g)L.push({word:l.substring(N.start,N.end),startColumn:N.start+1,endColumn:N.end+1});return L}m(c,e){const l=[];let g;for(e.lastIndex=0;(g=e.exec(c))&&g[0].length!==0;)l.push({start:g.index,end:g.index+g[0].length});return l}getValueInRange(c){if(c=this.n(c),c.startLineNumber===c.endLineNumber)return this.b[c.startLineNumber-1].substring(c.startColumn-1,c.endColumn-1);const e=this.c,l=c.startLineNumber-1,g=c.endLineNumber-1,L=[];L.push(this.b[l].substring(c.startColumn-1));for(let N=l+1;N<g;N++)L.push(this.b[N]);return L.push(this.b[g].substring(0,c.endColumn-1)),L.join(e)}offsetAt(c){return c=this.o(c),this.h(),this.f.getPrefixSum(c.lineNumber-2)+(c.column-1)}positionAt(c){c=Math.floor(c),c=Math.max(0,c),this.h();const e=this.f.getIndexOf(c),l=this.b[e.index].length;return{lineNumber:1+e.index,column:1+Math.min(e.remainder,l)}}n(c){const e=this.o({lineNumber:c.startLineNumber,column:c.startColumn}),l=this.o({lineNumber:c.endLineNumber,column:c.endColumn});return e.lineNumber!==c.startLineNumber||e.column!==c.startColumn||l.lineNumber!==c.endLineNumber||l.column!==c.endColumn?{startLineNumber:e.lineNumber,startColumn:e.column,endLineNumber:l.lineNumber,endColumn:l.column}:c}o(c){if(!m.$Vt.isIPosition(c))throw new Error("bad position");let{lineNumber:e,column:l}=c,g=!1;if(e<1)e=1,l=1,g=!0;else if(e>this.b.length)e=this.b.length,l=this.b[e-1].length+1,g=!0;else{const L=this.b[e-1].length+1;l<1?(l=1,g=!0):l>L&&(l=L,g=!0)}return g?{lineNumber:e,column:l}:c}}t.$G5=$}),ie(re[85],ue([0,1,32,5,2,65,66,81,71,29,73,39,62,31,24,4,64,72,82]),function(W,t,n,i,p,m,A,d,o,u,h,$,b,c,e,l,g,L,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorSimpleWorker=t.BaseEditorSimpleWorker=void 0,t.create=a;const E=!1;class _{constructor(){this.d=new N.$F5}dispose(){}f(f){return this.d.getModel(f)}g(){return this.d.getModels()}$acceptNewModel(f){this.d.$acceptNewModel(f)}$acceptModelChanged(f,v){this.d.$acceptModelChanged(f,v)}$acceptRemovedModel(f){this.d.$acceptRemovedModel(f)}async $computeUnicodeHighlights(f,v,k){const R=this.f(f);return R?h.$94.computeUnicodeHighlights(R,v,k):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async $findSectionHeaders(f,v){const k=this.f(f);return k?(0,L.$B5)(k,v):[]}async $computeDiff(f,v,k,R){const T=this.f(f),j=this.f(v);return!T||!j?null:w.h(T,j,k,R)}static h(f,v,k,R){const T=R==="advanced"?b.$z5.getDefault():b.$z5.getLegacy(),j=f.getLinesContent(),M=v.getLinesContent(),D=T.computeDiff(j,M,k),F=D.changes.length>0?!1:this.j(f,v);function y(B){return B.map(z=>[z.original.startLineNumber,z.original.endLineNumberExclusive,z.modified.startLineNumber,z.modified.endLineNumberExclusive,z.innerChanges?.map(H=>[H.originalRange.startLineNumber,H.originalRange.startColumn,H.originalRange.endLineNumber,H.originalRange.endColumn,H.modifiedRange.startLineNumber,H.modifiedRange.startColumn,H.modifiedRange.endLineNumber,H.modifiedRange.endColumn])])}return{identical:F,quitEarly:D.hitTimeout,changes:y(D.changes),moves:D.moves.map(B=>[B.lineRangeMapping.original.startLineNumber,B.lineRangeMapping.original.endLineNumberExclusive,B.lineRangeMapping.modified.startLineNumber,B.lineRangeMapping.modified.endLineNumberExclusive,y(B.changes)])}}static j(f,v){const k=f.getLineCount(),R=v.getLineCount();if(k!==R)return!1;for(let T=1;T<=k;T++){const j=f.getLineContent(T),M=v.getLineContent(T);if(j!==M)return!1}return!0}async $computeDirtyDiff(f,v,k){const R=this.f(f),T=this.f(v);if(!R||!T)return null;const j=R.getLinesContent(),M=T.getLinesContent();return new $.$ju(j,M,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:k,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.k=1e5}async $computeMoreMinimalEdits(f,v,k){const R=this.f(f);if(!R)return v;const T=[];let j;v=v.slice(0).sort((D,F)=>{if(D.range&&F.range)return p.$Wt.compareRangesUsingStarts(D.range,F.range);const y=D.range?0:1,B=F.range?0:1;return y-B});let M=0;for(let D=1;D<v.length;D++)p.$Wt.getEndPosition(v[M].range).equals(p.$Wt.getStartPosition(v[D].range))?(v[M].range=p.$Wt.fromPositions(p.$Wt.getStartPosition(v[M].range),p.$Wt.getEndPosition(v[D].range)),v[M].text+=v[D].text):(M++,v[M]=v[D]);v.length=M+1;for(let{range:D,text:F,eol:y}of v){if(typeof y=="number"&&(j=y),p.$Wt.isEmpty(D)&&!F)continue;const B=R.getValueInRange(D);if(F=F.replace(/\r\n|\n|\r/g,R.eol),B===F)continue;if(Math.max(F.length,B.length)>w.k){T.push({range:D,text:F});continue}const z=(0,n.$2t)(B,F,k),H=R.offsetAt(p.$Wt.lift(D).getStartPosition());for(const U of z){const C=R.positionAt(H+U.originalStart),ee=R.positionAt(H+U.originalStart+U.originalLength),J={text:F.substr(U.modifiedStart,U.modifiedLength),range:{startLineNumber:C.lineNumber,startColumn:C.column,endLineNumber:ee.lineNumber,endColumn:ee.column}};R.getValueInRange(J.range)!==J.text&&T.push(J)}}return typeof j=="number"&&T.push({eol:j,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),T}$computeHumanReadableDiff(f,v,k){const R=this.f(f);if(!R)return v;const T=[];let j;v=v.slice(0).sort((M,D)=>{if(M.range&&D.range)return p.$Wt.compareRangesUsingStarts(M.range,D.range);const F=M.range?0:1,y=D.range?0:1;return F-y});for(let{range:M,text:D,eol:F}of v){let C=function(J,K){return new i.$Vt(J.lineNumber+K.lineNumber-1,K.lineNumber===1?J.column+K.column-1:K.column)},ee=function(J,K){const ne=[];for(let P=K.startLineNumber;P<=K.endLineNumber;P++){const X=J[P-1];P===K.startLineNumber&&P===K.endLineNumber?ne.push(X.substring(K.startColumn-1,K.endColumn-1)):P===K.startLineNumber?ne.push(X.substring(K.startColumn-1)):P===K.endLineNumber?ne.push(X.substring(0,K.endColumn-1)):ne.push(X)}return ne};if(typeof F=="number"&&(j=F),p.$Wt.isEmpty(M)&&!D)continue;const y=R.getValueInRange(M);if(D=D.replace(/\r\n|\n|\r/g,R.eol),y===D)continue;if(Math.max(D.length,y.length)>w.k){T.push({range:M,text:D});continue}const B=y.split(/\r\n|\n|\r/),z=D.split(/\r\n|\n|\r/),H=b.$z5.getDefault().computeDiff(B,z,k),U=p.$Wt.lift(M).getStartPosition();for(const J of H.changes)if(J.innerChanges)for(const K of J.innerChanges)T.push({range:p.$Wt.fromPositions(C(U,K.originalRange.getStartPosition()),C(U,K.originalRange.getEndPosition())),text:ee(z,K.modifiedRange).join(R.eol)});else throw new l.$gb("The experimental diff algorithm always produces inner changes")}return typeof j=="number"&&T.push({eol:j,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),T}async $computeLinks(f){const v=this.f(f);return v?(0,m.$_4)(v):null}async $computeDefaultDocumentColors(f){const v=this.f(f);return v?(0,g.$A5)(v):null}static{this.l=1e4}async $textualSuggest(f,v,k,R){const T=new u.$ke,j=new RegExp(k,R),M=new Set;e:for(const D of f){const F=this.f(D);if(F){for(const y of F.words(j))if(!(y===v||!isNaN(Number(y)))&&(M.add(y),M.size>w.l))break e}}return{words:Array.from(M),duration:T.elapsed()}}async $computeWordRanges(f,v,k,R){const T=this.f(f);if(!T)return Object.create(null);const j=new RegExp(k,R),M=Object.create(null);for(let D=v.startLineNumber;D<v.endLineNumber;D++){const F=T.getLineWords(D,j);for(const y of F){if(!isNaN(Number(y.word)))continue;let B=M[y.word];B||(B=[],M[y.word]=B),B.push({startLineNumber:D,startColumn:y.startColumn,endLineNumber:D,endColumn:y.endColumn})}}return M}async $navigateValueSet(f,v,k,R,T){const j=this.f(f);if(!j)return null;const M=new RegExp(R,T);v.startColumn===v.endColumn&&(v={startLineNumber:v.startLineNumber,startColumn:v.startColumn,endLineNumber:v.endLineNumber,endColumn:v.endColumn+1});const D=j.getValueInRange(v),F=j.getWordAtPosition({lineNumber:v.startLineNumber,column:v.startColumn},M);if(!F)return null;const y=j.getValueInRange(F);return A.$a5.INSTANCE.navigateValueSet(v,D,F,y,k)}}t.BaseEditorSimpleWorker=_;class w extends _{constructor(f,v){super(),this.o=f,this.p=v,this.n=null}async $ping(){return"pong"}$loadForeignModule(f,v,k){const R=(M,D)=>this.o.$fhr(M,D),j={host:(0,c.$vo)(k,R),getMirrorModels:()=>this.g()};return this.p?(this.n=this.p(j,v),Promise.resolve((0,c.$uo)(this.n))):new Promise((M,D)=>{const F=y=>{this.n=y.create(j,v),M((0,c.$uo)(this.n))};if(!E)W([`${f}`],F,D);else{const y=e.$5g.asBrowserUri(`${f}.js`).toString(!0);new Promise((B,z)=>{W([`${y}`],B,z)}).then(De).then(F).catch(D)}})}$fmr(f,v){if(!this.n||typeof this.n[f]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+f));try{return Promise.resolve(this.n[f].apply(this.n,v))}catch(k){return Promise.reject(k)}}}t.EditorSimpleWorker=w;function a(s){return new w(o.$d5.getChannel(s),null)}typeof importScripts=="function"&&(globalThis.monaco=(0,d.$c5)())})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/e37706186d2105b4158df80574323ebb987d7f64/core/vs/base/worker/workerMain.js.map
