/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/platform","vs/base/common/path","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/event","vs/base/common/strings","vs/base/common/async","vs/base/common/errors","vs/base/common/types","vs/base/common/charCode","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/extpath","fs","vs/base/common/lazy","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/files/common/watcher","vs/base/common/map","vs/base/common/normalization","vs/nls","vs/base/common/resources","vs/base/common/glob","vs/base/node/pfs","vs/base/parts/ipc/common/ipc","vs/base/common/functional","vs/base/common/marshallingIds","vs/base/common/ternarySearchTree","vs/base/parts/sandbox/node/electronTypes","vs/nls.messages","vs/base/common/process","vs/base/common/processes","vs/base/common/network","vs/base/node/extpath","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/objects","vs/base/common/uint","vs/base/common/errorMessage","vs/base/common/console","vs/base/common/marshalling","os","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/platform/instantiation/common/instantiation","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/parcel/parcelWatcher","vs/platform/files/node/watcher/watcherStats","vs/platform/files/node/watcher/watcher","util","child_process","@parcel/watcher","vs/platform/files/node/watcher/watcherMain"],_e=function(fe){for(var e=[],_=0,t=fe.length;_<t;_++)e[_]=be[fe[_]];return e};define(be[38],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=void 0,e.$jb=_,e.$kb=t,e.$lb=W,e.$mb=M,e.$nb=Y,e.$ob=p,e.$pb=U,e.$rb=N,e.$sb=b,e.$tb=D,e.$ub=F,e.$vb=c;function _(r,d){const E=t(r,d);if(E!==-1)return r[E]}function t(r,d,E=r.length-1){for(let f=E;f>=0;f--){const A=r[f];if(d(A))return f}return-1}function W(r,d){const E=M(r,d);return E===-1?void 0:r[E]}function M(r,d,E=0,f=r.length){let A=E,w=f;for(;A<w;){const u=Math.floor((A+w)/2);d(r[u])?A=u+1:w=u}return A-1}function Y(r,d){const E=p(r,d);return E===r.length?void 0:r[E]}function p(r,d,E=0,f=r.length){let A=E,w=f;for(;A<w;){const u=Math.floor((A+w)/2);d(r[u])?w=u:A=u+1}return A}function U(r,d,E=0,f=r.length){const A=p(r,d,E,f);return A===r.length?-1:A}class T{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(T.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!d(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const E=M(this.e,d,this.c);return this.c=E+1,E===-1?void 0:this.e[E]}}e.$qb=T;function N(r,d){if(r.length===0)return;let E=r[0];for(let f=1;f<r.length;f++){const A=r[f];d(A,E)>0&&(E=A)}return E}function b(r,d){if(r.length===0)return;let E=r[0];for(let f=1;f<r.length;f++){const A=r[f];d(A,E)>=0&&(E=A)}return E}function D(r,d){return N(r,(E,f)=>-d(E,f))}function F(r,d){if(r.length===0)return-1;let E=0;for(let f=1;f<r.length;f++){const A=r[f];d(A,r[E])>0&&(E=f)}return E}function c(r,d){for(const E of r){const f=d(E);if(f!==void 0)return f}}}),define(be[11],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var _;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(_||(e.CharCode=_={}))}),define(be[39],_e([0,1]),function(fe,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.$i=void 0,e.$e=t,e.$f=W,e.$g=M,e.$h=Y;function t(U,T){const N=Object.create(null);for(const b of U){const D=T(b);let F=N[D];F||(F=N[D]=[]),F.push(b)}return N}function W(U,T){const N=[],b=[];for(const D of U)T.has(D)||N.push(D);for(const D of T)U.has(D)||b.push(D);return{removed:N,added:b}}function M(U,T){const N=[],b=[];for(const[D,F]of U)T.has(D)||N.push(F);for(const[D,F]of T)U.has(D)||b.push(F);return{removed:N,added:b}}function Y(U,T){const N=new Set;for(const b of T)U.has(b)&&N.add(b);return N}class p{static{_=Symbol.toStringTag}constructor(T,N){this.b=N,this.a=new Map,this[_]="SetWithKey";for(const b of T)this.add(b)}get size(){return this.a.size}add(T){const N=this.b(T);return this.a.set(N,T),this}delete(T){return this.a.delete(this.b(T))}has(T){return this.a.has(this.b(T))}*entries(){for(const T of this.a.values())yield[T,T]}keys(){return this.values()}*values(){for(const T of this.a.values())yield T}clear(){this.a.clear()}forEach(T,N){this.a.forEach(b=>T.call(N,b,b,this))}[Symbol.iterator](){return this.values()}}e.$i=p}),define(be[40],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=t,e.$di=W,e.$ei=M;function _(Y){return(p,U,T)=>{let N=null,b=null;if(typeof T.value=="function"?(N="value",b=T.value):typeof T.get=="function"&&(N="get",b=T.get),!b)throw new Error("not supported");T[N]=Y(b,U)}}function t(Y,p,U){let T=null,N=null;if(typeof U.value=="function"?(T="value",N=U.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof U.get=="function"&&(T="get",N=U.get),!N)throw new Error("not supported");const b=`$memoize$${p}`;U[T]=function(...D){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,D)}),this[b]}}function W(Y,p,U){return _((T,N)=>{const b=`$debounce$${N}`,D=`$debounce$result$${N}`;return function(...F){this[D]||(this[D]=U?U():void 0),clearTimeout(this[b]),p&&(this[D]=p(this[D],...F),F=[this[D]]),this[b]=setTimeout(()=>{T.apply(this,F),this[D]=U?U():void 0},Y)}})}function M(Y,p,U){return _((T,N)=>{const b=`$throttle$timer$${N}`,D=`$throttle$result$${N}`,F=`$throttle$lastRun$${N}`,c=`$throttle$pending$${N}`;return function(...r){if(this[D]||(this[D]=U?U():void 0),(this[F]===null||this[F]===void 0)&&(this[F]=-Number.MAX_VALUE),p&&(this[D]=p(this[D],...r)),this[c])return;const d=this[F]+Y;d<=Date.now()?(this[F]=Date.now(),T.apply(this,[this[D]]),this[D]=U?U():void 0):(this[c]=!0,this[b]=setTimeout(()=>{this[c]=!1,this[F]=Date.now(),T.apply(this,[this[D]]),this[D]=U?U():void 0},d-Date.now()))}})}}),define(be[9],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=e.$fb=e.$eb=e.$db=e.$cb=e.$ab=e.$9=e.$1=e.$Z=void 0,e.setUnexpectedErrorHandler=t,e.$3=W,e.$4=M,e.$5=Y,e.$6=p,e.$7=U,e.$8=N,e.$0=D,e.$$=F,e.$_=c,e.$bb=d;class _{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?w.isErrorNoTelemetry(n)?new w(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$Z=_,e.$1=new _;function t(i){e.$1.setUnexpectedErrorHandler(i)}function W(i){if(!i||typeof i!="object")return!1;const n=i;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function M(i){N(i)||e.$1.onUnexpectedError(i)}function Y(i){N(i)||e.$1.onUnexpectedExternalError(i)}function p(i){if(i instanceof Error){const{name:n,message:s}=i,o=i.stacktrace||i.stack;return{$isError:!0,name:n,message:s,stack:o,noTelemetry:w.isErrorNoTelemetry(i)}}return i}function U(i){let n;return i.noTelemetry?n=new w:(n=new Error,n.name=i.name),n.message=i.message,n.stack=i.stack,n}const T="Canceled";function N(i){return i instanceof b?!0:i instanceof Error&&i.name===T&&i.message===T}class b extends Error{constructor(){super(T),this.name=this.message}}e.$9=b;function D(){const i=new Error(T);return i.name=i.message,i}function F(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function c(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class r extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$ab=r;function d(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class E extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$cb=E;class f extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$db=f;class A extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$eb=A;class w extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof w)return n;const s=new w;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$fb=w;class u extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}e.$gb=u}),define(be[12],_e([0,1,9,38]),function(fe,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.$cc=e.$ac=e.$_b=e.CompareResult=void 0,e.$wb=W,e.$xb=M,e.$yb=Y,e.$zb=p,e.$Ab=U,e.$Bb=T,e.$Cb=N,e.$Db=b,e.$Eb=D,e.$Fb=F,e.$Gb=c,e.$Hb=r,e.$Ib=d,e.top=E,e.$Kb=f,e.$Lb=w,e.$Mb=u,e.$Nb=i,e.$Ob=n,e.$Pb=s,e.$Qb=o,e.$Rb=S,e.$Sb=$,e.$Tb=m,e.$Ub=h,e.$Vb=y,e.$Wb=L,e.$Xb=l,e.$Yb=v,e.$Zb=q,e.$1b=x,e.$2b=J,e.$3b=K,e.$4b=se,e.$5b=V,e.$6b=ne,e.$7b=re,e.$8b=oe,e.$9b=I,e.$0b=z,e.$$b=Q,e.$bc=ee,e.$fc=we;function W(j,G=0){return j[j.length-(1+G)]}function M(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}function Y(j,G,P=(a,B)=>a===B){if(j===G)return!0;if(!j||!G||j.length!==G.length)return!1;for(let a=0,B=j.length;a<B;a++)if(!P(j[a],G[a]))return!1;return!0}function p(j,G){const P=j.length-1;G<P&&(j[G]=j[P]),j.pop()}function U(j,G,P){return T(j.length,a=>P(j[a],G))}function T(j,G){let P=0,a=j-1;for(;P<=a;){const B=(P+a)/2|0,X=G(B);if(X<0)P=B+1;else if(X>0)a=B-1;else return B}return-(P+1)}function N(j,G,P){if(j=j|0,j>=G.length)throw new TypeError("invalid index");const a=G[Math.floor(G.length*Math.random())],B=[],X=[],te=[];for(const de of G){const De=P(de,a);De<0?B.push(de):De>0?X.push(de):te.push(de)}return j<B.length?N(j,B,P):j<B.length+te.length?te[0]:N(j-(B.length+te.length),X,P)}function b(j,G){const P=[];let a;for(const B of j.slice(0).sort(G))!a||G(a[0],B)!==0?(a=[B],P.push(a)):a.push(B);return P}function*D(j,G){let P,a;for(const B of j)a!==void 0&&G(a,B)?P.push(B):(P&&(yield P),P=[B]),a=B;P&&(yield P)}function F(j,G){for(let P=0;P<=j.length;P++)G(P===0?void 0:j[P-1],P===j.length?void 0:j[P])}function c(j,G){for(let P=0;P<j.length;P++)G(P===0?void 0:j[P-1],j[P],P+1===j.length?void 0:j[P+1])}function r(j,G,P){const a=[];function B(de,De,Re){if(De===0&&Re.length===0)return;const Oe=a[a.length-1];Oe&&Oe.start+Oe.deleteCount===de?(Oe.deleteCount+=De,Oe.toInsert.push(...Re)):a.push({start:de,deleteCount:De,toInsert:Re})}let X=0,te=0;for(;;){if(X===j.length){B(X,0,G.slice(te));break}if(te===G.length){B(X,j.length-X,[]);break}const de=j[X],De=G[te],Re=P(de,De);Re===0?(X+=1,te+=1):Re<0?(B(X,1,[]),X+=1):Re>0&&(B(X,0,[De]),te+=1)}return a}function d(j,G,P){const a=r(j,G,P),B=[],X=[];for(const te of a)B.push(...j.slice(te.start,te.start+te.deleteCount)),X.push(...te.toInsert);return{removed:B,added:X}}function E(j,G,P){if(P===0)return[];const a=j.slice(0,P).sort(G);return A(j,G,a,P,j.length),a}function f(j,G,P,a,B){return P===0?Promise.resolve([]):new Promise((X,te)=>{(async()=>{const de=j.length,De=j.slice(0,P).sort(G);for(let Re=P,Oe=Math.min(P+a,de);Re<de;Re=Oe,Oe=Math.min(Oe+a,de)){if(Re>P&&await new Promise(ge=>setTimeout(ge)),B&&B.isCancellationRequested)throw new _.$9;A(j,G,De,Re,Oe)}return De})().then(X,te)})}function A(j,G,P,a,B){for(const X=P.length;a<B;a++){const te=j[a];if(G(te,P[X-1])<0){P.pop();const de=(0,t.$ob)(P,De=>G(te,De)<0);P.splice(de,0,te)}}}function w(j){return j.filter(G=>!!G)}function u(j){let G=0;for(let P=0;P<j.length;P++)j[P]&&(j[G]=j[P],G+=1);j.length=G}function i(j,G,P){j.splice(P,0,j.splice(G,1)[0])}function n(j){return!Array.isArray(j)||j.length===0}function s(j){return Array.isArray(j)&&j.length>0}function o(j,G=P=>P){const P=new Set;return j.filter(a=>{const B=G(a);return P.has(B)?!1:(P.add(B),!0)})}function S(j){const G=new Set;return P=>{const a=j(P);return G.has(a)?!1:(G.add(a),!0)}}function $(j,G){return j.length>0?j[0]:G}function m(j,G){return j.length>0?j[j.length-1]:G}function h(j,G,P=(a,B)=>a===B){let a=0;for(let B=0,X=Math.min(j.length,G.length);B<X&&P(j[B],G[B]);B++)a++;return a}function y(j,G){let P=typeof G=="number"?j:0;typeof G=="number"?P=j:(P=0,G=j);const a=[];if(P<=G)for(let B=P;B<G;B++)a.push(B);else for(let B=P;B>G;B--)a.push(B);return a}function L(j,G,P){return j.reduce((a,B)=>(a[G(B)]=P?P(B):B,a),Object.create(null))}function l(j,G){return j.push(G),()=>v(j,G)}function v(j,G){const P=j.indexOf(G);if(P>-1)return j.splice(P,1),G}function q(j,G,P){const a=j.slice(0,G),B=j.slice(G);return a.concat(P,B)}function x(j,G){let P;if(typeof G=="number"){let a=G;P=()=>{const B=Math.sin(a++)*179426549;return B-Math.floor(B)}}else P=Math.random;for(let a=j.length-1;a>0;a-=1){const B=Math.floor(P()*(a+1)),X=j[a];j[a]=j[B],j[B]=X}}function J(j,G){const P=j.indexOf(G);P>-1&&(j.splice(P,1),j.unshift(G))}function K(j,G){const P=j.indexOf(G);P>-1&&(j.splice(P,1),j.push(G))}function se(j,G){for(const P of G)j.push(P)}function V(j,G){return Array.isArray(j)?j.map(G):G(j)}function ne(j){return Array.isArray(j)?j:[j]}function re(j){return j[Math.floor(Math.random()*j.length)]}function oe(j,G,P){const a=g(j,G),B=j.length,X=P.length;j.length=B+X;for(let te=B-1;te>=a;te--)j[te+X]=j[te];for(let te=0;te<X;te++)j[te+a]=P[te]}function I(j,G,P,a){const B=g(j,G);let X=j.splice(B,P);return X===void 0&&(X=[]),oe(j,B,a),X}function g(j,G){return G<0?Math.max(G+j.length,0):Math.min(G,j.length)}var k;(function(j){function G(X){return X<0}j.isLessThan=G;function P(X){return X<=0}j.isLessThanOrEqual=P;function a(X){return X>0}j.isGreaterThan=a;function B(X){return X===0}j.isNeitherLessOrGreaterThan=B,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(k||(e.CompareResult=k={}));function z(j,G){return(P,a)=>G(j(P),j(a))}function Q(...j){return(G,P)=>{for(const a of j){const B=a(G,P);if(!k.isNeitherLessOrGreaterThan(B))return B}return k.neitherLessOrGreaterThan}}const R=(j,G)=>j-G;e.$_b=R;const Z=(j,G)=>(0,e.$_b)(j?1:0,G?1:0);e.$ac=Z;function ee(j){return(G,P)=>-j(G,P)}class ie{constructor(G){this.g=G,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(G){let P=this.c;for(;P<this.g.length&&G(this.g[P]);)P++;const a=P===this.c?null:this.g.slice(this.c,P);return this.c=P,a}takeFromEndWhile(G){let P=this.d;for(;P>=0&&G(this.g[P]);)P--;const a=P===this.d?null:this.g.slice(P+1,this.d+1);return this.d=P,a}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const G=this.g[this.c];return this.c++,G}removeLast(){const G=this.g[this.d];return this.d--,G}takeCount(G){const P=this.g.slice(this.c,this.c+G);return this.c+=G,P}}e.$cc=ie;class ue{static{this.empty=new ue(G=>{})}constructor(G){this.iterate=G}forEach(G){this.iterate(P=>(G(P),!0))}toArray(){const G=[];return this.iterate(P=>(G.push(P),!0)),G}filter(G){return new ue(P=>this.iterate(a=>G(a)?P(a):!0))}map(G){return new ue(P=>this.iterate(a=>P(G(a))))}some(G){let P=!1;return this.iterate(a=>(P=G(a),!P)),P}findFirst(G){let P;return this.iterate(a=>G(a)?(P=a,!1):!0),P}findLast(G){let P;return this.iterate(a=>(G(a)&&(P=a),!0)),P}findLastMaxBy(G){let P,a=!0;return this.iterate(B=>((a||k.isGreaterThan(G(B,P)))&&(a=!1,P=B),!0)),P}}e.$dc=ue;class he{constructor(G){this.c=G}static createSortPermutation(G,P){const a=Array.from(G.keys()).sort((B,X)=>P(G[B],G[X]));return new he(a)}apply(G){return G.map((P,a)=>G[this.c[a]])}inverse(){const G=this.c.slice();for(let P=0;P<this.c.length;P++)G[this.c[P]]=P;return new he(G)}}e.$ec=he;async function we(j,G){return(await Promise.all(j.map(async(a,B)=>({element:a,ok:await G(a,B)})))).find(a=>a.ok)?.element}}),define(be[27],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hb=_;function _(t,W){const M=this;let Y=!1,p;return function(){if(Y)return p;if(Y=!0,W)try{p=t.apply(M,arguments)}finally{W()}else p=t.apply(M,arguments);return p}}}),define(be[41],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(t){function W(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}t.is=W;const M=Object.freeze([]);function Y(){return M}t.empty=Y;function*p(n){yield n}t.single=p;function U(n){return W(n)?n:p(n)}t.wrap=U;function T(n){return n||M}t.from=T;function*N(n){for(let s=n.length-1;s>=0;s--)yield n[s]}t.reverse=N;function b(n){return!n||n[Symbol.iterator]().next().done===!0}t.isEmpty=b;function D(n){return n[Symbol.iterator]().next().value}t.first=D;function F(n,s){let o=0;for(const S of n)if(s(S,o++))return!0;return!1}t.some=F;function c(n,s){for(const o of n)if(s(o))return o}t.find=c;function*r(n,s){for(const o of n)s(o)&&(yield o)}t.filter=r;function*d(n,s){let o=0;for(const S of n)yield s(S,o++)}t.map=d;function*E(n,s){let o=0;for(const S of n)yield*s(S,o++)}t.flatMap=E;function*f(...n){for(const s of n)yield*s}t.concat=f;function A(n,s,o){let S=o;for(const $ of n)S=s(S,$);return S}t.reduce=A;function*w(n,s,o=n.length){for(s<0&&(s+=n.length),o<0?o+=n.length:o>n.length&&(o=n.length);s<o;s++)yield n[s]}t.slice=w;function u(n,s=Number.POSITIVE_INFINITY){const o=[];if(s===0)return[o,n];const S=n[Symbol.iterator]();for(let $=0;$<s;$++){const m=S.next();if(m.done)return[o,t.empty()];o.push(m.value)}return[o,{[Symbol.iterator](){return S}}]}t.consume=u;async function i(n){const s=[];for await(const o of n)s.push(o);return Promise.resolve(s)}t.asyncToArray=i})(_||(e.Iterable=_={}))}),define(be[16],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y=void 0;class _{constructor(W){this.d=W,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(W){this.c=W}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$Y=_}),define(be[42],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=void 0;class _{static{this.Undefined=new _(void 0)}constructor(M){this.element=M,this.next=_.Undefined,this.prev=_.Undefined}}class t{constructor(){this.a=_.Undefined,this.b=_.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===_.Undefined}clear(){let M=this.a;for(;M!==_.Undefined;){const Y=M.next;M.prev=_.Undefined,M.next=_.Undefined,M=Y}this.a=_.Undefined,this.b=_.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,Y){const p=new _(M);if(this.a===_.Undefined)this.a=p,this.b=p;else if(Y){const T=this.b;this.b=p,p.prev=T,T.next=p}else{const T=this.a;this.a=p,p.next=T,T.prev=p}this.c+=1;let U=!1;return()=>{U||(U=!0,this.e(p))}}shift(){if(this.a!==_.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==_.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==_.Undefined&&M.next!==_.Undefined){const Y=M.prev;Y.next=M.next,M.next.prev=Y}else M.prev===_.Undefined&&M.next===_.Undefined?(this.a=_.Undefined,this.b=_.Undefined):M.next===_.Undefined?(this.b=this.b.prev,this.b.next=_.Undefined):M.prev===_.Undefined&&(this.a=this.a.next,this.a.prev=_.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==_.Undefined;)yield M.element,M=M.next}}e.$0c=t}),define(be[20],_e([0,1]),function(fe,e){"use strict";var _,t,W;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.Touch=e.$Gc=e.$Fc=void 0,e.$Cc=M,e.$Dc=Y,e.$Ec=p,e.$Nc=w;function M(u,i,n){let s=u.get(i);return s===void 0&&(s=n,u.set(i,s)),s}function Y(u){const i=[];return u.forEach((n,s)=>{i.push(`${s} => ${n}`)}),`Map(${u.size}) {${i.join(", ")}}`}function p(u){const i=[];return u.forEach(n=>{i.push(n)}),`Set(${u.size}) {${i.join(", ")}}`}class U{constructor(i,n){this.uri=i,this.value=n}}function T(u){return Array.isArray(u)}class N{static{this.c=i=>i.toString()}constructor(i,n){if(this[_]="ResourceMap",i instanceof N)this.d=new Map(i.d),this.e=n??N.c;else if(T(i)){this.d=new Map,this.e=n??N.c;for(const[s,o]of i)this.set(s,o)}else this.d=new Map,this.e=i??N.c}set(i,n){return this.d.set(this.e(i),new U(i,n)),this}get(i){return this.d.get(this.e(i))?.value}has(i){return this.d.has(this.e(i))}get size(){return this.d.size}clear(){this.d.clear()}delete(i){return this.d.delete(this.e(i))}forEach(i,n){typeof n<"u"&&(i=i.bind(n));for(const[s,o]of this.d)i(o.value,o.uri,this)}*values(){for(const i of this.d.values())yield i.value}*keys(){for(const i of this.d.values())yield i.uri}*entries(){for(const i of this.d.values())yield[i.uri,i.value]}*[(_=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.d)yield[i.uri,i.value]}}e.$Fc=N;class b{constructor(i,n){this[t]="ResourceSet",!i||typeof i=="function"?this.c=new N(i):(this.c=new N(n),i.forEach(this.add,this))}get size(){return this.c.size}add(i){return this.c.set(i,i),this}clear(){this.c.clear()}delete(i){return this.c.delete(i)}forEach(i,n){this.c.forEach((s,o)=>i.call(n,o,o,this))}has(i){return this.c.has(i)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Gc=b;var D;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(D||(e.Touch=D={}));class F{constructor(){this[W]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(i){return this.c.has(i)}get(i,n=D.None){const s=this.c.get(i);if(s)return n!==D.None&&this.m(s,n),s.value}set(i,n,s=D.None){let o=this.c.get(i);if(o)o.value=n,s!==D.None&&this.m(o,s);else{switch(o={key:i,value:n,next:void 0,previous:void 0},s){case D.None:this.k(o);break;case D.AsOld:this.j(o);break;case D.AsNew:this.k(o);break;default:this.k(o);break}this.c.set(i,o),this.f++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this.c.get(i);if(n)return this.c.delete(i),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const i=this.d;return this.c.delete(i.key),this.l(i),this.f--,i.value}forEach(i,n){const s=this.g;let o=this.d;for(;o;){if(n?i.bind(n)(o.value,o.key,this):i(o.value,o.key,this),this.g!==s)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,n=this.g;let s=this.d;const o={[Symbol.iterator](){return o},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const S={value:s.key,done:!1};return s=s.next,S}else return{value:void 0,done:!0}}};return o}values(){const i=this,n=this.g;let s=this.d;const o={[Symbol.iterator](){return o},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const S={value:s.value,done:!1};return s=s.next,S}else return{value:void 0,done:!0}}};return o}entries(){const i=this,n=this.g;let s=this.d;const o={[Symbol.iterator](){return o},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const S={value:[s.key,s.value],done:!1};return s=s.next,S}else return{value:void 0,done:!0}}};return o}[(W=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this.d,s=this.size;for(;n&&s>i;)this.c.delete(n.key),n=n.next,s--;this.d=n,this.f=s,n&&(n.previous=void 0),this.g++}i(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this.e,s=this.size;for(;n&&s>i;)this.c.delete(n.key),n=n.previous,s--;this.e=n,this.f=s,n&&(n.next=void 0),this.g++}j(i){if(!this.d&&!this.e)this.e=i;else if(this.d)i.next=this.d,this.d.previous=i;else throw new Error("Invalid list");this.d=i,this.g++}k(i){if(!this.d&&!this.e)this.d=i;else if(this.e)i.previous=this.e,this.e.next=i;else throw new Error("Invalid list");this.e=i,this.g++}l(i){if(i===this.d&&i===this.e)this.d=void 0,this.e=void 0;else if(i===this.d){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.d=i.next}else if(i===this.e){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.e=i.previous}else{const n=i.next,s=i.previous;if(!n||!s)throw new Error("Invalid list");n.previous=s,s.next=n}i.next=void 0,i.previous=void 0,this.g++}m(i,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==D.AsOld&&n!==D.AsNew)){if(n===D.AsOld){if(i===this.d)return;const s=i.next,o=i.previous;i===this.e?(o.next=void 0,this.e=o):(s.previous=o,o.next=s),i.previous=void 0,i.next=this.d,this.d.previous=i,this.d=i,this.g++}else if(n===D.AsNew){if(i===this.e)return;const s=i.next,o=i.previous;i===this.d?(s.previous=void 0,this.d=s):(s.previous=o,o.next=s),i.next=void 0,i.previous=this.e,this.e.next=i,this.e=i,this.g++}}}toJSON(){const i=[];return this.forEach((n,s)=>{i.push([s,n])}),i}fromJSON(i){this.clear();for(const[n,s]of i)this.set(n,s)}}e.$Hc=F;class c extends F{constructor(i,n=1){super(),this.n=i,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(i){this.n=i,this.p()}get ratio(){return this.o}set ratio(i){this.o=Math.min(Math.max(0,i),1),this.p()}get(i,n=D.AsNew){return super.get(i,n)}peek(i){return super.get(i,D.None)}set(i,n){return super.set(i,n,D.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class r extends c{constructor(i,n=1){super(i,n)}q(i){this.h(i)}set(i,n){return super.set(i,n),this.p(),this}}e.$Ic=r;class d extends c{constructor(i,n=1){super(i,n)}q(i){this.i(i)}set(i,n){return this.n<=this.size&&!this.has(i)&&this.q(Math.round(this.n*this.o)-1),super.set(i,n),this}}e.$Jc=d;class E{constructor(){this.c=new Map}add(i){return this.c.set(i,(this.c.get(i)||0)+1),this}delete(i){let n=this.c.get(i)||0;return n===0?!1:(n--,n===0?this.c.delete(i):this.c.set(i,n),!0)}has(i){return this.c.has(i)}}e.$Kc=E;class f{constructor(i){if(this.c=new Map,this.d=new Map,i)for(const[n,s]of i)this.set(n,s)}clear(){this.c.clear(),this.d.clear()}set(i,n){this.c.set(i,n),this.d.set(n,i)}get(i){return this.c.get(i)}getKey(i){return this.d.get(i)}delete(i){const n=this.c.get(i);return n===void 0?!1:(this.c.delete(i),this.d.delete(n),!0)}forEach(i,n){this.c.forEach((s,o)=>{i.call(n,s,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Lc=f;class A{constructor(){this.c=new Map}add(i,n){let s=this.c.get(i);s||(s=new Set,this.c.set(i,s)),s.add(n)}delete(i,n){const s=this.c.get(i);s&&(s.delete(n),s.size===0&&this.c.delete(i))}forEach(i,n){const s=this.c.get(i);s&&s.forEach(n)}get(i){const n=this.c.get(i);return n||new Set}}e.$Mc=A;function w(u,i){if(u===i)return!0;if(u.size!==i.size)return!1;for(const[n,s]of u)if(!i.has(n)||i.get(n)!==s)return!1;for(const[n]of i)if(!u.has(n))return!1;return!0}}),define(be[4],_e([0,1,12,39,20,27,41]),function(fe,e,_,t,W,M,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$7c=e.$6c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Oc=void 0,e.$Pc=N,e.$Qc=b,e.$Rc=D,e.$Sc=r,e.$Tc=d,e.$Uc=E,e.$Vc=f,e.$Wc=A,e.$Xc=w,e.$8c=y;const p=!1;let U=null;class T{constructor(){this.b=new Map}static{this.a=0}c(v){let q=this.b.get(v);return q||(q={parent:null,source:null,isSingleton:!1,value:v,idx:T.a++},this.b.set(v,q)),q}trackDisposable(v){const q=this.c(v);q.source||(q.source=new Error().stack)}setParent(v,q){const x=this.c(v);x.parent=q}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,q){const x=q.get(v);if(x)return x;const J=v.parent?this.f(this.c(v.parent),q):v;return q.set(v,J),J}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,x])=>x.source!==null&&!this.f(x,v).isSingleton).flatMap(([x])=>x)}computeLeakingDisposables(v=10,q){let x;if(q)x=q;else{const ne=new Map,re=[...this.b.values()].filter(I=>I.source!==null&&!this.f(I,ne).isSingleton);if(re.length===0)return;const oe=new Set(re.map(I=>I.value));if(x=re.filter(I=>!(I.parent&&oe.has(I.parent))),x.length===0)throw new Error("There are cyclic diposable chains!")}if(!x)return;function J(ne){function re(I,g){for(;I.length>0&&g.some(k=>typeof k=="string"?k===I[0]:I[0].match(k));)I.shift()}const oe=ne.source.split(`
`).map(I=>I.trim().replace("at ","")).filter(I=>I!=="");return re(oe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),oe.reverse()}const K=new W.$Mc;for(const ne of x){const re=J(ne);for(let oe=0;oe<=re.length;oe++)K.add(re.slice(0,oe).join(`
`),ne)}x.sort((0,_.$0b)(ne=>ne.idx,_.$_b));let se="",V=0;for(const ne of x.slice(0,v)){V++;const re=J(ne),oe=[];for(let I=0;I<re.length;I++){let g=re[I];g=`(shared with ${K.get(re.slice(0,I+1).join(`
`)).size}/${x.length} leaks) at ${g}`;const z=K.get(re.slice(0,I).join(`
`)),Q=(0,t.$e)([...z].map(R=>J(R)[I]),R=>R);delete Q[re[I]];for(const[R,Z]of Object.entries(Q))oe.unshift(`    - stacktraces of ${Z.length} other leaks continue with ${R}`);oe.unshift(g)}se+=`


==================== Leaking disposable ${V}/${x.length}: ${ne.value.constructor.name} ====================
${oe.join(`
`)}
============================================================

`}return x.length>v&&(se+=`


... and ${x.length-v} more leaking disposables

`),{leaks:x,details:se}}}e.$Oc=T;function N(l){U=l}if(p){const l="__is_disposable_tracked__";N(new class{trackDisposable(v){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[l]||console.log(q)},3e3)}setParent(v,q){if(v&&v!==i.None)try{v[l]=!0}catch{}}markAsDisposed(v){if(v&&v!==i.None)try{v[l]=!0}catch{}}markAsSingleton(v){}})}function b(l){return U?.trackDisposable(l),l}function D(l){U?.markAsDisposed(l)}function F(l,v){U?.setParent(l,v)}function c(l,v){if(U)for(const q of l)U.setParent(q,v)}function r(l){return U?.markAsSingleton(l),l}function d(l){return typeof l=="object"&&l!==null&&typeof l.dispose=="function"&&l.dispose.length===0}function E(l){if(Y.Iterable.is(l)){const v=[];for(const q of l)if(q)try{q.dispose()}catch(x){v.push(x)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}function f(l){for(const v of l)d(v)&&v.dispose();return[]}function A(...l){const v=w(()=>E(l));return c(l,v),v}function w(l){const v=b({dispose:(0,M.$hb)(()=>{D(v),l()})});return v}class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,b(this)}dispose(){this.g||(D(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{E(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return F(v,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),F(v,null))}}e.$Yc=u;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,b(this),F(this.q,this)}dispose(){D(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Zc=i;class n{constructor(){this.b=!1,b(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&F(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,D(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&F(v,null),v}}e.$1c=n;class s{constructor(v){this.a=new n,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$2c=s;class o{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$3c=o;class S{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(v){let q=v;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,D(this))},this}}e.$4c=S;class ${constructor(){this.a=new Map}acquire(v,...q){let x=this.a.get(v);x||(x={counter:0,object:this.b(v,...q)},this.a.set(v,x));const{object:J}=x,K=(0,M.$hb)(()=>{--x.counter===0&&(this.c(v,x.object),this.a.delete(v))});return x.counter++,{object:J,dispose:K}}}e.$5c=$;class m{constructor(v){this.a=v}async acquire(v,...q){const x=this.a.acquire(v,...q);try{return{object:await x.object,dispose:()=>x.dispose()}}catch(J){throw x.dispose(),J}}}e.$6c=m;class h{constructor(v){this.object=v}dispose(){}}e.$7c=h;function y(l){const v=new u;try{l(v)}finally{v.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,b(this)}dispose(){D(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{E(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,q,x=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),x||this.a.get(v)?.dispose(),this.a.set(v,q)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const q=this.a.get(v);return this.a.delete(v),q}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$9c=L}),define(be[28],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var _;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(_||(e.MarshalledId=_={}))}),define(be[21],_e([0,1,20]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=void 0,e.$sm=W,e.$tm=Y;const t=new _.$Ic(1e4);function W(T){return U(T,"NFC",t)}const M=new _.$Ic(1e4);function Y(T){return U(T,"NFD",M)}const p=/[^\u0000-\u0080]/;function U(T,N,b){if(!T)return T;const D=b.get(T);if(D)return D;let F;return p.test(T)?F=T.normalize(N):F=T,b.set(T,F),F}e.$um=function(){const T=/[\u0300-\u036f]/g;return function(N){return Y(N).replace(T,"")}}()}),define(be[43],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=void 0;const _=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(M){return new t(M)}constructor(M){this.c=_&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ke=t}),define(be[6],_e([0,1,9,27,4,42,43]),function(fe,e,_,t,W,M,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$me=e.Event=void 0,e.$ne=F;const p=!1,U=!1,T=!1;var N;(function(J){J.None=()=>W.$Zc.None;function K(ge){if(T){const{onDidAddListener:le}=ge,$e=r.create();let ae=0;ge.onDidAddListener=()=>{++ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),le?.()}}}function se(ge,le){return Z(ge,()=>{},0,void 0,!0,void 0,le)}J.defer=se;function V(ge){return(le,$e=null,ae)=>{let Ee=!1,ye;return ye=ge(Le=>{if(!Ee)return ye?ye.dispose():Ee=!0,le.call($e,Le)},null,ae),Ee&&ye.dispose(),ye}}J.once=V;function ne(ge,le){return J.once(J.filter(ge,le))}J.onceIf=ne;function re(ge,le,$e){return Q((ae,Ee=null,ye)=>ge(Le=>ae.call(Ee,le(Le)),null,ye),$e)}J.map=re;function oe(ge,le,$e){return Q((ae,Ee=null,ye)=>ge(Le=>{le(Le),ae.call(Ee,Le)},null,ye),$e)}J.forEach=oe;function I(ge,le,$e){return Q((ae,Ee=null,ye)=>ge(Le=>le(Le)&&ae.call(Ee,Le),null,ye),$e)}J.filter=I;function g(ge){return ge}J.signal=g;function k(...ge){return(le,$e=null,ae)=>{const Ee=(0,W.$Wc)(...ge.map(ye=>ye(Le=>le.call($e,Le))));return R(Ee,ae)}}J.any=k;function z(ge,le,$e,ae){let Ee=$e;return re(ge,ye=>(Ee=le(Ee,ye),Ee),ae)}J.reduce=z;function Q(ge,le){let $e;const ae={onWillAddFirstListener(){$e=ge(Ee.fire,Ee)},onDidRemoveLastListener(){$e?.dispose()}};le||K(ae);const Ee=new n(ae);return le?.add(Ee),Ee.event}function R(ge,le){return le instanceof Array?le.push(ge):le&&le.add(ge),ge}function Z(ge,le,$e=100,ae=!1,Ee=!1,ye,Le){let Ue,Te,Ae,ke=0,je;const He={leakWarningThreshold:ye,onWillAddFirstListener(){Ue=ge(Ve=>{ke++,Te=le(Te,Ve),ae&&!Ae&&(We.fire(Te),Te=void 0),je=()=>{const qe=Te;Te=void 0,Ae=void 0,(!ae||ke>1)&&We.fire(qe),ke=0},typeof $e=="number"?(clearTimeout(Ae),Ae=setTimeout(je,$e)):Ae===void 0&&(Ae=0,queueMicrotask(je))})},onWillRemoveListener(){Ee&&ke>0&&je?.()},onDidRemoveLastListener(){je=void 0,Ue.dispose()}};Le||K(He);const We=new n(He);return Le?.add(We),We.event}J.debounce=Z;function ee(ge,le=0,$e){return J.debounce(ge,(ae,Ee)=>ae?(ae.push(Ee),ae):[Ee],le,void 0,!0,void 0,$e)}J.accumulate=ee;function ie(ge,le=(ae,Ee)=>ae===Ee,$e){let ae=!0,Ee;return I(ge,ye=>{const Le=ae||!le(ye,Ee);return ae=!1,Ee=ye,Le},$e)}J.latch=ie;function ue(ge,le,$e){return[J.filter(ge,le,$e),J.filter(ge,ae=>!le(ae),$e)]}J.split=ue;function he(ge,le=!1,$e=[],ae){let Ee=$e.slice(),ye=ge(Te=>{Ee?Ee.push(Te):Ue.fire(Te)});ae&&ae.add(ye);const Le=()=>{Ee?.forEach(Te=>Ue.fire(Te)),Ee=null},Ue=new n({onWillAddFirstListener(){ye||(ye=ge(Te=>Ue.fire(Te)),ae&&ae.add(ye))},onDidAddFirstListener(){Ee&&(le?setTimeout(Le):Le())},onDidRemoveLastListener(){ye&&ye.dispose(),ye=null}});return ae&&ae.add(Ue),Ue.event}J.buffer=he;function we(ge,le){return(ae,Ee,ye)=>{const Le=le(new G);return ge(function(Ue){const Te=Le.evaluate(Ue);Te!==j&&ae.call(Ee,Te)},void 0,ye)}}J.chain=we;const j=Symbol("HaltChainable");class G{constructor(){this.f=[]}map(le){return this.f.push(le),this}forEach(le){return this.f.push($e=>(le($e),$e)),this}filter(le){return this.f.push($e=>le($e)?$e:j),this}reduce(le,$e){let ae=$e;return this.f.push(Ee=>(ae=le(ae,Ee),ae)),this}latch(le=($e,ae)=>$e===ae){let $e=!0,ae;return this.f.push(Ee=>{const ye=$e||!le(Ee,ae);return $e=!1,ae=Ee,ye?Ee:j}),this}evaluate(le){for(const $e of this.f)if(le=$e(le),le===j)break;return le}}function P(ge,le,$e=ae=>ae){const ae=(...Ue)=>Le.fire($e(...Ue)),Ee=()=>ge.on(le,ae),ye=()=>ge.removeListener(le,ae),Le=new n({onWillAddFirstListener:Ee,onDidRemoveLastListener:ye});return Le.event}J.fromNodeEventEmitter=P;function a(ge,le,$e=ae=>ae){const ae=(...Ue)=>Le.fire($e(...Ue)),Ee=()=>ge.addEventListener(le,ae),ye=()=>ge.removeEventListener(le,ae),Le=new n({onWillAddFirstListener:Ee,onDidRemoveLastListener:ye});return Le.event}J.fromDOMEventEmitter=a;function B(ge){return new Promise(le=>V(ge)(le))}J.toPromise=B;function X(ge){const le=new n;return ge.then($e=>{le.fire($e)},()=>{le.fire(void 0)}).finally(()=>{le.dispose()}),le.event}J.fromPromise=X;function te(ge,le){return ge($e=>le.fire($e))}J.forward=te;function de(ge,le,$e){return le($e),ge(ae=>le(ae))}J.runAndSubscribe=de;class De{constructor(le,$e){this._observable=le,this.f=0,this.g=!1;const ae={onWillAddFirstListener:()=>{le.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{le.removeObserver(this)}};$e||K(ae),this.emitter=new n(ae),$e&&$e.add(this.emitter)}beginUpdate(le){this.f++}handlePossibleChange(le){}handleChange(le,$e){this.g=!0}endUpdate(le){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Re(ge,le){return new De(ge,le).emitter.event}J.fromObservable=Re;function Oe(ge){return(le,$e,ae)=>{let Ee=0,ye=!1;const Le={beginUpdate(){Ee++},endUpdate(){Ee--,Ee===0&&(ge.reportChanges(),ye&&(ye=!1,le.call($e)))},handlePossibleChange(){},handleChange(){ye=!0}};ge.addObserver(Le),ge.reportChanges();const Ue={dispose(){ge.removeObserver(Le)}};return ae instanceof W.$Yc?ae.add(Ue):Array.isArray(ae)&&ae.push(Ue),Ue}}J.fromObservableLight=Oe})(N||(e.Event=N={}));class b{static{this.all=new Set}static{this.f=0}constructor(K){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${K}_${b.f++}`,b.all.add(this)}start(K){this.g=new Y.$ke,this.listenerCount=K}stop(){if(this.g){const K=this.g.elapsed();this.durations.push(K),this.elapsedOverall+=K,this.invocationCount+=1,this.g=void 0}}}e.$me=b;let D=-1;function F(J){const K=D;return D=J,{dispose(){D=K}}}class c{static{this.f=1}constructor(K,se,V=(c.f++).toString(16).padStart(3,"0")){this.j=K,this.threshold=se,this.name=V,this.h=0}dispose(){this.g?.clear()}check(K,se){const V=this.threshold;if(V<=0||se<V)return;this.g||(this.g=new Map);const ne=this.g.get(K.value)||0;if(this.g.set(K.value,ne+1),this.h-=1,this.h<=0){this.h=V*.5;const[re,oe]=this.getMostFrequentStack(),I=`[${this.name}] potential listener LEAK detected, having ${se} listeners already. MOST frequent listener (${oe}):`;console.warn(I),console.warn(re);const g=new d(I,re);this.j(g)}return()=>{const re=this.g.get(K.value)||0;this.g.set(K.value,re-1)}}getMostFrequentStack(){if(!this.g)return;let K,se=0;for(const[V,ne]of this.g)(!K||se<ne)&&(K=[V,ne],se=ne);return K}}class r{static create(){const K=new Error;return new r(K.stack??"")}constructor(K){this.value=K}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d extends Error{constructor(K,se){super(K),this.name="ListenerLeakError",this.stack=se}}e.$oe=d;class E extends Error{constructor(K,se){super(K),this.name="ListenerRefusalError",this.stack=se}}e.$pe=E;let f=0;class A{constructor(K){this.value=K,this.id=f++}}const w=2,u=(J,K)=>{if(J instanceof A)K(J);else for(let se=0;se<J.length;se++){const V=J[se];V&&K(V)}};let i;if(p){const J=[];setInterval(()=>{J.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(J.join(`
`)),J.length=0)},3e3),i=new FinalizationRegistry(K=>{typeof K=="string"&&J.push(K)})}class n{constructor(K){this.z=0,this.f=K,this.g=D>0||this.f?.leakWarningThreshold?new c(K?.onListenerError??_.$4,this.f?.leakWarningThreshold??D):void 0,this.j=this.f?._profName?new b(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(U){const K=this.u;queueMicrotask(()=>{u(K,se=>se.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(K,se,V)=>{if(this.g&&this.z>this.g.threshold**2){const g=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(g);const k=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],z=new E(`${g}. HINT: Stack shows most frequent listener (${k[1]}-times)`,k[0]);return(this.f?.onListenerError||_.$4)(z),W.$Zc.None}if(this.m)return W.$Zc.None;se&&(K=K.bind(se));const ne=new A(K);let re,oe;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(ne.stack=r.create(),re=this.g.check(ne.stack,this.z+1)),U&&(ne.stack=oe??r.create()),this.u?this.u instanceof A?(this.w??=new o,this.u=[this.u,ne]):this.u.push(ne):(this.f?.onWillAddFirstListener?.(this),this.u=ne,this.f?.onDidAddFirstListener?.(this)),this.z++;const I=(0,W.$Xc)(()=>{i?.unregister(I),re?.(),this.A(ne)});if(V instanceof W.$Yc?V.add(I):Array.isArray(V)&&V.push(I),i){const g=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),k=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(g);i.register(I,k?.[2]??g,I)}return I},this.q}A(K){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const se=this.u,V=se.indexOf(K);if(V===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,se[V]=void 0;const ne=this.w.current===this;if(this.z*w<=se.length){let re=0;for(let oe=0;oe<se.length;oe++)se[oe]?se[re++]=se[oe]:ne&&(this.w.end--,re<this.w.i&&this.w.i--);se.length=re}}B(K,se){if(!K)return;const V=this.f?.onListenerError||_.$4;if(!V){K.value(se);return}try{K.value(se)}catch(ne){V(ne)}}C(K){const se=K.current.u;for(;K.i<K.end;)this.B(se[K.i++],K.value);K.reset()}fire(K){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof A)this.B(this.u,K);else{const se=this.w;se.enqueue(this,K,this.u.length),this.C(se)}this.j?.stop()}hasListeners(){return this.z>0}}e.$qe=n;const s=()=>new o;e.$re=s;class o{constructor(){this.i=-1,this.end=0}enqueue(K,se,V){this.i=0,this.end=V,this.current=K,this.value=se}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class S extends n{async fireAsync(K,se,V){if(this.u)for(this.h||(this.h=new M.$0c),u(this.u,ne=>this.h.push([ne.value,K]));this.h.size>0&&!se.isCancellationRequested;){const[ne,re]=this.h.shift(),oe=[],I={...re,token:se,waitUntil:g=>{if(Object.isFrozen(oe))throw new Error("waitUntil can NOT be called asynchronous");V&&(g=V(g,ne)),oe.push(g)}};try{ne(I)}catch(g){(0,_.$4)(g);continue}Object.freeze(oe),await Promise.allSettled(oe).then(g=>{for(const k of g)k.status==="rejected"&&(0,_.$4)(k.reason)})}}}e.$se=S;class $ extends n{get isPaused(){return this.h!==0}constructor(K){super(K),this.h=0,this.s=new M.$0c,this.t=K?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const K=Array.from(this.s);this.s.clear(),super.fire(this.t(K))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(K){this.z&&(this.h!==0?this.s.push(K):super.fire(K))}}e.$te=$;class m extends ${constructor(K){super(K),this.k=K.delay??100}fire(K){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(K)}}e.$ue=m;class h extends n{constructor(K){super(K),this.h=[],this.k=K?.merge}fire(K){this.hasListeners()&&(this.h.push(K),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(se=>super.fire(se)),this.h=[]}))}}e.$ve=h;class y{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(K){const se={event:K,listener:null};this.h.push(se),this.g&&this.m(se);const V=()=>{this.g&&this.o(se);const ne=this.h.indexOf(se);this.h.splice(ne,1)};return(0,W.$Xc)((0,t.$hb)(V))}j(){this.g=!0,this.h.forEach(K=>this.m(K))}k(){this.g=!1,this.h.forEach(K=>this.o(K))}m(K){K.listener=K.event(se=>this.f.fire(se))}o(K){K.listener?.dispose(),K.listener=null}dispose(){this.f.dispose();for(const K of this.h)K.listener?.dispose();this.h=[]}}e.$we=y;class L{constructor(K,se,V,ne){this.f=new W.$Yc;const re=this.f.add(new y),oe=this.f.add(new W.$9c);function I(g){oe.set(g,re.add(ne(g)))}for(const g of K)I(g);this.f.add(se(g=>{I(g)})),this.f.add(V(g=>{oe.deleteAndDispose(g)})),this.event=re.event}dispose(){this.f.dispose()}}e.$xe=L;class l{constructor(){this.f=[]}wrapEvent(K,se,V){return(ne,re,oe)=>K(I=>{const g=this.f[this.f.length-1];if(!se){g?g.buffers.push(()=>ne.call(re,I)):ne.call(re,I);return}const k=g;if(!k){ne.call(re,se(V,I));return}k.items??=[],k.items.push(I),k.buffers.length===0&&g.buffers.push(()=>{k.reducedResult??=V?k.items.reduce(se,V):k.items.reduce(se),ne.call(re,k.reducedResult)})},void 0,oe)}bufferEvents(K){const se={buffers:new Array};this.f.push(se);const V=K();return this.f.pop(),se.buffers.forEach(ne=>ne()),V}}e.$ye=l;class v{constructor(){this.f=!1,this.g=N.None,this.h=W.$Zc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(K){this.g=K,this.f&&(this.h.dispose(),this.h=K(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ze=v;class q{static const(K){return new x(K)}constructor(K){this.g=K,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(K){K!==this.g&&(this.g=K,this.f.fire(void 0))}}e.$Ae=q;class x{constructor(K){this.value=K,this.onDidChange=N.None}}}),define(be[13],_e([0,1,6]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.CancellationToken=void 0,e.$Ce=p;const t=Object.freeze(function(U,T){const N=setTimeout(U.bind(T),0);return{dispose(){clearTimeout(N)}}});var W;(function(U){function T(N){return N===U.None||N===U.Cancelled||N instanceof M?!0:!N||typeof N!="object"?!1:typeof N.isCancellationRequested=="boolean"&&typeof N.onCancellationRequested=="function"}U.isCancellationToken=T,U.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),U.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(W||(e.CancellationToken=W={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new _.$qe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class Y{constructor(T){this.f=void 0,this.g=void 0,this.g=T&&T.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=W.Cancelled}dispose(T=!1){T&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=W.None}}e.$Be=Y;function p(U){const T=new Y;return U.add({dispose(){T.cancel()}}),T.token}}),define(be[44],_e([0,1,13]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ef=e.$df=e.$bf=void 0,e.$cf=W;class t{constructor(U){this.b=U,this.a=null}get(){if(this.a)return this.a;const U=new _.$Be,T=this.b(U.token);return this.a={promise:T,dispose:()=>{this.a=null,U.cancel(),U.dispose()}},this.a}}e.$bf=t;function W(p){return p}class M{constructor(U,T){this.a=void 0,this.b=void 0,typeof U=="function"?(this.c=U,this.d=W):(this.c=T,this.d=U.getCacheKey)}get(U){const T=this.d(U);return this.b!==T&&(this.b=T,this.a=this.c(U)),this.a}}e.$df=M;class Y{get cachedValues(){return this.a}constructor(U,T){this.a=new Map,this.b=new Map,typeof U=="function"?(this.c=U,this.d=W):(this.c=T,this.d=U.getCacheKey)}get(U){const T=this.d(U);if(this.b.has(T))return this.b.get(T);const N=this.c(U);return this.a.set(U,N),this.b.set(T,N),N}}e.$ef=Y}),define(be[45],_e([0,1,9,4]),function(fe,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=W,e.$Ee=M,e.$Fe=Y,e.$Ge=p,e.$He=T,e.$Ie=N,e.$Je=b,e.$Ke=D,e.$Le=F,e.$Me=c,e.$Ne=r,e.$Oe=d,e.$Pe=E,e.$Qe=f,e.$Re=A;function W(w){const u=w;return u?typeof u.read=="function":!1}function M(w){const u=w;return u?[u.on,u.pause,u.resume,u.destroy].every(i=>typeof i=="function"):!1}function Y(w){const u=w;return u?M(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}function p(w,u){return new U(w,u)}class U{constructor(u,i){this.e=u,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(i=>i(u))}h(u){this.c.error.length===0?(0,_.$4)(u):this.c.error.slice(0).forEach(i=>i(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,i){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(u,i){if(this.a.destroyed)return;let n;switch(u){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const s=n.indexOf(i);s>=0&&n.splice(s,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function T(w,u){const i=[];let n;for(;(n=w.read())!==null;)i.push(n);return u(i)}function N(w,u,i){const n=[];let s;for(;(s=w.read())!==null&&n.length<i;)n.push(s);return s===null&&n.length>0?u(n):{read:()=>{if(n.length>0)return n.shift();if(typeof s<"u"){const o=s;return s=void 0,o}return w.read()}}}function b(w,u){return new Promise((i,n)=>{const s=[];D(w,{onData:o=>{u&&s.push(o)},onError:o=>{u?n(o):i(void 0)},onEnd:()=>{i(u?u(s):void 0)}})})}function D(w,u,i){w.on("error",n=>{i?.isCancellationRequested||u.onError(n)}),w.on("end",()=>{i?.isCancellationRequested||u.onEnd()}),w.on("data",n=>{i?.isCancellationRequested||u.onData(n)})}function F(w,u){return new Promise((i,n)=>{const s=new t.$Yc,o=[],S=h=>{if(o.push(h),o.length>u)return s.dispose(),w.pause(),i({stream:w,buffer:o,ended:!1})},$=h=>(s.dispose(),n(h)),m=()=>(s.dispose(),i({stream:w,buffer:o,ended:!0}));s.add((0,t.$Xc)(()=>w.removeListener("error",$))),w.on("error",$),s.add((0,t.$Xc)(()=>w.removeListener("end",m))),w.on("end",m),s.add((0,t.$Xc)(()=>w.removeListener("data",S))),w.on("data",S)})}function c(w,u){const i=p(u);return i.end(w),i}function r(){const w=p(()=>{throw new Error("not supported")});return w.end(),w}function d(w){let u=!1;return{read:()=>u?null:(u=!0,w)}}function E(w,u,i){const n=p(i);return D(w,{onData:s=>n.write(u.data(s)),onError:s=>n.error(u.error?u.error(s):s),onEnd:()=>n.end()}),n}function f(w,u,i){let n=!1;return{read:()=>{const s=u.read();return n?s:(n=!0,s!==null?i([w,s]):w)}}}function A(w,u,i){let n=!1;const s=p(i);return D(u,{onData:o=>n?s.write(o):(n=!0,s.write(i([w,o]))),onError:o=>s.error(o),onEnd:()=>{n||(n=!0,s.write(w)),s.end()}}),s}});var Xe=this&&this.__createBinding||(Object.create?function(fe,e,_,t){t===void 0&&(t=_);var W=Object.getOwnPropertyDescriptor(e,_);(!W||("get"in W?!e.__esModule:W.writable||W.configurable))&&(W={enumerable:!0,get:function(){return e[_]}}),Object.defineProperty(fe,t,W)}:function(fe,e,_,t){t===void 0&&(t=_),fe[t]=e[_]}),Qe=this&&this.__setModuleDefault||(Object.create?function(fe,e){Object.defineProperty(fe,"default",{enumerable:!0,value:e})}:function(fe,e){fe.default=e}),Ie=this&&this.__importStar||function(fe){if(fe&&fe.__esModule)return fe;var e={};if(fe!=null)for(var _ in fe)_!=="default"&&Object.prototype.hasOwnProperty.call(fe,_)&&Xe(e,fe,_);return Qe(e,fe),e};define(be[17],_e([0,1,16,45]),function(fe,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=void 0,e.$Te=T,e.$Ue=N,e.$Ve=b,e.$We=D,e.$Xe=F,e.$Ye=c,e.$Ze=r,e.$1e=d,e.$2e=E,e.$3e=f,e.$4e=A,e.$5e=w,e.$6e=u,e.$7e=i,e.$8e=n,e.$9e=s,e.$0e=o,e.$$e=S,e.$_e=$,e.$af=y,t=Ie(t);const W=typeof Buffer<"u",M=new _.$Y(()=>new Uint8Array(256));let Y,p;class U{static alloc(l){return W?new U(Buffer.allocUnsafe(l)):new U(new Uint8Array(l))}static wrap(l){return W&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new U(l)}static fromString(l,v){return!(v?.dontUseNodeBuffer||!1)&&W?new U(Buffer.from(l)):(Y||(Y=new TextEncoder),new U(Y.encode(l)))}static fromByteArray(l){const v=U.alloc(l.length);for(let q=0,x=l.length;q<x;q++)v.buffer[q]=l[q];return v}static concat(l,v){if(typeof v>"u"){v=0;for(let J=0,K=l.length;J<K;J++)v+=l[J].byteLength}const q=U.alloc(v);let x=0;for(let J=0,K=l.length;J<K;J++){const se=l[J];q.set(se,x),x+=se.byteLength}return q}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=U.alloc(this.byteLength);return l.set(this),l}toString(){return W?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(l,v){return new U(this.buffer.subarray(l,v))}set(l,v){if(l instanceof U)this.buffer.set(l.buffer,v);else if(l instanceof Uint8Array)this.buffer.set(l,v);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),v);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return D(this.buffer,l)}writeUInt32BE(l,v){F(this.buffer,l,v)}readUInt32LE(l){return c(this.buffer,l)}writeUInt32LE(l,v){r(this.buffer,l,v)}readUInt8(l){return d(this.buffer,l)}writeUInt8(l,v){E(this.buffer,l,v)}indexOf(l,v=0){return T(this.buffer,l instanceof U?l.buffer:l,v)}}e.$Se=U;function T(L,l,v=0){const q=l.byteLength,x=L.byteLength;if(q===0)return 0;if(q===1)return L.indexOf(l[0]);if(q>x-v)return-1;const J=M.value;J.fill(l.length);for(let ne=0;ne<l.length;ne++)J[l[ne]]=l.length-ne-1;let K=v+l.length-1,se=K,V=-1;for(;K<x;)if(L[K]===l[se]){if(se===0){V=K;break}K--,se--}else K+=Math.max(l.length-se,J[L[K]]),se=l.length-1;return V}function N(L,l){return L[l+0]<<0>>>0|L[l+1]<<8>>>0}function b(L,l,v){L[v+0]=l&255,l=l>>>8,L[v+1]=l&255}function D(L,l){return L[l]*2**24+L[l+1]*2**16+L[l+2]*2**8+L[l+3]}function F(L,l,v){L[v+3]=l,l=l>>>8,L[v+2]=l,l=l>>>8,L[v+1]=l,l=l>>>8,L[v]=l}function c(L,l){return L[l+0]<<0>>>0|L[l+1]<<8>>>0|L[l+2]<<16>>>0|L[l+3]<<24>>>0}function r(L,l,v){L[v+0]=l&255,l=l>>>8,L[v+1]=l&255,l=l>>>8,L[v+2]=l&255,l=l>>>8,L[v+3]=l&255}function d(L,l){return L[l]}function E(L,l,v){L[v]=l}function f(L){return t.$He(L,l=>U.concat(l))}function A(L){return t.$Oe(L)}function w(L){return t.$Je(L,l=>U.concat(l))}async function u(L){return L.ended?U.concat(L.buffer):U.concat([...L.buffer,await w(L.stream)])}function i(L){return t.$Me(L,l=>U.concat(l))}function n(L){return t.$Pe(L,{data:l=>typeof l=="string"?U.fromString(l):U.wrap(l)},l=>U.concat(l))}function s(L){return t.$Ge(l=>U.concat(l),L)}function o(L,l){return t.$Qe(L,l,v=>U.concat(v))}function S(L,l){return t.$Re(L,l,v=>U.concat(v))}function $(L){let l=0,v=0,q=0;const x=new Uint8Array(Math.floor(L.length/4*3)),J=se=>{switch(v){case 3:x[q++]=l|se,v=0;break;case 2:x[q++]=l|se>>>2,l=se<<6,v=3;break;case 1:x[q++]=l|se>>>4,l=se<<4,v=2;break;default:l=se<<2,v=1}};for(let se=0;se<L.length;se++){const V=L.charCodeAt(se);if(V>=65&&V<=90)J(V-65);else if(V>=97&&V<=122)J(V-97+26);else if(V>=48&&V<=57)J(V-48+52);else if(V===43||V===45)J(62);else if(V===47||V===95)J(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${L[se]}`)}}const K=q;for(;v>0;)J(0);return U.wrap(x).slice(0,K)}const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:L},l=!0,v=!1){const q=v?h:m;let x="";const J=L.byteLength%3;let K=0;for(;K<L.byteLength-J;K+=3){const se=L[K+0],V=L[K+1],ne=L[K+2];x+=q[se>>>2],x+=q[(se<<4|V>>>4)&63],x+=q[(V<<2|ne>>>6)&63],x+=q[ne&63]}if(J===1){const se=L[K+0];x+=q[se>>>2],x+=q[se<<4&63],l&&(x+="==")}else if(J===2){const se=L[K+0],V=L[K+1];x+=q[se>>>2],x+=q[(se<<4|V>>>4)&63],x+=q[V<<2&63],l&&(x+="=")}return x}}),define(be[46],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=void 0,e.$le=Symbol("MicrotaskDelay")}),define(be[10],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=_,e.$kg=t,e.$lg=W,e.$mg=M,e.$ng=Y,e.$og=p,e.$pg=U,e.$qg=T,e.$rg=N,e.$sg=b,e.$tg=D,e.$ug=F,e.$vg=c,e.$wg=d,e.$xg=E,e.$yg=f,e.$zg=A,e.$Ag=w,e.$Bg=u;function _(i){return typeof i=="string"}function t(i){return Array.isArray(i)&&i.every(n=>_(n))}function W(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function M(i){const n=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof n}function Y(i){return typeof i=="number"&&!isNaN(i)}function p(i){return!!i&&typeof i[Symbol.iterator]=="function"}function U(i){return i===!0||i===!1}function T(i){return typeof i>"u"}function N(i){return!b(i)}function b(i){return T(i)||i===null}function D(i,n){if(!i)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function F(i){if(b(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function c(...i){const n=[];for(let s=0;s<i.length;s++){const o=i[s];if(b(o))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(o)}return n}const r=Object.prototype.hasOwnProperty;function d(i){if(!W(i))return!1;for(const n in i)if(r.call(i,n))return!1;return!0}function E(i){return typeof i=="function"}function f(...i){return i.length>0&&i.every(E)}function A(i,n){const s=Math.min(i.length,n.length);for(let o=0;o<s;o++)w(i[o],n[o])}function w(i,n){if(_(n)){if(typeof i!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(E(n)){try{if(i instanceof n)return}catch{}if(!b(i)&&i.constructor===n||n.length===1&&n.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function u(i){return i}}),define(be[47],_e([0,1,10]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=t,e.$lo=W,e.$mo=Y,e.$no=U,e.$oo=T,e.$po=N,e.$qo=b,e.$ro=D,e.$so=F,e.$to=c,e.$uo=r,e.$vo=d,e.$wo=E;function t(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const A=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([w,u])=>{A[w]=u&&typeof u=="object"?t(u):u}),A}function W(f){if(!f||typeof f!="object")return f;const A=[f];for(;A.length>0;){const w=A.shift();Object.freeze(w);for(const u in w)if(M.call(w,u)){const i=w[u];typeof i=="object"&&!Object.isFrozen(i)&&!(0,_.$mg)(i)&&A.push(i)}}return f}const M=Object.prototype.hasOwnProperty;function Y(f,A){return p(f,A,new Set)}function p(f,A,w){if((0,_.$sg)(f))return f;const u=A(f);if(typeof u<"u")return u;if(Array.isArray(f)){const i=[];for(const n of f)i.push(p(n,A,w));return i}if((0,_.$lg)(f)){if(w.has(f))throw new Error("Cannot clone recursive data-structure");w.add(f);const i={};for(const n in f)M.call(f,n)&&(i[n]=p(f[n],A,w));return w.delete(f),i}return f}function U(f,A,w=!0){return(0,_.$lg)(f)?((0,_.$lg)(A)&&Object.keys(A).forEach(u=>{u in f?w&&((0,_.$lg)(f[u])&&(0,_.$lg)(A[u])?U(f[u],A[u],w):f[u]=A[u]):f[u]=A[u]}),f):A}function T(f,A){if(f===A)return!0;if(f==null||A===null||A===void 0||typeof f!=typeof A||typeof f!="object"||Array.isArray(f)!==Array.isArray(A))return!1;let w,u;if(Array.isArray(f)){if(f.length!==A.length)return!1;for(w=0;w<f.length;w++)if(!T(f[w],A[w]))return!1}else{const i=[];for(u in f)i.push(u);i.sort();const n=[];for(u in A)n.push(u);if(n.sort(),!T(i,n))return!1;for(w=0;w<i.length;w++)if(!T(f[i[w]],A[i[w]]))return!1}return!0}function N(f){const A=new Set;return JSON.stringify(f,(w,u)=>{if((0,_.$lg)(u)||Array.isArray(u)){if(A.has(u))return"[Circular]";A.add(u)}return typeof u=="bigint"?`[BigInt ${u.toString()}]`:u})}function b(f,A){const w=Object.create(null);return!f||!A||Object.keys(A).forEach(i=>{const n=f[i],s=A[i];T(n,s)||(w[i]=s)}),w}function D(f,A){const w=A.toLowerCase(),u=Object.keys(f).find(i=>i.toLowerCase()===w);return u?f[u]:f[A]}function F(f,A){const w=Object.create(null);for(const[u,i]of Object.entries(f))A(u,i)&&(w[u]=i);return w}function c(f){let A=[];for(;Object.prototype!==f;)A=A.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return A}function r(f){const A=[];for(const w of c(f))typeof f[w]=="function"&&A.push(w);return A}function d(f,A){const w=i=>function(){const n=Array.prototype.slice.call(arguments,0);return A(i,n)},u={};for(const i of f)u[i]=w(i);return u}function E(f,A){const w={};for(const[u,i]of Object.entries(f))w[u]=A(i,u);return w}}),define(be[48],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$ff=t,e.$gf=W;var _;(function(M){M[M.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",M[M.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",M[M.MAX_UINT_8=255]="MAX_UINT_8",M[M.MAX_UINT_16=65535]="MAX_UINT_16",M[M.MAX_UINT_32=4294967295]="MAX_UINT_32",M[M.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_||(e.Constants=_={}));function t(M){return M<0?0:M>_.MAX_UINT_8?_.MAX_UINT_8:M|0}function W(M){return M<0?0:M>_.MAX_UINT_32?_.MAX_UINT_32:M|0}}),define(be[7],_e([0,1,44,11,16,48]),function(fe,e,_,t,W,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=e.GraphemeBreakType=e.$9f=e.$1f=e.$Tf=e.$Sf=void 0,e.$hf=Y,e.$if=U,e.$jf=N,e.$kf=b,e.$lf=D,e.$mf=F,e.$nf=c,e.$of=r,e.$pf=d,e.$qf=E,e.$rf=f,e.$sf=A,e.$tf=w,e.$uf=u,e.$vf=i,e.$wf=n,e.$xf=s,e.$yf=o,e.$zf=S,e.$Af=$,e.$Bf=m,e.$Cf=h,e.$Df=y,e.$Ef=L,e.$Ff=l,e.$Gf=v,e.$Hf=q,e.$If=x,e.$Jf=J,e.$Kf=K,e.$Lf=se,e.$Mf=V,e.$Nf=ne,e.$Of=re,e.$Pf=oe,e.$Qf=I,e.$Rf=g,e.$Uf=R,e.$Vf=Z,e.$Wf=ee,e.$Xf=ie,e.$Yf=we,e.$Zf=G,e.$2f=P,e.$3f=a,e.$4f=B,e.$5f=X,e.$6f=de,e.$7f=De,e.$8f=Oe,e.$0f=ge,e.$$f=le,e.$_f=$e,e.$ag=ae,e.$bg=Ee,e.$cg=ye,e.$dg=Le,e.$eg=Ue,e.$fg=He;function Y(O){return!O||typeof O!="string"?!0:O.trim().length===0}const p=/{(\d+)}/g;function U(O,...H){return H.length===0?O:O.replace(p,function(C,ce){const me=parseInt(ce,10);return isNaN(me)||me<0||me>=H.length?C:H[me]})}const T=/{([^}]+)}/g;function N(O,H){return Object.keys(H).length===0?O:O.replace(T,(C,ce)=>H[ce]??C)}function b(O){return O.replace(/[<>"'&]/g,H=>{switch(H){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return H})}function D(O){return O.replace(/[<>&]/g,function(H){switch(H){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return H}})}function F(O){return O.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(O,H){let C=0,ce=O.indexOf(H);for(;ce!==-1;)C++,ce=O.indexOf(H,ce+H.length);return C}function r(O,H,C="\u2026"){return O.length<=H?O:`${O.substr(0,H)}${C}`}function d(O,H,C="\u2026"){if(O.length<=H)return O;const ce=Math.ceil(H/2)-C.length/2,me=Math.floor(H/2)-C.length/2;return`${O.substr(0,ce)}${C}${O.substr(O.length-me)}`}function E(O,H=" "){const C=f(O,H);return A(C,H)}function f(O,H){if(!O||!H)return O;const C=H.length;if(C===0||O.length===0)return O;let ce=0;for(;O.indexOf(H,ce)===ce;)ce=ce+C;return O.substring(ce)}function A(O,H){if(!O||!H)return O;const C=H.length,ce=O.length;if(C===0||ce===0)return O;let me=ce,ve=-1;for(;ve=O.lastIndexOf(H,me-1),!(ve===-1||ve+C!==me);){if(ve===0)return"";me=ve}return O.substring(0,me)}function w(O){return O.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function u(O){return O.replace(/\*/g,"")}function i(O,H,C={}){if(!O)throw new Error("Cannot create regex from empty string");H||(O=F(O)),C.wholeWord&&(/\B/.test(O.charAt(0))||(O="\\b"+O),/\B/.test(O.charAt(O.length-1))||(O=O+"\\b"));let ce="";return C.global&&(ce+="g"),C.matchCase||(ce+="i"),C.multiline&&(ce+="m"),C.unicode&&(ce+="u"),new RegExp(O,ce)}function n(O){return O.source==="^"||O.source==="^$"||O.source==="$"||O.source==="^\\s*$"?!1:!!(O.exec("")&&O.lastIndex===0)}function s(O){return O.split(/\r\n|\r|\n/)}function o(O){const H=[],C=O.split(/(\r\n|\r|\n)/);for(let ce=0;ce<Math.ceil(C.length/2);ce++)H.push(C[2*ce]+(C[2*ce+1]??""));return H}function S(O){for(let H=0,C=O.length;H<C;H++){const ce=O.charCodeAt(H);if(ce!==t.CharCode.Space&&ce!==t.CharCode.Tab)return H}return-1}function $(O,H=0,C=O.length){for(let ce=H;ce<C;ce++){const me=O.charCodeAt(ce);if(me!==t.CharCode.Space&&me!==t.CharCode.Tab)return O.substring(H,ce)}return O.substring(H,C)}function m(O,H=O.length-1){for(let C=H;C>=0;C--){const ce=O.charCodeAt(C);if(ce!==t.CharCode.Space&&ce!==t.CharCode.Tab)return C}return-1}function h(O,H,C){const ce=[];let me=0;for(const ve of O.matchAll(H)){if(ce.push(O.slice(me,ve.index)),ve.index===void 0)throw new Error("match.index should be defined");me=ve.index+ve[0].length,ce.push(C(ve[0],...ve.slice(1),ve.index,O,ve.groups))}return ce.push(O.slice(me)),Promise.all(ce).then(ve=>ve.join(""))}function y(O,H){return O<H?-1:O>H?1:0}function L(O,H,C=0,ce=O.length,me=0,ve=H.length){for(;C<ce&&me<ve;C++,me++){const Ne=O.charCodeAt(C),Fe=H.charCodeAt(me);if(Ne<Fe)return-1;if(Ne>Fe)return 1}const Pe=ce-C,Me=ve-me;return Pe<Me?-1:Pe>Me?1:0}function l(O,H){return v(O,H,0,O.length,0,H.length)}function v(O,H,C=0,ce=O.length,me=0,ve=H.length){for(;C<ce&&me<ve;C++,me++){let Ne=O.charCodeAt(C),Fe=H.charCodeAt(me);if(Ne===Fe)continue;if(Ne>=128||Fe>=128)return L(O.toLowerCase(),H.toLowerCase(),C,ce,me,ve);x(Ne)&&(Ne-=32),x(Fe)&&(Fe-=32);const Se=Ne-Fe;if(Se!==0)return Se}const Pe=ce-C,Me=ve-me;return Pe<Me?-1:Pe>Me?1:0}function q(O){return O>=t.CharCode.Digit0&&O<=t.CharCode.Digit9}function x(O){return O>=t.CharCode.a&&O<=t.CharCode.z}function J(O){return O>=t.CharCode.A&&O<=t.CharCode.Z}function K(O,H){return O.length===H.length&&v(O,H)===0}function se(O,H){const C=H.length;return H.length>O.length?!1:v(O,H,0,C)===0}function V(O,H){const C=Math.min(O.length,H.length);let ce;for(ce=0;ce<C;ce++)if(O.charCodeAt(ce)!==H.charCodeAt(ce))return ce;return C}function ne(O,H){const C=Math.min(O.length,H.length);let ce;const me=O.length-1,ve=H.length-1;for(ce=0;ce<C;ce++)if(O.charCodeAt(me-ce)!==H.charCodeAt(ve-ce))return ce;return C}function re(O){return 55296<=O&&O<=56319}function oe(O){return 56320<=O&&O<=57343}function I(O,H){return(O-55296<<10)+(H-56320)+65536}function g(O,H,C){const ce=O.charCodeAt(C);if(re(ce)&&C+1<H){const me=O.charCodeAt(C+1);if(oe(me))return I(ce,me)}return ce}function k(O,H){const C=O.charCodeAt(H-1);if(oe(C)&&H>1){const ce=O.charCodeAt(H-2);if(re(ce))return I(ce,C)}return C}class z{get offset(){return this.e}constructor(H,C=0){this.c=H,this.d=H.length,this.e=C}setOffset(H){this.e=H}prevCodePoint(){const H=k(this.c,this.e);return this.e-=H>=M.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,H}nextCodePoint(){const H=g(this.c,this.d,this.e);return this.e+=H>=M.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,H}eol(){return this.e>=this.d}}e.$Sf=z;class Q{get offset(){return this.c.offset}constructor(H,C=0){this.c=new z(H,C)}nextGraphemeLength(){const H=ke.getInstance(),C=this.c,ce=C.offset;let me=H.getGraphemeBreakType(C.nextCodePoint());for(;!C.eol();){const ve=C.offset,Pe=H.getGraphemeBreakType(C.nextCodePoint());if(Te(me,Pe)){C.setOffset(ve);break}me=Pe}return C.offset-ce}prevGraphemeLength(){const H=ke.getInstance(),C=this.c,ce=C.offset;let me=H.getGraphemeBreakType(C.prevCodePoint());for(;C.offset>0;){const ve=C.offset,Pe=H.getGraphemeBreakType(C.prevCodePoint());if(Te(Pe,me)){C.setOffset(ve);break}me=Pe}return ce-C.offset}eol(){return this.c.eol()}}e.$Tf=Q;function R(O,H){return new Q(O,H).nextGraphemeLength()}function Z(O,H){return new Q(O,H).prevGraphemeLength()}function ee(O,H){H>0&&oe(O.charCodeAt(H))&&H--;const C=H+R(O,H);return[C-Z(O,C),C]}function ie(O){const H=new Q(O);let C=0;for(;!H.eol();)C++,H.nextGraphemeLength();return C}let ue;function he(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function we(O){return ue||(ue=he()),ue.test(O)}const j=/^[\t\n\r\x20-\x7E]*$/;function G(O){return j.test(O)}e.$1f=/[\u2028\u2029]/;function P(O){return e.$1f.test(O)}function a(O){return O>=11904&&O<=55215||O>=63744&&O<=64255||O>=65281&&O<=65374}function B(O){return O>=127462&&O<=127487||O===8986||O===8987||O===9200||O===9203||O>=9728&&O<=10175||O===11088||O===11093||O>=127744&&O<=128591||O>=128640&&O<=128764||O>=128992&&O<=129008||O>=129280&&O<=129535||O>=129648&&O<=129782}function X(O,H,C=""){const ce=O.trimStart();if(ce.length<H)return ce;const me=/\b/g;let ve=0;for(;me.test(ce)&&!(ce.length-me.lastIndex<H);)ve=me.lastIndex,me.lastIndex+=1;return ve===0?ce:C+ce.substring(ve).trimStart()}const te=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*de(O){let H=0;for(const C of O.matchAll(te))H!==C.index&&(yield{isCode:!1,str:O.substring(H,C.index)}),yield{isCode:!0,str:C[0]},H=C.index+C[0].length;H!==O.length&&(yield{isCode:!1,str:O.substring(H)})}function De(O){return O&&(O=O.replace(te,"")),O}const Re=/\\\[.*?\\\]/g;function Oe(O){return De(O).replace(Re,"")}e.$9f=String.fromCharCode(t.CharCode.UTF8_BOM);function ge(O){return!!(O&&O.length>0&&O.charCodeAt(0)===t.CharCode.UTF8_BOM)}function le(O){return ge(O)?O.substr(1):O}function $e(O,H){if(!O||!H||O.length<H.length)return!1;const C=H.length,ce=O.toLowerCase();let me=0,ve=-1;for(;me<C;){const Pe=ce.indexOf(H[me],ve+1);if(Pe<0)return!1;ve=Pe,me++}return!0}function ae(O,H=!1){return O?(H&&(O=O.replace(/\\./g,"")),O.toLowerCase()!==O):!1}function Ee(O){return O.charAt(0).toUpperCase()+O.slice(1)}function ye(O,H=1){if(H===0)return"";let C=-1;do C=O.indexOf(`
`,C+1),H--;while(H>0&&C>=0);return C===-1?O:(O[C-1]==="\r"&&C--,O.substr(0,C))}function Le(O){const H=t.CharCode.Z-t.CharCode.A+1;return O=O%(2*H),O<H?String.fromCharCode(t.CharCode.a+O):String.fromCharCode(t.CharCode.A+O-H)}function Ue(O){return ke.getInstance().getGraphemeBreakType(O)}function Te(O,H){return O===Ae.Other?H!==Ae.Extend&&H!==Ae.SpacingMark:O===Ae.CR&&H===Ae.LF?!1:O===Ae.Control||O===Ae.CR||O===Ae.LF||H===Ae.Control||H===Ae.CR||H===Ae.LF?!0:!(O===Ae.L&&(H===Ae.L||H===Ae.V||H===Ae.LV||H===Ae.LVT)||(O===Ae.LV||O===Ae.V)&&(H===Ae.V||H===Ae.T)||(O===Ae.LVT||O===Ae.T)&&H===Ae.T||H===Ae.Extend||H===Ae.ZWJ||H===Ae.SpacingMark||O===Ae.Prepend||O===Ae.ZWJ&&H===Ae.Extended_Pictographic||O===Ae.Regional_Indicator&&H===Ae.Regional_Indicator)}var Ae;(function(O){O[O.Other=0]="Other",O[O.Prepend=1]="Prepend",O[O.CR=2]="CR",O[O.LF=3]="LF",O[O.Control=4]="Control",O[O.Extend=5]="Extend",O[O.Regional_Indicator=6]="Regional_Indicator",O[O.SpacingMark=7]="SpacingMark",O[O.L=8]="L",O[O.V=9]="V",O[O.T=10]="T",O[O.LV=11]="LV",O[O.LVT=12]="LVT",O[O.ZWJ=13]="ZWJ",O[O.Extended_Pictographic=14]="Extended_Pictographic"})(Ae||(e.GraphemeBreakType=Ae={}));class ke{static{this.c=null}static getInstance(){return ke.c||(ke.c=new ke),ke.c}constructor(){this.d=je()}getGraphemeBreakType(H){if(H<32)return H===t.CharCode.LineFeed?Ae.LF:H===t.CharCode.CarriageReturn?Ae.CR:Ae.Control;if(H<127)return Ae.Other;const C=this.d,ce=C.length/3;let me=1;for(;me<=ce;)if(H<C[3*me])me=2*me;else if(H>C[3*me+1])me=2*me+1;else return C[3*me+2];return Ae.Other}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(O,H){if(O===0)return 0;const C=We(O,H);if(C!==void 0)return C;const ce=new z(H,O);return ce.prevCodePoint(),ce.offset}function We(O,H){const C=new z(H,O);let ce=C.prevCodePoint();for(;Ve(ce)||ce===qe.emojiVariantSelector||ce===qe.enclosingKeyCap;){if(C.offset===0)return;ce=C.prevCodePoint()}if(!B(ce))return;let me=C.offset;return me>0&&C.prevCodePoint()===qe.zwj&&(me=C.offset),me}function Ve(O){return 127995<=O&&O<=127999}var qe;(function(O){O[O.zwj=8205]="zwj",O[O.emojiVariantSelector=65039]="emojiVariantSelector",O[O.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.$gg="\xA0";class ze{static{this.c=new W.$Y(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new _.$df({getCacheKey:JSON.stringify},H=>{function C(Se){const Be=new Map;for(let pe=0;pe<Se.length;pe+=2)Be.set(Se[pe],Se[pe+1]);return Be}function ce(Se,Be){const pe=new Map(Se);for(const[Ke,Ye]of Be)pe.set(Ke,Ye);return pe}function me(Se,Be){if(!Se)return Be;const pe=new Map;for(const[Ke,Ye]of Se)Be.has(Ke)&&pe.set(Ke,Ye);return pe}const ve=this.c.value;let Pe=H.filter(Se=>!Se.startsWith("_")&&Se in ve);Pe.length===0&&(Pe=["_default"]);let Me;for(const Se of Pe){const Be=C(ve[Se]);Me=me(Me,Be)}const Ne=C(ve._common),Fe=ce(Ne,Me);return new ze(Fe)})}static getInstance(H){return ze.d.get(Array.from(H))}static{this.e=new W.$Y(()=>Object.keys(ze.c.value).filter(H=>!H.startsWith("_")))}static getLocales(){return ze.e.value}constructor(H){this.f=H}isAmbiguous(H){return this.f.has(H)}containsAmbiguousCharacter(H){for(let C=0;C<H.length;C++){const ce=H.codePointAt(C);if(typeof ce=="number"&&this.isAmbiguous(ce))return!0}return!1}getPrimaryConfusable(H){return this.f.get(H)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$hg=ze;class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(H){return Ge.e().has(H)}static containsInvisibleCharacter(H){for(let C=0;C<H.length;C++){const ce=H.codePointAt(C);if(typeof ce=="number"&&Ge.isInvisibleCharacter(ce))return!0}return!1}static get codePoints(){return Ge.e()}}e.$ig=Ge}),define(be[29],_e([0,1,12,11,7]),function(fe,e,_,t,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=void 0;class M{constructor(){this.b="",this.c=0}reset(c){return this.b=c,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(c){const r=c.charCodeAt(0),d=this.b.charCodeAt(this.c);return r-d}value(){return this.b[this.c]}}e.$Mi=M;class Y{constructor(c=!0){this.e=c}reset(c){return this.b=c,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let c=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===t.CharCode.Period)if(c)this.c++;else break;else c=!1;return this}cmp(c){return this.e?(0,W.$Ef)(c,this.b,0,c.length,this.c,this.d):(0,W.$Gf)(c,this.b,0,c.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ni=Y;class p{constructor(c=!0,r=!0){this.f=c,this.g=r}reset(c){this.d=0,this.e=0,this.b=c,this.c=c.length;for(let r=c.length-1;r>=0;r--,this.c--){const d=this.b.charCodeAt(r);if(!(d===t.CharCode.Slash||this.f&&d===t.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let c=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===t.CharCode.Slash||this.f&&r===t.CharCode.Backslash)if(c)this.d++;else break;else c=!1}return this}cmp(c){return this.g?(0,W.$Ef)(c,this.b,0,c.length,this.d,this.e):(0,W.$Gf)(c,this.b,0,c.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Oi=p;var U;(function(F){F[F.Scheme=1]="Scheme",F[F.Authority=2]="Authority",F[F.Path=3]="Path",F[F.Query=4]="Query",F[F.Fragment=5]="Fragment"})(U||(U={}));class T{constructor(c,r){this.f=c,this.g=r,this.d=[],this.e=0}reset(c){return this.c=c,this.d=[],this.c.scheme&&this.d.push(U.Scheme),this.c.authority&&this.d.push(U.Authority),this.c.path&&(this.b=new p(!1,!this.f(c)),this.b.reset(c.path),this.b.value()&&this.d.push(U.Path)),this.g(c)||(this.c.query&&this.d.push(U.Query),this.c.fragment&&this.d.push(U.Fragment)),this.e=0,this}next(){return this.d[this.e]===U.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===U.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(c){if(this.d[this.e]===U.Scheme)return(0,W.$Ff)(c,this.c.scheme);if(this.d[this.e]===U.Authority)return(0,W.$Ff)(c,this.c.authority);if(this.d[this.e]===U.Path)return this.b.cmp(c);if(this.d[this.e]===U.Query)return(0,W.$Df)(c,this.c.query);if(this.d[this.e]===U.Fragment)return(0,W.$Df)(c,this.c.fragment);throw new Error}value(){if(this.d[this.e]===U.Scheme)return this.c.scheme;if(this.d[this.e]===U.Authority)return this.c.authority;if(this.d[this.e]===U.Path)return this.b.value();if(this.d[this.e]===U.Query)return this.c.query;if(this.d[this.e]===U.Fragment)return this.c.fragment;throw new Error}}e.$Pi=T;class N{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(F){F[F.Left=-1]="Left",F[F.Mid=0]="Mid",F[F.Right=1]="Right"})(b||(b={}));class D{static forUris(c=()=>!1,r=()=>!1){return new D(new T(c,r))}static forPaths(c=!1){return new D(new p(void 0,!c))}static forStrings(){return new D(new M)}static forConfigKeys(){return new D(new Y)}constructor(c){this.b=c}clear(){this.c=void 0}fill(c,r){if(r){const d=r.slice(0);(0,_.$1b)(d);for(const E of d)this.set(E,c)}else{const d=c.slice(0);(0,_.$1b)(d);for(const E of d)this.set(E[0],E[1])}}set(c,r){const d=this.b.reset(c);let E;this.c||(this.c=new N,this.c.segment=d.value());const f=[];for(E=this.c;;){const w=d.cmp(E.segment);if(w>0)E.left||(E.left=new N,E.left.segment=d.value()),f.push([b.Left,E]),E=E.left;else if(w<0)E.right||(E.right=new N,E.right.segment=d.value()),f.push([b.Right,E]),E=E.right;else if(d.hasNext())d.next(),E.mid||(E.mid=new N,E.mid.segment=d.value()),f.push([b.Mid,E]),E=E.mid;else break}const A=E.value;E.value=r,E.key=c;for(let w=f.length-1;w>=0;w--){const u=f[w][1];u.updateHeight();const i=u.balanceFactor();if(i<-1||i>1){const n=f[w][0],s=f[w+1][0];if(n===b.Right&&s===b.Right)f[w][1]=u.rotateLeft();else if(n===b.Left&&s===b.Left)f[w][1]=u.rotateRight();else if(n===b.Right&&s===b.Left)u.right=f[w+1][1]=f[w+1][1].rotateRight(),f[w][1]=u.rotateLeft();else if(n===b.Left&&s===b.Right)u.left=f[w+1][1]=f[w+1][1].rotateLeft(),f[w][1]=u.rotateRight();else throw new Error;if(w>0)switch(f[w-1][0]){case b.Left:f[w-1][1].left=f[w][1];break;case b.Right:f[w-1][1].right=f[w][1];break;case b.Mid:f[w-1][1].mid=f[w][1];break}else this.c=f[0][1]}}return A}get(c){return this.d(c)?.value}d(c){const r=this.b.reset(c);let d=this.c;for(;d;){const E=r.cmp(d.segment);if(E>0)d=d.left;else if(E<0)d=d.right;else if(r.hasNext())r.next(),d=d.mid;else break}return d}has(c){const r=this.d(c);return!(r?.value===void 0&&r?.mid===void 0)}delete(c){return this.e(c,!1)}deleteSuperstr(c){return this.e(c,!0)}e(c,r){const d=this.b.reset(c),E=[];let f=this.c;for(;f;){const A=d.cmp(f.segment);if(A>0)E.push([b.Left,f]),f=f.left;else if(A<0)E.push([b.Right,f]),f=f.right;else if(d.hasNext())d.next(),E.push([b.Mid,f]),f=f.mid;else break}if(f){if(r?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const A=this.f(f.right);if(A.key){const{key:w,value:u,segment:i}=A;this.e(A.key,!1),f.key=w,f.value=u,f.segment=i}}else{const A=f.left??f.right;if(E.length>0){const[w,u]=E[E.length-1];switch(w){case b.Left:u.left=A;break;case b.Mid:u.mid=A;break;case b.Right:u.right=A;break}}else this.c=A}for(let A=E.length-1;A>=0;A--){const w=E[A][1];w.updateHeight();const u=w.balanceFactor();if(u>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),E[A][1]=w.rotateLeft()):u<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),E[A][1]=w.rotateRight()),A>0)switch(E[A-1][0]){case b.Left:E[A-1][1].left=E[A][1];break;case b.Right:E[A-1][1].right=E[A][1];break;case b.Mid:E[A-1][1].mid=E[A][1];break}else this.c=E[0][1]}}}f(c){for(;c.left;)c=c.left;return c}findSubstr(c){const r=this.b.reset(c);let d=this.c,E;for(;d;){const f=r.cmp(d.segment);if(f>0)d=d.left;else if(f<0)d=d.right;else if(r.hasNext())r.next(),E=d.value||E,d=d.mid;else break}return d&&d.value||E}findSuperstr(c){return this.g(c,!1)}g(c,r){const d=this.b.reset(c);let E=this.c;for(;E;){const f=d.cmp(E.segment);if(f>0)E=E.left;else if(f<0)E=E.right;else if(d.hasNext())d.next(),E=E.mid;else return E.mid?this.h(E.mid):r?E.value:void 0}}hasElementOrSubtree(c){return this.g(c,!0)!==void 0}forEach(c){for(const[r,d]of this)c(d,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(c){const r=[];return this.j(c,r),r[Symbol.iterator]()}j(c,r){c&&(c.left&&this.j(c.left,r),c.value&&r.push([c.key,c.value]),c.mid&&this.j(c.mid,r),c.right&&this.j(c.right,r))}_isBalanced(){const c=r=>{if(!r)return!0;const d=r.balanceFactor();return d<-1||d>1?!1:c(r.left)&&c(r.right)};return c(this.c)}}e.$Qi=D}),define(be[30],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zY=_;function _(t){return!!t.parentPort}}),define(be[31],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a=_,e.$b=t;function _(){return globalThis._VSCODE_NLS_MESSAGES}function t(){return globalThis._VSCODE_NLS_LANGUAGE}}),define(be[22],_e([0,1,31,31]),function(fe,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=e.getNLSLanguage=void 0,e.localize=Y,e.localize2=U,Object.defineProperty(e,"getNLSLanguage",{enumerable:!0,get:function(){return t.$b}}),Object.defineProperty(e,"getNLSMessages",{enumerable:!0,get:function(){return t.$a}});const W=(0,_.$b)()==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function M(T,N){let b;return N.length===0?b=T:b=T.replace(/\{(\d+)\}/g,(D,F)=>{const c=F[0],r=N[c];let d=D;return typeof r=="string"?d=r:(typeof r=="number"||typeof r=="boolean"||r===void 0||r===null)&&(d=String(r)),d}),W&&(b="\uFF3B"+b.replace(/[aouei]/g,"$&$&")+"\uFF3D"),b}function Y(T,N,...b){return M(typeof T=="number"?p(T,N):N,b)}function p(T,N){const b=(0,_.$a)()?.[T];if(typeof b!="string"){if(typeof N=="string")return N;throw new Error(`!!! NLS MISSING: ${T} !!!`)}return b}function U(T,N,...b){let D;typeof T=="number"?D=p(T,N):D=N;const F=M(D,b);return{value:F,original:N===D?F:M(N,b)}}}),define(be[49],_e([0,1,12,10,22]),function(fe,e,_,t,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=U,e.$wj=T,e.$xj=N,_=Ie(_),t=Ie(t),W=Ie(W);function M(b,D){return D&&(b.stack||b.stacktrace)?W.localize(107,null,p(b),Y(b.stack)||Y(b.stacktrace)):p(b)}function Y(b){return Array.isArray(b)?b.join(`
`):b}function p(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?W.localize(108,null,b.message):b.message||W.localize(109,null)}function U(b=null,D=!1){if(!b)return W.localize(110,null);if(Array.isArray(b)){const F=_.$Lb(b),c=U(F[0],D);return F.length>1?W.localize(111,null,c,F.length):c}if(t.$jg(b))return b;if(b.detail){const F=b.detail;if(F.error)return M(F.error,D);if(F.exception)return M(F.exception,D)}return b.stack?M(b,D):b.message?b.message:W.localize(112,null)}function T(b){const D=b;return D instanceof Error&&Array.isArray(D.actions)}function N(b,D){let F;return typeof b=="string"?F=new Error(b):F=b,F.actions=D,F}}),define(be[2],_e([0,1,22]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=e.$H=e.OS=e.OperatingSystem=e.$E=e.$D=e.$C=e.$B=e.$A=e.Language=e.$z=e.$y=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.Platform=e.$j=void 0,e.$k=n,e.$G=h,e.$M=y,_=Ie(_),e.$j="en";let t=!1,W=!1,M=!1,Y=!1,p=!1,U=!1,T=!1,N=!1,b=!1,D=!1,F,c=e.$j,r=e.$j,d,E;const f=globalThis;let A;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?A=f.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(A=process);const w=typeof A?.versions?.electron=="string",u=w&&A?.type==="renderer";if(typeof A=="object"){t=A.platform==="win32",W=A.platform==="darwin",M=A.platform==="linux",Y=M&&!!A.env.SNAP&&!!A.env.SNAP_REVISION,T=w,b=!!A.env.CI||!!A.env.BUILD_ARTIFACTSTAGINGDIRECTORY,F=e.$j,c=e.$j;const L=A.env.VSCODE_NLS_CONFIG;if(L)try{const l=JSON.parse(L);F=l.userLocale,r=l.osLocale,c=l.resolvedLanguage||e.$j,d=l.languagePack?.translationsConfigFile}catch{}p=!0}else typeof navigator=="object"&&!u?(E=navigator.userAgent,t=E.indexOf("Windows")>=0,W=E.indexOf("Macintosh")>=0,N=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=E.indexOf("Linux")>=0,D=E?.indexOf("Mobi")>=0,U=!0,c=_.getNLSLanguage()||e.$j,F=navigator.language.toLowerCase(),r=F):console.error("Unable to resolve platform.");var i;(function(L){L[L.Web=0]="Web",L[L.Mac=1]="Mac",L[L.Linux=2]="Linux",L[L.Windows=3]="Windows"})(i||(e.Platform=i={}));function n(L){switch(L){case i.Web:return"Web";case i.Mac:return"Mac";case i.Linux:return"Linux";case i.Windows:return"Windows"}}let s=i.Web;W?s=i.Mac:t?s=i.Windows:M&&(s=i.Linux),e.$l=t,e.$m=W,e.$n=M,e.$o=Y,e.$p=p,e.$q=T,e.$r=U,e.$s=U&&typeof f.importScripts=="function",e.$t=e.$s?f.origin:void 0,e.$u=N,e.$v=D,e.$w=b,e.$x=s,e.$y=E,e.$z=c;var o;(function(L){function l(){return e.$z}L.value=l;function v(){return e.$z.length===2?e.$z==="en":e.$z.length>=3?e.$z[0]==="e"&&e.$z[1]==="n"&&e.$z[2]==="-":!1}L.isDefaultVariant=v;function q(){return e.$z==="en"}L.isDefault=q})(o||(e.Language=o={})),e.$A=F,e.$B=r,e.$C=d,e.$D=typeof f.postMessage=="function"&&!f.importScripts,e.$E=(()=>{if(e.$D){const L=[];f.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let q=0,x=L.length;q<x;q++){const J=L[q];if(J.id===v.data.vscodeScheduleAsyncWork){L.splice(q,1),J.callback();return}}});let l=0;return v=>{const q=++l;L.push({id:q,callback:v}),f.postMessage({vscodeScheduleAsyncWork:q},"*")}}return L=>setTimeout(L)})();var S;(function(L){L[L.Windows=1]="Windows",L[L.Macintosh=2]="Macintosh",L[L.Linux=3]="Linux"})(S||(e.OperatingSystem=S={})),e.OS=W||N?S.Macintosh:t?S.Windows:S.Linux;let $=!0,m=!1;function h(){if(!m){m=!0;const L=new Uint8Array(2);L[0]=1,L[1]=2,$=new Uint16Array(L.buffer)[0]===513}return $}e.$H=!!(e.$y&&e.$y.indexOf("Chrome")>=0),e.$I=!!(e.$y&&e.$y.indexOf("Firefox")>=0),e.$J=!!(!e.$H&&e.$y&&e.$y.indexOf("Safari")>=0),e.$K=!!(e.$y&&e.$y.indexOf("Edg/")>=0),e.$L=!!(e.$y&&e.$y.indexOf("Android")>=0);function y(L){return parseFloat(L)>=20}}),define(be[32],_e([0,1,2]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jc=e.$ic=e.env=e.cwd=void 0;let t;const W=globalThis.vscode;if(typeof W<"u"&&typeof W.process<"u"){const M=W.process;t={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return _.$l?"win32":_.$m?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.$ic=t.platform,e.$jc=t.arch}),define(be[3],_e([0,1,32]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yc=e.sep=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=void 0,_=Ie(_);const t=65,W=97,M=90,Y=122,p=46,U=47,T=92,N=58,b=63;class D extends Error{constructor(s,o,S){let $;typeof o=="string"&&o.indexOf("not ")===0?($="must not be",o=o.replace(/^not /,"")):$="must be";const m=s.indexOf(".")!==-1?"property":"argument";let h=`The "${s}" ${m} ${$} of type ${o}`;h+=`. Received type ${typeof S}`,super(h),this.code="ERR_INVALID_ARG_TYPE"}}function F(n,s){if(n===null||typeof n!="object")throw new D(s,"Object",n)}function c(n,s){if(typeof n!="string")throw new D(s,"string",n)}const r=_.$ic==="win32";function d(n){return n===U||n===T}function E(n){return n===U}function f(n){return n>=t&&n<=M||n>=W&&n<=Y}function A(n,s,o,S){let $="",m=0,h=-1,y=0,L=0;for(let l=0;l<=n.length;++l){if(l<n.length)L=n.charCodeAt(l);else{if(S(L))break;L=U}if(S(L)){if(!(h===l-1||y===1))if(y===2){if($.length<2||m!==2||$.charCodeAt($.length-1)!==p||$.charCodeAt($.length-2)!==p){if($.length>2){const v=$.lastIndexOf(o);v===-1?($="",m=0):($=$.slice(0,v),m=$.length-1-$.lastIndexOf(o)),h=l,y=0;continue}else if($.length!==0){$="",m=0,h=l,y=0;continue}}s&&($+=$.length>0?`${o}..`:"..",m=2)}else $.length>0?$+=`${o}${n.slice(h+1,l)}`:$=n.slice(h+1,l),m=l-h-1;h=l,y=0}else L===p&&y!==-1?++y:y=-1}return $}function w(n){return n?`${n[0]==="."?"":"."}${n}`:""}function u(n,s){F(s,"pathObject");const o=s.dir||s.root,S=s.base||`${s.name||""}${w(s.ext)}`;return o?o===s.root?`${o}${S}`:`${o}${n}${S}`:S}e.$kc={resolve(...n){let s="",o="",S=!1;for(let $=n.length-1;$>=-1;$--){let m;if($>=0){if(m=n[$],c(m,`paths[${$}]`),m.length===0)continue}else s.length===0?m=_.cwd():(m=_.env[`=${s}`]||_.cwd(),(m===void 0||m.slice(0,2).toLowerCase()!==s.toLowerCase()&&m.charCodeAt(2)===T)&&(m=`${s}\\`));const h=m.length;let y=0,L="",l=!1;const v=m.charCodeAt(0);if(h===1)d(v)&&(y=1,l=!0);else if(d(v))if(l=!0,d(m.charCodeAt(1))){let q=2,x=q;for(;q<h&&!d(m.charCodeAt(q));)q++;if(q<h&&q!==x){const J=m.slice(x,q);for(x=q;q<h&&d(m.charCodeAt(q));)q++;if(q<h&&q!==x){for(x=q;q<h&&!d(m.charCodeAt(q));)q++;(q===h||q!==x)&&(L=`\\\\${J}\\${m.slice(x,q)}`,y=q)}}}else y=1;else f(v)&&m.charCodeAt(1)===N&&(L=m.slice(0,2),y=2,h>2&&d(m.charCodeAt(2))&&(l=!0,y=3));if(L.length>0)if(s.length>0){if(L.toLowerCase()!==s.toLowerCase())continue}else s=L;if(S){if(s.length>0)break}else if(o=`${m.slice(y)}\\${o}`,S=l,l&&s.length>0)break}return o=A(o,!S,"\\",d),S?`${s}\\${o}`:`${s}${o}`||"."},normalize(n){c(n,"path");const s=n.length;if(s===0)return".";let o=0,S,$=!1;const m=n.charCodeAt(0);if(s===1)return E(m)?"\\":n;if(d(m))if($=!0,d(n.charCodeAt(1))){let y=2,L=y;for(;y<s&&!d(n.charCodeAt(y));)y++;if(y<s&&y!==L){const l=n.slice(L,y);for(L=y;y<s&&d(n.charCodeAt(y));)y++;if(y<s&&y!==L){for(L=y;y<s&&!d(n.charCodeAt(y));)y++;if(y===s)return`\\\\${l}\\${n.slice(L)}\\`;y!==L&&(S=`\\\\${l}\\${n.slice(L,y)}`,o=y)}}}else o=1;else f(m)&&n.charCodeAt(1)===N&&(S=n.slice(0,2),o=2,s>2&&d(n.charCodeAt(2))&&($=!0,o=3));let h=o<s?A(n.slice(o),!$,"\\",d):"";return h.length===0&&!$&&(h="."),h.length>0&&d(n.charCodeAt(s-1))&&(h+="\\"),S===void 0?$?`\\${h}`:h:$?`${S}\\${h}`:`${S}${h}`},isAbsolute(n){c(n,"path");const s=n.length;if(s===0)return!1;const o=n.charCodeAt(0);return d(o)||s>2&&f(o)&&n.charCodeAt(1)===N&&d(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,o;for(let m=0;m<n.length;++m){const h=n[m];c(h,"path"),h.length>0&&(s===void 0?s=o=h:s+=`\\${h}`)}if(s===void 0)return".";let S=!0,$=0;if(typeof o=="string"&&d(o.charCodeAt(0))){++$;const m=o.length;m>1&&d(o.charCodeAt(1))&&(++$,m>2&&(d(o.charCodeAt(2))?++$:S=!1))}if(S){for(;$<s.length&&d(s.charCodeAt($));)$++;$>=2&&(s=`\\${s.slice($)}`)}return e.$kc.normalize(s)},relative(n,s){if(c(n,"from"),c(s,"to"),n===s)return"";const o=e.$kc.resolve(n),S=e.$kc.resolve(s);if(o===S||(n=o.toLowerCase(),s=S.toLowerCase(),n===s))return"";let $=0;for(;$<n.length&&n.charCodeAt($)===T;)$++;let m=n.length;for(;m-1>$&&n.charCodeAt(m-1)===T;)m--;const h=m-$;let y=0;for(;y<s.length&&s.charCodeAt(y)===T;)y++;let L=s.length;for(;L-1>y&&s.charCodeAt(L-1)===T;)L--;const l=L-y,v=h<l?h:l;let q=-1,x=0;for(;x<v;x++){const K=n.charCodeAt($+x);if(K!==s.charCodeAt(y+x))break;K===T&&(q=x)}if(x!==v){if(q===-1)return S}else{if(l>v){if(s.charCodeAt(y+x)===T)return S.slice(y+x+1);if(x===2)return S.slice(y+x)}h>v&&(n.charCodeAt($+x)===T?q=x:x===2&&(q=3)),q===-1&&(q=0)}let J="";for(x=$+q+1;x<=m;++x)(x===m||n.charCodeAt(x)===T)&&(J+=J.length===0?"..":"\\..");return y+=q,J.length>0?`${J}${S.slice(y,L)}`:(S.charCodeAt(y)===T&&++y,S.slice(y,L))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=e.$kc.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===T){if(s.charCodeAt(1)===T){const o=s.charCodeAt(2);if(o!==b&&o!==p)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(f(s.charCodeAt(0))&&s.charCodeAt(1)===N&&s.charCodeAt(2)===T)return`\\\\?\\${s}`;return n},dirname(n){c(n,"path");const s=n.length;if(s===0)return".";let o=-1,S=0;const $=n.charCodeAt(0);if(s===1)return d($)?n:".";if(d($)){if(o=S=1,d(n.charCodeAt(1))){let y=2,L=y;for(;y<s&&!d(n.charCodeAt(y));)y++;if(y<s&&y!==L){for(L=y;y<s&&d(n.charCodeAt(y));)y++;if(y<s&&y!==L){for(L=y;y<s&&!d(n.charCodeAt(y));)y++;if(y===s)return n;y!==L&&(o=S=y+1)}}}}else f($)&&n.charCodeAt(1)===N&&(o=s>2&&d(n.charCodeAt(2))?3:2,S=o);let m=-1,h=!0;for(let y=s-1;y>=S;--y)if(d(n.charCodeAt(y))){if(!h){m=y;break}}else h=!1;if(m===-1){if(o===-1)return".";m=o}return n.slice(0,m)},basename(n,s){s!==void 0&&c(s,"suffix"),c(n,"path");let o=0,S=-1,$=!0,m;if(n.length>=2&&f(n.charCodeAt(0))&&n.charCodeAt(1)===N&&(o=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let h=s.length-1,y=-1;for(m=n.length-1;m>=o;--m){const L=n.charCodeAt(m);if(d(L)){if(!$){o=m+1;break}}else y===-1&&($=!1,y=m+1),h>=0&&(L===s.charCodeAt(h)?--h===-1&&(S=m):(h=-1,S=y))}return o===S?S=y:S===-1&&(S=n.length),n.slice(o,S)}for(m=n.length-1;m>=o;--m)if(d(n.charCodeAt(m))){if(!$){o=m+1;break}}else S===-1&&($=!1,S=m+1);return S===-1?"":n.slice(o,S)},extname(n){c(n,"path");let s=0,o=-1,S=0,$=-1,m=!0,h=0;n.length>=2&&n.charCodeAt(1)===N&&f(n.charCodeAt(0))&&(s=S=2);for(let y=n.length-1;y>=s;--y){const L=n.charCodeAt(y);if(d(L)){if(!m){S=y+1;break}continue}$===-1&&(m=!1,$=y+1),L===p?o===-1?o=y:h!==1&&(h=1):o!==-1&&(h=-1)}return o===-1||$===-1||h===0||h===1&&o===$-1&&o===S+1?"":n.slice(o,$)},format:u.bind(null,"\\"),parse(n){c(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const o=n.length;let S=0,$=n.charCodeAt(0);if(o===1)return d($)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(d($)){if(S=1,d(n.charCodeAt(1))){let q=2,x=q;for(;q<o&&!d(n.charCodeAt(q));)q++;if(q<o&&q!==x){for(x=q;q<o&&d(n.charCodeAt(q));)q++;if(q<o&&q!==x){for(x=q;q<o&&!d(n.charCodeAt(q));)q++;q===o?S=q:q!==x&&(S=q+1)}}}}else if(f($)&&n.charCodeAt(1)===N){if(o<=2)return s.root=s.dir=n,s;if(S=2,d(n.charCodeAt(2))){if(o===3)return s.root=s.dir=n,s;S=3}}S>0&&(s.root=n.slice(0,S));let m=-1,h=S,y=-1,L=!0,l=n.length-1,v=0;for(;l>=S;--l){if($=n.charCodeAt(l),d($)){if(!L){h=l+1;break}continue}y===-1&&(L=!1,y=l+1),$===p?m===-1?m=l:v!==1&&(v=1):m!==-1&&(v=-1)}return y!==-1&&(m===-1||v===0||v===1&&m===y-1&&m===h+1?s.base=s.name=n.slice(h,y):(s.name=n.slice(h,m),s.base=n.slice(h,y),s.ext=n.slice(m,y))),h>0&&h!==S?s.dir=n.slice(0,h-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(r){const n=/\\/g;return()=>{const s=_.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>_.cwd()})();e.$lc={resolve(...n){let s="",o=!1;for(let S=n.length-1;S>=-1&&!o;S--){const $=S>=0?n[S]:i();c($,`paths[${S}]`),$.length!==0&&(s=`${$}/${s}`,o=$.charCodeAt(0)===U)}return s=A(s,!o,"/",E),o?`/${s}`:s.length>0?s:"."},normalize(n){if(c(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===U,o=n.charCodeAt(n.length-1)===U;return n=A(n,!s,"/",E),n.length===0?s?"/":o?"./":".":(o&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return c(n,"path"),n.length>0&&n.charCodeAt(0)===U},join(...n){if(n.length===0)return".";let s;for(let o=0;o<n.length;++o){const S=n[o];c(S,"path"),S.length>0&&(s===void 0?s=S:s+=`/${S}`)}return s===void 0?".":e.$lc.normalize(s)},relative(n,s){if(c(n,"from"),c(s,"to"),n===s||(n=e.$lc.resolve(n),s=e.$lc.resolve(s),n===s))return"";const o=1,S=n.length,$=S-o,m=1,h=s.length-m,y=$<h?$:h;let L=-1,l=0;for(;l<y;l++){const q=n.charCodeAt(o+l);if(q!==s.charCodeAt(m+l))break;q===U&&(L=l)}if(l===y)if(h>y){if(s.charCodeAt(m+l)===U)return s.slice(m+l+1);if(l===0)return s.slice(m+l)}else $>y&&(n.charCodeAt(o+l)===U?L=l:l===0&&(L=0));let v="";for(l=o+L+1;l<=S;++l)(l===S||n.charCodeAt(l)===U)&&(v+=v.length===0?"..":"/..");return`${v}${s.slice(m+L)}`},toNamespacedPath(n){return n},dirname(n){if(c(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===U;let o=-1,S=!0;for(let $=n.length-1;$>=1;--$)if(n.charCodeAt($)===U){if(!S){o=$;break}}else S=!1;return o===-1?s?"/":".":s&&o===1?"//":n.slice(0,o)},basename(n,s){s!==void 0&&c(s,"ext"),c(n,"path");let o=0,S=-1,$=!0,m;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let h=s.length-1,y=-1;for(m=n.length-1;m>=0;--m){const L=n.charCodeAt(m);if(L===U){if(!$){o=m+1;break}}else y===-1&&($=!1,y=m+1),h>=0&&(L===s.charCodeAt(h)?--h===-1&&(S=m):(h=-1,S=y))}return o===S?S=y:S===-1&&(S=n.length),n.slice(o,S)}for(m=n.length-1;m>=0;--m)if(n.charCodeAt(m)===U){if(!$){o=m+1;break}}else S===-1&&($=!1,S=m+1);return S===-1?"":n.slice(o,S)},extname(n){c(n,"path");let s=-1,o=0,S=-1,$=!0,m=0;for(let h=n.length-1;h>=0;--h){const y=n.charCodeAt(h);if(y===U){if(!$){o=h+1;break}continue}S===-1&&($=!1,S=h+1),y===p?s===-1?s=h:m!==1&&(m=1):s!==-1&&(m=-1)}return s===-1||S===-1||m===0||m===1&&s===S-1&&s===o+1?"":n.slice(s,S)},format:u.bind(null,"/"),parse(n){c(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const o=n.charCodeAt(0)===U;let S;o?(s.root="/",S=1):S=0;let $=-1,m=0,h=-1,y=!0,L=n.length-1,l=0;for(;L>=S;--L){const v=n.charCodeAt(L);if(v===U){if(!y){m=L+1;break}continue}h===-1&&(y=!1,h=L+1),v===p?$===-1?$=L:l!==1&&(l=1):$!==-1&&(l=-1)}if(h!==-1){const v=m===0&&o?1:m;$===-1||l===0||l===1&&$===h-1&&$===m+1?s.base=s.name=n.slice(v,h):(s.name=n.slice(v,$),s.base=n.slice(v,h),s.ext=n.slice($,h))}return m>0?s.dir=n.slice(0,m-1):o&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$lc.win32=e.$kc.win32=e.$kc,e.$lc.posix=e.$kc.posix=e.$lc,e.$mc=r?e.$kc.normalize:e.$lc.normalize,e.$nc=r?e.$kc.isAbsolute:e.$lc.isAbsolute,e.$oc=r?e.$kc.join:e.$lc.join,e.$pc=r?e.$kc.resolve:e.$lc.resolve,e.$qc=r?e.$kc.relative:e.$lc.relative,e.$rc=r?e.$kc.dirname:e.$lc.dirname,e.$sc=r?e.$kc.basename:e.$lc.basename,e.$tc=r?e.$kc.extname:e.$lc.extname,e.$uc=r?e.$kc.format:e.$lc.format,e.$vc=r?e.$kc.parse:e.$lc.parse,e.$wc=r?e.$kc.toNamespacedPath:e.$lc.toNamespacedPath,e.sep=r?e.$kc.sep:e.$lc.sep,e.$yc=r?e.$kc.delimiter:e.$lc.delimiter}),define(be[14],_e([0,1,11,3,2,7,10]),function(fe,e,_,t,W,M,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=p,e.$Dg=U,e.$Eg=T,e.$Fg=N,e.$Gg=b,e.$Hg=r,e.$Ig=d,e.$Jg=E,e.$Kg=f,e.$Lg=A,e.$Mg=w,e.$Ng=u,e.$Og=i,e.$Pg=n,e.$Qg=s,e.$Rg=o,e.$Sg=m;function p(h){return h===_.CharCode.Slash||h===_.CharCode.Backslash}function U(h){return h.replace(/[\\/]/g,t.$lc.sep)}function T(h){return h.indexOf("/")===-1&&(h=U(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}function N(h,y=t.$lc.sep){if(!h)return"";const L=h.length,l=h.charCodeAt(0);if(p(l)){if(p(h.charCodeAt(1))&&!p(h.charCodeAt(2))){let q=3;const x=q;for(;q<L&&!p(h.charCodeAt(q));q++);if(x!==q&&!p(h.charCodeAt(q+1))){for(q+=1;q<L;q++)if(p(h.charCodeAt(q)))return h.slice(0,q+1).replace(/[\\/]/g,y)}}return y}else if(f(l)&&h.charCodeAt(1)===_.CharCode.Colon)return p(h.charCodeAt(2))?h.slice(0,2)+y:h.slice(0,2);let v=h.indexOf("://");if(v!==-1){for(v+=3;v<L;v++)if(p(h.charCodeAt(v)))return h.slice(0,v+1)}return""}function b(h){if(!W.$l||!h||h.length<5)return!1;let y=h.charCodeAt(0);if(y!==_.CharCode.Backslash||(y=h.charCodeAt(1),y!==_.CharCode.Backslash))return!1;let L=2;const l=L;for(;L<h.length&&(y=h.charCodeAt(L),y!==_.CharCode.Backslash);L++);return!(l===L||(y=h.charCodeAt(L+1),isNaN(y)||y===_.CharCode.Backslash))}const D=/[\\/:\*\?"<>\|]/g,F=/[/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(h,y=W.$l){const L=y?D:F;return!(!h||h.length===0||/^\s+$/.test(h)||(L.lastIndex=0,L.test(h))||y&&c.test(h)||h==="."||h===".."||y&&h[h.length-1]==="."||y&&h.length!==h.trim().length||h.length>255)}function d(h,y,L){const l=h===y;return!L||l?l:!h||!y?!1:(0,M.$Kf)(h,y)}function E(h,y,L,l=t.sep){if(h===y)return!0;if(!h||!y||y.length>h.length)return!1;if(L){if(!(0,M.$Lf)(h,y))return!1;if(y.length===h.length)return!0;let q=y.length;return y.charAt(y.length-1)===l&&q--,h.charAt(q)===l}return y.charAt(y.length-1)!==l&&(y+=l),h.indexOf(y)===0}function f(h){return h>=_.CharCode.A&&h<=_.CharCode.Z||h>=_.CharCode.a&&h<=_.CharCode.z}function A(h,y){return W.$l&&h.endsWith(":")&&(h+=t.sep),(0,t.$nc)(h)||(h=(0,t.$oc)(y,h)),h=(0,t.$mc)(h),w(h)}function w(h){return W.$l?(h=(0,M.$sf)(h,t.sep),h.endsWith(":")&&(h+=t.sep)):(h=(0,M.$sf)(h,t.sep),h||(h=t.sep)),h}function u(h){const y=(0,t.$mc)(h);return W.$l?h.length>3?!1:i(y)&&(h.length===2||y.charCodeAt(2)===_.CharCode.Backslash):y===t.$lc.sep}function i(h,y=W.$l){return y?f(h.charCodeAt(0))&&h.charCodeAt(1)===_.CharCode.Colon:!1}function n(h,y=W.$l){return i(h,y)?h[0]:void 0}function s(h,y,L){return y.length>h.length?-1:h===y?0:(L&&(h=h.toLowerCase(),y=y.toLowerCase()),h.indexOf(y))}function o(h){const y=h.split(":");let L,l,v;for(const q of y){const x=Number(q);(0,Y.$ng)(x)?l===void 0?l=x:v===void 0&&(v=x):L=L?[L,q].join(":"):q}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:l!==void 0?l:void 0,column:v!==void 0?v:l!==void 0?1:void 0}}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",$="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function m(h,y,L=8){let l="";for(let q=0;q<L;q++){let x;q===0&&W.$l&&!y&&(L===3||L===4)?x=$:x=S,l+=x.charAt(Math.floor(Math.random()*x.length))}let v;return y?v=`${y}-${l}`:v=l,h?(0,t.$oc)(h,v):v}}),define(be[33],_e([0,1,2]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$qm=M,e.$rm=Y;var t;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(t||(e.Source=t={}));var W;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(W||(e.TerminateResponseCode=W={}));function M(p,...U){const T=U.reduce((D,F)=>(D[F]=!0,D),{}),N=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter(D=>!T[D]).forEach(D=>{for(let F=0;F<N.length;F++)if(D.search(N[F])!==-1){delete p[D];break}})}function Y(p){p&&(delete p.DEBUG,_.$n&&delete p.LD_PRELOAD)}}),define(be[5],_e([0,1,11,28,3,2]),function(fe,e,_,t,W,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$Ac=d,e.$Bc=i,W=Ie(W);const Y=/^\w[\w\d+.-]*$/,p=/^\//,U=/^\/\//;function T($,m){if(!$.scheme&&m)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${$.authority}", path: "${$.path}", query: "${$.query}", fragment: "${$.fragment}"}`);if($.scheme&&!Y.test($.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if($.path){if($.authority){if(!p.test($.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(U.test($.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function N($,m){return!$&&!m?"file":$}function b($,m){switch($){case"https":case"http":case"file":m?m[0]!==F&&(m=F+m):m=F;break}return m}const D="",F="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class r{static isUri(m){return m instanceof r?!0:m?typeof m.authority=="string"&&typeof m.fragment=="string"&&typeof m.path=="string"&&typeof m.query=="string"&&typeof m.scheme=="string"&&typeof m.fsPath=="string"&&typeof m.with=="function"&&typeof m.toString=="function":!1}constructor(m,h,y,L,l,v=!1){typeof m=="object"?(this.scheme=m.scheme||D,this.authority=m.authority||D,this.path=m.path||D,this.query=m.query||D,this.fragment=m.fragment||D):(this.scheme=N(m,v),this.authority=h||D,this.path=b(this.scheme,y||D),this.query=L||D,this.fragment=l||D,T(this,v))}get fsPath(){return i(this,!1)}with(m){if(!m)return this;let{scheme:h,authority:y,path:L,query:l,fragment:v}=m;return h===void 0?h=this.scheme:h===null&&(h=D),y===void 0?y=this.authority:y===null&&(y=D),L===void 0?L=this.path:L===null&&(L=D),l===void 0?l=this.query:l===null&&(l=D),v===void 0?v=this.fragment:v===null&&(v=D),h===this.scheme&&y===this.authority&&L===this.path&&l===this.query&&v===this.fragment?this:new f(h,y,L,l,v)}static parse(m,h=!1){const y=c.exec(m);return y?new f(y[2]||D,S(y[4]||D),S(y[5]||D),S(y[7]||D),S(y[9]||D),h):new f(D,D,D,D,D)}static file(m){let h=D;if(M.$l&&(m=m.replace(/\\/g,F)),m[0]===F&&m[1]===F){const y=m.indexOf(F,2);y===-1?(h=m.substring(2),m=F):(h=m.substring(2,y),m=m.substring(y)||F)}return new f("file",h,m,D,D)}static from(m,h){return new f(m.scheme,m.authority,m.path,m.query,m.fragment,h)}static joinPath(m,...h){if(!m.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return M.$l&&m.scheme==="file"?y=r.file(W.$kc.join(i(m,!0),...h)).path:y=W.$lc.join(m.path,...h),m.with({path:y})}toString(m=!1){return n(this,m)}toJSON(){return this}static revive(m){if(m){if(m instanceof r)return m;{const h=new f(m);return h._formatted=m.external??null,h._fsPath=m._sep===E?m.fsPath??null:null,h}}else return m}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=r;function d($){return!$||typeof $!="object"?!1:typeof $.scheme=="string"&&(typeof $.authority=="string"||typeof $.authority>"u")&&(typeof $.path=="string"||typeof $.path>"u")&&(typeof $.query=="string"||typeof $.query>"u")&&(typeof $.fragment=="string"||typeof $.fragment>"u")}const E=M.$l?1:void 0;class f extends r{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(m=!1){return m?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const m={$mid:t.MarshalledId.Uri};return this._fsPath&&(m.fsPath=this._fsPath,m._sep=E),this._formatted&&(m.external=this._formatted),this.path&&(m.path=this.path),this.scheme&&(m.scheme=this.scheme),this.authority&&(m.authority=this.authority),this.query&&(m.query=this.query),this.fragment&&(m.fragment=this.fragment),m}}const A={[_.CharCode.Colon]:"%3A",[_.CharCode.Slash]:"%2F",[_.CharCode.QuestionMark]:"%3F",[_.CharCode.Hash]:"%23",[_.CharCode.OpenSquareBracket]:"%5B",[_.CharCode.CloseSquareBracket]:"%5D",[_.CharCode.AtSign]:"%40",[_.CharCode.ExclamationMark]:"%21",[_.CharCode.DollarSign]:"%24",[_.CharCode.Ampersand]:"%26",[_.CharCode.SingleQuote]:"%27",[_.CharCode.OpenParen]:"%28",[_.CharCode.CloseParen]:"%29",[_.CharCode.Asterisk]:"%2A",[_.CharCode.Plus]:"%2B",[_.CharCode.Comma]:"%2C",[_.CharCode.Semicolon]:"%3B",[_.CharCode.Equals]:"%3D",[_.CharCode.Space]:"%20"};function w($,m,h){let y,L=-1;for(let l=0;l<$.length;l++){const v=$.charCodeAt(l);if(v>=_.CharCode.a&&v<=_.CharCode.z||v>=_.CharCode.A&&v<=_.CharCode.Z||v>=_.CharCode.Digit0&&v<=_.CharCode.Digit9||v===_.CharCode.Dash||v===_.CharCode.Period||v===_.CharCode.Underline||v===_.CharCode.Tilde||m&&v===_.CharCode.Slash||h&&v===_.CharCode.OpenSquareBracket||h&&v===_.CharCode.CloseSquareBracket||h&&v===_.CharCode.Colon)L!==-1&&(y+=encodeURIComponent($.substring(L,l)),L=-1),y!==void 0&&(y+=$.charAt(l));else{y===void 0&&(y=$.substr(0,l));const q=A[v];q!==void 0?(L!==-1&&(y+=encodeURIComponent($.substring(L,l)),L=-1),y+=q):L===-1&&(L=l)}}return L!==-1&&(y+=encodeURIComponent($.substring(L))),y!==void 0?y:$}function u($){let m;for(let h=0;h<$.length;h++){const y=$.charCodeAt(h);y===_.CharCode.Hash||y===_.CharCode.QuestionMark?(m===void 0&&(m=$.substr(0,h)),m+=A[y]):m!==void 0&&(m+=$[h])}return m!==void 0?m:$}function i($,m){let h;return $.authority&&$.path.length>1&&$.scheme==="file"?h=`//${$.authority}${$.path}`:$.path.charCodeAt(0)===_.CharCode.Slash&&($.path.charCodeAt(1)>=_.CharCode.A&&$.path.charCodeAt(1)<=_.CharCode.Z||$.path.charCodeAt(1)>=_.CharCode.a&&$.path.charCodeAt(1)<=_.CharCode.z)&&$.path.charCodeAt(2)===_.CharCode.Colon?m?h=$.path.substr(1):h=$.path[1].toLowerCase()+$.path.substr(2):h=$.path,M.$l&&(h=h.replace(/\//g,"\\")),h}function n($,m){const h=m?u:w;let y="",{scheme:L,authority:l,path:v,query:q,fragment:x}=$;if(L&&(y+=L,y+=":"),(l||L==="file")&&(y+=F,y+=F),l){let J=l.indexOf("@");if(J!==-1){const K=l.substr(0,J);l=l.substr(J+1),J=K.lastIndexOf(":"),J===-1?y+=h(K,!1,!1):(y+=h(K.substr(0,J),!1,!1),y+=":",y+=h(K.substr(J+1),!1,!0)),y+="@"}l=l.toLowerCase(),J=l.lastIndexOf(":"),J===-1?y+=h(l,!1,!0):(y+=h(l.substr(0,J),!1,!0),y+=l.substr(J))}if(v){if(v.length>=3&&v.charCodeAt(0)===_.CharCode.Slash&&v.charCodeAt(2)===_.CharCode.Colon){const J=v.charCodeAt(1);J>=_.CharCode.A&&J<=_.CharCode.Z&&(v=`/${String.fromCharCode(J+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===_.CharCode.Colon){const J=v.charCodeAt(0);J>=_.CharCode.A&&J<=_.CharCode.Z&&(v=`${String.fromCharCode(J+32)}:${v.substr(2)}`)}y+=h(v,!0,!1)}return q&&(y+="?",y+=h(q,!1,!1)),x&&(y+="#",y+=m?x:w(x,!1,!1)),y}function s($){try{return decodeURIComponent($)}catch{return $.length>3?$.substr(0,3)+s($.substr(3)):$}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function S($){return $.match(o)?$.replace(o,m=>s(m)):$}}),define(be[50],_e([0,1,5]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=t,e.$mr=W,e.$nr=M,e.log=p;function t(T){const N=T;return N&&typeof N.type=="string"&&typeof N.severity=="string"}function W(T){const N=[];let b;try{const D=JSON.parse(T.arguments),F=D[D.length-1];F&&F.__$stack&&(D.pop(),b=F.__$stack),N.push(...D)}catch{N.push("Unable to log remote console arguments",T.arguments)}return{args:N,stack:b}}function M(T){if(typeof T!="string")return M(W(T).stack);const N=T;if(N){const b=Y(N),D=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(D&&D.length===4)return{uri:_.URI.file(D[1]),line:Number(D[2]),column:Number(D[3])}}}function Y(T){if(!T)return T;const N=T.indexOf(`
`);return N===-1?T:T.substring(0,N)}function p(T,N){const{args:b,stack:D}=W(T),F=typeof b[0]=="string"&&b.length===1;let c=Y(D);c&&(c=`(${c.trim()})`);let r=[];if(typeof b[0]=="string"?c&&F?r=[`%c[${N}] %c${b[0]} %c${c}`,U("blue"),U(""),U("grey")]:r=[`%c[${N}] %c${b[0]}`,U("blue"),U(""),...b.slice(1)]:r=[`%c[${N}]%`,U("blue"),...b],c&&!F&&r.push(c),typeof console[T.severity]!="function")throw new Error("Unknown console method");console[T.severity].apply(console,r)}function U(T){return`color: ${T}`}}),define(be[51],_e([0,1,17,5,28]),function(fe,e,_,t,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=M,e.$gi=Y,e.$hi=U;function M(T){return JSON.stringify(T,p)}function Y(T){let N=JSON.parse(T);return N=U(N),N}function p(T,N){return N instanceof RegExp?{$mid:W.MarshalledId.Regexp,source:N.source,flags:N.flags}:N}function U(T,N=0){if(!T||N>200)return T;if(typeof T=="object"){switch(T.$mid){case W.MarshalledId.Uri:return t.URI.revive(T);case W.MarshalledId.Regexp:return new RegExp(T.source,T.flags);case W.MarshalledId.Date:return new Date(T.source)}if(T instanceof _.$Se||T instanceof Uint8Array)return T;if(Array.isArray(T))for(let b=0;b<T.length;++b)T[b]=U(T[b],N+1);else for(const b in T)Object.hasOwnProperty.call(T,b)&&(T[b]=U(T[b],N+1))}return T}}),define(be[34],_e([0,1,9,2,7,5,3]),function(fe,e,_,t,W,M,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Xg=e.$Wg=e.$Vg=e.Schemas=void 0,e.$Tg=U,e.$Ug=T,e.$Yg=b,_=Ie(_),t=Ie(t),Y=Ie(Y);var p;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",c.vscodeNotebookMetadata="vscode-notebook-metadata",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting",c.outputChannel="output"})(p||(e.Schemas=p={}));function U(c,r){return M.URI.isUri(c)?(0,W.$Kf)(c.scheme,r):(0,W.$Lf)(c,r+":")}function T(c,...r){return r.some(d=>U(c,d))}e.$Vg="vscode-tkn",e.$Wg="tkn";class N{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,d){this.f=b(r,d)}getServerRootPath(){return this.f}get g(){return Y.$lc.join(this.f,p.vscodeRemoteResource)}set(r,d,E){this.a[r]=d,this.b[r]=E}setConnectionToken(r,d){this.c[r]=d}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(u){return _.$4(u),r}const d=r.authority;let E=this.a[d];E&&E.indexOf(":")!==-1&&E.indexOf("[")===-1&&(E=`[${E}]`);const f=this.b[d],A=this.c[d];let w=`path=${encodeURIComponent(r.path)}`;return typeof A=="string"&&(w+=`&${e.$Wg}=${encodeURIComponent(A)}`),M.URI.from({scheme:t.$r?this.d:p.vscodeRemoteResource,authority:`${E}:${f}`,path:this.g,query:w})}}e.$Xg=new N;function b(c,r){return Y.$lc.join(r??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.$Zg="vs/../../extensions",e.$1g="vs/../../node_modules",e.$2g="vs/../../node_modules.asar",e.$3g="vs/../../node_modules.asar.unpacked",e.$4g="vscode-app";class D{static{this.a=e.$4g}asBrowserUri(r){const d=this.b(r,fe);return this.uriToBrowserUri(d)}uriToBrowserUri(r){return r.scheme===p.vscodeRemote?e.$Xg.rewrite(r):r.scheme===p.file&&(t.$p||t.$t===`${p.vscodeFileResource}://${D.a}`)?r.with({scheme:p.vscodeFileResource,authority:r.authority||D.a,query:null,fragment:null}):r}asFileUri(r){const d=this.b(r,fe);return this.uriToFileUri(d)}uriToFileUri(r){return r.scheme===p.vscodeFileResource?r.with({scheme:p.file,authority:r.authority!==D.a?r.authority:null,query:null,fragment:null}):r}b(r,d){if(M.URI.isUri(r))return r;if(globalThis._VSCODE_FILE_ROOT){const E=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(E))return M.URI.joinPath(M.URI.parse(E,!0),r);const f=Y.$oc(E,r);return M.URI.file(f)}return M.URI.parse(d.toUrl(r))}}e.$5g=new D;var F;(function(c){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(r.get("3"));const d="vscode-coi";function E(A){let w;typeof A=="string"?w=new URL(A).searchParams:A instanceof URL?w=A.searchParams:M.URI.isUri(A)&&(w=new URL(A.toString(!0)).searchParams);const u=w?.get(d);if(u)return r.get(u)}c.getHeadersFromQuery=E;function f(A,w,u){if(!globalThis.crossOriginIsolated)return;const i=w&&u?"3":u?"2":"1";A instanceof URLSearchParams?A.set(d,i):A[d]=i}c.addSearchParam=f})(F||(e.COI=F={}))}),define(be[23],_e([0,1,11,14,34,3,2,7,5]),function(fe,e,_,t,W,M,Y,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=void 0,e.$_g=T,e.$uh=b,e.$vh=F,t=Ie(t),M=Ie(M);function T(c){return(0,U.$Bc)(c,!0)}class N{constructor(r){this.a=r}compare(r,d,E=!1){return r===d?0:(0,p.$Df)(this.getComparisonKey(r,E),this.getComparisonKey(d,E))}isEqual(r,d,E=!1){return r===d?!0:!r||!d?!1:this.getComparisonKey(r,E)===this.getComparisonKey(d,E)}getComparisonKey(r,d=!1){return r.with({path:this.a(r)?r.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(r){return this.a(r)}isEqualOrParent(r,d,E=!1){if(r.scheme===d.scheme){if(r.scheme===W.Schemas.file)return t.$Jg(T(r),T(d),this.a(r))&&r.query===d.query&&(E||r.fragment===d.fragment);if((0,e.$qh)(r.authority,d.authority))return t.$Jg(r.path,d.path,this.a(r),"/")&&r.query===d.query&&(E||r.fragment===d.fragment)}return!1}joinPath(r,...d){return U.URI.joinPath(r,...d)}basenameOrAuthority(r){return(0,e.$ih)(r)||r.authority}basename(r){return M.$lc.basename(r.path)}extname(r){return M.$lc.extname(r.path)}dirname(r){if(r.path.length===0)return r;let d;return r.scheme===W.Schemas.file?d=U.URI.file(M.$rc(T(r))).path:(d=M.$lc.dirname(r.path),r.authority&&d.length&&d.charCodeAt(0)!==_.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),d="/")),r.with({path:d})}normalizePath(r){if(!r.path.length)return r;let d;return r.scheme===W.Schemas.file?d=U.URI.file(M.$mc(T(r))).path:d=M.$lc.normalize(r.path),r.with({path:d})}relativePath(r,d){if(r.scheme!==d.scheme||!(0,e.$qh)(r.authority,d.authority))return;if(r.scheme===W.Schemas.file){const A=M.$qc(T(r),T(d));return Y.$l?t.$Dg(A):A}let E=r.path||"/";const f=d.path||"/";if(this.a(r)){let A=0;for(const w=Math.min(E.length,f.length);A<w&&!(E.charCodeAt(A)!==f.charCodeAt(A)&&E.charAt(A).toLowerCase()!==f.charAt(A).toLowerCase());A++);E=f.substr(0,A)+E.substr(A)}return M.$lc.relative(E,f)}resolvePath(r,d){if(r.scheme===W.Schemas.file){const E=U.URI.file(M.$pc(T(r),d));return r.with({authority:E.authority,path:E.path})}return d=t.$Eg(d),r.with({path:M.$lc.resolve(r.path,d)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,d){return r===d||r!==void 0&&d!==void 0&&(0,p.$Kf)(r,d)}hasTrailingPathSeparator(r,d=M.sep){if(r.scheme===W.Schemas.file){const E=T(r);return E.length>t.$Fg(E).length&&E[E.length-1]===d}else{const E=r.path;return E.length>1&&E.charCodeAt(E.length-1)===_.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,d=M.sep){return(0,e.$rh)(r,d)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,d=M.sep){let E=!1;if(r.scheme===W.Schemas.file){const f=T(r);E=f!==void 0&&f.length===t.$Fg(f).length&&f[f.length-1]===d}else{d="/";const f=r.path;E=f.length===1&&f.charCodeAt(f.length-1)===_.CharCode.Slash}return!E&&!(0,e.$rh)(r,d)?r.with({path:r.path+"/"}):r}}e.$ah=N,e.$bh=new N(()=>!1),e.$ch=new N(c=>c.scheme===W.Schemas.file?!Y.$n:!0),e.$dh=new N(c=>!0),e.$eh=e.$bh.isEqual.bind(e.$bh),e.$fh=e.$bh.isEqualOrParent.bind(e.$bh),e.$gh=e.$bh.getComparisonKey.bind(e.$bh),e.$hh=e.$bh.basenameOrAuthority.bind(e.$bh),e.$ih=e.$bh.basename.bind(e.$bh),e.$jh=e.$bh.extname.bind(e.$bh),e.$kh=e.$bh.dirname.bind(e.$bh),e.$lh=e.$bh.joinPath.bind(e.$bh),e.$mh=e.$bh.normalizePath.bind(e.$bh),e.$nh=e.$bh.relativePath.bind(e.$bh),e.$oh=e.$bh.resolvePath.bind(e.$bh),e.$ph=e.$bh.isAbsolutePath.bind(e.$bh),e.$qh=e.$bh.isEqualAuthority.bind(e.$bh),e.$rh=e.$bh.hasTrailingPathSeparator.bind(e.$bh),e.$sh=e.$bh.removeTrailingPathSeparator.bind(e.$bh),e.$th=e.$bh.addTrailingPathSeparator.bind(e.$bh);function b(c,r){const d=[];for(let E=0;E<c.length;E++){const f=r(c[E]);c.some((A,w)=>w===E?!1:(0,e.$fh)(f,r(A)))||d.push(c[E])}return d}var D;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function r(d){const E=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(w=>{const[u,i]=w.split(":");u&&i&&E.set(u,i)});const A=d.path.substring(0,d.path.indexOf(";"));return A&&E.set(c.META_DATA_MIME,A),E}c.parseMetaData=r})(D||(e.DataUri=D={}));function F(c,r,d){if(r){let E=c.path;return E&&E[0]!==M.$lc.sep&&(E=M.$lc.sep+E),c.with({scheme:d,authority:r,path:E})}return c.with({scheme:d})}}),define(be[8],_e([0,1,13,9,6,4,23,2,46,16]),function(fe,e,_,t,W,M,Y,p,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$_h=e.$$h=e.$0h=e.$9h=e.Promises=e.$8h=e.$7h=e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0,e.$wh=N,e.$xh=b,e.$yh=D,e.$zh=F,e.$Ah=c,e.$Bh=r,e.$Ch=d,e.$Dh=E,e.$Lh=$,e.$Mh=m,e.$Nh=h,e.$Oh=y,e.$Ph=L,e.$5h=g,e.$ai=j;function N(P){return!!P&&typeof P.then=="function"}function b(P){const a=new _.$Be,B=P(a.token),X=new Promise((te,de)=>{const De=a.token.onCancellationRequested(()=>{De.dispose(),de(new t.$9)});Promise.resolve(B).then(Re=>{De.dispose(),a.dispose(),te(Re)},Re=>{De.dispose(),a.dispose(),de(Re)})});return new class{cancel(){a.cancel(),a.dispose()}then(te,de){return X.then(te,de)}catch(te){return this.then(void 0,te)}finally(te){return X.finally(te)}}}function D(P,a,B){return new Promise((X,te)=>{const de=a.onCancellationRequested(()=>{de.dispose(),X(B)});P.then(X,te).finally(()=>de.dispose())})}function F(P,a){return new Promise((B,X)=>{const te=a.onCancellationRequested(()=>{te.dispose(),X(new t.$9)});P.then(B,X).finally(()=>te.dispose())})}async function c(P){let a=-1;const B=P.map((X,te)=>X.then(de=>(a=te,de)));try{return await Promise.race(B)}finally{P.forEach((X,te)=>{te!==a&&X.cancel()})}}function r(P,a,B){let X;const te=setTimeout(()=>{X?.(void 0),B?.()},a);return Promise.race([P.finally(()=>clearTimeout(te)),new Promise(de=>X=de)])}function d(P){return new Promise((a,B)=>{const X=P();N(X)?X.then(a,B):a(X)})}function E(){let P,a;return{promise:new Promise((X,te)=>{P=X,a=te}),resolve:P,reject:a}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(a){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=a,!this.b){const B=()=>{if(this.b=null,this.f)return;const X=this.queue(this.d);return this.d=null,X};this.b=new Promise(X=>{this.a.then(B,B).then(X)})}return new Promise((B,X)=>{this.b.then(B,X)})}return this.a=a(),new Promise((B,X)=>{this.a.then(te=>{this.a=null,B(te)},te=>{this.a=null,X(te)})})}dispose(){this.f=!0}}e.$Eh=f;class A{constructor(){this.a=Promise.resolve(null)}queue(a){return this.a=this.a.then(()=>a(),()=>a())}}e.$Fh=A;class w{constructor(){this.a=new Map}queue(a,B){const te=(this.a.get(a)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.a.get(a)===te&&this.a.delete(a)});return this.a.set(a,te),te}}e.$Gh=w;const u=(P,a)=>{let B=!0;const X=setTimeout(()=>{B=!1,a()},P);return{isTriggered:()=>B,dispose:()=>{clearTimeout(X),B=!1}}},i=P=>{let a=!0;return queueMicrotask(()=>{a&&(a=!1,P())}),{isTriggered:()=>a,dispose:()=>{a=!1}}};class n{constructor(a){this.defaultDelay=a,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(a,B=this.defaultDelay){this.g=a,this.h(),this.b||(this.b=new Promise((te,de)=>{this.d=te,this.f=de}).then(()=>{if(this.b=null,this.d=null,this.g){const te=this.g;return this.g=null,te()}}));const X=()=>{this.a=null,this.d?.(null)};return this.a=B===U.$le?i(X):u(B,X),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.$9),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Hh=n;class s{constructor(a){this.a=new n(a),this.b=new f}trigger(a,B){return this.a.trigger(()=>this.b.queue(a),B)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ih=s;class o{constructor(){this.a=!1,this.b=new Promise((a,B)=>{this.d=a})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Jh=o;class S extends o{constructor(a){super(),this.f=setTimeout(()=>this.open(),a)}open(){clearTimeout(this.f),super.open()}}e.$Kh=S;function $(P,a){return a?new Promise((B,X)=>{const te=setTimeout(()=>{de.dispose(),B()},P),de=a.onCancellationRequested(()=>{clearTimeout(te),de.dispose(),X(new t.$9)})}):b(B=>$(P,B))}function m(P,a=0,B){const X=setTimeout(()=>{P(),B&&te.dispose()},a),te=(0,M.$Xc)(()=>{clearTimeout(X),B?.deleteAndLeak(te)});return B?.add(te),te}function h(P){const a=[];let B=0;const X=P.length;function te(){return B<X?P[B++]():null}function de(De){De!=null&&a.push(De);const Re=te();return Re?Re.then(de):Promise.resolve(a)}return Promise.resolve(null).then(de)}function y(P,a=X=>!!X,B=null){let X=0;const te=P.length,de=()=>{if(X>=te)return Promise.resolve(B);const De=P[X++];return Promise.resolve(De()).then(Oe=>a(Oe)?Promise.resolve(Oe):de())};return de()}function L(P,a=X=>!!X,B=null){if(P.length===0)return Promise.resolve(B);let X=P.length;const te=()=>{X=-1;for(const de of P)de.cancel?.()};return new Promise((de,De)=>{for(const Re of P)Re.then(Oe=>{--X>=0&&a(Oe)?(te(),de(Oe)):X===0&&de(B)}).catch(Oe=>{--X>=0&&(te(),De(Oe))})})}class l{constructor(a){this.a=0,this.b=!1,this.f=a,this.g=[],this.d=0,this.h=new W.$qe}whenIdle(){return this.size>0?W.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(a){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((B,X)=>{this.g.push({factory:a,c:B,e:X}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const a=this.g.shift();this.d++;const B=a.factory();B.then(a.c,a.e),B.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Qh=l;class v extends l{constructor(){super(1)}}e.$Rh=v;class q{constructor(){this.a=new k,this.b=0}queue(a){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,a())):this.a.run(this.b++,a())}}e.$Sh=q;class x{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const a=new R;return this.b.add(a),a.p}g(){for(const[,a]of this.a)if(a.size>0)return!1;return!0}queueSize(a,B=Y.$bh){const X=B.getComparisonKey(a);return this.a.get(X)?.size??0}queueFor(a,B,X=Y.$bh){const te=X.getComparisonKey(a);let de=this.a.get(te);if(!de){de=new v;const De=this.f++,Re=W.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(De),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$9c),this.d.set(De,Re),this.a.set(te,de)}return de.queue(B)}h(){this.g()&&this.j()}j(){for(const a of this.b)a.complete();this.b.clear()}dispose(){for(const[,a]of this.a)a.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Th=x;class J{constructor(a,B){this.b=!1,this.a=-1,typeof a=="function"&&typeof B=="number"&&this.setIfNotSet(a,B)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(a,B){if(this.b)throw new t.$gb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,a()},B)}setIfNotSet(a,B){if(this.b)throw new t.$gb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,a()},B))}}e.$Uh=J;class K{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(a,B,X=globalThis){if(this.f)throw new t.$gb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const te=X.setInterval(()=>{a()},B);this.d=(0,M.$Xc)(()=>{X.clearInterval(te),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Vh=K;class se{constructor(a,B){this.b=-1,this.a=a,this.d=B,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(a=this.d){this.cancel(),this.b=setTimeout(this.f,a)}get delay(){return this.d}set delay(a){this.d=a}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Wh=se;class V{constructor(a,B){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.a=a,this.b=B,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(a=this.b){a%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${a}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(a/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Xh=V;class ne extends se{constructor(a,B){super(a,B),this.j=[]}work(a){this.j.push(a),this.isScheduled()||this.schedule()}h(){const a=this.j;this.j=[],this.a?.(a)}dispose(){this.j=[],super.dispose()}}e.$Yh=ne;class re extends M.$Zc{constructor(a,B){super(),this.g=a,this.h=B,this.a=[],this.b=this.B(new M.$1c),this.f=!1}get pending(){return this.a.length}work(a){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+a.length>this.g.maxBufferedWork)return!1}else if(this.pending+a.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const B of a)this.a.push(B);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new se(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Zh=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$2h=(P,a)=>{(0,p.$E)(()=>{if(B)return;const X=Date.now()+15;a(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,X-Date.now())}}))});let B=!1;return{dispose(){B||(B=!0)}}}:e.$2h=(P,a,B)=>{const X=P.requestIdleCallback(a,typeof B=="number"?{timeout:B}:void 0);let te=!1;return{dispose(){te||(te=!0,P.cancelIdleCallback(X))}}},e.$1h=P=>(0,e.$2h)(globalThis,P)}();class oe{constructor(a,B){this.g=!1,this.d=()=>{try{this.j=B()}catch(X){this.l=X}finally{this.g=!0}},this.f=(0,e.$2h)(a,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$3h=oe;class I extends oe{constructor(a){super(globalThis,a)}}e.$4h=I;async function g(P,a,B){let X;for(let te=0;te<B;te++)try{return await P()}catch(de){X=de,await $(a)}throw X}class k{isRunning(a){return typeof a=="number"?this.a?.taskId===a:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(a,B,X){return this.a={taskId:a,cancel:()=>X?.(),promise:B},B.then(()=>this.d(a),()=>this.d(a)),B}d(a){this.a&&a===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const a=this.b;this.b=void 0,a.run().then(a.promiseResolve,a.promiseReject)}}queue(a){if(this.b)this.b.run=a;else{const{promise:B,resolve:X,reject:te}=E();this.b={run:a,promise:B,promiseResolve:X,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$6h=k;class z{constructor(a,B=()=>Date.now()){this.d=a,this.f=B,this.a=0,this.b=0}increment(){const a=this.f();return a-this.a>this.d&&(this.a=a,this.b=0),this.b++,this.b}}e.$7h=z;var Q;(function(P){P[P.Resolved=0]="Resolved",P[P.Rejected=1]="Rejected"})(Q||(Q={}));class R{get isRejected(){return this.d?.outcome===Q.Rejected}get isResolved(){return this.d?.outcome===Q.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===Q.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((a,B)=>{this.a=a,this.b=B})}complete(a){return new Promise(B=>{this.a(a),this.d={outcome:Q.Resolved,value:a},B()})}error(a){return new Promise(B=>{this.b(a),this.d={outcome:Q.Rejected,value:a},B()})}cancel(){return this.error(new t.$9)}}e.$8h=R;var Z;(function(P){async function a(X){let te;const de=await Promise.all(X.map(De=>De.then(Re=>Re,Re=>{te||(te=Re)})));if(typeof te<"u")throw te;return de}P.settled=a;function B(X){return new Promise(async(te,de)=>{try{await X(te,de)}catch(De){de(De)}})}P.withAsyncBody=B})(Z||(e.Promises=Z={}));class ee{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(a){this.a=void 0,this.b=void 0,this.d=!1,this.promise=a.then(B=>(this.a=B,this.d=!0,B),B=>{throw this.b=B,this.d=!0,B})}requireValue(){if(!this.d)throw new t.$gb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$9h=ee;class ie{constructor(a){this.b=a,this.a=new T.$Y(()=>new ee(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$0h=ie;var ue;(function(P){P[P.Initial=0]="Initial",P[P.DoneOK=1]="DoneOK",P[P.DoneError=2]="DoneError"})(ue||(ue={}));class he{static fromArray(a){return new he(B=>{B.emitMany(a)})}static fromPromise(a){return new he(async B=>{B.emitMany(await a)})}static fromPromises(a){return new he(async B=>{await Promise.all(a.map(async X=>B.emitOne(await X)))})}static merge(a){return new he(async B=>{await Promise.all(a.map(async X=>{for await(const te of X)B.emitOne(te)}))})}static{this.EMPTY=he.fromArray([])}constructor(a,B){this.a=ue.Initial,this.b=[],this.d=null,this.f=B,this.g=new W.$qe,queueMicrotask(async()=>{const X={emitOne:te=>this.h(te),emitMany:te=>this.j(te),reject:te=>this.l(te)};try{await Promise.resolve(a(X)),this.k()}catch(te){this.l(te)}finally{X.emitOne=void 0,X.emitMany=void 0,X.reject=void 0}})}[Symbol.asyncIterator](){let a=0;return{next:async()=>{do{if(this.a===ue.DoneError)throw this.d;if(a<this.b.length)return{done:!1,value:this.b[a++]};if(this.a===ue.DoneOK)return{done:!0,value:void 0};await W.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(a,B){return new he(async X=>{for await(const te of a)X.emitOne(B(te))})}map(a){return he.map(this,a)}static filter(a,B){return new he(async X=>{for await(const te of a)B(te)&&X.emitOne(te)})}filter(a){return he.filter(this,a)}static coalesce(a){return he.filter(a,B=>!!B)}coalesce(){return he.coalesce(this)}static async toPromise(a){const B=[];for await(const X of a)B.push(X);return B}toPromise(){return he.toPromise(this)}h(a){this.a===ue.Initial&&(this.b.push(a),this.g.fire())}j(a){this.a===ue.Initial&&(this.b=this.b.concat(a),this.g.fire())}k(){this.a===ue.Initial&&(this.a=ue.DoneOK,this.g.fire())}l(a){this.a===ue.Initial&&(this.a=ue.DoneError,this.d=a,this.g.fire())}}e.$$h=he;class we extends he{constructor(a,B){super(B),this.m=a}cancel(){this.m.cancel()}}e.$_h=we;function j(P){const a=new _.$Be,B=P(a.token);return new we(a,async X=>{const te=a.token.onCancellationRequested(()=>{te.dispose(),a.dispose(),X.reject(new t.$9)});try{for await(const de of B){if(a.token.isCancellationRequested)return;X.emitOne(de)}te.dispose(),a.dispose()}catch(de){te.dispose(),a.dispose(),X.reject(de)}})}class G{constructor(a){this.a=new R,this.b=new he(te=>{if(B){te.reject(B);return}return X&&te.emitMany(X),this.d=de=>te.reject(de),this.f=de=>te.emitOne(de),this.a.p},a);let B,X;this.f=te=>{X||(X=[]),X.push(te)},this.d=te=>{B||(B=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(a){this.d(a),this.a.complete()}emitOne(a){this.f(a)}}e.$bi=G}),define(be[24],_e([0,1,12,8,11,14,20,3,2,7]),function(fe,e,_,t,W,M,Y,p,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=e.$Bk=void 0,e.$Ak=N,e.$Dk=r,e.$Ek=q,e.$Fk=x,e.$Gk=J,e.$Hk=K,e.$Ik=se,e.$Jk=oe;function N(){return Object.create(null)}e.$Bk="**",e.$Ck="/";const b="[/\\\\]",D="[^/\\\\]",F=/\//g;function c(I,g){switch(I){case 0:return"";case 1:return`${D}*?`;default:return`(?:${b}|${D}+${b}${g?`|${b}${D}+`:""})*?`}}function r(I,g){if(!I)return[];const k=[];let z=!1,Q=!1,R="";for(const Z of I){switch(Z){case g:if(!z&&!Q){k.push(R),R="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}R+=Z}return R&&k.push(R),k}function d(I){if(!I)return"";let g="";const k=r(I,e.$Ck);if(k.every(z=>z===e.$Bk))g=".*";else{let z=!1;k.forEach((Q,R)=>{if(Q===e.$Bk){if(z)return;g+=c(2,R===k.length-1)}else{let Z=!1,ee="",ie=!1,ue="";for(const he of Q){if(he!=="}"&&Z){ee+=he;continue}if(ie&&(he!=="]"||!ue)){let we;he==="-"?we=he:(he==="^"||he==="!")&&!ue?we="^":he===e.$Ck?we="":we=(0,T.$mf)(he),ue+=we;continue}switch(he){case"{":Z=!0;continue;case"[":ie=!0;continue;case"}":{const j=`(?:${r(ee,",").map(G=>d(G)).join("|")})`;g+=j,Z=!1,ee="";break}case"]":{g+="["+ue+"]",ie=!1,ue="";break}case"?":g+=D;continue;case"*":g+=c(1);continue;default:g+=(0,T.$mf)(he)}}R<k.length-1&&(k[R+1]!==e.$Bk||R+2<k.length)&&(g+=b)}z=Q===e.$Bk})}return g}const E=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,A=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new Y.$Ic(1e4),s=function(){return!1},o=function(){return null};function S(I,g){if(!I)return o;let k;typeof I!="string"?k=I.pattern:k=I,k=k.trim();const z=`${k}_${!!g.trimForExclusions}`;let Q=n.get(z);if(Q)return $(Q,I);let R;return E.test(k)?Q=h(k.substr(4),k):(R=f.exec(m(k,g)))?Q=y(R[1],k):(g.trimForExclusions?w:A).test(k)?Q=L(k,g):(R=u.exec(m(k,g)))?Q=l(R[1].substr(1),k,!0):(R=i.exec(m(k,g)))?Q=l(R[1],k,!1):Q=v(k),n.set(z,Q),$(Q,I)}function $(I,g){if(typeof g=="string")return I;const k=function(z,Q){return(0,M.$Jg)(z,g.base,!U.$n)?I((0,T.$rf)(z.substr(g.base.length),p.sep),Q):null};return k.allBasenames=I.allBasenames,k.allPaths=I.allPaths,k.basenames=I.basenames,k.patterns=I.patterns,k}function m(I,g){return g.trimForExclusions&&I.endsWith("/**")?I.substr(0,I.length-2):I}function h(I,g){return function(k,z){return typeof k=="string"&&k.endsWith(I)?g:null}}function y(I,g){const k=`/${I}`,z=`\\${I}`,Q=function(Z,ee){return typeof Z!="string"?null:ee?ee===I?g:null:Z===I||Z.endsWith(k)||Z.endsWith(z)?g:null},R=[I];return Q.basenames=R,Q.patterns=[g],Q.allBasenames=R,Q}function L(I,g){const k=re(I.slice(1,-1).split(",").map(ee=>S(ee,g)).filter(ee=>ee!==o),I),z=k.length;if(!z)return o;if(z===1)return k[0];const Q=function(ee,ie){for(let ue=0,he=k.length;ue<he;ue++)if(k[ue](ee,ie))return I;return null},R=k.find(ee=>!!ee.allBasenames);R&&(Q.allBasenames=R.allBasenames);const Z=k.reduce((ee,ie)=>ie.allPaths?ee.concat(ie.allPaths):ee,[]);return Z.length&&(Q.allPaths=Z),Q}function l(I,g,k){const z=p.sep===p.$lc.sep,Q=z?I:I.replace(F,p.sep),R=p.sep+Q,Z=p.$lc.sep+I;let ee;return k?ee=function(ie,ue){return typeof ie=="string"&&(ie===Q||ie.endsWith(R)||!z&&(ie===I||ie.endsWith(Z)))?g:null}:ee=function(ie,ue){return typeof ie=="string"&&(ie===Q||!z&&ie===I)?g:null},ee.allPaths=[(k?"*/":"./")+I],ee}function v(I){try{const g=new RegExp(`^${d(I)}$`);return function(k){return g.lastIndex=0,typeof k=="string"&&g.test(k)?I:null}}catch{return o}}function q(I,g,k){return!I||typeof g!="string"?!1:x(I)(g,void 0,k)}function x(I,g={}){if(!I)return s;if(typeof I=="string"||J(I)){const k=S(I,g);if(k===o)return s;const z=function(Q,R){return!!k(Q,R)};return k.allBasenames&&(z.allBasenames=k.allBasenames),k.allPaths&&(z.allPaths=k.allPaths),z}return V(I,g)}function J(I){const g=I;return g?typeof g.base=="string"&&typeof g.pattern=="string":!1}function K(I){return I.allBasenames||[]}function se(I){return I.allPaths||[]}function V(I,g){const k=re(Object.getOwnPropertyNames(I).map(ee=>ne(ee,I[ee],g)).filter(ee=>ee!==o)),z=k.length;if(!z)return o;if(!k.some(ee=>!!ee.requiresSiblings)){if(z===1)return k[0];const ee=function(he,we){let j;for(let G=0,P=k.length;G<P;G++){const a=k[G](he,we);if(typeof a=="string")return a;(0,t.$wh)(a)&&(j||(j=[]),j.push(a))}return j?(async()=>{for(const G of j){const P=await G;if(typeof P=="string")return P}return null})():null},ie=k.find(he=>!!he.allBasenames);ie&&(ee.allBasenames=ie.allBasenames);const ue=k.reduce((he,we)=>we.allPaths?he.concat(we.allPaths):he,[]);return ue.length&&(ee.allPaths=ue),ee}const Q=function(ee,ie,ue){let he,we;for(let j=0,G=k.length;j<G;j++){const P=k[j];P.requiresSiblings&&ue&&(ie||(ie=(0,p.$sc)(ee)),he||(he=ie.substr(0,ie.length-(0,p.$tc)(ee).length)));const a=P(ee,ie,he,ue);if(typeof a=="string")return a;(0,t.$wh)(a)&&(we||(we=[]),we.push(a))}return we?(async()=>{for(const j of we){const G=await j;if(typeof G=="string")return G}return null})():null},R=k.find(ee=>!!ee.allBasenames);R&&(Q.allBasenames=R.allBasenames);const Z=k.reduce((ee,ie)=>ie.allPaths?ee.concat(ie.allPaths):ee,[]);return Z.length&&(Q.allPaths=Z),Q}function ne(I,g,k){if(g===!1)return o;const z=S(I,k);if(z===o)return o;if(typeof g=="boolean")return z;if(g){const Q=g.when;if(typeof Q=="string"){const R=(Z,ee,ie,ue)=>{if(!ue||!z(Z,ee))return null;const he=Q.replace("$(basename)",()=>ie),we=ue(he);return(0,t.$wh)(we)?we.then(j=>j?I:null):we?I:null};return R.requiresSiblings=!0,R}}return z}function re(I,g){const k=I.filter(ee=>!!ee.basenames);if(k.length<2)return I;const z=k.reduce((ee,ie)=>{const ue=ie.basenames;return ue?ee.concat(ue):ee},[]);let Q;if(g){Q=[];for(let ee=0,ie=z.length;ee<ie;ee++)Q.push(g)}else Q=k.reduce((ee,ie)=>{const ue=ie.patterns;return ue?ee.concat(ue):ee},[]);const R=function(ee,ie){if(typeof ee!="string")return null;if(!ie){let he;for(he=ee.length;he>0;he--){const we=ee.charCodeAt(he-1);if(we===W.CharCode.Slash||we===W.CharCode.Backslash)break}ie=ee.substr(he)}const ue=z.indexOf(ie);return ue!==-1?Q[ue]:null};R.basenames=z,R.patterns=Q,R.allBasenames=z;const Z=I.filter(ee=>!ee.basenames);return Z.push(R),Z}function oe(I,g){return(0,_.$yb)(I,g,(k,z)=>typeof k=="string"&&typeof z=="string"?k===z:typeof k!="string"&&typeof z!="string"?k.base===z.base&&k.pattern===z.pattern:!1)}}),define(be[25],_e([0,1,15,52,61,8,14,21,3,2,23,5]),function(fe,e,_,t,W,M,Y,p,U,T,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=d,e.readdirSync=A,e.whenDeleted=i,e.configureFlushOnWrite=$,e.writeFileSync=h,_=Ie(_);var D;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(D||(e.RimRafMode=D={}));async function F(V,ne=D.UNLINK,re){if((0,Y.$Ng)(V))throw new Error("rimraf - will refuse to recursively delete root");return ne===D.UNLINK?r(V):c(V,re)}async function c(V,ne=(0,Y.$Sg)((0,t.tmpdir)())){try{try{await _.promises.rename(V,ne)}catch(re){return re.code==="ENOENT"?void 0:r(V)}r(ne).catch(re=>{})}catch(re){if(re.code!=="ENOENT")throw re}}async function r(V){return _.promises.rm(V,{recursive:!0,force:!0,maxRetries:3})}function d(V){if((0,Y.$Ng)(V))throw new Error("rimraf - will refuse to recursively delete root");_.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}async function E(V,ne){return w(await(ne?f(V):_.promises.readdir(V)))}async function f(V){try{return await _.promises.readdir(V,{withFileTypes:!0})}catch(oe){console.warn("[node.js fs] readdir with filetypes failed with error: ",oe)}const ne=[],re=await E(V);for(const oe of re){let I=!1,g=!1,k=!1;try{const z=await _.promises.lstat((0,U.$oc)(V,oe));I=z.isFile(),g=z.isDirectory(),k=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}ne.push({name:oe,isFile:()=>I,isDirectory:()=>g,isSymbolicLink:()=>k})}return ne}function A(V){return w(_.readdirSync(V))}function w(V){return V.map(ne=>typeof ne=="string"?T.$m?(0,p.$sm)(ne):ne:(ne.name=T.$m?(0,p.$sm)(ne.name):ne.name,ne))}async function u(V){const ne=await E(V),re=[];for(const oe of ne)await n.existsDirectory((0,U.$oc)(V,oe))&&re.push(oe);return re}function i(V,ne=1e3){return new Promise(re=>{let oe=!1;const I=setInterval(()=>{oe||(oe=!0,_.access(V,g=>{oe=!1,g&&(clearInterval(I),re(void 0))}))},ne)})}var n;(function(V){async function ne(I){let g;try{if(g=await _.promises.lstat(I),!g.isSymbolicLink())return{stat:g}}catch{}try{return{stat:await _.promises.stat(I),symbolicLink:g?.isSymbolicLink()?{dangling:!1}:void 0}}catch(k){if(k.code==="ENOENT"&&g)return{stat:g,symbolicLink:{dangling:!0}};if(T.$l&&k.code==="EACCES")try{return{stat:await _.promises.stat(await _.promises.readlink(I)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&g)return{stat:g,symbolicLink:{dangling:!0}};throw z}throw k}}V.stat=ne;async function re(I){try{const{stat:g,symbolicLink:k}=await V.stat(I);return g.isFile()&&k?.dangling!==!0}catch{}return!1}V.existsFile=re;async function oe(I){try{const{stat:g,symbolicLink:k}=await V.stat(I);return g.isDirectory()&&k?.dangling!==!0}catch{}return!1}V.existsDirectory=oe})(n||(e.SymlinkSupport=n={}));const s=new M.$Th;function o(V,ne,re){return s.queueFor(b.URI.file(V),()=>{const oe=y(re);return new Promise((I,g)=>m(V,ne,oe,k=>k?g(k):I()))},N.$ch)}let S=!0;function $(V){S=V}function m(V,ne,re,oe){if(!S)return _.writeFile(V,ne,{mode:re.mode,flag:re.flag},oe);_.open(V,re.flag,re.mode,(I,g)=>{if(I)return oe(I);_.writeFile(g,ne,k=>{if(k)return _.close(g,()=>oe(k));_.fdatasync(g,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),$(!1)),_.close(g,Q=>oe(Q))))})})}function h(V,ne,re){const oe=y(re);if(!S)return _.writeFileSync(V,ne,{mode:oe.mode,flag:oe.flag});const I=_.openSync(V,oe.flag,oe.mode);try{_.writeFileSync(I,ne);try{_.fdatasyncSync(I)}catch(g){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",g),$(!1)}}finally{_.closeSync(I)}}function y(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function L(V,ne,re=6e4){if(V!==ne)try{T.$l&&typeof re=="number"?await l(V,ne,Date.now(),re):await _.promises.rename(V,ne)}catch(oe){if(V.toLowerCase()!==ne.toLowerCase()&&oe.code==="EXDEV"||V.endsWith("."))await v(V,ne,{preserveSymlinks:!1}),await F(V,D.MOVE);else throw oe}}async function l(V,ne,re,oe,I=0){try{return await _.promises.rename(V,ne)}catch(g){if(g.code!=="EACCES"&&g.code!=="EPERM"&&g.code!=="EBUSY")throw g;if(Date.now()-re>=oe)throw console.error(`[node.js fs] rename failed after ${I} retries with error: ${g}`),g;if(I===0){let k=!1;try{const{stat:z}=await n.stat(ne);z.isFile()||(k=!0)}catch{}if(k)throw g}return await(0,M.$Lh)(Math.min(100,I*10)),l(V,ne,re,oe,I+1)}}async function v(V,ne,re){return x(V,ne,{root:{source:V,target:ne},options:re,handledSourcePaths:new Set})}const q=511;async function x(V,ne,re){if(re.handledSourcePaths.has(V))return;re.handledSourcePaths.add(V);const{stat:oe,symbolicLink:I}=await n.stat(V);if(I){if(re.options.preserveSymlinks)try{return await se(V,ne,re)}catch{}if(I.dangling)return}return oe.isDirectory()?J(V,ne,oe.mode&q,re):K(V,ne,oe.mode&q)}async function J(V,ne,re,oe){await _.promises.mkdir(ne,{recursive:!0,mode:re});const I=await E(V);for(const g of I)await x((0,U.$oc)(V,g),(0,U.$oc)(ne,g),oe)}async function K(V,ne,re){await _.promises.copyFile(V,ne),await _.promises.chmod(ne,re)}async function se(V,ne,re){let oe=await _.promises.readlink(V);(0,Y.$Jg)(oe,re.root.source,!T.$n)&&(oe=(0,U.$oc)(re.root.target,oe.substr(re.root.source.length+1))),await _.promises.symlink(oe,ne)}e.Promises=new class{get read(){return(V,ne,re,oe,I)=>new Promise((g,k)=>{_.read(V,ne,re,oe,I,(z,Q,R)=>z?k(z):g({bytesRead:Q,buffer:R}))})}get write(){return(V,ne,re,oe,I)=>new Promise((g,k)=>{_.write(V,ne,re,oe,I,(z,Q,R)=>z?k(z):g({bytesWritten:Q,buffer:R}))})}get fdatasync(){return(0,W.promisify)(_.fdatasync)}get open(){return(0,W.promisify)(_.open)}get close(){return(0,W.promisify)(_.close)}get realpath(){return(0,W.promisify)(_.realpath)}async exists(V){try{return await _.promises.access(V),!0}catch{return!1}}get readdir(){return E}get readDirsInDir(){return u}get writeFile(){return o}get rm(){return F}get rename(){return L}get copy(){return v}}}),define(be[35],_e([0,1,15,3,2,7,25]),function(fe,e,_,t,W,M,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=p,e.$ur=U,e.$vr=T,e.$wr=N,_=Ie(_);function p(D){if(W.$n)return D;const F=(0,t.$rc)(D);if(D===F)return D;const c=((0,t.$sc)(D)||D).toLowerCase();try{const d=(0,Y.readdirSync)(F).filter(E=>E.toLowerCase()===c);if(d.length===1){const E=p(F);if(E)return(0,t.$oc)(E,d[0])}else if(d.length>1){const E=d.indexOf(c);if(E>=0){const f=p(F);if(f)return(0,t.$oc)(f,d[E])}}}catch{}return null}async function U(D,F){if(W.$n)return D;const c=(0,t.$rc)(D);if(D===c)return D;const r=((0,t.$sc)(D)||D).toLowerCase();try{if(F?.isCancellationRequested)return null;const E=(await Y.Promises.readdir(c)).filter(f=>f.toLowerCase()===r);if(E.length===1){const f=await U(c,F);if(f)return(0,t.$oc)(f,E[0])}else if(E.length>1){const f=E.indexOf(r);if(f>=0){const A=await U(c,F);if(A)return(0,t.$oc)(A,E[f])}}}catch{}return null}async function T(D){try{return await Y.Promises.realpath(D)}catch{const c=b(D);return await _.promises.access(c,_.constants.R_OK),c}}function N(D){try{return _.realpathSync(D)}catch{const c=b(D);return _.accessSync(c,_.constants.R_OK),c}}function b(D){return(0,M.$sf)((0,t.$mc)(D),t.sep)}}),define(be[53],_e([0,1,15,3,2,32,33,10,25]),function(fe,e,_,t,W,M,Y,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$Dm=T,e.$Em=N,t=Ie(t),W=Ie(W),M=Ie(M),p=Ie(p),U=Ie(U),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return Y.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return Y.TerminateResponseCode}});function T(D=M.env){return D.comspec||"cmd.exe"}function N(D){let F=[],c=!1;const r=function(d){if(c){F.push(d);return}(!D.send(d,f=>{if(f&&console.error(f),c=!1,F.length>0){const A=F.slice(0);F=[],A.forEach(w=>r(w))}})||W.$l)&&(c=!0)};return{send:r}}var b;(function(D){async function F(c,r,d){if(t.$nc(c))return c;if(r===void 0&&(r=M.cwd()),t.$rc(c)!=="."||(d===void 0&&p.$jg(M.env.PATH)&&(d=M.env.PATH.split(t.$yc)),d===void 0||d.length===0))return t.$oc(r,c);async function f(A){if(await U.Promises.exists(A)){let w;try{w=await _.promises.stat(A)}catch(u){u.message.startsWith("EACCES")&&(w=await _.promises.lstat(A))}return w?!w.isDirectory():!1}return!1}for(const A of d){let w;if(t.$nc(A)?w=t.$oc(A,c):w=t.$oc(r,A,c),await f(w))return w;let u=w+".com";if(await f(u)||(u=w+".exe",await f(u)))return u}return t.$oc(r,c)}D.findExecutable=F})(b||(e.win32=b={}))});var Je=this&&this.__decorate||function(fe,e,_,t){var W=arguments.length,M=W<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,_):t,Y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(fe,e,_,t);else for(var p=fe.length-1;p>=0;p--)(Y=fe[p])&&(M=(W<3?Y(M):W>3?Y(e,_,M):Y(e,_))||M);return W>3&&M&&Object.defineProperty(e,_,M),M};define(be[26],_e([0,1,12,8,17,13,40,9,6,4,51,7,10]),function(fe,e,_,t,W,M,Y,p,U,T,N,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.ProxyChannel=e.$si=e.$pi=e.$oi=e.$ni=e.RequestInitiator=e.$mi=e.$ji=e.$ii=void 0,e.$ki=$,e.$li=m,e.$qi=q,e.$ri=x,b=Ie(b);var F;(function(I){I[I.Promise=100]="Promise",I[I.PromiseCancel=101]="PromiseCancel",I[I.EventListen=102]="EventListen",I[I.EventDispose=103]="EventDispose"})(F||(F={}));function c(I){switch(I){case F.Promise:return"req";case F.PromiseCancel:return"cancel";case F.EventListen:return"subscribe";case F.EventDispose:return"unsubscribe"}}var r;(function(I){I[I.Initialize=200]="Initialize",I[I.PromiseSuccess=201]="PromiseSuccess",I[I.PromiseError=202]="PromiseError",I[I.PromiseErrorObj=203]="PromiseErrorObj",I[I.EventFire=204]="EventFire"})(r||(r={}));function d(I){switch(I){case r.Initialize:return"init";case r.PromiseSuccess:return"reply:";case r.PromiseError:case r.PromiseErrorObj:return"replyErr:";case r.EventFire:return"event:"}}var E;(function(I){I[I.Uninitialized=0]="Uninitialized",I[I.Idle=1]="Idle"})(E||(E={}));function f(I){let g=0;for(let k=0;;k+=7){const z=I.read(1);if(g|=(z.buffer[0]&127)<<k,!(z.buffer[0]&128))return g}}const A=s(0);function w(I,g){if(g===0){I.write(A);return}let k=0;for(let Q=g;Q!==0;Q=Q>>>7)k++;const z=W.$Se.alloc(k);for(let Q=0;g!==0;Q++)z.buffer[Q]=g&127,g=g>>>7,g>0&&(z.buffer[Q]|=128);I.write(z)}class u{constructor(g){this.b=g,this.a=0}read(g){const k=this.b.slice(this.a,this.a+g);return this.a+=k.byteLength,k}}e.$ii=u;class i{constructor(){this.a=[]}get buffer(){return W.$Se.concat(this.a)}write(g){this.a.push(g)}}e.$ji=i;var n;(function(I){I[I.Undefined=0]="Undefined",I[I.String=1]="String",I[I.Buffer=2]="Buffer",I[I.VSBuffer=3]="VSBuffer",I[I.Array=4]="Array",I[I.Object=5]="Object",I[I.Int=6]="Int"})(n||(n={}));function s(I){const g=W.$Se.alloc(1);return g.writeUInt8(I,0),g}const o={Undefined:s(n.Undefined),String:s(n.String),Buffer:s(n.Buffer),VSBuffer:s(n.VSBuffer),Array:s(n.Array),Object:s(n.Object),Uint:s(n.Int)},S=typeof Buffer<"u";function $(I,g){if(typeof g>"u")I.write(o.Undefined);else if(typeof g=="string"){const k=W.$Se.fromString(g);I.write(o.String),w(I,k.byteLength),I.write(k)}else if(S&&Buffer.isBuffer(g)){const k=W.$Se.wrap(g);I.write(o.Buffer),w(I,k.byteLength),I.write(k)}else if(g instanceof W.$Se)I.write(o.VSBuffer),w(I,g.byteLength),I.write(g);else if(Array.isArray(g)){I.write(o.Array),w(I,g.length);for(const k of g)$(I,k)}else if(typeof g=="number"&&(g|0)===g)I.write(o.Uint),w(I,g);else{const k=W.$Se.fromString(JSON.stringify(g));I.write(o.Object),w(I,k.byteLength),I.write(k)}}function m(I){switch(I.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return I.read(f(I)).toString();case n.Buffer:return I.read(f(I)).buffer;case n.VSBuffer:return I.read(f(I));case n.Array:{const k=f(I),z=[];for(let Q=0;Q<k;Q++)z.push(m(I));return z}case n.Object:return JSON.parse(I.read(f(I)).toString());case n.Int:return f(I)}}class h{constructor(g,k,z=null,Q=1e3){this.h=g,this.j=k,this.k=z,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(R=>this.q(R)),this.m({type:r.Initialize})}registerChannel(g,k){this.b.set(g,k),setTimeout(()=>this.w(g),0)}m(g){switch(g.type){case r.Initialize:{const k=this.o([g.type]);this.k?.logOutgoing(k,0,y.OtherSide,d(g.type));return}case r.PromiseSuccess:case r.PromiseError:case r.EventFire:case r.PromiseErrorObj:{const k=this.o([g.type,g.id],g.data);this.k?.logOutgoing(k,g.id,y.OtherSide,d(g.type),g.data);return}}}o(g,k=void 0){const z=new i;return $(z,g),$(z,k),this.p(z.buffer)}p(g){try{return this.h.send(g),g.byteLength}catch{return 0}}q(g){const k=new u(g),z=m(k),Q=m(k),R=z[0];switch(R){case F.Promise:return this.k?.logIncoming(g.byteLength,z[1],y.OtherSide,`${c(R)}: ${z[2]}.${z[3]}`,Q),this.s({type:R,id:z[1],channelName:z[2],name:z[3],arg:Q});case F.EventListen:return this.k?.logIncoming(g.byteLength,z[1],y.OtherSide,`${c(R)}: ${z[2]}.${z[3]}`,Q),this.t({type:R,id:z[1],channelName:z[2],name:z[3],arg:Q});case F.PromiseCancel:return this.k?.logIncoming(g.byteLength,z[1],y.OtherSide,`${c(R)}`),this.u({type:R,id:z[1]});case F.EventDispose:return this.k?.logIncoming(g.byteLength,z[1],y.OtherSide,`${c(R)}`),this.u({type:R,id:z[1]})}}s(g){const k=this.b.get(g.channelName);if(!k){this.v(g);return}const z=new M.$Be;let Q;try{Q=k.call(this.j,g.name,g.arg,z.token)}catch(ee){Q=Promise.reject(ee)}const R=g.id;Q.then(ee=>{this.m({id:R,data:ee,type:r.PromiseSuccess})},ee=>{ee instanceof Error?this.m({id:R,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split(`
`):void 0},type:r.PromiseError}):this.m({id:R,data:ee,type:r.PromiseErrorObj})}).finally(()=>{Z.dispose(),this.d.delete(g.id)});const Z=(0,T.$Xc)(()=>z.cancel());this.d.set(g.id,Z)}t(g){const k=this.b.get(g.channelName);if(!k){this.v(g);return}const z=g.id,R=k.listen(this.j,g.name,g.arg)(Z=>this.m({id:z,data:Z,type:r.EventFire}));this.d.set(g.id,R)}u(g){const k=this.d.get(g.id);k&&(k.dispose(),this.d.delete(g.id))}v(g){let k=this.g.get(g.channelName);k||(k=[],this.g.set(g.channelName,k));const z=setTimeout(()=>{console.error(`Unknown channel: ${g.channelName}`),g.type===F.Promise&&this.m({id:g.id,data:{name:"Unknown channel",message:`Channel name '${g.channelName}' timed out after ${this.l}ms`,stack:void 0},type:r.PromiseError})},this.l);k.push({request:g,timeoutTimer:z})}w(g){const k=this.g.get(g);if(k){for(const z of k)switch(clearTimeout(z.timeoutTimer),z.request.type){case F.Promise:this.s(z.request);break;case F.EventListen:this.t(z.request);break}this.g.delete(g)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,T.$Uc)(this.d.values()),this.d.clear()}}e.$mi=h;var y;(function(I){I[I.LocalSide=0]="LocalSide",I[I.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class L{constructor(g,k=null){this.l=g,this.a=!1,this.b=E.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new U.$qe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(z=>this.s(z)),this.j=k}getChannel(g){const k=this;return{call(z,Q,R){return k.a?Promise.reject(new p.$9):k.m(g,z,Q,R)},listen(z,Q){return k.a?U.Event.None:k.o(g,z,Q)}}}m(g,k,z,Q=M.CancellationToken.None){const R=this.g++,Z=F.Promise,ee={id:R,type:Z,channelName:g,name:k,arg:z};if(Q.isCancellationRequested)return Promise.reject(new p.$9);let ie;return new Promise((he,we)=>{if(Q.isCancellationRequested)return we(new p.$9);const j=()=>{const B=X=>{switch(X.type){case r.PromiseSuccess:this.f.delete(R),he(X.data);break;case r.PromiseError:{this.f.delete(R);const te=new Error(X.data.message);te.stack=Array.isArray(X.data.stack)?X.data.stack.join(`
`):X.data.stack,te.name=X.data.name,we(te);break}case r.PromiseErrorObj:this.f.delete(R),we(X.data);break}};this.f.set(R,B),this.p(ee)};let G=null;this.b===E.Idle?j():(G=(0,t.$xh)(B=>this.u()),G.then(()=>{G=null,j()}));const P=()=>{G?(G.cancel(),G=null):this.p({id:R,type:F.PromiseCancel}),we(new p.$9)},a=Q.onCancellationRequested(P);ie=(0,T.$Wc)((0,T.$Xc)(P),a),this.d.add(ie)}).finally(()=>{ie.dispose(),this.d.delete(ie)})}o(g,k,z){const Q=this.g++,R=F.EventListen,Z={id:Q,type:R,channelName:g,name:k,arg:z};let ee=null;const ie=new U.$qe({onWillAddFirstListener:()=>{ee=(0,t.$xh)(he=>this.u()),ee.then(()=>{ee=null,this.d.add(ie),this.p(Z)})},onDidRemoveLastListener:()=>{ee?(ee.cancel(),ee=null):(this.d.delete(ie),this.p({id:Q,type:F.EventDispose}))}}),ue=he=>ie.fire(he.data);return this.f.set(Q,ue),ie.event}p(g){switch(g.type){case F.Promise:case F.EventListen:{const k=this.q([g.type,g.id,g.channelName,g.name],g.arg);this.j?.logOutgoing(k,g.id,y.LocalSide,`${c(g.type)}: ${g.channelName}.${g.name}`,g.arg);return}case F.PromiseCancel:case F.EventDispose:{const k=this.q([g.type,g.id]);this.j?.logOutgoing(k,g.id,y.LocalSide,c(g.type));return}}}q(g,k=void 0){const z=new i;return $(z,g),$(z,k),this.r(z.buffer)}r(g){try{return this.l.send(g),g.byteLength}catch{return 0}}s(g){const k=new u(g),z=m(k),Q=m(k),R=z[0];switch(R){case r.Initialize:return this.j?.logIncoming(g.byteLength,0,y.LocalSide,d(R)),this.t({type:z[0]});case r.PromiseSuccess:case r.PromiseError:case r.EventFire:case r.PromiseErrorObj:return this.j?.logIncoming(g.byteLength,z[1],y.LocalSide,d(R),Q),this.t({type:z[0],id:z[1],data:Q})}}t(g){if(g.type===r.Initialize){this.b=E.Idle,this.k.fire();return}this.f.get(g.id)?.(g)}get onDidInitializePromise(){return U.Event.toPromise(this.onDidInitialize)}u(){return this.b===E.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,T.$Uc)(this.d.values()),this.d.clear()}}e.$ni=L,Je([Y.$ci],L.prototype,"onDidInitializePromise",null);class l{get connections(){const g=[];return this.f.forEach(k=>g.push(k)),g}constructor(g,k,z){this.a=new Map,this.f=new Set,this.g=new U.$qe,this.onDidAddConnection=this.g.event,this.h=new U.$qe,this.onDidRemoveConnection=this.h.event,this.j=new T.$Yc,this.j.add(g(({protocol:Q,onDidClientDisconnect:R})=>{const Z=U.Event.once(Q.onMessage);this.j.add(Z(ee=>{const ie=new u(ee),ue=m(ie),he=new h(Q,ue,k,z),we=new L(Q,k);this.a.forEach((G,P)=>he.registerChannel(P,G));const j={channelServer:he,channelClient:we,ctx:ue};this.f.add(j),this.g.fire(j),this.j.add(R(()=>{he.dispose(),we.dispose(),this.f.delete(j),this.h.fire(j)}))}))}))}getChannel(g,k){const z=this;return{call(Q,R,Z){let ee;if((0,D.$xg)(k)){const ue=(0,_.$7b)(z.connections.filter(k));ee=ue?Promise.resolve(ue):U.Event.toPromise(U.Event.filter(z.onDidAddConnection,k))}else ee=k.routeCall(z,Q,R);const ie=ee.then(ue=>ue.channelClient.getChannel(g));return q(ie).call(Q,R,Z)},listen(Q,R){if((0,D.$xg)(k))return z.k(g,k,Q,R);const Z=k.routeEvent(z,Q,R).then(ee=>ee.channelClient.getChannel(g));return q(Z).listen(Q,R)}}}k(g,k,z,Q){const R=this;let Z;const ee=new U.$qe({onWillAddFirstListener:()=>{Z=new T.$Yc;const ie=new U.$we,ue=new Map,he=j=>{const P=j.channelClient.getChannel(g).listen(z,Q),a=ie.add(P);ue.set(j,a)},we=j=>{const G=ue.get(j);G&&(G.dispose(),ue.delete(j))};R.connections.filter(k).forEach(he),U.Event.filter(R.onDidAddConnection,k)(he,void 0,Z),R.onDidRemoveConnection(we,void 0,Z),ie.event(ee.fire,ee,Z),Z.add(ie)},onDidRemoveLastListener:()=>{Z?.dispose(),Z=void 0}});return ee.event}registerChannel(g,k){this.a.set(g,k);for(const z of this.f)z.channelServer.registerChannel(g,k)}dispose(){this.j.dispose();for(const g of this.f)g.channelClient.dispose(),g.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$oi=l;class v{constructor(g,k,z=null){const Q=new i;$(Q,k),g.send(Q.buffer),this.a=new L(g,z),this.d=new h(g,k,z)}getChannel(g){return this.a.getChannel(g)}registerChannel(g,k){this.d.registerChannel(g,k)}dispose(){this.a.dispose(),this.d.dispose()}}e.$pi=v;function q(I){return{call(g,k,z){return I.then(Q=>Q.call(g,k,z))},listen(g,k){const z=new U.$ze;return I.then(Q=>z.input=Q.listen(g,k)),z.event}}}function x(I){let g=!1;return{call(k,z,Q){return g?I.call(k,z,Q):(0,t.$Lh)(0).then(()=>g=!0).then(()=>I.call(k,z,Q))},listen(k,z){if(g)return I.listen(k,z);const Q=new U.$ze;return(0,t.$Lh)(0).then(()=>g=!0).then(()=>Q.input=I.listen(k,z)),Q.event}}}class J{constructor(g){this.a=g}routeCall(g){return this.b(g)}routeEvent(g){return this.b(g)}async b(g){for(const k of g.connections)if(await Promise.resolve(this.a(k.ctx)))return Promise.resolve(k);return await U.Event.toPromise(g.onDidAddConnection),await this.b(g)}}e.$si=J;var K;(function(I){function g(R,Z,ee){const ie=R,ue=ee&&ee.disableMarshalling,he=new Map;for(const we in ie)z(we)&&he.set(we,U.Event.buffer(ie[we],!0,void 0,Z));return new class{listen(we,j,G){const P=he.get(j);if(P)return P;const a=ie[j];if(typeof a=="function"){if(Q(j))return a.call(ie,G);if(z(j))return he.set(j,U.Event.buffer(ie[j],!0,void 0,Z)),he.get(j)}throw new p.$fb(`Event not found: ${j}`)}call(we,j,G){const P=ie[j];if(typeof P=="function"){if(!ue&&Array.isArray(G))for(let B=0;B<G.length;B++)G[B]=(0,N.$hi)(G[B]);let a=P.apply(ie,G);return a instanceof Promise||(a=Promise.resolve(a)),a}throw new p.$fb(`Method not found: ${j}`)}}}I.fromService=g;function k(R,Z){const ee=Z&&Z.disableMarshalling;return new Proxy({},{get(ie,ue){if(typeof ue=="string")return Z?.properties?.has(ue)?Z.properties.get(ue):Q(ue)?function(he){return R.listen(ue,he)}:z(ue)?R.listen(ue):async function(...he){let we;Z&&!(0,D.$sg)(Z.context)?we=[Z.context,...he]:we=he;const j=await R.call(ue,we);return ee?j:(0,N.$hi)(j)};throw new p.$fb(`Property not found: ${String(ue)}`)}})}I.toService=k;function z(R){return R[0]==="o"&&R[1]==="n"&&b.$Jf(R.charCodeAt(2))}function Q(R){return/^onDynamic/.test(R)&&b.$Jf(R.charCodeAt(9))}})(K||(e.ProxyChannel=K={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(I){if(Array.isArray(I))return I;if(I&&typeof I=="object"&&typeof I.toString=="function"){const g=I.toString();if(g!=="[object Object]")return g}return I}function ne(I){return Array.isArray(I)?I.map(V):V(I)}function re(I,g,k,z,Q,R,Z){Z=ne(Z);const ee=se[Q],ie=ee[z%ee.length];let ue=[`%c[${I}]%c[${String(g).padStart(7," ")}]%c[len: ${String(k).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${R}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(R)?(ue=ue.concat(Z),ue.push(")")):ue.push(Z),console.log.apply(console,ue)}class oe{constructor(g,k){this.d=g,this.f=k,this.a=0,this.b=0}logOutgoing(g,k,z,Q,R){this.b+=g,re(this.d,this.b,g,k,z,Q,R)}logIncoming(g,k,z,Q,R){this.a+=g,re(this.f,this.a,g,k,z,Q,R)}}e.$ti=oe}),define(be[54],_e([0,1,62,8,17,13,50,9,6,4,47,53,33,26]),function(fe,e,_,t,W,M,Y,p,U,T,N,b,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0,p=Ie(p);class c extends F.$mi{constructor(E){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:U.Event.fromNodeEventEmitter(process,"message",f=>W.$Se.wrap(Buffer.from(f,"base64")))},E),process.once("disconnect",()=>this.dispose())}}e.$pr=c;class r{constructor(E,f){this.i=E,this.j=f,this.c=new Set,this.g=new Map,this.h=new U.$qe,this.onDidProcessExit=this.h.event;const A=f&&f.timeout?f.timeout:6e4;this.b=new t.$Hh(A),this.d=null,this.f=null}getChannel(E){const f=this;return{call(A,w,u){return f.k(E,A,w,u)},listen(A,w){return f.l(E,A,w)}}}k(E,f,A,w=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(p.$0());this.b.cancel();const u=this.n(E),i=(0,t.$xh)(o=>u.call(f,A,o)),n=w.onCancellationRequested(()=>i.cancel()),s=(0,T.$Xc)(()=>i.cancel());return this.c.add(s),i.finally(()=>{n.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(E,f,A){if(!this.b)return U.Event.None;this.b.cancel();let w;const u=new U.$qe({onWillAddFirstListener:()=>{w=this.n(E).listen(f,A)(u.fire,u),this.c.add(w)},onDidRemoveLastListener:()=>{this.c.delete(w),w.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return u.event}get m(){if(!this.f){const E=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,N.$ko)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter($=>!/^--inspect(-brk)?=/.test($)).filter($=>!$.startsWith("--vscode-"))),(0,D.$rm)(f.env),this.d=(0,_.fork)(this.i,E,f);const A=new U.$qe,u=U.Event.fromNodeEventEmitter(this.d,"message",$=>$)($=>{if((0,Y.$lr)($)){(0,Y.log)($,`IPC Library: ${this.j.serverName}`);return}A.fire(W.$Se.wrap(Buffer.from($,"base64")))}),i=this.j.useQueue?(0,b.$Em)(this.d):this.d,n=$=>this.d&&this.d.connected&&i.send($.buffer.toString("base64")),s=A.event,o={send:n,onMessage:s};this.f=new F.$ni(o);const S=()=>this.o();process.once("exit",S),this.d.on("error",$=>console.warn('IPC "'+this.j.serverName+'" errored with '+$)),this.d.on("exit",($,m)=>{process.removeListener("exit",S),u.dispose(),this.c.forEach(h=>(0,T.$Uc)(h)),this.c.clear(),$!==0&&m!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+$+" and signal "+m),this.b?.cancel(),this.o(),this.h.fire({code:$,signal:m})})}return this.f}n(E){let f=this.g.get(E);return f||(f=this.m.getChannel(E),this.g.set(E,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$qr=r}),define(be[55],_e([0,1,30,17,26,6,10,12]),function(fe,e,_,t,W,M,Y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AY=void 0,e.$BY=N;class U{constructor(D){this.a=D,this.onMessage=M.Event.fromNodeEventEmitter(this.a,"message",F=>F.data?t.$Se.wrap(F.data):t.$Se.alloc(0)),D.start()}send(D){this.a.postMessage(D.buffer)}disconnect(){this.a.close()}}class T extends W.$oi{static b(D){(0,Y.$tg)((0,_.$zY)(process),"Electron Utility Process");const F=new M.$qe;return process.parentPort.on("message",c=>{if(D?.handledClientConnection(c))return;const r=(0,p.$Sb)(c.ports);r&&F.fire(r)}),M.Event.map(F.event,c=>({protocol:new U(c),onDidClientDisconnect:M.Event.fromNodeEventEmitter(c,"close")}))}constructor(D){super(T.b(D))}}e.$AY=T;function N(b,D,F){const c=r=>{r.data===D&&(b.removeListener("message",c),F())};b.on("message",c)}}),define(be[56],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e._util=void 0,e.$Ki=W,e.$Li=M;var _;(function(Y){Y.serviceIds=new Map,Y.DI_TARGET="$di$target",Y.DI_DEPENDENCIES="$di$dependencies";function p(U){return U[Y.DI_DEPENDENCIES]||[]}Y.getServiceDependencies=p})(_||(e._util=_={})),e.$Ji=W("instantiationService");function t(Y,p,U){p[_.DI_TARGET]===p?p[_.DI_DEPENDENCIES].push({id:Y,index:U}):(p[_.DI_DEPENDENCIES]=[{id:Y,index:U}],p[_.DI_TARGET]=p)}function W(Y){if(_.serviceIds.has(Y))return _.serviceIds.get(Y);const p=function(U,T,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(p,U,N)};return p.toString=()=>Y,_.serviceIds.set(Y,p),p}function M(Y){return Y}}),define(be[18],_e([0,1,29,3,7,10,5,22,56,2,34,16]),function(fe,e,_,t,W,M,Y,p,U,T,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Kl=e.FileKind=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.FileOperationResult=e.$Cl=e.$Bl=e.$Al=e.$yl=e.FileChangeType=e.$xl=e.FileOperation=e.$rl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$fl=void 0,e.$gl=D,e.$hl=d,e.$il=f,e.$jl=A,e.$kl=w,e.$ll=u,e.$ml=i,e.$nl=n,e.$ol=s,e.$pl=o,e.$ql=S,e.$sl=h,e.$tl=y,e.$ul=L,e.$vl=l,e.$wl=v,e.$zl=se,e.$Ll=g,e.$Ml=k,e.$Ol=Q,e.$fl=(0,U.$Ki)("fileService");function D(R){return R.create===!0}var F;(function(R){R[R.Unknown=0]="Unknown",R[R.File=1]="File",R[R.Directory=2]="Directory",R[R.SymbolicLink=64]="SymbolicLink"})(F||(e.FileType=F={}));var c;(function(R){R[R.Readonly=1]="Readonly",R[R.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var r;(function(R){R[R.UPDATED=2]="UPDATED",R[R.ADDED=4]="ADDED",R[R.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function d(R){const Z=R;return!!Z&&typeof Z.onDidChange=="function"}var E;(function(R){R[R.None=0]="None",R[R.FileReadWrite=2]="FileReadWrite",R[R.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",R[R.FileReadStream=16]="FileReadStream",R[R.FileFolderCopy=8]="FileFolderCopy",R[R.PathCaseSensitive=1024]="PathCaseSensitive",R[R.Readonly=2048]="Readonly",R[R.Trash=4096]="Trash",R[R.FileWriteUnlock=8192]="FileWriteUnlock",R[R.FileAtomicRead=16384]="FileAtomicRead",R[R.FileAtomicWrite=32768]="FileAtomicWrite",R[R.FileAtomicDelete=65536]="FileAtomicDelete",R[R.FileClone=131072]="FileClone"})(E||(e.FileSystemProviderCapabilities=E={}));function f(R){return!!(R.capabilities&E.FileReadWrite)}function A(R){return!!(R.capabilities&E.FileFolderCopy)}function w(R){return!!(R.capabilities&E.FileClone)}function u(R){return!!(R.capabilities&E.FileOpenReadWriteClose)}function i(R){return!!(R.capabilities&E.FileReadStream)}function n(R){return f(R)?!!(R.capabilities&E.FileAtomicRead):!1}function s(R){return f(R)?!!(R.capabilities&E.FileAtomicWrite):!1}function o(R){return!!(R.capabilities&E.FileAtomicDelete)}function S(R){return!!(R.capabilities&E.Readonly)}var $;(function(R){R.FileExists="EntryExists",R.FileNotFound="EntryNotFound",R.FileNotADirectory="EntryNotADirectory",R.FileIsADirectory="EntryIsADirectory",R.FileExceedsStorageQuota="EntryExceedsStorageQuota",R.FileTooLarge="EntryTooLarge",R.FileWriteLocked="EntryWriteLocked",R.NoPermissions="NoPermissions",R.Unavailable="Unavailable",R.Unknown="Unknown"})($||(e.FileSystemProviderErrorCode=$={}));class m extends Error{static create(Z,ee){const ie=new m(Z.toString(),ee);return L(ie,ee),ie}constructor(Z,ee){super(Z),this.code=ee}}e.$rl=m;function h(R,Z){return m.create(R,Z)}function y(R){return R||h((0,p.localize)(1865,null),$.Unknown)}function L(R,Z){return R.name=Z?`${Z} (FileSystemError)`:"FileSystemError",R}function l(R){if(!R)return $.Unknown;if(R instanceof m)return R.code;const Z=/^(.+) \(FileSystemError\)$/.exec(R.name);if(!Z)return $.Unknown;switch(Z[1]){case $.FileExists:return $.FileExists;case $.FileIsADirectory:return $.FileIsADirectory;case $.FileNotADirectory:return $.FileNotADirectory;case $.FileNotFound:return $.FileNotFound;case $.FileTooLarge:return $.FileTooLarge;case $.FileWriteLocked:return $.FileWriteLocked;case $.NoPermissions:return $.NoPermissions;case $.Unavailable:return $.Unavailable}return $.Unknown}function v(R){if(R instanceof V)return R.fileOperationResult;switch(l(R)){case $.FileNotFound:return oe.FILE_NOT_FOUND;case $.FileIsADirectory:return oe.FILE_IS_DIRECTORY;case $.FileNotADirectory:return oe.FILE_NOT_DIRECTORY;case $.FileWriteLocked:return oe.FILE_WRITE_LOCKED;case $.NoPermissions:return oe.FILE_PERMISSION_DENIED;case $.FileExists:return oe.FILE_MOVE_CONFLICT;case $.FileTooLarge:return oe.FILE_TOO_LARGE;default:return oe.FILE_OTHER_ERROR}}var q;(function(R){R[R.CREATE=0]="CREATE",R[R.DELETE=1]="DELETE",R[R.MOVE=2]="MOVE",R[R.COPY=3]="COPY",R[R.WRITE=4]="WRITE"})(q||(e.FileOperation=q={}));class x{constructor(Z,ee,ie){this.resource=Z,this.operation=ee,this.target=ie}isOperation(Z){return this.operation===Z}}e.$xl=x;var J;(function(R){R[R.UPDATED=0]="UPDATED",R[R.ADDED=1]="ADDED",R[R.DELETED=2]="DELETED"})(J||(e.FileChangeType=J={}));class K{static{this.a=null}constructor(Z,ee){this.c=ee,this.b=void 0,this.d=new b.$Y(()=>{const ie=_.$Qi.forUris(()=>this.c);return ie.fill(this.rawAdded.map(ue=>[ue,!0])),ie}),this.f=new b.$Y(()=>{const ie=_.$Qi.forUris(()=>this.c);return ie.fill(this.rawUpdated.map(ue=>[ue,!0])),ie}),this.g=new b.$Y(()=>{const ie=_.$Qi.forUris(()=>this.c);return ie.fill(this.rawDeleted.map(ue=>[ue,!0])),ie}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ie of Z){switch(ie.type){case J.ADDED:this.rawAdded.push(ie.resource);break;case J.UPDATED:this.rawUpdated.push(ie.resource);break;case J.DELETED:this.rawDeleted.push(ie.resource);break}this.b!==K.a&&(typeof ie.cId=="number"?this.b===void 0?this.b=ie.cId:this.b!==ie.cId&&(this.b=K.a):this.b!==void 0&&(this.b=K.a))}}contains(Z,...ee){return this.h(Z,{includeChildren:!1},...ee)}affects(Z,...ee){return this.h(Z,{includeChildren:!0},...ee)}h(Z,ee,...ie){if(!Z)return!1;const ue=ie.length>0;return!!((!ue||ie.includes(J.ADDED))&&(this.d.value.get(Z)||ee.includeChildren&&this.d.value.findSuperstr(Z))||(!ue||ie.includes(J.UPDATED))&&(this.f.value.get(Z)||ee.includeChildren&&this.f.value.findSuperstr(Z))||(!ue||ie.includes(J.DELETED))&&(this.g.value.findSubstr(Z)||ee.includeChildren&&this.g.value.findSuperstr(Z)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Z){return this.b===Z}hasCorrelation(){return typeof this.b=="number"}}e.$yl=K;function se(R,Z,ee){return!R||!Z||R===Z||Z.length>R.length?!1:(Z.charAt(Z.length-1)!==t.sep&&(Z+=t.sep),ee?(0,W.$Lf)(R,Z):R.indexOf(Z)===0)}class V extends Error{constructor(Z,ee,ie){super(Z),this.fileOperationResult=ee,this.options=ie}}e.$Al=V;class ne extends V{constructor(Z,ee,ie,ue){super(Z,ee,ue),this.fileOperationResult=ee,this.size=ie}}e.$Bl=ne;class re extends V{constructor(Z,ee,ie){super(Z,oe.FILE_NOT_MODIFIED_SINCE,ie),this.stat=ee}}e.$Cl=re;var oe;(function(R){R[R.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",R[R.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",R[R.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",R[R.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",R[R.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",R[R.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",R[R.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",R[R.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",R[R.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",R[R.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",R[R.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(oe||(e.FileOperationResult=oe={})),e.$Dl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$El={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Fl="files.associations",e.$Gl="files.exclude",e.$Hl="files.readonlyInclude",e.$Il="files.readonlyExclude",e.$Jl="files.readonlyFromPermissions";var I;(function(R){R[R.FILE=0]="FILE",R[R.FOLDER=1]="FOLDER",R[R.ROOT_FOLDER=2]="ROOT_FOLDER"})(I||(e.FileKind=I={})),e.$Kl="";function g(R){if(!(typeof R.size!="number"||typeof R.mtime!="number"))return R.mtime.toString(29)+R.size.toString(31)}async function k(R,Z){if(!Z.hasProvider(Y.URI.from({scheme:R.scheme})))return new Promise(ee=>{const ie=Z.onDidChangeFileSystemProviderRegistrations(ue=>{ue.scheme===R.scheme&&ue.added&&(ie.dispose(),ee())})})}class z{static{this.KB=1024}static{this.MB=z.KB*z.KB}static{this.GB=z.MB*z.KB}static{this.TB=z.GB*z.KB}static formatSize(Z){return(0,M.$ng)(Z)||(Z=0),Z<z.KB?(0,p.localize)(1866,null,Z.toFixed(0)):Z<z.MB?(0,p.localize)(1867,null,(Z/z.KB).toFixed(2)):Z<z.GB?(0,p.localize)(1868,null,(Z/z.MB).toFixed(2)):Z<z.TB?(0,p.localize)(1869,null,(Z/z.GB).toFixed(2)):(0,p.localize)(1870,null,(Z/z.TB).toFixed(2))}}e.$Nl=z;function Q(R){const Z=typeof R=="string"||R?.scheme===N.Schemas.vscodeRemote;return typeof R!="string"&&R?.scheme===N.Schemas.file?1024*z.MB:Z?10*z.MB:T.$r?50*z.MB:1024*z.MB}}),define(be[19],_e([0,1,24,4,3,2,5,18]),function(fe,e,_,t,W,M,Y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=e.$br=void 0,e.$_q=U,e.$ar=T,e.$er=F,e.$fr=c,e.$gr=r,e.$hr=d,e.$ir=f,e.$jr=A;function U(w){return typeof w.correlationId=="number"}function T(w){return w.recursive===!0}class N extends t.$Zc{static{this.a=5}constructor(u,i,n,s){super(),this.h=u,this.j=i,this.m=n,this.n=s,this.c=this.B(new t.$1c),this.f=void 0,this.g=0}s(){const u=new t.$Yc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(i=>this.h(i))),u.add(this.b.onDidLogMessage(i=>this.j(i))),u.add(this.b.onDidError(i=>this.t(i.error,i.request)))}t(u,i){this.u(u,i)?this.g<N.a&&this.f?(this.y(`restarting watcher after unexpected error: ${u}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${u}`):this.y(u)}u(u,i){return!(!this.n.restartOnError||i||u.indexOf("No space left on device")!==-1||u.indexOf("EMFILE")!==-1)}w(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}y(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}z(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$br=N;class b extends N{constructor(u,i,n){super(u,i,n,{type:"node.js",restartOnError:!1})}}e.$cr=b;class D extends N{constructor(u,i,n){super(u,i,n,{type:"universal",restartOnError:!0})}}e.$dr=D;function F(w){return w.map(u=>({type:u.type,resource:Y.URI.revive(u.resource),cId:u.cId}))}function c(w){const u=new E;for(const i of w)u.processEvent(i);return u.coalesce()}function r(w,u){return typeof u=="string"&&!u.startsWith(_.$Bk)&&!(0,W.$nc)(u)?{base:w,pattern:u}:u}function d(w,u){const i=[];for(const n of u)i.push((0,_.$Fk)(r(w,n)));return i}class E{constructor(){this.a=new Set,this.b=new Map}c(u){return M.$n?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const i=this.b.get(this.c(u));let n=!1;if(i){const s=i.type,o=u.type;i.resource.fsPath!==u.resource.fsPath&&(u.type===p.FileChangeType.DELETED||u.type===p.FileChangeType.ADDED)?n=!0:s===p.FileChangeType.ADDED&&o===p.FileChangeType.DELETED?(this.b.delete(this.c(u)),this.a.delete(i)):s===p.FileChangeType.DELETED&&o===p.FileChangeType.ADDED?i.type=p.FileChangeType.UPDATED:s===p.FileChangeType.ADDED&&o===p.FileChangeType.UPDATED||(i.type=o)}else n=!0;n&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],i=[];return Array.from(this.a).filter(n=>n.type!==p.FileChangeType.DELETED?(u.push(n),!1):!0).sort((n,s)=>n.resource.fsPath.length-s.resource.fsPath.length).filter(n=>i.some(s=>(0,p.$zl)(n.resource.fsPath,s,!M.$n))?!1:(i.push(n.resource.fsPath),!0)).concat(u)}}function f(w,u){if(typeof u=="number")switch(w.type){case p.FileChangeType.ADDED:return(u&p.FileChangeFilter.ADDED)===0;case p.FileChangeType.DELETED:return(u&p.FileChangeFilter.DELETED)===0;case p.FileChangeType.UPDATED:return(u&p.FileChangeFilter.UPDATED)===0}return!1}function A(w){if(typeof w=="number"){const u=[];return w&p.FileChangeFilter.ADDED&&u.push("Added"),w&p.FileChangeFilter.DELETED&&u.push("Deleted"),w&p.FileChangeFilter.UPDATED&&u.push("Updated"),u.length===0?"<all>":`[${u.join(", ")}]`}return"<none>"}}),define(be[36],_e([0,1,15,4,19,6,18,5,8]),function(fe,e,_,t,W,M,Y,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;class T extends t.$Zc{constructor(){super(),this.a=this.B(new M.$qe),this.onDidChangeFile=this.a.event,this.b=this.B(new M.$qe),this.onDidLogMessage=this.b.event,this.c=this.B(new M.$qe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new t.$9c),this.m=new Set,this.n=this.B(new U.$Ih(this.y())),this.r=5007,this.s=new U.$8h,this.R=!1,this.B(this.f(b=>this.t(b)))}t(b){this.u(b)&&this.z(b)}u(b){return(0,W.$_q)(b)}async watch(b){this.s.isSettled||this.s.complete(),this.s=new U.$8h;try{this.h.clear(),this.g.clear();for(const D of b)this.u(D)?this.h.set(D.correlationId,D):this.g.add(D);for(const[D]of this.j)this.h.has(D)||(this.j.deleteAndDispose(D),this.m.delete(D));return await this.w(!1)}finally{this.s.complete()}}w(b){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(D=>!this.j.has(D.correlationId))]),b?this.y():0)}y(){return 800}isSuspended(b){return typeof b.correlationId!="number"?!1:this.m.has(b.correlationId)?"polling":this.j.has(b.correlationId)}async z(b){if(this.j.has(b.correlationId))return;const D=new t.$Yc;this.j.set(b.correlationId,D),await this.s.p,!D.isDisposed&&(this.D(b,D),this.w(!0))}C(b){this.j.deleteAndDispose(b.correlationId),this.m.delete(b.correlationId),this.w(!1)}D(b,D){this.F(b,D)?(this.P(`reusing an existing recursive watcher to monitor ${b.path}`),this.m.delete(b.correlationId)):(this.G(b,D),this.m.add(b.correlationId))}F(b,D){const F=this.O?.subscribe(b.path,(c,r)=>{D.isDisposed||(c?this.D(b,D):r?.type===Y.FileChangeType.ADDED&&this.H(b))});return F?(D.add(F),!0):!1}G(b,D){let F=!1;const c=(r,d)=>{if(D.isDisposed)return;const E=this.I(r),f=this.I(d),A=F;F=E,!E&&(f||A)&&this.H(b)};this.P(`starting fs.watchFile() on ${b.path} (correlationId: ${b.correlationId})`);try{(0,_.watchFile)(b.path,{persistent:!1,interval:this.r},c)}catch(r){this.Q(`fs.watchFile() failed with error ${r} on path ${b.path} (correlationId: ${b.correlationId})`)}D.add((0,t.$Xc)(()=>{this.P(`stopping fs.watchFile() on ${b.path} (correlationId: ${b.correlationId})`);try{(0,_.unwatchFile)(b.path,c)}catch(r){this.Q(`fs.unwatchFile() failed with error ${r} on path ${b.path} (correlationId: ${b.correlationId})`)}}))}H(b){this.P(`detected ${b.path} exists again, resuming watcher (correlationId: ${b.correlationId})`);const D={resource:p.URI.file(b.path),type:Y.FileChangeType.ADDED,cId:b.correlationId};this.a.fire([D]),this.J(D,b),this.C(b)}I(b){return b.ctimeMs===0&&b.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(b,D){if(this.R){const F=` >> normalized ${b.type===Y.FileChangeType.ADDED?"[ADDED]":b.type===Y.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${b.resource.fsPath}`;this.L(F,D)}}L(b,D){this.R&&this.P(`${b}${typeof D.correlationId=="number"?` <${D.correlationId}> `:""}`)}M(b){return`${b.path} (excludes: ${b.excludes.length>0?b.excludes:"<none>"}, includes: ${b.includes&&b.includes.length>0?JSON.stringify(b.includes):"<all>"}, filter: ${(0,W.$jr)(b.filter)}, correlationId: ${typeof b.correlationId=="number"?b.correlationId:"<none>"})`}async setVerboseLogging(b){this.R=b}}e.$sr=T}),define(be[37],_e([0,1,15,8,13,14,4,21,3,2,23,5,35,25,18,19]),function(fe,e,_,t,W,M,Y,p,U,T,N,b,D,F,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=void 0,e.$yr=E;class d extends Y.$Zc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(A,w,u,i,n,s){super(),this.s=A,this.t=w,this.u=u,this.w=i,this.y=n,this.z=s,this.c=this.B(new t.$Zh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},o=>this.u(o))),this.f=this.B(new t.$Yh(o=>this.M(o),d.b)),this.g=(0,r.$hr)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,r.$hr)(this.s.path,this.s.includes):void 0,this.j=(0,r.$_q)(this.s)?this.s.filter:void 0,this.m=new W.$Be,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const A=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const w=await _.promises.stat(A);if(this.m.token.isCancellationRequested)return;this.B(await this.G(A,w.isDirectory()))}catch(A){A.code!=="ENOENT"?this.O(A):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${A})`),this.D()}}D(){this.r=!0,this.w?.()}async F(A){let w=A.path;try{w=await F.Promises.realpath(A.path),A.path===w&&(w=await(0,D.$ur)(A.path,this.m.token)??A.path),A.path!==w&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${A.path}, real: ${w})`)}catch{}return w}async G(A,w){const u=new Y.$Yc;return this.H(A,w,u)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(A,w,u)),u}H(A,w,u){if(w)return!1;const i=b.URI.file(this.s.path),n=this.t?.subscribe(this.s.path,async(s,o)=>{if(!u.isDisposed)if(s){const S=await this.G(A,w);u.isDisposed?S.dispose():u.add(S)}else o&&(typeof o.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:i,type:o.type,cId:this.s.correlationId},!0)});return n?(u.add(n),!0):!1}async I(A,w,u){if(T.$m&&(0,M.$Jg)(A,"/Volumes/",!0)){this.O(`Refusing to watch ${A} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const i=new W.$Be(this.m.token);u.add((0,Y.$Xc)(()=>i.dispose(!0)));const n=new Y.$Yc;u.add(n);try{const s=b.URI.file(this.s.path),o=(0,U.$sc)(A),S=(0,_.watch)(A);n.add((0,Y.$Xc)(()=>{S.removeAllListeners(),S.close()})),this.Q(`Started watching: '${A}'`);const $=new Set;if(w)try{for(const h of await F.Promises.readdir(A))$.add(h)}catch(h){this.O(h)}if(i.token.isCancellationRequested)return;const m=new Map;n.add((0,Y.$Xc)(()=>{for(const[,h]of m)h.dispose();m.clear()})),S.on("error",(h,y)=>{i.token.isCancellationRequested||(this.O(`Failed to watch ${A} for changes using fs.watch() (${h}, ${y})`),this.D())}),S.on("change",(h,y)=>{if(i.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${h}"] ${y}`);let L="";if(y&&(L=y.toString(),T.$m&&(L=(0,p.$sm)(L))),!(!L||h!=="change"&&h!=="rename"))if(w)if(h==="rename"){m.get(L)?.dispose();const l=setTimeout(async()=>{if(m.delete(L),L===o&&!await F.Promises.exists(A)){this.J(s);return}if(i.token.isCancellationRequested)return;const v=await this.N((0,U.$oc)(A,L));if(i.token.isCancellationRequested)return;let q;v?$.has(L)?q=c.FileChangeType.UPDATED:(q=c.FileChangeType.ADDED,$.add(L)):($.delete(L),q=c.FileChangeType.DELETED),this.L({resource:(0,N.$lh)(s,L),type:q,cId:this.s.correlationId})},d.a);m.set(L,(0,Y.$Xc)(()=>clearTimeout(l)))}else{let l;$.has(L)?l=c.FileChangeType.UPDATED:(l=c.FileChangeType.ADDED,$.add(L)),this.L({resource:(0,N.$lh)(s,L),type:l,cId:this.s.correlationId})}else if(h==="rename"||L!==o){const l=setTimeout(async()=>{const v=await F.Promises.exists(A);i.token.isCancellationRequested||(v?(this.L({resource:s,type:c.FileChangeType.UPDATED,cId:this.s.correlationId},!0),n.add(await this.G(A,!1))):this.J(s))},d.a);n.clear(),n.add((0,Y.$Xc)(()=>clearTimeout(l)))}else this.L({resource:s,type:c.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(s){i.token.isCancellationRequested||this.O(`Failed to watch ${A} for changes using fs.watch() (${s.toString()})`),this.D()}}J(A){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:A,type:c.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(A,w=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${A.type===c.FileChangeType.ADDED?"[ADDED]":A.type===c.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${A.resource.fsPath}`),!w&&this.g.some(u=>u(A.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${A.resource.fsPath}`):!w&&this.h&&this.h.length>0&&!this.h.some(u=>u(A.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${A.resource.fsPath}`):this.f.work(A))}M(A){const w=(0,r.$fr)(A),u=[];for(const n of w){if((0,r.$ir)(n,this.j)){this.z&&this.R(` >> ignored (filtered) ${n.resource.fsPath}`);continue}u.push(n)}if(u.length===0)return;if(this.z)for(const n of u)this.R(` >> normalized ${n.type===c.FileChangeType.ADDED?"[ADDED]":n.type===c.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`);this.c.work(u)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(A){if(T.$n)return F.Promises.exists(A);try{const w=(0,U.$sc)(A);return(await F.Promises.readdir((0,U.$rc)(A))).some(i=>i===w)}catch(w){return this.Q(w),!1}}setVerboseLogging(A){this.z=A}O(A){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${A}`})}P(A){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${A}`})}Q(A){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${A}`})}R(A){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${A}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$xr=d;async function E(f,A,w,u,i=512){const n=await F.Promises.open(f,"r"),s=Buffer.allocUnsafe(i),o=new W.$Be(u);let S,$=!1;const m={path:f,excludes:[],recursive:!1},h=new d(m,void 0,y=>{(async()=>{for(const{type:L}of y)if(L===c.FileChangeType.UPDATED){if($)return;$=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:l}=await F.Promises.read(n,s,0,i,null);if(!l||o.token.isCancellationRequested)break;A(s.slice(0,l))}}catch(l){S=new Error(l),o.dispose(!0)}finally{$=!1}}})()});return await h.ready,w(),new Promise((y,L)=>{o.token.onCancellationRequested(async()=>{h.dispose();try{await F.Promises.close(n)}catch(l){S=new Error(l)}S?L(S):y()})})}}),define(be[57],_e([0,1,6,24,36,2,37,14]),function(fe,e,_,t,W,M,Y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;class U extends W.$sr{constructor(N){super(),this.O=N,this.onDidError=_.Event.None,this.watchers=new Set}async N(N){N=this.Z(N);const b=[],D=new Set(Array.from(this.watchers));for(const F of N){const c=this.W(F);c&&(0,t.$Jk)(c.request.excludes,F.excludes)&&(0,t.$Jk)(c.request.includes,F.includes)?D.delete(c):b.push(F)}b.length&&this.P(`Request to start watching: ${b.map(F=>this.M(F)).join(",")}`),D.size&&this.P(`Request to stop watching: ${Array.from(D).map(F=>this.M(F.request)).join(",")}`);for(const F of D)this.Y(F);for(const F of b)this.X(F)}W(N){for(const b of this.watchers)if(typeof N.correlationId=="number"||typeof b.request.correlationId=="number"){if(b.request.correlationId===N.correlationId)return b}else if((0,p.$Ig)(b.request.path,N.path,!M.$n))return b}X(N){const b=new Y.$xr(N,this.O,F=>this.a.fire(F),()=>this.c.fire(N),F=>this.b.fire(F),this.R),D={request:N,instance:b};this.watchers.add(D)}async stop(){await super.stop();for(const N of this.watchers)this.Y(N)}Y(N){this.P("stopping file watcher",N),this.watchers.delete(N),N.instance.dispose()}Z(N){const b=new Map;for(const D of N){const F=M.$n?D.path:D.path.toLowerCase();let c=b.get(D.correlationId);c||(c=new Map,b.set(D.correlationId,c)),c.has(F)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(D)}`),c.set(F,D)}return Array.from(b.values()).map(D=>Array.from(D.values())).flat()}async setVerboseLogging(N){super.setVerboseLogging(N);for(const b of this.watchers)b.instance.setVerboseLogging(N)}P(N,b){this.R&&this.b.fire({type:"trace",message:this.bb(N,b)})}Q(N){this.b.fire({type:"warn",message:this.bb(N)})}bb(N,b){return b?`[File Watcher (node.js)] ${N} (${this.M(b.request)})`:`[File Watcher (node.js)] ${N}`}}e.$zr=U}),define(be[58],_e([0,1,63,15,52,5,8,13,49,6,14,24,36,29,21,3,2,35,37,18,19,4]),function(fe,e,_,t,W,M,Y,p,U,T,N,b,D,F,c,r,d,E,f,A,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rnc=e.$Qnc=void 0,_=Ie(_);class i extends u.$Zc{get failed(){return this.c}get stopped(){return this.f}constructor(o,S,$,m,h,y){super(),this.ready=o,this.request=S,this.restarts=$,this.token=m,this.worker=h,this.m=y,this.a=this.B(new T.$qe),this.onDidStop=this.a.event,this.b=this.B(new T.$qe),this.onDidFail=this.b.event,this.c=!1,this.f=!1,this.g=this.request.includes?(0,w.$hr)(this.request.path,this.request.includes):void 0,this.h=this.request.excludes?(0,w.$hr)(this.request.path,this.request.excludes):void 0,this.j=new Map,this.B((0,u.$Xc)(()=>this.j.clear()))}subscribe(o,S){o=M.URI.file(o).fsPath;let $=this.j.get(o);return $||($=new Set,this.j.set(o,$)),$.add(S),(0,u.$Xc)(()=>{const m=this.j.get(o);m&&(m.delete(S),m.size===0&&this.j.delete(o))})}get subscriptionsCount(){return this.j.size}notifyFileChange(o,S){const $=this.j.get(o);if($)for(const m of $)m(S)}notifyWatchFailed(){this.c=!0,this.b.fire()}include(o){return!this.g||this.g.length===0?!0:this.g.some(S=>S(o))}exclude(o){return!!this.h?.some(S=>S(o))}async stop(o){this.f=!0;try{await this.m()}finally{this.a.fire({joinRestart:o}),this.dispose()}}}e.$Qnc=i;class n extends D.$sr{static{this.S=new Map([["create",A.FileChangeType.ADDED],["update",A.FileChangeType.UPDATED],["delete",A.FileChangeType.DELETED]])}static{this.U=d.$l?"windows":d.$n?"inotify":"fs-events"}static{this.X=75}constructor(){super(),this.W=this.B(new T.$qe),this.onDidError=this.W.event,this.watchers=new Set,this.Y=this.B(new Y.$Zh({maxWorkChunkSize:500,throttleDelay:200,maxBufferedWork:3e4},o=>this.a.fire(o))),this.Z=!1,this.$()}$(){process.on("uncaughtException",o=>this.nb(o)),process.on("unhandledRejection",o=>this.nb(o))}async N(o){o=this.qb(o);const S=[],$=new Set(Array.from(this.watchers));for(const m of o){const h=this.bb(m);h&&(0,b.$Jk)(h.request.excludes,m.excludes)&&(0,b.$Jk)(h.request.includes,m.includes)&&h.request.pollingInterval===m.pollingInterval?$.delete(h):S.push(m)}S.length&&this.P(`Request to start watching: ${S.map(m=>this.M(m)).join(",")}`),$.size&&this.P(`Request to stop watching: ${Array.from($).map(m=>this.M(m.request)).join(",")}`);for(const m of $)await this.pb(m);for(const m of S)m.pollingInterval?this.cb(m,m.pollingInterval):await this.db(m)}bb(o){for(const S of this.watchers)if(this.u(o)||this.u(S.request)){if(S.request.correlationId===o.correlationId)return S}else if((0,N.$Ig)(S.request.path,o.path,!d.$n))return S}cb(o,S,$=0){const m=new p.$Be,h=new Y.$8h,y=(0,N.$Sg)((0,W.tmpdir)(),"vscode-watcher-snapshot"),L=new i(h.p,o,$,m.token,new Y.$Yh(K=>this.gb(K,L),n.X),async()=>{m.dispose(!0),L.worker.flush(),L.worker.dispose(),J.dispose(),(0,t.unlinkSync)(y)});this.watchers.add(L);const{realPath:l,realPathDiffers:v,realPathLength:q}=this.ib(o);this.P(`Started watching: '${l}' with polling interval '${S}'`);let x=0;const J=new Y.$Wh(async()=>{if(x++,!m.token.isCancellationRequested){if(x>1){const K=await _.getEventsSince(l,y,{ignore:o.excludes,backend:n.U});if(m.token.isCancellationRequested)return;this.eb(K,L,v,q)}await _.writeSnapshot(l,y,{ignore:o.excludes,backend:n.U}),x===1&&h.complete(),!m.token.isCancellationRequested&&J.schedule()}},S);J.schedule(0)}async db(o,S=0){const $=new p.$Be,m=new Y.$8h,h=new i(m.p,o,S,$.token,new Y.$Yh(v=>this.gb(v,h),n.X),async()=>{$.dispose(!0),h.worker.flush(),h.worker.dispose(),await(await m.p)?.unsubscribe()});this.watchers.add(h);const{realPath:y,realPathDiffers:L,realPathLength:l}=this.ib(o);try{const v=await _.subscribe(y,(q,x)=>{h.token.isCancellationRequested||(q&&this.nb(q,o),this.eb(x,h,L,l))},{backend:n.U,ignore:h.request.excludes});this.P(`Started watching: '${y}' with backend '${n.U}'`),m.complete(v)}catch(v){this.nb(v,o),m.complete(void 0),h.notifyWatchFailed(),this.c.fire(o)}}eb(o,S,$,m){if(o.length===0)return;this.jb(o,S.request,$,m);const h=this.fb(S,o);for(const y of h)S.worker.work(y)}fb(o,S){const $=[];for(const{path:m,type:h}of S){const y=n.S.get(h);this.R&&this.L(`${y===A.FileChangeType.ADDED?"[ADDED]":y===A.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${m}`,o.request),o.include(m)?$.push({type:y,resource:M.URI.file(m),cId:o.request.correlationId}):this.R&&this.L(` >> ignored (not included) ${m}`,o.request)}return $}gb(o,S){const $=(0,w.$fr)(o),{events:m,rootDeleted:h}=this.kb($,S);this.hb(m,S),h&&this.lb(S)}hb(o,S){if(o.length===0)return;this.Y.work(o)?this.Y.pending>0&&this.P(`started throttling events due to large amount of file change events at once (pending: ${this.Y.pending}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`,S):this.Q(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}ib(o){let S=o.path,$=!1,m=o.path.length;try{S=(0,E.$wr)(o.path),o.path===S&&(S=(0,E.$tr)(o.path)??o.path),o.path!==S&&(m=S.length,$=!0,this.P(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${o.path}, real: ${S})`))}catch{}return{realPath:S,realPathDiffers:$,realPathLength:m}}jb(o,S,$,m){for(const h of o)d.$m&&(h.path=(0,c.$sm)(h.path)),d.$l&&S.path.length<=3&&(h.path=(0,r.$mc)(h.path)),$&&(h.path=S.path+h.path.substr(m))}kb(o,S){const $=[];let m=!1;const h=this.u(S.request)?S.request.filter:void 0;for(const y of o){if(S.subscriptionsCount>0&&S.notifyFileChange(y.resource.fsPath,y),m=y.type===A.FileChangeType.DELETED&&(0,N.$Ig)(y.resource.fsPath,S.request.path,!d.$n),(0,w.$ir)(y,h)||m&&!this.u(S.request)){this.R&&this.L(` >> ignored (filtered) ${y.resource.fsPath}`,S.request);continue}this.J(y,S.request),$.push(y)}return{events:$,rootDeleted:m}}lb(o){this.Q("Watcher shutdown because watched path got deleted",o);let S=!1;this.u(o.request)||(S=this.mb(o)),S||(o.notifyWatchFailed(),this.c.fire(o.request))}mb(o){const S=(0,r.$rc)(o.request.path);if((0,t.existsSync)(S)){this.P("Trying to watch on the parent path to restart the watcher...",o);const $=new f.$xr({path:S,excludes:[],recursive:!1,correlationId:o.request.correlationId},void 0,m=>{if(!o.token.isCancellationRequested){for(const{resource:h,type:y}of m)if((0,N.$Ig)(h.fsPath,o.request.path,!d.$n)&&(y===A.FileChangeType.ADDED||y===A.FileChangeType.UPDATED)&&this.rb(o.request.path)){this.Q("Watcher restarts because watched path got created again",o),$.dispose(),this.ob(o);break}}},void 0,m=>this.b.fire(m),this.R);return o.token.onCancellationRequested(()=>$.dispose()),!0}return!1}nb(o,S){const $=(0,U.$vj)(o);$.indexOf("No space left on device")!==-1?this.Z||(this.ub("Inotify limit reached (ENOSPC)",S),this.Z=!0):(this.ub(`Unexpected error: ${$} (EUNKNOWN)`,S),this.W.fire({request:S,error:$}))}async stop(){await super.stop();for(const o of this.watchers)await this.pb(o)}ob(o,S=800){const $=new Y.$Wh(async()=>{if(o.token.isCancellationRequested)return;const m=new Y.$8h;try{await this.pb(o,m.p),o.request.pollingInterval?this.cb(o.request,o.request.pollingInterval,o.restarts+1):await this.db(o.request,o.restarts+1)}finally{m.complete()}},S);$.schedule(),o.token.onCancellationRequested(()=>$.dispose())}async pb(o,S){this.P("stopping file watcher",o),this.watchers.delete(o);try{await o.stop(S)}catch($){this.ub(`Unexpected error stopping watcher: ${(0,U.$vj)($)}`,o.request)}}qb(o,S=!0){o.sort((h,y)=>h.path.length-y.path.length);const $=new Map;for(const h of o){if(h.excludes.includes(b.$Bk))continue;const y=d.$n?h.path:h.path.toLowerCase();let L=$.get(h.correlationId);L||(L=new Map,$.set(h.correlationId,L)),L.has(y)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(h)}`),L.set(y,h)}const m=[];for(const h of $.values()){const y=F.$Qi.forPaths(!d.$n);for(const L of h.values()){if(y.findSubstr(L.path))try{if((0,E.$wr)(L.path)===L.path){this.P(`ignoring a request for watching who's parent is already watched: ${this.M(L)}`);continue}}catch(l){this.P(`ignoring a request for watching who's realpath failed to resolve: ${this.M(L)} (error: ${l})`),this.c.fire(L);continue}if(S&&!this.rb(L.path)){this.c.fire(L);continue}y.set(L.path,L)}m.push(...Array.from(y).map(([,L])=>L))}return m}rb(o){try{if(!(0,t.statSync)(o).isDirectory())return this.P(`ignoring a path for watching that is a file and not a folder: ${o}`),!1}catch(S){return this.P(`ignoring a path for watching who's stat info failed to resolve: ${o} (error: ${S})`),!1}return!0}subscribe(o,S){for(const $ of this.watchers){if($.failed||!(0,N.$Jg)(o,$.request.path,!d.$n)||$.exclude(o)||!$.include(o))continue;const m=new u.$Yc;return m.add(T.Event.once($.onDidStop)(async h=>{await h.joinRestart,!m.isDisposed&&S(!0)})),m.add(T.Event.once($.onDidFail)(()=>S(!0))),m.add($.subscribe(o,h=>S(null,h))),m}}P(o,S){this.R&&this.b.fire({type:"trace",message:this.vb(o,S?.request)})}Q(o,S){this.b.fire({type:"warn",message:this.vb(o,S?.request)})}ub(o,S){this.b.fire({type:"error",message:this.vb(o,S)})}vb(o,S){return S?`[File Watcher (parcel)] ${o} (path: ${S.path})`:`[File Watcher (parcel)] ${o}`}get O(){return this}}e.$Rnc=n}),define(be[59],_e([0,1,19]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Snc=t;function t(c,r,d){const E=[],f=U(c.filter(q=>q.recursive)),A=f.filter(q=>r.isSuspended(q)===!1),w=f.filter(q=>r.isSuspended(q)==="polling"),u=f.filter(q=>r.isSuspended(q)===!0),i=M(f,r),n=Y(r),s=U(c.filter(q=>!q.recursive)),o=s.filter(q=>d.isSuspended(q)===!1),S=s.filter(q=>d.isSuspended(q)==="polling"),$=s.filter(q=>d.isSuspended(q)===!0),m=M(s,d),h=p(d);E.push("[Summary]"),E.push(`- Recursive Requests:     total: ${f.length}, suspended: ${i.suspended}, polling: ${i.polling}`),E.push(`- Non-Recursive Requests: total: ${s.length}, suspended: ${m.suspended}, polling: ${m.polling}`),E.push(`- Recursive Watchers:     total: ${r.watchers.size}, active: ${n.active}, failed: ${n.failed}, stopped: ${n.stopped}`),E.push(`- Non-Recursive Watchers: total: ${d.watchers.size}, active: ${h.active}, failed: ${h.failed}, reusing: ${h.reusing}`),E.push(`- I/O Handles Impact:     total: ${i.polling+m.polling+n.active+h.active}`),E.push(`
[Recursive Requests (${f.length}, suspended: ${i.suspended}, polling: ${i.polling})]:`);const y=[];for(const q of[A,w,u].flat())N(y,q,r);E.push(...W(y));const L=[];D(L,r),E.push(...W(L)),E.push(`
[Non-Recursive Requests (${s.length}, suspended: ${m.suspended}, polling: ${m.polling})]:`);const l=[];for(const q of[o,S,$].flat())N(l,q,d);E.push(...W(l));const v=[];return F(v,d),E.push(...W(v)),`

[File Watcher] request stats:

${E.join(`
`)}

`}function W(c){let r=0;for(const d of c)r=Math.max(r,d.split("	")[0].length);for(let d=0;d<c.length;d++){const f=c[d].split("	");if(f.length===2){const A=" ".repeat(r-f[0].length);c[d]=`${f[0]}${A}	${f[1]}`}}return c}function M(c,r){let d=0,E=0;for(const f of c){const A=r.isSuspended(f);A!==!1&&(E++,A==="polling"&&d++)}return{suspended:E,polling:d}}function Y(c){let r=0,d=0,E=0;for(const f of c.watchers.values())!f.failed&&!f.stopped&&r++,f.failed&&d++,f.stopped&&E++;return{active:r,failed:d,stopped:E}}function p(c){let r=0,d=0,E=0;for(const f of c.watchers)!f.instance.failed&&!f.instance.isReusingRecursiveWatcher&&r++,f.instance.failed&&d++,f.instance.isReusingRecursiveWatcher&&E++;return{active:r,failed:d,reusing:E}}function U(c){return c.sort((r,d)=>{const E=T(r)?r.path:r.request.path,f=T(d)?d.path:d.request.path,A=Math.min(E.length,f.length);for(let w=0;w<A;w++)if(E[w]!==f[w])return E[w]<f[w]?-1:1;return E.length-f.length}),c}function T(c){return typeof c?.path=="string"}function N(c,r,d){const E=[],f=d.isSuspended(r);f!==!1&&(f==="polling"?E.push("[SUSPENDED <polling>]"):E.push("[SUSPENDED <non-polling>]")),c.push(` ${r.path}	${E.length>0?E.join(" ")+" ":""}(${b(r)})`)}function b(c){return`excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, filter: ${(0,_.$jr)(c.filter)}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"}`}function D(c,r){const d=U(Array.from(r.watchers.values())),{active:E,failed:f,stopped:A}=Y(r);c.push(`
[Recursive Watchers (${d.length}, active: ${E}, failed: ${f}, stopped: ${A})]:`);for(const w of d){const u=[];w.failed&&u.push("[FAILED]"),w.stopped&&u.push("[STOPPED]"),w.subscriptionsCount>0&&u.push(`[SUBSCRIBED:${w.subscriptionsCount}]`),w.restarts>0&&u.push(`[RESTARTED:${w.restarts}]`),c.push(` ${w.request.path}	${u.length>0?u.join(" ")+" ":""}(${b(w.request)})`)}}function F(c,r){const d=U(Array.from(r.watchers.values())),E=d.filter(n=>!n.instance.failed&&!n.instance.isReusingRecursiveWatcher),f=d.filter(n=>n.instance.failed),A=d.filter(n=>n.instance.isReusingRecursiveWatcher),{active:w,failed:u,reusing:i}=p(r);c.push(`
[Non-Recursive Watchers (${d.length}, active: ${w}, failed: ${u}, reusing: ${i})]:`);for(const n of[E,f,A].flat()){const s=[];n.instance.failed&&s.push("[FAILED]"),n.instance.isReusingRecursiveWatcher&&s.push("[REUSING]"),c.push(` ${n.request.path}	${s.length>0?s.join(" ")+" ":""}(${b(n.request)})`)}}}),define(be[60],_e([0,1,4,6,58,57,8,59]),function(fe,e,_,t,W,M,Y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tnc=void 0;class U extends _.$Zc{constructor(){super(...arguments),this.a=this.B(new W.$Rnc),this.b=this.B(new M.$zr(this.a)),this.onDidChangeFile=t.Event.any(this.a.onDidChangeFile,this.b.onDidChangeFile),this.onDidError=t.Event.any(this.a.onDidError,this.b.onDidError),this.c=this.B(new t.$qe),this.onDidLogMessage=t.Event.any(this.c.event,this.a.onDidLogMessage,this.b.onDidLogMessage),this.f=[]}async watch(N){this.f=N;let b;try{await this.a.watch(N.filter(D=>D.recursive))}catch(D){b=D}try{await this.b.watch(N.filter(D=>!D.recursive))}catch(D){b||(b=D)}if(b)throw b}async setVerboseLogging(N){N&&this.f.length>0&&this.c.fire({type:"trace",message:(0,p.$Snc)(this.f,this.a,this.b)}),await Y.Promises.settled([this.a.setVerboseLogging(N),this.b.setVerboseLogging(N)])}async stop(){await Y.Promises.settled([this.a.stop(),this.b.stop()])}}e.$Tnc=U}),define(be[64],_e([0,1,4,26,54,55,30,60]),function(fe,e,_,t,W,M,Y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let U;(0,Y.$zY)(process)?U=new M.$AY:U=new W.$pr("watcher");const T=new p.$Tnc;U.registerChannel("watcher",t.ProxyChannel.fromService(T,new _.$Yc))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/e37706186d2105b4158df80574323ebb987d7f64/core/vs/platform/files/node/watcher/watcherMain.js.map
