/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var he=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/path","vs/base/common/uri","vs/base/common/errors","vs/nls","vs/platform/log/common/log","vs/base/common/types","vs/base/common/strings","vs/base/common/async","vs/base/common/charCode","vs/base/common/decorators","vs/base/common/process","vs/platform/terminal/common/terminal","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/network","os","vs/platform/instantiation/common/instantiation","vs/platform/terminal/common/capabilities/capabilities","vs/base/common/lazy","vs/base/common/resources","vs/base/common/map","vs/base/common/marshallingIds","vs/base/node/pfs","child_process","vs/base/parts/ipc/common/ipc","vs/base/common/functional","vs/base/common/objects","vs/base/parts/sandbox/node/electronTypes","vs/nls.messages","vs/base/common/extpath","vs/base/common/processes","fs","vs/base/node/processes","vs/platform/contextkey/common/contextkey","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/node/terminalEnvironment","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/uint","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/uuid","vs/base/common/date","vs/base/common/errorMessage","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/files/common/files","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/terminal/common/capabilities/bufferMarkCapability","vs/platform/terminal/common/capabilities/commandDetection/promptInputModel","vs/platform/terminal/common/capabilities/commandDetection/terminalCommand","vs/platform/terminal/common/capabilities/commandDetectionCapability","vs/platform/terminal/common/capabilities/cwdDetectionCapability","vs/platform/terminal/common/capabilities/partialCommandDetectionCapability","vs/platform/terminal/common/capabilities/terminalCapabilityStore","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalAutoResponder","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalProcess","vs/platform/terminal/common/terminalStrings","vs/platform/terminal/common/xterm/shellIntegrationAddon","vs/platform/terminal/node/heartbeatService","vs/platform/terminal/node/windowsShellHelper","vs/platform/terminal/node/terminalProcess","vs/platform/terminal/node/ptyService","util","minimist","node-pty","vs/base/common/performance","@xterm/headless","vs/platform/terminal/node/ptyHostMain"],fe=function(ie){for(var e=[],o=0,t=ie.length;o<t;o++)e[o]=he[ie[o]];return e};define(he[44],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=void 0,e.$jb=o,e.$kb=t,e.$lb=_,e.$mb=g,e.$nb=j,e.$ob=A,e.$pb=w,e.$rb=v,e.$sb=f,e.$tb=m,e.$ub=a,e.$vb=l;function o(c,d){const $=t(c,d);if($!==-1)return c[$]}function t(c,d,$=c.length-1){for(let s=$;s>=0;s--){const b=c[s];if(d(b))return s}return-1}function _(c,d){const $=g(c,d);return $===-1?void 0:c[$]}function g(c,d,$=0,s=c.length){let b=$,E=s;for(;b<E;){const P=Math.floor((b+E)/2);d(c[P])?b=P+1:E=P}return b-1}function j(c,d){const $=A(c,d);return $===c.length?void 0:c[$]}function A(c,d,$=0,s=c.length){let b=$,E=s;for(;b<E;){const P=Math.floor((b+E)/2);d(c[P])?E=P:b=P+1}return b}function w(c,d,$=0,s=c.length){const b=A(c,d,$,s);return b===c.length?-1:b}class r{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(r.assertInvariants){if(this.d){for(const s of this.e)if(this.d(s)&&!d(s))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const $=g(this.e,d,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$qb=r;function v(c,d){if(c.length===0)return;let $=c[0];for(let s=1;s<c.length;s++){const b=c[s];d(b,$)>0&&($=b)}return $}function f(c,d){if(c.length===0)return;let $=c[0];for(let s=1;s<c.length;s++){const b=c[s];d(b,$)>=0&&($=b)}return $}function m(c,d){return v(c,($,s)=>-d($,s))}function a(c,d){if(c.length===0)return-1;let $=0;for(let s=1;s<c.length;s++){const b=c[s];d(b,c[$])>0&&($=s)}return $}function l(c,d){for(const $ of c){const s=d($);if(s!==void 0)return s}}}),define(he[13],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var o;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(o||(e.CharCode=o={}))}),define(he[45],fe([0,1]),function(ie,e){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$i=void 0,e.$e=t,e.$f=_,e.$g=g,e.$h=j;function t(w,r){const v=Object.create(null);for(const f of w){const m=r(f);let a=v[m];a||(a=v[m]=[]),a.push(f)}return v}function _(w,r){const v=[],f=[];for(const m of w)r.has(m)||v.push(m);for(const m of r)w.has(m)||f.push(m);return{removed:v,added:f}}function g(w,r){const v=[],f=[];for(const[m,a]of w)r.has(m)||v.push(a);for(const[m,a]of r)w.has(m)||f.push(a);return{removed:v,added:f}}function j(w,r){const v=new Set;for(const f of r)w.has(f)&&v.add(f);return v}class A{static{o=Symbol.toStringTag}constructor(r,v){this.b=v,this.a=new Map,this[o]="SetWithKey";for(const f of r)this.add(f)}get size(){return this.a.size}add(r){const v=this.b(r);return this.a.set(v,r),this}delete(r){return this.a.delete(this.b(r))}has(r){return this.a.has(this.b(r))}*entries(){for(const r of this.a.values())yield[r,r]}keys(){return this.values()}*values(){for(const r of this.a.values())yield r}clear(){this.a.clear()}forEach(r,v){this.a.forEach(f=>r.call(v,f,f,this))}[Symbol.iterator](){return this.values()}}e.$i=A}),define(he[14],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=t,e.$di=_,e.$ei=g;function o(j){return(A,w,r)=>{let v=null,f=null;if(typeof r.value=="function"?(v="value",f=r.value):typeof r.get=="function"&&(v="get",f=r.get),!f)throw new Error("not supported");r[v]=j(f,w)}}function t(j,A,w){let r=null,v=null;if(typeof w.value=="function"?(r="value",v=w.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(r="get",v=w.get),!v)throw new Error("not supported");const f=`$memoize$${A}`;w[r]=function(...m){return this.hasOwnProperty(f)||Object.defineProperty(this,f,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,m)}),this[f]}}function _(j,A,w){return o((r,v)=>{const f=`$debounce$${v}`,m=`$debounce$result$${v}`;return function(...a){this[m]||(this[m]=w?w():void 0),clearTimeout(this[f]),A&&(this[m]=A(this[m],...a),a=[this[m]]),this[f]=setTimeout(()=>{r.apply(this,a),this[m]=w?w():void 0},j)}})}function g(j,A,w){return o((r,v)=>{const f=`$throttle$timer$${v}`,m=`$throttle$result$${v}`,a=`$throttle$lastRun$${v}`,l=`$throttle$pending$${v}`;return function(...c){if(this[m]||(this[m]=w?w():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),A&&(this[m]=A(this[m],...c)),this[l])return;const d=this[a]+j;d<=Date.now()?(this[a]=Date.now(),r.apply(this,[this[m]]),this[m]=w?w():void 0):(this[l]=!0,this[f]=setTimeout(()=>{this[l]=!1,this[a]=Date.now(),r.apply(this,[this[m]]),this[m]=w?w():void 0},d-Date.now()))}})}}),define(he[7],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=e.$fb=e.$eb=e.$db=e.$cb=e.$ab=e.$9=e.$1=e.$Z=void 0,e.setUnexpectedErrorHandler=t,e.$3=_,e.$4=g,e.$5=j,e.$6=A,e.$7=w,e.$8=v,e.$0=m,e.$$=a,e.$_=l,e.$bb=d;class o{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?E.isErrorNoTelemetry(n)?new E(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(h=>{h(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$Z=o,e.$1=new o;function t(i){e.$1.setUnexpectedErrorHandler(i)}function _(i){if(!i||typeof i!="object")return!1;const n=i;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function g(i){v(i)||e.$1.onUnexpectedError(i)}function j(i){v(i)||e.$1.onUnexpectedExternalError(i)}function A(i){if(i instanceof Error){const{name:n,message:h}=i,R=i.stacktrace||i.stack;return{$isError:!0,name:n,message:h,stack:R,noTelemetry:E.isErrorNoTelemetry(i)}}return i}function w(i){let n;return i.noTelemetry?n=new E:(n=new Error,n.name=i.name),n.message=i.message,n.stack=i.stack,n}const r="Canceled";function v(i){return i instanceof f?!0:i instanceof Error&&i.name===r&&i.message===r}class f extends Error{constructor(){super(r),this.name=this.message}}e.$9=f;function m(){const i=new Error(r);return i.name=i.message,i}function a(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function l(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class c extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$ab=c;function d(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class $ extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$cb=$;class s extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$db=s;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$eb=b;class E extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof E)return n;const h=new E;return h.message=n.message,h.stack=n.stack,h}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$fb=E;class P extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,P.prototype)}}e.$gb=P}),define(he[17],fe([0,1,7,44]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.$cc=e.$ac=e.$_b=e.CompareResult=void 0,e.$wb=_,e.$xb=g,e.$yb=j,e.$zb=A,e.$Ab=w,e.$Bb=r,e.$Cb=v,e.$Db=f,e.$Eb=m,e.$Fb=a,e.$Gb=l,e.$Hb=c,e.$Ib=d,e.top=$,e.$Kb=s,e.$Lb=E,e.$Mb=P,e.$Nb=i,e.$Ob=n,e.$Pb=h,e.$Qb=R,e.$Rb=W,e.$Sb=p,e.$Tb=L,e.$Ub=k,e.$Vb=M,e.$Wb=C,e.$Xb=D,e.$Yb=y,e.$Zb=T,e.$1b=I,e.$2b=S,e.$3b=F,e.$4b=J,e.$5b=V,e.$6b=Q,e.$7b=re,e.$8b=ae,e.$9b=X,e.$0b=ee,e.$$b=le,e.$bc=de,e.$fc=oe;function _(N,K=0){return N[N.length-(1+K)]}function g(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}function j(N,K,U=(O,G)=>O===G){if(N===K)return!0;if(!N||!K||N.length!==K.length)return!1;for(let O=0,G=N.length;O<G;O++)if(!U(N[O],K[O]))return!1;return!0}function A(N,K){const U=N.length-1;K<U&&(N[K]=N[U]),N.pop()}function w(N,K,U){return r(N.length,O=>U(N[O],K))}function r(N,K){let U=0,O=N-1;for(;U<=O;){const G=(U+O)/2|0,x=K(G);if(x<0)U=G+1;else if(x>0)O=G-1;else return G}return-(U+1)}function v(N,K,U){if(N=N|0,N>=K.length)throw new TypeError("invalid index");const O=K[Math.floor(K.length*Math.random())],G=[],x=[],ne=[];for(const $e of K){const ve=U($e,O);ve<0?G.push($e):ve>0?x.push($e):ne.push($e)}return N<G.length?v(N,G,U):N<G.length+ne.length?ne[0]:v(N-(G.length+ne.length),x,U)}function f(N,K){const U=[];let O;for(const G of N.slice(0).sort(K))!O||K(O[0],G)!==0?(O=[G],U.push(O)):O.push(G);return U}function*m(N,K){let U,O;for(const G of N)O!==void 0&&K(O,G)?U.push(G):(U&&(yield U),U=[G]),O=G;U&&(yield U)}function a(N,K){for(let U=0;U<=N.length;U++)K(U===0?void 0:N[U-1],U===N.length?void 0:N[U])}function l(N,K){for(let U=0;U<N.length;U++)K(U===0?void 0:N[U-1],N[U],U+1===N.length?void 0:N[U+1])}function c(N,K,U){const O=[];function G($e,ve,Se){if(ve===0&&Se.length===0)return;const Ie=O[O.length-1];Ie&&Ie.start+Ie.deleteCount===$e?(Ie.deleteCount+=ve,Ie.toInsert.push(...Se)):O.push({start:$e,deleteCount:ve,toInsert:Se})}let x=0,ne=0;for(;;){if(x===N.length){G(x,0,K.slice(ne));break}if(ne===K.length){G(x,N.length-x,[]);break}const $e=N[x],ve=K[ne],Se=U($e,ve);Se===0?(x+=1,ne+=1):Se<0?(G(x,1,[]),x+=1):Se>0&&(G(x,0,[ve]),ne+=1)}return O}function d(N,K,U){const O=c(N,K,U),G=[],x=[];for(const ne of O)G.push(...N.slice(ne.start,ne.start+ne.deleteCount)),x.push(...ne.toInsert);return{removed:G,added:x}}function $(N,K,U){if(U===0)return[];const O=N.slice(0,U).sort(K);return b(N,K,O,U,N.length),O}function s(N,K,U,O,G){return U===0?Promise.resolve([]):new Promise((x,ne)=>{(async()=>{const $e=N.length,ve=N.slice(0,U).sort(K);for(let Se=U,Ie=Math.min(U+O,$e);Se<$e;Se=Ie,Ie=Math.min(Ie+O,$e)){if(Se>U&&await new Promise(we=>setTimeout(we)),G&&G.isCancellationRequested)throw new o.$9;b(N,K,ve,Se,Ie)}return ve})().then(x,ne)})}function b(N,K,U,O,G){for(const x=U.length;O<G;O++){const ne=N[O];if(K(ne,U[x-1])<0){U.pop();const $e=(0,t.$ob)(U,ve=>K(ne,ve)<0);U.splice($e,0,ne)}}}function E(N){return N.filter(K=>!!K)}function P(N){let K=0;for(let U=0;U<N.length;U++)N[U]&&(N[K]=N[U],K+=1);N.length=K}function i(N,K,U){N.splice(U,0,N.splice(K,1)[0])}function n(N){return!Array.isArray(N)||N.length===0}function h(N){return Array.isArray(N)&&N.length>0}function R(N,K=U=>U){const U=new Set;return N.filter(O=>{const G=K(O);return U.has(G)?!1:(U.add(G),!0)})}function W(N){const K=new Set;return U=>{const O=N(U);return K.has(O)?!1:(K.add(O),!0)}}function p(N,K){return N.length>0?N[0]:K}function L(N,K){return N.length>0?N[N.length-1]:K}function k(N,K,U=(O,G)=>O===G){let O=0;for(let G=0,x=Math.min(N.length,K.length);G<x&&U(N[G],K[G]);G++)O++;return O}function M(N,K){let U=typeof K=="number"?N:0;typeof K=="number"?U=N:(U=0,K=N);const O=[];if(U<=K)for(let G=U;G<K;G++)O.push(G);else for(let G=U;G>K;G--)O.push(G);return O}function C(N,K,U){return N.reduce((O,G)=>(O[K(G)]=U?U(G):G,O),Object.create(null))}function D(N,K){return N.push(K),()=>y(N,K)}function y(N,K){const U=N.indexOf(K);if(U>-1)return N.splice(U,1),K}function T(N,K,U){const O=N.slice(0,K),G=N.slice(K);return O.concat(U,G)}function I(N,K){let U;if(typeof K=="number"){let O=K;U=()=>{const G=Math.sin(O++)*179426549;return G-Math.floor(G)}}else U=Math.random;for(let O=N.length-1;O>0;O-=1){const G=Math.floor(U()*(O+1)),x=N[O];N[O]=N[G],N[G]=x}}function S(N,K){const U=N.indexOf(K);U>-1&&(N.splice(U,1),N.unshift(K))}function F(N,K){const U=N.indexOf(K);U>-1&&(N.splice(U,1),N.push(K))}function J(N,K){for(const U of K)N.push(U)}function V(N,K){return Array.isArray(N)?N.map(K):K(N)}function Q(N){return Array.isArray(N)?N:[N]}function re(N){return N[Math.floor(Math.random()*N.length)]}function ae(N,K,U){const O=B(N,K),G=N.length,x=U.length;N.length=G+x;for(let ne=G-1;ne>=O;ne--)N[ne+x]=N[ne];for(let ne=0;ne<x;ne++)N[ne+O]=U[ne]}function X(N,K,U,O){const G=B(N,K);let x=N.splice(G,U);return x===void 0&&(x=[]),ae(N,G,O),x}function B(N,K){return K<0?Math.max(K+N.length,0):Math.min(K,N.length)}var Z;(function(N){function K(x){return x<0}N.isLessThan=K;function U(x){return x<=0}N.isLessThanOrEqual=U;function O(x){return x>0}N.isGreaterThan=O;function G(x){return x===0}N.isNeitherLessOrGreaterThan=G,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(Z||(e.CompareResult=Z={}));function ee(N,K){return(U,O)=>K(N(U),N(O))}function le(...N){return(K,U)=>{for(const O of N){const G=O(K,U);if(!Z.isNeitherLessOrGreaterThan(G))return G}return Z.neitherLessOrGreaterThan}}const q=(N,K)=>N-K;e.$_b=q;const ce=(N,K)=>(0,e.$_b)(N?1:0,K?1:0);e.$ac=ce;function de(N){return(K,U)=>-N(K,U)}class te{constructor(K){this.g=K,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(K){let U=this.c;for(;U<this.g.length&&K(this.g[U]);)U++;const O=U===this.c?null:this.g.slice(this.c,U);return this.c=U,O}takeFromEndWhile(K){let U=this.d;for(;U>=0&&K(this.g[U]);)U--;const O=U===this.d?null:this.g.slice(U+1,this.d+1);return this.d=U,O}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const K=this.g[this.c];return this.c++,K}removeLast(){const K=this.g[this.d];return this.d--,K}takeCount(K){const U=this.g.slice(this.c,this.c+K);return this.c+=K,U}}e.$cc=te;class u{static{this.empty=new u(K=>{})}constructor(K){this.iterate=K}forEach(K){this.iterate(U=>(K(U),!0))}toArray(){const K=[];return this.iterate(U=>(K.push(U),!0)),K}filter(K){return new u(U=>this.iterate(O=>K(O)?U(O):!0))}map(K){return new u(U=>this.iterate(O=>U(K(O))))}some(K){let U=!1;return this.iterate(O=>(U=K(O),!U)),U}findFirst(K){let U;return this.iterate(O=>K(O)?(U=O,!1):!0),U}findLast(K){let U;return this.iterate(O=>(K(O)&&(U=O),!0)),U}findLastMaxBy(K){let U,O=!0;return this.iterate(G=>((O||Z.isGreaterThan(K(G,U)))&&(O=!1,U=G),!0)),U}}e.$dc=u;class H{constructor(K){this.c=K}static createSortPermutation(K,U){const O=Array.from(K.keys()).sort((G,x)=>U(K[G],K[x]));return new H(O)}apply(K){return K.map((U,O)=>K[this.c[O]])}inverse(){const K=this.c.slice();for(let U=0;U<this.c.length;U++)K[this.c[U]]=U;return new H(K)}}e.$ec=H;async function oe(N,K){return(await Promise.all(N.map(async(O,G)=>({element:O,ok:await K(O,G)})))).find(O=>O.ok)?.element}}),define(he[46],fe([0,1,7]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=t,e.$jd=_,e.$kd=g,e.$ld=j,e.$md=A,e.$nd=w;function t(r,v){if(!r)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}function _(r,v="Unreachable"){throw new Error(v)}function g(r,v="unexpected state"){if(!r)throw new o.$gb(`Assertion Failed: ${v}`)}function j(r){r||(0,o.$4)(new o.$gb("Soft Assertion Failed"))}function A(r){if(!r()){debugger;r(),(0,o.$4)(new o.$gb("Assertion Failed"))}}function w(r,v){let f=0;for(;f<r.length-1;){const m=r[f],a=r[f+1];if(!v(m,a))return!1;f++}return!0}}),define(he[31],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hb=o;function o(t,_){const g=this;let j=!1,A;return function(){if(j)return A;if(j=!0,_)try{A=t.apply(g,arguments)}finally{_()}else A=t.apply(g,arguments);return A}}}),define(he[47],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var o;(function(t){function _(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}t.is=_;const g=Object.freeze([]);function j(){return g}t.empty=j;function*A(n){yield n}t.single=A;function w(n){return _(n)?n:A(n)}t.wrap=w;function r(n){return n||g}t.from=r;function*v(n){for(let h=n.length-1;h>=0;h--)yield n[h]}t.reverse=v;function f(n){return!n||n[Symbol.iterator]().next().done===!0}t.isEmpty=f;function m(n){return n[Symbol.iterator]().next().value}t.first=m;function a(n,h){let R=0;for(const W of n)if(h(W,R++))return!0;return!1}t.some=a;function l(n,h){for(const R of n)if(h(R))return R}t.find=l;function*c(n,h){for(const R of n)h(R)&&(yield R)}t.filter=c;function*d(n,h){let R=0;for(const W of n)yield h(W,R++)}t.map=d;function*$(n,h){let R=0;for(const W of n)yield*h(W,R++)}t.flatMap=$;function*s(...n){for(const h of n)yield*h}t.concat=s;function b(n,h,R){let W=R;for(const p of n)W=h(W,p);return W}t.reduce=b;function*E(n,h,R=n.length){for(h<0&&(h+=n.length),R<0?R+=n.length:R>n.length&&(R=n.length);h<R;h++)yield n[h]}t.slice=E;function P(n,h=Number.POSITIVE_INFINITY){const R=[];if(h===0)return[R,n];const W=n[Symbol.iterator]();for(let p=0;p<h;p++){const L=W.next();if(L.done)return[R,t.empty()];R.push(L.value)}return[R,{[Symbol.iterator](){return W}}]}t.consume=P;async function i(n){const h=[];for await(const R of n)h.push(R);return Promise.resolve(h)}t.asyncToArray=i})(o||(e.Iterable=o={}))}),define(he[24],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y=void 0;class o{constructor(_){this.d=_,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(_){this.c=_}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$Y=o}),define(he[48],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=void 0;class o{static{this.Undefined=new o(void 0)}constructor(g){this.element=g,this.next=o.Undefined,this.prev=o.Undefined}}class t{constructor(){this.a=o.Undefined,this.b=o.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===o.Undefined}clear(){let g=this.a;for(;g!==o.Undefined;){const j=g.next;g.prev=o.Undefined,g.next=o.Undefined,g=j}this.a=o.Undefined,this.b=o.Undefined,this.c=0}unshift(g){return this.d(g,!1)}push(g){return this.d(g,!0)}d(g,j){const A=new o(g);if(this.a===o.Undefined)this.a=A,this.b=A;else if(j){const r=this.b;this.b=A,A.prev=r,r.next=A}else{const r=this.a;this.a=A,A.next=r,r.prev=A}this.c+=1;let w=!1;return()=>{w||(w=!0,this.e(A))}}shift(){if(this.a!==o.Undefined){const g=this.a.element;return this.e(this.a),g}}pop(){if(this.b!==o.Undefined){const g=this.b.element;return this.e(this.b),g}}e(g){if(g.prev!==o.Undefined&&g.next!==o.Undefined){const j=g.prev;j.next=g.next,g.next.prev=j}else g.prev===o.Undefined&&g.next===o.Undefined?(this.a=o.Undefined,this.b=o.Undefined):g.next===o.Undefined?(this.b=this.b.prev,this.b.next=o.Undefined):g.prev===o.Undefined&&(this.a=this.a.next,this.a.prev=o.Undefined);this.c-=1}*[Symbol.iterator](){let g=this.a;for(;g!==o.Undefined;)yield g.element,g=g.next}}e.$0c=t}),define(he[26],fe([0,1]),function(ie,e){"use strict";var o,t,_;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.Touch=e.$Gc=e.$Fc=void 0,e.$Cc=g,e.$Dc=j,e.$Ec=A,e.$Nc=E;function g(P,i,n){let h=P.get(i);return h===void 0&&(h=n,P.set(i,h)),h}function j(P){const i=[];return P.forEach((n,h)=>{i.push(`${h} => ${n}`)}),`Map(${P.size}) {${i.join(", ")}}`}function A(P){const i=[];return P.forEach(n=>{i.push(n)}),`Set(${P.size}) {${i.join(", ")}}`}class w{constructor(i,n){this.uri=i,this.value=n}}function r(P){return Array.isArray(P)}class v{static{this.c=i=>i.toString()}constructor(i,n){if(this[o]="ResourceMap",i instanceof v)this.d=new Map(i.d),this.e=n??v.c;else if(r(i)){this.d=new Map,this.e=n??v.c;for(const[h,R]of i)this.set(h,R)}else this.d=new Map,this.e=i??v.c}set(i,n){return this.d.set(this.e(i),new w(i,n)),this}get(i){return this.d.get(this.e(i))?.value}has(i){return this.d.has(this.e(i))}get size(){return this.d.size}clear(){this.d.clear()}delete(i){return this.d.delete(this.e(i))}forEach(i,n){typeof n<"u"&&(i=i.bind(n));for(const[h,R]of this.d)i(R.value,R.uri,this)}*values(){for(const i of this.d.values())yield i.value}*keys(){for(const i of this.d.values())yield i.uri}*entries(){for(const i of this.d.values())yield[i.uri,i.value]}*[(o=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.d)yield[i.uri,i.value]}}e.$Fc=v;class f{constructor(i,n){this[t]="ResourceSet",!i||typeof i=="function"?this.c=new v(i):(this.c=new v(n),i.forEach(this.add,this))}get size(){return this.c.size}add(i){return this.c.set(i,i),this}clear(){this.c.clear()}delete(i){return this.c.delete(i)}forEach(i,n){this.c.forEach((h,R)=>i.call(n,R,R,this))}has(i){return this.c.has(i)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Gc=f;var m;(function(P){P[P.None=0]="None",P[P.AsOld=1]="AsOld",P[P.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class a{constructor(){this[_]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(i){return this.c.has(i)}get(i,n=m.None){const h=this.c.get(i);if(h)return n!==m.None&&this.m(h,n),h.value}set(i,n,h=m.None){let R=this.c.get(i);if(R)R.value=n,h!==m.None&&this.m(R,h);else{switch(R={key:i,value:n,next:void 0,previous:void 0},h){case m.None:this.k(R);break;case m.AsOld:this.j(R);break;case m.AsNew:this.k(R);break;default:this.k(R);break}this.c.set(i,R),this.f++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this.c.get(i);if(n)return this.c.delete(i),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const i=this.d;return this.c.delete(i.key),this.l(i),this.f--,i.value}forEach(i,n){const h=this.g;let R=this.d;for(;R;){if(n?i.bind(n)(R.value,R.key,this):i(R.value,R.key,this),this.g!==h)throw new Error("LinkedMap got modified during iteration.");R=R.next}}keys(){const i=this,n=this.g;let h=this.d;const R={[Symbol.iterator](){return R},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(h){const W={value:h.key,done:!1};return h=h.next,W}else return{value:void 0,done:!0}}};return R}values(){const i=this,n=this.g;let h=this.d;const R={[Symbol.iterator](){return R},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(h){const W={value:h.value,done:!1};return h=h.next,W}else return{value:void 0,done:!0}}};return R}entries(){const i=this,n=this.g;let h=this.d;const R={[Symbol.iterator](){return R},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(h){const W={value:[h.key,h.value],done:!1};return h=h.next,W}else return{value:void 0,done:!0}}};return R}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this.d,h=this.size;for(;n&&h>i;)this.c.delete(n.key),n=n.next,h--;this.d=n,this.f=h,n&&(n.previous=void 0),this.g++}i(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this.e,h=this.size;for(;n&&h>i;)this.c.delete(n.key),n=n.previous,h--;this.e=n,this.f=h,n&&(n.next=void 0),this.g++}j(i){if(!this.d&&!this.e)this.e=i;else if(this.d)i.next=this.d,this.d.previous=i;else throw new Error("Invalid list");this.d=i,this.g++}k(i){if(!this.d&&!this.e)this.d=i;else if(this.e)i.previous=this.e,this.e.next=i;else throw new Error("Invalid list");this.e=i,this.g++}l(i){if(i===this.d&&i===this.e)this.d=void 0,this.e=void 0;else if(i===this.d){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.d=i.next}else if(i===this.e){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.e=i.previous}else{const n=i.next,h=i.previous;if(!n||!h)throw new Error("Invalid list");n.previous=h,h.next=n}i.next=void 0,i.previous=void 0,this.g++}m(i,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==m.AsOld&&n!==m.AsNew)){if(n===m.AsOld){if(i===this.d)return;const h=i.next,R=i.previous;i===this.e?(R.next=void 0,this.e=R):(h.previous=R,R.next=h),i.previous=void 0,i.next=this.d,this.d.previous=i,this.d=i,this.g++}else if(n===m.AsNew){if(i===this.e)return;const h=i.next,R=i.previous;i===this.d?(h.previous=void 0,this.d=h):(h.previous=R,R.next=h),i.next=void 0,i.previous=this.e,this.e.next=i,this.e=i,this.g++}}}toJSON(){const i=[];return this.forEach((n,h)=>{i.push([h,n])}),i}fromJSON(i){this.clear();for(const[n,h]of i)this.set(n,h)}}e.$Hc=a;class l extends a{constructor(i,n=1){super(),this.n=i,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(i){this.n=i,this.p()}get ratio(){return this.o}set ratio(i){this.o=Math.min(Math.max(0,i),1),this.p()}get(i,n=m.AsNew){return super.get(i,n)}peek(i){return super.get(i,m.None)}set(i,n){return super.set(i,n,m.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class c extends l{constructor(i,n=1){super(i,n)}q(i){this.h(i)}set(i,n){return super.set(i,n),this.p(),this}}e.$Ic=c;class d extends l{constructor(i,n=1){super(i,n)}q(i){this.i(i)}set(i,n){return this.n<=this.size&&!this.has(i)&&this.q(Math.round(this.n*this.o)-1),super.set(i,n),this}}e.$Jc=d;class ${constructor(){this.c=new Map}add(i){return this.c.set(i,(this.c.get(i)||0)+1),this}delete(i){let n=this.c.get(i)||0;return n===0?!1:(n--,n===0?this.c.delete(i):this.c.set(i,n),!0)}has(i){return this.c.has(i)}}e.$Kc=$;class s{constructor(i){if(this.c=new Map,this.d=new Map,i)for(const[n,h]of i)this.set(n,h)}clear(){this.c.clear(),this.d.clear()}set(i,n){this.c.set(i,n),this.d.set(n,i)}get(i){return this.c.get(i)}getKey(i){return this.d.get(i)}delete(i){const n=this.c.get(i);return n===void 0?!1:(this.c.delete(i),this.d.delete(n),!0)}forEach(i,n){this.c.forEach((h,R)=>{i.call(n,h,R,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Lc=s;class b{constructor(){this.c=new Map}add(i,n){let h=this.c.get(i);h||(h=new Set,this.c.set(i,h)),h.add(n)}delete(i,n){const h=this.c.get(i);h&&(h.delete(n),h.size===0&&this.c.delete(i))}forEach(i,n){const h=this.c.get(i);h&&h.forEach(n)}get(i){const n=this.c.get(i);return n||new Set}}e.$Mc=b;function E(P,i){if(P===i)return!0;if(P.size!==i.size)return!1;for(const[n,h]of P)if(!i.has(n)||i.get(n)!==h)return!1;for(const[n]of i)if(!P.has(n))return!1;return!0}}),define(he[2],fe([0,1,17,45,26,31,47]),function(ie,e,o,t,_,g,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$7c=e.$6c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Oc=void 0,e.$Pc=v,e.$Qc=f,e.$Rc=m,e.$Sc=c,e.$Tc=d,e.$Uc=$,e.$Vc=s,e.$Wc=b,e.$Xc=E,e.$8c=M;const A=!1;let w=null;class r{constructor(){this.b=new Map}static{this.a=0}c(y){let T=this.b.get(y);return T||(T={parent:null,source:null,isSingleton:!1,value:y,idx:r.a++},this.b.set(y,T)),T}trackDisposable(y){const T=this.c(y);T.source||(T.source=new Error().stack)}setParent(y,T){const I=this.c(y);I.parent=T}markAsDisposed(y){this.b.delete(y)}markAsSingleton(y){this.c(y).isSingleton=!0}f(y,T){const I=T.get(y);if(I)return I;const S=y.parent?this.f(this.c(y.parent),T):y;return T.set(y,S),S}getTrackedDisposables(){const y=new Map;return[...this.b.entries()].filter(([,I])=>I.source!==null&&!this.f(I,y).isSingleton).flatMap(([I])=>I)}computeLeakingDisposables(y=10,T){let I;if(T)I=T;else{const Q=new Map,re=[...this.b.values()].filter(X=>X.source!==null&&!this.f(X,Q).isSingleton);if(re.length===0)return;const ae=new Set(re.map(X=>X.value));if(I=re.filter(X=>!(X.parent&&ae.has(X.parent))),I.length===0)throw new Error("There are cyclic diposable chains!")}if(!I)return;function S(Q){function re(X,B){for(;X.length>0&&B.some(Z=>typeof Z=="string"?Z===X[0]:X[0].match(Z));)X.shift()}const ae=Q.source.split(`
`).map(X=>X.trim().replace("at ","")).filter(X=>X!=="");return re(ae,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ae.reverse()}const F=new _.$Mc;for(const Q of I){const re=S(Q);for(let ae=0;ae<=re.length;ae++)F.add(re.slice(0,ae).join(`
`),Q)}I.sort((0,o.$0b)(Q=>Q.idx,o.$_b));let J="",V=0;for(const Q of I.slice(0,y)){V++;const re=S(Q),ae=[];for(let X=0;X<re.length;X++){let B=re[X];B=`(shared with ${F.get(re.slice(0,X+1).join(`
`)).size}/${I.length} leaks) at ${B}`;const ee=F.get(re.slice(0,X).join(`
`)),le=(0,t.$e)([...ee].map(q=>S(q)[X]),q=>q);delete le[re[X]];for(const[q,ce]of Object.entries(le))ae.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${q}`);ae.unshift(B)}J+=`


==================== Leaking disposable ${V}/${I.length}: ${Q.value.constructor.name} ====================
${ae.join(`
`)}
============================================================

`}return I.length>y&&(J+=`


... and ${I.length-y} more leaking disposables

`),{leaks:I,details:J}}}e.$Oc=r;function v(D){w=D}if(A){const D="__is_disposable_tracked__";v(new class{trackDisposable(y){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{y[D]||console.log(T)},3e3)}setParent(y,T){if(y&&y!==i.None)try{y[D]=!0}catch{}}markAsDisposed(y){if(y&&y!==i.None)try{y[D]=!0}catch{}}markAsSingleton(y){}})}function f(D){return w?.trackDisposable(D),D}function m(D){w?.markAsDisposed(D)}function a(D,y){w?.setParent(D,y)}function l(D,y){if(w)for(const T of D)w.setParent(T,y)}function c(D){return w?.markAsSingleton(D),D}function d(D){return typeof D=="object"&&D!==null&&typeof D.dispose=="function"&&D.dispose.length===0}function $(D){if(j.Iterable.is(D)){const y=[];for(const T of D)if(T)try{T.dispose()}catch(I){y.push(I)}if(y.length===1)throw y[0];if(y.length>1)throw new AggregateError(y,"Encountered errors while disposing of store");return Array.isArray(D)?[]:D}else if(D)return D.dispose(),D}function s(D){for(const y of D)d(y)&&y.dispose();return[]}function b(...D){const y=E(()=>$(D));return l(D,y),y}function E(D){const y=f({dispose:(0,g.$hb)(()=>{m(y),D()})});return y}class P{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,f(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(y){if(!y)return y;if(y===this)throw new Error("Cannot register a disposable on itself!");return a(y,this),this.g?P.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(y),y}delete(y){if(y){if(y===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(y),y.dispose()}}deleteAndLeak(y){y&&this.f.has(y)&&(this.f.delete(y),a(y,null))}}e.$Yc=P;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new P,f(this),a(this.q,this)}dispose(){m(this),this.q.dispose()}B(y){if(y===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(y)}}e.$Zc=i;class n{constructor(){this.b=!1,f(this)}get value(){return this.b?void 0:this.a}set value(y){this.b||y===this.a||(this.a?.dispose(),y&&a(y,this),this.a=y)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const y=this.a;return this.a=void 0,y&&a(y,null),y}}e.$1c=n;class h{constructor(y){this.a=new n,this.b=!1,this.a.value=y}get value(){return this.a.value}set value(y){this.b||y===this.a.value||(this.a.value=y)}dispose(){this.b=!0,this.a.dispose()}}e.$2c=h;class R{constructor(y){this.b=y,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$3c=R;class W{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,f(this)}set(y){let T=y;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,m(this))},this}}e.$4c=W;class p{constructor(){this.a=new Map}acquire(y,...T){let I=this.a.get(y);I||(I={counter:0,object:this.b(y,...T)},this.a.set(y,I));const{object:S}=I,F=(0,g.$hb)(()=>{--I.counter===0&&(this.c(y,I.object),this.a.delete(y))});return I.counter++,{object:S,dispose:F}}}e.$5c=p;class L{constructor(y){this.a=y}async acquire(y,...T){const I=this.a.acquire(y,...T);try{return{object:await I.object,dispose:()=>I.dispose()}}catch(S){throw I.dispose(),S}}}e.$6c=L;class k{constructor(y){this.object=y}dispose(){}}e.$7c=k;function M(D){const y=new P;try{D(y)}finally{y.dispose()}}class C{constructor(){this.a=new Map,this.b=!1,f(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(y){return this.a.has(y)}get size(){return this.a.size}get(y){return this.a.get(y)}set(y,T,I=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),I||this.a.get(y)?.dispose(),this.a.set(y,T)}deleteAndDispose(y){this.a.get(y)?.dispose(),this.a.delete(y)}deleteAndLeak(y){const T=this.a.get(y);return this.a.delete(y),T}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$9c=C}),define(he[27],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var o;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(o||(e.MarshalledId=o={}))}),define(he[49],fe([0,1,26]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=void 0,e.$sm=_,e.$tm=j;const t=new o.$Ic(1e4);function _(r){return w(r,"NFC",t)}const g=new o.$Ic(1e4);function j(r){return w(r,"NFD",g)}const A=/[^\u0000-\u0080]/;function w(r,v,f){if(!r)return r;const m=f.get(r);if(m)return m;let a;return A.test(r)?a=r.normalize(v):a=r,f.set(r,a),a}e.$um=function(){const r=/[\u0300-\u036f]/g;return function(v){return j(v).replace(r,"")}}()}),function(){function ie(_){const g=[];typeof _=="number"&&g.push("code/timeOrigin",_);function j(w){g.push(w,Date.now())}function A(){const w=[];for(let r=0;r<g.length;r+=2)w.push({name:g[r],startTime:g[r+1]});return w}return{mark:j,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(_){performance.mark(_)},getMarks(){let _=performance.timeOrigin;typeof _!="number"&&(_=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const g=[{name:"code/timeOrigin",startTime:Math.round(_)}];for(const j of performance.getEntriesByType("mark"))g.push({name:j.name,startTime:Math.round(_+j.startTime)});return g}};if(typeof process=="object"){const _=performance?.timeOrigin;return ie(_)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function o(_){return _.MonacoPerformanceMarks||(_.MonacoPerformanceMarks=e()),_.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=o(t))}(),define(he[50],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=void 0;const o=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(g){return new t(g)}constructor(g){this.c=o&&g===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ke=t}),define(he[4],fe([0,1,7,31,2,48,50]),function(ie,e,o,t,_,g,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$me=e.Event=void 0,e.$ne=a;const A=!1,w=!1,r=!1;var v;(function(S){S.None=()=>_.$Zc.None;function F(we){if(r){const{onDidAddListener:ge}=we,pe=c.create();let be=0;we.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),pe.print()),ge?.()}}}function J(we,ge){return ce(we,()=>{},0,void 0,!0,void 0,ge)}S.defer=J;function V(we){return(ge,pe=null,be)=>{let Ee=!1,_e;return _e=we(Pe=>{if(!Ee)return _e?_e.dispose():Ee=!0,ge.call(pe,Pe)},null,be),Ee&&_e.dispose(),_e}}S.once=V;function Q(we,ge){return S.once(S.filter(we,ge))}S.onceIf=Q;function re(we,ge,pe){return le((be,Ee=null,_e)=>we(Pe=>be.call(Ee,ge(Pe)),null,_e),pe)}S.map=re;function ae(we,ge,pe){return le((be,Ee=null,_e)=>we(Pe=>{ge(Pe),be.call(Ee,Pe)},null,_e),pe)}S.forEach=ae;function X(we,ge,pe){return le((be,Ee=null,_e)=>we(Pe=>ge(Pe)&&be.call(Ee,Pe),null,_e),pe)}S.filter=X;function B(we){return we}S.signal=B;function Z(...we){return(ge,pe=null,be)=>{const Ee=(0,_.$Wc)(...we.map(_e=>_e(Pe=>ge.call(pe,Pe))));return q(Ee,be)}}S.any=Z;function ee(we,ge,pe,be){let Ee=pe;return re(we,_e=>(Ee=ge(Ee,_e),Ee),be)}S.reduce=ee;function le(we,ge){let pe;const be={onWillAddFirstListener(){pe=we(Ee.fire,Ee)},onDidRemoveLastListener(){pe?.dispose()}};ge||F(be);const Ee=new n(be);return ge?.add(Ee),Ee.event}function q(we,ge){return ge instanceof Array?ge.push(we):ge&&ge.add(we),we}function ce(we,ge,pe=100,be=!1,Ee=!1,_e,Pe){let Re,ke,Le,Te=0,ze;const Ve={leakWarningThreshold:_e,onWillAddFirstListener(){Re=we(Ye=>{Te++,ke=ge(ke,Ye),be&&!Le&&(We.fire(ke),ke=void 0),ze=()=>{const qe=ke;ke=void 0,Le=void 0,(!be||Te>1)&&We.fire(qe),Te=0},typeof pe=="number"?(clearTimeout(Le),Le=setTimeout(ze,pe)):Le===void 0&&(Le=0,queueMicrotask(ze))})},onWillRemoveListener(){Ee&&Te>0&&ze?.()},onDidRemoveLastListener(){ze=void 0,Re.dispose()}};Pe||F(Ve);const We=new n(Ve);return Pe?.add(We),We.event}S.debounce=ce;function de(we,ge=0,pe){return S.debounce(we,(be,Ee)=>be?(be.push(Ee),be):[Ee],ge,void 0,!0,void 0,pe)}S.accumulate=de;function te(we,ge=(be,Ee)=>be===Ee,pe){let be=!0,Ee;return X(we,_e=>{const Pe=be||!ge(_e,Ee);return be=!1,Ee=_e,Pe},pe)}S.latch=te;function u(we,ge,pe){return[S.filter(we,ge,pe),S.filter(we,be=>!ge(be),pe)]}S.split=u;function H(we,ge=!1,pe=[],be){let Ee=pe.slice(),_e=we(ke=>{Ee?Ee.push(ke):Re.fire(ke)});be&&be.add(_e);const Pe=()=>{Ee?.forEach(ke=>Re.fire(ke)),Ee=null},Re=new n({onWillAddFirstListener(){_e||(_e=we(ke=>Re.fire(ke)),be&&be.add(_e))},onDidAddFirstListener(){Ee&&(ge?setTimeout(Pe):Pe())},onDidRemoveLastListener(){_e&&_e.dispose(),_e=null}});return be&&be.add(Re),Re.event}S.buffer=H;function oe(we,ge){return(be,Ee,_e)=>{const Pe=ge(new K);return we(function(Re){const ke=Pe.evaluate(Re);ke!==N&&be.call(Ee,ke)},void 0,_e)}}S.chain=oe;const N=Symbol("HaltChainable");class K{constructor(){this.f=[]}map(ge){return this.f.push(ge),this}forEach(ge){return this.f.push(pe=>(ge(pe),pe)),this}filter(ge){return this.f.push(pe=>ge(pe)?pe:N),this}reduce(ge,pe){let be=pe;return this.f.push(Ee=>(be=ge(be,Ee),be)),this}latch(ge=(pe,be)=>pe===be){let pe=!0,be;return this.f.push(Ee=>{const _e=pe||!ge(Ee,be);return pe=!1,be=Ee,_e?Ee:N}),this}evaluate(ge){for(const pe of this.f)if(ge=pe(ge),ge===N)break;return ge}}function U(we,ge,pe=be=>be){const be=(...Re)=>Pe.fire(pe(...Re)),Ee=()=>we.on(ge,be),_e=()=>we.removeListener(ge,be),Pe=new n({onWillAddFirstListener:Ee,onDidRemoveLastListener:_e});return Pe.event}S.fromNodeEventEmitter=U;function O(we,ge,pe=be=>be){const be=(...Re)=>Pe.fire(pe(...Re)),Ee=()=>we.addEventListener(ge,be),_e=()=>we.removeEventListener(ge,be),Pe=new n({onWillAddFirstListener:Ee,onDidRemoveLastListener:_e});return Pe.event}S.fromDOMEventEmitter=O;function G(we){return new Promise(ge=>V(we)(ge))}S.toPromise=G;function x(we){const ge=new n;return we.then(pe=>{ge.fire(pe)},()=>{ge.fire(void 0)}).finally(()=>{ge.dispose()}),ge.event}S.fromPromise=x;function ne(we,ge){return we(pe=>ge.fire(pe))}S.forward=ne;function $e(we,ge,pe){return ge(pe),we(be=>ge(be))}S.runAndSubscribe=$e;class ve{constructor(ge,pe){this._observable=ge,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{ge.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{ge.removeObserver(this)}};pe||F(be),this.emitter=new n(be),pe&&pe.add(this.emitter)}beginUpdate(ge){this.f++}handlePossibleChange(ge){}handleChange(ge,pe){this.g=!0}endUpdate(ge){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Se(we,ge){return new ve(we,ge).emitter.event}S.fromObservable=Se;function Ie(we){return(ge,pe,be)=>{let Ee=0,_e=!1;const Pe={beginUpdate(){Ee++},endUpdate(){Ee--,Ee===0&&(we.reportChanges(),_e&&(_e=!1,ge.call(pe)))},handlePossibleChange(){},handleChange(){_e=!0}};we.addObserver(Pe),we.reportChanges();const Re={dispose(){we.removeObserver(Pe)}};return be instanceof _.$Yc?be.add(Re):Array.isArray(be)&&be.push(Re),Re}}S.fromObservableLight=Ie})(v||(e.Event=v={}));class f{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${f.f++}`,f.all.add(this)}start(F){this.g=new j.$ke,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$me=f;let m=-1;function a(S){const F=m;return m=S,{dispose(){m=F}}}class l{static{this.f=1}constructor(F,J,V=(l.f++).toString(16).padStart(3,"0")){this.j=F,this.threshold=J,this.name=V,this.h=0}dispose(){this.g?.clear()}check(F,J){const V=this.threshold;if(V<=0||J<V)return;this.g||(this.g=new Map);const Q=this.g.get(F.value)||0;if(this.g.set(F.value,Q+1),this.h-=1,this.h<=0){this.h=V*.5;const[re,ae]=this.getMostFrequentStack(),X=`[${this.name}] potential listener LEAK detected, having ${J} listeners already. MOST frequent listener (${ae}):`;console.warn(X),console.warn(re);const B=new d(X,re);this.j(B)}return()=>{const re=this.g.get(F.value)||0;this.g.set(F.value,re-1)}}getMostFrequentStack(){if(!this.g)return;let F,J=0;for(const[V,Q]of this.g)(!F||J<Q)&&(F=[V,Q],J=Q);return F}}class c{static create(){const F=new Error;return new c(F.stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d extends Error{constructor(F,J){super(F),this.name="ListenerLeakError",this.stack=J}}e.$oe=d;class $ extends Error{constructor(F,J){super(F),this.name="ListenerRefusalError",this.stack=J}}e.$pe=$;let s=0;class b{constructor(F){this.value=F,this.id=s++}}const E=2,P=(S,F)=>{if(S instanceof b)F(S);else for(let J=0;J<S.length;J++){const V=S[J];V&&F(V)}};let i;if(A){const S=[];setInterval(()=>{S.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(S.join(`
`)),S.length=0)},3e3),i=new FinalizationRegistry(F=>{typeof F=="string"&&S.push(F)})}class n{constructor(F){this.z=0,this.f=F,this.g=m>0||this.f?.leakWarningThreshold?new l(F?.onListenerError??o.$4,this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new f(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(w){const F=this.u;queueMicrotask(()=>{P(F,J=>J.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,J,V)=>{if(this.g&&this.z>this.g.threshold**2){const B=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(B);const Z=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ee=new $(`${B}. HINT: Stack shows most frequent listener (${Z[1]}-times)`,Z[0]);return(this.f?.onListenerError||o.$4)(ee),_.$Zc.None}if(this.m)return _.$Zc.None;J&&(F=F.bind(J));const Q=new b(F);let re,ae;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(Q.stack=c.create(),re=this.g.check(Q.stack,this.z+1)),w&&(Q.stack=ae??c.create()),this.u?this.u instanceof b?(this.w??=new R,this.u=[this.u,Q]):this.u.push(Q):(this.f?.onWillAddFirstListener?.(this),this.u=Q,this.f?.onDidAddFirstListener?.(this)),this.z++;const X=(0,_.$Xc)(()=>{i?.unregister(X),re?.(),this.A(Q)});if(V instanceof _.$Yc?V.add(X):Array.isArray(V)&&V.push(X),i){const B=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),Z=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(B);i.register(X,Z?.[2]??B,X)}return X},this.q}A(F){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const J=this.u,V=J.indexOf(F);if(V===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,J[V]=void 0;const Q=this.w.current===this;if(this.z*E<=J.length){let re=0;for(let ae=0;ae<J.length;ae++)J[ae]?J[re++]=J[ae]:Q&&(this.w.end--,re<this.w.i&&this.w.i--);J.length=re}}B(F,J){if(!F)return;const V=this.f?.onListenerError||o.$4;if(!V){F.value(J);return}try{F.value(J)}catch(Q){V(Q)}}C(F){const J=F.current.u;for(;F.i<F.end;)this.B(J[F.i++],F.value);F.reset()}fire(F){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof b)this.B(this.u,F);else{const J=this.w;J.enqueue(this,F,this.u.length),this.C(J)}this.j?.stop()}hasListeners(){return this.z>0}}e.$qe=n;const h=()=>new R;e.$re=h;class R{constructor(){this.i=-1,this.end=0}enqueue(F,J,V){this.i=0,this.end=V,this.current=F,this.value=J}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class W extends n{async fireAsync(F,J,V){if(this.u)for(this.h||(this.h=new g.$0c),P(this.u,Q=>this.h.push([Q.value,F]));this.h.size>0&&!J.isCancellationRequested;){const[Q,re]=this.h.shift(),ae=[],X={...re,token:J,waitUntil:B=>{if(Object.isFrozen(ae))throw new Error("waitUntil can NOT be called asynchronous");V&&(B=V(B,Q)),ae.push(B)}};try{Q(X)}catch(B){(0,o.$4)(B);continue}Object.freeze(ae),await Promise.allSettled(ae).then(B=>{for(const Z of B)Z.status==="rejected"&&(0,o.$4)(Z.reason)})}}}e.$se=W;class p extends n{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new g.$0c,this.t=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.t(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.z&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$te=p;class L extends p{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$ue=L;class k extends n{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(J=>super.fire(J)),this.h=[]}))}}e.$ve=k;class M{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const J={event:F,listener:null};this.h.push(J),this.g&&this.m(J);const V=()=>{this.g&&this.o(J);const Q=this.h.indexOf(J);this.h.splice(Q,1)};return(0,_.$Xc)((0,t.$hb)(V))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(J=>this.f.fire(J))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$we=M;class C{constructor(F,J,V,Q){this.f=new _.$Yc;const re=this.f.add(new M),ae=this.f.add(new _.$9c);function X(B){ae.set(B,re.add(Q(B)))}for(const B of F)X(B);this.f.add(J(B=>{X(B)})),this.f.add(V(B=>{ae.deleteAndDispose(B)})),this.event=re.event}dispose(){this.f.dispose()}}e.$xe=C;class D{constructor(){this.f=[]}wrapEvent(F,J,V){return(Q,re,ae)=>F(X=>{const B=this.f[this.f.length-1];if(!J){B?B.buffers.push(()=>Q.call(re,X)):Q.call(re,X);return}const Z=B;if(!Z){Q.call(re,J(V,X));return}Z.items??=[],Z.items.push(X),Z.buffers.length===0&&B.buffers.push(()=>{Z.reducedResult??=V?Z.items.reduce(J,V):Z.items.reduce(J),Q.call(re,Z.reducedResult)})},void 0,ae)}bufferEvents(F){const J={buffers:new Array};this.f.push(J);const V=F();return this.f.pop(),J.buffers.forEach(Q=>Q()),V}}e.$ye=D;class y{constructor(){this.f=!1,this.g=v.None,this.h=_.$Zc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ze=y;class T{static const(F){return new I(F)}constructor(F){this.g=F,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$Ae=T;class I{constructor(F){this.value=F,this.onDidChange=v.None}}}),define(he[18],fe([0,1,4]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.CancellationToken=void 0,e.$Ce=A;const t=Object.freeze(function(w,r){const v=setTimeout(w.bind(r),0);return{dispose(){clearTimeout(v)}}});var _;(function(w){function r(v){return v===w.None||v===w.Cancelled||v instanceof g?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}w.isCancellationToken=r,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:o.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(_||(e.CancellationToken=_={}));class g{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new o.$qe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class j{constructor(r){this.f=void 0,this.g=void 0,this.g=r&&r.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new g),this.f}cancel(){this.f?this.f instanceof g&&this.f.cancel():this.f=_.Cancelled}dispose(r=!1){r&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof g&&this.f.dispose():this.f=_.None}}e.$Be=j;function A(w){const r=new j;return w.add({dispose(){r.cancel()}}),r.token}}),define(he[51],fe([0,1,18]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ef=e.$df=e.$bf=void 0,e.$cf=_;class t{constructor(w){this.b=w,this.a=null}get(){if(this.a)return this.a;const w=new o.$Be,r=this.b(w.token);return this.a={promise:r,dispose:()=>{this.a=null,w.cancel(),w.dispose()}},this.a}}e.$bf=t;function _(A){return A}class g{constructor(w,r){this.a=void 0,this.b=void 0,typeof w=="function"?(this.c=w,this.d=_):(this.c=r,this.d=w.getCacheKey)}get(w){const r=this.d(w);return this.b!==r&&(this.b=r,this.a=this.c(w)),this.a}}e.$df=g;class j{get cachedValues(){return this.a}constructor(w,r){this.a=new Map,this.b=new Map,typeof w=="function"?(this.c=w,this.d=_):(this.c=r,this.d=w.getCacheKey)}get(w){const r=this.d(w);if(this.b.has(r))return this.b.get(r);const v=this.c(w);return this.a.set(w,v),this.b.set(r,v),v}}e.$ef=j}),define(he[52],fe([0,1,7,2]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=_,e.$Ee=g,e.$Fe=j,e.$Ge=A,e.$He=r,e.$Ie=v,e.$Je=f,e.$Ke=m,e.$Le=a,e.$Me=l,e.$Ne=c,e.$Oe=d,e.$Pe=$,e.$Qe=s,e.$Re=b;function _(E){const P=E;return P?typeof P.read=="function":!1}function g(E){const P=E;return P?[P.on,P.pause,P.resume,P.destroy].every(i=>typeof i=="function"):!1}function j(E){const P=E;return P?g(P.stream)&&Array.isArray(P.buffer)&&typeof P.ended=="boolean":!1}function A(E,P){return new w(E,P)}class w{constructor(P,i){this.e=P,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(P){if(!this.a.destroyed){if(this.a.flowing)this.g(P);else if(this.b.data.push(P),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(P){this.a.destroyed||(this.a.flowing?this.h(P):this.b.error.push(P))}end(P){this.a.destroyed||(typeof P<"u"&&this.write(P),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(P){this.c.data.slice(0).forEach(i=>i(P))}h(P){this.c.error.length===0?(0,o.$4)(P):this.c.error.slice(0).forEach(i=>i(P))}i(){this.c.end.slice(0).forEach(P=>P())}on(P,i){if(!this.a.destroyed)switch(P){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(P,i){if(this.a.destroyed)return;let n;switch(P){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const h=n.indexOf(i);h>=0&&n.splice(h,1)}}j(){if(this.b.data.length>0){const P=this.e(this.b.data);this.g(P),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const P of this.b.error)this.h(P);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function r(E,P){const i=[];let n;for(;(n=E.read())!==null;)i.push(n);return P(i)}function v(E,P,i){const n=[];let h;for(;(h=E.read())!==null&&n.length<i;)n.push(h);return h===null&&n.length>0?P(n):{read:()=>{if(n.length>0)return n.shift();if(typeof h<"u"){const R=h;return h=void 0,R}return E.read()}}}function f(E,P){return new Promise((i,n)=>{const h=[];m(E,{onData:R=>{P&&h.push(R)},onError:R=>{P?n(R):i(void 0)},onEnd:()=>{i(P?P(h):void 0)}})})}function m(E,P,i){E.on("error",n=>{i?.isCancellationRequested||P.onError(n)}),E.on("end",()=>{i?.isCancellationRequested||P.onEnd()}),E.on("data",n=>{i?.isCancellationRequested||P.onData(n)})}function a(E,P){return new Promise((i,n)=>{const h=new t.$Yc,R=[],W=k=>{if(R.push(k),R.length>P)return h.dispose(),E.pause(),i({stream:E,buffer:R,ended:!1})},p=k=>(h.dispose(),n(k)),L=()=>(h.dispose(),i({stream:E,buffer:R,ended:!0}));h.add((0,t.$Xc)(()=>E.removeListener("error",p))),E.on("error",p),h.add((0,t.$Xc)(()=>E.removeListener("end",L))),E.on("end",L),h.add((0,t.$Xc)(()=>E.removeListener("data",W))),E.on("data",W)})}function l(E,P){const i=A(P);return i.end(E),i}function c(){const E=A(()=>{throw new Error("not supported")});return E.end(),E}function d(E){let P=!1;return{read:()=>P?null:(P=!0,E)}}function $(E,P,i){const n=A(i);return m(E,{onData:h=>n.write(P.data(h)),onError:h=>n.error(P.error?P.error(h):h),onEnd:()=>n.end()}),n}function s(E,P,i){let n=!1;return{read:()=>{const h=P.read();return n?h:(n=!0,h!==null?i([E,h]):E)}}}function b(E,P,i){let n=!1;const h=A(i);return m(P,{onData:R=>n?h.write(R):(n=!0,h.write(i([E,R]))),onError:R=>h.error(R),onEnd:()=>{n||(n=!0,h.write(E)),h.end()}}),h}});var Je=this&&this.__createBinding||(Object.create?function(ie,e,o,t){t===void 0&&(t=o);var _=Object.getOwnPropertyDescriptor(e,o);(!_||("get"in _?!e.__esModule:_.writable||_.configurable))&&(_={enumerable:!0,get:function(){return e[o]}}),Object.defineProperty(ie,t,_)}:function(ie,e,o,t){t===void 0&&(t=o),ie[t]=e[o]}),Qe=this&&this.__setModuleDefault||(Object.create?function(ie,e){Object.defineProperty(ie,"default",{enumerable:!0,value:e})}:function(ie,e){ie.default=e}),Ae=this&&this.__importStar||function(ie){if(ie&&ie.__esModule)return ie;var e={};if(ie!=null)for(var o in ie)o!=="default"&&Object.prototype.hasOwnProperty.call(ie,o)&&Je(e,ie,o);return Qe(e,ie),e};define(he[19],fe([0,1,24,52]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=void 0,e.$Te=r,e.$Ue=v,e.$Ve=f,e.$We=m,e.$Xe=a,e.$Ye=l,e.$Ze=c,e.$1e=d,e.$2e=$,e.$3e=s,e.$4e=b,e.$5e=E,e.$6e=P,e.$7e=i,e.$8e=n,e.$9e=h,e.$0e=R,e.$$e=W,e.$_e=p,e.$af=M,t=Ae(t);const _=typeof Buffer<"u",g=new o.$Y(()=>new Uint8Array(256));let j,A;class w{static alloc(D){return _?new w(Buffer.allocUnsafe(D)):new w(new Uint8Array(D))}static wrap(D){return _&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new w(D)}static fromString(D,y){return!(y?.dontUseNodeBuffer||!1)&&_?new w(Buffer.from(D)):(j||(j=new TextEncoder),new w(j.encode(D)))}static fromByteArray(D){const y=w.alloc(D.length);for(let T=0,I=D.length;T<I;T++)y.buffer[T]=D[T];return y}static concat(D,y){if(typeof y>"u"){y=0;for(let S=0,F=D.length;S<F;S++)y+=D[S].byteLength}const T=w.alloc(y);let I=0;for(let S=0,F=D.length;S<F;S++){const J=D[S];T.set(J,I),I+=J.byteLength}return T}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=w.alloc(this.byteLength);return D.set(this),D}toString(){return _?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(D,y){return new w(this.buffer.subarray(D,y))}set(D,y){if(D instanceof w)this.buffer.set(D.buffer,y);else if(D instanceof Uint8Array)this.buffer.set(D,y);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),y);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),y);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return m(this.buffer,D)}writeUInt32BE(D,y){a(this.buffer,D,y)}readUInt32LE(D){return l(this.buffer,D)}writeUInt32LE(D,y){c(this.buffer,D,y)}readUInt8(D){return d(this.buffer,D)}writeUInt8(D,y){$(this.buffer,D,y)}indexOf(D,y=0){return r(this.buffer,D instanceof w?D.buffer:D,y)}}e.$Se=w;function r(C,D,y=0){const T=D.byteLength,I=C.byteLength;if(T===0)return 0;if(T===1)return C.indexOf(D[0]);if(T>I-y)return-1;const S=g.value;S.fill(D.length);for(let Q=0;Q<D.length;Q++)S[D[Q]]=D.length-Q-1;let F=y+D.length-1,J=F,V=-1;for(;F<I;)if(C[F]===D[J]){if(J===0){V=F;break}F--,J--}else F+=Math.max(D.length-J,S[C[F]]),J=D.length-1;return V}function v(C,D){return C[D+0]<<0>>>0|C[D+1]<<8>>>0}function f(C,D,y){C[y+0]=D&255,D=D>>>8,C[y+1]=D&255}function m(C,D){return C[D]*2**24+C[D+1]*2**16+C[D+2]*2**8+C[D+3]}function a(C,D,y){C[y+3]=D,D=D>>>8,C[y+2]=D,D=D>>>8,C[y+1]=D,D=D>>>8,C[y]=D}function l(C,D){return C[D+0]<<0>>>0|C[D+1]<<8>>>0|C[D+2]<<16>>>0|C[D+3]<<24>>>0}function c(C,D,y){C[y+0]=D&255,D=D>>>8,C[y+1]=D&255,D=D>>>8,C[y+2]=D&255,D=D>>>8,C[y+3]=D&255}function d(C,D){return C[D]}function $(C,D,y){C[y]=D}function s(C){return t.$He(C,D=>w.concat(D))}function b(C){return t.$Oe(C)}function E(C){return t.$Je(C,D=>w.concat(D))}async function P(C){return C.ended?w.concat(C.buffer):w.concat([...C.buffer,await E(C.stream)])}function i(C){return t.$Me(C,D=>w.concat(D))}function n(C){return t.$Pe(C,{data:D=>typeof D=="string"?w.fromString(D):w.wrap(D)},D=>w.concat(D))}function h(C){return t.$Ge(D=>w.concat(D),C)}function R(C,D){return t.$Qe(C,D,y=>w.concat(y))}function W(C,D){return t.$Re(C,D,y=>w.concat(y))}function p(C){let D=0,y=0,T=0;const I=new Uint8Array(Math.floor(C.length/4*3)),S=J=>{switch(y){case 3:I[T++]=D|J,y=0;break;case 2:I[T++]=D|J>>>2,D=J<<6,y=3;break;case 1:I[T++]=D|J>>>4,D=J<<4,y=2;break;default:D=J<<2,y=1}};for(let J=0;J<C.length;J++){const V=C.charCodeAt(J);if(V>=65&&V<=90)S(V-65);else if(V>=97&&V<=122)S(V-97+26);else if(V>=48&&V<=57)S(V-48+52);else if(V===43||V===45)S(62);else if(V===47||V===95)S(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${C[J]}`)}}const F=T;for(;y>0;)S(0);return w.wrap(I).slice(0,F)}const L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function M({buffer:C},D=!0,y=!1){const T=y?k:L;let I="";const S=C.byteLength%3;let F=0;for(;F<C.byteLength-S;F+=3){const J=C[F+0],V=C[F+1],Q=C[F+2];I+=T[J>>>2],I+=T[(J<<4|V>>>4)&63],I+=T[(V<<2|Q>>>6)&63],I+=T[Q&63]}if(S===1){const J=C[F+0];I+=T[J>>>2],I+=T[J<<4&63],D&&(I+="==")}else if(S===2){const J=C[F+0],V=C[F+1];I+=T[J>>>2],I+=T[(J<<4|V>>>4)&63],I+=T[V<<2&63],D&&(I+="=")}return I}}),define(he[53],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=void 0,e.$le=Symbol("MicrotaskDelay")}),define(he[10],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=o,e.$kg=t,e.$lg=_,e.$mg=g,e.$ng=j,e.$og=A,e.$pg=w,e.$qg=r,e.$rg=v,e.$sg=f,e.$tg=m,e.$ug=a,e.$vg=l,e.$wg=d,e.$xg=$,e.$yg=s,e.$zg=b,e.$Ag=E,e.$Bg=P;function o(i){return typeof i=="string"}function t(i){return Array.isArray(i)&&i.every(n=>o(n))}function _(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function g(i){const n=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof n}function j(i){return typeof i=="number"&&!isNaN(i)}function A(i){return!!i&&typeof i[Symbol.iterator]=="function"}function w(i){return i===!0||i===!1}function r(i){return typeof i>"u"}function v(i){return!f(i)}function f(i){return r(i)||i===null}function m(i,n){if(!i)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function a(i){if(f(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function l(...i){const n=[];for(let h=0;h<i.length;h++){const R=i[h];if(f(R))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);n.push(R)}return n}const c=Object.prototype.hasOwnProperty;function d(i){if(!_(i))return!1;for(const n in i)if(c.call(i,n))return!1;return!0}function $(i){return typeof i=="function"}function s(...i){return i.length>0&&i.every($)}function b(i,n){const h=Math.min(i.length,n.length);for(let R=0;R<h;R++)E(i[R],n[R])}function E(i,n){if(o(n)){if(typeof i!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if($(n)){try{if(i instanceof n)return}catch{}if(!f(i)&&i.constructor===n||n.length===1&&n.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function P(i){return i}}),define(he[32],fe([0,1,10]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=t,e.$lo=_,e.$mo=j,e.$no=w,e.$oo=r,e.$po=v,e.$qo=f,e.$ro=m,e.$so=a,e.$to=l,e.$uo=c,e.$vo=d,e.$wo=$;function t(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const b=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([E,P])=>{b[E]=P&&typeof P=="object"?t(P):P}),b}function _(s){if(!s||typeof s!="object")return s;const b=[s];for(;b.length>0;){const E=b.shift();Object.freeze(E);for(const P in E)if(g.call(E,P)){const i=E[P];typeof i=="object"&&!Object.isFrozen(i)&&!(0,o.$mg)(i)&&b.push(i)}}return s}const g=Object.prototype.hasOwnProperty;function j(s,b){return A(s,b,new Set)}function A(s,b,E){if((0,o.$sg)(s))return s;const P=b(s);if(typeof P<"u")return P;if(Array.isArray(s)){const i=[];for(const n of s)i.push(A(n,b,E));return i}if((0,o.$lg)(s)){if(E.has(s))throw new Error("Cannot clone recursive data-structure");E.add(s);const i={};for(const n in s)g.call(s,n)&&(i[n]=A(s[n],b,E));return E.delete(s),i}return s}function w(s,b,E=!0){return(0,o.$lg)(s)?((0,o.$lg)(b)&&Object.keys(b).forEach(P=>{P in s?E&&((0,o.$lg)(s[P])&&(0,o.$lg)(b[P])?w(s[P],b[P],E):s[P]=b[P]):s[P]=b[P]}),s):b}function r(s,b){if(s===b)return!0;if(s==null||b===null||b===void 0||typeof s!=typeof b||typeof s!="object"||Array.isArray(s)!==Array.isArray(b))return!1;let E,P;if(Array.isArray(s)){if(s.length!==b.length)return!1;for(E=0;E<s.length;E++)if(!r(s[E],b[E]))return!1}else{const i=[];for(P in s)i.push(P);i.sort();const n=[];for(P in b)n.push(P);if(n.sort(),!r(i,n))return!1;for(E=0;E<i.length;E++)if(!r(s[i[E]],b[i[E]]))return!1}return!0}function v(s){const b=new Set;return JSON.stringify(s,(E,P)=>{if((0,o.$lg)(P)||Array.isArray(P)){if(b.has(P))return"[Circular]";b.add(P)}return typeof P=="bigint"?`[BigInt ${P.toString()}]`:P})}function f(s,b){const E=Object.create(null);return!s||!b||Object.keys(b).forEach(i=>{const n=s[i],h=b[i];r(n,h)||(E[i]=h)}),E}function m(s,b){const E=b.toLowerCase(),P=Object.keys(s).find(i=>i.toLowerCase()===E);return P?s[P]:s[b]}function a(s,b){const E=Object.create(null);for(const[P,i]of Object.entries(s))b(P,i)&&(E[P]=i);return E}function l(s){let b=[];for(;Object.prototype!==s;)b=b.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return b}function c(s){const b=[];for(const E of l(s))typeof s[E]=="function"&&b.push(E);return b}function d(s,b){const E=i=>function(){const n=Array.prototype.slice.call(arguments,0);return b(i,n)},P={};for(const i of s)P[i]=E(i);return P}function $(s,b){const E={};for(const[P,i]of Object.entries(s))E[P]=b(i,P);return E}}),define(he[54],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$ff=t,e.$gf=_;var o;(function(g){g[g.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",g[g.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",g[g.MAX_UINT_8=255]="MAX_UINT_8",g[g.MAX_UINT_16=65535]="MAX_UINT_16",g[g.MAX_UINT_32=4294967295]="MAX_UINT_32",g[g.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(o||(e.Constants=o={}));function t(g){return g<0?0:g>o.MAX_UINT_8?o.MAX_UINT_8:g|0}function _(g){return g<0?0:g>o.MAX_UINT_32?o.MAX_UINT_32:g|0}}),define(he[11],fe([0,1,51,13,24,54]),function(ie,e,o,t,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=e.GraphemeBreakType=e.$9f=e.$1f=e.$Tf=e.$Sf=void 0,e.$hf=j,e.$if=w,e.$jf=v,e.$kf=f,e.$lf=m,e.$mf=a,e.$nf=l,e.$of=c,e.$pf=d,e.$qf=$,e.$rf=s,e.$sf=b,e.$tf=E,e.$uf=P,e.$vf=i,e.$wf=n,e.$xf=h,e.$yf=R,e.$zf=W,e.$Af=p,e.$Bf=L,e.$Cf=k,e.$Df=M,e.$Ef=C,e.$Ff=D,e.$Gf=y,e.$Hf=T,e.$If=I,e.$Jf=S,e.$Kf=F,e.$Lf=J,e.$Mf=V,e.$Nf=Q,e.$Of=re,e.$Pf=ae,e.$Qf=X,e.$Rf=B,e.$Uf=q,e.$Vf=ce,e.$Wf=de,e.$Xf=te,e.$Yf=oe,e.$Zf=K,e.$2f=U,e.$3f=O,e.$4f=G,e.$5f=x,e.$6f=$e,e.$7f=ve,e.$8f=Ie,e.$0f=we,e.$$f=ge,e.$_f=pe,e.$ag=be,e.$bg=Ee,e.$cg=_e,e.$dg=Pe,e.$eg=Re,e.$fg=Ve;function j(z){return!z||typeof z!="string"?!0:z.trim().length===0}const A=/{(\d+)}/g;function w(z,...Y){return Y.length===0?z:z.replace(A,function(se,ue){const ye=parseInt(ue,10);return isNaN(ye)||ye<0||ye>=Y.length?se:Y[ye]})}const r=/{([^}]+)}/g;function v(z,Y){return Object.keys(Y).length===0?z:z.replace(r,(se,ue)=>Y[ue]??se)}function f(z){return z.replace(/[<>"'&]/g,Y=>{switch(Y){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Y})}function m(z){return z.replace(/[<>&]/g,function(Y){switch(Y){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Y}})}function a(z){return z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(z,Y){let se=0,ue=z.indexOf(Y);for(;ue!==-1;)se++,ue=z.indexOf(Y,ue+Y.length);return se}function c(z,Y,se="\u2026"){return z.length<=Y?z:`${z.substr(0,Y)}${se}`}function d(z,Y,se="\u2026"){if(z.length<=Y)return z;const ue=Math.ceil(Y/2)-se.length/2,ye=Math.floor(Y/2)-se.length/2;return`${z.substr(0,ue)}${se}${z.substr(z.length-ye)}`}function $(z,Y=" "){const se=s(z,Y);return b(se,Y)}function s(z,Y){if(!z||!Y)return z;const se=Y.length;if(se===0||z.length===0)return z;let ue=0;for(;z.indexOf(Y,ue)===ue;)ue=ue+se;return z.substring(ue)}function b(z,Y){if(!z||!Y)return z;const se=Y.length,ue=z.length;if(se===0||ue===0)return z;let ye=ue,De=-1;for(;De=z.lastIndexOf(Y,ye-1),!(De===-1||De+se!==ye);){if(De===0)return"";ye=De}return z.substring(0,ye)}function E(z){return z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function P(z){return z.replace(/\*/g,"")}function i(z,Y,se={}){if(!z)throw new Error("Cannot create regex from empty string");Y||(z=a(z)),se.wholeWord&&(/\B/.test(z.charAt(0))||(z="\\b"+z),/\B/.test(z.charAt(z.length-1))||(z=z+"\\b"));let ue="";return se.global&&(ue+="g"),se.matchCase||(ue+="i"),se.multiline&&(ue+="m"),se.unicode&&(ue+="u"),new RegExp(z,ue)}function n(z){return z.source==="^"||z.source==="^$"||z.source==="$"||z.source==="^\\s*$"?!1:!!(z.exec("")&&z.lastIndex===0)}function h(z){return z.split(/\r\n|\r|\n/)}function R(z){const Y=[],se=z.split(/(\r\n|\r|\n)/);for(let ue=0;ue<Math.ceil(se.length/2);ue++)Y.push(se[2*ue]+(se[2*ue+1]??""));return Y}function W(z){for(let Y=0,se=z.length;Y<se;Y++){const ue=z.charCodeAt(Y);if(ue!==t.CharCode.Space&&ue!==t.CharCode.Tab)return Y}return-1}function p(z,Y=0,se=z.length){for(let ue=Y;ue<se;ue++){const ye=z.charCodeAt(ue);if(ye!==t.CharCode.Space&&ye!==t.CharCode.Tab)return z.substring(Y,ue)}return z.substring(Y,se)}function L(z,Y=z.length-1){for(let se=Y;se>=0;se--){const ue=z.charCodeAt(se);if(ue!==t.CharCode.Space&&ue!==t.CharCode.Tab)return se}return-1}function k(z,Y,se){const ue=[];let ye=0;for(const De of z.matchAll(Y)){if(ue.push(z.slice(ye,De.index)),De.index===void 0)throw new Error("match.index should be defined");ye=De.index+De[0].length,ue.push(se(De[0],...De.slice(1),De.index,z,De.groups))}return ue.push(z.slice(ye)),Promise.all(ue).then(De=>De.join(""))}function M(z,Y){return z<Y?-1:z>Y?1:0}function C(z,Y,se=0,ue=z.length,ye=0,De=Y.length){for(;se<ue&&ye<De;se++,ye++){const Ue=z.charCodeAt(se),Ne=Y.charCodeAt(ye);if(Ue<Ne)return-1;if(Ue>Ne)return 1}const Oe=ue-se,Fe=De-ye;return Oe<Fe?-1:Oe>Fe?1:0}function D(z,Y){return y(z,Y,0,z.length,0,Y.length)}function y(z,Y,se=0,ue=z.length,ye=0,De=Y.length){for(;se<ue&&ye<De;se++,ye++){let Ue=z.charCodeAt(se),Ne=Y.charCodeAt(ye);if(Ue===Ne)continue;if(Ue>=128||Ne>=128)return C(z.toLowerCase(),Y.toLowerCase(),se,ue,ye,De);I(Ue)&&(Ue-=32),I(Ne)&&(Ne-=32);const Me=Ue-Ne;if(Me!==0)return Me}const Oe=ue-se,Fe=De-ye;return Oe<Fe?-1:Oe>Fe?1:0}function T(z){return z>=t.CharCode.Digit0&&z<=t.CharCode.Digit9}function I(z){return z>=t.CharCode.a&&z<=t.CharCode.z}function S(z){return z>=t.CharCode.A&&z<=t.CharCode.Z}function F(z,Y){return z.length===Y.length&&y(z,Y)===0}function J(z,Y){const se=Y.length;return Y.length>z.length?!1:y(z,Y,0,se)===0}function V(z,Y){const se=Math.min(z.length,Y.length);let ue;for(ue=0;ue<se;ue++)if(z.charCodeAt(ue)!==Y.charCodeAt(ue))return ue;return se}function Q(z,Y){const se=Math.min(z.length,Y.length);let ue;const ye=z.length-1,De=Y.length-1;for(ue=0;ue<se;ue++)if(z.charCodeAt(ye-ue)!==Y.charCodeAt(De-ue))return ue;return se}function re(z){return 55296<=z&&z<=56319}function ae(z){return 56320<=z&&z<=57343}function X(z,Y){return(z-55296<<10)+(Y-56320)+65536}function B(z,Y,se){const ue=z.charCodeAt(se);if(re(ue)&&se+1<Y){const ye=z.charCodeAt(se+1);if(ae(ye))return X(ue,ye)}return ue}function Z(z,Y){const se=z.charCodeAt(Y-1);if(ae(se)&&Y>1){const ue=z.charCodeAt(Y-2);if(re(ue))return X(ue,se)}return se}class ee{get offset(){return this.e}constructor(Y,se=0){this.c=Y,this.d=Y.length,this.e=se}setOffset(Y){this.e=Y}prevCodePoint(){const Y=Z(this.c,this.e);return this.e-=Y>=g.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Y}nextCodePoint(){const Y=B(this.c,this.d,this.e);return this.e+=Y>=g.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Y}eol(){return this.e>=this.d}}e.$Sf=ee;class le{get offset(){return this.c.offset}constructor(Y,se=0){this.c=new ee(Y,se)}nextGraphemeLength(){const Y=Te.getInstance(),se=this.c,ue=se.offset;let ye=Y.getGraphemeBreakType(se.nextCodePoint());for(;!se.eol();){const De=se.offset,Oe=Y.getGraphemeBreakType(se.nextCodePoint());if(ke(ye,Oe)){se.setOffset(De);break}ye=Oe}return se.offset-ue}prevGraphemeLength(){const Y=Te.getInstance(),se=this.c,ue=se.offset;let ye=Y.getGraphemeBreakType(se.prevCodePoint());for(;se.offset>0;){const De=se.offset,Oe=Y.getGraphemeBreakType(se.prevCodePoint());if(ke(Oe,ye)){se.setOffset(De);break}ye=Oe}return ue-se.offset}eol(){return this.c.eol()}}e.$Tf=le;function q(z,Y){return new le(z,Y).nextGraphemeLength()}function ce(z,Y){return new le(z,Y).prevGraphemeLength()}function de(z,Y){Y>0&&ae(z.charCodeAt(Y))&&Y--;const se=Y+q(z,Y);return[se-ce(z,se),se]}function te(z){const Y=new le(z);let se=0;for(;!Y.eol();)se++,Y.nextGraphemeLength();return se}let u;function H(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(z){return u||(u=H()),u.test(z)}const N=/^[\t\n\r\x20-\x7E]*$/;function K(z){return N.test(z)}e.$1f=/[\u2028\u2029]/;function U(z){return e.$1f.test(z)}function O(z){return z>=11904&&z<=55215||z>=63744&&z<=64255||z>=65281&&z<=65374}function G(z){return z>=127462&&z<=127487||z===8986||z===8987||z===9200||z===9203||z>=9728&&z<=10175||z===11088||z===11093||z>=127744&&z<=128591||z>=128640&&z<=128764||z>=128992&&z<=129008||z>=129280&&z<=129535||z>=129648&&z<=129782}function x(z,Y,se=""){const ue=z.trimStart();if(ue.length<Y)return ue;const ye=/\b/g;let De=0;for(;ye.test(ue)&&!(ue.length-ye.lastIndex<Y);)De=ye.lastIndex,ye.lastIndex+=1;return De===0?ue:se+ue.substring(De).trimStart()}const ne=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*$e(z){let Y=0;for(const se of z.matchAll(ne))Y!==se.index&&(yield{isCode:!1,str:z.substring(Y,se.index)}),yield{isCode:!0,str:se[0]},Y=se.index+se[0].length;Y!==z.length&&(yield{isCode:!1,str:z.substring(Y)})}function ve(z){return z&&(z=z.replace(ne,"")),z}const Se=/\\\[.*?\\\]/g;function Ie(z){return ve(z).replace(Se,"")}e.$9f=String.fromCharCode(t.CharCode.UTF8_BOM);function we(z){return!!(z&&z.length>0&&z.charCodeAt(0)===t.CharCode.UTF8_BOM)}function ge(z){return we(z)?z.substr(1):z}function pe(z,Y){if(!z||!Y||z.length<Y.length)return!1;const se=Y.length,ue=z.toLowerCase();let ye=0,De=-1;for(;ye<se;){const Oe=ue.indexOf(Y[ye],De+1);if(Oe<0)return!1;De=Oe,ye++}return!0}function be(z,Y=!1){return z?(Y&&(z=z.replace(/\\./g,"")),z.toLowerCase()!==z):!1}function Ee(z){return z.charAt(0).toUpperCase()+z.slice(1)}function _e(z,Y=1){if(Y===0)return"";let se=-1;do se=z.indexOf(`
`,se+1),Y--;while(Y>0&&se>=0);return se===-1?z:(z[se-1]==="\r"&&se--,z.substr(0,se))}function Pe(z){const Y=t.CharCode.Z-t.CharCode.A+1;return z=z%(2*Y),z<Y?String.fromCharCode(t.CharCode.a+z):String.fromCharCode(t.CharCode.A+z-Y)}function Re(z){return Te.getInstance().getGraphemeBreakType(z)}function ke(z,Y){return z===Le.Other?Y!==Le.Extend&&Y!==Le.SpacingMark:z===Le.CR&&Y===Le.LF?!1:z===Le.Control||z===Le.CR||z===Le.LF||Y===Le.Control||Y===Le.CR||Y===Le.LF?!0:!(z===Le.L&&(Y===Le.L||Y===Le.V||Y===Le.LV||Y===Le.LVT)||(z===Le.LV||z===Le.V)&&(Y===Le.V||Y===Le.T)||(z===Le.LVT||z===Le.T)&&Y===Le.T||Y===Le.Extend||Y===Le.ZWJ||Y===Le.SpacingMark||z===Le.Prepend||z===Le.ZWJ&&Y===Le.Extended_Pictographic||z===Le.Regional_Indicator&&Y===Le.Regional_Indicator)}var Le;(function(z){z[z.Other=0]="Other",z[z.Prepend=1]="Prepend",z[z.CR=2]="CR",z[z.LF=3]="LF",z[z.Control=4]="Control",z[z.Extend=5]="Extend",z[z.Regional_Indicator=6]="Regional_Indicator",z[z.SpacingMark=7]="SpacingMark",z[z.L=8]="L",z[z.V=9]="V",z[z.T=10]="T",z[z.LV=11]="LV",z[z.LVT=12]="LVT",z[z.ZWJ=13]="ZWJ",z[z.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(e.GraphemeBreakType=Le={}));class Te{static{this.c=null}static getInstance(){return Te.c||(Te.c=new Te),Te.c}constructor(){this.d=ze()}getGraphemeBreakType(Y){if(Y<32)return Y===t.CharCode.LineFeed?Le.LF:Y===t.CharCode.CarriageReturn?Le.CR:Le.Control;if(Y<127)return Le.Other;const se=this.d,ue=se.length/3;let ye=1;for(;ye<=ue;)if(Y<se[3*ye])ye=2*ye;else if(Y>se[3*ye+1])ye=2*ye+1;else return se[3*ye+2];return Le.Other}}function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(z,Y){if(z===0)return 0;const se=We(z,Y);if(se!==void 0)return se;const ue=new ee(Y,z);return ue.prevCodePoint(),ue.offset}function We(z,Y){const se=new ee(Y,z);let ue=se.prevCodePoint();for(;Ye(ue)||ue===qe.emojiVariantSelector||ue===qe.enclosingKeyCap;){if(se.offset===0)return;ue=se.prevCodePoint()}if(!G(ue))return;let ye=se.offset;return ye>0&&se.prevCodePoint()===qe.zwj&&(ye=se.offset),ye}function Ye(z){return 127995<=z&&z<=127999}var qe;(function(z){z[z.zwj=8205]="zwj",z[z.emojiVariantSelector=65039]="emojiVariantSelector",z[z.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.$gg="\xA0";class He{static{this.c=new _.$Y(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new o.$df({getCacheKey:JSON.stringify},Y=>{function se(Me){const Be=new Map;for(let Ce=0;Ce<Me.length;Ce+=2)Be.set(Me[Ce],Me[Ce+1]);return Be}function ue(Me,Be){const Ce=new Map(Me);for(const[Xe,Ze]of Be)Ce.set(Xe,Ze);return Ce}function ye(Me,Be){if(!Me)return Be;const Ce=new Map;for(const[Xe,Ze]of Me)Be.has(Xe)&&Ce.set(Xe,Ze);return Ce}const De=this.c.value;let Oe=Y.filter(Me=>!Me.startsWith("_")&&Me in De);Oe.length===0&&(Oe=["_default"]);let Fe;for(const Me of Oe){const Be=se(De[Me]);Fe=ye(Fe,Be)}const Ue=se(De._common),Ne=ue(Ue,Fe);return new He(Ne)})}static getInstance(Y){return He.d.get(Array.from(Y))}static{this.e=new _.$Y(()=>Object.keys(He.c.value).filter(Y=>!Y.startsWith("_")))}static getLocales(){return He.e.value}constructor(Y){this.f=Y}isAmbiguous(Y){return this.f.has(Y)}containsAmbiguousCharacter(Y){for(let se=0;se<Y.length;se++){const ue=Y.codePointAt(se);if(typeof ue=="number"&&this.isAmbiguous(ue))return!0}return!1}getPrimaryConfusable(Y){return this.f.get(Y)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$hg=He;class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(Y){return Ge.e().has(Y)}static containsInvisibleCharacter(Y){for(let se=0;se<Y.length;se++){const ue=Y.codePointAt(se);if(typeof ue=="number"&&Ge.isInvisibleCharacter(ue))return!0}return!1}static get codePoints(){return Ge.e()}}e.$ig=Ge}),define(he[55],fe([0,1,11]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Cj=void 0,e.$yj=t,e.$zj=_,e.$Aj=g,e.$Bj=A,e.$Dj=c,o=Ae(o);function t($){return _($,0)}function _($,s){switch(typeof $){case"object":return $===null?g(349,s):Array.isArray($)?w($,s):r($,s);case"string":return A($,s);case"boolean":return j($,s);case"number":return g($,s);case"undefined":return g(937,s);default:return g(617,s)}}function g($,s){return(s<<5)-s+$|0}function j($,s){return g($?433:863,s)}function A($,s){s=g(149417,s);for(let b=0,E=$.length;b<E;b++)s=g($.charCodeAt(b),s);return s}function w($,s){return s=g(104579,s),$.reduce((b,E)=>_(E,b),s)}function r($,s){return s=g(181387,s),Object.keys($).sort().reduce((b,E)=>(b=A(E,b),_($[E],b)),s)}class v{constructor(){this.g=0}get value(){return this.g}hash(s){return this.g=_(s,this.g),this.g}}e.$Cj=v;var f;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(f||(f={}));function m($,s,b=32){const E=b-s,P=~((1<<E)-1);return($<<s|(P&$)>>>E)>>>0}function a($,s=0,b=$.byteLength,E=0){for(let P=0;P<b;P++)$[s+P]=E}function l($,s,b="0"){for(;$.length<s;)$=b+$;return $}function c($,s=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(b=>b.toString(16).padStart(2,"0")).join(""):l(($>>>0).toString(16),s/4)}class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(f.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(s){const b=s.length;if(b===0)return;const E=this.p;let P=this.r,i=this.u,n,h;for(i!==0?(n=i,h=-1,i=0):(n=s.charCodeAt(0),h=0);;){let R=n;if(o.$Of(n))if(h+1<b){const W=s.charCodeAt(h+1);o.$Pf(W)?(h++,R=o.$Qf(n,W)):R=f.UNICODE_REPLACEMENT}else{i=n;break}else o.$Pf(n)&&(R=f.UNICODE_REPLACEMENT);if(P=this.w(E,P,R),h++,h<b)n=s.charCodeAt(h);else break}this.r=P,this.u=i}w(s,b,E){return E<128?s[b++]=E:E<2048?(s[b++]=192|(E&1984)>>>6,s[b++]=128|(E&63)>>>0):E<65536?(s[b++]=224|(E&61440)>>>12,s[b++]=128|(E&4032)>>>6,s[b++]=128|(E&63)>>>0):(s[b++]=240|(E&1835008)>>>18,s[b++]=128|(E&258048)>>>12,s[b++]=128|(E&4032)>>>6,s[b++]=128|(E&63)>>>0),b>=f.BLOCK_SIZE&&(this.y(),b-=f.BLOCK_SIZE,this.t+=f.BLOCK_SIZE,s[0]=s[f.BLOCK_SIZE+0],s[1]=s[f.BLOCK_SIZE+1],s[2]=s[f.BLOCK_SIZE+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,f.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,a(this.p,this.r),this.r>56&&(this.y(),a(this.p));const s=8*this.t;this.q.setUint32(56,Math.floor(s/4294967296),!1),this.q.setUint32(60,s%4294967296,!1),this.y()}y(){const s=d.g,b=this.q;for(let L=0;L<64;L+=4)s.setUint32(L,b.getUint32(L,!1),!1);for(let L=64;L<320;L+=4)s.setUint32(L,m(s.getUint32(L-12,!1)^s.getUint32(L-32,!1)^s.getUint32(L-56,!1)^s.getUint32(L-64,!1),1),!1);let E=this.h,P=this.l,i=this.m,n=this.n,h=this.o,R,W,p;for(let L=0;L<80;L++)L<20?(R=P&i|~P&n,W=1518500249):L<40?(R=P^i^n,W=1859775393):L<60?(R=P&i|P&n|i&n,W=2400959708):(R=P^i^n,W=3395469782),p=m(E,5)+R+h+W+s.getUint32(L*4,!1)&4294967295,h=n,n=i,i=m(P,30),P=E,E=p;this.h=this.h+E&4294967295,this.l=this.l+P&4294967295,this.m=this.m+i&4294967295,this.n=this.n+n&4294967295,this.o=this.o+h&4294967295}}e.$Ej=d}),define(he[56],fe([0,1,17,13,11]),function(ie,e,o,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=void 0;class g{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const c=l.charCodeAt(0),d=this.b.charCodeAt(this.c);return c-d}value(){return this.b[this.c]}}e.$Mi=g;class j{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===t.CharCode.Period)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,_.$Ef)(l,this.b,0,l.length,this.c,this.d):(0,_.$Gf)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ni=j;class A{constructor(l=!0,c=!0){this.f=l,this.g=c}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let c=l.length-1;c>=0;c--,this.c--){const d=this.b.charCodeAt(c);if(!(d===t.CharCode.Slash||this.f&&d===t.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const c=this.b.charCodeAt(this.e);if(c===t.CharCode.Slash||this.f&&c===t.CharCode.Backslash)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,_.$Ef)(l,this.b,0,l.length,this.d,this.e):(0,_.$Gf)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Oi=A;var w;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(w||(w={}));class r{constructor(l,c){this.f=l,this.g=c,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(w.Scheme),this.c.authority&&this.d.push(w.Authority),this.c.path&&(this.b=new A(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(w.Path)),this.g(l)||(this.c.query&&this.d.push(w.Query),this.c.fragment&&this.d.push(w.Fragment)),this.e=0,this}next(){return this.d[this.e]===w.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===w.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===w.Scheme)return(0,_.$Ff)(l,this.c.scheme);if(this.d[this.e]===w.Authority)return(0,_.$Ff)(l,this.c.authority);if(this.d[this.e]===w.Path)return this.b.cmp(l);if(this.d[this.e]===w.Query)return(0,_.$Df)(l,this.c.query);if(this.d[this.e]===w.Fragment)return(0,_.$Df)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===w.Scheme)return this.c.scheme;if(this.d[this.e]===w.Authority)return this.c.authority;if(this.d[this.e]===w.Path)return this.b.value();if(this.d[this.e]===w.Query)return this.c.query;if(this.d[this.e]===w.Fragment)return this.c.fragment;throw new Error}}e.$Pi=r;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(f||(f={}));class m{static forUris(l=()=>!1,c=()=>!1){return new m(new r(l,c))}static forPaths(l=!1){return new m(new A(void 0,!l))}static forStrings(){return new m(new g)}static forConfigKeys(){return new m(new j)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,c){if(c){const d=c.slice(0);(0,o.$1b)(d);for(const $ of d)this.set($,l)}else{const d=l.slice(0);(0,o.$1b)(d);for(const $ of d)this.set($[0],$[1])}}set(l,c){const d=this.b.reset(l);let $;this.c||(this.c=new v,this.c.segment=d.value());const s=[];for($=this.c;;){const E=d.cmp($.segment);if(E>0)$.left||($.left=new v,$.left.segment=d.value()),s.push([f.Left,$]),$=$.left;else if(E<0)$.right||($.right=new v,$.right.segment=d.value()),s.push([f.Right,$]),$=$.right;else if(d.hasNext())d.next(),$.mid||($.mid=new v,$.mid.segment=d.value()),s.push([f.Mid,$]),$=$.mid;else break}const b=$.value;$.value=c,$.key=l;for(let E=s.length-1;E>=0;E--){const P=s[E][1];P.updateHeight();const i=P.balanceFactor();if(i<-1||i>1){const n=s[E][0],h=s[E+1][0];if(n===f.Right&&h===f.Right)s[E][1]=P.rotateLeft();else if(n===f.Left&&h===f.Left)s[E][1]=P.rotateRight();else if(n===f.Right&&h===f.Left)P.right=s[E+1][1]=s[E+1][1].rotateRight(),s[E][1]=P.rotateLeft();else if(n===f.Left&&h===f.Right)P.left=s[E+1][1]=s[E+1][1].rotateLeft(),s[E][1]=P.rotateRight();else throw new Error;if(E>0)switch(s[E-1][0]){case f.Left:s[E-1][1].left=s[E][1];break;case f.Right:s[E-1][1].right=s[E][1];break;case f.Mid:s[E-1][1].mid=s[E][1];break}else this.c=s[0][1]}}return b}get(l){return this.d(l)?.value}d(l){const c=this.b.reset(l);let d=this.c;for(;d;){const $=c.cmp(d.segment);if($>0)d=d.left;else if($<0)d=d.right;else if(c.hasNext())c.next(),d=d.mid;else break}return d}has(l){const c=this.d(l);return!(c?.value===void 0&&c?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,c){const d=this.b.reset(l),$=[];let s=this.c;for(;s;){const b=d.cmp(s.segment);if(b>0)$.push([f.Left,s]),s=s.left;else if(b<0)$.push([f.Right,s]),s=s.right;else if(d.hasNext())d.next(),$.push([f.Mid,s]),s=s.mid;else break}if(s){if(c?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const b=this.f(s.right);if(b.key){const{key:E,value:P,segment:i}=b;this.e(b.key,!1),s.key=E,s.value=P,s.segment=i}}else{const b=s.left??s.right;if($.length>0){const[E,P]=$[$.length-1];switch(E){case f.Left:P.left=b;break;case f.Mid:P.mid=b;break;case f.Right:P.right=b;break}}else this.c=b}for(let b=$.length-1;b>=0;b--){const E=$[b][1];E.updateHeight();const P=E.balanceFactor();if(P>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),$[b][1]=E.rotateLeft()):P<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),$[b][1]=E.rotateRight()),b>0)switch($[b-1][0]){case f.Left:$[b-1][1].left=$[b][1];break;case f.Right:$[b-1][1].right=$[b][1];break;case f.Mid:$[b-1][1].mid=$[b][1];break}else this.c=$[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const c=this.b.reset(l);let d=this.c,$;for(;d;){const s=c.cmp(d.segment);if(s>0)d=d.left;else if(s<0)d=d.right;else if(c.hasNext())c.next(),$=d.value||$,d=d.mid;else break}return d&&d.value||$}findSuperstr(l){return this.g(l,!1)}g(l,c){const d=this.b.reset(l);let $=this.c;for(;$;){const s=d.cmp($.segment);if(s>0)$=$.left;else if(s<0)$=$.right;else if(d.hasNext())d.next(),$=$.mid;else return $.mid?this.h($.mid):c?$.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[c,d]of this)l(d,c)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const c=[];return this.j(l,c),c[Symbol.iterator]()}j(l,c){l&&(l.left&&this.j(l.left,c),l.value&&c.push([l.key,l.value]),l.mid&&this.j(l.mid,c),l.right&&this.j(l.right,c))}_isBalanced(){const l=c=>{if(!c)return!0;const d=c.balanceFactor();return d<-1||d>1?!1:l(c.left)&&l(c.right)};return l(this.c)}}e.$Qi=m}),define(he[57],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=void 0,e.$6g=t;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(_){return o.test(_)}e.$7g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let _;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?_=crypto.getRandomValues.bind(crypto):_=function(A){for(let w=0;w<A.length;w++)A[w]=Math.floor(Math.random()*256);return A};const g=new Uint8Array(16),j=[];for(let A=0;A<256;A++)j.push(A.toString(16).padStart(2,"0"));return function(){_(g),g[6]=g[6]&15|64,g[8]=g[8]&63|128;let w=0,r="";return r+=j[g[w++]],r+=j[g[w++]],r+=j[g[w++]],r+=j[g[w++]],r+="-",r+=j[g[w++]],r+=j[g[w++]],r+="-",r+=j[g[w++]],r+=j[g[w++]],r+="-",r+=j[g[w++]],r+=j[g[w++]],r+="-",r+=j[g[w++]],r+=j[g[w++]],r+=j[g[w++]],r+=j[g[w++]],r+=j[g[w++]],r+=j[g[w++]],r}}()}),define(he[33],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zY=o;function o(t){return!!t.parentPort}}),define(he[34],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a=o,e.$b=t;function o(){return globalThis._VSCODE_NLS_MESSAGES}function t(){return globalThis._VSCODE_NLS_LANGUAGE}}),define(he[8],fe([0,1,34,34]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=e.getNLSLanguage=void 0,e.localize=j,e.localize2=w,Object.defineProperty(e,"getNLSLanguage",{enumerable:!0,get:function(){return t.$b}}),Object.defineProperty(e,"getNLSMessages",{enumerable:!0,get:function(){return t.$a}});const _=(0,o.$b)()==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function g(r,v){let f;return v.length===0?f=r:f=r.replace(/\{(\d+)\}/g,(m,a)=>{const l=a[0],c=v[l];let d=m;return typeof c=="string"?d=c:(typeof c=="number"||typeof c=="boolean"||c===void 0||c===null)&&(d=String(c)),d}),_&&(f="\uFF3B"+f.replace(/[aouei]/g,"$&$&")+"\uFF3D"),f}function j(r,v,...f){return g(typeof r=="number"?A(r,v):v,f)}function A(r,v){const f=(0,o.$a)()?.[r];if(typeof f!="string"){if(typeof v=="string")return v;throw new Error(`!!! NLS MISSING: ${r} !!!`)}return f}function w(r,v,...f){let m;typeof r=="number"?m=A(r,v):m=v;const a=g(m,f);return{value:a,original:v===m?a:g(v,f)}}}),define(he[58],fe([0,1,8]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=r,e.$8m=v,e.$9m=f,e.$0m=m;const t=60,_=t*60,g=_*24,j=g*7,A=g*30,w=g*365;function r(a,l,c,d){typeof a!="number"&&(a=a.getTime());const $=Math.round((new Date().getTime()-a)/1e3);if($<-30)return(0,o.localize)(42,null,r(new Date().getTime()+$*1e3,!1));if(!d&&$<30)return(0,o.localize)(43,null);let s;return $<t?(s=$,l?s===1?c?(0,o.localize)(44,null,s):(0,o.localize)(45,null,s):c?(0,o.localize)(46,null,s):(0,o.localize)(47,null,s):s===1?c?(0,o.localize)(48,null,s):(0,o.localize)(49,null,s):c?(0,o.localize)(50,null,s):(0,o.localize)(51,null,s)):$<_?(s=Math.floor($/t),l?s===1?c?(0,o.localize)(52,null,s):(0,o.localize)(53,null,s):c?(0,o.localize)(54,null,s):(0,o.localize)(55,null,s):s===1?c?(0,o.localize)(56,null,s):(0,o.localize)(57,null,s):c?(0,o.localize)(58,null,s):(0,o.localize)(59,null,s)):$<g?(s=Math.floor($/_),l?s===1?c?(0,o.localize)(60,null,s):(0,o.localize)(61,null,s):c?(0,o.localize)(62,null,s):(0,o.localize)(63,null,s):s===1?c?(0,o.localize)(64,null,s):(0,o.localize)(65,null,s):c?(0,o.localize)(66,null,s):(0,o.localize)(67,null,s)):$<j?(s=Math.floor($/g),l?s===1?(0,o.localize)(68,null,s):(0,o.localize)(69,null,s):s===1?(0,o.localize)(70,null,s):(0,o.localize)(71,null,s)):$<A?(s=Math.floor($/j),l?s===1?c?(0,o.localize)(72,null,s):(0,o.localize)(73,null,s):c?(0,o.localize)(74,null,s):(0,o.localize)(75,null,s):s===1?c?(0,o.localize)(76,null,s):(0,o.localize)(77,null,s):c?(0,o.localize)(78,null,s):(0,o.localize)(79,null,s)):$<w?(s=Math.floor($/A),l?s===1?c?(0,o.localize)(80,null,s):(0,o.localize)(81,null,s):c?(0,o.localize)(82,null,s):(0,o.localize)(83,null,s):s===1?c?(0,o.localize)(84,null,s):(0,o.localize)(85,null,s):c?(0,o.localize)(86,null,s):(0,o.localize)(87,null,s)):(s=Math.floor($/w),l?s===1?c?(0,o.localize)(88,null,s):(0,o.localize)(89,null,s):c?(0,o.localize)(90,null,s):(0,o.localize)(91,null,s):s===1?c?(0,o.localize)(92,null,s):(0,o.localize)(93,null,s):c?(0,o.localize)(94,null,s):(0,o.localize)(95,null,s))}function v(a,l,c){typeof a!="number"&&(a=a.getTime());const d=new Date;d.setHours(0,0,0,0);const $=new Date(d.getTime());return $.setDate($.getDate()-1),a>d.getTime()?(0,o.localize)(96,null):a>$.getTime()?(0,o.localize)(97,null):r(a,l,c)}function f(a,l){const c=Math.abs(a/1e3);return c<1?l?(0,o.localize)(98,null,a):(0,o.localize)(99,null,a):c<t?l?(0,o.localize)(100,null,Math.round(a)/1e3):(0,o.localize)(101,null,Math.round(a)/1e3):c<_?l?(0,o.localize)(102,null,Math.round(a/(1e3*t))):(0,o.localize)(103,null,Math.round(a/(1e3*t))):c<g?l?(0,o.localize)(104,null,Math.round(a/(1e3*_))):(0,o.localize)(105,null,Math.round(a/(1e3*_))):(0,o.localize)(106,null,Math.round(a/(1e3*g)))}function m(a){return a.getFullYear()+"-"+String(a.getMonth()+1).padStart(2,"0")+"-"+String(a.getDate()).padStart(2,"0")+"T"+String(a.getHours()).padStart(2,"0")+":"+String(a.getMinutes()).padStart(2,"0")+":"+String(a.getSeconds()).padStart(2,"0")+"."+(a.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(he[59],fe([0,1,17,10,8]),function(ie,e,o,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=w,e.$wj=r,e.$xj=v,o=Ae(o),t=Ae(t),_=Ae(_);function g(f,m){return m&&(f.stack||f.stacktrace)?_.localize(107,null,A(f),j(f.stack)||j(f.stacktrace)):A(f)}function j(f){return Array.isArray(f)?f.join(`
`):f}function A(f){return f.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${f.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?_.localize(108,null,f.message):f.message||_.localize(109,null)}function w(f=null,m=!1){if(!f)return _.localize(110,null);if(Array.isArray(f)){const a=o.$Lb(f),l=w(a[0],m);return a.length>1?_.localize(111,null,l,a.length):l}if(t.$jg(f))return f;if(f.detail){const a=f.detail;if(a.error)return g(a.error,m);if(a.exception)return g(a.exception,m)}return f.stack?g(f,m):f.message?f.message:_.localize(112,null)}function r(f){const m=f;return m instanceof Error&&Array.isArray(m.actions)}function v(f,m){let a;return typeof f=="string"?a=new Error(f):a=f,a.actions=m,a}}),define(he[3],fe([0,1,8]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=e.$H=e.OS=e.OperatingSystem=e.$E=e.$D=e.$C=e.$B=e.$A=e.Language=e.$z=e.$y=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.Platform=e.$j=void 0,e.$k=n,e.$G=k,e.$M=M,o=Ae(o),e.$j="en";let t=!1,_=!1,g=!1,j=!1,A=!1,w=!1,r=!1,v=!1,f=!1,m=!1,a,l=e.$j,c=e.$j,d,$;const s=globalThis;let b;typeof s.vscode<"u"&&typeof s.vscode.process<"u"?b=s.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(b=process);const E=typeof b?.versions?.electron=="string",P=E&&b?.type==="renderer";if(typeof b=="object"){t=b.platform==="win32",_=b.platform==="darwin",g=b.platform==="linux",j=g&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,r=E,f=!!b.env.CI||!!b.env.BUILD_ARTIFACTSTAGINGDIRECTORY,a=e.$j,l=e.$j;const C=b.env.VSCODE_NLS_CONFIG;if(C)try{const D=JSON.parse(C);a=D.userLocale,c=D.osLocale,l=D.resolvedLanguage||e.$j,d=D.languagePack?.translationsConfigFile}catch{}A=!0}else typeof navigator=="object"&&!P?($=navigator.userAgent,t=$.indexOf("Windows")>=0,_=$.indexOf("Macintosh")>=0,v=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,g=$.indexOf("Linux")>=0,m=$?.indexOf("Mobi")>=0,w=!0,l=o.getNLSLanguage()||e.$j,a=navigator.language.toLowerCase(),c=a):console.error("Unable to resolve platform.");var i;(function(C){C[C.Web=0]="Web",C[C.Mac=1]="Mac",C[C.Linux=2]="Linux",C[C.Windows=3]="Windows"})(i||(e.Platform=i={}));function n(C){switch(C){case i.Web:return"Web";case i.Mac:return"Mac";case i.Linux:return"Linux";case i.Windows:return"Windows"}}let h=i.Web;_?h=i.Mac:t?h=i.Windows:g&&(h=i.Linux),e.$l=t,e.$m=_,e.$n=g,e.$o=j,e.$p=A,e.$q=r,e.$r=w,e.$s=w&&typeof s.importScripts=="function",e.$t=e.$s?s.origin:void 0,e.$u=v,e.$v=m,e.$w=f,e.$x=h,e.$y=$,e.$z=l;var R;(function(C){function D(){return e.$z}C.value=D;function y(){return e.$z.length===2?e.$z==="en":e.$z.length>=3?e.$z[0]==="e"&&e.$z[1]==="n"&&e.$z[2]==="-":!1}C.isDefaultVariant=y;function T(){return e.$z==="en"}C.isDefault=T})(R||(e.Language=R={})),e.$A=a,e.$B=c,e.$C=d,e.$D=typeof s.postMessage=="function"&&!s.importScripts,e.$E=(()=>{if(e.$D){const C=[];s.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let T=0,I=C.length;T<I;T++){const S=C[T];if(S.id===y.data.vscodeScheduleAsyncWork){C.splice(T,1),S.callback();return}}});let D=0;return y=>{const T=++D;C.push({id:T,callback:y}),s.postMessage({vscodeScheduleAsyncWork:T},"*")}}return C=>setTimeout(C)})();var W;(function(C){C[C.Windows=1]="Windows",C[C.Macintosh=2]="Macintosh",C[C.Linux=3]="Linux"})(W||(e.OperatingSystem=W={})),e.OS=_||v?W.Macintosh:t?W.Windows:W.Linux;let p=!0,L=!1;function k(){if(!L){L=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,p=new Uint16Array(C.buffer)[0]===513}return p}e.$H=!!(e.$y&&e.$y.indexOf("Chrome")>=0),e.$I=!!(e.$y&&e.$y.indexOf("Firefox")>=0),e.$J=!!(!e.$H&&e.$y&&e.$y.indexOf("Safari")>=0),e.$K=!!(e.$y&&e.$y.indexOf("Edg/")>=0),e.$L=!!(e.$y&&e.$y.indexOf("Android")>=0);function M(C){return parseFloat(C)>=20}}),define(he[15],fe([0,1,3]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jc=e.$ic=e.env=e.cwd=void 0;let t;const _=globalThis.vscode;if(typeof _<"u"&&typeof _.process<"u"){const g=_.process;t={get platform(){return g.platform},get arch(){return g.arch},get env(){return g.env},cwd(){return g.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return o.$l?"win32":o.$m?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.$ic=t.platform,e.$jc=t.arch}),define(he[5],fe([0,1,15]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yc=e.sep=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=void 0,o=Ae(o);const t=65,_=97,g=90,j=122,A=46,w=47,r=92,v=58,f=63;class m extends Error{constructor(h,R,W){let p;typeof R=="string"&&R.indexOf("not ")===0?(p="must not be",R=R.replace(/^not /,"")):p="must be";const L=h.indexOf(".")!==-1?"property":"argument";let k=`The "${h}" ${L} ${p} of type ${R}`;k+=`. Received type ${typeof W}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function a(n,h){if(n===null||typeof n!="object")throw new m(h,"Object",n)}function l(n,h){if(typeof n!="string")throw new m(h,"string",n)}const c=o.$ic==="win32";function d(n){return n===w||n===r}function $(n){return n===w}function s(n){return n>=t&&n<=g||n>=_&&n<=j}function b(n,h,R,W){let p="",L=0,k=-1,M=0,C=0;for(let D=0;D<=n.length;++D){if(D<n.length)C=n.charCodeAt(D);else{if(W(C))break;C=w}if(W(C)){if(!(k===D-1||M===1))if(M===2){if(p.length<2||L!==2||p.charCodeAt(p.length-1)!==A||p.charCodeAt(p.length-2)!==A){if(p.length>2){const y=p.lastIndexOf(R);y===-1?(p="",L=0):(p=p.slice(0,y),L=p.length-1-p.lastIndexOf(R)),k=D,M=0;continue}else if(p.length!==0){p="",L=0,k=D,M=0;continue}}h&&(p+=p.length>0?`${R}..`:"..",L=2)}else p.length>0?p+=`${R}${n.slice(k+1,D)}`:p=n.slice(k+1,D),L=D-k-1;k=D,M=0}else C===A&&M!==-1?++M:M=-1}return p}function E(n){return n?`${n[0]==="."?"":"."}${n}`:""}function P(n,h){a(h,"pathObject");const R=h.dir||h.root,W=h.base||`${h.name||""}${E(h.ext)}`;return R?R===h.root?`${R}${W}`:`${R}${n}${W}`:W}e.$kc={resolve(...n){let h="",R="",W=!1;for(let p=n.length-1;p>=-1;p--){let L;if(p>=0){if(L=n[p],l(L,`paths[${p}]`),L.length===0)continue}else h.length===0?L=o.cwd():(L=o.env[`=${h}`]||o.cwd(),(L===void 0||L.slice(0,2).toLowerCase()!==h.toLowerCase()&&L.charCodeAt(2)===r)&&(L=`${h}\\`));const k=L.length;let M=0,C="",D=!1;const y=L.charCodeAt(0);if(k===1)d(y)&&(M=1,D=!0);else if(d(y))if(D=!0,d(L.charCodeAt(1))){let T=2,I=T;for(;T<k&&!d(L.charCodeAt(T));)T++;if(T<k&&T!==I){const S=L.slice(I,T);for(I=T;T<k&&d(L.charCodeAt(T));)T++;if(T<k&&T!==I){for(I=T;T<k&&!d(L.charCodeAt(T));)T++;(T===k||T!==I)&&(C=`\\\\${S}\\${L.slice(I,T)}`,M=T)}}}else M=1;else s(y)&&L.charCodeAt(1)===v&&(C=L.slice(0,2),M=2,k>2&&d(L.charCodeAt(2))&&(D=!0,M=3));if(C.length>0)if(h.length>0){if(C.toLowerCase()!==h.toLowerCase())continue}else h=C;if(W){if(h.length>0)break}else if(R=`${L.slice(M)}\\${R}`,W=D,D&&h.length>0)break}return R=b(R,!W,"\\",d),W?`${h}\\${R}`:`${h}${R}`||"."},normalize(n){l(n,"path");const h=n.length;if(h===0)return".";let R=0,W,p=!1;const L=n.charCodeAt(0);if(h===1)return $(L)?"\\":n;if(d(L))if(p=!0,d(n.charCodeAt(1))){let M=2,C=M;for(;M<h&&!d(n.charCodeAt(M));)M++;if(M<h&&M!==C){const D=n.slice(C,M);for(C=M;M<h&&d(n.charCodeAt(M));)M++;if(M<h&&M!==C){for(C=M;M<h&&!d(n.charCodeAt(M));)M++;if(M===h)return`\\\\${D}\\${n.slice(C)}\\`;M!==C&&(W=`\\\\${D}\\${n.slice(C,M)}`,R=M)}}}else R=1;else s(L)&&n.charCodeAt(1)===v&&(W=n.slice(0,2),R=2,h>2&&d(n.charCodeAt(2))&&(p=!0,R=3));let k=R<h?b(n.slice(R),!p,"\\",d):"";return k.length===0&&!p&&(k="."),k.length>0&&d(n.charCodeAt(h-1))&&(k+="\\"),W===void 0?p?`\\${k}`:k:p?`${W}\\${k}`:`${W}${k}`},isAbsolute(n){l(n,"path");const h=n.length;if(h===0)return!1;const R=n.charCodeAt(0);return d(R)||h>2&&s(R)&&n.charCodeAt(1)===v&&d(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let h,R;for(let L=0;L<n.length;++L){const k=n[L];l(k,"path"),k.length>0&&(h===void 0?h=R=k:h+=`\\${k}`)}if(h===void 0)return".";let W=!0,p=0;if(typeof R=="string"&&d(R.charCodeAt(0))){++p;const L=R.length;L>1&&d(R.charCodeAt(1))&&(++p,L>2&&(d(R.charCodeAt(2))?++p:W=!1))}if(W){for(;p<h.length&&d(h.charCodeAt(p));)p++;p>=2&&(h=`\\${h.slice(p)}`)}return e.$kc.normalize(h)},relative(n,h){if(l(n,"from"),l(h,"to"),n===h)return"";const R=e.$kc.resolve(n),W=e.$kc.resolve(h);if(R===W||(n=R.toLowerCase(),h=W.toLowerCase(),n===h))return"";let p=0;for(;p<n.length&&n.charCodeAt(p)===r;)p++;let L=n.length;for(;L-1>p&&n.charCodeAt(L-1)===r;)L--;const k=L-p;let M=0;for(;M<h.length&&h.charCodeAt(M)===r;)M++;let C=h.length;for(;C-1>M&&h.charCodeAt(C-1)===r;)C--;const D=C-M,y=k<D?k:D;let T=-1,I=0;for(;I<y;I++){const F=n.charCodeAt(p+I);if(F!==h.charCodeAt(M+I))break;F===r&&(T=I)}if(I!==y){if(T===-1)return W}else{if(D>y){if(h.charCodeAt(M+I)===r)return W.slice(M+I+1);if(I===2)return W.slice(M+I)}k>y&&(n.charCodeAt(p+I)===r?T=I:I===2&&(T=3)),T===-1&&(T=0)}let S="";for(I=p+T+1;I<=L;++I)(I===L||n.charCodeAt(I)===r)&&(S+=S.length===0?"..":"\\..");return M+=T,S.length>0?`${S}${W.slice(M,C)}`:(W.charCodeAt(M)===r&&++M,W.slice(M,C))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const h=e.$kc.resolve(n);if(h.length<=2)return n;if(h.charCodeAt(0)===r){if(h.charCodeAt(1)===r){const R=h.charCodeAt(2);if(R!==f&&R!==A)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(s(h.charCodeAt(0))&&h.charCodeAt(1)===v&&h.charCodeAt(2)===r)return`\\\\?\\${h}`;return n},dirname(n){l(n,"path");const h=n.length;if(h===0)return".";let R=-1,W=0;const p=n.charCodeAt(0);if(h===1)return d(p)?n:".";if(d(p)){if(R=W=1,d(n.charCodeAt(1))){let M=2,C=M;for(;M<h&&!d(n.charCodeAt(M));)M++;if(M<h&&M!==C){for(C=M;M<h&&d(n.charCodeAt(M));)M++;if(M<h&&M!==C){for(C=M;M<h&&!d(n.charCodeAt(M));)M++;if(M===h)return n;M!==C&&(R=W=M+1)}}}}else s(p)&&n.charCodeAt(1)===v&&(R=h>2&&d(n.charCodeAt(2))?3:2,W=R);let L=-1,k=!0;for(let M=h-1;M>=W;--M)if(d(n.charCodeAt(M))){if(!k){L=M;break}}else k=!1;if(L===-1){if(R===-1)return".";L=R}return n.slice(0,L)},basename(n,h){h!==void 0&&l(h,"suffix"),l(n,"path");let R=0,W=-1,p=!0,L;if(n.length>=2&&s(n.charCodeAt(0))&&n.charCodeAt(1)===v&&(R=2),h!==void 0&&h.length>0&&h.length<=n.length){if(h===n)return"";let k=h.length-1,M=-1;for(L=n.length-1;L>=R;--L){const C=n.charCodeAt(L);if(d(C)){if(!p){R=L+1;break}}else M===-1&&(p=!1,M=L+1),k>=0&&(C===h.charCodeAt(k)?--k===-1&&(W=L):(k=-1,W=M))}return R===W?W=M:W===-1&&(W=n.length),n.slice(R,W)}for(L=n.length-1;L>=R;--L)if(d(n.charCodeAt(L))){if(!p){R=L+1;break}}else W===-1&&(p=!1,W=L+1);return W===-1?"":n.slice(R,W)},extname(n){l(n,"path");let h=0,R=-1,W=0,p=-1,L=!0,k=0;n.length>=2&&n.charCodeAt(1)===v&&s(n.charCodeAt(0))&&(h=W=2);for(let M=n.length-1;M>=h;--M){const C=n.charCodeAt(M);if(d(C)){if(!L){W=M+1;break}continue}p===-1&&(L=!1,p=M+1),C===A?R===-1?R=M:k!==1&&(k=1):R!==-1&&(k=-1)}return R===-1||p===-1||k===0||k===1&&R===p-1&&R===W+1?"":n.slice(R,p)},format:P.bind(null,"\\"),parse(n){l(n,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return h;const R=n.length;let W=0,p=n.charCodeAt(0);if(R===1)return d(p)?(h.root=h.dir=n,h):(h.base=h.name=n,h);if(d(p)){if(W=1,d(n.charCodeAt(1))){let T=2,I=T;for(;T<R&&!d(n.charCodeAt(T));)T++;if(T<R&&T!==I){for(I=T;T<R&&d(n.charCodeAt(T));)T++;if(T<R&&T!==I){for(I=T;T<R&&!d(n.charCodeAt(T));)T++;T===R?W=T:T!==I&&(W=T+1)}}}}else if(s(p)&&n.charCodeAt(1)===v){if(R<=2)return h.root=h.dir=n,h;if(W=2,d(n.charCodeAt(2))){if(R===3)return h.root=h.dir=n,h;W=3}}W>0&&(h.root=n.slice(0,W));let L=-1,k=W,M=-1,C=!0,D=n.length-1,y=0;for(;D>=W;--D){if(p=n.charCodeAt(D),d(p)){if(!C){k=D+1;break}continue}M===-1&&(C=!1,M=D+1),p===A?L===-1?L=D:y!==1&&(y=1):L!==-1&&(y=-1)}return M!==-1&&(L===-1||y===0||y===1&&L===M-1&&L===k+1?h.base=h.name=n.slice(k,M):(h.name=n.slice(k,L),h.base=n.slice(k,M),h.ext=n.slice(L,M))),k>0&&k!==W?h.dir=n.slice(0,k-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(c){const n=/\\/g;return()=>{const h=o.cwd().replace(n,"/");return h.slice(h.indexOf("/"))}}return()=>o.cwd()})();e.$lc={resolve(...n){let h="",R=!1;for(let W=n.length-1;W>=-1&&!R;W--){const p=W>=0?n[W]:i();l(p,`paths[${W}]`),p.length!==0&&(h=`${p}/${h}`,R=p.charCodeAt(0)===w)}return h=b(h,!R,"/",$),R?`/${h}`:h.length>0?h:"."},normalize(n){if(l(n,"path"),n.length===0)return".";const h=n.charCodeAt(0)===w,R=n.charCodeAt(n.length-1)===w;return n=b(n,!h,"/",$),n.length===0?h?"/":R?"./":".":(R&&(n+="/"),h?`/${n}`:n)},isAbsolute(n){return l(n,"path"),n.length>0&&n.charCodeAt(0)===w},join(...n){if(n.length===0)return".";let h;for(let R=0;R<n.length;++R){const W=n[R];l(W,"path"),W.length>0&&(h===void 0?h=W:h+=`/${W}`)}return h===void 0?".":e.$lc.normalize(h)},relative(n,h){if(l(n,"from"),l(h,"to"),n===h||(n=e.$lc.resolve(n),h=e.$lc.resolve(h),n===h))return"";const R=1,W=n.length,p=W-R,L=1,k=h.length-L,M=p<k?p:k;let C=-1,D=0;for(;D<M;D++){const T=n.charCodeAt(R+D);if(T!==h.charCodeAt(L+D))break;T===w&&(C=D)}if(D===M)if(k>M){if(h.charCodeAt(L+D)===w)return h.slice(L+D+1);if(D===0)return h.slice(L+D)}else p>M&&(n.charCodeAt(R+D)===w?C=D:D===0&&(C=0));let y="";for(D=R+C+1;D<=W;++D)(D===W||n.charCodeAt(D)===w)&&(y+=y.length===0?"..":"/..");return`${y}${h.slice(L+C)}`},toNamespacedPath(n){return n},dirname(n){if(l(n,"path"),n.length===0)return".";const h=n.charCodeAt(0)===w;let R=-1,W=!0;for(let p=n.length-1;p>=1;--p)if(n.charCodeAt(p)===w){if(!W){R=p;break}}else W=!1;return R===-1?h?"/":".":h&&R===1?"//":n.slice(0,R)},basename(n,h){h!==void 0&&l(h,"ext"),l(n,"path");let R=0,W=-1,p=!0,L;if(h!==void 0&&h.length>0&&h.length<=n.length){if(h===n)return"";let k=h.length-1,M=-1;for(L=n.length-1;L>=0;--L){const C=n.charCodeAt(L);if(C===w){if(!p){R=L+1;break}}else M===-1&&(p=!1,M=L+1),k>=0&&(C===h.charCodeAt(k)?--k===-1&&(W=L):(k=-1,W=M))}return R===W?W=M:W===-1&&(W=n.length),n.slice(R,W)}for(L=n.length-1;L>=0;--L)if(n.charCodeAt(L)===w){if(!p){R=L+1;break}}else W===-1&&(p=!1,W=L+1);return W===-1?"":n.slice(R,W)},extname(n){l(n,"path");let h=-1,R=0,W=-1,p=!0,L=0;for(let k=n.length-1;k>=0;--k){const M=n.charCodeAt(k);if(M===w){if(!p){R=k+1;break}continue}W===-1&&(p=!1,W=k+1),M===A?h===-1?h=k:L!==1&&(L=1):h!==-1&&(L=-1)}return h===-1||W===-1||L===0||L===1&&h===W-1&&h===R+1?"":n.slice(h,W)},format:P.bind(null,"/"),parse(n){l(n,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return h;const R=n.charCodeAt(0)===w;let W;R?(h.root="/",W=1):W=0;let p=-1,L=0,k=-1,M=!0,C=n.length-1,D=0;for(;C>=W;--C){const y=n.charCodeAt(C);if(y===w){if(!M){L=C+1;break}continue}k===-1&&(M=!1,k=C+1),y===A?p===-1?p=C:D!==1&&(D=1):p!==-1&&(D=-1)}if(k!==-1){const y=L===0&&R?1:L;p===-1||D===0||D===1&&p===k-1&&p===L+1?h.base=h.name=n.slice(y,k):(h.name=n.slice(y,p),h.base=n.slice(y,k),h.ext=n.slice(p,k))}return L>0?h.dir=n.slice(0,L-1):R&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.$lc.win32=e.$kc.win32=e.$kc,e.$lc.posix=e.$kc.posix=e.$lc,e.$mc=c?e.$kc.normalize:e.$lc.normalize,e.$nc=c?e.$kc.isAbsolute:e.$lc.isAbsolute,e.$oc=c?e.$kc.join:e.$lc.join,e.$pc=c?e.$kc.resolve:e.$lc.resolve,e.$qc=c?e.$kc.relative:e.$lc.relative,e.$rc=c?e.$kc.dirname:e.$lc.dirname,e.$sc=c?e.$kc.basename:e.$lc.basename,e.$tc=c?e.$kc.extname:e.$lc.extname,e.$uc=c?e.$kc.format:e.$lc.format,e.$vc=c?e.$kc.parse:e.$lc.parse,e.$wc=c?e.$kc.toNamespacedPath:e.$lc.toNamespacedPath,e.sep=c?e.$kc.sep:e.$lc.sep,e.$yc=c?e.$kc.delimiter:e.$lc.delimiter}),define(he[35],fe([0,1,13,5,3,11,10]),function(ie,e,o,t,_,g,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=A,e.$Dg=w,e.$Eg=r,e.$Fg=v,e.$Gg=f,e.$Hg=c,e.$Ig=d,e.$Jg=$,e.$Kg=s,e.$Lg=b,e.$Mg=E,e.$Ng=P,e.$Og=i,e.$Pg=n,e.$Qg=h,e.$Rg=R,e.$Sg=L;function A(k){return k===o.CharCode.Slash||k===o.CharCode.Backslash}function w(k){return k.replace(/[\\/]/g,t.$lc.sep)}function r(k){return k.indexOf("/")===-1&&(k=w(k)),/^[a-zA-Z]:(\/|$)/.test(k)&&(k="/"+k),k}function v(k,M=t.$lc.sep){if(!k)return"";const C=k.length,D=k.charCodeAt(0);if(A(D)){if(A(k.charCodeAt(1))&&!A(k.charCodeAt(2))){let T=3;const I=T;for(;T<C&&!A(k.charCodeAt(T));T++);if(I!==T&&!A(k.charCodeAt(T+1))){for(T+=1;T<C;T++)if(A(k.charCodeAt(T)))return k.slice(0,T+1).replace(/[\\/]/g,M)}}return M}else if(s(D)&&k.charCodeAt(1)===o.CharCode.Colon)return A(k.charCodeAt(2))?k.slice(0,2)+M:k.slice(0,2);let y=k.indexOf("://");if(y!==-1){for(y+=3;y<C;y++)if(A(k.charCodeAt(y)))return k.slice(0,y+1)}return""}function f(k){if(!_.$l||!k||k.length<5)return!1;let M=k.charCodeAt(0);if(M!==o.CharCode.Backslash||(M=k.charCodeAt(1),M!==o.CharCode.Backslash))return!1;let C=2;const D=C;for(;C<k.length&&(M=k.charCodeAt(C),M!==o.CharCode.Backslash);C++);return!(D===C||(M=k.charCodeAt(C+1),isNaN(M)||M===o.CharCode.Backslash))}const m=/[\\/:\*\?"<>\|]/g,a=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(k,M=_.$l){const C=M?m:a;return!(!k||k.length===0||/^\s+$/.test(k)||(C.lastIndex=0,C.test(k))||M&&l.test(k)||k==="."||k===".."||M&&k[k.length-1]==="."||M&&k.length!==k.trim().length||k.length>255)}function d(k,M,C){const D=k===M;return!C||D?D:!k||!M?!1:(0,g.$Kf)(k,M)}function $(k,M,C,D=t.sep){if(k===M)return!0;if(!k||!M||M.length>k.length)return!1;if(C){if(!(0,g.$Lf)(k,M))return!1;if(M.length===k.length)return!0;let T=M.length;return M.charAt(M.length-1)===D&&T--,k.charAt(T)===D}return M.charAt(M.length-1)!==D&&(M+=D),k.indexOf(M)===0}function s(k){return k>=o.CharCode.A&&k<=o.CharCode.Z||k>=o.CharCode.a&&k<=o.CharCode.z}function b(k,M){return _.$l&&k.endsWith(":")&&(k+=t.sep),(0,t.$nc)(k)||(k=(0,t.$oc)(M,k)),k=(0,t.$mc)(k),E(k)}function E(k){return _.$l?(k=(0,g.$sf)(k,t.sep),k.endsWith(":")&&(k+=t.sep)):(k=(0,g.$sf)(k,t.sep),k||(k=t.sep)),k}function P(k){const M=(0,t.$mc)(k);return _.$l?k.length>3?!1:i(M)&&(k.length===2||M.charCodeAt(2)===o.CharCode.Backslash):M===t.$lc.sep}function i(k,M=_.$l){return M?s(k.charCodeAt(0))&&k.charCodeAt(1)===o.CharCode.Colon:!1}function n(k,M=_.$l){return i(k,M)?k[0]:void 0}function h(k,M,C){return M.length>k.length?-1:k===M?0:(C&&(k=k.toLowerCase(),M=M.toLowerCase()),k.indexOf(M))}function R(k){const M=k.split(":");let C,D,y;for(const T of M){const I=Number(T);(0,j.$ng)(I)?D===void 0?D=I:y===void 0&&(y=I):C=C?[C,T].join(":"):T}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:D!==void 0?D:void 0,column:y!==void 0?y:D!==void 0?1:void 0}}const W="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",p="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function L(k,M,C=8){let D="";for(let T=0;T<C;T++){let I;T===0&&_.$l&&!M&&(C===3||C===4)?I=p:I=W,D+=I.charAt(Math.floor(Math.random()*I.length))}let y;return M?y=`${M}-${D}`:y=D,k?(0,t.$oc)(k,y):y}}),define(he[36],fe([0,1,3]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$qm=g,e.$rm=j;var t;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(t||(e.Source=t={}));var _;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(_||(e.TerminateResponseCode=_={}));function g(A,...w){const r=w.reduce((m,a)=>(m[a]=!0,m),{}),v=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(m=>!r[m]).forEach(m=>{for(let a=0;a<v.length;a++)if(m.search(v[a])!==-1){delete A[m];break}})}function j(A){A&&(delete A.DEBUG,o.$n&&delete A.LD_PRELOAD)}}),define(he[6],fe([0,1,13,27,5,3]),function(ie,e,o,t,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$Ac=d,e.$Bc=i,_=Ae(_);const j=/^\w[\w\d+.-]*$/,A=/^\//,w=/^\/\//;function r(p,L){if(!p.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${p.authority}", path: "${p.path}", query: "${p.query}", fragment: "${p.fragment}"}`);if(p.scheme&&!j.test(p.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(p.path){if(p.authority){if(!A.test(p.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(p.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(p,L){return!p&&!L?"file":p}function f(p,L){switch(p){case"https":case"http":case"file":L?L[0]!==a&&(L=a+L):L=a;break}return L}const m="",a="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(L){return L instanceof c?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,k,M,C,D,y=!1){typeof L=="object"?(this.scheme=L.scheme||m,this.authority=L.authority||m,this.path=L.path||m,this.query=L.query||m,this.fragment=L.fragment||m):(this.scheme=v(L,y),this.authority=k||m,this.path=f(this.scheme,M||m),this.query=C||m,this.fragment=D||m,r(this,y))}get fsPath(){return i(this,!1)}with(L){if(!L)return this;let{scheme:k,authority:M,path:C,query:D,fragment:y}=L;return k===void 0?k=this.scheme:k===null&&(k=m),M===void 0?M=this.authority:M===null&&(M=m),C===void 0?C=this.path:C===null&&(C=m),D===void 0?D=this.query:D===null&&(D=m),y===void 0?y=this.fragment:y===null&&(y=m),k===this.scheme&&M===this.authority&&C===this.path&&D===this.query&&y===this.fragment?this:new s(k,M,C,D,y)}static parse(L,k=!1){const M=l.exec(L);return M?new s(M[2]||m,W(M[4]||m),W(M[5]||m),W(M[7]||m),W(M[9]||m),k):new s(m,m,m,m,m)}static file(L){let k=m;if(g.$l&&(L=L.replace(/\\/g,a)),L[0]===a&&L[1]===a){const M=L.indexOf(a,2);M===-1?(k=L.substring(2),L=a):(k=L.substring(2,M),L=L.substring(M)||a)}return new s("file",k,L,m,m)}static from(L,k){return new s(L.scheme,L.authority,L.path,L.query,L.fragment,k)}static joinPath(L,...k){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return g.$l&&L.scheme==="file"?M=c.file(_.$kc.join(i(L,!0),...k)).path:M=_.$lc.join(L.path,...k),L.with({path:M})}toString(L=!1){return n(this,L)}toJSON(){return this}static revive(L){if(L){if(L instanceof c)return L;{const k=new s(L);return k._formatted=L.external??null,k._fsPath=L._sep===$?L.fsPath??null:null,k}}else return L}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=c;function d(p){return!p||typeof p!="object"?!1:typeof p.scheme=="string"&&(typeof p.authority=="string"||typeof p.authority>"u")&&(typeof p.path=="string"||typeof p.path>"u")&&(typeof p.query=="string"||typeof p.query>"u")&&(typeof p.fragment=="string"||typeof p.fragment>"u")}const $=g.$l?1:void 0;class s extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(L=!1){return L?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const L={$mid:t.MarshalledId.Uri};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=$),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const b={[o.CharCode.Colon]:"%3A",[o.CharCode.Slash]:"%2F",[o.CharCode.QuestionMark]:"%3F",[o.CharCode.Hash]:"%23",[o.CharCode.OpenSquareBracket]:"%5B",[o.CharCode.CloseSquareBracket]:"%5D",[o.CharCode.AtSign]:"%40",[o.CharCode.ExclamationMark]:"%21",[o.CharCode.DollarSign]:"%24",[o.CharCode.Ampersand]:"%26",[o.CharCode.SingleQuote]:"%27",[o.CharCode.OpenParen]:"%28",[o.CharCode.CloseParen]:"%29",[o.CharCode.Asterisk]:"%2A",[o.CharCode.Plus]:"%2B",[o.CharCode.Comma]:"%2C",[o.CharCode.Semicolon]:"%3B",[o.CharCode.Equals]:"%3D",[o.CharCode.Space]:"%20"};function E(p,L,k){let M,C=-1;for(let D=0;D<p.length;D++){const y=p.charCodeAt(D);if(y>=o.CharCode.a&&y<=o.CharCode.z||y>=o.CharCode.A&&y<=o.CharCode.Z||y>=o.CharCode.Digit0&&y<=o.CharCode.Digit9||y===o.CharCode.Dash||y===o.CharCode.Period||y===o.CharCode.Underline||y===o.CharCode.Tilde||L&&y===o.CharCode.Slash||k&&y===o.CharCode.OpenSquareBracket||k&&y===o.CharCode.CloseSquareBracket||k&&y===o.CharCode.Colon)C!==-1&&(M+=encodeURIComponent(p.substring(C,D)),C=-1),M!==void 0&&(M+=p.charAt(D));else{M===void 0&&(M=p.substr(0,D));const T=b[y];T!==void 0?(C!==-1&&(M+=encodeURIComponent(p.substring(C,D)),C=-1),M+=T):C===-1&&(C=D)}}return C!==-1&&(M+=encodeURIComponent(p.substring(C))),M!==void 0?M:p}function P(p){let L;for(let k=0;k<p.length;k++){const M=p.charCodeAt(k);M===o.CharCode.Hash||M===o.CharCode.QuestionMark?(L===void 0&&(L=p.substr(0,k)),L+=b[M]):L!==void 0&&(L+=p[k])}return L!==void 0?L:p}function i(p,L){let k;return p.authority&&p.path.length>1&&p.scheme==="file"?k=`//${p.authority}${p.path}`:p.path.charCodeAt(0)===o.CharCode.Slash&&(p.path.charCodeAt(1)>=o.CharCode.A&&p.path.charCodeAt(1)<=o.CharCode.Z||p.path.charCodeAt(1)>=o.CharCode.a&&p.path.charCodeAt(1)<=o.CharCode.z)&&p.path.charCodeAt(2)===o.CharCode.Colon?L?k=p.path.substr(1):k=p.path[1].toLowerCase()+p.path.substr(2):k=p.path,g.$l&&(k=k.replace(/\//g,"\\")),k}function n(p,L){const k=L?P:E;let M="",{scheme:C,authority:D,path:y,query:T,fragment:I}=p;if(C&&(M+=C,M+=":"),(D||C==="file")&&(M+=a,M+=a),D){let S=D.indexOf("@");if(S!==-1){const F=D.substr(0,S);D=D.substr(S+1),S=F.lastIndexOf(":"),S===-1?M+=k(F,!1,!1):(M+=k(F.substr(0,S),!1,!1),M+=":",M+=k(F.substr(S+1),!1,!0)),M+="@"}D=D.toLowerCase(),S=D.lastIndexOf(":"),S===-1?M+=k(D,!1,!0):(M+=k(D.substr(0,S),!1,!0),M+=D.substr(S))}if(y){if(y.length>=3&&y.charCodeAt(0)===o.CharCode.Slash&&y.charCodeAt(2)===o.CharCode.Colon){const S=y.charCodeAt(1);S>=o.CharCode.A&&S<=o.CharCode.Z&&(y=`/${String.fromCharCode(S+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===o.CharCode.Colon){const S=y.charCodeAt(0);S>=o.CharCode.A&&S<=o.CharCode.Z&&(y=`${String.fromCharCode(S+32)}:${y.substr(2)}`)}M+=k(y,!0,!1)}return T&&(M+="?",M+=k(T,!1,!1)),I&&(M+="#",M+=L?I:E(I,!1,!1)),M}function h(p){try{return decodeURIComponent(p)}catch{return p.length>3?p.substr(0,3)+h(p.substr(3)):p}}const R=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function W(p){return p.match(R)?p.replace(R,L=>h(L)):p}}),define(he[60],fe([0,1,6]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=t,e.$mr=_,e.$nr=g,e.log=A;function t(r){const v=r;return v&&typeof v.type=="string"&&typeof v.severity=="string"}function _(r){const v=[];let f;try{const m=JSON.parse(r.arguments),a=m[m.length-1];a&&a.__$stack&&(m.pop(),f=a.__$stack),v.push(...m)}catch{v.push("Unable to log remote console arguments",r.arguments)}return{args:v,stack:f}}function g(r){if(typeof r!="string")return g(_(r).stack);const v=r;if(v){const f=j(v),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(f||"");if(m&&m.length===4)return{uri:o.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function j(r){if(!r)return r;const v=r.indexOf(`
`);return v===-1?r:r.substring(0,v)}function A(r,v){const{args:f,stack:m}=_(r),a=typeof f[0]=="string"&&f.length===1;let l=j(m);l&&(l=`(${l.trim()})`);let c=[];if(typeof f[0]=="string"?l&&a?c=[`%c[${v}] %c${f[0]} %c${l}`,w("blue"),w(""),w("grey")]:c=[`%c[${v}] %c${f[0]}`,w("blue"),w(""),...f.slice(1)]:c=[`%c[${v}]%`,w("blue"),...f],l&&!a&&c.push(l),typeof console[r.severity]!="function")throw new Error("Unknown console method");console[r.severity].apply(console,c)}function w(r){return`color: ${r}`}}),define(he[61],fe([0,1,19,6,27]),function(ie,e,o,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=g,e.$gi=j,e.$hi=w;function g(r){return JSON.stringify(r,A)}function j(r){let v=JSON.parse(r);return v=w(v),v}function A(r,v){return v instanceof RegExp?{$mid:_.MarshalledId.Regexp,source:v.source,flags:v.flags}:v}function w(r,v=0){if(!r||v>200)return r;if(typeof r=="object"){switch(r.$mid){case _.MarshalledId.Uri:return t.URI.revive(r);case _.MarshalledId.Regexp:return new RegExp(r.source,r.flags);case _.MarshalledId.Date:return new Date(r.source)}if(r instanceof o.$Se||r instanceof Uint8Array)return r;if(Array.isArray(r))for(let f=0;f<r.length;++f)r[f]=w(r[f],v+1);else for(const f in r)Object.hasOwnProperty.call(r,f)&&(r[f]=w(r[f],v+1))}return r}}),define(he[20],fe([0,1,7,3,11,6,5]),function(ie,e,o,t,_,g,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Xg=e.$Wg=e.$Vg=e.Schemas=void 0,e.$Tg=w,e.$Ug=r,e.$Yg=f,o=Ae(o),t=Ae(t),j=Ae(j);var A;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",l.vscodeNotebookMetadata="vscode-notebook-metadata",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting",l.outputChannel="output"})(A||(e.Schemas=A={}));function w(l,c){return g.URI.isUri(l)?(0,_.$Kf)(l.scheme,c):(0,_.$Lf)(l,c+":")}function r(l,...c){return c.some(d=>w(l,d))}e.$Vg="vscode-tkn",e.$Wg="tkn";class v{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c,d){this.f=f(c,d)}getServerRootPath(){return this.f}get g(){return j.$lc.join(this.f,A.vscodeRemoteResource)}set(c,d,$){this.a[c]=d,this.b[c]=$}setConnectionToken(c,d){this.c[c]=d}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(P){return o.$4(P),c}const d=c.authority;let $=this.a[d];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const s=this.b[d],b=this.c[d];let E=`path=${encodeURIComponent(c.path)}`;return typeof b=="string"&&(E+=`&${e.$Wg}=${encodeURIComponent(b)}`),g.URI.from({scheme:t.$r?this.d:A.vscodeRemoteResource,authority:`${$}:${s}`,path:this.g,query:E})}}e.$Xg=new v;function f(l,c){return j.$lc.join(c??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.$Zg="vs/../../extensions",e.$1g="vs/../../node_modules",e.$2g="vs/../../node_modules.asar",e.$3g="vs/../../node_modules.asar.unpacked",e.$4g="vscode-app";class m{static{this.a=e.$4g}asBrowserUri(c){const d=this.b(c,ie);return this.uriToBrowserUri(d)}uriToBrowserUri(c){return c.scheme===A.vscodeRemote?e.$Xg.rewrite(c):c.scheme===A.file&&(t.$p||t.$t===`${A.vscodeFileResource}://${m.a}`)?c.with({scheme:A.vscodeFileResource,authority:c.authority||m.a,query:null,fragment:null}):c}asFileUri(c){const d=this.b(c,ie);return this.uriToFileUri(d)}uriToFileUri(c){return c.scheme===A.vscodeFileResource?c.with({scheme:A.file,authority:c.authority!==m.a?c.authority:null,query:null,fragment:null}):c}b(c,d){if(g.URI.isUri(c))return c;if(globalThis._VSCODE_FILE_ROOT){const $=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test($))return g.URI.joinPath(g.URI.parse($,!0),c);const s=j.$oc($,c);return g.URI.file(s)}return g.URI.parse(d.toUrl(c))}}e.$5g=new m;var a;(function(l){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(c.get("3"));const d="vscode-coi";function $(b){let E;typeof b=="string"?E=new URL(b).searchParams:b instanceof URL?E=b.searchParams:g.URI.isUri(b)&&(E=new URL(b.toString(!0)).searchParams);const P=E?.get(d);if(P)return c.get(P)}l.getHeadersFromQuery=$;function s(b,E,P){if(!globalThis.crossOriginIsolated)return;const i=E&&P?"3":P?"2":"1";b instanceof URLSearchParams?b.set(d,i):b[d]=i}l.addSearchParam=s})(a||(e.COI=a={}))}),define(he[25],fe([0,1,13,35,20,5,3,11,6]),function(ie,e,o,t,_,g,j,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=void 0,e.$_g=r,e.$uh=f,e.$vh=a,t=Ae(t),g=Ae(g);function r(l){return(0,w.$Bc)(l,!0)}class v{constructor(c){this.a=c}compare(c,d,$=!1){return c===d?0:(0,A.$Df)(this.getComparisonKey(c,$),this.getComparisonKey(d,$))}isEqual(c,d,$=!1){return c===d?!0:!c||!d?!1:this.getComparisonKey(c,$)===this.getComparisonKey(d,$)}getComparisonKey(c,d=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,d,$=!1){if(c.scheme===d.scheme){if(c.scheme===_.Schemas.file)return t.$Jg(r(c),r(d),this.a(c))&&c.query===d.query&&($||c.fragment===d.fragment);if((0,e.$qh)(c.authority,d.authority))return t.$Jg(c.path,d.path,this.a(c),"/")&&c.query===d.query&&($||c.fragment===d.fragment)}return!1}joinPath(c,...d){return w.URI.joinPath(c,...d)}basenameOrAuthority(c){return(0,e.$ih)(c)||c.authority}basename(c){return g.$lc.basename(c.path)}extname(c){return g.$lc.extname(c.path)}dirname(c){if(c.path.length===0)return c;let d;return c.scheme===_.Schemas.file?d=w.URI.file(g.$rc(r(c))).path:(d=g.$lc.dirname(c.path),c.authority&&d.length&&d.charCodeAt(0)!==o.CharCode.Slash&&(console.error(`dirname("${c.toString})) resulted in a relative path`),d="/")),c.with({path:d})}normalizePath(c){if(!c.path.length)return c;let d;return c.scheme===_.Schemas.file?d=w.URI.file(g.$mc(r(c))).path:d=g.$lc.normalize(c.path),c.with({path:d})}relativePath(c,d){if(c.scheme!==d.scheme||!(0,e.$qh)(c.authority,d.authority))return;if(c.scheme===_.Schemas.file){const b=g.$qc(r(c),r(d));return j.$l?t.$Dg(b):b}let $=c.path||"/";const s=d.path||"/";if(this.a(c)){let b=0;for(const E=Math.min($.length,s.length);b<E&&!($.charCodeAt(b)!==s.charCodeAt(b)&&$.charAt(b).toLowerCase()!==s.charAt(b).toLowerCase());b++);$=s.substr(0,b)+$.substr(b)}return g.$lc.relative($,s)}resolvePath(c,d){if(c.scheme===_.Schemas.file){const $=w.URI.file(g.$pc(r(c),d));return c.with({authority:$.authority,path:$.path})}return d=t.$Eg(d),c.with({path:g.$lc.resolve(c.path,d)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,d){return c===d||c!==void 0&&d!==void 0&&(0,A.$Kf)(c,d)}hasTrailingPathSeparator(c,d=g.sep){if(c.scheme===_.Schemas.file){const $=r(c);return $.length>t.$Fg($).length&&$[$.length-1]===d}else{const $=c.path;return $.length>1&&$.charCodeAt($.length-1)===o.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,d=g.sep){return(0,e.$rh)(c,d)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,d=g.sep){let $=!1;if(c.scheme===_.Schemas.file){const s=r(c);$=s!==void 0&&s.length===t.$Fg(s).length&&s[s.length-1]===d}else{d="/";const s=c.path;$=s.length===1&&s.charCodeAt(s.length-1)===o.CharCode.Slash}return!$&&!(0,e.$rh)(c,d)?c.with({path:c.path+"/"}):c}}e.$ah=v,e.$bh=new v(()=>!1),e.$ch=new v(l=>l.scheme===_.Schemas.file?!j.$n:!0),e.$dh=new v(l=>!0),e.$eh=e.$bh.isEqual.bind(e.$bh),e.$fh=e.$bh.isEqualOrParent.bind(e.$bh),e.$gh=e.$bh.getComparisonKey.bind(e.$bh),e.$hh=e.$bh.basenameOrAuthority.bind(e.$bh),e.$ih=e.$bh.basename.bind(e.$bh),e.$jh=e.$bh.extname.bind(e.$bh),e.$kh=e.$bh.dirname.bind(e.$bh),e.$lh=e.$bh.joinPath.bind(e.$bh),e.$mh=e.$bh.normalizePath.bind(e.$bh),e.$nh=e.$bh.relativePath.bind(e.$bh),e.$oh=e.$bh.resolvePath.bind(e.$bh),e.$ph=e.$bh.isAbsolutePath.bind(e.$bh),e.$qh=e.$bh.isEqualAuthority.bind(e.$bh),e.$rh=e.$bh.hasTrailingPathSeparator.bind(e.$bh),e.$sh=e.$bh.removeTrailingPathSeparator.bind(e.$bh),e.$th=e.$bh.addTrailingPathSeparator.bind(e.$bh);function f(l,c){const d=[];for(let $=0;$<l.length;$++){const s=c(l[$]);l.some((b,E)=>E===$?!1:(0,e.$fh)(s,c(b)))||d.push(l[$])}return d}var m;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function c(d){const $=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(E=>{const[P,i]=E.split(":");P&&i&&$.set(P,i)});const b=d.path.substring(0,d.path.indexOf(";"));return b&&$.set(l.META_DATA_MIME,b),$}l.parseMetaData=c})(m||(e.DataUri=m={}));function a(l,c,d){if(c){let $=l.path;return $&&$[0]!==g.$lc.sep&&($=g.$lc.sep+$),l.with({scheme:d,authority:c,path:$})}return l.with({scheme:d})}}),define(he[12],fe([0,1,18,7,4,2,25,3,53,24]),function(ie,e,o,t,_,g,j,A,w,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$_h=e.$$h=e.$0h=e.$9h=e.Promises=e.$8h=e.$7h=e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0,e.$wh=v,e.$xh=f,e.$yh=m,e.$zh=a,e.$Ah=l,e.$Bh=c,e.$Ch=d,e.$Dh=$,e.$Lh=p,e.$Mh=L,e.$Nh=k,e.$Oh=M,e.$Ph=C,e.$5h=B,e.$ai=N;function v(U){return!!U&&typeof U.then=="function"}function f(U){const O=new o.$Be,G=U(O.token),x=new Promise((ne,$e)=>{const ve=O.token.onCancellationRequested(()=>{ve.dispose(),$e(new t.$9)});Promise.resolve(G).then(Se=>{ve.dispose(),O.dispose(),ne(Se)},Se=>{ve.dispose(),O.dispose(),$e(Se)})});return new class{cancel(){O.cancel(),O.dispose()}then(ne,$e){return x.then(ne,$e)}catch(ne){return this.then(void 0,ne)}finally(ne){return x.finally(ne)}}}function m(U,O,G){return new Promise((x,ne)=>{const $e=O.onCancellationRequested(()=>{$e.dispose(),x(G)});U.then(x,ne).finally(()=>$e.dispose())})}function a(U,O){return new Promise((G,x)=>{const ne=O.onCancellationRequested(()=>{ne.dispose(),x(new t.$9)});U.then(G,x).finally(()=>ne.dispose())})}async function l(U){let O=-1;const G=U.map((x,ne)=>x.then($e=>(O=ne,$e)));try{return await Promise.race(G)}finally{U.forEach((x,ne)=>{ne!==O&&x.cancel()})}}function c(U,O,G){let x;const ne=setTimeout(()=>{x?.(void 0),G?.()},O);return Promise.race([U.finally(()=>clearTimeout(ne)),new Promise($e=>x=$e)])}function d(U){return new Promise((O,G)=>{const x=U();v(x)?x.then(O,G):O(x)})}function $(){let U,O;return{promise:new Promise((x,ne)=>{U=x,O=ne}),resolve:U,reject:O}}class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(O){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=O,!this.b){const G=()=>{if(this.b=null,this.f)return;const x=this.queue(this.d);return this.d=null,x};this.b=new Promise(x=>{this.a.then(G,G).then(x)})}return new Promise((G,x)=>{this.b.then(G,x)})}return this.a=O(),new Promise((G,x)=>{this.a.then(ne=>{this.a=null,G(ne)},ne=>{this.a=null,x(ne)})})}dispose(){this.f=!0}}e.$Eh=s;class b{constructor(){this.a=Promise.resolve(null)}queue(O){return this.a=this.a.then(()=>O(),()=>O())}}e.$Fh=b;class E{constructor(){this.a=new Map}queue(O,G){const ne=(this.a.get(O)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(O)===ne&&this.a.delete(O)});return this.a.set(O,ne),ne}}e.$Gh=E;const P=(U,O)=>{let G=!0;const x=setTimeout(()=>{G=!1,O()},U);return{isTriggered:()=>G,dispose:()=>{clearTimeout(x),G=!1}}},i=U=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,U())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};class n{constructor(O){this.defaultDelay=O,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(O,G=this.defaultDelay){this.g=O,this.h(),this.b||(this.b=new Promise((ne,$e)=>{this.d=ne,this.f=$e}).then(()=>{if(this.b=null,this.d=null,this.g){const ne=this.g;return this.g=null,ne()}}));const x=()=>{this.a=null,this.d?.(null)};return this.a=G===w.$le?i(x):P(G,x),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.$9),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Hh=n;class h{constructor(O){this.a=new n(O),this.b=new s}trigger(O,G){return this.a.trigger(()=>this.b.queue(O),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ih=h;class R{constructor(){this.a=!1,this.b=new Promise((O,G)=>{this.d=O})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Jh=R;class W extends R{constructor(O){super(),this.f=setTimeout(()=>this.open(),O)}open(){clearTimeout(this.f),super.open()}}e.$Kh=W;function p(U,O){return O?new Promise((G,x)=>{const ne=setTimeout(()=>{$e.dispose(),G()},U),$e=O.onCancellationRequested(()=>{clearTimeout(ne),$e.dispose(),x(new t.$9)})}):f(G=>p(U,G))}function L(U,O=0,G){const x=setTimeout(()=>{U(),G&&ne.dispose()},O),ne=(0,g.$Xc)(()=>{clearTimeout(x),G?.deleteAndLeak(ne)});return G?.add(ne),ne}function k(U){const O=[];let G=0;const x=U.length;function ne(){return G<x?U[G++]():null}function $e(ve){ve!=null&&O.push(ve);const Se=ne();return Se?Se.then($e):Promise.resolve(O)}return Promise.resolve(null).then($e)}function M(U,O=x=>!!x,G=null){let x=0;const ne=U.length,$e=()=>{if(x>=ne)return Promise.resolve(G);const ve=U[x++];return Promise.resolve(ve()).then(Ie=>O(Ie)?Promise.resolve(Ie):$e())};return $e()}function C(U,O=x=>!!x,G=null){if(U.length===0)return Promise.resolve(G);let x=U.length;const ne=()=>{x=-1;for(const $e of U)$e.cancel?.()};return new Promise(($e,ve)=>{for(const Se of U)Se.then(Ie=>{--x>=0&&O(Ie)?(ne(),$e(Ie)):x===0&&$e(G)}).catch(Ie=>{--x>=0&&(ne(),ve(Ie))})})}class D{constructor(O){this.a=0,this.b=!1,this.f=O,this.g=[],this.d=0,this.h=new _.$qe}whenIdle(){return this.size>0?_.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(O){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((G,x)=>{this.g.push({factory:O,c:G,e:x}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const O=this.g.shift();this.d++;const G=O.factory();G.then(O.c,O.e),G.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Qh=D;class y extends D{constructor(){super(1)}}e.$Rh=y;class T{constructor(){this.a=new Z,this.b=0}queue(O){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,O())):this.a.run(this.b++,O())}}e.$Sh=T;class I{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const O=new q;return this.b.add(O),O.p}g(){for(const[,O]of this.a)if(O.size>0)return!1;return!0}queueSize(O,G=j.$bh){const x=G.getComparisonKey(O);return this.a.get(x)?.size??0}queueFor(O,G,x=j.$bh){const ne=x.getComparisonKey(O);let $e=this.a.get(ne);if(!$e){$e=new y;const ve=this.f++,Se=_.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(ne),this.h(),this.d?.deleteAndDispose(ve),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new g.$9c),this.d.set(ve,Se),this.a.set(ne,$e)}return $e.queue(G)}h(){this.g()&&this.j()}j(){for(const O of this.b)O.complete();this.b.clear()}dispose(){for(const[,O]of this.a)O.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Th=I;class S{constructor(O,G){this.b=!1,this.a=-1,typeof O=="function"&&typeof G=="number"&&this.setIfNotSet(O,G)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(O,G){if(this.b)throw new t.$gb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,O()},G)}setIfNotSet(O,G){if(this.b)throw new t.$gb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,O()},G))}}e.$Uh=S;class F{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(O,G,x=globalThis){if(this.f)throw new t.$gb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ne=x.setInterval(()=>{O()},G);this.d=(0,g.$Xc)(()=>{x.clearInterval(ne),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Vh=F;class J{constructor(O,G){this.b=-1,this.a=O,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(O=this.d){this.cancel(),this.b=setTimeout(this.f,O)}get delay(){return this.d}set delay(O){this.d=O}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Wh=J;class V{constructor(O,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=O,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(O=this.b){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(O/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Xh=V;class Q extends J{constructor(O,G){super(O,G),this.j=[]}work(O){this.j.push(O),this.isScheduled()||this.schedule()}h(){const O=this.j;this.j=[],this.a?.(O)}dispose(){this.j=[],super.dispose()}}e.$Yh=Q;class re extends g.$Zc{constructor(O,G){super(),this.g=O,this.h=G,this.a=[],this.b=this.B(new g.$1c),this.f=!1}get pending(){return this.a.length}work(O){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+O.length>this.g.maxBufferedWork)return!1}else if(this.pending+O.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of O)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new J(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Zh=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$2h=(U,O)=>{(0,A.$E)(()=>{if(G)return;const x=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,x-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.$2h=(U,O,G)=>{const x=U.requestIdleCallback(O,typeof G=="number"?{timeout:G}:void 0);let ne=!1;return{dispose(){ne||(ne=!0,U.cancelIdleCallback(x))}}},e.$1h=U=>(0,e.$2h)(globalThis,U)}();class ae{constructor(O,G){this.g=!1,this.d=()=>{try{this.j=G()}catch(x){this.l=x}finally{this.g=!0}},this.f=(0,e.$2h)(O,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$3h=ae;class X extends ae{constructor(O){super(globalThis,O)}}e.$4h=X;async function B(U,O,G){let x;for(let ne=0;ne<G;ne++)try{return await U()}catch($e){x=$e,await p(O)}throw x}class Z{isRunning(O){return typeof O=="number"?this.a?.taskId===O:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(O,G,x){return this.a={taskId:O,cancel:()=>x?.(),promise:G},G.then(()=>this.d(O),()=>this.d(O)),G}d(O){this.a&&O===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const O=this.b;this.b=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}queue(O){if(this.b)this.b.run=O;else{const{promise:G,resolve:x,reject:ne}=$();this.b={run:O,promise:G,promiseResolve:x,promiseReject:ne}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$6h=Z;class ee{constructor(O,G=()=>Date.now()){this.d=O,this.f=G,this.a=0,this.b=0}increment(){const O=this.f();return O-this.a>this.d&&(this.a=O,this.b=0),this.b++,this.b}}e.$7h=ee;var le;(function(U){U[U.Resolved=0]="Resolved",U[U.Rejected=1]="Rejected"})(le||(le={}));class q{get isRejected(){return this.d?.outcome===le.Rejected}get isResolved(){return this.d?.outcome===le.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===le.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((O,G)=>{this.a=O,this.b=G})}complete(O){return new Promise(G=>{this.a(O),this.d={outcome:le.Resolved,value:O},G()})}error(O){return new Promise(G=>{this.b(O),this.d={outcome:le.Rejected,value:O},G()})}cancel(){return this.error(new t.$9)}}e.$8h=q;var ce;(function(U){async function O(x){let ne;const $e=await Promise.all(x.map(ve=>ve.then(Se=>Se,Se=>{ne||(ne=Se)})));if(typeof ne<"u")throw ne;return $e}U.settled=O;function G(x){return new Promise(async(ne,$e)=>{try{await x(ne,$e)}catch(ve){$e(ve)}})}U.withAsyncBody=G})(ce||(e.Promises=ce={}));class de{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(O){this.a=void 0,this.b=void 0,this.d=!1,this.promise=O.then(G=>(this.a=G,this.d=!0,G),G=>{throw this.b=G,this.d=!0,G})}requireValue(){if(!this.d)throw new t.$gb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$9h=de;class te{constructor(O){this.b=O,this.a=new r.$Y(()=>new de(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$0h=te;var u;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(u||(u={}));class H{static fromArray(O){return new H(G=>{G.emitMany(O)})}static fromPromise(O){return new H(async G=>{G.emitMany(await O)})}static fromPromises(O){return new H(async G=>{await Promise.all(O.map(async x=>G.emitOne(await x)))})}static merge(O){return new H(async G=>{await Promise.all(O.map(async x=>{for await(const ne of x)G.emitOne(ne)}))})}static{this.EMPTY=H.fromArray([])}constructor(O,G){this.a=u.Initial,this.b=[],this.d=null,this.f=G,this.g=new _.$qe,queueMicrotask(async()=>{const x={emitOne:ne=>this.h(ne),emitMany:ne=>this.j(ne),reject:ne=>this.l(ne)};try{await Promise.resolve(O(x)),this.k()}catch(ne){this.l(ne)}finally{x.emitOne=void 0,x.emitMany=void 0,x.reject=void 0}})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this.a===u.DoneError)throw this.d;if(O<this.b.length)return{done:!1,value:this.b[O++]};if(this.a===u.DoneOK)return{done:!0,value:void 0};await _.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(O,G){return new H(async x=>{for await(const ne of O)x.emitOne(G(ne))})}map(O){return H.map(this,O)}static filter(O,G){return new H(async x=>{for await(const ne of O)G(ne)&&x.emitOne(ne)})}filter(O){return H.filter(this,O)}static coalesce(O){return H.filter(O,G=>!!G)}coalesce(){return H.coalesce(this)}static async toPromise(O){const G=[];for await(const x of O)G.push(x);return G}toPromise(){return H.toPromise(this)}h(O){this.a===u.Initial&&(this.b.push(O),this.g.fire())}j(O){this.a===u.Initial&&(this.b=this.b.concat(O),this.g.fire())}k(){this.a===u.Initial&&(this.a=u.DoneOK,this.g.fire())}l(O){this.a===u.Initial&&(this.a=u.DoneError,this.d=O,this.g.fire())}}e.$$h=H;class oe extends H{constructor(O,G){super(G),this.m=O}cancel(){this.m.cancel()}}e.$_h=oe;function N(U){const O=new o.$Be,G=U(O.token);return new oe(O,async x=>{const ne=O.token.onCancellationRequested(()=>{ne.dispose(),O.dispose(),x.reject(new t.$9)});try{for await(const $e of G){if(O.token.isCancellationRequested)return;x.emitOne($e)}ne.dispose(),O.dispose()}catch($e){ne.dispose(),O.dispose(),x.reject($e)}})}class K{constructor(O){this.a=new q,this.b=new H(ne=>{if(G){ne.reject(G);return}return x&&ne.emitMany(x),this.d=$e=>ne.reject($e),this.f=$e=>ne.emitOne($e),this.a.p},O);let G,x;this.f=ne=>{x||(x=[]),x.push(ne)},this.d=ne=>{G||(G=ne)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(O){this.d(O),this.a.complete()}emitOne(O){this.f(O)}}e.$bi=K}),define(he[62],fe([0,1,19,27,6]),function(ie,e,o,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=e.$Sn=void 0,e.$Un=w,e.$Vn=v,e.$Wn=f;function g(m){return m.toJSON()}class j{constructor(a){this.a=a}transformIncoming(a){const l=this.a.transformIncoming(a);return l===a?a:g(_.URI.from(l))}transformOutgoing(a){const l=this.a.transformOutgoing(a);return l===a?a:g(_.URI.from(l))}transformOutgoingURI(a){const l=this.a.transformOutgoing(a);return l===a?a:_.URI.from(l)}transformOutgoingScheme(a){return this.a.transformOutgoingScheme(a)}}e.$Sn=j,e.$Tn=new class{transformIncoming(m){return m}transformOutgoing(m){return m}transformOutgoingURI(m){return m}transformOutgoingScheme(m){return m}};function A(m,a,l){if(!m||l>200)return null;if(typeof m=="object"){if(m instanceof _.URI)return a.transformOutgoing(m);for(const c in m)if(Object.hasOwnProperty.call(m,c)){const d=A(m[c],a,l+1);d!==null&&(m[c]=d)}}return null}function w(m,a){const l=A(m,a,0);return l===null?m:l}function r(m,a,l,c){if(!m||c>200)return null;if(typeof m=="object"){if(m.$mid===t.MarshalledId.Uri)return l?_.URI.revive(a.transformIncoming(m)):a.transformIncoming(m);if(m instanceof o.$Se)return null;for(const d in m)if(Object.hasOwnProperty.call(m,d)){const $=r(m[d],a,l,c+1);$!==null&&(m[d]=$)}}return null}function v(m,a){const l=r(m,a,!1,0);return l===null?m:l}function f(m,a){const l=r(m,a,!0,0);return l===null?m:l}}),define(he[28],fe([0,1,37,21,101,12,35,49,5,3,25,6]),function(ie,e,o,t,_,g,j,A,w,r,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=d,e.readdirSync=b,e.whenDeleted=i,e.configureFlushOnWrite=p,e.writeFileSync=k,o=Ae(o);var m;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function a(V,Q=m.UNLINK,re){if((0,j.$Ng)(V))throw new Error("rimraf - will refuse to recursively delete root");return Q===m.UNLINK?c(V):l(V,re)}async function l(V,Q=(0,j.$Sg)((0,t.tmpdir)())){try{try{await o.promises.rename(V,Q)}catch(re){return re.code==="ENOENT"?void 0:c(V)}c(Q).catch(re=>{})}catch(re){if(re.code!=="ENOENT")throw re}}async function c(V){return o.promises.rm(V,{recursive:!0,force:!0,maxRetries:3})}function d(V){if((0,j.$Ng)(V))throw new Error("rimraf - will refuse to recursively delete root");o.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}async function $(V,Q){return E(await(Q?s(V):o.promises.readdir(V)))}async function s(V){try{return await o.promises.readdir(V,{withFileTypes:!0})}catch(ae){console.warn("[node.js fs] readdir with filetypes failed with error: ",ae)}const Q=[],re=await $(V);for(const ae of re){let X=!1,B=!1,Z=!1;try{const ee=await o.promises.lstat((0,w.$oc)(V,ae));X=ee.isFile(),B=ee.isDirectory(),Z=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}Q.push({name:ae,isFile:()=>X,isDirectory:()=>B,isSymbolicLink:()=>Z})}return Q}function b(V){return E(o.readdirSync(V))}function E(V){return V.map(Q=>typeof Q=="string"?r.$m?(0,A.$sm)(Q):Q:(Q.name=r.$m?(0,A.$sm)(Q.name):Q.name,Q))}async function P(V){const Q=await $(V),re=[];for(const ae of Q)await n.existsDirectory((0,w.$oc)(V,ae))&&re.push(ae);return re}function i(V,Q=1e3){return new Promise(re=>{let ae=!1;const X=setInterval(()=>{ae||(ae=!0,o.access(V,B=>{ae=!1,B&&(clearInterval(X),re(void 0))}))},Q)})}var n;(function(V){async function Q(X){let B;try{if(B=await o.promises.lstat(X),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await o.promises.stat(X),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(r.$l&&Z.code==="EACCES")try{return{stat:await o.promises.stat(await o.promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw ee}throw Z}}V.stat=Q;async function re(X){try{const{stat:B,symbolicLink:Z}=await V.stat(X);return B.isFile()&&Z?.dangling!==!0}catch{}return!1}V.existsFile=re;async function ae(X){try{const{stat:B,symbolicLink:Z}=await V.stat(X);return B.isDirectory()&&Z?.dangling!==!0}catch{}return!1}V.existsDirectory=ae})(n||(e.SymlinkSupport=n={}));const h=new g.$Th;function R(V,Q,re){return h.queueFor(f.URI.file(V),()=>{const ae=M(re);return new Promise((X,B)=>L(V,Q,ae,Z=>Z?B(Z):X()))},v.$ch)}let W=!0;function p(V){W=V}function L(V,Q,re,ae){if(!W)return o.writeFile(V,Q,{mode:re.mode,flag:re.flag},ae);o.open(V,re.flag,re.mode,(X,B)=>{if(X)return ae(X);o.writeFile(B,Q,Z=>{if(Z)return o.close(B,()=>ae(Z));o.fdatasync(B,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),p(!1)),o.close(B,le=>ae(le))))})})}function k(V,Q,re){const ae=M(re);if(!W)return o.writeFileSync(V,Q,{mode:ae.mode,flag:ae.flag});const X=o.openSync(V,ae.flag,ae.mode);try{o.writeFileSync(X,Q);try{o.fdatasyncSync(X)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),p(!1)}}finally{o.closeSync(X)}}function M(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function C(V,Q,re=6e4){if(V!==Q)try{r.$l&&typeof re=="number"?await D(V,Q,Date.now(),re):await o.promises.rename(V,Q)}catch(ae){if(V.toLowerCase()!==Q.toLowerCase()&&ae.code==="EXDEV"||V.endsWith("."))await y(V,Q,{preserveSymlinks:!1}),await a(V,m.MOVE);else throw ae}}async function D(V,Q,re,ae,X=0){try{return await o.promises.rename(V,Q)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-re>=ae)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${B}`),B;if(X===0){let Z=!1;try{const{stat:ee}=await n.stat(Q);ee.isFile()||(Z=!0)}catch{}if(Z)throw B}return await(0,g.$Lh)(Math.min(100,X*10)),D(V,Q,re,ae,X+1)}}async function y(V,Q,re){return I(V,Q,{root:{source:V,target:Q},options:re,handledSourcePaths:new Set})}const T=511;async function I(V,Q,re){if(re.handledSourcePaths.has(V))return;re.handledSourcePaths.add(V);const{stat:ae,symbolicLink:X}=await n.stat(V);if(X){if(re.options.preserveSymlinks)try{return await J(V,Q,re)}catch{}if(X.dangling)return}return ae.isDirectory()?S(V,Q,ae.mode&T,re):F(V,Q,ae.mode&T)}async function S(V,Q,re,ae){await o.promises.mkdir(Q,{recursive:!0,mode:re});const X=await $(V);for(const B of X)await I((0,w.$oc)(V,B),(0,w.$oc)(Q,B),ae)}async function F(V,Q,re){await o.promises.copyFile(V,Q),await o.promises.chmod(Q,re)}async function J(V,Q,re){let ae=await o.promises.readlink(V);(0,j.$Jg)(ae,re.root.source,!r.$n)&&(ae=(0,w.$oc)(re.root.target,ae.substr(re.root.source.length+1))),await o.promises.symlink(ae,Q)}e.Promises=new class{get read(){return(V,Q,re,ae,X)=>new Promise((B,Z)=>{o.read(V,Q,re,ae,X,(ee,le,q)=>ee?Z(ee):B({bytesRead:le,buffer:q}))})}get write(){return(V,Q,re,ae,X)=>new Promise((B,Z)=>{o.write(V,Q,re,ae,X,(ee,le,q)=>ee?Z(ee):B({bytesWritten:le,buffer:q}))})}get fdatasync(){return(0,_.promisify)(o.fdatasync)}get open(){return(0,_.promisify)(o.open)}get close(){return(0,_.promisify)(o.close)}get realpath(){return(0,_.promisify)(o.realpath)}async exists(V){try{return await o.promises.access(V),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return P}get writeFile(){return R}get rm(){return a}get rename(){return C}get copy(){return y}}}),define(he[63],fe([0,1,21,5,28]),function(ie,e,o,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=s,e.$Cm=b,o=Ae(o),t=Ae(t),_=Ae(_);const g=/^\d+$/,j=/^Microsoft.PowerShell_.*/,A=/^Microsoft.PowerShellPreview_.*/;var w;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(w||(w={}));let r;switch(process.arch){case"ia32":r=w.x86;break;case"arm":case"arm64":r=w.ARM;break;default:r=w.x64;break}let v;process.env.PROCESSOR_ARCHITEW6432?v=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?w.ARM:w.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?v=w.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?v=w.x86:v=w.x64;class f{constructor(P,i,n){this.exePath=P,this.displayName=i,this.a=n}async exists(){return this.a===void 0&&(this.a=await _.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:E=!1}={}){return E?r===w.x64?process.env["ProgramFiles(x86)"]||null:v===w.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function a({useAlternateBitness:E=!1,findPreview:P=!1}={}){const i=m({useAlternateBitness:E});if(!i)return null;const n=t.$oc(i,"PowerShell");if(!await _.SymlinkSupport.existsDirectory(n))return null;let h=-1,R=null;for(const L of await _.Promises.readdir(n)){let k=-1;if(P){const C=L.indexOf("-");if(C<0)continue;const D=L.substring(0,C);if(!g.test(D)||L.substring(C+1)!=="preview")continue;k=parseInt(D,10)}else{if(!g.test(L))continue;k=parseInt(L,10)}if(k<=h)continue;const M=t.$oc(n,L,"pwsh.exe");await _.SymlinkSupport.existsFile(M)&&(R=M,h=k)}if(!R)return null;const W=i.includes("x86")?" (x86)":"",p=P?" Preview":"";return new f(R,`PowerShell${p}${W}`,!0)}async function l({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const P=t.$oc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await _.SymlinkSupport.existsDirectory(P))return null;const{pwshMsixDirRegex:i,pwshMsixName:n}=E?{pwshMsixDirRegex:A,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const h of await _.Promises.readdir(P))if(i.test(h)){const R=t.$oc(P,h,"pwsh.exe");return new f(R,n)}return null}function c(){const E=t.$oc(o.homedir(),".dotnet","tools","pwsh.exe");return new f(E,".NET Core PowerShell Global Tool")}function d(){const E=t.$oc(process.env.windir,r===w.x86&&v!==w.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new f(E,"Windows PowerShell",!0)}async function*$(){let E=await a();E&&(yield E),E=await a({useAlternateBitness:!0}),E&&(yield E),E=await l(),E&&(yield E),E=c(),E&&(yield E),E=await a({findPreview:!0}),E&&(yield E),E=await l({findPreview:!0}),E&&(yield E),E=await a({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=d(),E&&(yield E)}async function*s(){for await(const E of $())await E.exists()&&(yield E)}async function b(){for await(const E of s())return E;return null}}),define(he[38],fe([0,1,37,5,3,15,36,10,28]),function(ie,e,o,t,_,g,j,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$Dm=r,e.$Em=v,t=Ae(t),_=Ae(_),g=Ae(g),A=Ae(A),w=Ae(w),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function r(m=g.env){return m.comspec||"cmd.exe"}function v(m){let a=[],l=!1;const c=function(d){if(l){a.push(d);return}(!m.send(d,s=>{if(s&&console.error(s),l=!1,a.length>0){const b=a.slice(0);a=[],b.forEach(E=>c(E))}})||_.$l)&&(l=!0)};return{send:c}}var f;(function(m){async function a(l,c,d){if(t.$nc(l))return l;if(c===void 0&&(c=g.cwd()),t.$rc(l)!=="."||(d===void 0&&A.$jg(g.env.PATH)&&(d=g.env.PATH.split(t.$yc)),d===void 0||d.length===0))return t.$oc(c,l);async function s(b){if(await w.Promises.exists(b)){let E;try{E=await o.promises.stat(b)}catch(P){P.message.startsWith("EACCES")&&(E=await o.promises.lstat(b))}return E?!E.isDirectory():!1}return!1}for(const b of d){let E;if(t.$nc(b)?E=t.$oc(b,l):E=t.$oc(c,b,l),await s(E))return E;let P=E+".com";if(await s(P)||(P=E+".exe",await s(P)))return P}return t.$oc(c,l)}m.findExecutable=a})(f||(e.win32=f={}))}),define(he[64],fe([0,1,29,20]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=_;function _(j){return new Promise((A,w)=>{let r;const v=new Map;function f(a,l,c,d,$){const s=v.get(l);if(a===j||s){const b={name:m(c),cmd:c,pid:a,ppid:l,load:d,mem:$};v.set(a,b),a===j&&(r=b),s&&(s.children||(s.children=[]),s.children.push(b),s.children.length>1&&(s.children=s.children.sort((E,P)=>E.pid-P.pid)))}}function m(a){const l=/--utility-sub-type=network/i,c=/--crashes-directory/i,d=/\\pipe\\winpty-control/i,$=/conhost\.exe.+--headless/i,s=/--type=([a-zA-Z-]+)/;if(c.exec(a))return"electron-crash-reporter";if(d.exec(a))return"winpty-agent";if($.exec(a))return"conpty-agent";let b=s.exec(a);if(b&&b.length===2)return b[1]==="renderer"?"window":b[1]==="utility"?l.exec(a)?"utility-network-service":"utility-process":b[1]==="extensionHost"?"extension-host":b[1];const E=/[a-zA-Z-]+\.js/g;let P="";do b=E.exec(a),b&&(P+=b+" ");while(b);return P&&a.indexOf("node ")<0&&a.indexOf("node.exe")<0?`electron-nodejs (${P})`:a}if(process.platform==="win32"){const a=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,c)=>{ie(["@vscode/windows-process-tree"],l,c)}).then(Ae).then(l=>{l.getProcessList(j,c=>{if(!c){w(new Error(`Root process ${j} not found`));return}l.getProcessCpuUsage(c,d=>{const $=new Map;d.forEach(s=>{const b=a(s.commandLine||"");$.set(s.pid,{name:m(b),cmd:b,pid:s.pid,ppid:s.ppid,load:s.cpu||0,mem:s.memory||0})}),r=$.get(j),r?($.forEach(s=>{const b=$.get(s.ppid);b&&(b.children||(b.children=[]),b.children.push(s))}),$.forEach(s=>{s.children&&(s.children=s.children.sort((b,E)=>b.pid-E.pid))}),A(r)):w(new Error(`Root process ${j} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let a=function(){let l=[r];const c=[];for(;l.length;){const $=l.shift();$&&(c.push($.pid),$.children&&(l=l.concat($.children)))}let d=JSON.stringify(t.$5g.asFileUri("vs/base/node/cpuUsage.sh").fsPath);d+=" "+c.join(" "),(0,o.exec)(d,{},($,s,b)=>{if($||b)w($||new Error(b.toString()));else{const E=s.toString().split(`
`);for(let P=0;P<c.length;P++){const i=v.get(c[P]);i.load=parseFloat(E[P])}if(!r){w(new Error(`Root process ${j} not found`));return}A(r)}})};(0,o.exec)("which ps",{},(l,c,d)=>{if(l||d)if(process.platform!=="linux")w(l||new Error(d.toString()));else{const $=JSON.stringify(t.$5g.asFileUri("vs/base/node/ps.sh").fsPath);(0,o.exec)($,{},(s,b,E)=>{s||E?w(s||new Error(E.toString())):(g(b,f),a())})}else{const $=c.toString().trim();(0,o.exec)(`${$} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(b,E,P)=>{b||P&&!P.includes("screen size is bogus")?w(b||new Error(P.toString())):(g(E,f),process.platform==="linux"?a():r?A(r):w(new Error(`Root process ${j} not found`)))})}})}})}function g(j,A){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,r=j.toString().split(`
`);for(const v of r){const f=w.exec(v.trim());f&&f.length===6&&A(parseInt(f[1]),parseInt(f[2]),f[5],parseFloat(f[3]),parseFloat(f[4]))}}}),define(he[65],fe([0,1,21,3,63,38]),function(ie,e,o,t,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=j,t=Ae(t),g=Ae(g);async function j(f,m){return f===t.OperatingSystem.Windows?t.$l?v():g.$Dm(m):w(f,m)}let A=null;function w(f,m){if(t.$n&&f===t.OperatingSystem.Macintosh||t.$m&&f===t.OperatingSystem.Linux)return"/bin/bash";if(!A){let a;if(t.$l)a="/bin/bash";else{if(a=m.SHELL,!a)try{a=(0,o.userInfo)().shell}catch{}a||(a="sh"),a==="/bin/false"&&(a="/bin/bash")}A=a}return A}let r=null;async function v(){return r||(r=(await(0,_.$Cm)()).exePath),r}});var me=this&&this.__decorate||function(ie,e,o,t){var _=arguments.length,g=_<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,o):t,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")g=Reflect.decorate(ie,e,o,t);else for(var A=ie.length-1;A>=0;A--)(j=ie[A])&&(g=(_<3?j(g):_>3?j(e,o,g):j(e,o))||g);return _>3&&g&&Object.defineProperty(e,o,g),g};define(he[30],fe([0,1,17,12,19,18,14,7,4,2,61,11,10]),function(ie,e,o,t,_,g,j,A,w,r,v,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.ProxyChannel=e.$si=e.$pi=e.$oi=e.$ni=e.RequestInitiator=e.$mi=e.$ji=e.$ii=void 0,e.$ki=p,e.$li=L,e.$qi=T,e.$ri=I,f=Ae(f);var a;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(a||(a={}));function l(X){switch(X){case a.Promise:return"req";case a.PromiseCancel:return"cancel";case a.EventListen:return"subscribe";case a.EventDispose:return"unsubscribe"}}var c;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(c||(c={}));function d(X){switch(X){case c.Initialize:return"init";case c.PromiseSuccess:return"reply:";case c.PromiseError:case c.PromiseErrorObj:return"replyErr:";case c.EventFire:return"event:"}}var $;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})($||($={}));function s(X){let B=0;for(let Z=0;;Z+=7){const ee=X.read(1);if(B|=(ee.buffer[0]&127)<<Z,!(ee.buffer[0]&128))return B}}const b=h(0);function E(X,B){if(B===0){X.write(b);return}let Z=0;for(let le=B;le!==0;le=le>>>7)Z++;const ee=_.$Se.alloc(Z);for(let le=0;B!==0;le++)ee.buffer[le]=B&127,B=B>>>7,B>0&&(ee.buffer[le]|=128);X.write(ee)}class P{constructor(B){this.b=B,this.a=0}read(B){const Z=this.b.slice(this.a,this.a+B);return this.a+=Z.byteLength,Z}}e.$ii=P;class i{constructor(){this.a=[]}get buffer(){return _.$Se.concat(this.a)}write(B){this.a.push(B)}}e.$ji=i;var n;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(n||(n={}));function h(X){const B=_.$Se.alloc(1);return B.writeUInt8(X,0),B}const R={Undefined:h(n.Undefined),String:h(n.String),Buffer:h(n.Buffer),VSBuffer:h(n.VSBuffer),Array:h(n.Array),Object:h(n.Object),Uint:h(n.Int)},W=typeof Buffer<"u";function p(X,B){if(typeof B>"u")X.write(R.Undefined);else if(typeof B=="string"){const Z=_.$Se.fromString(B);X.write(R.String),E(X,Z.byteLength),X.write(Z)}else if(W&&Buffer.isBuffer(B)){const Z=_.$Se.wrap(B);X.write(R.Buffer),E(X,Z.byteLength),X.write(Z)}else if(B instanceof _.$Se)X.write(R.VSBuffer),E(X,B.byteLength),X.write(B);else if(Array.isArray(B)){X.write(R.Array),E(X,B.length);for(const Z of B)p(X,Z)}else if(typeof B=="number"&&(B|0)===B)X.write(R.Uint),E(X,B);else{const Z=_.$Se.fromString(JSON.stringify(B));X.write(R.Object),E(X,Z.byteLength),X.write(Z)}}function L(X){switch(X.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return X.read(s(X)).toString();case n.Buffer:return X.read(s(X)).buffer;case n.VSBuffer:return X.read(s(X));case n.Array:{const Z=s(X),ee=[];for(let le=0;le<Z;le++)ee.push(L(X));return ee}case n.Object:return JSON.parse(X.read(s(X)).toString());case n.Int:return s(X)}}class k{constructor(B,Z,ee=null,le=1e3){this.h=B,this.j=Z,this.k=ee,this.l=le,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(q=>this.q(q)),this.m({type:c.Initialize})}registerChannel(B,Z){this.b.set(B,Z),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case c.Initialize:{const Z=this.o([B.type]);this.k?.logOutgoing(Z,0,M.OtherSide,d(B.type));return}case c.PromiseSuccess:case c.PromiseError:case c.EventFire:case c.PromiseErrorObj:{const Z=this.o([B.type,B.id],B.data);this.k?.logOutgoing(Z,B.id,M.OtherSide,d(B.type),B.data);return}}}o(B,Z=void 0){const ee=new i;return p(ee,B),p(ee,Z),this.p(ee.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const Z=new P(B),ee=L(Z),le=L(Z),q=ee[0];switch(q){case a.Promise:return this.k?.logIncoming(B.byteLength,ee[1],M.OtherSide,`${l(q)}: ${ee[2]}.${ee[3]}`,le),this.s({type:q,id:ee[1],channelName:ee[2],name:ee[3],arg:le});case a.EventListen:return this.k?.logIncoming(B.byteLength,ee[1],M.OtherSide,`${l(q)}: ${ee[2]}.${ee[3]}`,le),this.t({type:q,id:ee[1],channelName:ee[2],name:ee[3],arg:le});case a.PromiseCancel:return this.k?.logIncoming(B.byteLength,ee[1],M.OtherSide,`${l(q)}`),this.u({type:q,id:ee[1]});case a.EventDispose:return this.k?.logIncoming(B.byteLength,ee[1],M.OtherSide,`${l(q)}`),this.u({type:q,id:ee[1]})}}s(B){const Z=this.b.get(B.channelName);if(!Z){this.v(B);return}const ee=new g.$Be;let le;try{le=Z.call(this.j,B.name,B.arg,ee.token)}catch(de){le=Promise.reject(de)}const q=B.id;le.then(de=>{this.m({id:q,data:de,type:c.PromiseSuccess})},de=>{de instanceof Error?this.m({id:q,data:{message:de.message,name:de.name,stack:de.stack?de.stack.split(`
`):void 0},type:c.PromiseError}):this.m({id:q,data:de,type:c.PromiseErrorObj})}).finally(()=>{ce.dispose(),this.d.delete(B.id)});const ce=(0,r.$Xc)(()=>ee.cancel());this.d.set(B.id,ce)}t(B){const Z=this.b.get(B.channelName);if(!Z){this.v(B);return}const ee=B.id,q=Z.listen(this.j,B.name,B.arg)(ce=>this.m({id:ee,data:ce,type:c.EventFire}));this.d.set(B.id,q)}u(B){const Z=this.d.get(B.id);Z&&(Z.dispose(),this.d.delete(B.id))}v(B){let Z=this.g.get(B.channelName);Z||(Z=[],this.g.set(B.channelName,Z));const ee=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===a.Promise&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:c.PromiseError})},this.l);Z.push({request:B,timeoutTimer:ee})}w(B){const Z=this.g.get(B);if(Z){for(const ee of Z)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case a.Promise:this.s(ee.request);break;case a.EventListen:this.t(ee.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,r.$Uc)(this.d.values()),this.d.clear()}}e.$mi=k;var M;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})(M||(e.RequestInitiator=M={}));class C{constructor(B,Z=null){this.l=B,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.$qe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=Z}getChannel(B){const Z=this;return{call(ee,le,q){return Z.a?Promise.reject(new A.$9):Z.m(B,ee,le,q)},listen(ee,le){return Z.a?w.Event.None:Z.o(B,ee,le)}}}m(B,Z,ee,le=g.CancellationToken.None){const q=this.g++,ce=a.Promise,de={id:q,type:ce,channelName:B,name:Z,arg:ee};if(le.isCancellationRequested)return Promise.reject(new A.$9);let te;return new Promise((H,oe)=>{if(le.isCancellationRequested)return oe(new A.$9);const N=()=>{const G=x=>{switch(x.type){case c.PromiseSuccess:this.f.delete(q),H(x.data);break;case c.PromiseError:{this.f.delete(q);const ne=new Error(x.data.message);ne.stack=Array.isArray(x.data.stack)?x.data.stack.join(`
`):x.data.stack,ne.name=x.data.name,oe(ne);break}case c.PromiseErrorObj:this.f.delete(q),oe(x.data);break}};this.f.set(q,G),this.p(de)};let K=null;this.b===$.Idle?N():(K=(0,t.$xh)(G=>this.u()),K.then(()=>{K=null,N()}));const U=()=>{K?(K.cancel(),K=null):this.p({id:q,type:a.PromiseCancel}),oe(new A.$9)},O=le.onCancellationRequested(U);te=(0,r.$Wc)((0,r.$Xc)(U),O),this.d.add(te)}).finally(()=>{te.dispose(),this.d.delete(te)})}o(B,Z,ee){const le=this.g++,q=a.EventListen,ce={id:le,type:q,channelName:B,name:Z,arg:ee};let de=null;const te=new w.$qe({onWillAddFirstListener:()=>{de=(0,t.$xh)(H=>this.u()),de.then(()=>{de=null,this.d.add(te),this.p(ce)})},onDidRemoveLastListener:()=>{de?(de.cancel(),de=null):(this.d.delete(te),this.p({id:le,type:a.EventDispose}))}}),u=H=>te.fire(H.data);return this.f.set(le,u),te.event}p(B){switch(B.type){case a.Promise:case a.EventListen:{const Z=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(Z,B.id,M.LocalSide,`${l(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case a.PromiseCancel:case a.EventDispose:{const Z=this.q([B.type,B.id]);this.j?.logOutgoing(Z,B.id,M.LocalSide,l(B.type));return}}}q(B,Z=void 0){const ee=new i;return p(ee,B),p(ee,Z),this.r(ee.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const Z=new P(B),ee=L(Z),le=L(Z),q=ee[0];switch(q){case c.Initialize:return this.j?.logIncoming(B.byteLength,0,M.LocalSide,d(q)),this.t({type:ee[0]});case c.PromiseSuccess:case c.PromiseError:case c.EventFire:case c.PromiseErrorObj:return this.j?.logIncoming(B.byteLength,ee[1],M.LocalSide,d(q),le),this.t({type:ee[0],id:ee[1],data:le})}}t(B){if(B.type===c.Initialize){this.b=$.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,r.$Uc)(this.d.values()),this.d.clear()}}e.$ni=C,me([j.$ci],C.prototype,"onDidInitializePromise",null);class D{get connections(){const B=[];return this.f.forEach(Z=>B.push(Z)),B}constructor(B,Z,ee){this.a=new Map,this.f=new Set,this.g=new w.$qe,this.onDidAddConnection=this.g.event,this.h=new w.$qe,this.onDidRemoveConnection=this.h.event,this.j=new r.$Yc,this.j.add(B(({protocol:le,onDidClientDisconnect:q})=>{const ce=w.Event.once(le.onMessage);this.j.add(ce(de=>{const te=new P(de),u=L(te),H=new k(le,u,Z,ee),oe=new C(le,Z);this.a.forEach((K,U)=>H.registerChannel(U,K));const N={channelServer:H,channelClient:oe,ctx:u};this.f.add(N),this.g.fire(N),this.j.add(q(()=>{H.dispose(),oe.dispose(),this.f.delete(N),this.h.fire(N)}))}))}))}getChannel(B,Z){const ee=this;return{call(le,q,ce){let de;if((0,m.$xg)(Z)){const u=(0,o.$7b)(ee.connections.filter(Z));de=u?Promise.resolve(u):w.Event.toPromise(w.Event.filter(ee.onDidAddConnection,Z))}else de=Z.routeCall(ee,le,q);const te=de.then(u=>u.channelClient.getChannel(B));return T(te).call(le,q,ce)},listen(le,q){if((0,m.$xg)(Z))return ee.k(B,Z,le,q);const ce=Z.routeEvent(ee,le,q).then(de=>de.channelClient.getChannel(B));return T(ce).listen(le,q)}}}k(B,Z,ee,le){const q=this;let ce;const de=new w.$qe({onWillAddFirstListener:()=>{ce=new r.$Yc;const te=new w.$we,u=new Map,H=N=>{const U=N.channelClient.getChannel(B).listen(ee,le),O=te.add(U);u.set(N,O)},oe=N=>{const K=u.get(N);K&&(K.dispose(),u.delete(N))};q.connections.filter(Z).forEach(H),w.Event.filter(q.onDidAddConnection,Z)(H,void 0,ce),q.onDidRemoveConnection(oe,void 0,ce),te.event(de.fire,de,ce),ce.add(te)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return de.event}registerChannel(B,Z){this.a.set(B,Z);for(const ee of this.f)ee.channelServer.registerChannel(B,Z)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$oi=D;class y{constructor(B,Z,ee=null){const le=new i;p(le,Z),B.send(le.buffer),this.a=new C(B,ee),this.d=new k(B,Z,ee)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,Z){this.d.registerChannel(B,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.$pi=y;function T(X){return{call(B,Z,ee){return X.then(le=>le.call(B,Z,ee))},listen(B,Z){const ee=new w.$ze;return X.then(le=>ee.input=le.listen(B,Z)),ee.event}}}function I(X){let B=!1;return{call(Z,ee,le){return B?X.call(Z,ee,le):(0,t.$Lh)(0).then(()=>B=!0).then(()=>X.call(Z,ee,le))},listen(Z,ee){if(B)return X.listen(Z,ee);const le=new w.$ze;return(0,t.$Lh)(0).then(()=>B=!0).then(()=>le.input=X.listen(Z,ee)),le.event}}}class S{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const Z of B.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await w.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$si=S;var F;(function(X){function B(q,ce,de){const te=q,u=de&&de.disableMarshalling,H=new Map;for(const oe in te)ee(oe)&&H.set(oe,w.Event.buffer(te[oe],!0,void 0,ce));return new class{listen(oe,N,K){const U=H.get(N);if(U)return U;const O=te[N];if(typeof O=="function"){if(le(N))return O.call(te,K);if(ee(N))return H.set(N,w.Event.buffer(te[N],!0,void 0,ce)),H.get(N)}throw new A.$fb(`Event not found: ${N}`)}call(oe,N,K){const U=te[N];if(typeof U=="function"){if(!u&&Array.isArray(K))for(let G=0;G<K.length;G++)K[G]=(0,v.$hi)(K[G]);let O=U.apply(te,K);return O instanceof Promise||(O=Promise.resolve(O)),O}throw new A.$fb(`Method not found: ${N}`)}}}X.fromService=B;function Z(q,ce){const de=ce&&ce.disableMarshalling;return new Proxy({},{get(te,u){if(typeof u=="string")return ce?.properties?.has(u)?ce.properties.get(u):le(u)?function(H){return q.listen(u,H)}:ee(u)?q.listen(u):async function(...H){let oe;ce&&!(0,m.$sg)(ce.context)?oe=[ce.context,...H]:oe=H;const N=await q.call(u,oe);return de?N:(0,v.$hi)(N)};throw new A.$fb(`Property not found: ${String(u)}`)}})}X.toService=Z;function ee(q){return q[0]==="o"&&q[1]==="n"&&f.$Jf(q.charCodeAt(2))}function le(q){return/^onDynamic/.test(q)&&f.$Jf(q.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const J=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const B=X.toString();if(B!=="[object Object]")return B}return X}function Q(X){return Array.isArray(X)?X.map(V):V(X)}function re(X,B,Z,ee,le,q,ce){ce=Q(ce);const de=J[le],te=de[ee%de.length];let u=[`%c[${X}]%c[${String(B).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${te}`];/\($/.test(q)?(u=u.concat(ce),u.push(")")):u.push(ce),console.log.apply(console,u)}class ae{constructor(B,Z){this.d=B,this.f=Z,this.a=0,this.b=0}logOutgoing(B,Z,ee,le,q){this.b+=B,re(this.d,this.b,B,Z,ee,le,q)}logIncoming(B,Z,ee,le,q){this.a+=B,re(this.f,this.a,B,Z,ee,le,q)}}e.$ti=ae}),define(he[66],fe([0,1,29,12,19,18,60,7,4,2,32,38,36,30]),function(ie,e,o,t,_,g,j,A,w,r,v,f,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0,A=Ae(A);class l extends a.$mi{constructor($){super({send:s=>{try{process.send?.(s.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",s=>_.$Se.wrap(Buffer.from(s,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$pr=l;class c{constructor($,s){this.i=$,this.j=s,this.c=new Set,this.g=new Map,this.h=new w.$qe,this.onDidProcessExit=this.h.event;const b=s&&s.timeout?s.timeout:6e4;this.b=new t.$Hh(b),this.d=null,this.f=null}getChannel($){const s=this;return{call(b,E,P){return s.k($,b,E,P)},listen(b,E){return s.l($,b,E)}}}k($,s,b,E=g.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(A.$0());this.b.cancel();const P=this.n($),i=(0,t.$xh)(R=>P.call(s,b,R)),n=E.onCancellationRequested(()=>i.cancel()),h=(0,r.$Xc)(()=>i.cancel());return this.c.add(h),i.finally(()=>{n.dispose(),this.c.delete(h),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l($,s,b){if(!this.b)return w.Event.None;this.b.cancel();let E;const P=new w.$qe({onWillAddFirstListener:()=>{E=this.n($).listen(s,b)(P.fire,P),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return P.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],s=Object.create(null);s.env={...(0,v.$ko)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(s.env={...s.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(s.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(s.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(s.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),s.execArgv===void 0&&(s.execArgv=process.execArgv.filter(p=>!/^--inspect(-brk)?=/.test(p)).filter(p=>!p.startsWith("--vscode-"))),(0,m.$rm)(s.env),this.d=(0,o.fork)(this.i,$,s);const b=new w.$qe,P=w.Event.fromNodeEventEmitter(this.d,"message",p=>p)(p=>{if((0,j.$lr)(p)){(0,j.log)(p,`IPC Library: ${this.j.serverName}`);return}b.fire(_.$Se.wrap(Buffer.from(p,"base64")))}),i=this.j.useQueue?(0,f.$Em)(this.d):this.d,n=p=>this.d&&this.d.connected&&i.send(p.buffer.toString("base64")),h=b.event,R={send:n,onMessage:h};this.f=new a.$ni(R);const W=()=>this.o();process.once("exit",W),this.d.on("error",p=>console.warn('IPC "'+this.j.serverName+'" errored with '+p)),this.d.on("exit",(p,L)=>{process.removeListener("exit",W),P.dispose(),this.c.forEach(k=>(0,r.$Uc)(k)),this.c.clear(),p!==0&&L!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+p+" and signal "+L),this.b?.cancel(),this.o(),this.h.fire({code:p,signal:L})})}return this.f}n($){let s=this.g.get($);return s||(s=this.m.getChannel($),this.g.set($,s)),s}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$qr=c}),define(he[67],fe([0,1,33,19,30,4,10,17]),function(ie,e,o,t,_,g,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AY=void 0,e.$BY=v;class w{constructor(m){this.a=m,this.onMessage=g.Event.fromNodeEventEmitter(this.a,"message",a=>a.data?t.$Se.wrap(a.data):t.$Se.alloc(0)),m.start()}send(m){this.a.postMessage(m.buffer)}disconnect(){this.a.close()}}class r extends _.$oi{static b(m){(0,j.$tg)((0,o.$zY)(process),"Electron Utility Process");const a=new g.$qe;return process.parentPort.on("message",l=>{if(m?.handledClientConnection(l))return;const c=(0,A.$Sb)(l.ports);c&&a.fire(c)}),g.Event.map(a.event,l=>({protocol:new w(l),onDidClientDisconnect:g.Event.fromNodeEventEmitter(l,"close")}))}constructor(m){super(r.b(m))}}e.$AY=r;function v(f,m,a){const l=c=>{c.data===m&&(f.removeListener("message",l),a())};f.on("message",l)}}),define(he[68],fe([0,1,13,7,8]),function(ie,e,o,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.TokenType=void 0;var g;(function(v){v[v.LParen=0]="LParen",v[v.RParen=1]="RParen",v[v.Neg=2]="Neg",v[v.Eq=3]="Eq",v[v.NotEq=4]="NotEq",v[v.Lt=5]="Lt",v[v.LtEq=6]="LtEq",v[v.Gt=7]="Gt",v[v.GtEq=8]="GtEq",v[v.RegexOp=9]="RegexOp",v[v.RegexStr=10]="RegexStr",v[v.True=11]="True",v[v.False=12]="False",v[v.In=13]="In",v[v.Not=14]="Not",v[v.And=15]="And",v[v.Or=16]="Or",v[v.Str=17]="Str",v[v.QuotedStr=18]="QuotedStr",v[v.Error=19]="Error",v[v.EOF=20]="EOF"})(g||(e.TokenType=g={}));function j(...v){switch(v.length){case 1:return(0,_.localize)(1693,null,v[0]);case 2:return(0,_.localize)(1694,null,v[0],v[1]);case 3:return(0,_.localize)(1695,null,v[0],v[1],v[2]);default:return}}const A=(0,_.localize)(1696,null),w=(0,_.localize)(1697,null);class r{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(f){switch(f.type){case g.LParen:return"(";case g.RParen:return")";case g.Neg:return"!";case g.Eq:return f.isTripleEq?"===":"==";case g.NotEq:return f.isTripleEq?"!==":"!=";case g.Lt:return"<";case g.LtEq:return"<=";case g.Gt:return">=";case g.GtEq:return">=";case g.RegexOp:return"=~";case g.RegexStr:return f.lexeme;case g.True:return"true";case g.False:return"false";case g.In:return"in";case g.Not:return"not";case g.And:return"&&";case g.Or:return"||";case g.Str:return f.lexeme;case g.QuotedStr:return f.lexeme;case g.Error:return f.lexeme;case g.EOF:return"EOF";default:throw(0,t.$_)(`unhandled token type: ${JSON.stringify(f)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(f=>f.charCodeAt(0)))}static{this.b=new Map([["not",g.Not],["in",g.In],["false",g.False],["true",g.True]])}get errors(){return this.g}reset(f){return this.c=f,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case o.CharCode.OpenParen:this.k(g.LParen);break;case o.CharCode.CloseParen:this.k(g.RParen);break;case o.CharCode.ExclamationMark:if(this.h(o.CharCode.Equals)){const m=this.h(o.CharCode.Equals);this.f.push({type:g.NotEq,offset:this.d,isTripleEq:m})}else this.k(g.Neg);break;case o.CharCode.SingleQuote:this.o();break;case o.CharCode.Slash:this.q();break;case o.CharCode.Equals:if(this.h(o.CharCode.Equals)){const m=this.h(o.CharCode.Equals);this.f.push({type:g.Eq,offset:this.d,isTripleEq:m})}else this.h(o.CharCode.Tilde)?this.k(g.RegexOp):this.l(j("==","=~"));break;case o.CharCode.LessThan:this.k(this.h(o.CharCode.Equals)?g.LtEq:g.Lt);break;case o.CharCode.GreaterThan:this.k(this.h(o.CharCode.Equals)?g.GtEq:g.Gt);break;case o.CharCode.Ampersand:this.h(o.CharCode.Ampersand)?this.k(g.And):this.l(j("&&"));break;case o.CharCode.Pipe:this.h(o.CharCode.Pipe)?this.k(g.Or):this.l(j("||"));break;case o.CharCode.Space:case o.CharCode.CarriageReturn:case o.CharCode.Tab:case o.CharCode.LineFeed:case o.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(g.EOF),Array.from(this.f)}h(f){return this.r()||this.c.charCodeAt(this.e)!==f?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?o.CharCode.Null:this.c.charCodeAt(this.e)}k(f){this.f.push({type:f,offset:this.d})}l(f){const m=this.d,a=this.c.substring(this.d,this.e),l={type:g.Error,offset:this.d,lexeme:a};this.g.push({offset:m,lexeme:a,additionalInfo:f}),this.f.push(l)}n(){this.m.lastIndex=this.d;const f=this.m.exec(this.c);if(f){this.e=this.d+f[0].length;const m=this.c.substring(this.d,this.e),a=r.b.get(m);a?this.k(a):this.f.push({type:g.Str,lexeme:m,offset:this.d})}}o(){for(;this.j()!==o.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:g.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let f=this.e,m=!1,a=!1;for(;;){if(f>=this.c.length){this.e=f,this.l(w);return}const c=this.c.charCodeAt(f);if(m)m=!1;else if(c===o.CharCode.Slash&&!a){f++;break}else c===o.CharCode.OpenSquareBracket?a=!0:c===o.CharCode.Backslash?m=!0:c===o.CharCode.CloseSquareBracket&&(a=!1);f++}for(;f<this.c.length&&r.a.has(this.c.charCodeAt(f));)f++;this.e=f;const l=this.c.substring(this.d,this.e);this.f.push({type:g.RegexStr,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fj=r}),define(he[69],fe([0,1,58,14,20,5,15,25,6]),function(ie,e,o,t,_,g,j,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=void 0,e.$an=v,e.$bn=f,e.$$m=/^([^.]+\..+)[:=](.+)$/;class r{get appRoot(){return(0,g.$rc)(_.$5g.asFileUri("").fsPath)}get userHome(){return w.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return w.URI.file((0,g.$oc)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.b.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,A.$lh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:_.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,A.$lh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const a=(0,o.$0m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,g.$oc)(this.userDataPath,"logs",a)}return w.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,A.$lh)(w.URI.file((0,g.$oc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,A.$lh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,A.$lh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,A.$lh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const a=j.env.VSCODE_PORTABLE;return a?w.URI.file((0,g.$oc)(a,"argv.json")):(0,A.$lh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,g.$oc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const a=this.args["builtin-extensions-dir"];return a?(0,g.$pc)(a):(0,g.$mc)((0,g.$oc)(_.$5g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const a=this.args["extensions-download-dir"];return a?w.URI.file((0,g.$pc)(a)):w.URI.file((0,g.$oc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const a=this.args["extensions-dir"];if(a)return(0,g.$pc)(a);const l=j.env.VSCODE_EXTENSIONS;if(l)return l;const c=j.env.VSCODE_PORTABLE;return c?(0,g.$oc)(c,"extensions"):(0,A.$lh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const a=this.args.extensionDevelopmentPath;if(Array.isArray(a))return a.map(l=>/^[^:/?#]+?:\/\//.test(l)?w.URI.parse(l):w.URI.file((0,g.$mc)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(a=>a==="ui"||a==="workspace"||a==="web"?a:"workspace")}get extensionTestsLocationURI(){const a=this.args.extensionTestsPath;if(a)return/^[^:/?#]+?:\/\//.test(a)?w.URI.parse(a):w.URI.file((0,g.$mc)(a))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const a=this.args["disable-extension"];if(a){if(typeof a=="string")return[a];if(Array.isArray(a)&&a.length>0)return a}return!1}get debugExtensionHost(){return v(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(a=>!e.$$m.test(a))}get extensionLogLevel(){const a=[];for(const l of this.args.log||[]){const c=e.$$m.exec(l);c&&c[1]&&c[2]&&a.push([c[1],c[2]])}return a.length?a:void 0}get serviceMachineIdResource(){return(0,A.$lh)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const a=j.env.VSCODE_PORTABLE;return a?w.URI.file((0,g.$oc)(a,"policy.json")):(0,A.$lh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(a){this.args.continueOn=a}get args(){return this.a}constructor(a,l,c){this.a=a,this.b=l,this.c=c,this.editSessionId=this.args.editSessionId}}e.$_m=r,me([t.$ci],r.prototype,"appRoot",null),me([t.$ci],r.prototype,"userHome",null),me([t.$ci],r.prototype,"userDataPath",null),me([t.$ci],r.prototype,"appSettingsHome",null),me([t.$ci],r.prototype,"tmpDir",null),me([t.$ci],r.prototype,"cacheHome",null),me([t.$ci],r.prototype,"stateResource",null),me([t.$ci],r.prototype,"userRoamingDataHome",null),me([t.$ci],r.prototype,"userDataSyncHome",null),me([t.$ci],r.prototype,"sync",null),me([t.$ci],r.prototype,"machineSettingsResource",null),me([t.$ci],r.prototype,"workspaceStorageHome",null),me([t.$ci],r.prototype,"localHistoryHome",null),me([t.$ci],r.prototype,"keyboardLayoutResource",null),me([t.$ci],r.prototype,"argvResource",null),me([t.$ci],r.prototype,"isExtensionDevelopment",null),me([t.$ci],r.prototype,"untitledWorkspacesHome",null),me([t.$ci],r.prototype,"builtinExtensionsPath",null),me([t.$ci],r.prototype,"extensionsPath",null),me([t.$ci],r.prototype,"extensionDevelopmentLocationURI",null),me([t.$ci],r.prototype,"extensionDevelopmentKind",null),me([t.$ci],r.prototype,"extensionTestsLocationURI",null),me([t.$ci],r.prototype,"debugExtensionHost",null),me([t.$ci],r.prototype,"logLevel",null),me([t.$ci],r.prototype,"extensionLogLevel",null),me([t.$ci],r.prototype,"serviceMachineIdResource",null),me([t.$ci],r.prototype,"disableTelemetry",null),me([t.$ci],r.prototype,"disableWorkspaceTrust",null),me([t.$ci],r.prototype,"useInMemorySecretStorage",null),me([t.$ci],r.prototype,"policyFile",null);function v(m,a){return f(m["inspect-extensions"],m["inspect-brk-extensions"],5870,a,m.debugId,m.extensionEnvironment)}function f(m,a,l,c,d,$){const b=Number(a||m)||(c?null:l),E=b?!!a:!1;let P;if($)try{P=JSON.parse($)}catch{}return{port:b,break:E,debugId:d,env:P}}});var Ke=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(he[70],fe([0,1,102,3,8]),function(ie,e,o,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=void 0,e.$Im=A,e.$Jm=r,e.$Km=a,e.$Lm=l,o=Ke(o);const g={o:(0,_.localize)(1713,null),e:(0,_.localize)(1714,null),t:(0,_.localize)(1715,null)};e.$Gm=["tunnel","serve-web"],e.$Hm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,_.localize)(1716,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,_.localize)(1717,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,_.localize)(1718,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,_.localize)(1719,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,_.localize)(1720,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,_.localize)(1721,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,_.localize)(1722,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,_.localize)(1723,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,_.localize)(1724,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,_.localize)(1725,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,_.localize)(1726,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,_.localize)(1727,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,_.localize)(1728,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,_.localize)(1729,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,_.localize)(1730,null)},"show-versions":{type:"boolean",cat:"e",description:(0,_.localize)(1731,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,_.localize)(1732,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,_.localize)(1733,null)},"pre-release":{type:"boolean",cat:"e",description:(0,_.localize)(1734,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,_.localize)(1735,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,_.localize)(1736,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,_.localize)(1737,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,_.localize)(1738,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,_.localize)(1739,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,_.localize)(1740,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,_.localize)(1741,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,_.localize)(1742,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,_.localize)(1743,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,_.localize)(1744,null)},sync:{type:"string",cat:"t",description:(0,_.localize)(1745,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,_.localize)(1746,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,_.localize)(1747,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,_.localize)(1748,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,_.localize)(1749,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,_.localize)(1750,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,_.localize)(1751,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const j={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function A(c,d,$=j){const s=c.find(p=>p.length>0&&p[0]!=="-"),b={},E=["_"],P=[],i={};let n;for(const p in d){const L=d[p];L.type==="subcommand"?p===s&&(n=L):(L.alias&&(b[p]=L.alias),L.type==="string"||L.type==="string[]"?(E.push(p),L.deprecates&&E.push(...L.deprecates)):L.type==="boolean"&&(P.push(p),L.deprecates&&P.push(...L.deprecates)),L.global&&(i[p]=L))}if(n&&s){const p=i;for(const C in n.options)p[C]=n.options[C];const L=c.filter(C=>C!==s),k=$.getSubcommandReporter?$.getSubcommandReporter(s):void 0,M=A(L,p,k);return{[s]:M,_:[]}}const h=(0,o.default)(c,{string:E,boolean:P,alias:b}),R={},W=h;R._=h._.map(p=>String(p)).filter(p=>p.length>0),delete W._;for(const p in d){const L=d[p];if(L.type==="subcommand")continue;L.alias&&delete W[L.alias];let k=W[p];if(L.deprecates)for(const M of L.deprecates)W.hasOwnProperty(M)&&(k||(k=W[M],k&&$.onDeprecatedOption(M,L.deprecationMessage||(0,_.localize)(1752,null,p))),delete W[M]);if(typeof k<"u"){if(L.type==="string[]"){if(Array.isArray(k)||(k=[k]),!L.allowEmptyValue){const M=k.filter(C=>C.length>0);M.length!==k.length&&($.onEmptyValue(p),k=M.length>0?M:void 0)}}else L.type==="string"&&(Array.isArray(k)?(k=k.pop(),$.onMultipleValues(p,k)):!k&&!L.allowEmptyValue&&($.onEmptyValue(p),k=void 0));R[p]=k,L.deprecationMessage&&$.onDeprecatedOption(p,L.deprecationMessage)}delete W[p]}for(const p in W)$.onUnknownOption(p);return R}function w(c,d){let $="";return d.args&&(Array.isArray(d.args)?$=` <${d.args.join("> <")}>`:$=` <${d.args}>`),d.alias?`-${d.alias} --${c}${$}`:`--${c}${$}`}function r(c,d){const $=[];for(const s in c){const b=c[s],E=w(s,b);$.push([E,b.description])}return v($,d)}function v(c,d){const s=c.reduce((P,i)=>Math.max(P,i[0].length),12)+2+1;if(d-s<25)return c.reduce((P,i)=>P.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const b=d-s-1,E=[];for(const P of c){const i=P[0],n=m(P[1],b),h=f(s-i.length-2);E.push("  "+i+h+n[0]);for(let R=1;R<n.length;R++)E.push(f(s)+n[R])}return E}function f(c){return" ".repeat(c)}function m(c,d){const $=[];for(;c.length;){const s=c.length<d?c.length:c.lastIndexOf(" ",d),b=c.slice(0,s).trim();c=c.slice(s),$.push(b)}return $}function a(c,d,$,s,b){const E=process.stdout.isTTY&&process.stdout.columns||80,P=b?.noInputFiles!==!0?`[${(0,_.localize)(1753,null)}...]`:"",i=[`${c} ${$}`];i.push(""),i.push(`${(0,_.localize)(1754,null)}: ${d} [${(0,_.localize)(1755,null)}]${P}`),i.push(""),b?.noPipe!==!0&&(t.$l?i.push((0,_.localize)(1756,null,d)):i.push((0,_.localize)(1757,null,d)),i.push(""));const n={},h=[];for(const R in s){const W=s[R];if(W.type==="subcommand")W.description&&h.push({command:R,description:W.description});else if(W.description&&W.cat){let p=n[W.cat];p||(n[W.cat]=p={}),p[R]=W}}for(const R in n){const W=R,p=n[W];p&&(i.push(g[W]),i.push(...r(p,E)),i.push(""))}return h.length&&(i.push((0,_.localize)(1758,null)),i.push(...v(h.map(R=>[R.command,R.description]),E)),i.push("")),i.join(`
`)}function l(c,d){return`${c||(0,_.localize)(1759,null)}
${d||(0,_.localize)(1760,null)}
${process.arch}`}}),function(){function ie(e,o,t){function _(j,A){const w=g(j,A),r=[w];return e.isAbsolute(w)||r.unshift(t),e.resolve(...r)}function g(j,A){process.env.VSCODE_DEV&&(A="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let r=process.env.VSCODE_APPDATA;if(r)return e.join(r,A);const v=j["user-data-dir"];if(v)return v;switch(process.platform){case"win32":if(r=process.env.APPDATA,!r){const f=process.env.USERPROFILE;if(typeof f!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");r=e.join(f,"AppData","Roaming")}break;case"darwin":r=e.join(o.homedir(),"Library","Application Support");break;case"linux":r=process.env.XDG_CONFIG_HOME||e.join(o.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(r,A)}return{getUserDataPath:_}}if(typeof define=="function")define(he[71],fe([72,21,15]),function(e,o,t){return ie(e,o,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),o=require("os");module.exports=ie(e,o,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(he[73],fe([0,1,21,69,71]),function(ie,e,o,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=void 0,e.$dn=j,e.$en=A;class g extends t.$_m{constructor(r,v){super(r,{homeDir:(0,o.homedir)(),tmpDir:(0,o.tmpdir)(),userDataDir:(0,_.getUserDataPath)(r,v.nameShort)},v)}}e.$cn=g;function j(w,r){return(0,t.$bn)(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,r,w.extensionEnvironment)}function A(w,r){return(0,t.$bn)(w["inspect-sharedprocess"],w["inspect-brk-sharedprocess"],5879,r,w.extensionEnvironment)}}),define(he[22],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e._util=void 0,e.$Ki=_,e.$Li=g;var o;(function(j){j.serviceIds=new Map,j.DI_TARGET="$di$target",j.DI_DEPENDENCIES="$di$dependencies";function A(w){return w[j.DI_DEPENDENCIES]||[]}j.getServiceDependencies=A})(o||(e._util=o={})),e.$Ji=_("instantiationService");function t(j,A,w){A[o.DI_TARGET]===A?A[o.DI_DEPENDENCIES].push({id:j,index:w}):(A[o.DI_DEPENDENCIES]=[{id:j,index:w}],A[o.DI_TARGET]=A)}function _(j){if(o.serviceIds.has(j))return o.serviceIds.get(j);const A=function(w,r,v){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(A,w,v)};return A.toString=()=>j,o.serviceIds.set(j,A),A}function g(j){return j}}),define(he[39],fe([0,1,13,3,11,68,22,8,7]),function(ie,e,o,t,_,g,j,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Ij=e.$Hj=e.ContextKeyExprType=void 0,e.$Gj=v,e.$Jj=h,e.$Kj=R,e.$4j=q;const r=new Map;r.set("false",!1),r.set("true",!0),r.set("isMac",t.$m),r.set("isLinux",t.$n),r.set("isWindows",t.$l),r.set("isWeb",t.$r),r.set("isMacNative",t.$m&&!t.$r),r.set("isEdge",t.$K),r.set("isFirefox",t.$I),r.set("isChrome",t.$H),r.set("isSafari",t.$J);function v(te,u){if(r.get(te)!==void 0)throw(0,w.$$)("contextkey.setConstant(k, v) invoked with already set constant `k`");r.set(te,u)}const f=Object.prototype.hasOwnProperty;var m;(function(te){te[te.False=0]="False",te[te.True=1]="True",te[te.Defined=2]="Defined",te[te.Not=3]="Not",te[te.Equals=4]="Equals",te[te.NotEquals=5]="NotEquals",te[te.And=6]="And",te[te.Regex=7]="Regex",te[te.NotRegex=8]="NotRegex",te[te.Or=9]="Or",te[te.In=10]="In",te[te.NotIn=11]="NotIn",te[te.Greater=12]="Greater",te[te.GreaterEquals=13]="GreaterEquals",te[te.Smaller=14]="Smaller",te[te.SmallerEquals=15]="SmallerEquals"})(m||(e.ContextKeyExprType=m={}));const a={regexParsingWithErrorRecovery:!0},l=(0,A.localize)(1673,null),c=(0,A.localize)(1674,null),d=(0,A.localize)(1675,null),$=(0,A.localize)(1676,null),s=(0,A.localize)(1677,null),b=(0,A.localize)(1678,null),E=(0,A.localize)(1679,null),P=(0,A.localize)(1680,null);class i{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(u=a){this.k=u,this.d=new g.$Fj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(u){if(u===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:c});return}this.f=this.d.reset(u).scan(),this.g=0,this.h=[];try{const H=this.l();if(!this.E()){const oe=this.D(),N=oe.type===g.TokenType.Str?b:void 0;throw this.h.push({message:s,offset:oe.offset,lexeme:g.$Fj.getLexeme(oe),additionalInfo:N}),i.c}return H}catch(H){if(H!==i.c)throw H;return}}l(){return this.m()}m(){const u=[this.o()];for(;this.y(g.TokenType.Or);){const H=this.o();u.push(H)}return u.length===1?u[0]:n.or(...u)}o(){const u=[this.s()];for(;this.y(g.TokenType.And);){const H=this.s();u.push(H)}return u.length===1?u[0]:n.and(...u)}s(){if(this.y(g.TokenType.Neg)){const u=this.D();switch(u.type){case g.TokenType.True:return this.z(),p.INSTANCE;case g.TokenType.False:return this.z(),L.INSTANCE;case g.TokenType.LParen:{this.z();const H=this.l();return this.A(g.TokenType.RParen,$),H?.negate()}case g.TokenType.Str:return this.z(),T.create(u.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",u)}}return this.t()}t(){const u=this.D();switch(u.type){case g.TokenType.True:return this.z(),n.true();case g.TokenType.False:return this.z(),n.false();case g.TokenType.LParen:{this.z();const H=this.l();return this.A(g.TokenType.RParen,$),H}case g.TokenType.Str:{const H=u.lexeme;if(this.z(),this.y(g.TokenType.RegexOp)){const N=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),N.type!==g.TokenType.RegexStr)throw this.B("REGEX",N);const K=N.lexeme,U=K.lastIndexOf("/"),O=U===K.length-1?void 0:this.w(K.substring(U+1));let G;try{G=new RegExp(K.substring(1,U),O)}catch{throw this.B("REGEX",N)}return Q.create(H,G)}switch(N.type){case g.TokenType.RegexStr:case g.TokenType.Error:{const K=[N.lexeme];this.z();let U=this.D(),O=0;for(let ve=0;ve<N.lexeme.length;ve++)N.lexeme.charCodeAt(ve)===o.CharCode.OpenParen?O++:N.lexeme.charCodeAt(ve)===o.CharCode.CloseParen&&O--;for(;!this.E()&&U.type!==g.TokenType.And&&U.type!==g.TokenType.Or;){switch(U.type){case g.TokenType.LParen:O++;break;case g.TokenType.RParen:O--;break;case g.TokenType.RegexStr:case g.TokenType.QuotedStr:for(let ve=0;ve<U.lexeme.length;ve++)U.lexeme.charCodeAt(ve)===o.CharCode.OpenParen?O++:N.lexeme.charCodeAt(ve)===o.CharCode.CloseParen&&O--}if(O<0)break;K.push(g.$Fj.getLexeme(U)),this.z(),U=this.D()}const G=K.join(""),x=G.lastIndexOf("/"),ne=x===G.length-1?void 0:this.w(G.substring(x+1));let $e;try{$e=new RegExp(G.substring(1,x),ne)}catch{throw this.B("REGEX",N)}return n.regex(H,$e)}case g.TokenType.QuotedStr:{const K=N.lexeme;this.z();let U=null;if(!(0,_.$hf)(K)){const O=K.indexOf("/"),G=K.lastIndexOf("/");if(O!==G&&O>=0){const x=K.slice(O+1,G),ne=K[G+1]==="i"?"i":"";try{U=new RegExp(x,ne)}catch{throw this.B("REGEX",N)}}}if(U===null)throw this.B("REGEX",N);return Q.create(H,U)}default:throw this.B("REGEX",this.D())}}if(this.y(g.TokenType.Not)){this.A(g.TokenType.In,d);const N=this.u();return n.notIn(H,N)}switch(this.D().type){case g.TokenType.Eq:{this.z();const N=this.u();if(this.x().type===g.TokenType.QuotedStr)return n.equals(H,N);switch(N){case"true":return n.has(H);case"false":return n.not(H);default:return n.equals(H,N)}}case g.TokenType.NotEq:{this.z();const N=this.u();if(this.x().type===g.TokenType.QuotedStr)return n.notEquals(H,N);switch(N){case"true":return n.not(H);case"false":return n.has(H);default:return n.notEquals(H,N)}}case g.TokenType.Lt:return this.z(),J.create(H,this.u());case g.TokenType.LtEq:return this.z(),V.create(H,this.u());case g.TokenType.Gt:return this.z(),S.create(H,this.u());case g.TokenType.GtEq:return this.z(),F.create(H,this.u());case g.TokenType.In:return this.z(),n.in(H,this.u());default:return n.has(H)}}case g.TokenType.EOF:throw this.h.push({message:E,offset:u.offset,lexeme:"",additionalInfo:P}),i.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const u=this.D();switch(u.type){case g.TokenType.Str:case g.TokenType.QuotedStr:return this.z(),u.lexeme;case g.TokenType.True:return this.z(),"true";case g.TokenType.False:return this.z(),"false";case g.TokenType.In:return this.z(),"in";default:return""}}w(u){return u.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(u){return this.C(u)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(u,H){if(this.C(u))return this.z();throw this.B(H,this.D())}B(u,H,oe){const N=(0,A.localize)(1681,null,u,g.$Fj.getLexeme(H)),K=H.offset,U=g.$Fj.getLexeme(H);return this.h.push({message:N,offset:K,lexeme:U,additionalInfo:oe}),i.c}C(u){return this.D().type===u}D(){return this.f[this.g]}E(){return this.D().type===g.TokenType.EOF}}e.$Hj=i;class n{static false(){return p.INSTANCE}static true(){return L.INSTANCE}static has(u){return k.create(u)}static equals(u,H){return M.create(u,H)}static notEquals(u,H){return y.create(u,H)}static regex(u,H){return Q.create(u,H)}static in(u,H){return C.create(u,H)}static notIn(u,H){return D.create(u,H)}static not(u){return T.create(u)}static and(...u){return X.create(u,null,!0)}static or(...u){return B.create(u,null,!0)}static greater(u,H){return S.create(u,H)}static greaterEquals(u,H){return F.create(u,H)}static smaller(u,H){return J.create(u,H)}static smallerEquals(u,H){return V.create(u,H)}static{this.c=new i({regexParsingWithErrorRecovery:!1})}static deserialize(u){return u==null?void 0:this.c.parse(u)}}e.$Ij=n;function h(te){const u=new i({regexParsingWithErrorRecovery:!1});return te.map(H=>(u.parse(H),u.lexingErrors.length>0?u.lexingErrors.map(oe=>({errorMessage:oe.additionalInfo?(0,A.localize)(1682,null,oe.additionalInfo):(0,A.localize)(1683,null),offset:oe.offset,length:oe.lexeme.length})):u.parsingErrors.length>0?u.parsingErrors.map(oe=>({errorMessage:oe.additionalInfo?`${oe.message}. ${oe.additionalInfo}`:oe.message,offset:oe.offset,length:oe.lexeme.length})):[]))}function R(te,u){const H=te?te.substituteConstants():void 0,oe=u?u.substituteConstants():void 0;return!H&&!oe?!0:!H||!oe?!1:H.equals(oe)}function W(te,u){return te.cmp(u)}class p{static{this.INSTANCE=new p}constructor(){this.type=m.False}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}substituteConstants(){return this}evaluate(u){return!1}serialize(){return"false"}keys(){return[]}map(u){return this}negate(){return L.INSTANCE}}e.$Lj=p;class L{static{this.INSTANCE=new L}constructor(){this.type=m.True}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}substituteConstants(){return this}evaluate(u){return!0}serialize(){return"true"}keys(){return[]}map(u){return this}negate(){return p.INSTANCE}}e.$Mj=L;class k{static create(u,H=null){const oe=r.get(u);return typeof oe=="boolean"?oe?L.INSTANCE:p.INSTANCE:new k(u,H)}constructor(u,H){this.key=u,this.c=H,this.type=m.Defined}cmp(u){return u.type!==this.type?this.type-u.type:ee(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}substituteConstants(){const u=r.get(this.key);return typeof u=="boolean"?u?L.INSTANCE:p.INSTANCE:this}evaluate(u){return!!u.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(u){return u.mapDefined(this.key)}negate(){return this.c||(this.c=T.create(this.key,this)),this.c}}e.$Nj=k;class M{static create(u,H,oe=null){if(typeof H=="boolean")return H?k.create(u,oe):T.create(u,oe);const N=r.get(u);return typeof N=="boolean"?H===(N?"true":"false")?L.INSTANCE:p.INSTANCE:new M(u,H,oe)}constructor(u,H,oe){this.c=u,this.d=H,this.f=oe,this.type=m.Equals}cmp(u){return u.type!==this.type?this.type-u.type:le(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){const u=r.get(this.c);if(typeof u=="boolean"){const H=u?"true":"false";return this.d===H?L.INSTANCE:p.INSTANCE}return this}evaluate(u){return u.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(u){return u.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Oj=M;class C{static create(u,H){return new C(u,H)}constructor(u,H){this.d=u,this.f=H,this.type=m.In,this.c=null}cmp(u){return u.type!==this.type?this.type-u.type:le(this.d,this.f,u.d,u.f)}equals(u){return u.type===this.type?this.d===u.d&&this.f===u.f:!1}substituteConstants(){return this}evaluate(u){const H=u.getValue(this.f),oe=u.getValue(this.d);return Array.isArray(H)?H.includes(oe):typeof oe=="string"&&typeof H=="object"&&H!==null?f.call(H,oe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(u){return u.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$Pj=C;class D{static create(u,H){return new D(u,H)}constructor(u,H){this.d=u,this.f=H,this.type=m.NotIn,this.c=C.create(u,H)}cmp(u){return u.type!==this.type?this.type-u.type:this.c.cmp(u.c)}equals(u){return u.type===this.type?this.c.equals(u.c):!1}substituteConstants(){return this}evaluate(u){return!this.c.evaluate(u)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(u){return u.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qj=D;class y{static create(u,H,oe=null){if(typeof H=="boolean")return H?T.create(u,oe):k.create(u,oe);const N=r.get(u);return typeof N=="boolean"?H===(N?"true":"false")?p.INSTANCE:L.INSTANCE:new y(u,H,oe)}constructor(u,H,oe){this.c=u,this.d=H,this.f=oe,this.type=m.NotEquals}cmp(u){return u.type!==this.type?this.type-u.type:le(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){const u=r.get(this.c);if(typeof u=="boolean"){const H=u?"true":"false";return this.d===H?p.INSTANCE:L.INSTANCE}return this}evaluate(u){return u.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(u){return u.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Rj=y;class T{static create(u,H=null){const oe=r.get(u);return typeof oe=="boolean"?oe?p.INSTANCE:L.INSTANCE:new T(u,H)}constructor(u,H){this.c=u,this.d=H,this.type=m.Not}cmp(u){return u.type!==this.type?this.type-u.type:ee(this.c,u.c)}equals(u){return u.type===this.type?this.c===u.c:!1}substituteConstants(){const u=r.get(this.c);return typeof u=="boolean"?u?p.INSTANCE:L.INSTANCE:this}evaluate(u){return!u.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(u){return u.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$Sj=T;function I(te,u){if(typeof te=="string"){const H=parseFloat(te);isNaN(H)||(te=H)}return typeof te=="string"||typeof te=="number"?u(te):p.INSTANCE}class S{static create(u,H,oe=null){return I(H,N=>new S(u,N,oe))}constructor(u,H,oe){this.c=u,this.d=H,this.f=oe,this.type=m.Greater}cmp(u){return u.type!==this.type?this.type-u.type:le(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){return this}evaluate(u){return typeof this.d=="string"?!1:parseFloat(u.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(u){return u.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Tj=S;class F{static create(u,H,oe=null){return I(H,N=>new F(u,N,oe))}constructor(u,H,oe){this.c=u,this.d=H,this.f=oe,this.type=m.GreaterEquals}cmp(u){return u.type!==this.type?this.type-u.type:le(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){return this}evaluate(u){return typeof this.d=="string"?!1:parseFloat(u.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(u){return u.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$Uj=F;class J{static create(u,H,oe=null){return I(H,N=>new J(u,N,oe))}constructor(u,H,oe){this.c=u,this.d=H,this.f=oe,this.type=m.Smaller}cmp(u){return u.type!==this.type?this.type-u.type:le(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){return this}evaluate(u){return typeof this.d=="string"?!1:parseFloat(u.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(u){return u.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Vj=J;class V{static create(u,H,oe=null){return I(H,N=>new V(u,N,oe))}constructor(u,H,oe){this.c=u,this.d=H,this.f=oe,this.type=m.SmallerEquals}cmp(u){return u.type!==this.type?this.type-u.type:le(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){return this}evaluate(u){return typeof this.d=="string"?!1:parseFloat(u.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(u){return u.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Wj=V;class Q{static create(u,H){return new Q(u,H)}constructor(u,H){this.d=u,this.f=H,this.type=m.Regex,this.c=null}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.d<u.d)return-1;if(this.d>u.d)return 1;const H=this.f?this.f.source:"",oe=u.f?u.f.source:"";return H<oe?-1:H>oe?1:0}equals(u){if(u.type===this.type){const H=this.f?this.f.source:"",oe=u.f?u.f.source:"";return this.d===u.d&&H===oe}return!1}substituteConstants(){return this}evaluate(u){const H=u.getValue(this.d);return this.f?this.f.test(H):!1}serialize(){const u=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${u}`}keys(){return[this.d]}map(u){return u.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=re.create(this)),this.c}}e.$Xj=Q;class re{static create(u){return new re(u)}constructor(u){this.c=u,this.type=m.NotRegex}cmp(u){return u.type!==this.type?this.type-u.type:this.c.cmp(u.c)}equals(u){return u.type===this.type?this.c.equals(u.c):!1}substituteConstants(){return this}evaluate(u){return!this.c.evaluate(u)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(u){return new re(this.c.map(u))}negate(){return this.c}}e.$Yj=re;function ae(te){let u=null;for(let H=0,oe=te.length;H<oe;H++){const N=te[H].substituteConstants();if(te[H]!==N&&u===null){u=[];for(let K=0;K<H;K++)u[K]=te[K]}u!==null&&(u[H]=N)}return u===null?te:u}class X{static create(u,H,oe){return X.d(u,H,oe)}constructor(u,H){this.expr=u,this.c=H,this.type=m.And}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let H=0,oe=this.expr.length;H<oe;H++){const N=W(this.expr[H],u.expr[H]);if(N!==0)return N}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let H=0,oe=this.expr.length;H<oe;H++)if(!this.expr[H].equals(u.expr[H]))return!1;return!0}return!1}substituteConstants(){const u=ae(this.expr);return u===this.expr?this:X.create(u,this.c,!1)}evaluate(u){for(let H=0,oe=this.expr.length;H<oe;H++)if(!this.expr[H].evaluate(u))return!1;return!0}static d(u,H,oe){const N=[];let K=!1;for(const U of u)if(U){if(U.type===m.True){K=!0;continue}if(U.type===m.False)return p.INSTANCE;if(U.type===m.And){N.push(...U.expr);continue}N.push(U)}if(N.length===0&&K)return L.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(W);for(let U=1;U<N.length;U++)N[U-1].equals(N[U])&&(N.splice(U,1),U--);if(N.length===1)return N[0];for(;N.length>1;){const U=N[N.length-1];if(U.type!==m.Or)break;N.pop();const O=N.pop(),G=N.length===0,x=B.create(U.expr.map(ne=>X.create([ne,O],null,oe)),null,G);x&&(N.push(x),N.sort(W))}if(N.length===1)return N[0];if(oe){for(let U=0;U<N.length;U++)for(let O=U+1;O<N.length;O++)if(N[U].negate().equals(N[O]))return p.INSTANCE;if(N.length===1)return N[0]}return new X(N,H)}}serialize(){return this.expr.map(u=>u.serialize()).join(" && ")}keys(){const u=[];for(const H of this.expr)u.push(...H.keys());return u}map(u){return new X(this.expr.map(H=>H.map(u)),null)}negate(){if(!this.c){const u=[];for(const H of this.expr)u.push(H.negate());this.c=B.create(u,this,!0)}return this.c}}e.$Zj=X;class B{static create(u,H,oe){return B.d(u,H,oe)}constructor(u,H){this.expr=u,this.c=H,this.type=m.Or}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let H=0,oe=this.expr.length;H<oe;H++){const N=W(this.expr[H],u.expr[H]);if(N!==0)return N}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let H=0,oe=this.expr.length;H<oe;H++)if(!this.expr[H].equals(u.expr[H]))return!1;return!0}return!1}substituteConstants(){const u=ae(this.expr);return u===this.expr?this:B.create(u,this.c,!1)}evaluate(u){for(let H=0,oe=this.expr.length;H<oe;H++)if(this.expr[H].evaluate(u))return!0;return!1}static d(u,H,oe){let N=[],K=!1;if(u){for(let U=0,O=u.length;U<O;U++){const G=u[U];if(G){if(G.type===m.False){K=!0;continue}if(G.type===m.True)return L.INSTANCE;if(G.type===m.Or){N=N.concat(G.expr);continue}N.push(G)}}if(N.length===0&&K)return p.INSTANCE;N.sort(W)}if(N.length!==0){if(N.length===1)return N[0];for(let U=1;U<N.length;U++)N[U-1].equals(N[U])&&(N.splice(U,1),U--);if(N.length===1)return N[0];if(oe){for(let U=0;U<N.length;U++)for(let O=U+1;O<N.length;O++)if(N[U].negate().equals(N[O]))return L.INSTANCE;if(N.length===1)return N[0]}return new B(N,H)}}serialize(){return this.expr.map(u=>u.serialize()).join(" || ")}keys(){const u=[];for(const H of this.expr)u.push(...H.keys());return u}map(u){return new B(this.expr.map(H=>H.map(u)),null)}negate(){if(!this.c){const u=[];for(const H of this.expr)u.push(H.negate());for(;u.length>1;){const H=u.shift(),oe=u.shift(),N=[];for(const K of de(H))for(const U of de(oe))N.push(X.create([K,U],null,!1));u.unshift(B.create(N,null,!1))}this.c=B.create(u,this,!0)}return this.c}}e.$1j=B;class Z extends k{static{this.d=[]}static all(){return Z.d.values()}constructor(u,H,oe){super(u,null),this.f=H,typeof oe=="object"?Z.d.push({...oe,key:u}):oe!==!0&&Z.d.push({key:u,description:oe,type:H!=null?typeof H:void 0})}bindTo(u){return u.createKey(this.key,this.f)}getValue(u){return u.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(u){return M.create(this.key,u)}notEqualsTo(u){return y.create(this.key,u)}}e.$2j=Z,e.$3j=(0,j.$Ki)("contextKeyService");function ee(te,u){return te<u?-1:te>u?1:0}function le(te,u,H,oe){return te<H?-1:te>H?1:u<oe?-1:u>oe?1:0}function q(te,u){if(te.type===m.False||u.type===m.True)return!0;if(te.type===m.Or)return u.type===m.Or?ce(te.expr,u.expr):!1;if(u.type===m.Or){for(const H of u.expr)if(q(te,H))return!0;return!1}if(te.type===m.And){if(u.type===m.And)return ce(u.expr,te.expr);for(const H of te.expr)if(q(H,u))return!0;return!1}return te.equals(u)}function ce(te,u){let H=0,oe=0;for(;H<te.length&&oe<u.length;){const N=te[H].cmp(u[oe]);if(N<0)return!1;N===0&&H++,oe++}return H===te.length}function de(te){return te.type===m.Or?te.expr:[te]}}),define(he[74],fe([0,1,56,5,11,10,6,8,22,3,20,24]),function(ie,e,o,t,_,g,j,A,w,r,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Kl=e.FileKind=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.FileOperationResult=e.$Cl=e.$Bl=e.$Al=e.$yl=e.FileChangeType=e.$xl=e.FileOperation=e.$rl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$fl=void 0,e.$gl=m,e.$hl=d,e.$il=s,e.$jl=b,e.$kl=E,e.$ll=P,e.$ml=i,e.$nl=n,e.$ol=h,e.$pl=R,e.$ql=W,e.$sl=k,e.$tl=M,e.$ul=C,e.$vl=D,e.$wl=y,e.$zl=J,e.$Ll=B,e.$Ml=Z,e.$Ol=le,e.$fl=(0,w.$Ki)("fileService");function m(q){return q.create===!0}var a;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(a||(e.FileType=a={}));var l;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var c;(function(q){q[q.UPDATED=2]="UPDATED",q[q.ADDED=4]="ADDED",q[q.DELETED=8]="DELETED"})(c||(e.FileChangeFilter=c={}));function d(q){const ce=q;return!!ce&&typeof ce.onDidChange=="function"}var $;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function s(q){return!!(q.capabilities&$.FileReadWrite)}function b(q){return!!(q.capabilities&$.FileFolderCopy)}function E(q){return!!(q.capabilities&$.FileClone)}function P(q){return!!(q.capabilities&$.FileOpenReadWriteClose)}function i(q){return!!(q.capabilities&$.FileReadStream)}function n(q){return s(q)?!!(q.capabilities&$.FileAtomicRead):!1}function h(q){return s(q)?!!(q.capabilities&$.FileAtomicWrite):!1}function R(q){return!!(q.capabilities&$.FileAtomicDelete)}function W(q){return!!(q.capabilities&$.Readonly)}var p;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(p||(e.FileSystemProviderErrorCode=p={}));class L extends Error{static create(ce,de){const te=new L(ce.toString(),de);return C(te,de),te}constructor(ce,de){super(ce),this.code=de}}e.$rl=L;function k(q,ce){return L.create(q,ce)}function M(q){return q||k((0,A.localize)(1865,null),p.Unknown)}function C(q,ce){return q.name=ce?`${ce} (FileSystemError)`:"FileSystemError",q}function D(q){if(!q)return p.Unknown;if(q instanceof L)return q.code;const ce=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!ce)return p.Unknown;switch(ce[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}function y(q){if(q instanceof V)return q.fileOperationResult;switch(D(q)){case p.FileNotFound:return ae.FILE_NOT_FOUND;case p.FileIsADirectory:return ae.FILE_IS_DIRECTORY;case p.FileNotADirectory:return ae.FILE_NOT_DIRECTORY;case p.FileWriteLocked:return ae.FILE_WRITE_LOCKED;case p.NoPermissions:return ae.FILE_PERMISSION_DENIED;case p.FileExists:return ae.FILE_MOVE_CONFLICT;case p.FileTooLarge:return ae.FILE_TOO_LARGE;default:return ae.FILE_OTHER_ERROR}}var T;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(T||(e.FileOperation=T={}));class I{constructor(ce,de,te){this.resource=ce,this.operation=de,this.target=te}isOperation(ce){return this.operation===ce}}e.$xl=I;var S;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(S||(e.FileChangeType=S={}));class F{static{this.a=null}constructor(ce,de){this.c=de,this.b=void 0,this.d=new f.$Y(()=>{const te=o.$Qi.forUris(()=>this.c);return te.fill(this.rawAdded.map(u=>[u,!0])),te}),this.f=new f.$Y(()=>{const te=o.$Qi.forUris(()=>this.c);return te.fill(this.rawUpdated.map(u=>[u,!0])),te}),this.g=new f.$Y(()=>{const te=o.$Qi.forUris(()=>this.c);return te.fill(this.rawDeleted.map(u=>[u,!0])),te}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const te of ce){switch(te.type){case S.ADDED:this.rawAdded.push(te.resource);break;case S.UPDATED:this.rawUpdated.push(te.resource);break;case S.DELETED:this.rawDeleted.push(te.resource);break}this.b!==F.a&&(typeof te.cId=="number"?this.b===void 0?this.b=te.cId:this.b!==te.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(ce,...de){return this.h(ce,{includeChildren:!1},...de)}affects(ce,...de){return this.h(ce,{includeChildren:!0},...de)}h(ce,de,...te){if(!ce)return!1;const u=te.length>0;return!!((!u||te.includes(S.ADDED))&&(this.d.value.get(ce)||de.includeChildren&&this.d.value.findSuperstr(ce))||(!u||te.includes(S.UPDATED))&&(this.f.value.get(ce)||de.includeChildren&&this.f.value.findSuperstr(ce))||(!u||te.includes(S.DELETED))&&(this.g.value.findSubstr(ce)||de.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$yl=F;function J(q,ce,de){return!q||!ce||q===ce||ce.length>q.length?!1:(ce.charAt(ce.length-1)!==t.sep&&(ce+=t.sep),de?(0,_.$Lf)(q,ce):q.indexOf(ce)===0)}class V extends Error{constructor(ce,de,te){super(ce),this.fileOperationResult=de,this.options=te}}e.$Al=V;class Q extends V{constructor(ce,de,te,u){super(ce,de,u),this.fileOperationResult=de,this.size=te}}e.$Bl=Q;class re extends V{constructor(ce,de,te){super(ce,ae.FILE_NOT_MODIFIED_SINCE,te),this.stat=de}}e.$Cl=re;var ae;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$Dl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$El={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Fl="files.associations",e.$Gl="files.exclude",e.$Hl="files.readonlyInclude",e.$Il="files.readonlyExclude",e.$Jl="files.readonlyFromPermissions";var X;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$Kl="";function B(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}async function Z(q,ce){if(!ce.hasProvider(j.URI.from({scheme:q.scheme})))return new Promise(de=>{const te=ce.onDidChangeFileSystemProviderRegistrations(u=>{u.scheme===q.scheme&&u.added&&(te.dispose(),de())})})}class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(ce){return(0,g.$ng)(ce)||(ce=0),ce<ee.KB?(0,A.localize)(1866,null,ce.toFixed(0)):ce<ee.MB?(0,A.localize)(1867,null,(ce/ee.KB).toFixed(2)):ce<ee.GB?(0,A.localize)(1868,null,(ce/ee.MB).toFixed(2)):ce<ee.TB?(0,A.localize)(1869,null,(ce/ee.GB).toFixed(2)):(0,A.localize)(1870,null,(ce/ee.TB).toFixed(2))}}e.$Nl=ee;function le(q){const ce=typeof q=="string"||q?.scheme===v.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===v.Schemas.file?1024*ee.MB:ce?10*ee.MB:r.$r?50*ee.MB:1024*ee.MB}}),define(he[9],fe([0,1,8,59,4,55,2,26,3,25,10,6,39,22]),function(ie,e,o,t,_,g,j,A,w,r,v,f,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$ik=e.LogLevel=e.$gk=e.$fk=void 0,e.$hk=c,e.log=$,e.$tk=L,e.$uk=k,e.$vk=M,e.$wk=C,o=Ae(o),e.$fk=(0,a.$Ki)("logService"),e.$gk=(0,a.$Ki)("loggerService");function l(){return new Date().toISOString()}function c(D){return(0,v.$ng)(D)}var d;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(d||(e.LogLevel=d={})),e.$ik=d.Info;function $(D,y,T){switch(y){case d.Trace:D.trace(T);break;case d.Debug:D.debug(T);break;case d.Info:D.info(T);break;case d.Warning:D.warn(T);break;case d.Error:D.error(T);break;case d.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function s(D,y=!1){let T="";for(let I=0;I<D.length;I++){let S=D[I];if(S instanceof Error&&(S=(0,t.$vj)(S,y)),typeof S=="object")try{S=JSON.stringify(S)}catch{}T+=(I>0?" ":"")+S}return T}class b extends j.$Zc{constructor(){super(...arguments),this.b=e.$ik,this.c=this.B(new _.$qe),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==d.Off&&this.b<=y}}e.$kk=b;class E extends b{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...T){this.f(d.Trace)&&this.g(d.Trace,s([y,...T],!0))}debug(y,...T){this.f(d.Debug)&&this.g(d.Debug,s([y,...T]))}info(y,...T){this.f(d.Info)&&this.g(d.Info,s([y,...T]))}warn(y,...T){this.f(d.Warning)&&this.g(d.Warning,s([y,...T]))}error(y,...T){if(this.f(d.Error))if(y instanceof Error){const I=Array.prototype.slice.call(arguments);I[0]=y.stack,this.g(d.Error,s(I))}else this.g(d.Error,s([y,...T]))}flush(){}}e.$lk=E;class P extends b{constructor(y=e.$ik){super(),this.setLevel(y),this.g=!w.$l}trace(y,...T){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,y,...T):console.log(`[main ${l()}]`,y,...T))}debug(y,...T){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,y,...T):console.log(`[main ${l()}]`,y,...T))}info(y,...T){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,y,...T):console.log(`[main ${l()}]`,y,...T))}warn(y,...T){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,y,...T):console.warn(`[main ${l()}]`,y,...T))}error(y,...T){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,y,...T):console.error(`[main ${l()}]`,y,...T))}flush(){}}e.$mk=P;class i extends b{constructor(y=e.$ik,T=!0){super(),this.g=T,this.setLevel(y)}trace(y,...T){this.f(d.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...T):console.log(y,...T))}debug(y,...T){this.f(d.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...T):console.log(y,...T))}info(y,...T){this.f(d.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...T):console.log(y,...T))}warn(y,...T){this.f(d.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...T):console.log(y,...T))}error(y,...T){this.f(d.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...T):console.error(y,...T))}flush(){}}e.$nk=i;class n extends b{constructor(y,T=e.$ik){super(),this.g=y,this.setLevel(T)}trace(y,...T){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(y),...T])}debug(y,...T){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(y),...T])}info(y,...T){this.f(d.Info)&&this.g.log(d.Info,[this.h(y),...T])}warn(y,...T){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(y),...T])}error(y,...T){this.f(d.Error)&&this.g.log(d.Error,[this.h(y),...T])}h(y){return typeof y=="string"?y:(0,t.$vj)(y,this.f(d.Trace))}flush(){}}e.$ok=n;class h extends b{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const T of this.g)T.setLevel(y);super.setLevel(y)}trace(y,...T){for(const I of this.g)I.trace(y,...T)}debug(y,...T){for(const I of this.g)I.debug(y,...T)}info(y,...T){for(const I of this.g)I.info(y,...T)}warn(y,...T){for(const I of this.g)I.warn(y,...T)}error(y,...T){for(const I of this.g)I.error(y,...T)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose();super.dispose()}}e.$pk=h;class R extends j.$Zc{constructor(y,T,I){if(super(),this.h=y,this.j=T,this.b=new A.$Fc,this.c=this.B(new _.$qe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new _.$qe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new _.$qe),this.onDidChangeVisibility=this.g.event,I)for(const S of I)this.b.set(S.resource,{logger:void 0,info:S})}m(y){return(0,v.$jg)(y)?[...this.b.values()].find(T=>T.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,T){const I=this.n(y),S=(0,v.$jg)(y)?y:T?.id??(0,g.$yj)(I.toString()).toString(16);let F=this.b.get(I)?.logger;const J=T?.logLevel==="always"?d.Trace:T?.logLevel;F||(F=this.s(I,J??this.getLogLevel(I)??this.h,{...T,id:S}));const V={logger:F,info:{resource:I,id:S,logLevel:J,name:T?.name,hidden:T?.hidden,extensionId:T?.extensionId,when:T?.when}};return this.registerLogger(V.info),this.b.set(I,V),F}n(y){return(0,v.$jg)(y)?(0,r.$lh)(this.j,`${y}.log`):y}setLogLevel(y,T){if(f.URI.isUri(y)){const I=y,S=T,F=this.b.get(I);F&&S!==F.info.logLevel&&(F.info.logLevel=S===this.h?void 0:S,F.logger?.setLevel(S),this.b.set(F.info.resource,F),this.f.fire([I,S]))}else{this.h=y;for(const[I,S]of this.b.entries())this.b.get(I)?.info.logLevel===void 0&&S.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,T){const I=this.m(y);I&&T!==!I.info.hidden&&(I.info.hidden=!T,this.b.set(I.info.resource,I),this.g.fire([I.info.resource,T]))}getLogLevel(y){let T;return y&&(T=this.b.get(y)?.info.logLevel),T??this.h}registerLogger(y){const T=this.b.get(y.resource);T?T.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const T=this.b.get(y);T&&(T.logger&&T.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[T.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$qk=R;class W{constructor(){this.onDidChangeLogLevel=new _.$qe().event}setLevel(y){}getLevel(){return d.Info}trace(y,...T){}debug(y,...T){}info(y,...T){}warn(y,...T){}error(y,...T){}critical(y,...T){}dispose(){}flush(){}}e.$rk=W;class p extends W{}e.$sk=p;function L(D){if(D.verbose)return d.Trace;if(typeof D.logLevel=="string"){const y=C(D.logLevel.toLowerCase());if(y!==void 0)return y}return e.$ik}function k(D){switch(D){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}function M(D){switch(D){case d.Trace:return{original:"Trace",value:o.localize(1959,null)};case d.Debug:return{original:"Debug",value:o.localize(1960,null)};case d.Info:return{original:"Info",value:o.localize(1961,null)};case d.Warning:return{original:"Warning",value:o.localize(1962,null)};case d.Error:return{original:"Error",value:o.localize(1963,null)};case d.Off:return{original:"Off",value:o.localize(1964,null)}}}function C(D){switch(D){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.$xk=new m.$2j("logLevel",k(d.Info))}),define(he[75],fe([0,1,6,4,9,2]),function(ie,e,o,t,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=e.$Cs=e.$Bs=void 0;class j extends _.$qk{constructor(f,m,a,l,c){super(m,a,l),this.r=f,this.t=c,this.B(c.listen("onDidChangeLogLevel",f)(d=>{(0,_.$hk)(d)?super.setLogLevel(d):super.setLogLevel(o.URI.revive(d[0]),d[1])})),this.B(c.listen("onDidChangeVisibility",f)(([d,$])=>super.setVisibility(o.URI.revive(d),$))),this.B(c.listen("onDidChangeLoggers",f)(({added:d,removed:$})=>{for(const s of d)super.registerLogger({...s,resource:o.URI.revive(s.resource)});for(const s of $)super.deregisterLogger(s.resource)}))}createConsoleMainLogger(){return new _.$ok({log:(f,m)=>{this.t.call("consoleLog",[f,m])}})}registerLogger(f){super.registerLogger(f),this.t.call("registerLogger",[f,this.r])}deregisterLogger(f){super.deregisterLogger(f),this.t.call("deregisterLogger",[f,this.r])}setLogLevel(f,m){super.setLogLevel(f,m),this.t.call("setLogLevel",[f,m])}setVisibility(f,m){super.setVisibility(f,m),this.t.call("setVisibility",[this.n(f),m])}s(f,m,a){return new A(this.t,f,m,a,this.r)}static setLogLevel(f,m,a){return f.call("setLogLevel",[m,a])}}e.$Bs=j;class A extends _.$lk{constructor(f,m,a,l,c){super(l?.logLevel==="always"),this.r=f,this.s=m,this.m=!1,this.n=[],this.setLevel(a),this.r.call("createLogger",[m,l,c]).then(()=>{this.u(this.n),this.m=!0})}g(f,m){const a=[[f,m]];this.m?this.u(a):this.n.push(...a)}u(f){this.r.call("log",[this.s,f])}}class w{constructor(f,m){this.a=f,this.b=m}listen(f,m){const a=this.b(f);switch(m){case"onDidChangeLoggers":return t.Event.map(this.a.onDidChangeLoggers,l=>({added:[...l.added].map(c=>this.c(c,a)),removed:[...l.removed].map(c=>this.c(c,a))}));case"onDidChangeVisibility":return t.Event.map(this.a.onDidChangeVisibility,l=>[a.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return t.Event.map(this.a.onDidChangeLogLevel,l=>(0,_.$hk)(l)?l:[a.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${m}`)}async call(f,m,a){const l=this.b(f);switch(m){case"setLogLevel":return(0,_.$hk)(a[0])?this.a.setLogLevel(a[0]):this.a.setLogLevel(o.URI.revive(l.transformIncoming(a[0][0])),a[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(c=>this.c(c,l)))}throw new Error(`Call not found: ${m}`)}c(f,m){return{...f,resource:m.transformOutgoingURI(f.resource)}}}e.$Cs=w;class r extends g.$Zc{constructor(f,m){super(),m.call("setLogLevel",[f.getLogLevel()]),this.B(f.onDidChangeLogLevel(a=>m.call("setLogLevel",[a]))),m.call("getRegisteredLoggers").then(a=>{for(const l of a)f.registerLogger({...l,resource:o.URI.revive(l.resource)})}),this.B(m.listen("onDidChangeVisibility")(([a,l])=>f.setVisibility(o.URI.revive(a),l))),this.B(m.listen("onDidChangeLoggers")(({added:a,removed:l})=>{for(const c of a)f.registerLogger({...c,resource:o.URI.revive(c.resource)});for(const c of l)f.deregisterLogger(c.resource)}))}}e.$Ds=r}),define(he[76],fe([0,1,2,9]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$R=void 0;class _ extends o.$Zc{constructor(j,A=[]){super(),this.a=new t.$pk([j,...A]),this.B(j.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...A){this.a.trace(j,...A)}debug(j,...A){this.a.debug(j,...A)}info(j,...A){this.a.info(j,...A)}warn(j,...A){this.a.warn(j,...A)}error(j,...A){this.a.error(j,...A)}flush(){this.a.flush()}}e.$$R=_}),define(he[77],fe([0,1,74,9]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZR=void 0;var _;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(_||(_={}));async function g(r,v,f,m,a){try{const l=await new Promise((d,$)=>{ie(["@vscode/spdlog"],d,$)}).then(Ae);l.setFlushOn(_.Trace);const c=await l.createAsyncRotatingLogger(r,v,f,m);return a?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(l){console.error(l)}return null}function j(r,v,f){switch(v){case t.LogLevel.Trace:r.trace(f);break;case t.LogLevel.Debug:r.debug(f);break;case t.LogLevel.Info:r.info(f);break;case t.LogLevel.Warning:r.warn(f);break;case t.LogLevel.Error:r.error(f);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function A(r,v){switch(v){case t.LogLevel.Trace:r.setLevel(_.Trace);break;case t.LogLevel.Debug:r.setLevel(_.Debug);break;case t.LogLevel.Info:r.setLevel(_.Info);break;case t.LogLevel.Warning:r.setLevel(_.Warning);break;case t.LogLevel.Error:r.setLevel(_.Error);break;case t.LogLevel.Off:r.setLevel(_.Off);break;default:throw new Error(`Invalid log level ${v}`)}}class w extends t.$lk{constructor(v,f,m,a,l){super(),this.m=[],this.setLevel(l),this.n=this.s(v,f,m,a),this.B(this.onDidChangeLogLevel(c=>{this.r&&A(this.r,c)}))}async s(v,f,m,a){const l=m?6:1,c=30/l*o.$Nl.MB,d=await g(v,f,c,l,a);if(d){this.r=d,A(this.r,this.getLevel());for(const{level:$,message:s}of this.m)j(this.r,$,s);this.m=[]}}g(v,f){this.r?j(this.r,v,f):this.getLevel()<=v&&this.m.push({level:v,message:f})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$ZR=w}),define(he[78],fe([0,1,57,9,77]),function(ie,e,o,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1R=void 0;class g extends t.$qk{s(A,w,r){return new _.$ZR((0,o.$7g)(),A.fsPath,!r?.donotRotate,!!r?.donotUseFormatters,w)}}e.$1R=g}),define(he[79],fe([0,1,15]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let t;const _=globalThis.vscode;if(typeof _<"u"&&typeof _.context<"u"){const g=_.context.configuration();if(g)t=g.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(t=globalThis._VSCODE_PRODUCT_JSON,o.env.VSCODE_DEV&&Object.assign(t,{nameShort:`${t.nameShort} Dev`,nameLong:`${t.nameLong} Dev`,dataFolderName:`${t.dataFolderName}-dev`,serverDataFolderName:t.serverDataFolderName?`${t.serverDataFolderName}-dev`:void 0}),!t.version){const g=globalThis._VSCODE_PACKAGE_JSON;Object.assign(t,{version:g.version})}}else t={},Object.keys(t).length===0&&Object.assign(t,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=t}),define(he[80],fe([0,1,22]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=e.$yk=void 0,e.$yk=(0,o.$Ki)("productService"),e.$zk="vscode://schemas/vscode-product"}),define(he[81],fe([0,1,46,10]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=void 0,o=Ae(o),t=Ae(t);class _{constructor(){this.a=new Map}add(j,A){o.ok(t.$jg(j)),o.ok(t.$lg(A)),o.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,A)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$xo=new _}),define(he[23],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CommandInvalidationReason=e.TerminalCapability=void 0;var o;(function(_){_[_.CwdDetection=0]="CwdDetection",_[_.NaiveCwdDetection=1]="NaiveCwdDetection",_[_.CommandDetection=2]="CommandDetection",_[_.PartialCommandDetection=3]="PartialCommandDetection",_[_.BufferMarkDetection=4]="BufferMarkDetection"})(o||(e.TerminalCapability=o={}));var t;(function(_){_.Windows="windows",_.NoProblemsReported="noProblemsReported"})(t||(e.CommandInvalidationReason=t={}))}),define(he[82],fe([0,1,4,2,23]),function(ie,e,o,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pxb=void 0;class g extends t.$Zc{constructor(A){super(),this.f=A,this.type=_.TerminalCapability.BufferMarkDetection,this.a=new Map,this.b=new Map,this.c=this.B(new o.$qe),this.onMarkAdded=this.c.event}*markers(){for(const A of this.a.values())yield A;for(const A of this.b.values())yield A}addMark(A){const w=A?.marker||this.f.registerMarker(),r=A?.id;w&&(r?(this.a.set(r,w),w.onDispose(()=>this.a.delete(r))):(this.b.set(w.id,w),w.onDispose(()=>this.b.delete(w.id))),this.c.fire({marker:w,id:r,hidden:A?.hidden,hoverMessage:A?.hoverMessage}))}getMark(A){return this.a.get(A)}}e.$pxb=g});var je=this&&this.__param||function(ie,e){return function(o,t){e(o,t,ie)}};define(he[83],fe([0,1,4,2,9,14]),function(ie,e,o,t,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=void 0;var j;(function(w){w[w.Unknown=0]="Unknown",w[w.Input=1]="Input",w[w.Execute=2]="Execute"})(j||(j={}));let A=class extends t.$Zc{get value(){return this.j}get prefix(){return this.j.substring(0,this.m)}get suffix(){return this.j.substring(this.m,this.n===-1?void 0:this.n)}get cursorIndex(){return this.m}get ghostTextIndex(){return this.n}constructor(r,v,f,m){super(),this.w=r,this.z=m,this.a=j.Unknown,this.c=0,this.h="",this.j="",this.m=0,this.n=-1,this.r=this.B(new o.$qe),this.onDidStartInput=this.r.event,this.s=this.B(new o.$qe),this.onDidChangeInput=this.s.event,this.t=this.B(new o.$qe),this.onDidFinishInput=this.t.event,this.u=this.B(new o.$qe),this.onDidInterrupt=this.u.event,this.B(o.Event.any(this.w.onCursorMove,this.w.onData,this.w.onWriteParsed)(()=>this.G())),this.B(this.w.onData(a=>this.I(a))),this.B(v(a=>this.D(a))),this.B(f(()=>this.F())),this.B(this.onDidStartInput(()=>this.C("PromptInputModel#onDidStartInput"))),this.B(this.onDidChangeInput(()=>this.C("PromptInputModel#onDidChangeInput"))),this.B(this.onDidFinishInput(()=>this.C("PromptInputModel#onDidFinishInput"))),this.B(this.onDidInterrupt(()=>this.C("PromptInputModel#onDidInterrupt")))}C(r){this.z.getLevel()===_.LogLevel.Trace&&this.z.trace(r,this.getCombinedString())}setContinuationPrompt(r){this.g=r,this.G()}setLastPromptLine(r){this.f=r,this.G()}setConfidentCommandLine(r){this.j!==r&&(this.j=r,this.m=-1,this.n=-1,this.s.fire(this.Q()))}getCombinedString(){const r=this.j.replaceAll(`
`,"\u23CE");if(this.m===-1)return r;let v=`${r.substring(0,this.cursorIndex)}|`;return this.ghostTextIndex!==-1?(v+=`${r.substring(this.cursorIndex,this.ghostTextIndex)}[`,v+=`${r.substring(this.ghostTextIndex)}]`):v+=r.substring(this.cursorIndex),v}serialize(){return{modelState:this.Q(),commandStartX:this.c,lastPromptLine:this.f,continuationPrompt:this.g,lastUserInput:this.h}}deserialize(r){this.j=r.modelState.value,this.m=r.modelState.cursorIndex,this.n=r.modelState.ghostTextIndex,this.c=r.commandStartX,this.f=r.lastPromptLine,this.g=r.continuationPrompt,this.h=r.lastUserInput}D(r){this.a!==j.Input&&(this.a=j.Input,this.b=r.marker,this.c=this.w.buffer.active.cursorX,this.j="",this.m=0,this.r.fire(this.Q()),this.s.fire(this.Q()),this.f&&this.c!==this.f.length&&this.w.buffer.active.getLine(this.b.line)?.translateToString(!0).startsWith(this.f)&&(this.c=this.f.length,this.G()))}F(){if(this.a===j.Execute)return;this.m=-1,this.n!==-1&&(this.j=this.j.substring(0,this.n),this.n=-1);const r=this.Q();this.h===""&&(this.h="",this.u.fire(r)),this.a=j.Execute,this.t.fire(r),this.s.fire(r)}G(){try{this.H()}catch(r){this.z.error("Error while syncing prompt input model",r)}}H(){if(this.a!==j.Input)return;const r=this.b?.line;if(r===void 0)return;const v=this.w.buffer.active;let f=v.getLine(r);const m=f?.translateToString(!0,this.c);if(!f||m===void 0){this.z.trace("PromptInputModel#_sync: no line");return}const a=v.baseY+v.cursorY;let l=m,c=-1,d;a===r?d=this.O(this.c,v,f):d=m.trimEnd().length,a===r&&v.cursorX>1&&(c=this.J(v,f,d));for(let $=r+1;$<=a;$++){f=v.getLine($);const s=f?.translateToString(!0);if(s&&f)if(f.isWrapped){l+=s;const b=this.O(0,v,f);a===$?d+=b:d+=s.length}else if(this.g===void 0||this.M(s)){const b=this.L(s);if(l+=`
${b}`,a===$){const E=this.N(f,s),P=this.O(E,v,f);d+=P+1}else d+=b.length+1}else break}for(let $=a+1;$<v.baseY+this.w.rows;$++){f=v.getLine($);const s=f?.translateToString(!0);if(s&&f)if(this.g===void 0||this.M(s))l+=`
${this.L(s)}`;else break;else break}this.z.getLevel()===_.LogLevel.Trace&&this.z.trace(`PromptInputModel#_sync: ${this.getCombinedString()}`);{let $=this.j.length-this.j.trimEnd().length;this.h==="\x7F"&&(this.h="",d===this.m-1&&(this.j.trimEnd().length>l.trimEnd().length&&l.trimEnd().length<=d?$=Math.max(this.j.length-1-l.trimEnd().length,0):$=Math.max($-1,0))),this.h==="\x1B[3~"&&(this.h="",d===this.m&&($=Math.max($-1,0)));const s=l.split(`
`),b=s.length>1,E=l.trimEnd();if(!b){E.length<l.length&&(this.h===" "&&(this.h="",d>E.length&&d>this.m&&$++),$=Math.max(d-E.length,$,0));const P=d===0?"":l[d-1];$>0&&d===this.m+1&&this.h!==""&&P!==" "&&($=this.j.length-this.m)}if(b){s[s.length-1]=s.at(-1)?.trimEnd()??"";const P=(s.length-1)*(this.g?.length??0);$=Math.max(0,d-l.length-P)}l=s.map(P=>P.trimEnd()).join(`
`)+" ".repeat($)}(this.j!==l||this.m!==d||this.n!==c)&&(this.j=l,this.m=d,this.n=c,this.s.fire(this.Q()))}I(r){this.h=r}J(r,v,f){let m=-1,a=!1,l=r.cursorX;for(;l>0;){const c=v.getCell(--l);if(!c)break;if(c.getChars().trim().length>0){a=!this.P(c);break}}if(a){let c=0,d=r.cursorX;for(;d<v.length;){const $=v.getCell(d++);if(!$||$.getCode()===0)break;if(this.P($)){m=f+c;break}c+=$.getChars().length}}return m}L(r){return this.M(r)&&(r=r.substring(this.g.length)),r}M(r){return!!(this.g&&r.startsWith(this.g))}N(r,v){if(!this.g||!v.startsWith(this.g))return 0;let f="",m=0;for(;f!==this.g;)f+=r.getCell(m++).getChars();return m}O(r,v,f){return f?.translateToString(!0,r,v.cursorX).length??0}P(r){return!!(r.isItalic()||r.isDim())}Q(){return Object.freeze({value:this.j,prefix:this.prefix,suffix:this.suffix,cursorIndex:this.m,ghostTextIndex:this.n})}};e.$ss=A,me([(0,g.$ei)(0)],A.prototype,"G",null),e.$ss=A=me([je(3,_.$fk)],A)}),define(he[84],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=e.$ts=void 0;class o{get command(){return this.b.command}get commandLineConfidence(){return this.b.commandLineConfidence}get isTrusted(){return this.b.isTrusted}get timestamp(){return this.b.timestamp}get duration(){return this.b.duration}get promptStartMarker(){return this.b.promptStartMarker}get marker(){return this.b.marker}get endMarker(){return this.b.endMarker}set endMarker(v){this.b.endMarker=v}get executedMarker(){return this.b.executedMarker}get aliases(){return this.b.aliases}get wasReplayed(){return this.b.wasReplayed}get cwd(){return this.b.cwd}get exitCode(){return this.b.exitCode}get commandStartLineContent(){return this.b.commandStartLineContent}get markProperties(){return this.b.markProperties}get executedX(){return this.b.executedX}get startX(){return this.b.startX}constructor(v,f){this.a=v,this.b=f}static deserialize(v,f,m){const a=v.buffer.normal,l=f.startLine!==void 0?v.registerMarker(f.startLine-(a.baseY+a.cursorY)):void 0;if(!l)return;const c=f.promptStartLine!==void 0?v.registerMarker(f.promptStartLine-(a.baseY+a.cursorY)):void 0,d=f.endLine!==void 0?v.registerMarker(f.endLine-(a.baseY+a.cursorY)):void 0,$=f.executedLine!==void 0?v.registerMarker(f.executedLine-(a.baseY+a.cursorY)):void 0;return new o(v,{command:m?"":f.command,commandLineConfidence:f.commandLineConfidence??"low",isTrusted:f.isTrusted,promptStartMarker:c,marker:l,startX:f.startX,endMarker:d,executedMarker:$,executedX:f.executedX,timestamp:f.timestamp,duration:f.duration,cwd:f.cwd,commandStartLineContent:f.commandStartLineContent,exitCode:f.exitCode,markProperties:f.markProperties,aliases:void 0,wasReplayed:!0})}serialize(v){return{promptStartLine:this.promptStartMarker?.line,startLine:this.marker?.line,startX:void 0,endLine:this.endMarker?.line,executedLine:this.executedMarker?.line,executedX:this.executedX,command:v?"":this.command,commandLineConfidence:v?"low":this.commandLineConfidence,isTrusted:this.isTrusted,cwd:this.cwd,exitCode:this.exitCode,commandStartLineContent:this.commandStartLineContent,timestamp:this.timestamp,duration:this.duration,markProperties:this.markProperties}}extractCommandLine(){return _(this.a.buffer.active,this.a.cols,this.marker,this.startX,this.executedMarker,this.executedX)}getOutput(){if(!this.executedMarker||!this.endMarker)return;const v=this.executedMarker.line,f=this.endMarker.line;if(v===f)return;let m="",a;for(let l=v;l<f;l++)a=this.a.buffer.active.getLine(l),a&&(m+=a.translateToString(!a.isWrapped)+(a.isWrapped?"":`
`));return m===""?void 0:m}getOutputMatch(v){if(!this.executedMarker||!this.endMarker)return;const f=this.endMarker.line;if(f===-1)return;const m=this.a.buffer.active,a=Math.max(this.executedMarker.line,0),l=v.lineMatcher,c=typeof l=="string"?1:v.length||j(l),d=[];let $;if(v.anchor==="bottom")for(let s=f-(v.offset||0);s>=a;s--){let b=s;const E=s;for(;b>=a&&m.getLine(b)?.isWrapped;)b--;if(s=b,d.unshift(g(m,b,E,this.a.cols)),$||($=d[0].match(l)),d.length>=c)break}else for(let s=a+(v.offset||0);s<f;s++){const b=s;let E=s;for(;E+1<f&&m.getLine(E+1)?.isWrapped;)E++;if(s=E,d.push(g(m,b,E,this.a.cols)),$||($=d[d.length-1].match(l)),d.length>=c)break}return $?{regexMatch:$,outputLines:d}:void 0}hasOutput(){return!this.executedMarker?.isDisposed&&!this.endMarker?.isDisposed&&!!(this.executedMarker&&this.endMarker&&this.executedMarker.line<this.endMarker.line)}getPromptRowCount(){return A(this,this.a.buffer.active)}getCommandRowCount(){return w(this)}}e.$ts=o;class t{constructor(v){this.c=v}serialize(v){if(this.commandStartMarker)return{promptStartLine:this.promptStartMarker?.line,startLine:this.commandStartMarker.line,startX:this.commandStartX,endLine:void 0,executedLine:void 0,executedX:void 0,command:"",commandLineConfidence:"low",isTrusted:!0,cwd:v,exitCode:void 0,commandStartLineContent:void 0,timestamp:0,duration:0,markProperties:void 0}}promoteToFullCommand(v,f,m,a){if(f===void 0&&this.command===void 0&&(this.command=""),this.command!==void 0&&!this.command.startsWith("\\")||m)return new o(this.c,{command:m?"":this.command||"",commandLineConfidence:m?"low":this.commandLineConfidence||"low",isTrusted:!!this.isTrusted,promptStartMarker:this.promptStartMarker,marker:this.commandStartMarker,startX:this.commandStartX,endMarker:this.commandFinishedMarker,executedMarker:this.commandExecutedMarker,executedX:this.commandExecutedX,timestamp:Date.now(),duration:this.b||0,cwd:v,exitCode:f,commandStartLineContent:this.commandStartLineContent,markProperties:a})}markExecutedTime(){this.a===void 0&&(this.a=Date.now())}markFinishedTime(){this.b===void 0&&this.a!==void 0&&(this.b=Date.now()-this.a)}extractCommandLine(){return _(this.c.buffer.active,this.c.cols,this.commandStartMarker,this.commandStartX,this.commandExecutedMarker,this.commandExecutedX)}getPromptRowCount(){return A(this,this.c.buffer.active)}getCommandRowCount(){return w(this)}}e.$us=t;function _(r,v,f,m,a,l){if(!f||!a||m===void 0||l===void 0)return"";let c="";for(let d=f.line;d<=a.line;d++){const $=r.getLine(d);$&&(c+=$.translateToString(!0,d===f.line?m:0,d===a.line?l:v))}return c}function g(r,v,f,m){const a=Math.max(2048/m*2);f=Math.min(f,v+a);let l="";for(let c=v;c<=f;c++){const d=r.getLine(c);d&&(l+=d.translateToString(!0,0,m))}return l}function j(r){if(!r.multiline)return 1;const v=r.source;let f=1,m=v.indexOf("\\n");for(;m!==-1;)f++,m=v.indexOf("\\n",m+1);return f}function A(r,v){const f="hasOutput"in r?r.marker:r.commandStartMarker;if(!f||!r.promptStartMarker)return 1;let m=1,a=r.promptStartMarker.line;for(;a<f.line&&(v.getLine(a)?.translateToString(!0)??"").length===0;)a++;return m=f.line-a+1,m}function w(r){const v="hasOutput"in r?r.marker:r.commandStartMarker,f="hasOutput"in r?r.executedMarker:r.commandExecutedMarker;if(!v||!f)return 1;let a=Math.max(f.line,v.line)-v.line+1;return("hasOutput"in r?r.executedX:r.commandExecutedX)===0&&a--,a}}),define(he[85],fe([0,1,12,14,4,2,9,23,84,83]),function(ie,e,o,t,_,g,j,A,w,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lxb=void 0,e.$mxb=l;let v=class extends g.$Zc{get promptInputModel(){return this.c}get commands(){return this.f}get executingCommand(){return this.n.command}get executingCommandObject(){if(this.n.commandStartMarker)return{marker:this.n.commandStartMarker}}get currentCommand(){return this.n}get cwd(){return this.g}get promptTerminator(){return this.h}constructor(s,b){super(),this.L=s,this.M=b,this.type=A.TerminalCapability.CommandDetection,this.f=[],this.n=new w.$us(this.L),this.r=[],this.t=!1,this.D=this.B(new _.$qe),this.onCommandStarted=this.D.event,this.F=this.B(new _.$qe),this.onBeforeCommandFinished=this.F.event,this.G=this.B(new _.$qe),this.onCommandFinished=this.G.event,this.H=this.B(new _.$qe),this.onCommandExecuted=this.H.event,this.I=this.B(new _.$qe),this.onCommandInvalidated=this.I.event,this.J=this.B(new _.$qe),this.onCurrentCommandInvalidated=this.J.event,this.c=this.B(new r.$ss(this.L,this.onCommandStarted,this.onCommandExecuted,this.M)),this.B(this.onCommandExecuted(P=>{if(P.commandLineConfidence!=="high"){const i=P;P.command=i.extractCommandLine(),P.commandLineConfidence="low","getOutput"in i?i.promptStartMarker&&i.marker&&i.executedMarker&&P.command.indexOf(`
`)===-1&&i.startX!==void 0&&i.startX>0&&(P.commandLineConfidence="medium"):i.promptStartMarker&&i.commandStartMarker&&i.commandExecutedMarker&&P.command.indexOf(`
`)===-1&&i.commandStartX!==void 0&&i.commandStartX>0&&(P.commandLineConfidence="medium")}}));const E=this;this.z=new class{get onCurrentCommandInvalidatedEmitter(){return E.J}get onCommandStartedEmitter(){return E.D}get onCommandExecutedEmitter(){return E.H}get dimensions(){return E.s}get isCommandStorageDisabled(){return E.t}get commandMarkers(){return E.r}set commandMarkers(P){E.r=P}get clearCommandsInViewport(){return E.P.bind(E)}commitCommandFinished(){E.w?.flush(),E.w=void 0}},this.C=this.B(new g.$2c(new f(this.L,this,this.z,this.M))),this.s={cols:this.L.cols,rows:this.L.rows},this.B(this.L.onResize(P=>this.N(P))),this.B(this.L.onCursorMove(()=>this.O()))}N(s){this.C.value.preHandleResize?.(s),this.s.cols=s.cols,this.s.rows=s.rows}O(){this.q.isDisposed||this.L.buffer.active===this.L.buffer.normal&&this.n.commandStartMarker&&this.L.buffer.active.baseY+this.L.buffer.active.cursorY<this.n.commandStartMarker.line&&(this.P(),this.n.isInvalid=!0,this.J.fire({reason:A.CommandInvalidationReason.Windows}))}P(){let s=0;for(let b=this.f.length-1;b>=0;b--){const E=this.f[b].marker?.line;if(E&&E<this.L.buffer.active.baseY)break;s++}s>0&&this.I.fire(this.f.splice(this.f.length-s,s))}setContinuationPrompt(s){this.c.setContinuationPrompt(s)}setPromptTerminator(s,b){this.M.debug("CommandDetectionCapability#setPromptTerminator",s),this.h=s,this.c.setLastPromptLine(b)}setCwd(s){this.g=s}setIsWindowsPty(s){if(s&&!(this.C.value instanceof a)){const b=this;this.C.value=new a(this.L,this,new class{get onCurrentCommandInvalidatedEmitter(){return b.J}get onCommandStartedEmitter(){return b.D}get onCommandExecutedEmitter(){return b.H}get dimensions(){return b.s}get isCommandStorageDisabled(){return b.t}get commandMarkers(){return b.r}set commandMarkers(E){b.r=E}get clearCommandsInViewport(){return b.P.bind(b)}commitCommandFinished(){b.w?.flush(),b.w=void 0}},this.M)}else!s&&!(this.C.value instanceof f)&&(this.C.value=new f(this.L,this,this.z,this.M))}setIsCommandStorageDisabled(){this.t=!0}getCommandForLine(s){if(this.n.promptStartMarker&&s>=this.n.promptStartMarker?.line)return this.n;if(this.f.length!==0&&!((this.f[0].promptStartMarker??this.f[0].marker).line>s)){for(let b=this.commands.length-1;b>=0;b--)if((this.commands[b].promptStartMarker??this.commands[b].marker).line<=s)return this.commands[b]}}getCwdForLine(s){if(this.n.promptStartMarker&&s>=this.n.promptStartMarker?.line)return this.g;const b=this.getCommandForLine(s);if(b&&"cwd"in b)return b.cwd}handlePromptStart(s){const b=this.commands.at(-1);b?.endMarker&&b?.executedMarker&&b.endMarker.line===b.executedMarker.line&&(this.M.debug("CommandDetectionCapability#handlePromptStart adjusted commandFinished",`${b.endMarker.line} -> ${b.executedMarker.line+1}`),b.endMarker=d(this.L,b.executedMarker,1)),this.n.promptStartMarker=s?.marker||(b?.endMarker?d(this.L,b.endMarker):this.L.registerMarker(0)),this.M.debug("CommandDetectionCapability#handlePromptStart",this.L.buffer.active.cursorX,this.n.promptStartMarker?.line)}handleContinuationStart(){this.n.currentContinuationMarker=this.L.registerMarker(0),this.M.debug("CommandDetectionCapability#handleContinuationStart",this.n.currentContinuationMarker)}handleContinuationEnd(){if(!this.n.currentContinuationMarker){this.M.warn("CommandDetectionCapability#handleContinuationEnd Received continuation end without start");return}this.n.continuations||(this.n.continuations=[]),this.n.continuations.push({marker:this.n.currentContinuationMarker,end:this.L.buffer.active.cursorX}),this.n.currentContinuationMarker=void 0,this.M.debug("CommandDetectionCapability#handleContinuationEnd",this.n.continuations[this.n.continuations.length-1])}handleRightPromptStart(){this.n.commandRightPromptStartX=this.L.buffer.active.cursorX,this.M.debug("CommandDetectionCapability#handleRightPromptStart",this.n.commandRightPromptStartX)}handleRightPromptEnd(){this.n.commandRightPromptEndX=this.L.buffer.active.cursorX,this.M.debug("CommandDetectionCapability#handleRightPromptEnd",this.n.commandRightPromptEndX)}handleCommandStart(s){if(this.u=s,this.n.cwd=this.g,this.n.commandStartMarker=s?.marker||this.n.commandStartMarker,this.n.commandStartMarker?.line===this.L.buffer.active.cursorY){this.n.commandStartX=this.L.buffer.active.cursorX,this.M.debug("CommandDetectionCapability#handleCommandStart",this.n.commandStartX,this.n.commandStartMarker?.line);return}this.C.value.handleCommandStart(s)}handleGenericCommand(s){s?.markProperties?.disableCommandStorage&&this.setIsCommandStorageDisabled(),this.handlePromptStart(s),this.handleCommandStart(s),this.handleCommandExecuted(s),this.handleCommandFinished(void 0,s)}handleCommandExecuted(s){this.C.value.handleCommandExecuted(s),this.n.markExecutedTime()}handleCommandFinished(s,b){if(this.n.markFinishedTime(),this.C.value.preHandleCommandFinished?.(),this.M.debug("CommandDetectionCapability#handleCommandFinished",this.L.buffer.active.cursorX,b?.marker?.line,this.n.command,this.n),s===void 0){const P=this.commands.length>0?this.commands[this.commands.length-1]:void 0;this.n.command&&this.n.command.length>0&&P?.command===this.n.command&&(s=P.exitCode)}if(this.n.commandStartMarker===void 0||!this.L.buffer.active)return;this.n.commandFinishedMarker=b?.marker||this.L.registerMarker(0),this.C.value.postHandleCommandFinished?.();const E=this.n.promoteToFullCommand(this.g,s,this.u?.ignoreCommandLine??!1,b?.markProperties);E&&(this.f.push(E),this.w=new o.$Wh(()=>{this.F.fire(E),this.n.isInvalid||(this.M.debug("CommandDetectionCapability#onCommandFinished",E),this.G.fire(E))},50),this.w.schedule()),this.n=new w.$us(this.L),this.u=void 0}setCommandLine(s,b){this.M.debug("CommandDetectionCapability#setCommandLine",s,b),this.n.command=s,this.n.commandLineConfidence="high",this.n.isTrusted=b,b&&this.c.setConfidentCommandLine(s)}serialize(){const s=this.commands.map(E=>E.serialize(this.t)),b=this.n.serialize(this.g);return b&&s.push(b),{isWindowsPty:this.C.value instanceof a,commands:s,promptInputModel:this.c.serialize()}}deserialize(s){s.isWindowsPty&&this.setIsWindowsPty(s.isWindowsPty);const b=this.L.buffer.normal;for(const E of s.commands){if(!E.endLine){const i=E.startLine!==void 0?this.L.registerMarker(E.startLine-(b.baseY+b.cursorY)):void 0;if(!i)continue;this.n.commandStartMarker=E.startLine!==void 0?this.L.registerMarker(E.startLine-(b.baseY+b.cursorY)):void 0,this.n.commandStartX=E.startX,this.n.promptStartMarker=E.promptStartLine!==void 0?this.L.registerMarker(E.promptStartLine-(b.baseY+b.cursorY)):void 0,this.g=E.cwd,this.D.fire({marker:i});continue}const P=w.$ts.deserialize(this.L,E,this.t);P&&(this.f.push(P),this.M.debug("CommandDetectionCapability#onCommandFinished",P),this.G.fire(P))}s.promptInputModel&&this.c.deserialize(s.promptInputModel)}};e.$lxb=v,me([(0,t.$di)(500)],v.prototype,"O",null),e.$lxb=v=me([je(1,j.$fk)],v);class f extends g.$Zc{constructor(s,b,E,P){super(),this.c=s,this.f=b,this.g=E,this.h=P,this.B(s.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&E.clearCommandsInViewport(),!1)))}handleCommandStart(s){this.g.commitCommandFinished();const b=this.f.currentCommand;b.commandStartX=this.c.buffer.active.cursorX,b.commandStartMarker=s?.marker||this.c.registerMarker(0),b.commandExecutedMarker?.dispose(),b.commandExecutedMarker=void 0,b.commandExecutedX=void 0;for(const E of this.g.commandMarkers)E.dispose();this.g.commandMarkers.length=0,this.g.onCommandStartedEmitter.fire({marker:s?.marker||b.commandStartMarker,markProperties:s?.markProperties}),this.h.debug("CommandDetectionCapability#handleCommandStart",b.commandStartX,b.commandStartMarker?.line)}handleCommandExecuted(s){const b=this.f.currentCommand;if(b.commandExecutedMarker=s?.marker||this.c.registerMarker(0),b.commandExecutedX=this.c.buffer.active.cursorX,this.h.debug("CommandDetectionCapability#handleCommandExecuted",b.commandExecutedX,b.commandExecutedMarker?.line),!b.commandStartMarker||!b.commandExecutedMarker||b.commandStartX===void 0)return;b.command=this.g.isCommandStorageDisabled?"":this.c.buffer.active.getLine(b.commandStartMarker.line)?.translateToString(!0,b.commandStartX,b.commandRightPromptStartX).trim();let E=b.commandStartMarker.line+1;const P=b.commandExecutedMarker.line;for(;E<P;E++){const i=this.c.buffer.active.getLine(E);if(i){const n=b.continuations?.find(R=>R.marker.line===E);n&&(b.command+=`
`);const h=n?.end??0;b.command+=i.translateToString(!0,h)}}E===P&&(b.command+=this.c.buffer.active.getLine(P)?.translateToString(!0,void 0,b.commandExecutedX)||""),this.g.onCommandExecutedEmitter.fire(b)}}var m;(function($){$[$.MaxCheckLineCount=10]="MaxCheckLineCount",$[$.Interval=20]="Interval",$[$.MaximumPollCount=10]="MaximumPollCount"})(m||(m={}));let a=class extends g.$Zc{constructor(s,b,E,P){super(),this.n=s,this.r=b,this.s=E,this.t=P,this.c=this.B(new g.$1c),this.g=0,this.h=0,this.B(s.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&this.s.clearCommandsInViewport(),!1))),this.B(this.r.onBeforeCommandFinished(i=>{(i.command.trim().toLowerCase()==="clear"||i.command.trim().toLowerCase()==="cls")&&(this.f?.cancel(),this.f=void 0,this.s.clearCommandsInViewport(),this.r.currentCommand.isInvalid=!0,this.s.onCurrentCommandInvalidatedEmitter.fire({reason:A.CommandInvalidationReason.Windows}))}))}preHandleResize(s){const b=this.n.buffer.active.baseY,E=s.rows-this.s.dimensions.rows;E>0&&this.D().then(()=>{const P=Math.min(E,b);for(let i=this.r.commands.length-1;i>=0;i--){const n=this.r.commands[i];if(!n.marker||n.marker.line<b||n.commandStartLineContent===void 0)break;const h=this.n.buffer.active.getLine(n.marker.line);if(!h||h.translateToString(!0)===n.commandStartLineContent)continue;const R=n.marker.line-P;this.n.buffer.active.getLine(R)?.translateToString(!0)===n.commandStartLineContent&&this.n._core._bufferService.buffer.lines.onDeleteEmitter.fire({index:this.n.buffer.active.baseY,amount:P})}})}handleCommandStart(){this.r.currentCommand.commandStartX=this.n.buffer.active.cursorX,this.s.commandMarkers.length=0;const s=this.r.currentCommand.commandStartMarker=this.r.currentCommand.promptStartMarker?d(this.n,this.r.currentCommand.promptStartMarker):this.n.registerMarker(0);this.r.currentCommand.commandStartX=0,this.g=0,this.h=0,this.f=new o.$Wh(()=>this.u(s),m.Interval),this.f.schedule()}u(s){if(this.q.isDisposed)return;const b=this.n.buffer.active;let E=this.g;for(;E<m.MaxCheckLineCount&&s.line+E<b.baseY+this.n.rows;){if(this.C()){const P=this.F(s.line+E);if(P){const i=typeof P=="string"?P:P.prompt;if(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0),typeof P=="object"&&P.likelySingleLine){this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted promptStart",`${this.r.currentCommand.promptStartMarker?.line} -> ${this.r.currentCommand.commandStartMarker.line}`),this.r.currentCommand.promptStartMarker?.dispose(),this.r.currentCommand.promptStartMarker=d(this.n,this.r.currentCommand.commandStartMarker);const n=this.r.commands.at(-1);n&&this.r.currentCommand.commandStartMarker.line!==n.endMarker?.line&&(n.endMarker?.dispose(),n.endMarker=d(this.n,this.r.currentCommand.commandStartMarker))}this.r.currentCommand.commandStartX=i.length,this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted commandStart",`${s.line} -> ${this.r.currentCommand.commandStartMarker.line}:${this.r.currentCommand.commandStartX}`),this.w();return}}E++}E<m.MaxCheckLineCount?(this.g=E,++this.h<m.MaximumPollCount?this.f?.schedule():this.w()):this.w()}w(){if(this.f&&(this.h=m.MaximumPollCount,this.f.flush(),this.f=void 0),this.s.commitCommandFinished(),this.r.currentCommand.commandExecutedMarker||(this.c.value=this.n.onCursorMove(()=>{if(this.s.commandMarkers.length===0||this.s.commandMarkers[this.s.commandMarkers.length-1].line!==this.n.buffer.active.cursorY){const s=this.n.registerMarker(0);s&&this.s.commandMarkers.push(s)}})),this.r.currentCommand.commandStartMarker){const s=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);s&&(this.r.currentCommand.commandStartLineContent=s.translateToString(!0))}this.s.onCommandStartedEmitter.fire({marker:this.r.currentCommand.commandStartMarker}),this.t.debug("CommandDetectionCapability#_handleCommandStartWindows",this.r.currentCommand.commandStartX,this.r.currentCommand.commandStartMarker?.line)}handleCommandExecuted(s){this.f&&this.w(),this.c.clear(),this.z(),this.r.currentCommand.commandExecutedX=this.n.buffer.active.cursorX,this.s.onCommandExecutedEmitter.fire(this.r.currentCommand),this.t.debug("CommandDetectionCapability#handleCommandExecuted",this.r.currentCommand.commandExecutedX,this.r.currentCommand.commandExecutedMarker?.line)}preHandleCommandFinished(){this.r.currentCommand.commandExecutedMarker||(this.s.commandMarkers.length===0&&(this.r.currentCommand.commandStartMarker||(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0)),this.r.currentCommand.commandStartMarker&&this.s.commandMarkers.push(this.r.currentCommand.commandStartMarker)),this.z())}postHandleCommandFinished(){const s=this.r.currentCommand,b=s.command,E=s.commandStartMarker?.line,P=s.commandExecutedMarker?.line;if(!b||b.length===0||E===void 0||E===-1||P===void 0||P===-1)return;let i=0,n=!1;for(let h=E;h<=P;h++){const R=this.n.buffer.active.getLine(h);if(!R)break;const W=R.translateToString(!0);for(let p=0;p<W.length;p++){for(;b.length<i&&b[i]===" ";)i++;if(W[p]===b[i]&&i++,i===b.length){const L=p>=this.n.cols-1;s.commandExecutedMarker=this.n.registerMarker(h-(this.n.buffer.active.baseY+this.n.buffer.active.cursorY)+(L?1:0)),s.commandExecutedX=L?0:p+1,n=!0;break}}if(n)break}}z(){if(this.s.commandMarkers.length!==0){if(this.s.commandMarkers=this.s.commandMarkers.sort((s,b)=>s.line-b.line),this.r.currentCommand.commandStartMarker=this.s.commandMarkers[0],this.r.currentCommand.commandStartMarker){const s=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);s&&(this.r.currentCommand.commandStartLineContent=s.translateToString(!0))}this.r.currentCommand.commandExecutedMarker=this.s.commandMarkers[this.s.commandMarkers.length-1],this.s.onCommandExecutedEmitter.fire(this.r.currentCommand)}}C(){const s=this.r.commands.at(-1);if(!s)return!0;const b=this.n.buffer.active.baseY+this.n.buffer.active.cursorY,E=(s.endMarker?s.endMarker.line:s.marker?.line)??-1;return b>E}D(){const s=this.n.buffer.active.cursorX,b=this.n.buffer.active.cursorY;let E=0;return new Promise((P,i)=>{const n=setInterval(()=>{if(s!==this.n.buffer.active.cursorX||b!==this.n.buffer.active.cursorY){P(),clearInterval(n);return}E+=10,E>1e3&&(clearInterval(n),P())},10)})}F(s=this.n.buffer.active.baseY+this.n.buffer.active.cursorY){const b=this.n.buffer.active.getLine(s);if(!b)return;const E=b.translateToString(!0);if(!E)return;const P=E.match(/(?<prompt>(\(.+\)\s)?(?:PS.+>\s?))/)?.groups?.prompt;if(P){const W=this.G(P,E,">");if(W)return{prompt:W,likelySingleLine:!0}}const i=E.match(/.*\u276f(?=[^\u276f]*$)/g)?.[0];if(i){const W=this.G(i,E,"\u276F");if(W)return W}const n=E.match(/^(?<prompt>\$)/)?.groups?.prompt;if(n){const W=this.G(n,E,"$");if(W)return W}const h=E.match(/^(?<prompt>>>> )/g)?.groups?.prompt;if(h)return{prompt:h,likelySingleLine:!0};if(this.r.promptTerminator&&E.trim().endsWith(this.r.promptTerminator)){const W=this.G(E,E,this.r.promptTerminator);if(W)return W}const R=E.match(/^(?<prompt>(\(.+\)\s)?(?:[A-Z]:\\.*>))/);return R?.groups?.prompt?{prompt:R.groups.prompt,likelySingleLine:!0}:void 0}G(s,b,E){if(s)return b===s&&s.endsWith(E)&&(s+=" "),s}};a=me([je(3,j.$fk)],a);function l($,s,b,E){if(!E)return;const P=s.executedMarker,i=s.endMarker;if(!P||!i)return;const n=P.line,h=i.line,R=E.length,W=[];if(E.anchor==="bottom")for(let p=h-(E.offset||0);p>=n;p--){let L=p;const k=p;for(;L>=n&&$.getLine(L)?.isWrapped;)L--;p=L,W.unshift(c($,L,k,b)),W.length>R&&W.pop()}else for(let p=n+(E.offset||0);p<h;p++){const L=p;let k=p;for(;k+1<h&&$.getLine(k+1)?.isWrapped;)k++;p=k,W.push(c($,L,k,b)),W.length===R&&W.shift()}return W}function c($,s,b,E){const P=Math.max(2048/E*2);b=Math.min(b,s+P);let i="";for(let n=s;n<=b;n++){const h=$.getLine(n);h&&(i+=h.translateToString(!0,0,E))}return i}function d($,s,b=0){return $.registerMarker(s.line-($.buffer.active.baseY+$.buffer.active.cursorY)+b)}}),define(he[86],fe([0,1,4,2,23]),function(ie,e,o,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nxb=void 0;class g extends t.$Zc{constructor(){super(...arguments),this.type=_.TerminalCapability.CwdDetection,this.a="",this.b=new Map,this.c=this.B(new o.$qe),this.onDidChangeCwd=this.c.event}get cwds(){return Array.from(this.b.keys())}getCwd(){return this.a}updateCwd(A){const w=this.a!==A;this.a=A;const r=this.b.get(this.a)||0;this.b.delete(this.a),this.b.set(this.a,r+1),w&&this.c.fire(A)}}e.$nxb=g}),define(he[87],fe([0,1,4,2,23]),function(ie,e,o,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oxb=void 0;var g;(function(A){A[A.MinimumPromptLength=2]="MinimumPromptLength"})(g||(g={}));class j extends t.$Yc{get commands(){return this.a}constructor(w){super(),this.c=w,this.type=_.TerminalCapability.PartialCommandDetection,this.a=[],this.b=this.add(new o.$qe),this.onCommandFinished=this.b.event,this.add(this.c.onData(r=>this.h(r))),this.add(this.c.parser.registerCsiHandler({final:"J"},r=>(r.length>=1&&(r[0]===2||r[0]===3)&&this.m(),!1)))}h(w){w==="\r"&&this.j()}j(){if(this.c&&this.c.buffer.active.cursorX>=g.MinimumPromptLength){const w=this.c.registerMarker(0);w&&(this.a.push(w),this.b.fire(w))}}m(){let w=0;for(let r=this.a.length-1;r>=0&&!(this.a[r].line<this.c.buffer.active.baseY);r--)w++;this.a.splice(this.a.length-w,w)}}e.$oxb=j}),define(he[88],fe([0,1,4,2]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kxb=e.$jxb=void 0;class _ extends t.$Zc{constructor(){super(...arguments),this.a=new Map,this.b=this.B(new o.$qe),this.onDidRemoveCapabilityType=this.b.event,this.f=this.B(new o.$qe),this.onDidAddCapabilityType=this.f.event,this.g=this.B(new o.$qe),this.onDidRemoveCapability=this.g.event,this.h=this.B(new o.$qe),this.onDidAddCapability=this.h.event}get items(){return this.a.keys()}add(A,w){this.a.set(A,w),this.f.fire(A),this.h.fire({id:A,capability:w})}get(A){return this.a.get(A)}remove(A){const w=this.a.get(A);w&&(this.a.delete(A),this.b.fire(A),this.h.fire({id:A,capability:w}))}has(A){return this.a.has(A)}}e.$jxb=_;class g extends t.$Zc{constructor(){super(...arguments),this._stores=[],this.a=this.B(new o.$qe),this.onDidRemoveCapabilityType=this.a.event,this.b=this.B(new o.$qe),this.onDidAddCapabilityType=this.b.event,this.f=this.B(new o.$qe),this.onDidRemoveCapability=this.f.event,this.g=this.B(new o.$qe),this.onDidAddCapability=this.g.event}get items(){return this.h()}*h(){for(const A of this._stores)for(const w of A.items)yield w}has(A){for(const w of this._stores)for(const r of w.items)if(r===A)return!0;return!1}get(A){for(const w of this._stores){const r=w.get(A);if(r)return r}}add(A){this._stores.push(A);for(const w of A.items)this.b.fire(w),this.g.fire({id:w,capability:A.get(w)});this.B(A.onDidAddCapabilityType(w=>this.b.fire(w))),this.B(A.onDidAddCapability(w=>this.g.fire(w))),this.B(A.onDidRemoveCapabilityType(w=>this.a.fire(w))),this.B(A.onDidRemoveCapability(w=>this.f.fire(w)))}}e.$kxb=g}),define(he[40],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var o;(function(t){t[t.Replace=1]="Replace",t[t.Append=2]="Append",t[t.Prepend=3]="Prepend"})(o||(e.EnvironmentVariableMutatorType=o={}))}),define(he[89],fe([0,1,3,40]),function(ie,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0;const _=new Map([[t.EnvironmentVariableMutatorType.Append,"APPEND"],[t.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[t.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class g{constructor(v){this.collections=v,this.a=new Map,this.b=new Map,v.forEach((f,m)=>{this.d(f,m);const a=f.map.entries();let l=a.next();for(;!l.done;){const c=l.value[1],d=l.value[0];let $=this.a.get(d);if($||($=[],this.a.set(d,$)),$.length>0&&$[0].type===t.EnvironmentVariableMutatorType.Replace){l=a.next();continue}const s={extensionIdentifier:m,value:c.value,type:c.type,scope:c.scope,variable:c.variable,options:c.options};s.scope||delete s.scope,$.unshift(s),l=a.next()}})}async applyToProcessEnvironment(v,f,m){let a;o.$l&&(a={},Object.keys(v).forEach(l=>a[l.toLowerCase()]=l));for(const[l,c]of this.getVariableMap(f)){const d=o.$l&&a[l.toLowerCase()]||l;for(const $ of c){const s=m?await m($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case t.EnvironmentVariableMutatorType.Append:v[d]=(v[d]||"")+s;break;case t.EnvironmentVariableMutatorType.Prepend:v[d]=s+(v[d]||"");break;case t.EnvironmentVariableMutatorType.Replace:v[d]=s;break}if($.options?.applyAtShellIntegration??!1){const b=`VSCODE_ENV_${_.get($.type)}`;v[b]=(v[b]?v[b]+":":"")+l+"="+this.c(s)}}}}c(v){return v.replaceAll(":","\\x3a")}diff(v,f){const m=new Map,a=new Map,l=new Map;if(v.getVariableMap(f).forEach((c,d)=>{const $=this.getVariableMap(f).get(d),s=A(c,$);s&&m.set(d,s)}),this.getVariableMap(f).forEach((c,d)=>{const $=v.getVariableMap(f).get(d),s=A(c,$);s&&l.set(d,s)}),this.getVariableMap(f).forEach((c,d)=>{const $=v.getVariableMap(f).get(d),s=w(c,$);s&&a.set(d,s)}),!(m.size===0&&a.size===0&&l.size===0))return{added:m,changed:a,removed:l}}getVariableMap(v){const f=new Map;for(const m of this.a.values()){const a=m.filter(l=>j(l,v));a.length>0&&f.set(a[0].variable,a)}return f}getDescriptionMap(v){const f=new Map;for(const m of this.b.values()){const a=m.filter(l=>j(l,v,!0));for(const l of a)f.set(l.extensionIdentifier,l.description)}return f}d(v,f){if(!v.descriptionMap)return;const m=v.descriptionMap.entries();let a=m.next();for(;!a.done;){const l=a.value[1],c=a.value[0];let d=this.b.get(c);d||(d=[],this.b.set(c,d));const $={extensionIdentifier:f,scope:l.scope,description:l.description};$.scope||delete $.scope,d.push($),a=m.next()}}}e.$Ts=g;function j(r,v,f=!1){return r.scope?!!(r.scope.workspaceFolder&&v?.workspaceFolder&&r.scope.workspaceFolder.index===v.workspaceFolder.index):f?v===r.scope:!0}function A(r,v){if(!v)return r;const f=new Set;v.forEach(a=>f.add(a.extensionIdentifier));const m=[];return r.forEach(a=>{f.has(a.extensionIdentifier)||m.push(a)}),m.length===0?void 0:m}function w(r,v){if(!v)return;const f=new Map;v.forEach(a=>f.set(a.extensionIdentifier,a));const m=[];return r.forEach(a=>{const l=f.get(a.extensionIdentifier);l&&(a.type!==l.type||a.value!==l.value||a.scope?.workspaceFolder?.index!==l.scope?.workspaceFolder?.index)&&m.push(l)}),m.length===0?void 0:m}}),define(he[90],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=o,e.$Os=t,e.$Ps=_,e.$Qs=g,e.$Rs=j,e.$Ss=A;function o(w){return[...w.entries()]}function t(w){return w?[...w.entries()]:[]}function _(w){return new Map(w)}function g(w){return new Map(w??[])}function j(w){return Array.from(w.entries()).map(r=>[r[0],o(r[1].map),t(r[1].descriptionMap)])}function A(w){return new Map(w.map(r=>[r[0],{map:_(r[1]),descriptionMap:g(r[2])}]))}}),define(he[91],fe([0,1,12,18,4,2,9]),function(ie,e,o,t,_,g,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0;let A=class extends g.$Zc{constructor(r,v){super(),this.h=v,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new _.$qe),this.onCreateRequest=this.g.event,this.b=r===void 0?15e3:r,this.B((0,g.$Xc)(()=>{for(const f of this.f.values())(0,g.$Uc)(f)}))}createRequest(r){return new Promise((v,f)=>{const m=++this.a;this.c.set(m,v),this.g.fire({requestId:m,...r});const a=new t.$Be;(0,o.$Lh)(this.b,a.token).then(()=>f(`Request ${m} timed out (${this.b}ms)`)),this.f.set(m,[(0,g.$Xc)(()=>a.cancel())])})}acceptReply(r,v){const f=this.c.get(r);f?(this.c.delete(r),(0,g.$Uc)(this.f.get(r)||[]),this.f.delete(r),f(v)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${r}`)}};e.$Es=A,e.$Es=A=me([je(1,j.$fk)],A)}),define(he[16],fe([0,1,22,39,81]),function(ie,e,o,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=e.$zs=e.$ys=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$xs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.GeneralShellType=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ws=void 0,e.$ws=new t.$2j("terminalTabFocusMode",!1,!0);var g;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(g||(e.TerminalSettingPrefix=g={}));var j;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(j||(e.TerminalSettingId=j={}));var A;(function(i){i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh"})(A||(e.PosixShellType=A={}));var w;(function(i){i.CommandPrompt="cmd",i.Wsl="wsl",i.GitBash="gitbash"})(w||(e.WindowsShellType=w={}));var r;(function(i){i.PowerShell="pwsh",i.Python="python",i.Julia="julia",i.NuShell="nu"})(r||(e.GeneralShellType=r={}));var v;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(v||(e.TitleEventSource=v={}));var f;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(f||(e.TerminalIpcChannels=f={}));var m;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(m||(e.ProcessPropertyType=m={})),e.$xs=(0,o.$Ki)("ptyService");var a;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(a||(e.HeartbeatConstants=a={}));var l;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(l||(e.TerminalLocation=l={}));var c;(function(i){i.TerminalView="view",i.Editor="editor"})(c||(e.TerminalLocationString=c={}));var d;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(d||(e.LocalReconnectConstants=d={}));var $;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})($||(e.FlowControlConstants=$={}));var s;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(s||(e.ProfileSource=s={}));var b;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(b||(e.ShellIntegrationStatus=b={}));var E;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(E||(e.TerminalExitReason=E={})),e.$ys={Backend:"workbench.contributions.terminal.processBackend"};class P{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(n){const h=this.b(n.remoteAuthority);if(this.a.has(h))throw new Error(`A terminal backend with remote authority '${h}' was already registered.`);this.a.set(h,n)}getTerminalBackend(n){return this.a.get(this.b(n))}b(n){return n?.toLowerCase()??""}}_.$xo.add(e.$ys.Backend,new P),e.$zs=(0,o.$Ki)("localPtyService"),e.$As=(0,o.$Ki)("terminalLogService")}),define(he[92],fe([0,1,12,2,3]),function(ie,e,o,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$nc=void 0;class g extends t.$Zc{constructor(A,w,r,v){super(),this.a=0,this.b=!1,this.c=!1,this.B(A.onProcessData(f=>{if(this.b||this.c)return;const m=typeof f=="string"?f:f.data;for(let a=0;a<m.length;a++)m[a]===w[this.a]?this.a++:this.f(),this.a===w.length&&(v.debug(`Auto reply match: "${w}", response: "${r}"`),A.input(r),this.c=!0,(0,o.$Lh)(1e3).then(()=>this.c=!1),this.f())}))}f(){this.a=0}handleResize(){_.$l&&(this.b=!0)}handleInput(){this.b=!1}}e.$$nc=g}),define(he[93],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zyb=void 0;class o{constructor(_){this.b=_,this.a=new Map}dispose(){for(const _ of this.a.values())_.dispose()}startBuffering(_,g,j=5){const A=g(w=>{const r=typeof w=="string"?w:w.data;let v=this.a.get(_);if(v){v.data.push(r);return}const f=setTimeout(()=>this.flushBuffer(_),j);v={data:[r],timeoutId:f,dispose:()=>{clearTimeout(f),this.flushBuffer(_),A.dispose()}},this.a.set(_,v)});return A}stopBuffering(_){this.a.get(_)?.dispose()}flushBuffer(_){const g=this.a.get(_);g&&(this.a.delete(_),this.b(_,g.data.join("")))}}e.$zyb=o}),define(he[41],fe([0,1,3]),function(ie,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AR=t,e.$BR=_,e.$CR=g,e.$DR=j;function t(A){let w=A;w.includes("\\")&&(w=w.replace(/\\/g,"\\\\"));const r=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return w=w.replace(r,""),`'${w}'`}function _(A,w,r){if(!A)return"";if(!w)return A;w.match(/[\/\\]$/)&&(w=w.slice(0,w.length-1));const v=A.replace(/\\/g,"/").toLowerCase(),f=w.replace(/\\/g,"/").toLowerCase();return v.includes(f)?`~${r}${A.slice(w.length+1)}`:A}function g(A){return A.match(/^['"].*['"]$/)&&(A=A.substring(1,A.length-1)),o.OS===o.OperatingSystem.Windows&&A&&A[1]===":"?A[0].toUpperCase()+A.substring(1):A}function j(A){return!A.strictEnv}}),define(he[94],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=t;var o;(function(_){_[_.WriteMaxChunkSize=50]="WriteMaxChunkSize"})(o||(o={}));function t(_){const g=[];let j=0;for(let A=0;A<_.length-1;A++)(A-j+1>=o.WriteMaxChunkSize||_[A+1]==="\x1B")&&(g.push(_.substring(j,A+1)),j=A+1,A++);return j!==_.length&&g.push(_.substring(j)),g}}),define(he[95],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fZb=o;function o(t,_={}){let g="";return _.excludeLeadingNewLine||(g+=`\r
`),g+="\x1B[0m\x1B[7m * ",_.loudFormatting?g+="\x1B[0;104m":g+="\x1B[0m",g+=` ${t} \x1B[0m
\r`,g}}),define(he[96],fe([0,1,16,2,88,85,86,23,87,4,82,6,41,11]),function(ie,e,o,t,_,g,j,A,w,r,v,f,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qxb=e.ShellIntegrationOscPs=void 0,e.$rxb=b,e.$sxb=E,e.$txb=P;var l;(function(i){i[i.FinalTerm=133]="FinalTerm",i[i.VSCode=633]="VSCode",i[i.ITerm=1337]="ITerm",i[i.SetCwd=7]="SetCwd",i[i.SetWindowsFriendlyCwd=9]="SetWindowsFriendlyCwd"})(l||(e.ShellIntegrationOscPs=l={}));var c;(function(i){i.PromptStart="A",i.CommandStart="B",i.CommandExecuted="C",i.CommandFinished="D"})(c||(c={}));var d;(function(i){i.PromptStart="A",i.CommandStart="B",i.CommandExecuted="C",i.CommandFinished="D",i.CommandLine="E",i.ContinuationStart="F",i.ContinuationEnd="G",i.RightPromptStart="H",i.RightPromptEnd="I",i.Property="P",i.SetMark="SetMark"})(d||(d={}));var $;(function(i){i.SetMark="SetMark",i.CurrentDir="CurrentDir"})($||($={}));class s extends t.$Zc{get status(){return this.g}constructor(n,h,R,W){super(),this.j=n,this.m=h,this.n=R,this.r=W,this.capabilities=this.B(new _.$jxb),this.b=!1,this.f=[],this.g=o.ShellIntegrationStatus.Off,this.h=new r.$qe,this.onDidChangeStatus=this.h.event,this.B((0,t.$Xc)(()=>{this.z(),this.s()}))}s(){(0,t.$Uc)(this.f),this.f.length=0}activate(n){this.a=n,this.capabilities.add(A.TerminalCapability.PartialCommandDetection,this.B(new w.$oxb(this.a))),this.B(n.parser.registerOscHandler(l.VSCode,h=>this.w(h))),this.B(n.parser.registerOscHandler(l.ITerm,h=>this.H(h))),this.f.push(n.parser.registerOscHandler(l.FinalTerm,h=>this.t(h))),this.B(n.parser.registerOscHandler(l.SetCwd,h=>this.J(h))),this.B(n.parser.registerOscHandler(l.SetWindowsFriendlyCwd,h=>this.I(h))),this.y()}getMarkerId(n,h){this.N(n).getMark(h)}t(n){const h=this.u(n);return this.g===o.ShellIntegrationStatus.Off&&(this.g=o.ShellIntegrationStatus.FinalTerm,this.h.fire(this.g)),h}u(n){if(!this.a)return!1;const[h,...R]=n.split(";");switch(h){case c.PromptStart:return this.M(this.a).handlePromptStart(),!0;case c.CommandStart:return this.M(this.a).handleCommandStart({ignoreCommandLine:!0}),!0;case c.CommandExecuted:return this.M(this.a).handleCommandExecuted(),!0;case c.CommandFinished:{const W=R.length===1?parseInt(R[0]):void 0;return this.M(this.a).handleCommandFinished(W),!0}}return!1}w(n){const h=this.C(n);return!this.b&&h&&(this.n?.publicLog2("terminal/shellIntegrationActivationSucceeded"),this.b=!0,this.z()),this.g!==o.ShellIntegrationStatus.VSCode&&(this.g=o.ShellIntegrationStatus.VSCode,this.h.fire(this.g)),h}async y(){!this.n||this.m||(this.c=setTimeout(()=>{!this.capabilities.get(A.TerminalCapability.CommandDetection)&&!this.capabilities.get(A.TerminalCapability.CwdDetection)&&(this.n?.publicLog2("terminal/shellIntegrationActivationTimeout"),this.r.warn("Shell integration failed to add capabilities within 10 seconds")),this.b=!0},1e4))}z(){this.c!==void 0&&(clearTimeout(this.c),this.c=void 0)}C(n){if(!this.a)return!1;const h=n.indexOf(";"),R=h===-1?n:n.substring(0,h),W=h===-1?[]:n.substring(h+1).split(";");switch(R){case d.PromptStart:return this.M(this.a).handlePromptStart(),!0;case d.CommandStart:return this.M(this.a).handleCommandStart(),!0;case d.CommandExecuted:return this.M(this.a).handleCommandExecuted(),!0;case d.CommandFinished:{const p=W[0],L=p!==void 0?parseInt(p):void 0;return this.M(this.a).handleCommandFinished(L),!0}case d.CommandLine:{const p=W[0],L=W[1];let k;return p!==void 0?k=b(p):k="",this.M(this.a).setCommandLine(k,L===this.j),!0}case d.ContinuationStart:return this.M(this.a).handleContinuationStart(),!0;case d.ContinuationEnd:return this.M(this.a).handleContinuationEnd(),!0;case d.RightPromptStart:return this.M(this.a).handleRightPromptStart(),!0;case d.RightPromptEnd:return this.M(this.a).handleRightPromptEnd(),!0;case d.Property:{const p=W[0],L=p!==void 0?b(p):"",{key:k,value:M}=E(L);if(M===void 0)return!0;switch(k){case"ContinuationPrompt":return this.D((0,a.$8f)(M)),!0;case"Cwd":return this.G(M),!0;case"IsWindows":return this.M(this.a).setIsWindowsPty(M==="True"),!0;case"Prompt":{const C=M.replace(/\x1b\[[0-9;]*m/g,"");return this.F(C),!0}case"Task":return this.N(this.a),this.capabilities.get(A.TerminalCapability.CommandDetection)?.setIsCommandStorageDisabled(),!0}}case d.SetMark:return this.N(this.a).addMark(P(W)),!0}return!1}D(n){this.a&&this.M(this.a).setContinuationPrompt(n)}F(n){if(!this.a)return;const h=n.substring(n.lastIndexOf(`
`)+1),R=h.substring(h.lastIndexOf(" "));R&&this.M(this.a).setPromptTerminator(R,h)}G(n){n=(0,m.$CR)(n),this.L().updateCwd(n),this.capabilities.get(A.TerminalCapability.CommandDetection)?.setCwd(n)}H(n){if(!this.a)return!1;const[h]=n.split(";");switch(h){case $.SetMark:this.N(this.a).addMark();default:{const{key:R,value:W}=E(h);if(W===void 0)return!0;switch(R){case $.CurrentDir:return this.G(W),!0}}}return!1}I(n){if(!this.a)return!1;const[h,...R]=n.split(";");switch(h){case"9":return R.length&&this.G(R[0]),!0}return!1}J(n){if(!this.a)return!1;const[h]=n.split(";");if(h.match(/^file:\/\/.*\//)){const R=f.URI.parse(h);if(R.path&&R.path.length>0)return this.G(R.path),!0}return!1}serialize(){return!this.a||!this.capabilities.has(A.TerminalCapability.CommandDetection)?{isWindowsPty:!1,commands:[],promptInputModel:void 0}:this.M(this.a).serialize()}deserialize(n){if(!this.a)throw new Error("Cannot restore commands before addon is activated");this.M(this.a).deserialize(n)}L(){let n=this.capabilities.get(A.TerminalCapability.CwdDetection);return n||(n=this.B(new j.$nxb),this.capabilities.add(A.TerminalCapability.CwdDetection,n)),n}M(n){let h=this.capabilities.get(A.TerminalCapability.CommandDetection);return h||(h=this.B(new g.$lxb(n,this.r)),this.capabilities.add(A.TerminalCapability.CommandDetection,h)),h}N(n){let h=this.capabilities.get(A.TerminalCapability.BufferMarkDetection);return h||(h=this.B(new v.$pxb(n)),this.capabilities.add(A.TerminalCapability.BufferMarkDetection,h)),h}}e.$qxb=s;function b(i){return i.replaceAll(/\\(\\|x([0-9a-f]{2}))/gi,(n,h,R)=>R?String.fromCharCode(parseInt(R,16)):h)}function E(i){const n=i.indexOf("=");return n===-1?{key:i,value:void 0}:{key:i.substring(0,n),value:i.substring(1+n)}}function P(i){let n,h=!1;for(const R of i)R!==void 0&&(R==="Hidden"&&(h=!0),R.startsWith("Id=")&&(n=R.substring(3)));return{id:n,hidden:h}}}),define(he[42],fe([0,1,5,14,4,2,64,9]),function(ie,e,o,t,_,g,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aoc=e.$_nc=void 0;var w;(function(v){v[v.InactiveThrottleDuration=5e3]="InactiveThrottleDuration",v[v.ActiveDebounceDuration=1e3]="ActiveDebounceDuration"})(w||(w={})),e.$_nc=[];let r=class extends g.$Zc{set hasChildProcesses(f){this.a!==f&&(this.a=f,this.f.debug("ChildProcessMonitor: Has child processes changed",f),this.b.fire(f))}get hasChildProcesses(){return this.a}constructor(f,m){super(),this.c=f,this.f=m,this.a=!1,this.b=this.B(new _.$qe),this.onDidChangeHasChildProcesses=this.b.event}handleInput(){this.g()}handleOutput(){this.h()}async g(){if(!this.q.isDisposed)try{const f=await(0,j.$6s)(this.c);this.hasChildProcesses=this.j(f)}catch(f){this.f.debug("ChildProcessMonitor: Fetching process tree failed",f)}}h(){this.g()}j(f){if(!f.children)return!1;if(f.children.length===1){const m=f.children[0];let a;if(m.cmd.startsWith('"'))a=m.cmd.substring(1,m.cmd.indexOf('"',1));else{const l=m.cmd.indexOf(" ");l===-1?a=m.cmd:a=m.cmd.substring(0,l)}return e.$_nc.indexOf((0,o.$vc)(a).name)===-1}return f.children.length>0}};e.$aoc=r,me([(0,t.$di)(w.ActiveDebounceDuration)],r.prototype,"g",null),me([(0,t.$ei)(w.InactiveThrottleDuration)],r.prototype,"h",null),e.$aoc=r=me([je(1,A.$fk)],r)}),define(he[97],fe([0,1,4,2,16]),function(ie,e,o,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$boc=void 0;class g extends t.$Zc{constructor(){super(),this.a=this.B(new o.$qe),this.onBeat=this.a.event;const A=setInterval(()=>{this.a.fire()},_.HeartbeatConstants.BeatInterval);this.B((0,t.$Xc)(()=>clearInterval(A)))}}e.$boc=g}),define(he[43],fe([0,1,21,20,32,5,3,15,11,10,28,40,90,89]),function(ie,e,o,t,_,g,j,A,w,r,v,f,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=l,e.$Vs=c,e.$Ws=d,o=Ae(o),g=Ae(g),A=Ae(A),v=Ae(v);function l(){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(o.release());let L=0;return p&&p.length===4&&(L=parseInt(p[3])),L}async function c(p,L,k,M=A.env,C=v.Promises.exists){if(g.$nc(p))return await C(p)?p:void 0;if(L===void 0&&(L=A.cwd()),g.$rc(p)!=="."){const I=g.$oc(L,p);return await C(I)?I:void 0}const y=(0,_.$ro)(M,"PATH");if(k===void 0&&(0,r.$jg)(y)&&(k=y.split(g.$yc)),k===void 0||k.length===0){const I=g.$oc(L,p);return await C(I)?I:void 0}for(const I of k){let S;if(g.$nc(I)?S=g.$oc(I,p):S=g.$oc(L,I,p),await C(S))return S;if(j.$l){let F=S+".com";if(await C(F)||(F=S+".exe",await C(F)))return F}}const T=g.$oc(L,p);return await C(T)?T:void 0}function d(p,L,k,M,C){const D=j.$l&&(!L.windowsEnableConpty||l()<18309);if(!L.shellIntegration.enabled||!p.executable||p.isFeatureTerminal&&!p.forceShellIntegration||p.ignoreShellIntegration||D)return;const y=p.args,T=A.$ic==="win32"?g.$sc(p.executable).toLowerCase():g.$sc(p.executable),I=g.$rc(t.$5g.asFileUri("").fsPath);let S;const F={VSCODE_INJECTION:"1"};if(L.shellIntegration.nonce&&(F.VSCODE_NONCE=L.shellIntegration.nonce),j.$l){if(T==="pwsh.exe"||T==="powershell.exe")return!y||R(y)?S=b.get(s.WindowsPwsh):h(y)&&(S=b.get(s.WindowsPwshLogin)),S?(S=[...S],S[S.length-1]=(0,w.$if)(S[S.length-1],I,""),F.VSCODE_STABLE=C.quality==="stable"?"1":"0",L.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),{newArgs:S,envMixin:F}):void 0;if(T==="bash.exe")return!y||y.length===0?S=b.get(s.Bash):W(y)&&(F.VSCODE_SHELL_LOGIN="1",$(L,F),S=b.get(s.Bash)),S?(S=[...S],S[S.length-1]=(0,w.$if)(S[S.length-1],I),F.VSCODE_STABLE=C.quality==="stable"?"1":"0",{newArgs:S,envMixin:F}):void 0;M.warn(`Shell integration cannot be enabled for executable "${p.executable}" and args`,p.args);return}switch(T){case"bash":return!y||y.length===0?S=b.get(s.Bash):W(y)&&(F.VSCODE_SHELL_LOGIN="1",$(L,F),S=b.get(s.Bash)),S?(S=[...S],S[S.length-1]=(0,w.$if)(S[S.length-1],I),F.VSCODE_STABLE=C.quality==="stable"?"1":"0",{newArgs:S,envMixin:F}):void 0;case"fish":{const J=k?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",V=g.$oc(I,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return F.XDG_DATA_DIRS=`${J}:${V}`,$(L,F),{newArgs:void 0,envMixin:F}}case"pwsh":return!y||R(y)?S=b.get(s.Pwsh):h(y)&&(S=b.get(s.PwshLogin)),S?(L.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),S=[...S],S[S.length-1]=(0,w.$if)(S[S.length-1],I,""),F.VSCODE_STABLE=C.quality==="stable"?"1":"0",{newArgs:S,envMixin:F}):void 0;case"zsh":{if(!y||y.length===0?S=b.get(s.Zsh):W(y)?(S=b.get(s.ZshLogin),$(L,F)):(y===b.get(s.Zsh)||y===b.get(s.ZshLogin))&&(S=y),!S)return;S=[...S],S[S.length-1]=(0,w.$if)(S[S.length-1],I);let J;try{J=o.userInfo().username}catch{J="unknown"}const V=g.$oc(o.tmpdir(),`${J}-${C.applicationName}-zsh`);F.ZDOTDIR=V;const Q=k?.ZDOTDIR??o.homedir()??"~";F.USER_ZDOTDIR=Q;const re=[];return re.push({source:g.$oc(I,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:g.$oc(V,".zshrc")}),re.push({source:g.$oc(I,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:g.$oc(V,".zprofile")}),re.push({source:g.$oc(I,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:g.$oc(V,".zshenv")}),re.push({source:g.$oc(I,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:g.$oc(V,".zlogin")}),{newArgs:S,envMixin:F,filesToCopy:re}}}M.warn(`Shell integration cannot be enabled for executable "${p.executable}" and args`,p.args)}function $(p,L){if(j.$m&&p.environmentVariableCollections){const k=(0,m.$Ss)(p.environmentVariableCollections),C=new a.$Ts(k).getVariableMap({workspaceFolder:p.workspaceFolder}).get("PATH"),D=[];if(C)for(const y of C)y.type===f.EnvironmentVariableMutatorType.Prepend&&D.push(y.value);D.length>0&&(L.VSCODE_PATH_PREFIX=D.join(""))}}var s;(function(p){p.WindowsPwsh="windows-pwsh",p.WindowsPwshLogin="windows-pwsh-login",p.Pwsh="pwsh",p.PwshLogin="pwsh-login",p.Zsh="zsh",p.ZshLogin="zsh-login",p.Bash="bash"})(s||(s={}));const b=new Map;b.set(s.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),b.set(s.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),b.set(s.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),b.set(s.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),b.set(s.Zsh,["-i"]),b.set(s.ZshLogin,["-il"]),b.set(s.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],P=["--login","-l"],i=["-i","--interactive"],n=["-nol","-nologo"];function h(p){return typeof p=="string"?E.includes(p.toLowerCase()):p.length===1&&E.includes(p[0].toLowerCase())||p.length===2&&(E.includes(p[0].toLowerCase())||E.includes(p[1].toLowerCase()))&&(n.includes(p[0].toLowerCase())||n.includes(p[1].toLowerCase()))}function R(p){return typeof p=="string"?n.includes(p.toLowerCase()):p.length===0||p?.length===1&&n.includes(p[0].toLowerCase())}function W(p){return typeof p!="string"&&(p=p.filter(L=>!i.includes(L.toLowerCase()))),p==="string"&&P.includes(p.toLowerCase())||typeof p!="string"&&p.length===1&&P.includes(p[0].toLowerCase())}}),define(he[98],fe([0,1,12,14,4,2,3,16]),function(ie,e,o,t,_,g,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$coc=void 0;const w=["cmd.exe","powershell.exe","pwsh.exe","bash.exe","wsl.exe","ubuntu.exe","ubuntu1804.exe","kali.exe","debian.exe","opensuse-42.exe","sles-12.exe"];let r;class v extends g.$Zc{get shellType(){return this.b}get shellTitle(){return this.c}get onShellNameChanged(){return this.f.event}get onShellTypeChanged(){return this.g.event}constructor(m){if(super(),this.h=m,this.c="",this.f=new _.$qe,this.g=new _.$qe,!j.$l)throw new Error(`WindowsShellHelper cannot be instantiated on ${j.$x}`);this.j()}async j(){this.q.isDisposed||this.checkShell()}async checkShell(){j.$l&&(await(0,o.$Lh)(300),this.getShellName().then(m=>{const a=this.getShellType(m);a!==this.b&&(this.g.fire(a),this.f.fire(m),this.b=a,this.c=m)}))}m(m){if(!m)return"";if(w.indexOf(m.name)===-1||!m.children||m.children.length===0)return m.name;let a=0;for(;a<m.children.length;a++){const l=m.children[a];if(!l.children||l.children.length===0||l.children[0].name!=="conhost.exe")break}return a>=m.children.length?m.name:this.m(m.children[a])}async getShellName(){return this.q.isDisposed?Promise.resolve(""):this.a?this.a:(r||(r=await new Promise((m,a)=>{ie(["@vscode/windows-process-tree"],m,a)}).then(Ae)),this.a=new Promise(m=>{r.getProcessTree(this.h,a=>{const l=this.m(a);this.a=void 0,m(l)})}),this.a)}getShellType(m){switch(m.toLowerCase()){case"cmd.exe":return A.WindowsShellType.CommandPrompt;case"powershell.exe":case"pwsh.exe":return A.GeneralShellType.PowerShell;case"bash.exe":case"git-cmd.exe":return A.WindowsShellType.GitBash;case"julia.exe:":return A.GeneralShellType.Julia;case"nu.exe":return A.GeneralShellType.NuShell;case"wsl.exe":case"ubuntu.exe":case"ubuntu1804.exe":case"kali.exe":case"debian.exe":case"opensuse-42.exe":case"sles-12.exe":return A.WindowsShellType.Wsl;default:return m.match(/python(\d(\.\d{0,2})?)?\.exe/)?A.GeneralShellType.Python:void 0}}}e.$coc=v,me([(0,t.$di)(500)],v.prototype,"checkShell",null)}),define(he[99],fe([0,1,37,29,12,4,2,5,3,6,8,9,80,16,42,43,98,103,94]),function(ie,e,o,t,_,g,j,A,w,r,v,f,m,a,l,c,d,$,s){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$doc=void 0,o=Ae(o),A=Ae(A);var E;(function(W){W[W.DataFlushTimeout=250]="DataFlushTimeout",W[W.MaximumShutdownTime=5e3]="MaximumShutdownTime"})(E||(E={}));var P;(function(W){W[W.KillSpawnThrottleInterval=250]="KillSpawnThrottleInterval",W[W.KillSpawnSpacingDuration=50]="KillSpawnSpacingDuration",W[W.WriteInterval=5]="WriteInterval"})(P||(P={}));const i=new Map([["bash",a.PosixShellType.Bash],["csh",a.PosixShellType.Csh],["fish",a.PosixShellType.Fish],["ksh",a.PosixShellType.Ksh],["sh",a.PosixShellType.Sh],["zsh",a.PosixShellType.Zsh]]),n=new Map([["pwsh",a.GeneralShellType.PowerShell],["python",a.GeneralShellType.Python],["julia",a.GeneralShellType.Julia],["nu",a.GeneralShellType.NuShell]]);let h=class extends j.$Zc{static{b=this}static{this.b=0}get exitMessage(){return this.h}get currentTitle(){return this.t?.shellTitle||this.n}get shellType(){return w.$l?this.t?.shellType:i.get(this.n)||n.get(this.n)}get hasChildProcesses(){return this.u?.hasChildProcesses||!1}constructor(p,L,k,M,C,D,y,T,I){super(),this.shellLaunchConfig=p,this.N=D,this.O=y,this.P=T,this.Q=I,this.id=0,this.shouldPersist=!1,this.a={cwd:"",initialCwd:"",fixedDimensions:{cols:void 0,rows:void 0},title:"",shellType:void 0,hasChildProcesses:!0,resolvedShellLaunchConfig:{},overrideDimensions:void 0,failedShellIntegrationActivation:!1,usedShellIntegrationInjection:void 0},this.n="",this.w=null,this.y=[],this.G=!1,this.H=0,this.I=this.B(new g.$qe),this.onProcessData=this.I.event,this.J=this.B(new g.$qe),this.onProcessReady=this.J.event,this.L=this.B(new g.$qe),this.onDidChangeProperty=this.L.event,this.M=this.B(new g.$qe),this.onProcessExit=this.M.event;let S;w.$l?S=A.$sc(this.shellLaunchConfig.executable||""):S="xterm-256color",this.D=L,this.a[a.ProcessPropertyType.InitialCwd]=this.D,this.a[a.ProcessPropertyType.Cwd]=this.D;const F=this.O.windowsEnableConpty&&process.platform==="win32"&&(0,c.$Us)()>=18309,J=F&&this.O.windowsUseConptyDll;this.F={name:S,cwd:L,env:C,cols:k,rows:M,useConpty:F,useConptyDll:J,conptyInheritCursor:F&&!!p.initialText},w.$l&&(F&&k===0&&M===0&&this.shellLaunchConfig.executable?.endsWith("Git\\bin\\bash.exe")&&(this.C=new R,this.B(this.C.onTrigger(V=>{this.C?.dispose(),this.C=void 0,V.cols&&V.rows&&this.resize(V.cols,V.rows)}))),this.onProcessReady(V=>{this.t=this.B(new d.$coc(V.pid)),this.B(this.t.onShellTypeChanged(Q=>this.L.fire({type:a.ProcessPropertyType.ShellType,value:Q}))),this.B(this.t.onShellNameChanged(Q=>this.L.fire({type:a.ProcessPropertyType.Title,value:Q})))})),this.B((0,j.$Xc)(()=>{this.w&&(clearInterval(this.w),this.w=null)}))}async start(){const L=(await Promise.all([this.R(),this.S()])).find(M=>M!==void 0);if(L)return L;let k;if(this.O.shellIntegration.enabled)if(k=(0,c.$Ws)(this.shellLaunchConfig,this.O,this.F.env,this.P,this.Q),k){if(this.L.fire({type:a.ProcessPropertyType.UsedShellIntegrationInjection,value:!0}),k.envMixin)for(const[M,C]of Object.entries(k.envMixin))this.F.env||={},this.F.env[M]=C;if(k.filesToCopy)for(const M of k.filesToCopy)try{await o.promises.mkdir(A.$rc(M.dest),{recursive:!0}),await o.promises.copyFile(M.source,M.dest)}catch{}}else this.L.fire({type:a.ProcessPropertyType.FailedShellIntegrationActivation,value:!0});try{return await this.U(this.shellLaunchConfig,this.F,k),k?.newArgs?{injectedArgs:k.newArgs}:void 0}catch(M){return this.P.trace("node-pty.node-pty.IPty#spawn native exception",M),{message:`A native exception occurred during launch (${M.message})`}}}async R(){try{if(!(await o.promises.stat(this.D)).isDirectory())return{message:(0,v.localize)(2121,null,this.D.toString())}}catch(p){if(p?.code==="ENOENT")return{message:(0,v.localize)(2122,null,this.D.toString())}}this.L.fire({type:a.ProcessPropertyType.InitialCwd,value:this.D})}async S(){const p=this.shellLaunchConfig;if(!p.executable)throw new Error("IShellLaunchConfig.executable not set");const L=p.cwd instanceof r.URI?p.cwd.path:p.cwd,k=p.env&&p.env.PATH?p.env.PATH.split(A.$yc):void 0,M=await(0,c.$Vs)(p.executable,L,k,this.N);if(!M)return{message:(0,v.localize)(2123,null,p.executable)};try{const C=await o.promises.stat(M);if(!C.isFile()&&!C.isSymbolicLink())return{message:(0,v.localize)(2124,null,p.executable)};p.executable=M}catch(C){if(C?.code!=="EACCES")throw C}}async U(p,L,k){const M=k?.newArgs||p.args||[];await this.Z(),this.P.trace("node-pty.IPty#spawn",p.executable,M,L);const C=(0,$.spawn)(p.executable,M,L);this.m=C,this.u=this.B(new l.$aoc(C.pid,this.P)),this.u.onDidChangeHasChildProcesses(D=>this.L.fire({type:a.ProcessPropertyType.HasChildProcesses,value:D})),this.s=new Promise(D=>{this.onProcessReady(()=>D())}),C.onData(D=>{this.H+=D.length,!this.G&&this.H>a.FlowControlConstants.HighWatermarkChars&&(this.P.trace(`Flow control: Pause (${this.H} > ${a.FlowControlConstants.HighWatermarkChars})`),this.G=!0,C.pause()),this.P.trace("node-pty.IPty#onData",D),this.I.fire(D),this.j&&this.X(),this.t?.checkShell(),this.u?.handleOutput()}),C.onExit(D=>{this.g=D.exitCode,this.X()}),this.$(C.pid),this.W(C)}W(p){setTimeout(()=>this.ab(p)),w.$l||(this.w=setInterval(()=>{this.n!==p.process&&this.ab(p)},200))}X(){this.P.getLevel()===f.LogLevel.Trace&&this.P.trace("TerminalProcess#_queueProcessExit",new Error().stack?.replace(/^Error/,"")),this.j&&clearTimeout(this.j),this.j=setTimeout(()=>{this.j=void 0,this.Y()},E.DataFlushTimeout)}async Y(){if(await this.s,!this.q.isDisposed){try{this.m&&(await this.Z(),this.P.trace("node-pty.IPty#kill"),this.m.kill())}catch{}this.M.fire(this.g||0),this.dispose()}}async Z(){if(!(!w.$l||!("useConpty"in this.F)||!this.F.useConpty)){for(;Date.now()-b.b<P.KillSpawnThrottleInterval;)this.P.trace("Throttling kill/spawn call"),await(0,_.$Lh)(P.KillSpawnThrottleInterval-(Date.now()-b.b)+P.KillSpawnSpacingDuration);b.b=Date.now()}}$(p){this.J.fire({pid:p,cwd:this.D,windowsPty:this.getWindowsPty()})}ab(p){if(this.q.isDisposed)return;this.n=p.process??"",this.L.fire({type:a.ProcessPropertyType.Title,value:this.n});const L=this.currentTitle.replace(/ \(figterm\)$/g,"");if(L.toLowerCase().startsWith("python"))this.L.fire({type:a.ProcessPropertyType.ShellType,value:a.GeneralShellType.Python});else if(L.toLowerCase().startsWith("julia"))this.L.fire({type:a.ProcessPropertyType.ShellType,value:a.GeneralShellType.Julia});else{const k=i.get(L)||n.get(L);this.L.fire({type:a.ProcessPropertyType.ShellType,value:k})}}shutdown(p){this.P.getLevel()===f.LogLevel.Trace&&this.P.trace("TerminalProcess#shutdown",new Error().stack?.replace(/^Error/,"")),p&&!w.$l?this.Y():!this.j&&!this.q.isDisposed&&(this.X(),setTimeout(()=>{this.j&&!this.q.isDisposed&&(this.j=void 0,this.Y())},E.MaximumShutdownTime))}input(p,L=!1){this.q.isDisposed||!this.m||(this.y.push(...(0,s.$vs)(p).map(k=>({isBinary:L,data:k}))),this.bb())}async processBinary(p){this.input(p,!0)}async refreshProperty(p){switch(p){case a.ProcessPropertyType.Cwd:{const L=await this.getCwd();return L!==this.a.cwd&&(this.a.cwd=L,this.L.fire({type:a.ProcessPropertyType.Cwd,value:this.a.cwd})),L}case a.ProcessPropertyType.InitialCwd:{const L=await this.getInitialCwd();return L!==this.a.initialCwd&&(this.a.initialCwd=L,this.L.fire({type:a.ProcessPropertyType.InitialCwd,value:this.a.initialCwd})),L}case a.ProcessPropertyType.Title:return this.currentTitle;default:return this.shellType}}async updateProperty(p,L){p===a.ProcessPropertyType.FixedDimensions&&(this.a.fixedDimensions=L)}bb(){if(!(this.z!==void 0||this.y.length===0)){if(this.cb(),this.y.length===0){this.z=void 0;return}this.z=setTimeout(()=>{this.z=void 0,this.bb()},P.WriteInterval)}}cb(){const p=this.y.shift();this.P.trace("node-pty.IPty#write",p.data),p.isBinary?this.m.write(Buffer.from(p.data,"binary")):this.m.write(p.data),this.u?.handleInput()}resize(p,L){if(!this.q.isDisposed&&!(typeof p!="number"||typeof L!="number"||isNaN(p)||isNaN(L))&&this.m){if(p=Math.max(p,1),L=Math.max(L,1),this.C){this.C.cols=p,this.C.rows=L;return}this.P.trace("node-pty.IPty#resize",p,L);try{this.m.resize(p,L)}catch(k){if(this.P.trace("node-pty.IPty#resize exception "+k.message),this.g!==void 0&&k.message!=="ioctl(2) failed, EBADF"&&k.message!=="Cannot resize a pty that has already exited")throw k}}}clearBuffer(){this.m?.clear()}acknowledgeDataEvent(p){this.H=Math.max(this.H-p,0),this.P.trace(`Flow control: Ack ${p} chars (unacknowledged: ${this.H})`),this.G&&this.H<a.FlowControlConstants.LowWatermarkChars&&(this.P.trace(`Flow control: Resume (${this.H} < ${a.FlowControlConstants.LowWatermarkChars})`),this.m?.resume(),this.G=!1)}clearUnacknowledgedChars(){this.H=0,this.P.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this.G&&(this.m?.resume(),this.G=!1)}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve(this.D)}async getCwd(){if(w.$m)return new Promise(p=>{if(!this.m){p(this.D);return}this.P.trace("node-pty.IPty#pid"),(0,t.exec)("lsof -OPln -p "+this.m.pid+" | grep cwd",{env:{...process.env,LANG:"en_US.UTF-8"}},(L,k,M)=>{!L&&k!==""?p(k.substring(k.indexOf("/"),k.length-1)):(this.P.error("lsof did not run successfully, it may not be on the $PATH?",L,k,M),p(this.D))})});if(w.$n){if(!this.m)return this.D;this.P.trace("node-pty.IPty#pid");try{return await o.promises.readlink(`/proc/${this.m.pid}/cwd`)}catch{return this.D}}return this.D}getWindowsPty(){return w.$l?{backend:"useConpty"in this.F&&this.F.useConpty?"conpty":"winpty",buildNumber:(0,c.$Us)()}:void 0}};e.$doc=h,e.$doc=h=b=me([je(7,f.$fk),je(8,m.$yk)],h);class R extends j.$Zc{get onTrigger(){return this.b.event}constructor(){super(),this.b=this.B(new g.$qe),this.a=setTimeout(()=>{this.b.fire({rows:this.rows,cols:this.cols})},1e3),this.B((0,j.$Xc)(()=>clearTimeout(this.a)))}}}),define(he[100],fe([0,1,29,12,4,2,3,65,9,91,16,93,41,43,99,8,42,92,7,96,95,72,14,104,105]),function(ie,e,o,t,_,g,j,A,w,r,v,f,m,a,l,c,d,$,s,b,E,P,i,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$foc=void 0,e.$eoc=R,n=Ae(n);function R(T,I,S){if(typeof S.value!="function")throw new Error("not supported");const F="value",J=S.value;S[F]=async function(...V){this.traceRpcArgs.logService.getLevel()===w.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Request] PtyService#${J.name}(${V.map(re=>JSON.stringify(re)).join(", ")})`),this.traceRpcArgs.simulatedLatency&&await(0,t.$Lh)(this.traceRpcArgs.simulatedLatency);let Q;try{Q=await J.apply(this,V)}catch(re){throw this.traceRpcArgs.logService.error(`[RPC Response] PtyService#${J.name}`,re),re}return this.traceRpcArgs.logService.getLevel()===w.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Response] PtyService#${J.name}`,Q),Q}}let W,p;class L extends g.$Zc{H(I,S){return S(F=>{this.I.getLevel()===w.LogLevel.Trace&&this.I.trace(`[RPC Event] PtyService#${I}.fire(${JSON.stringify(F)})`)}),S}get traceRpcArgs(){return{logService:this.I,simulatedLatency:this.M}}constructor(I,S,F,J){super(),this.I=I,this.J=S,this.L=F,this.M=J,this.a=new Map,this.b=new Map,this.g=new Map,this.j=new Map,this.n=0,this.u=this.B(new _.$qe),this.onHeartbeat=this.H("_onHeartbeat",this.u.event),this.w=this.B(new _.$qe),this.onProcessData=this.H("_onProcessData",this.w.event),this.y=this.B(new _.$qe),this.onProcessReplay=this.H("_onProcessReplay",this.y.event),this.z=this.B(new _.$qe),this.onProcessReady=this.H("_onProcessReady",this.z.event),this.C=this.B(new _.$qe),this.onProcessExit=this.H("_onProcessExit",this.C.event),this.D=this.B(new _.$qe),this.onProcessOrphanQuestion=this.H("_onProcessOrphanQuestion",this.D.event),this.F=this.B(new _.$qe),this.onDidRequestDetach=this.H("_onDidRequestDetach",this.F.event),this.G=this.B(new _.$qe),this.onDidChangeProperty=this.H("_onDidChangeProperty",this.G.event),this.B((0,g.$Xc)(()=>{for(const V of this.a.values())V.shutdown(!0);this.a.clear()})),this.f=this.B(new r.$Es(void 0,this.I)),this.f.onCreateRequest(this.F.fire,this.F)}async refreshIgnoreProcessNames(I){d.$_nc.length=0,d.$_nc.push(...I)}async requestDetachInstance(I,S){return this.f.createRequest({workspaceId:I,instanceId:S})}async acceptDetachInstanceReply(I,S){let F;const J=this.a.get(S);J&&(F=await this.S(S,J)),this.f.acceptReply(I,F)}async freePortKillProcess(I){const F=(await new Promise((J,V)=>{(0,o.exec)(j.$l?`netstat -ano | findstr "${I}"`:`lsof -nP -iTCP -sTCP:LISTEN | grep ${I}`,{},(Q,re)=>{if(Q)return V("Problem occurred when listing active processes");J(re)})})).split(/\r?\n/).filter(J=>!!J.trim());if(F.length>=1){const J=/\s+(\d+)(?:\s+|$)/,V=F[0].match(J)?.[1];if(V)try{process.kill(Number.parseInt(V))}catch{}else throw new Error(`Processes for port ${I} were not found`);return{port:I,processId:V}}throw new Error(`Could not kill process with port ${I}`)}async serializeTerminalState(I){const S=[];for(const[J,V]of this.a.entries())V.hasWrittenData&&I.indexOf(J)!==-1&&S.push(t.Promises.withAsyncBody(async Q=>{Q({id:J,shellLaunchConfig:V.shellLaunchConfig,processDetails:await this.S(J,V),processLaunchConfig:V.processLaunchOptions,unicodeVersion:V.unicodeVersion,replayEvent:await V.serializeNormalBuffer(),timestamp:Date.now()})}));const F={version:1,state:await Promise.all(S)};return JSON.stringify(F)}async reviveTerminalProcesses(I,S,F){const J=[];for(const V of S)J.push(this.N(I,V));await Promise.all(J)}async N(I,S){const F=(0,c.localize)(2120,null),J=await this.createProcess({...S.shellLaunchConfig,cwd:S.processDetails.cwd,color:S.processDetails.color,icon:S.processDetails.icon,name:S.processDetails.titleSource===v.TitleEventSource.Api?S.processDetails.title:void 0,initialText:S.replayEvent.events[0].data+(0,E.$fZb)(F,{loudFormatting:!0})},S.processDetails.cwd,S.replayEvent.events[0].cols,S.replayEvent.events[0].rows,S.unicodeVersion,S.processLaunchConfig.env,S.processLaunchConfig.executableEnv,S.processLaunchConfig.options,!0,S.processDetails.workspaceId,S.processDetails.workspaceName,!0,S.replayEvent.events[0].data),V=this.R(I,S.id);this.g.set(V,{newId:J,state:S}),this.I.info(`Revived process, old id ${V} -> new id ${J}`)}async shutdownAll(){this.dispose()}async createProcess(I,S,F,J,V,Q,re,ae,X,B,Z,ee,le){if(I.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const q=++this.n,ce=new l.$doc(I,S,F,J,Q,re,ae,this.I,this.J),de={env:Q,executableEnv:re,options:ae},te=new M(q,ce,B,Z,X,F,J,de,V,this.L,this.I,ee&&typeof I.initialText=="string"?I.initialText:void 0,le,I.icon,I.color,I.name,I.fixedDimensions);return ce.onProcessExit(u=>{te.dispose(),this.a.delete(q),this.C.fire({id:q,event:u})}),te.onProcessData(u=>this.w.fire({id:q,event:u})),te.onProcessReplay(u=>this.y.fire({id:q,event:u})),te.onProcessReady(u=>this.z.fire({id:q,event:u})),te.onProcessOrphanQuestion(()=>this.D.fire({id:q})),te.onDidChangeProperty(u=>this.G.fire({id:q,property:u})),te.onPersistentProcessReady(()=>{for(const u of this.j.entries())te.installAutoReply(u[0],u[1])}),this.a.set(q,te),q}async attachToProcess(I){try{await this.U(I).attach(),this.I.info(`Persistent process reconnection "${I}"`)}catch(S){throw this.I.warn(`Persistent process reconnection "${I}" failed`,S.message),S}}async updateTitle(I,S,F){this.U(I).setTitle(S,F)}async updateIcon(I,S,F,J){this.U(I).setIcon(S,F,J)}async clearBuffer(I){this.U(I).clearBuffer()}async refreshProperty(I,S){return this.U(I).refreshProperty(S)}async updateProperty(I,S,F){return this.U(I).updateProperty(S,F)}async detachFromProcess(I,S){return this.U(I).detach(S)}async reduceConnectionGraceTime(){for(const I of this.a.values())I.reduceGraceTime()}async listProcesses(){const I=Array.from(this.a.entries()).filter(([J,V])=>V.shouldPersistTerminal);this.I.info(`Listing ${I.length} persistent terminals, ${this.a.size} total terminals`);const S=I.map(async([J,V])=>this.S(J,V));return(await Promise.all(S)).filter(J=>J.isOrphan)}async getPerformanceMarks(){return n.getMarks()}async start(I){const S=this.a.get(I);return S?S.start():{message:`Could not find pty with id "${I}"`}}async shutdown(I,S){return this.a.get(I)?.shutdown(S)}async input(I,S){return this.U(I).input(S)}async processBinary(I,S){return this.U(I).writeBinary(S)}async resize(I,S,F){return this.U(I).resize(S,F)}async getInitialCwd(I){return this.U(I).getInitialCwd()}async getCwd(I){return this.U(I).getCwd()}async acknowledgeDataEvent(I,S){return this.U(I).acknowledgeDataEvent(S)}async setUnicodeVersion(I,S){return this.U(I).setUnicodeVersion(S)}async getLatency(){return[]}async orphanQuestionReply(I){return this.U(I).orphanQuestionReply()}async installAutoReply(I,S){this.j.set(I,S);for(const F of this.a.values())F.installAutoReply(I,S)}async uninstallAllAutoReplies(){for(const I of this.j.keys())for(const S of this.a.values())S.uninstallAutoReply(I)}async uninstallAutoReply(I){for(const S of this.a.values())S.uninstallAutoReply(I)}async getDefaultSystemShell(I=j.OS){return(0,A.$Fm)(I,process.env)}async getEnvironment(){return{...process.env}}async getWslPath(I,S){if(S==="win-to-unix"){if(!j.$l)return I;if((0,a.$Us)()<17063)return I.replace(/\\/g,"/");const F=this.O();return F?new Promise(J=>{(0,o.execFile)(F,["-e","wslpath",I],{},(Q,re,ae)=>{J(Q?I:(0,m.$AR)(re.trim()))}).stdin.end()}):I}if(S==="unix-to-win"&&j.$l){if((0,a.$Us)()<17063)return I;const F=this.O();return F?new Promise(J=>{(0,o.execFile)(F,["-e","wslpath","-w",I],{},(Q,re,ae)=>{J(Q?I:re.trim())}).stdin.end()}):I}return I}O(){const I=(0,a.$Us)()>=16299,S=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),F=process.env.SystemRoot;if(F)return(0,P.join)(F,S?"Sysnative":"System32",I?"wsl.exe":"bash.exe")}async getRevivedPtyNewId(I,S){try{return this.g.get(this.R(I,S))?.newId}catch(F){this.I.warn(`Couldn't find terminal ID ${I}-${S}`,F.message)}}async setTerminalLayoutInfo(I){this.b.set(I.workspaceId,I)}async getTerminalLayoutInfo(I){n.mark("code/willGetTerminalLayoutInfo");const S=this.b.get(I.workspaceId);if(S){const F=new Set,V=(await Promise.all(S.tabs.map(async Q=>this.P(I.workspaceId,Q,F)))).filter(Q=>Q.terminals.length>0);return n.mark("code/didGetTerminalLayoutInfo"),{tabs:V}}n.mark("code/didGetTerminalLayoutInfo")}async P(I,S,F){const V=(await Promise.all(S.terminals.map(Q=>this.Q(I,Q,F)))).filter(Q=>Q.terminal!==null);return{isActive:S.isActive,activePersistentProcessId:S.activePersistentProcessId,terminals:V}}async Q(I,S,F){try{const J=this.R(I,S.terminal),V=this.g.get(J)?.newId;this.I.info(`Expanding terminal instance, old id ${J} -> new id ${V}`),this.g.delete(J);const Q=V??S.terminal;if(F.has(Q))throw new Error(`Terminal ${Q} has already been expanded`);F.add(Q);const re=this.U(Q);return{terminal:{...re&&await this.S(S.terminal,re,V!==void 0),id:Q},relativeSize:S.relativeSize}}catch(J){return this.I.warn("Couldn't get layout info, a terminal was probably disconnected",J.message),this.I.debug("Reattach to wrong terminal debug info - layout info by id",S),this.I.debug("Reattach to wrong terminal debug info - _revivePtyIdMap",Array.from(this.g.values())),this.I.debug("Reattach to wrong terminal debug info - _ptys ids",Array.from(this.a.keys())),{terminal:null,relativeSize:S.relativeSize}}}R(I,S){return`${I}-${S}`}async S(I,S,F=!1){n.mark(`code/willBuildProcessDetails/${I}`);const[J,V]=await Promise.all([S.getCwd(),F?!0:S.isOrphaned()]),Q={id:I,title:S.title,titleSource:S.titleSource,pid:S.pid,workspaceId:S.workspaceId,workspaceName:S.workspaceName,cwd:J,isOrphan:V,icon:S.icon,color:S.color,fixedDimensions:S.fixedDimensions,environmentVariableCollections:S.processLaunchOptions.options.environmentVariableCollections,reconnectionProperties:S.shellLaunchConfig.reconnectionProperties,waitOnExit:S.shellLaunchConfig.waitOnExit,hideFromUser:S.shellLaunchConfig.hideFromUser,isFeatureTerminal:S.shellLaunchConfig.isFeatureTerminal,type:S.shellLaunchConfig.type,hasChildProcesses:S.hasChildProcesses,shellIntegrationNonce:S.processLaunchOptions.options.shellIntegration.nonce};return n.mark(`code/didBuildProcessDetails/${I}`),Q}U(I){const S=this.a.get(I);if(!S)throw new s.$fb("Could not find pty on pty host");return S}}e.$foc=L,me([i.$ci],L.prototype,"traceRpcArgs",null),me([R],L.prototype,"refreshIgnoreProcessNames",null),me([R],L.prototype,"requestDetachInstance",null),me([R],L.prototype,"acceptDetachInstanceReply",null),me([R],L.prototype,"freePortKillProcess",null),me([R],L.prototype,"serializeTerminalState",null),me([R],L.prototype,"reviveTerminalProcesses",null),me([R],L.prototype,"shutdownAll",null),me([R],L.prototype,"createProcess",null),me([R],L.prototype,"attachToProcess",null),me([R],L.prototype,"updateTitle",null),me([R],L.prototype,"updateIcon",null),me([R],L.prototype,"clearBuffer",null),me([R],L.prototype,"refreshProperty",null),me([R],L.prototype,"updateProperty",null),me([R],L.prototype,"detachFromProcess",null),me([R],L.prototype,"reduceConnectionGraceTime",null),me([R],L.prototype,"listProcesses",null),me([R],L.prototype,"getPerformanceMarks",null),me([R],L.prototype,"start",null),me([R],L.prototype,"shutdown",null),me([R],L.prototype,"input",null),me([R],L.prototype,"processBinary",null),me([R],L.prototype,"resize",null),me([R],L.prototype,"getInitialCwd",null),me([R],L.prototype,"getCwd",null),me([R],L.prototype,"acknowledgeDataEvent",null),me([R],L.prototype,"setUnicodeVersion",null),me([R],L.prototype,"getLatency",null),me([R],L.prototype,"orphanQuestionReply",null),me([R],L.prototype,"installAutoReply",null),me([R],L.prototype,"uninstallAllAutoReplies",null),me([R],L.prototype,"uninstallAutoReply",null),me([R],L.prototype,"getDefaultSystemShell",null),me([R],L.prototype,"getEnvironment",null),me([R],L.prototype,"getWslPath",null),me([R],L.prototype,"getRevivedPtyNewId",null),me([R],L.prototype,"setTerminalLayoutInfo",null),me([R],L.prototype,"getTerminalLayoutInfo",null);var k;(function(T){T.None="None",T.ReplayOnly="ReplayOnly",T.Session="Session"})(k||(k={}));class M extends g.$Zc{get pid(){return this.L}get shellLaunchConfig(){return this.W.shellLaunchConfig}get hasWrittenData(){return this.j.value!==k.None}get title(){return this.N||this.W.currentTitle}get titleSource(){return this.O}get icon(){return this.Y}get color(){return this.Z}get fixedDimensions(){return this.R}get hasChildProcesses(){return this.W.hasChildProcesses}setTitle(I,S){S===v.TitleEventSource.Api&&(this.j.setValue(k.Session,"setTitle"),this.P.freeRawReviveBuffer()),this.N=I,this.O=S}setIcon(I,S,F){(!this.Y||"id"in S&&"id"in this.Y&&S.id!==this.Y.id||!this.color||F!==this.Z)&&(this.P.freeRawReviveBuffer(),I&&this.j.setValue(k.Session,"setIcon")),this.Y=S,this.Z=F}S(I){this.R=I}constructor(I,S,F,J,V,Q,re,ae,X,B,Z,ee,le,q,ce,de,te){super(),this.U=I,this.W=S,this.workspaceId=F,this.workspaceName=J,this.shouldPersistTerminal=V,this.processLaunchOptions=ae,this.unicodeVersion=X,this.X=Z,this.Y=q,this.Z=ce,this.b=new Map,this.f=new Map,this.g=!1,this.w=new t.$Rh,this.C=this.B(new _.$qe),this.onProcessReplay=this.C.event,this.D=this.B(new _.$qe),this.onProcessReady=this.D.event,this.F=this.B(new _.$qe),this.onPersistentProcessReady=this.F.event,this.G=this.B(new _.$qe),this.onProcessData=this.G.event,this.H=this.B(new _.$qe),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new _.$qe),this.onDidChangeProperty=this.I.event,this.J=!1,this.L=-1,this.M="",this.O=v.TitleEventSource.Process,this.j=new C(`Persistent process "${this.U}" interaction state`,k.None,this.X),this.Q=ee!==void 0,this.P=new D(Q,re,B.scrollback,X,ee,ae.options.shellIntegration.nonce,V?le:void 0,this.X),de&&this.setTitle(de,v.TitleEventSource.Api),this.R=te,this.n=null,this.u=0,this.y=this.B(new t.$Xh(()=>{this.X.info(`Persistent process "${this.U}": The reconnection grace time of ${y(B.graceTime)} has expired, shutting down pid "${this.L}"`),this.shutdown(!0)},B.graceTime)),this.z=this.B(new t.$Xh(()=>{this.X.info(`Persistent process "${this.U}": The short reconnection grace time of ${y(B.shortGraceTime)} has expired, shutting down pid ${this.L}`),this.shutdown(!0)},B.shortGraceTime)),this.B(this.W.onProcessExit(()=>this.a.stopBuffering(this.U))),this.B(this.W.onProcessReady(u=>{this.L=u.pid,this.M=u.cwd,this.D.fire(u)})),this.B(this.W.onDidChangeProperty(u=>{this.I.fire(u)})),this.a=new f.$zyb((u,H)=>this.G.fire(H)),this.B(this.a.startBuffering(this.U,this.W.onProcessData)),this.B(this.onProcessData(u=>this.P.handleData(u))),this.B((0,g.$Xc)(()=>{for(const u of this.b.values())u.dispose();this.b.clear()}))}async attach(){!this.y.isScheduled()&&!this.z.isScheduled()&&this.X.warn(`Persistent process "${this.U}": Process had no disconnect runners but was an orphan`),this.y.cancel(),this.z.cancel()}async detach(I){this.shouldPersistTerminal&&(this.j.value!==k.None||I)?this.y.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this.P.generateReplayEvent(!0,this.j.value!==k.Session)}async refreshProperty(I){return this.W.refreshProperty(I)}async updateProperty(I,S){if(I===v.ProcessPropertyType.FixedDimensions)return this.S(S)}async start(){if(!this.g){const I=await this.W.start();return I&&"message"in I||(this.g=!0,this.Q?this.triggerReplay():this.F.fire()),I}this.D.fire({pid:this.L,cwd:this.M,windowsPty:this.W.getWindowsPty()}),this.I.fire({type:v.ProcessPropertyType.Title,value:this.W.currentTitle}),this.I.fire({type:v.ProcessPropertyType.ShellType,value:this.W.shellType}),this.triggerReplay()}shutdown(I){return this.W.shutdown(I)}input(I){if(this.j.setValue(k.Session,"input"),this.P.freeRawReviveBuffer(),!this.J){for(const S of this.b.values())S.handleInput();return this.W.input(I)}}writeBinary(I){return this.W.processBinary(I)}resize(I,S){if(!this.J){this.P.handleResize(I,S),this.a.flushBuffer(this.U);for(const F of this.b.values())F.handleResize();return this.W.resize(I,S)}}async clearBuffer(){this.P.clearBuffer(),this.W.clearBuffer()}setUnicodeVersion(I){this.unicodeVersion=I,this.P.setUnicodeVersion?.(I)}acknowledgeDataEvent(I){if(!this.J)return this.W.acknowledgeDataEvent(I)}getInitialCwd(){return this.W.getInitialCwd()}getCwd(){return this.W.getCwd()}async triggerReplay(){this.j.value===k.None&&this.j.setValue(k.ReplayOnly,"triggerReplay");const I=await this.P.generateReplayEvent();let S=0;for(const F of I.events)S+=F.data.length;this.X.info(`Persistent process "${this.U}": Replaying ${S} chars and ${I.events.length} size events`),this.C.fire(I),this.W.clearUnacknowledgedChars(),this.F.fire()}installAutoReply(I,S){this.b.get(I)?.dispose(),this.b.set(I,new $.$$nc(this.W,I,S,this.X))}uninstallAutoReply(I){this.b.get(I)?.dispose(),this.b.delete(I)}sendCommandResult(I,S,F){this.f.get(I)&&this.f.delete(I)}orphanQuestionReply(){if(this.u=Date.now(),this.n){const I=this.n;this.n=null,I.open()}}reduceGraceTime(){this.z.isScheduled()||this.y.isScheduled()&&this.z.schedule()}async isOrphaned(){return await this.w.queue(async()=>this.$())}async $(){return this.y.isScheduled()||this.z.isScheduled()?!0:(this.n||(this.n=new t.$Kh(4e3),this.u=0,this.H.fire()),await this.n.wait(),Date.now()-this.u>500)}}class C{get value(){return this.b}setValue(I,S){this.b!==I&&(this.b=I,this.f(S))}constructor(I,S,F){this.a=I,this.b=S,this.d=F,this.f("initialized")}f(I){this.d.debug(`MutationLogger "${this.a}" set to "${this.b}", reason: ${I}`)}}class D{constructor(I,S,F,J,V,Q,re,ae){this.f=re,this.a=new h.Terminal({cols:I,rows:S,scrollback:F,allowProposedApi:!0}),V&&this.a.writeln(V),this.setUnicodeVersion(J),this.b=new b.$qxb(Q,!0,void 0,ae),this.a.loadAddon(this.b)}freeRawReviveBuffer(){this.f=void 0}handleData(I){this.a.write(I)}handleResize(I,S){this.a.resize(I,S)}clearBuffer(){this.a.clear()}async generateReplayEvent(I,S){const F=new(await this._getSerializeConstructor());this.a.loadAddon(F);const J={scrollback:this.a.options.scrollback};I&&(J.excludeAltBuffer=!0,J.excludeModes=!0);let V;return S&&this.f?V=this.f:V=F.serialize(J),{events:[{cols:this.a.cols,rows:this.a.rows,data:V}],commands:this.b.serialize()}}async setUnicodeVersion(I){this.a.unicode.activeVersion!==I&&(I==="11"?(this.d=new(await this._getUnicode11Constructor()),this.a.loadAddon(this.d)):(this.d?.dispose(),this.d=void 0),this.a.unicode.activeVersion=I)}async _getUnicode11Constructor(){return p||(p=(await new Promise((I,S)=>{ie(["@xterm/addon-unicode11"],I,S)}).then(Ae)).Unicode11Addon),p}async _getSerializeConstructor(){return W||(W=(await new Promise((I,S)=>{ie(["@xterm/addon-serialize"],I,S)}).then(Ae)).SerializeAddon),W}}function y(T){let I=0,S=0,F=0;T>=1e3&&(F=Math.floor(T/1e3),T-=F*1e3),F>=60&&(S=Math.floor(F/60),F-=S*60),S>=60&&(I=Math.floor(S/60),S-=I*60);const J=I?`${I}h`:"",V=S?`${S}m`:"",Q=F?`${F}s`:"",re=T?`${T}ms`:"";return`${J}${V}${Q}${re}`}});var Ke=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(he[106],fe([0,1,62,30,66,67,8,70,73,9,75,76,78,79,16,97,100,33,12,2]),function(ie,e,o,t,_,g,j,A,w,r,v,f,m,a,l,c,d,$,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),a=Ke(a),E();async function E(){const P=parseInt(process.env.VSCODE_STARTUP_DELAY??"0"),i=parseInt(process.env.VSCODE_LATENCY??"0"),n={graceTime:parseInt(process.env.VSCODE_RECONNECT_GRACE_TIME||"0"),shortGraceTime:parseInt(process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME||"0"),scrollback:parseInt(process.env.VSCODE_RECONNECT_SCROLLBACK||"100")};delete process.env.VSCODE_RECONNECT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SCROLLBACK,delete process.env.VSCODE_LATENCY,delete process.env.VSCODE_STARTUP_DELAY,P&&await(0,s.$Lh)(P);const h=(0,$.$zY)(process);let R;h?R=new g.$AY:R=new _.$pr(l.TerminalIpcChannels.PtyHost);const W={_serviceBrand:void 0,...a.default},p=new w.$cn((0,A.$Im)(process.argv,A.$Hm),W),L=new m.$1R((0,r.$tk)(p),p.logsHome);R.registerChannel(l.TerminalIpcChannels.Logger,new v.$Cs(L,()=>o.$Tn));const k=L.createLogger("ptyhost",{name:(0,j.localize)(2119,null)}),M=new f.$$R(k);P&&M.warn(`Pty Host startup is delayed ${P}ms`),i&&M.warn(`Pty host is simulating ${i}ms latency`);const C=new b.$Yc,D=new c.$boc;R.registerChannel(l.TerminalIpcChannels.Heartbeat,t.ProxyChannel.fromService(D,C));const y=new d.$foc(M,W,n,i),T=t.ProxyChannel.fromService(y,C);R.registerChannel(l.TerminalIpcChannels.PtyHost,T),h&&R.registerChannel(l.TerminalIpcChannels.PtyHostWindow,T),process.once("exit",()=>{M.trace("Pty host exiting"),M.dispose(),D.dispose(),y.dispose()})}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/e37706186d2105b4158df80574323ebb987d7f64/core/vs/platform/terminal/node/ptyHostMain.js.map
